// Datei defDek01B.c
/* ------------------------------------------------------------------------
Demonstriert den Unterschied zwischen Deklarationen und Definitionen
------------------------------------------------------------------------ */
#include <stdio.h>

       int v01;                      // Vereinb.17: Deklaration!
       int v01;                      // Vereinb.18: Deklaration!

       int v02;                      // Vereinb.19: Definition!

       int v03;                      // Vereinb.20: Def. oder Dek?

extern int v04;                      // Vereinb.21: Deklaration!
// ------------------------------------------------------------------------
       int plus1(int m){return m+1;} // Vereinb.22: Definition!

       int plus2(int m);             // Vereinb.23 Deklaration!
       int plus2(int m);             // Vereinb.24 Deklaration!

       int plus3(int m){return m+3;} // Vereinb.25 Definition!
       
extern int plus4(int);               // Vereinb.26 Deklaration!
// ------------------------------------------------------------------------
int main(void) {
   v02 = 2;
   v03 = 3;
   
   printf("v01:       %2d\n", v01);
   printf("v02:       %2d\n", v02);
   printf("v03:       %2d\n", v03);
   printf("v04:       %2d\n", v04);
   
   printf("plus1(10): %2d\n", plus1(10));
   printf("plus2(20): %2d\n", plus2(20));
   printf("plus3(30): %2d\n", plus3(30));
   printf("plus4(40): %2d\n", plus4(40));
   
   return 0;
}
/* ------------------------------------------------------------------------
Begruendungen (warum Definition bzw. Deklaration)?

Vereinb.17: Dek, weil es anderswo eine eindeutige Definition gibt.
Vereinb.18: Dek, weil es anderswo eine eindeutige Definition gibt.
Vereinb.19: Def, weil es anderswo keine eindeutige Definition gibt.
Vereinb.20: Ausfuehrer waehlt eine als Def, die andern als Dek.
Vereinb.21: Dek, wegen 'extern'
------------------------------------------------------------------
Vereinb.22: Def, weil Rumpf vorhanden
Vereinb.23: Dek, kein Rumpf
Vereinb.24: Dek, kein Rumpf
Vereinb.25: Def, weil Rumpf vorhanden
Vereinb.26: Dek, kein Rumpf
---------------------------------------------------------------------------

Warnungen und Fehlermeldungen von Compilern und Bindern:
---------------------------------------------------------------------------
gcc:

defDek01A.c:15:12: warning: 'v04' initialized and declared 'extern'
---------------------------------------------------------------------------
bcc32:

Warning: Public symbol '_v01' defined in both module 
H:\BSPC\DEFDEK01\DEFDEK01A.OBJ and 
H:\BSPC\DEFDEK01\DEFDEK01B.OBJ
Warning: Public symbol '_v03' defined in both module 
H:\BSPC\DEFDEK01\DEFDEK01A.OBJ and 
H:\BSPC\DEFDEK01\DEFDEK01B.OBJ
---------------------------------------------------------------------------
lcc/lcclnk:

Keine Warnungen oder Fehlermeldungen!
---------------------------------------------------------------------------
Ausgabe des Programms:

v01:        1
v02:        2
v03:        3
v04:        4
plus1(10): 11
plus2(20): 22
plus3(30): 33
plus4(40): 44
------------------------------------------------------------------------ */
