// Datei IntTypes01.c
/* ------------------------------------------------------------------------
Statt die nicht-standardisierten Ganzzahltypen short, int, long etc.
benutzt dieses Programm den standardisierten Typ int_fast16_t. Werte
dieses Typs sind mindestens 16 Bits breit und der Ausfuehrer kann sie
besonders schnell bearbeiten.

Eine Ganzzahl wird mit scanf in eine Variable des Typs int_fast16_t
eingelesen (erst als Dezimalzahl, dann als Hexadezimalzahl und schliess-
lich als Oktalzahl) und wird mit printf jeweils dreimal ausgegeben
(als Dezimalzahl, Hexadezimalzahl und Oktalzahl).
------------------------------------------------------------------------ */
#include <stdint.h>  // int8_t, uint8_t, int_least8_t, uint_least8_t,
                     // int_fast8_t, intptr_t, uintptr_t, intmax_t, ...
#include <inttypes.h>// PRId8, PRIdLEAST8, PRIdFAST8, ...
#include <stdio.h>   // E/A in Bytestroeme, printf, sprintf, ...

int main(void) {
   printf("IntTypes01: Jetzt geht es los!\n");

   int_fast16_t otto;

   printf("------------------------------\n");
   printf("sizeof(int_fast16_t): %d\n", sizeof(int_fast16_t));
   printf("------------------------------\n");
   printf("PRIdFAST16: %s\n", PRIdFAST16);
   printf("PRIXFAST16: %s\n", PRIXFAST16);
   printf("PRIoFAST16: %s\n", PRIoFAST16);
   printf("------------------------------\n");
   printf("SCNdFAST16: %s\n", SCNdFAST16);
   printf("SCNxFAST16: %s\n", SCNxFAST16);
   printf("SCNoFAST16: %s\n", SCNoFAST16);
   printf("------------------------------\n");
   printf("Eine Ganzzahl, dezimal ? ");
   scanf("%"SCNdFAST16, &otto); // Eine Dezimalzahl einlesen
   printf("Ihre Eingabe,  dezimal : %"PRIdFAST16"\n", otto);
   printf("Ihre Eingabe,  hexadez.: %"PRIXFAST16"\n", otto);
   printf("Ihre Eingabe,  oktal   : %"PRIoFAST16"\n", otto);
   printf("------------------------------\n");
   printf("Eine Ganzzahl, hexadez.? ");
   scanf("%"SCNxFAST16, &otto); // Eine Hexadezimalzahl einlesen
   printf("Ihre Eingabe,  dezimal : %"PRIdFAST16"\n", otto);
   printf("Ihre Eingabe,  hexadez.: %"PRIXFAST16"\n", otto);
   printf("Ihre Eingabe,  oktal   : %"PRIoFAST16"\n", otto);
   printf("------------------------------\n");
   printf("Eine Ganzzahl, oktal   ? ");
   scanf("%"SCNoFAST16, &otto); // Eine Oktalzahl einlesen
   printf("Ihre Eingabe,  dezimal : %"PRIdFAST16"\n", otto);
   printf("Ihre Eingabe,  hexadez.: %"PRIXFAST16"\n", otto);
   printf("Ihre Eingabe,  oktal   : %"PRIoFAST16"\n", otto);
   printf("------------------------------\n");

   printf("IntTypes01: Das war's erstmal!\n");
   return 0;
} // main
/* ------------------------------------------------------------------------
Ausgabe des Programms IntTypes01:

Compiliert mit gcc, v3.4.4:           Compiliert mit lcc-win32, v3.8:

IntTypes01: Jetzt geht es los!        IntTypes01: Jetzt geht es los!
------------------------------        ------------------------------
sizeof(int_fast16_t): 4               sizeof(int_fast16_t): 2
------------------------------        ------------------------------
PRIdFAST16: ld                        PRIdFAST16: d
PRIXFAST16: lX                        PRIXFAST16: X
PRIoFAST16: lo                        PRIoFAST16: o
------------------------------        ------------------------------
SCNdFAST16: ld                        SCNdFAST16: d
SCNxFAST16: lx                        SCNxFAST16: x
SCNoFAST16: lo                        SCNoFAST16: o
------------------------------        ------------------------------
Eine Ganzzahl, dezimal ? 255          Eine Ganzzahl, dezimal ? 255
Ihre Eingabe,  dezimal : 255          Ihre Eingabe,  dezimal : 255
Ihre Eingabe,  hexadez.: FF           Ihre Eingabe,  hexadez.: FF
Ihre Eingabe,  oktal   : 377          Ihre Eingabe,  oktal   : 377
------------------------------        ------------------------------
Eine Ganzzahl, hexadez.? ff           Eine Ganzzahl, hexadez.? ff
Ihre Eingabe,  dezimal : 255          Ihre Eingabe,  dezimal : 255
Ihre Eingabe,  hexadez.: FF           Ihre Eingabe,  hexadez.: FF
Ihre Eingabe,  oktal   : 377          Ihre Eingabe,  oktal   : 377
------------------------------        ------------------------------
Eine Ganzzahl, oktal   ? 377          Eine Ganzzahl, oktal   ? 377
Ihre Eingabe,  dezimal : 255          Ihre Eingabe,  dezimal : 255
Ihre Eingabe,  hexadez.: FF           Ihre Eingabe,  hexadez.: FF
Ihre Eingabe,  oktal   : 377          Ihre Eingabe,  oktal   : 377
------------------------------        ------------------------------
IntTypes01: Das war's erstmal!        IntTypes01: Das war's erstmal!
------------------------------------------------------------------------ */
