// Datei kopflos.c
/* ------------------------------------------------------------------------
Dieses Programm kopflos.c ist dem Programm hallo01.c weitgehend gleich,
inkludiert aber keine Kopfdateien.

Kopfdateien (engl. header files, .h-Dateien) wie z.B. stdio.h sind 
sehr praktisch, aber wenn man will, kann man ganz ohne sie auskommen.

Ungefaehre Groesse der Kopfdatei stdio.h:
Lcc-win32:     ca. 230 Zeilen
Borland bcc32: ca. 500 Zeilen
Gnu gcc:       ca. 650 Zeilen
tcc            ca. 400 Zeilen

Von diesen Zeilen werden fuer dieses simple Programm nur zwei benoetigt, 
(siehe Ersatzteil 1 und Ersatztei 2). Die Tripel-Punkte ... sind keine
Auslassungen, sondern C-Syntax. Sie stehen fuer "beliebig viele weitere
Parameter").
------------------------------------------------------------------------ */
int printf (const char *, ...);  // Ersatzteil 1 fuer #include <stdio.h>
int scanf  (const char *, ...);  // Ersatzteil 2 fuer #include <stdio.h>

int main() {
   int   n1; // Aeltere C-Compiler erlauben Variablenvereinbarungen
   float f1; // nur am Anfang einer Funktion, vor der ersten
   float f2; // Anweisung (z.B. printf-Anweisung)

   printf("------------------------------------------\n");
   printf("Eine Ganzzahl? ");
   scanf ("%d", &n1);          // Liest eine Ganzzahl nach n1
   printf("Ihre Eingabe:  %d\n", n1);
   printf("------------------------------------------\n");
   printf("Zwei Gleitpunktzahlen? ");
   scanf ("%f %f", &f1, &f2); // Liest zwei Bruchzahlen nach f1 und f2
   printf("Ihre Eingaben:   %f, %f!\n", f1, f2);
   printf("------------------------------------------\n");

   return 0; // Meldung an das Betriebssystem: Alles o.k.
} // main
/* ------------------------------------------------------------------------
Ein Dialog mit dem Programm kopflos:

------------------------------------------
Eine Ganzzahl? 123
Ihre Eingabe:  123
------------------------------------------
Zwei Gleitpunktzahlen? 1.23 45.6
Ihre Eingaben:   1.230000, 45.599998!
------------------------------------------
------------------------------------------------------------------------ */
