@echo off
rem Cmd-Skript testeSkripte02.cmd
rem ----------------------------------------------------------------------
rem Ruft jedes der folgenden bash-Skripte einmal auf, wendet es auf
rem das simple Quellprogramm pp1.c an und fuehrt dann einen einfachen
rem Test aus:
rem                  Test-Frage
rem b, bb, bl, bt    Funktioniert das erzeugte Programm pp1.exe?
rem c, cb, cl, ct    Wurde eine Objektdatei (pp1.o bzw. pp1.obj) erzeugt?
rem ----------------------------------------------------------------------
rem Ein Test-String: Wird dem Programm %BN%.exe als Parameter 1 uebergeben
rem und wird von dem Programm zur Standardausgabe ausgegeben:
set EINGABE=abc123def456
rem Basis-Name des Programms (ohne Erweiterung .c, .o, .obj oder .exe):
set BN=pp1
rem Name einer Datei, in die stoerende Ausgaben "entsorgt werden":
set MUELL=aus.txt
rem Name einer Datei, in die die Ausgaben von Programmen gelenkt werden:
set DATEN=dat.txt
rem ----------------------------------------------------------------------

SetLocal

rem b-Skripte testen (mit Hilfe der c-Skripte):
call :TESTE_b b.cmd
call :TESTE_b bb.cmd
call :TESTE_b bl.cmd
call :TESTE_b bt.cmd

rem c-Skripte testen:
call :TESTE_c c.cmd  o
call :TESTE_c cb.cmd obj
call :TESTE_c cl.cmd obj
call :TESTE_c ct.cmd o

echo ---------------------------------------------------

rem Den Muelleimer und den Daten-Behaelter leeren (genauer: zerstoeren):
del %MUELL% 2>nul
del %DATEN% 2>nul

goto :EOF
rem Ende des "Haupt-Skripts", jetzt kommen noch 3 Prozduren

rem ----------------------------------------------------------------------
rem Die Prozedur TESTE_a:
:TESTE_b
   rem Erwartet 1 Parameter:
   rem %1 Name eines bash-Skripts

   echo ---------------------------------------------------
   echo TESTE_b %1

   rem Das a-Skript aufrufen
   call %1 %BN% > %MUELL%
   rem Das erzeugte Prog. aufrufen:
   %BN%.exe "%EINGABE%" > %DATEN%
   rem Die Ausgabe des Programms in die Variable AUSGABE lesen:
   set /P AUSGABE=< %DATEN%

   rem Stimmt die Ausgabe des Prog?
   if "%EINGABE%" EQU "%AUSGABE%" (
      echo O.K:
   ) else (
      echo Fehler ############################################
      echo   SOLL: %EINGABE%
      echo   IST:  %AUSGABE%
   )

   rem Alle erzeugten Dateien loeschen:
   call e > %MUELL%

   goto :EOF

rem ------------------------------------------------------------------------
rem Die Prozedur TEST_b
:TESTE_c
   rem Erwartet 2 Parameter:
   rem %1 Name eines der bash-Skripte c, cb, cl, ct
   rem %2 Erweiterung von Objektdateien (o bzw. obj)

   echo ---------------------------------------------------
   echo TESTE_c %1 %2

   rem Das c-Skript aufrufen:
   call %1 %BN% > %MUELL%

   rem Wurde eine Objekt-Datei (.o bzw. .obj-Datei) erzeugt?
   if EXIST %BN%.%2   (
      echo O.K.
   ) else (
      echo Fehler ############################################
      echo Es wurde keine Datei %BN%.%2 erzeugt! Es gibt nur:
      ls %BN%.*
   )

   rem Alle erzeugten Dateien loeschen:
   call e > %MUELL%
   goto :EOF

rem ------------------------------------------------------------------------

