#ifndef __RPC_H__
#include <rpc.h>
#endif
#ifndef __RPCNDR_H__
#include <rpcndr.h>
#endif
#if !defined( _OBJBASE_H_ )
#define _OBJBASE_H_
#pragma pack(push,8)
#ifdef _OLE32_
#define WINOLEAPI STDAPI
#define WINOLEAPI_(type) STDAPI_(type)
#else
#define WINOLEAPI HRESULT _stdcall
#define WINOLEAPI_(type) type _stdcall
#define IN
#define OUT
#endif
#define interface struct
#define STDMETHOD(method) HRESULT (STDMETHODCALLTYPE * method)
#define STDMETHOD_(type,method) type (STDMETHODCALLTYPE * method)
#define STDMETHODIMP HRESULT STDMETHODCALLTYPE
#define STDMETHODIMP_(type) type STDMETHODCALLTYPE
#if !defined(BEGIN_INTERFACE)
#define BEGIN_INTERFACE
#define END_INTERFACE
#endif
#define PURE
#define THIS_ INTERFACE * This,
#define THIS INTERFACE * This
#ifdef CONST_VTABLE
#undef CONST_VTBL
#define CONST_VTBL const
#define DECLARE_INTERFACE(iface) typedef interface iface {struct iface##Vtbl *lpVtbl;} iface; typedef struct iface##Vtbl iface##Vtbl;struct iface##Vtbl
#else
#undef CONST_VTBL
#define CONST_VTBL
#define DECLARE_INTERFACE(iface) typedef interface iface {struct iface##Vtbl * lpVtbl;} iface; typedef struct iface##Vtbl iface##Vtbl; struct iface##Vtbl
#endif
#define DECLARE_INTERFACE_(iface,baseiface) DECLARE_INTERFACE(iface)

#define FARSTRUCT
#define HUGEP
#include <stdlib.h>
#define LISet32(li,v) ((li).HighPart = (v) < 0 ? -1 : 0,(li).LowPart = (v))
#define ULISet32(li,v) ((li).HighPart = 0,(li).LowPart = (v))
#define CLSCTX_INPROC (CLSCTX_INPROC_SERVER|CLSCTX_INPROC_HANDLER)
#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM)
#define CLSCTX_ALL (CLSCTX_INPROC_SERVER| CLSCTX_INPROC_HANDLER|CLSCTX_LOCAL_SERVER|CLSCTX_REMOTE_SERVER)
#define CLSCTX_SERVER (CLSCTX_INPROC_SERVER|CLSCTX_LOCAL_SERVER|CLSCTX_REMOTE_SERVER)
#else
#define CLSCTX_ALL (CLSCTX_INPROC_SERVER|CLSCTX_INPROC_HANDLER|CLSCTX_LOCAL_SERVER)
#define CLSCTX_SERVER (CLSCTX_INPROC_SERVER|CLSCTX_LOCAL_SERVER)
#endif
typedef enum tagREGCLS {
 REGCLS_SINGLEUSE = 0,REGCLS_MULTIPLEUSE = 1,REGCLS_MULTI_SEPARATE = 2,
 REGCLS_SUSPENDED = 4,REGCLS_SURROGATE = 8
} REGCLS;
#define MARSHALINTERFACE_MIN 500
#define CWCSTORAGENAME 32
#define STGM_DIRECT 0
#define STGM_TRANSACTED 0x10000
#define STGM_SIMPLE 0x8000000
#define STGM_READ 0
#define STGM_WRITE 1
#define STGM_READWRITE 2
#define STGM_SHARE_DENY_NONE 0x40
#define STGM_SHARE_DENY_READ 0x30
#define STGM_SHARE_DENY_WRITE 0x20
#define STGM_SHARE_EXCLUSIVE 16
#define STGM_PRIORITY 0x40000
#define STGM_DELETEONRELEASE 0x4000000
#define STGM_NOSCRATCH 0x100000
#define STGM_CREATE 0x1000
#define STGM_CONVERT 0x20000
#define STGM_FAILIFTHERE 0
#define STGM_NOSNAPSHOT 0x200000
#define STGM_DIRECT_SWMR 0x400000
#define ASYNC_MODE_COMPATIBILITY 1
#define ASYNC_MODE_DEFAULT 0
#define STGTY_REPEAT 0x100
#define STG_TOEND 0xFFFFFFFF
#define STG_LAYOUT_SEQUENTIAL 0
#define STG_LAYOUT_INTERLEAVED 1
#define STGFMT_STORAGE 0
#define STGFMT_NATIVE 1
#define STGFMT_FILE 3
#define STGFMT_ANY 4
#define STGFMT_DOCFILE 5
#define STGFMT_DOCUMENT 0
#ifndef __IRpcStubBuffer_FWD_DEFINED__
#define __IRpcStubBuffer_FWD_DEFINED__
typedef interface IRpcStubBuffer IRpcStubBuffer;
#endif
#ifndef __IRpcChannelBuffer_FWD_DEFINED__
#define __IRpcChannelBuffer_FWD_DEFINED__
typedef interface IRpcChannelBuffer IRpcChannelBuffer;
#endif
#include <wtypes.h>
#ifndef __unknwn_h__
#include <unknwn.h>
#endif
#ifndef __objidl_h__
#include <objidl.h>
#endif
#ifndef INITGUID
#define DEFINE_GUID(name,l,w1,w2,b1,b2,b3,b4,b5,b6,b7,b8) extern GUID name
#else
#define DEFINE_GUID(name,l,w1,w2,b1,b2,b3,b4,b5,b6,b7,b8) GUID name = { l,w1,w2,{ b1,b2,b3,b4,b5,b6,b7,b8}}
#endif
#define DEFINE_OLEGUID(name,l,w1,w2) DEFINE_GUID(name,l,w1,w2,0xC0,0,0,0,0,0,0,0x46)
#ifdef _OLE32_
#define InlineIsEqualGUID(rguid1,rguid2) \
 (((PLONG) rguid1)[0] == ((PLONG) rguid2)[0] && \
 ((PLONG) rguid1)[1] == ((PLONG) rguid2)[1] && \
 ((PLONG) rguid1)[2] == ((PLONG) rguid2)[2] && \
 ((PLONG) rguid1)[3] == ((PLONG) rguid2)[3])
#ifdef _OLE32PRIV_
BOOL _fastcall wIsEqualGUID(REFGUID rguid1,REFGUID rguid2);
#define IsEqualGUID(rguid1,rguid2) wIsEqualGUID(rguid1,rguid2)
#else
#define IsEqualGUID(rguid1,rguid2) InlineIsEqualGUID(rguid1,rguid2)
#endif

#else
#define IsEqualGUID(rguid1,rguid2) (!memcmp(rguid1,rguid2,sizeof(GUID)))
#endif

#define IsEqualIID(riid1,riid2) IsEqualGUID(riid1,riid2)
#define IsEqualCLSID(rclsid1,rclsid2) IsEqualGUID(rclsid1,rclsid2)
#ifndef INITGUID
#include <cguid.h>
#endif
typedef enum tagCOINIT { COINIT_APARTMENTTHREADED = 2, COINIT_MULTITHREADED = 0,
COINIT_DISABLE_OLE1DDE = 4, COINIT_SPEED_OVER_MEMORY = 8, } COINIT;
typedef enum tagCOMSD { SD_LAUNCHPERMISSIONS = 0, SD_ACCESSPERMISSIONS = 1,
SD_LAUNCHRESTRICTIONS = 2, SD_ACCESSRESTRICTIONS = 3 } COMSD;
WINOLEAPI_(DWORD) CoBuildVersion( VOID );
WINOLEAPI CoInitialize(LPVOID pvReserved);
WINOLEAPI_(void) CoUninitialize(void);
WINOLEAPI CoGetMalloc(DWORD dwMemContext,LPMALLOC * ppMalloc);
WINOLEAPI_(DWORD) CoGetCurrentProcess(void);
WINOLEAPI CoRegisterMallocSpy(LPMALLOCSPY pMallocSpy);
WINOLEAPI CoRevokeMallocSpy(void);
WINOLEAPI CoCreateStandardMalloc(DWORD memctx,IMalloc * * ppMalloc);
WINOLEAPI CoInitializeEx(LPVOID pvReserved,DWORD dwCoInit);
WINOLEAPI CoRegisterInitializeSpy(void *,ULARGE_INTEGER *);
WINOLEAPI CoRevokeInitializeSpy(ULARGE_INTEGER);
#if DBG == 1
WINOLEAPI_(ULONG) DebugCoGetRpcFault( void );
WINOLEAPI_(void) DebugCoSetRpcFault( ULONG );
#endif
WINOLEAPI CoGetClassObject(REFCLSID,DWORD,LPVOID,REFIID,LPVOID *);
WINOLEAPI CoRegisterClassObject(REFCLSID,IUnknown *,DWORD,DWORD,LPDWORD);
WINOLEAPI CoRevokeClassObject(DWORD);
WINOLEAPI CoResumeClassObjects(void);
WINOLEAPI CoSuspendClassObjects(void);
WINOLEAPI_(ULONG) CoAddRefServerProcess(void);
WINOLEAPI_(ULONG) CoReleaseServerProcess(void);
WINOLEAPI CoGetPSClsid(REFIID,CLSID *);
WINOLEAPI CoGetSystemSecurityPermissions(COMSD comSDType, PSECURITY_DESCRIPTOR *ppSD);
WINOLEAPI CoRegisterPSClsid(REFIID,REFCLSID);
WINOLEAPI CoRegisterSurrogate(LPSURROGATE);
WINOLEAPI CoGetMarshalSizeMax(ULONG *,REFIID,IUnknown *,DWORD,LPVOID,DWORD);
WINOLEAPI CoMarshalInterface(LPSTREAM,REFIID,IUnknown *,DWORD,LPVOID,DWORD);
WINOLEAPI CoUnmarshalInterface(LPSTREAM,REFIID,LPVOID *);
WINOLEAPI CoMarshalHresult(LPSTREAM,HRESULT);
WINOLEAPI CoUnmarshalHresult(LPSTREAM,HRESULT  *);
WINOLEAPI CoReleaseMarshalData(LPSTREAM);
WINOLEAPI CoDisconnectObject(IUnknown *,DWORD);
WINOLEAPI CoLockObjectExternal(IUnknown *,BOOL,BOOL);
WINOLEAPI CoGetStandardMarshal(REFIID,IUnknown *,DWORD,LPVOID,DWORD,LPMARSHAL * );
WINOLEAPI CoGetStdMarshalEx(IUnknown *,DWORD,IUnknown * *);
WINOLEAPI CoGetStaticMarshal(IUnknown *,ULONG,IID **,UUID **,DWORD,ULONG,IUnknown * *,IUnknown **);
typedef enum tagSTDMSHLFLAGS {SMEXF_SERVER = 1,SMEXF_HANDLER =2 } STDMSHLFLAGS;
WINOLEAPI_(BOOL) CoIsHandlerConnected(IUnknown *);
WINOLEAPI_(BOOL) CoHasStrongExternalConnections(IUnknown *);
WINOLEAPI CoMarshalInterThreadInterfaceInStream(REFIID,IUnknown *,LPSTREAM *);
WINOLEAPI CoGetInterfaceAndReleaseStream(LPSTREAM,REFIID,LPVOID * );
WINOLEAPI CoCreateFreeThreadedMarshaler(IUnknown *,IUnknown * *l);
WINOLEAPI_(HINSTANCE) CoLoadLibrary(LPOLESTR,BOOL);
WINOLEAPI_(void) CoFreeLibrary(HINSTANCE);
WINOLEAPI_(void) CoFreeAllLibraries(void);
WINOLEAPI_(void) CoFreeUnusedLibraries(void);
WINOLEAPI CoInitializeSecurity(PSECURITY_DESCRIPTOR,LONG,SOLE_AUTHENTICATION_SERVICE *,void *,DWORD,DWORD,void *,DWORD,void *);
WINOLEAPI CoGetCallContext( REFIID riid,void **ppInterface );
WINOLEAPI CoQueryProxyBlanket( IUnknown *,DWORD *,DWORD *,OLECHAR **,DWORD *,DWORD *,RPC_AUTH_IDENTITY_HANDLE *,DWORD *);
WINOLEAPI CoSetProxyBlanket(IUnknown *,DWORD,DWORD,OLECHAR *,DWORD,DWORD,RPC_AUTH_IDENTITY_HANDLE,DWORD  );
WINOLEAPI CoCopyProxy(IUnknown *,IUnknown **);
WINOLEAPI CoQueryClientBlanket( DWORD *,DWORD *,OLECHAR **,DWORD *,DWORD *,RPC_AUTHZ_HANDLE *,DWORD *);
WINOLEAPI CoImpersonateClient();
WINOLEAPI CoRevertToSelf();
WINOLEAPI CoQueryAuthenticationServices(DWORD *,SOLE_AUTHENTICATION_SERVICE **);
WINOLEAPI CoSwitchCallContext(IUnknown *,IUnknown **);
#define COM_RIGHTS_EXECUTE 1
#define COM_RIGHTS_SAFE_FOR_SCRIPTING 2
WINOLEAPI CoCreateInstance(REFCLSID,IUnknown *,DWORD,REFIID,LPVOID *);
WINOLEAPI CoGetInstanceFromFile(COSERVERINFO *,CLSID *,IUnknown *,DWORD,DWORD,OLECHAR *,DWORD,MULTI_QI * ); 
WINOLEAPI CoGetInstanceFromIStorage( COSERVERINFO *,CLSID *,IUnknown *,DWORD,struct IStorage *,DWORD,MULTI_QI * ); 
WINOLEAPI CoCreateInstanceEx( REFCLSID,IUnknown *,DWORD,COSERVERINFO *,DWORD,MULTI_QI *);
WINOLEAPI CoGetCancelObject(DWORD,REFIID,void **);
WINOLEAPI CoSetCancelObject(IUnknown *);
WINOLEAPI CoCancelCall(DWORD,ULONG);
WINOLEAPI CoTestCancel();

#if (_WIN32_WINNT >= 0x0500 ) || defined(_WIN32_DCOM)
WINOLEAPI CoGetClassInfo(uCLSSPEC *,QUERYCONTEXT *);
WINOLEAPI CoGetClassAccess(IClassAccess **);
#define APPINFO_PUBLISHED 1
#define APPINFO_ASSIGNED 2
#define APPINFO_MSI 4
#define APPINFO_VISIBLE 8
#define APPINFO_AUTOINSTALL 16
#define APPINFO_ALLLOCALE 32
#define APPINFO_ALLPLATFORM 64
WINOLEAPI CoEnumApps(LPOLESTR,GUID *,DWORD,IEnumPackage **);
#endif

WINOLEAPI StringFromCLSID(REFCLSID,LPOLESTR *);
WINOLEAPI CLSIDFromString(LPOLESTR,LPCLSID);
WINOLEAPI StringFromIID(REFIID,LPOLESTR *);
WINOLEAPI IIDFromString(LPOLESTR,LPIID);
WINOLEAPI_(BOOL) CoIsOle1Class(REFCLSID);
WINOLEAPI ProgIDFromCLSID(REFCLSID,LPOLESTR *);
WINOLEAPI CLSIDFromProgID(LPCOLESTR,LPCLSID);
WINOLEAPI_(int) StringFromGUID2(REFGUID,LPOLESTR,int);
WINOLEAPI CoCreateGuid(GUID  *);
WINOLEAPI_(BOOL) CoFileTimeToDosDateTime(FILETIME *,LPWORD,LPWORD);
WINOLEAPI_(BOOL) CoDosDateTimeToFileTime(WORD ,WORD ,FILETIME * );
WINOLEAPI CoFileTimeNow(FILETIME *);
WINOLEAPI CoRegisterMessageFilter(LPMESSAGEFILTER,LPMESSAGEFILTER *);

WINOLEAPI CoRegisterChannelHook(REFGUID,IChannelHook *);
WINOLEAPI CoWaitForMultipleHandles (DWORD,DWORD,ULONG,LPHANDLE,LPDWORD);
typedef enum tagCOWAIT_FLAGS {COWAIT_WAITALL=1,COWAIT_ALERTABLE=2}COWAIT_FLAGS;
WINOLEAPI CoGetTreatAsClass(REFCLSID,LPCLSID);
WINOLEAPI CoTreatAsClass(REFCLSID,REFCLSID);
typedef HRESULT (_stdcall * LPFNGETCLASSOBJECT) (REFCLSID,REFIID,LPVOID *);
typedef HRESULT (_stdcall * LPFNCANUNLOADNOW)(void);
STDAPI DllGetClassObject(REFCLSID,REFIID,void **);
STDAPI DllCanUnloadNow(void);
WINOLEAPI_(LPVOID) CoTaskMemAlloc(ULONG);
WINOLEAPI_(LPVOID) CoTaskMemRealloc(LPVOID,ULONG);
WINOLEAPI_(void) CoTaskMemFree(LPVOID);
WINOLEAPI CreateDataAdviseHolder(LPDATAADVISEHOLDER *);
WINOLEAPI CreateDataCache(IUnknown *,REFCLSID,REFIID,LPVOID *);
WINOLEAPI StgCreateDocfile(OLECHAR *,DWORD,DWORD,IStorage **);
WINOLEAPI StgCreateDocfileOnILockBytes(ILockBytes *,DWORD,DWORD,IStorage * *);
WINOLEAPI StgOpenStorage(const OLECHAR *,IStorage  *,DWORD,SNB,DWORD,IStorage **);
WINOLEAPI StgOpenStorageOnILockBytes(ILockBytes  *,IStorage  *,DWORD,SNB,DWORD,IStorage * *);
WINOLEAPI StgIsStorageFile(const OLECHAR *);
WINOLEAPI StgIsStorageILockBytes(ILockBytes *);
WINOLEAPI StgSetTimes(OLECHAR const *,FILETIME const *,FILETIME const *,FILETIME const * );
WINOLEAPI StgOpenAsyncDocfileOnIFillLockBytes( IFillLockBytes *,DWORD,DWORD,IStorage **);
WINOLEAPI StgGetIFillLockBytesOnILockBytes( ILockBytes *,IFillLockBytes **);
WINOLEAPI StgGetIFillLockBytesOnFile(OLECHAR const *,IFillLockBytes **);
WINOLEAPI StgOpenLayoutDocfile(OLECHAR const *,DWORD,DWORD,IStorage **);
#define STGOPTIONS_VERSION 1
typedef struct tagSTGOPTIONS {
 USHORT usVersion;
 USHORT reserved;
 ULONG ulSectorSize;
} STGOPTIONS;

WINOLEAPI StgCreateStorageEx (const WCHAR*,DWORD,DWORD,DWORD,STGOPTIONS *,void *,REFIID,void ** ); 
WINOLEAPI StgOpenStorageEx (const WCHAR*,DWORD,DWORD,DWORD,STGOPTIONS *,void *,REFIID,void ** );
WINOLEAPI BindMoniker(LPMONIKER pmk,DWORD grfOpt,REFIID iidResult,LPVOID * ppvResult);
WINOLEAPI CoInstall( IBindCtx *,DWORD,uCLSSPEC *,QUERYCONTEXT *,LPWSTR);
WINOLEAPI CoGetObject(LPCWSTR,BIND_OPTS *,REFIID,void **);
WINOLEAPI MkParseDisplayName(LPBC,LPCOLESTR,ULONG  *,LPMONIKER  *);
WINOLEAPI MonikerRelativePathTo(LPMONIKER,LPMONIKER,LPMONIKER *,BOOL);
WINOLEAPI MonikerCommonPrefixWith(LPMONIKER,LPMONIKER,LPMONIKER *);
WINOLEAPI CreateBindCtx(DWORD,LPBC *);
WINOLEAPI CreateGenericComposite(LPMONIKER,LPMONIKER,LPMONIKER *);
WINOLEAPI GetClassFile(LPCOLESTR,CLSID *);
WINOLEAPI CreateClassMoniker(REFCLSID rclsid,LPMONIKER * ppmk);
WINOLEAPI CreateFileMoniker(LPCOLESTR,LPMONIKER *);
WINOLEAPI CreateItemMoniker(LPCOLESTR,LPCOLESTR,LPMONIKER *);
WINOLEAPI CreateAntiMoniker(LPMONIKER *);
WINOLEAPI CreatePointerMoniker(IUnknown *,LPMONIKER * );
WINOLEAPI GetRunningObjectTable(DWORD,LPRUNNINGOBJECTTABLE *);
#ifndef __urlmon_h__
#include <urlmon.h>
#endif
#ifndef __propidl_h__
#include <propidl.h>
#endif
WINOLEAPI CreateStdProgressIndicator(HWND,LPCOLESTR,IBindStatusCallback *,IBindStatusCallback **);
#pragma pack(pop)
#endif
