#ifndef _ACLUI_H_
#define _ACLUI_H_
#include <objbase.h>
#include <commctrl.h> 
#include <accctrl.h> 
#define ACLUIAPI WINAPI
typedef struct _SI_OBJECT_INFO { DWORD dwFlags; HINSTANCE hInstance; LPWSTR pszServerName; 
	LPWSTR pszObjectName; LPWSTR pszPageTitle; GUID guidObjectType; 
} SI_OBJECT_INFO,*PSI_OBJECT_INFO;
#define SI_EDIT_PERMS 0
#define SI_EDIT_OWNER 1
#define SI_EDIT_AUDITS 2
#define SI_CONTAINER 4
#define SI_READONLY 8
#define SI_ADVANCED 16
#define SI_RESET 32
#define SI_OWNER_READONLY 64
#define SI_EDIT_PROPERTIES 128
#define SI_OWNER_RECURSE 256
#define SI_NO_ACL_PROTECT 512
#define SI_NO_TREE_APPLY 1024
#define SI_PAGE_TITLE 2048
#define SI_SERVER_IS_DC 4096
#define SI_RESET_DACL_TREE 0x4000
#define SI_RESET_SACL_TREE 0x8000
#define SI_OBJECT_GUID 0x10000
#define SI_EDIT_EFFECTIVE 0x20000
#define SI_RESET_DACL 0x40000
#define SI_RESET_SACL 0x80000
#define SI_RESET_OWNER 0x100000
#define SI_NO_ADDITIONAL_PERMISSION 0x200000
#define SI_MAY_WRITE 0x10000000
#define SI_EDIT_ALL (SI_EDIT_PERMS | SI_EDIT_OWNER | SI_EDIT_AUDITS)
typedef struct _SI_ACCESS { const GUID *pguid; ACCESS_MASK mask; LPCWSTR pszName; DWORD dwFlags;
} SI_ACCESS,*PSI_ACCESS;
#define SI_ACCESS_SPECIFIC 0x10000
#define SI_ACCESS_GENERAL 0x20000
#define SI_ACCESS_CONTAINER 0x40000
#define SI_ACCESS_PROPERTY 0x80000
typedef struct _SI_INHERIT_TYPE { const GUID *pguid; ULONG dwFlags; LPCWSTR pszName; 
} SI_INHERIT_TYPE,*PSI_INHERIT_TYPE;
typedef enum _SI_PAGE_TYPE { SI_PAGE_PERM=0, SI_PAGE_ADVPERM, SI_PAGE_AUDIT, SI_PAGE_OWNER, SI_PAGE_EFFECTIVE,
} SI_PAGE_TYPE;
#define PSPCB_SI_INITDIALOG	(WM_USER + 1)
#undef INTERFACE
#define INTERFACE ISecurityInformation
DECLARE_INTERFACE_(ISecurityInformation,IUnknown)
{
STDMETHOD(QueryInterface) (THIS_ REFIID ,LPVOID *);
STDMETHOD_(ULONG,AddRef) (THIS);
STDMETHOD_(ULONG,Release) (THIS);
STDMETHOD(GetObjectInformation) (THIS_ PSI_OBJECT_INFO );
STDMETHOD(GetSecurity) (THIS_ SECURITY_INFORMATION ,PSECURITY_DESCRIPTOR *,BOOL );
STDMETHOD(SetSecurity) (THIS_ SECURITY_INFORMATION ,PSECURITY_DESCRIPTOR );
STDMETHOD(GetAccessRights) (THIS_ const GUID* pguidObjectType,DWORD ,PSI_ACCESS *,ULONG *,ULONG *);
STDMETHOD(MapGeneric) (THIS_ const GUID *,UCHAR *,ACCESS_MASK *);
STDMETHOD(GetInheritTypes) (THIS_ PSI_INHERIT_TYPE *,ULONG *);
STDMETHOD(PropertySheetPageCallback)(THIS_ HWND ,UINT ,SI_PAGE_TYPE );
};
typedef ISecurityInformation *LPSECURITYINFO;
#undef INTERFACE
#define INTERFACE ISecurityInformation2
DECLARE_INTERFACE_(ISecurityInformation2,IUnknown)
{
STDMETHOD(QueryInterface) (THIS_ REFIID ,LPVOID *);
STDMETHOD_(ULONG,AddRef) (THIS);
STDMETHOD_(ULONG,Release) (THIS);
STDMETHOD_(BOOL,IsDaclCanonical) (THIS_ PACL );
STDMETHOD(LookupSids) (THIS_ ULONG ,IN PSID *rgpSids,OUT LPDATAOBJECT *ppdo);
};
typedef ISecurityInformation2 *LPSECURITYINFO2;
#define CFSTR_ACLUI_SID_INFO_LIST TEXT("CFSTR_ACLUI_SID_INFO_LIST")
typedef struct _SID_INFO
{
PSID pSid;
PWSTR pwzCommonName;
PWSTR pwzClass; 
PWSTR pwzUPN; 
} SID_INFO,*PSID_INFO;
typedef struct _SID_INFO_LIST
{
ULONG cItems;
SID_INFO aSidInfo[ANYSIZE_ARRAY];
} SID_INFO_LIST,*PSID_INFO_LIST;
#undef INTERFACE
#define INTERFACE IEffectivePermission
DECLARE_INTERFACE_(IEffectivePermission,IUnknown)
{
STDMETHOD(QueryInterface) (THIS_ REFIID ,LPVOID *);
STDMETHOD_(ULONG,AddRef) (THIS);
STDMETHOD_(ULONG,Release) (THIS);
STDMETHOD(GetEffectivePermission) (THIS_ const GUID* pguidObjectType,PSID ,LPCWSTR ,PSECURITY_DESCRIPTOR ,POBJECT_TYPE_LIST *,ULONG *,PACCESS_MASK *,ULONG *);
};
typedef IEffectivePermission *LPEFFECTIVEPERMISSION;
#undef INTERFACE
#define INTERFACE ISecurityObjectTypeInfo
DECLARE_INTERFACE_(ISecurityObjectTypeInfo,IUnknown)
{
STDMETHOD(QueryInterface) (THIS_ REFIID ,LPVOID *);
STDMETHOD_(ULONG,AddRef) (THIS);
STDMETHOD_(ULONG,Release) (THIS);
STDMETHOD(GetInheritSource)(SECURITY_INFORMATION ,PACL ,PINHERITED_FROM *);
};
typedef ISecurityObjectTypeInfo *LPSecurityObjectTypeInfo;
EXTERN_GUID(IID_ISecurityInformation,0x965fc360,5887,4560,145,203,0,170,0,187,183,35);
EXTERN_GUID(IID_ISecurityInformation2,0xc3ccfdb4,0x6f88,4562,163,206,0,192,79,177,120,42);
EXTERN_GUID(IID_IEffectivePermission,0x3853dc76,0x9f35,0x407c,136,161,209,147,68,54,95,188);
EXTERN_GUID(IID_ISecurityObjectTypeInfo,0xfc3066eb,0x79ef,0x444b,145,17,209,138,117,235,242,250);
HPROPSHEETPAGE ACLUIAPI CreateSecurityPage(LPSECURITYINFO );
BOOL ACLUIAPI EditSecurity(HWND ,LPSECURITYINFO );
#endif 
