#ifndef __authz_h__
#define __authz_h__
#include <windows.h>
#include <adtgen.h>
#define AUTHZ_SKIP_TOKEN_GROUPS 2
#define AUTHZ_REQUIRE_S4U_LOGON 4
DECLARE_HANDLE(AUTHZ_ACCESS_CHECK_RESULTS_HANDLE);
DECLARE_HANDLE(AUTHZ_CLIENT_CONTEXT_HANDLE);
DECLARE_HANDLE(AUTHZ_RESOURCE_MANAGER_HANDLE);
DECLARE_HANDLE(AUTHZ_AUDIT_EVENT_HANDLE);
DECLARE_HANDLE(AUTHZ_AUDIT_EVENT_TYPE_HANDLE);
typedef AUTHZ_ACCESS_CHECK_RESULTS_HANDLE *PAUTHZ_ACCESS_CHECK_RESULTS_HANDLE;
typedef AUTHZ_CLIENT_CONTEXT_HANDLE *PAUTHZ_CLIENT_CONTEXT_HANDLE;
typedef AUTHZ_RESOURCE_MANAGER_HANDLE *PAUTHZ_RESOURCE_MANAGER_HANDLE;
typedef AUTHZ_AUDIT_EVENT_HANDLE *PAUTHZ_AUDIT_EVENT_HANDLE;
typedef AUTHZ_AUDIT_EVENT_TYPE_HANDLE *PAUTHZ_AUDIT_EVENT_TYPE_HANDLE;
typedef struct _AUTHZ_ACCESS_REQUEST
{
ACCESS_MASK DesiredAccess;
PSID PrincipalSelfSid;
POBJECT_TYPE_LIST ObjectTypeList;
DWORD ObjectTypeListLength;
PVOID OptionalArguments;
} AUTHZ_ACCESS_REQUEST,*PAUTHZ_ACCESS_REQUEST;
typedef struct _AUTHZ_ACCESS_REPLY
{
DWORD ResultListLength;
PACCESS_MASK GrantedAccessMask;
#define AUTHZ_GENERATE_SUCCESS_AUDIT 1
#define AUTHZ_GENERATE_FAILURE_AUDIT 2
PDWORD SaclEvaluationResults OPTIONAL;
PDWORD Error;
} AUTHZ_ACCESS_REPLY,*PAUTHZ_ACCESS_REPLY;
typedef BOOL (CALLBACK *PFN_AUTHZ_DYNAMIC_ACCESS_CHECK) (AUTHZ_CLIENT_CONTEXT_HANDLE ,PACE_HEADER ,PVOID ,PBOOL);
typedef BOOL (CALLBACK *PFN_AUTHZ_COMPUTE_DYNAMIC_GROUPS) (AUTHZ_CLIENT_CONTEXT_HANDLE ,PVOID ,PSID_AND_ATTRIBUTES *,PDWORD ,PSID_AND_ATTRIBUTES *,PDWORD pRestrictedSidCount );
typedef VOID (CALLBACK *PFN_AUTHZ_FREE_DYNAMIC_GROUPS) (PSID_AND_ATTRIBUTES pSidAttrArray );
#define AUTHZ_ACCESS_CHECK_NO_DEEP_COPY_SD 1
BOOL WINAPI AuthzAccessCheck(DWORD ,AUTHZ_CLIENT_CONTEXT_HANDLE ,PAUTHZ_ACCESS_REQUEST ,AUTHZ_AUDIT_EVENT_HANDLE ,PSECURITY_DESCRIPTOR ,PSECURITY_DESCRIPTOR *,DWORD ,PAUTHZ_ACCESS_REPLY ,PAUTHZ_ACCESS_CHECK_RESULTS_HANDLE phAccessCheckResults OPTIONAL );
BOOL WINAPI AuthzCachedAccessCheck(DWORD ,AUTHZ_ACCESS_CHECK_RESULTS_HANDLE ,PAUTHZ_ACCESS_REQUEST ,AUTHZ_AUDIT_EVENT_HANDLE ,PAUTHZ_ACCESS_REPLY pReply );
BOOL WINAPI AuthzOpenObjectAudit(DWORD ,AUTHZ_CLIENT_CONTEXT_HANDLE ,PAUTHZ_ACCESS_REQUEST ,AUTHZ_AUDIT_EVENT_HANDLE ,PSECURITY_DESCRIPTOR ,PSECURITY_DESCRIPTOR *,DWORD ,PAUTHZ_ACCESS_REPLY pReply );
BOOL WINAPI AuthzFreeHandle(AUTHZ_ACCESS_CHECK_RESULTS_HANDLE hAccessCheckResults );
#define AUTHZ_RM_FLAG_NO_AUDIT 1
#define AUTHZ_RM_FLAG_INITIALIZE_UNDER_IMPERSONATION 2
#define AUTHZ_VALID_RM_INIT_FLAGS (AUTHZ_RM_FLAG_NO_AUDIT | AUTHZ_RM_FLAG_INITIALIZE_UNDER_IMPERSONATION)
BOOL WINAPI AuthzInitializeResourceManager(DWORD ,PFN_AUTHZ_DYNAMIC_ACCESS_CHECK ,PFN_AUTHZ_COMPUTE_DYNAMIC_GROUPS ,PFN_AUTHZ_FREE_DYNAMIC_GROUPS ,PCWSTR ,PAUTHZ_RESOURCE_MANAGER_HANDLE phAuthzResourceManager );
BOOL WINAPI AuthzFreeResourceManager(AUTHZ_RESOURCE_MANAGER_HANDLE hAuthzResourceManager );
BOOL WINAPI AuthzInitializeContextFromToken(DWORD ,HANDLE ,AUTHZ_RESOURCE_MANAGER_HANDLE ,PLARGE_INTEGER ,LUID ,PVOID ,PAUTHZ_CLIENT_CONTEXT_HANDLE phAuthzClientContext );
BOOL WINAPI AuthzInitializeContextFromSid(DWORD ,PSID ,AUTHZ_RESOURCE_MANAGER_HANDLE ,PLARGE_INTEGER ,LUID ,PVOID ,PAUTHZ_CLIENT_CONTEXT_HANDLE phAuthzClientContext );
BOOL WINAPI AuthzInitializeContextFromAuthzContext(DWORD ,AUTHZ_CLIENT_CONTEXT_HANDLE ,PLARGE_INTEGER ,LUID ,PVOID ,PAUTHZ_CLIENT_CONTEXT_HANDLE phNewAuthzClientContext );
BOOL WINAPI AuthzAddSidsToContext(AUTHZ_CLIENT_CONTEXT_HANDLE ,PSID_AND_ATTRIBUTES ,DWORD ,PSID_AND_ATTRIBUTES ,DWORD ,PAUTHZ_CLIENT_CONTEXT_HANDLE phNewAuthzClientContext );
typedef enum _AUTHZ_CONTEXT_INFORMATION_CLASS
{
AuthzContextInfoUserSid=1,
AuthzContextInfoGroupsSids,
AuthzContextInfoRestrictedSids,
AuthzContextInfoPrivileges,
AuthzContextInfoExpirationTime,
AuthzContextInfoServerContext,
AuthzContextInfoIdentifier,
AuthzContextInfoSource,
AuthzContextInfoAll
} AUTHZ_CONTEXT_INFORMATION_CLASS;
BOOL WINAPI AuthzGetInformationFromContext(AUTHZ_CLIENT_CONTEXT_HANDLE ,AUTHZ_CONTEXT_INFORMATION_CLASS ,DWORD ,PDWORD ,PVOID Buffer );
BOOL WINAPI AuthzFreeContext(AUTHZ_CLIENT_CONTEXT_HANDLE hAuthzClientContext );
#define AUTHZ_NO_SUCCESS_AUDIT 1
#define AUTHZ_NO_FAILURE_AUDIT 2
#define AUTHZ_NO_ALLOC_STRINGS 4
#define AUTHZ_VALID_OBJECT_ACCESS_AUDIT_FLAGS (AUTHZ_NO_SUCCESS_AUDIT | \ AUTHZ_NO_FAILURE_AUDIT | \ AUTHZ_NO_ALLOC_STRINGS)
BOOL WINAPI AuthzInitializeObjectAccessAuditEvent(DWORD ,AUTHZ_AUDIT_EVENT_TYPE_HANDLE ,PWSTR ,PWSTR ,PWSTR ,PWSTR ,PAUTHZ_AUDIT_EVENT_HANDLE ,DWORD ,... );
typedef enum _AUTHZ_AUDIT_EVENT_INFORMATION_CLASS
{
AuthzAuditEventInfoFlags=1,
AuthzAuditEventInfoOperationType,
AuthzAuditEventInfoObjectType,
AuthzAuditEventInfoObjectName,
AuthzAuditEventInfoAdditionalInfo,
} AUTHZ_AUDIT_EVENT_INFORMATION_CLASS;
BOOL WINAPI AuthzGetInformationFromAuditEvent(AUTHZ_AUDIT_EVENT_HANDLE ,AUTHZ_AUDIT_EVENT_INFORMATION_CLASS ,DWORD ,PDWORD ,PVOID Buffer );
BOOL WINAPI AuthzFreeAuditEvent(AUTHZ_AUDIT_EVENT_HANDLE hAuditEvent );
#endif 
