#ifndef __bluetoothapis_h__
#define __bluetoothapis_h__
#ifndef __windows_h__
#include <windows.h>
#endif
#ifndef __bthsdpdef_h__
#include <bthsdpdef.h>
#endif
#define BLUETOOTH_MAX_NAME_SIZE (248)
#define BLUETOOTH_MAX_PASSKEY_SIZE (16)
#define BLUETOOTH_MAX_PASSKEY_BUFFER_SIZE (BLUETOOTH_MAX_PASSKEY_SIZE + 1)
typedef ULONGLONG BTH_ADDR;
typedef struct _BLUETOOTH_ADDRESS {
union {
BTH_ADDR ullLong; 
BYTE rgBytes[ 6 ]; 
};
} BLUETOOTH_ADDRESS_STRUCT;
#define BLUETOOTH_ADDRESS BLUETOOTH_ADDRESS_STRUCT
#define BLUETOOTH_NULL_ADDRESS ((ULONGLONG) 0)
typedef struct _BLUETOOTH_FIND_RADIO_PARAMS {
DWORD dwSize; 
} BLUETOOTH_FIND_RADIO_PARAMS;
typedef HANDLE HBLUETOOTH_RADIO_FIND;
HBLUETOOTH_RADIO_FIND WINAPI BluetoothFindFirstRadio(BLUETOOTH_FIND_RADIO_PARAMS *,HANDLE *phRadio );
BOOL WINAPI BluetoothFindNextRadio(HBLUETOOTH_RADIO_FIND ,HANDLE *phRadio );
BOOL WINAPI BluetoothFindRadioClose(HBLUETOOTH_RADIO_FIND hFind );
typedef struct _BLUETOOTH_RADIO_INFO {
DWORD dwSize; 
BLUETOOTH_ADDRESS address; 
WCHAR szName[ BLUETOOTH_MAX_NAME_SIZE ]; 
ULONG ulClassofDevice; 
USHORT lmpSubversion; 
USHORT manufacturer; 
} BLUETOOTH_RADIO_INFO,*PBLUETOOTH_RADIO_INFO;
DWORD WINAPI BluetoothGetRadioInfo(HANDLE ,PBLUETOOTH_RADIO_INFO pRadioInfo );
typedef struct _BLUETOOTH_DEVICE_INFO {
DWORD dwSize; 
BLUETOOTH_ADDRESS Address; 
ULONG ulClassofDevice; 
BOOL fConnected; 
BOOL fRemembered; 
BOOL fAuthenticated; 
SYSTEMTIME stLastSeen; 
SYSTEMTIME stLastUsed; 
WCHAR szName[ BLUETOOTH_MAX_NAME_SIZE ]; 
} BLUETOOTH_DEVICE_INFO_STRUCT;
#define BLUETOOTH_DEVICE_INFO BLUETOOTH_DEVICE_INFO_STRUCT
typedef BLUETOOTH_DEVICE_INFO * PBLUETOOTH_DEVICE_INFO;
typedef struct _BLUETOOTH_DEVICE_SEARCH_PARAMS {
DWORD dwSize; 
BOOL fReturnAuthenticated; 
BOOL fReturnRemembered; 
BOOL fReturnUnknown; 
BOOL fReturnConnected; 
BOOL fIssueInquiry; 
UCHAR cTimeoutMultiplier; 
HANDLE hRadio; 
} BLUETOOTH_DEVICE_SEARCH_PARAMS;
typedef HANDLE HBLUETOOTH_DEVICE_FIND;
HBLUETOOTH_DEVICE_FIND WINAPI BluetoothFindFirstDevice(BLUETOOTH_DEVICE_SEARCH_PARAMS *,BLUETOOTH_DEVICE_INFO *pbtdi );
BOOL WINAPI BluetoothFindNextDevice(HBLUETOOTH_DEVICE_FIND ,BLUETOOTH_DEVICE_INFO *pbtdi );
BOOL WINAPI BluetoothFindDeviceClose(HBLUETOOTH_DEVICE_FIND hFind );
DWORD WINAPI BluetoothGetDeviceInfo(HANDLE ,BLUETOOTH_DEVICE_INFO *pbtdi );
DWORD WINAPI BluetoothUpdateDeviceRecord(BLUETOOTH_DEVICE_INFO *pbtdi );
DWORD WINAPI BluetoothRemoveDevice(BLUETOOTH_ADDRESS *pAddress );
typedef struct _BLUETOOTH_COD_PAIRS {
ULONG ulCODMask; 
LPCWSTR pcszDescription; 
} BLUETOOTH_COD_PAIRS;
typedef BOOL (WINAPI *PFN_DEVICE_CALLBACK)(LPVOID ,PBLUETOOTH_DEVICE_INFO );
typedef struct _BLUETOOTH_SELECT_DEVICE_PARAMS {
DWORD dwSize; 
ULONG cNumOfClasses; 
BLUETOOTH_COD_PAIRS * prgClassOfDevices; 
LPWSTR pszInfo; 
HWND hwndParent; 
BOOL fForceAuthentication; 
BOOL fShowAuthenticated; 
BOOL fShowRemembered; 
BOOL fShowUnknown; 
BOOL fAddNewDeviceWizard; 
BOOL fSkipServicesPage; 
PFN_DEVICE_CALLBACK pfnDeviceCallback; 
LPVOID pvParam; 
DWORD cNumDevices; 
PBLUETOOTH_DEVICE_INFO pDevices; 
} BLUETOOTH_SELECT_DEVICE_PARAMS;
BOOL WINAPI BluetoothSelectDevices(BLUETOOTH_SELECT_DEVICE_PARAMS *pbtsdp );
BOOL WINAPI BluetoothSelectDevicesFree(BLUETOOTH_SELECT_DEVICE_PARAMS *pbtsdp );
BOOL WINAPI BluetoothDisplayDeviceProperties(HWND ,BLUETOOTH_DEVICE_INFO *pbtdi );
DWORD WINAPI BluetoothAuthenticateDevice(HWND ,HANDLE ,BLUETOOTH_DEVICE_INFO *,PWCHAR ,ULONG ulPasskeyLength );
DWORD WINAPI BluetoothAuthenticateMultipleDevices(HWND ,HANDLE ,DWORD ,BLUETOOTH_DEVICE_INFO *pbtdi );
#define BLUETOOTH_SERVICE_DISABLE 0
#define BLUETOOTH_SERVICE_ENABLE 1
#define BLUETOOTH_SERVICE_MASK (BLUETOOTH_ENABLE_SERVICE | BLUETOOTH_DISABLE_SERVICE)
DWORD WINAPI BluetoothSetServiceState(HANDLE ,BLUETOOTH_DEVICE_INFO *,GUID *,DWORD dwServiceFlags );
DWORD WINAPI BluetoothEnumerateInstalledServices(HANDLE ,BLUETOOTH_DEVICE_INFO *,DWORD *,GUID *pGuidServices );
BOOL WINAPI BluetoothEnableDiscovery(HANDLE ,BOOL fEnabled );
BOOL WINAPI BluetoothIsDiscoverable(HANDLE hRadio );
BOOL WINAPI BluetoothEnableIncomingConnections(HANDLE ,BOOL fEnabled );
BOOL WINAPI BluetoothIsConnectable(HANDLE hRadio );
typedef HANDLE HBLUETOOTH_AUTHENTICATION_REGISTRATION;
typedef BOOL (*PFN_AUTHENTICATION_CALLBACK)(LPVOID ,PBLUETOOTH_DEVICE_INFO );
DWORD WINAPI BluetoothRegisterForAuthentication(BLUETOOTH_DEVICE_INFO *,HBLUETOOTH_AUTHENTICATION_REGISTRATION *,PFN_AUTHENTICATION_CALLBACK ,PVOID pvParam );
BOOL WINAPI BluetoothUnregisterAuthentication(HBLUETOOTH_AUTHENTICATION_REGISTRATION hRegHandle );
DWORD WINAPI BluetoothSendAuthenticationResponse(HANDLE ,BLUETOOTH_DEVICE_INFO *,LPWSTR pszPasskey );
typedef struct _SDP_ELEMENT_DATA {
SDP_TYPE type;
SDP_SPECIFICTYPE specificType;
union {
SDP_LARGE_INTEGER_16 int128; 
LONGLONG int64; 
LONG int32; 
SHORT int16; 
CHAR int8; 
SDP_ULARGE_INTEGER_16 uint128; 
ULONGLONG uint64; 
ULONG uint32; 
USHORT uint16; 
UCHAR uint8; 
UCHAR booleanVal;
GUID uuid128; 
ULONG uuid32; 
USHORT uuid16; 
struct {
LPBYTE value;
ULONG length;
} string;
struct {
LPBYTE value;
ULONG length;
} url;
struct {
LPBYTE value;
ULONG length;
} sequence;
struct {
LPBYTE value;
ULONG length;
} alternative;
} data;
} SDP_ELEMENT_DATA,*PSDP_ELEMENT_DATA;
DWORD WINAPI BluetoothSdpGetElementData(LPBYTE ,ULONG ,PSDP_ELEMENT_DATA pData );
typedef HANDLE HBLUETOOTH_CONTAINER_ELEMENT;
DWORD WINAPI BluetoothSdpGetContainerElementData(LPBYTE ,ULONG ,HBLUETOOTH_CONTAINER_ELEMENT* pElement,PSDP_ELEMENT_DATA pData );
DWORD WINAPI BluetoothSdpGetAttributeValue(LPBYTE ,ULONG ,USHORT ,PSDP_ELEMENT_DATA pAttributeData );
typedef struct _SDP_STRING_TYPE_DATA {
USHORT encoding;
USHORT mibeNum;
USHORT attributeId;
} SDP_STRING_TYPE_DATA,*PSDP_STRING_TYPE_DATA;
DWORD WINAPI BluetoothSdpGetString(LPBYTE ,ULONG ,PSDP_STRING_TYPE_DATA ,USHORT ,PWCHAR ,PULONG pcchStringLength );
typedef BOOL (CALLBACK *PFN_BLUETOOTH_ENUM_ATTRIBUTES_CALLBACK)(ULONG ,LPBYTE ,ULONG ,LPVOID pvParam );
#define BluetoothEnumAttributes BluetoothSdpEnumAttributes
BOOL WINAPI BluetoothSdpEnumAttributes(LPBYTE ,ULONG ,PFN_BLUETOOTH_ENUM_ATTRIBUTES_CALLBACK ,LPVOID pvParam );
#endif
