#ifndef __cfgmgr32_h__
#define __cfgmgr32_h__
#include <cfg.h>
#ifndef GUID_DEFINED
#include <guiddef.h>
#endif 
#define CMAPI
typedef CONST VOID *PCVOID;
#define MAX_DEVICE_ID_LEN 200
#define MAX_DEVNODE_ID_LEN MAX_DEVICE_ID_LEN
#define MAX_GUID_STRING_LEN 39 
#define MAX_CLASS_NAME_LEN 32
#define MAX_PROFILE_LEN 80
#define MAX_CONFIG_VALUE 9999
#define MAX_INSTANCE_VALUE 9999
#define MAX_MEM_REGISTERS 9 
#define MAX_IO_PORTS 20 
#define MAX_IRQS 7 
#define MAX_DMA_CHANNELS 7 
#define DWORD_MAX 0xffffffff
#define DWORDLONG_MAX 0xffffffff
#define CONFIGMG_VERSION 1024
#ifdef NT_INCLUDED
#if (!defined(MIDL_PASS) || defined(__midl)) && (!defined(_M_IX86) || (defined(_INTEGRAL_MAX_BITS) && _INTEGRAL_MAX_BITS >= 64))
typedef unsigned __int64 DWORDLONG;
#else
typedef double DWORDLONG;
#endif
typedef DWORDLONG *PDWORDLONG;
#endif 
typedef DWORD RETURN_TYPE;
typedef RETURN_TYPE CONFIGRET;
typedef DWORD DEVNODE,DEVINST;
typedef DEVNODE *PDEVNODE,*PDEVINST;
typedef CHAR *DEVNODEID_A,*DEVINSTID_A; 
typedef WCHAR *DEVNODEID_W,*DEVINSTID_W; 
#ifdef UNICODE
typedef DEVNODEID_W DEVNODEID;
typedef DEVINSTID_W DEVINSTID;
#else
typedef DEVNODEID_A DEVNODEID;
typedef DEVINSTID_A DEVINSTID;
#endif
typedef DWORD_PTR LOG_CONF;
typedef LOG_CONF *PLOG_CONF;
typedef DWORD_PTR RES_DES;
typedef RES_DES *PRES_DES;
typedef ULONG RESOURCEID;
typedef RESOURCEID *PRESOURCEID;
typedef ULONG PRIORITY;
typedef PRIORITY *PPRIORITY;
typedef DWORD_PTR RANGE_LIST;
typedef RANGE_LIST *PRANGE_LIST;
typedef DWORD_PTR RANGE_ELEMENT;
typedef RANGE_ELEMENT *PRANGE_ELEMENT;
typedef HANDLE HMACHINE;
typedef HMACHINE *PHMACHINE;
typedef ULONG_PTR CONFLICT_LIST;
typedef CONFLICT_LIST *PCONFLICT_LIST;
typedef struct _CONFLICT_DETAILS_A {
ULONG CD_ulSize; 
ULONG CD_ulMask; 
DEVINST CD_dnDevInst; 
RES_DES CD_rdResDes; 
ULONG CD_ulFlags; 
CHAR CD_szDescription[MAX_PATH]; 
} CONFLICT_DETAILS_A,*PCONFLICT_DETAILS_A;
typedef struct _CONFLICT_DETAILS_W {
ULONG CD_ulSize; 
ULONG CD_ulMask; 
DEVINST CD_dnDevInst; 
RES_DES CD_rdResDes; 
ULONG CD_ulFlags; 
WCHAR CD_szDescription[MAX_PATH]; 
} CONFLICT_DETAILS_W,*PCONFLICT_DETAILS_W;
#ifdef UNICODE
typedef CONFLICT_DETAILS_W CONFLICT_DETAILS;
typedef PCONFLICT_DETAILS_W PCONFLICT_DETAILS;
#else
typedef CONFLICT_DETAILS_A CONFLICT_DETAILS;
typedef PCONFLICT_DETAILS_A PCONFLICT_DETAILS;
#endif
#define CM_CDMASK_DEVINST 1  
#define CM_CDMASK_RESDES 2  
#define CM_CDMASK_FLAGS 4  
#define CM_CDMASK_DESCRIPTION 8  
#define CM_CDMASK_VALID 15  
#define CM_CDFLAGS_DRIVER 1  
#define CM_CDFLAGS_ROOT_OWNED 2  
#define CM_CDFLAGS_RESERVED 4  
typedef ULONG REGDISPOSITION;
#include "pshpack1.h"
#define mMD_MemoryType 1 
#define fMD_MemoryType mMD_MemoryType 
#define fMD_ROM 0 
#define fMD_RAM 1 
#define mMD_32_24 2 
#define fMD_32_24 mMD_32_24 
#define fMD_24 0 
#define fMD_32 2 
#define mMD_Prefetchable 4 
#define fMD_Prefetchable mMD_Prefetchable 
#define fMD_Pref mMD_Prefetchable 
#define fMD_PrefetchDisallowed 0 
#define fMD_PrefetchAllowed 4 
#define mMD_Readable 8 
#define fMD_Readable mMD_Readable 
#define fMD_ReadAllowed 0 
#define fMD_ReadDisallowed 8 
#define mMD_CombinedWrite 16 
#define fMD_CombinedWrite mMD_CombinedWrite 
#define fMD_CombinedWriteDisallowed 0  
#define fMD_CombinedWriteAllowed 16 
#define mMD_Cacheable 32 
#define fMD_NonCacheable 0  
#define fMD_Cacheable 32 
typedef struct Mem_Range_s {
DWORDLONG MR_Align; 
ULONG MR_nBytes; 
DWORDLONG MR_Min; 
DWORDLONG MR_Max; 
DWORD MR_Flags; 
DWORD MR_Reserved;
} MEM_RANGE,*PMEM_RANGE;
typedef struct Mem_Des_s {
DWORD MD_Count; 
DWORD MD_Type; 
DWORDLONG MD_Alloc_Base; 
DWORDLONG MD_Alloc_End; 
DWORD MD_Flags; 
DWORD MD_Reserved;
} MEM_DES,*PMEM_DES;
typedef struct Mem_Resource_s {
MEM_DES MEM_Header; 
MEM_RANGE MEM_Data[ANYSIZE_ARRAY]; 
} MEM_RESOURCE,*PMEM_RESOURCE;
#define MType_Range sizeof(struct )
#define fIOD_PortType 1 
#define fIOD_Memory 0 
#define fIOD_IO 1 
#define fIOD_DECODE 252 
#define fIOD_10_BIT_DECODE 4
#define fIOD_12_BIT_DECODE 8
#define fIOD_16_BIT_DECODE 16
#define fIOD_POSITIVE_DECODE 32
#define fIOD_PASSIVE_DECODE 64
#define fIOD_WINDOW_DECODE 128
#define IO_ALIAS_10_BIT_DECODE 4
#define IO_ALIAS_12_BIT_DECODE 16
#define IO_ALIAS_16_BIT_DECODE 0
#define IO_ALIAS_POSITIVE_DECODE 255
typedef struct IO_Range_s {
DWORDLONG IOR_Align; 
DWORD IOR_nPorts; 
DWORDLONG IOR_Min; 
DWORDLONG IOR_Max; 
DWORD IOR_RangeFlags; 
DWORDLONG IOR_Alias; 
} IO_RANGE,*PIO_RANGE;
typedef struct IO_Des_s {
DWORD IOD_Count; 
DWORD IOD_Type; 
DWORDLONG IOD_Alloc_Base; 
DWORDLONG IOD_Alloc_End; 
DWORD IOD_DesFlags; 
} IO_DES,*PIO_DES;
typedef struct IO_Resource_s {
IO_DES IO_Header; 
IO_RANGE IO_Data[ANYSIZE_ARRAY]; 
} IO_RESOURCE,*PIO_RESOURCE;
#define IOA_Local 255
#define IOType_Range sizeof(struct )
#define mDD_Width 3  
#define fDD_BYTE 0  
#define fDD_WORD 1  
#define fDD_DWORD 2  
#define fDD_BYTE_AND_WORD 3  
#define mDD_BusMaster 4  
#define fDD_NoBusMaster 0  
#define fDD_BusMaster 4  
#define mDD_Type 24  
#define fDD_TypeStandard 0  
#define fDD_TypeA 8  
#define fDD_TypeB 16  
#define fDD_TypeF 24  
typedef struct DMA_Range_s {
ULONG DR_Min; 
ULONG DR_Max; 
ULONG DR_Flags; 
} DMA_RANGE,*PDMA_RANGE;
typedef struct DMA_Des_s {
DWORD DD_Count; 
DWORD DD_Type; 
DWORD DD_Flags; 
ULONG DD_Alloc_Chan; 
} DMA_DES,*PDMA_DES;
typedef struct DMA_Resource_s {
DMA_DES DMA_Header; 
DMA_RANGE DMA_Data[ANYSIZE_ARRAY]; 
} DMA_RESOURCE,*PDMA_RESOURCE;
#define DType_Range sizeof(struct )
#define mIRQD_Share 1 
#define fIRQD_Exclusive 0 
#define fIRQD_Share 1 
#define fIRQD_Share_Bit 0 
#define fIRQD_Level_Bit 1 
#define mIRQD_Edge_Level 2 
#define fIRQD_Level 0 
#define fIRQD_Edge 2 
typedef struct IRQ_Range_s {
ULONG IRQR_Min; 
ULONG IRQR_Max; 
ULONG IRQR_Flags; 
} IRQ_RANGE,*PIRQ_RANGE;
typedef struct IRQ_Des_32_s {
DWORD IRQD_Count; 
DWORD IRQD_Type; 
DWORD IRQD_Flags; 
ULONG IRQD_Alloc_Num; 
ULONG32 IRQD_Affinity;
} IRQ_DES_32,*PIRQ_DES_32;
typedef struct IRQ_Des_64_s {
DWORD IRQD_Count; 
DWORD IRQD_Type; 
DWORD IRQD_Flags; 
ULONG IRQD_Alloc_Num; 
ULONG64 IRQD_Affinity;
} IRQ_DES_64,*PIRQ_DES_64;
#ifdef _WIN64
typedef IRQ_DES_64 IRQ_DES;
typedef PIRQ_DES_64 PIRQ_DES;
#else
typedef IRQ_DES_32 IRQ_DES;
typedef PIRQ_DES_32 PIRQ_DES;
#endif
typedef struct IRQ_Resource_32_s {
IRQ_DES_32 IRQ_Header; 
IRQ_RANGE IRQ_Data[ANYSIZE_ARRAY]; 
} IRQ_RESOURCE_32,*PIRQ_RESOURCE_32;
typedef struct IRQ_Resource_64_s {
IRQ_DES_64 IRQ_Header; 
IRQ_RANGE IRQ_Data[ANYSIZE_ARRAY]; 
} IRQ_RESOURCE_64,*PIRQ_RESOURCE_64;
#ifdef _WIN64
typedef IRQ_RESOURCE_64 IRQ_RESOURCE;
typedef PIRQ_RESOURCE_64 PIRQ_RESOURCE;
#else
typedef IRQ_RESOURCE_32 IRQ_RESOURCE;
typedef PIRQ_RESOURCE_32 PIRQ_RESOURCE;
#endif
#define IRQType_Range sizeof(struct )
#define CM_RESDES_WIDTH_DEFAULT 0  
#define CM_RESDES_WIDTH_32 1  
#define CM_RESDES_WIDTH_64 2  
#define CM_RESDES_WIDTH_BITS 3
typedef struct DevPrivate_Range_s {
DWORD PR_Data1; 
DWORD PR_Data2; 
DWORD PR_Data3; 
} DEVPRIVATE_RANGE,*PDEVPRIVATE_RANGE;
typedef struct DevPrivate_Des_s {
DWORD PD_Count;
DWORD PD_Type;
DWORD PD_Data1;
DWORD PD_Data2;
DWORD PD_Data3;
DWORD PD_Flags;
} DEVPRIVATE_DES,*PDEVPRIVATE_DES;
typedef struct DevPrivate_Resource_s {
DEVPRIVATE_DES PRV_Header;
DEVPRIVATE_RANGE PRV_Data[ANYSIZE_ARRAY];
} DEVPRIVATE_RESOURCE,*PDEVPRIVATE_RESOURCE;
#define PType_Range sizeof(struct )
typedef struct CS_Des_s {
DWORD CSD_SignatureLength;
DWORD CSD_LegacyDataOffset;
DWORD CSD_LegacyDataSize;
DWORD CSD_Flags;
GUID CSD_ClassGuid;
BYTE CSD_Signature[ANYSIZE_ARRAY];
} CS_DES,*PCS_DES;
typedef struct CS_Resource_s {
CS_DES CS_Header;
} CS_RESOURCE,*PCS_RESOURCE;
#define mPCD_IO_8_16 1  
#define fPCD_IO_8 0  
#define fPCD_IO_16 1  
#define mPCD_MEM_8_16 2  
#define fPCD_MEM_8 0  
#define fPCD_MEM_16 2  
#define mPCD_MEM_A_C 12  
#define fPCD_MEM1_A 4  
#define fPCD_MEM2_A 8  
#define fPCD_IO_ZW_8 16  
#define fPCD_IO_SRC_16 32  
#define fPCD_IO_WS_16 64  
#define mPCD_MEM_WS 768 
#define fPCD_MEM_WS_ONE 256 
#define fPCD_MEM_WS_TWO 512 
#define fPCD_MEM_WS_THREE 768 
#define fPCD_MEM_A 4  
#define fPCD_ATTRIBUTES_PER_WINDOW 0x8000
#define fPCD_IO1_16 0x10000  
#define fPCD_IO1_ZW_8 0x20000  
#define fPCD_IO1_SRC_16 0x40000  
#define fPCD_IO1_WS_16 0x80000  
#define fPCD_IO2_16 0x100000  
#define fPCD_IO2_ZW_8 0x200000  
#define fPCD_IO2_SRC_16 0x400000  
#define fPCD_IO2_WS_16 0x800000  
#define mPCD_MEM1_WS 0x3000000  
#define fPCD_MEM1_WS_ONE 0x1000000  
#define fPCD_MEM1_WS_TWO 0x2000000  
#define fPCD_MEM1_WS_THREE 0x3000000  
#define fPCD_MEM1_16 0x4000000  
#define mPCD_MEM2_WS 0x30000000  
#define fPCD_MEM2_WS_ONE 0x10000000  
#define fPCD_MEM2_WS_TWO 0x20000000  
#define fPCD_MEM2_WS_THREE 0x30000000  
#define fPCD_MEM2_16 0x40000000  
#define PCD_MAX_MEMORY 2
#define PCD_MAX_IO 2
typedef struct PcCard_Des_s {
DWORD PCD_Count;
DWORD PCD_Type;
DWORD PCD_Flags;
BYTE PCD_ConfigIndex;
BYTE PCD_Reserved[3];
DWORD PCD_MemoryCardBase1;
DWORD PCD_MemoryCardBase2;
DWORD PCD_MemoryCardBase[PCD_MAX_MEMORY]; 
WORD PCD_MemoryFlags[PCD_MAX_MEMORY]; 
BYTE PCD_IoFlags[PCD_MAX_IO]; 
} PCCARD_DES,*PPCCARD_DES;
typedef struct PcCard_Resource_s {
PCCARD_DES PcCard_Header;
} PCCARD_RESOURCE,*PPCCARD_RESOURCE;
#define mPMF_AUDIO_ENABLE 8  
#define fPMF_AUDIO_ENABLE 8  
typedef struct MfCard_Des_s {
DWORD PMF_Count;
DWORD PMF_Type;
DWORD PMF_Flags;
BYTE PMF_ConfigOptions;
BYTE PMF_IoResourceIndex;
BYTE PMF_Reserved[2];
DWORD PMF_ConfigRegisterBase;
} MFCARD_DES,*PMFCARD_DES;
typedef struct MfCard_Resource_s {
MFCARD_DES MfCard_Header;
} MFCARD_RESOURCE,*PMFCARD_RESOURCE;
typedef struct BusNumber_Range_s {
ULONG BUSR_Min; 
ULONG BUSR_Max; 
ULONG BUSR_nBusNumbers; 
ULONG BUSR_Flags; 
} BUSNUMBER_RANGE,*PBUSNUMBER_RANGE;
typedef struct BusNumber_Des_s {
DWORD BUSD_Count; 
DWORD BUSD_Type; 
DWORD BUSD_Flags; 
ULONG BUSD_Alloc_Base; 
ULONG BUSD_Alloc_End; 
} BUSNUMBER_DES,*PBUSNUMBER_DES;
typedef struct BusNumber_Resource_s {
BUSNUMBER_DES BusNumber_Header; 
BUSNUMBER_RANGE BusNumber_Data[ANYSIZE_ARRAY]; 
} BUSNUMBER_RESOURCE,*PBUSNUMBER_RESOURCE;
#define BusNumberType_Range sizeof(struct )
#define CM_HWPI_NOT_DOCKABLE 0  
#define CM_HWPI_UNDOCKED 1  
#define CM_HWPI_DOCKED 2  
typedef struct HWProfileInfo_sA {
ULONG HWPI_ulHWProfile; 
CHAR HWPI_szFriendlyName[MAX_PROFILE_LEN]; 
DWORD HWPI_dwFlags; 
} HWPROFILEINFO_A,*PHWPROFILEINFO_A;
typedef struct HWProfileInfo_sW {
ULONG HWPI_ulHWProfile; 
WCHAR HWPI_szFriendlyName[MAX_PROFILE_LEN]; 
DWORD HWPI_dwFlags; 
} HWPROFILEINFO_W,*PHWPROFILEINFO_W;
#ifdef UNICODE
typedef HWPROFILEINFO_W HWPROFILEINFO;
typedef PHWPROFILEINFO_W PHWPROFILEINFO;
#else
typedef HWPROFILEINFO_A HWPROFILEINFO;
typedef PHWPROFILEINFO_A PHWPROFILEINFO;
#endif
#include "poppack.h"
#define ResType_All 0  
#define ResType_None 0  
#define ResType_Mem 1  
#define ResType_IO 2  
#define ResType_DMA 3  
#define ResType_IRQ 4  
#define ResType_DoNotUse 5  
#define ResType_BusNumber 6  
#define ResType_MAX 6  
#define ResType_Ignored_Bit 0x8000  
#define ResType_ClassSpecific 0xffff  
#define ResType_Reserved 0x8000  
#define ResType_DevicePrivate 0x8001  
#define ResType_PcCardConfig 0x8002  
#define ResType_MfCardConfig 0x8003  
#define CM_ADD_RANGE_ADDIFCONFLICT 0 
#define CM_ADD_RANGE_DONOTADDIFCONFLICT 1 
#define CM_ADD_RANGE_BITS 1
#define BASIC_LOG_CONF 0
#define FILTERED_LOG_CONF 1
#define ALLOC_LOG_CONF 2
#define BOOT_LOG_CONF 3
#define FORCED_LOG_CONF 4
#define OVERRIDE_LOG_CONF 5
#define NUM_LOG_CONF 6
#define LOG_CONF_BITS 7
#define PRIORITY_EQUAL_FIRST 8 
#define PRIORITY_EQUAL_LAST 0 
#define PRIORITY_BIT 8
#define RegDisposition_OpenAlways 0  
#define RegDisposition_OpenExisting 1  
#define RegDisposition_Bits 1
#define CM_ADD_ID_HARDWARE 0
#define CM_ADD_ID_COMPATIBLE 1
#define CM_ADD_ID_BITS 1
#define CM_CREATE_DEVNODE_NORMAL 0  
#define CM_CREATE_DEVNODE_NO_WAIT_INSTALL 1  
#define CM_CREATE_DEVNODE_PHANTOM 2
#define CM_CREATE_DEVNODE_GENERATE_ID 4
#define CM_CREATE_DEVNODE_DO_NOT_INSTALL 8
#define CM_CREATE_DEVNODE_BITS 15
#define CM_CREATE_DEVINST_NORMAL CM_CREATE_DEVNODE_NORMAL
#define CM_CREATE_DEVINST_NO_WAIT_INSTALL CM_CREATE_DEVNODE_NO_WAIT_INSTALL
#define CM_CREATE_DEVINST_PHANTOM CM_CREATE_DEVNODE_PHANTOM
#define CM_CREATE_DEVINST_GENERATE_ID CM_CREATE_DEVNODE_GENERATE_ID
#define CM_CREATE_DEVINST_DO_NOT_INSTALL CM_CREATE_DEVNODE_DO_NOT_INSTALL
#define CM_CREATE_DEVINST_BITS CM_CREATE_DEVNODE_BITS
#define CM_DELETE_CLASS_ONLY 0
#define CM_DELETE_CLASS_SUBKEYS 1
#define CM_DELETE_CLASS_BITS 1
#define CM_DETECT_NEW_PROFILE 1 
#define CM_DETECT_CRASHED 2 
#define CM_DETECT_HWPROF_FIRST_BOOT 4
#define CM_DETECT_RUN 0x80000000
#define CM_DETECT_BITS 0x80000007
#define CM_DISABLE_POLITE 0  
#define CM_DISABLE_ABSOLUTE 1  
#define CM_DISABLE_HARDWARE 2  
#define CM_DISABLE_UI_NOT_OK 4  
#define CM_DISABLE_BITS 7  
#define CM_GETIDLIST_FILTER_NONE 0
#define CM_GETIDLIST_FILTER_ENUMERATOR 1
#define CM_GETIDLIST_FILTER_SERVICE 2
#define CM_GETIDLIST_FILTER_EJECTRELATIONS 4
#define CM_GETIDLIST_FILTER_REMOVALRELATIONS 8
#define CM_GETIDLIST_FILTER_POWERRELATIONS 16
#define CM_GETIDLIST_FILTER_BUSRELATIONS 32
#define CM_GETIDLIST_DONOTGENERATE 0x10000040
#define CM_GETIDLIST_FILTER_BITS 0x1000007f
#define CM_GET_DEVICE_INTERFACE_LIST_PRESENT 0  
#define CM_GET_DEVICE_INTERFACE_LIST_ALL_DEVICES 1  
#define CM_GET_DEVICE_INTERFACE_LIST_BITS 1
#define CM_DRP_DEVICEDESC 1 
#define CM_DRP_HARDWAREID 2 
#define CM_DRP_COMPATIBLEIDS 3 
#define CM_DRP_UNUSED0 4 
#define CM_DRP_SERVICE 5 
#define CM_DRP_UNUSED1 6 
#define CM_DRP_UNUSED2 7 
#define CM_DRP_CLASS 8 
#define CM_DRP_CLASSGUID 9 
#define CM_DRP_DRIVER 10 
#define CM_DRP_CONFIGFLAGS 11 
#define CM_DRP_MFG 12 
#define CM_DRP_FRIENDLYNAME 13 
#define CM_DRP_LOCATION_INFORMATION 14 
#define CM_DRP_PHYSICAL_DEVICE_OBJECT_NAME 15 
#define CM_DRP_CAPABILITIES 16 
#define CM_DRP_UI_NUMBER 17 
#define CM_DRP_UPPERFILTERS 18 
#define CM_DRP_LOWERFILTERS 19 
#define CM_DRP_BUSTYPEGUID 20 
#define CM_DRP_LEGACYBUSTYPE 21 
#define CM_DRP_BUSNUMBER 22 
#define CM_DRP_ENUMERATOR_NAME 23 
#define CM_DRP_SECURITY 24 
#define CM_CRP_SECURITY CM_DRP_SECURITY 
#define CM_DRP_SECURITY_SDS 25 
#define CM_CRP_SECURITY_SDS CM_DRP_SECURITY_SDS 
#define CM_DRP_DEVTYPE 26 
#define CM_CRP_DEVTYPE CM_DRP_DEVTYPE 
#define CM_DRP_EXCLUSIVE 27 
#define CM_CRP_EXCLUSIVE CM_DRP_EXCLUSIVE 
#define CM_DRP_CHARACTERISTICS 28 
#define CM_CRP_CHARACTERISTICS CM_DRP_CHARACTERISTICS 
#define CM_DRP_ADDRESS 29 
#define CM_DRP_UI_NUMBER_DESC_FORMAT 30 
#define CM_DRP_DEVICE_POWER_DATA 31 
#define CM_DRP_REMOVAL_POLICY 32 
#define CM_DRP_REMOVAL_POLICY_HW_DEFAULT 33 
#define CM_DRP_REMOVAL_POLICY_OVERRIDE 34 
#define CM_DRP_INSTALL_STATE 35 
#define CM_DRP_MIN 1 
#define CM_CRP_MIN CM_DRP_MIN 
#define CM_DRP_MAX 35 
#define CM_CRP_MAX CM_DRP_MAX 
#define CM_DEVCAP_LOCKSUPPORTED 1
#define CM_DEVCAP_EJECTSUPPORTED 2
#define CM_DEVCAP_REMOVABLE 4
#define CM_DEVCAP_DOCKDEVICE 8
#define CM_DEVCAP_UNIQUEID 16
#define CM_DEVCAP_SILENTINSTALL 32
#define CM_DEVCAP_RAWDEVICEOK 64
#define CM_DEVCAP_SURPRISEREMOVALOK 128
#define CM_DEVCAP_HARDWAREDISABLED 256
#define CM_DEVCAP_NONDYNAMIC 512
#define CM_REMOVAL_POLICY_EXPECT_NO_REMOVAL 1
#define CM_REMOVAL_POLICY_EXPECT_ORDERLY_REMOVAL 2
#define CM_REMOVAL_POLICY_EXPECT_SURPRISE_REMOVAL 3
#define CM_INSTALL_STATE_INSTALLED 0
#define CM_INSTALL_STATE_NEEDS_REINSTALL 1
#define CM_INSTALL_STATE_FAILED_INSTALL 2
#define CM_INSTALL_STATE_FINISH_INSTALL 3
#define CM_LOCATE_DEVNODE_NORMAL 0
#define CM_LOCATE_DEVNODE_PHANTOM 1
#define CM_LOCATE_DEVNODE_CANCELREMOVE 2
#define CM_LOCATE_DEVNODE_NOVALIDATION 4
#define CM_LOCATE_DEVNODE_BITS 7
#define CM_LOCATE_DEVINST_NORMAL CM_LOCATE_DEVNODE_NORMAL
#define CM_LOCATE_DEVINST_PHANTOM CM_LOCATE_DEVNODE_PHANTOM
#define CM_LOCATE_DEVINST_CANCELREMOVE CM_LOCATE_DEVNODE_CANCELREMOVE
#define CM_LOCATE_DEVINST_NOVALIDATION CM_LOCATE_DEVNODE_NOVALIDATION
#define CM_LOCATE_DEVINST_BITS CM_LOCATE_DEVNODE_BITS
#define CM_OPEN_CLASS_KEY_INSTALLER 0
#define CM_OPEN_CLASS_KEY_INTERFACE 1
#define CM_OPEN_CLASS_KEY_BITS 1
#define CM_REMOVE_UI_OK 0
#define CM_REMOVE_UI_NOT_OK 1
#define CM_REMOVE_NO_RESTART 2
#define CM_REMOVE_BITS 3
#define CM_QUERY_REMOVE_UI_OK (CM_REMOVE_UI_OK)
#define CM_QUERY_REMOVE_UI_NOT_OK (CM_REMOVE_UI_NOT_OK)
#define CM_QUERY_REMOVE_BITS (CM_QUERY_REMOVE_UI_OK|CM_QUERY_REMOVE_UI_NOT_OK)
#define CM_REENUMERATE_NORMAL 0
#define CM_REENUMERATE_SYNCHRONOUS 1
#define CM_REENUMERATE_RETRY_INSTALLATION 2
#define CM_REENUMERATE_ASYNCHRONOUS 4
#define CM_REENUMERATE_BITS 7
#define CM_REGISTER_DEVICE_DRIVER_STATIC 0
#define CM_REGISTER_DEVICE_DRIVER_DISABLEABLE 1
#define CM_REGISTER_DEVICE_DRIVER_REMOVABLE 2
#define CM_REGISTER_DEVICE_DRIVER_BITS 3
#define CM_REGISTRY_HARDWARE 0
#define CM_REGISTRY_SOFTWARE 1
#define CM_REGISTRY_USER 256
#define CM_REGISTRY_CONFIG 512
#define CM_REGISTRY_BITS 769
#define CM_SET_DEVNODE_PROBLEM_NORMAL 0  
#define CM_SET_DEVNODE_PROBLEM_OVERRIDE 1  
#define CM_SET_DEVNODE_PROBLEM_BITS 1
#define CM_SET_DEVINST_PROBLEM_NORMAL CM_SET_DEVNODE_PROBLEM_NORMAL
#define CM_SET_DEVINST_PROBLEM_OVERRIDE CM_SET_DEVNODE_PROBLEM_OVERRIDE
#define CM_SET_DEVINST_PROBLEM_BITS CM_SET_DEVNODE_PROBLEM_BITS
#define CM_SET_HW_PROF_FLAGS_UI_NOT_OK 1  
#define CM_SET_HW_PROF_FLAGS_BITS 1
#define CM_SETUP_DEVNODE_READY 0 
#define CM_SETUP_DEVINST_READY CM_SETUP_DEVNODE_READY
#define CM_SETUP_DOWNLOAD 1 
#define CM_SETUP_WRITE_LOG_CONFS 2
#define CM_SETUP_PROP_CHANGE 3
#define CM_SETUP_DEVNODE_RESET 4 
#define CM_SETUP_DEVINST_RESET CM_SETUP_DEVNODE_RESET
#define CM_SETUP_BITS 7
#define CM_QUERY_ARBITRATOR_RAW 0
#define CM_QUERY_ARBITRATOR_TRANSLATED 1
#define CM_QUERY_ARBITRATOR_BITS 1
#define CM_CUSTOMDEVPROP_MERGE_MULTISZ 1
#define CM_CUSTOMDEVPROP_BITS 1
CMAPI CONFIGRET WINAPI CM_Add_Empty_Log_Conf(PLOG_CONF ,DEVINST ,PRIORITY ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Add_Empty_Log_Conf_Ex(PLOG_CONF ,DEVINST ,PRIORITY ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Add_IDA(DEVINST ,PSTR ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Add_IDW(DEVINST ,PWSTR ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Add_ID_ExA(DEVINST ,PSTR ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Add_ID_ExW(DEVINST ,PWSTR ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Add_ID CM_Add_IDW
#define CM_Add_ID_Ex CM_Add_ID_ExW
#else
#define CM_Add_ID CM_Add_IDA
#define CM_Add_ID_Ex CM_Add_ID_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Add_Range(DWORDLONG ,DWORDLONG ,RANGE_LIST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Add_Res_Des(PRES_DES ,LOG_CONF ,RESOURCEID ,PCVOID ,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Add_Res_Des_Ex(PRES_DES ,LOG_CONF ,RESOURCEID ,PCVOID ,ULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Connect_MachineA(PCSTR ,PHMACHINE phMachine );
CMAPI CONFIGRET WINAPI CM_Connect_MachineW(PCWSTR ,PHMACHINE phMachine );
#ifdef UNICODE
#define CM_Connect_Machine CM_Connect_MachineW
#else
#define CM_Connect_Machine CM_Connect_MachineA
#endif 
CMAPI CONFIGRET WINAPI CM_Create_DevNodeA(PDEVINST ,DEVINSTID_A ,DEVINST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Create_DevNodeW(PDEVINST ,DEVINSTID_W ,DEVINST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Create_DevNode_ExA(PDEVINST ,DEVINSTID_A ,DEVINST ,ULONG ,HANDLE hMachine );
CMAPI CONFIGRET WINAPI CM_Create_DevNode_ExW(PDEVINST ,DEVINSTID_W ,DEVINST ,ULONG ,HANDLE hMachine );
#define CM_Create_DevInstW CM_Create_DevNodeW
#define CM_Create_DevInstA CM_Create_DevNodeA
#define CM_Create_DevInst_ExW CM_Create_DevNode_ExW
#define CM_Create_DevInst_ExA CM_Create_DevNode_ExA
#ifdef UNICODE
#define CM_Create_DevNode CM_Create_DevNodeW
#define CM_Create_DevInst CM_Create_DevNodeW
#define CM_Create_DevNode_Ex CM_Create_DevNode_ExW
#define CM_Create_DevInst_Ex CM_Create_DevInst_ExW
#else
#define CM_Create_DevNode CM_Create_DevNodeA
#define CM_Create_DevInst CM_Create_DevNodeA
#define CM_Create_DevNode_Ex CM_Create_DevNode_ExA
#define CM_Create_DevInst_Ex CM_Create_DevNode_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Create_Range_List(PRANGE_LIST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Delete_Class_Key(LPGUID ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Delete_Class_Key_Ex(LPGUID ,ULONG ,HANDLE hMachine );
CMAPI CONFIGRET WINAPI CM_Delete_DevNode_Key(DEVNODE ,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Delete_DevNode_Key_Ex(DEVNODE ,ULONG ,ULONG ,HANDLE hMachine );
#define CM_Delete_DevInst_Key CM_Delete_DevNode_Key
#define CM_Delete_DevInst_Key_Ex CM_Delete_DevNode_Key_Ex
CMAPI CONFIGRET WINAPI CM_Delete_Range(DWORDLONG ,DWORDLONG ,RANGE_LIST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Detect_Resource_Conflict(DEVINST ,RESOURCEID ,PCVOID ,ULONG ,PBOOL ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Detect_Resource_Conflict_Ex(DEVINST ,RESOURCEID ,PCVOID ,ULONG ,PBOOL ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Disable_DevNode(DEVINST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Disable_DevNode_Ex(DEVINST ,ULONG ,HMACHINE hMachine );
#define CM_Disable_DevInst CM_Disable_DevNode
#define CM_Disable_DevInst_Ex CM_Disable_DevNode_Ex
CMAPI CONFIGRET WINAPI CM_Disconnect_Machine(HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Dup_Range_List(RANGE_LIST ,RANGE_LIST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Enable_DevNode(DEVINST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Enable_DevNode_Ex(DEVINST ,ULONG ,HMACHINE hMachine );
#define CM_Enable_DevInst CM_Enable_DevNode
#define CM_Enable_DevInst_Ex CM_Enable_DevNode_Ex
CMAPI CONFIGRET WINAPI CM_Enumerate_Classes(ULONG ,LPGUID ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Enumerate_Classes_Ex(ULONG ,LPGUID ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Enumerate_EnumeratorsA(ULONG ,PCHAR ,PULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Enumerate_EnumeratorsW(ULONG ,PWCHAR ,PULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Enumerate_Enumerators_ExA(ULONG ,PCHAR ,PULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Enumerate_Enumerators_ExW(ULONG ,PWCHAR ,PULONG ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Enumerate_Enumerators CM_Enumerate_EnumeratorsW
#define CM_Enumerate_Enumerators_Ex CM_Enumerate_Enumerators_ExW
#else
#define CM_Enumerate_Enumerators CM_Enumerate_EnumeratorsA
#define CM_Enumerate_Enumerators_Ex CM_Enumerate_Enumerators_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Find_Range(PDWORDLONG ,DWORDLONG ,ULONG ,DWORDLONG ,DWORDLONG ,RANGE_LIST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_First_Range(RANGE_LIST ,PDWORDLONG ,PDWORDLONG ,PRANGE_ELEMENT ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Free_Log_Conf(LOG_CONF ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Free_Log_Conf_Ex(LOG_CONF ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Free_Log_Conf_Handle(LOG_CONF lcLogConf );
CMAPI CONFIGRET WINAPI CM_Free_Range_List(RANGE_LIST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Free_Res_Des(PRES_DES ,RES_DES ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Free_Res_Des_Ex(PRES_DES ,RES_DES ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Free_Res_Des_Handle(RES_DES rdResDes );
CMAPI CONFIGRET WINAPI CM_Get_Child(PDEVINST ,DEVINST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Child_Ex(PDEVINST ,DEVINST ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Class_NameA(LPGUID ,PCHAR ,PULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Class_NameW(LPGUID ,PWCHAR ,PULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Class_Name_ExA(LPGUID ,PCHAR ,PULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Class_Name_ExW(LPGUID ,PWCHAR ,PULONG ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Get_Class_Name CM_Get_Class_NameW
#define CM_Get_Class_Name_Ex CM_Get_Class_Name_ExW
#else
#define CM_Get_Class_Name CM_Get_Class_NameA
#define CM_Get_Class_Name_Ex CM_Get_Class_Name_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Get_Class_Key_NameA(LPGUID ,LPSTR ,PULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Class_Key_NameW(LPGUID ,LPWSTR ,PULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Class_Key_Name_ExA(LPGUID ,LPSTR ,PULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Class_Key_Name_ExW(LPGUID ,LPWSTR ,PULONG ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Get_Class_Key_Name CM_Get_Class_Key_NameW
#define CM_Get_Class_Key_Name_Ex CM_Get_Class_Key_Name_ExW
#else
#define CM_Get_Class_Key_Name CM_Get_Class_Key_NameA
#define CM_Get_Class_Key_Name_Ex CM_Get_Class_Key_Name_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Get_Depth(PULONG ,DEVINST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Depth_Ex(PULONG ,DEVINST ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Device_IDA(DEVINST ,PCHAR ,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Device_IDW(DEVINST ,PWCHAR ,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Device_ID_ExA(DEVINST ,PCHAR ,ULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Device_ID_ExW(DEVINST ,PWCHAR ,ULONG ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Get_Device_ID CM_Get_Device_IDW
#define CM_Get_Device_ID_Ex CM_Get_Device_ID_ExW
#else
#define CM_Get_Device_ID CM_Get_Device_IDA
#define CM_Get_Device_ID_Ex CM_Get_Device_ID_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Get_Device_ID_ListA(PCSTR ,OPTIONAL PCHAR Buffer,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Device_ID_ListW(PCWSTR ,OPTIONAL PWCHAR Buffer,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Device_ID_List_ExA(PCSTR ,OPTIONAL PCHAR Buffer,ULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Device_ID_List_ExW(PCWSTR ,OPTIONAL PWCHAR Buffer,ULONG ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Get_Device_ID_List CM_Get_Device_ID_ListW
#define CM_Get_Device_ID_List_Ex CM_Get_Device_ID_List_ExW
#else
#define CM_Get_Device_ID_List CM_Get_Device_ID_ListA
#define CM_Get_Device_ID_List_Ex CM_Get_Device_ID_List_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Get_Device_ID_List_SizeA(PULONG ,PCSTR ,OPTIONAL ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Device_ID_List_SizeW(PULONG ,PCWSTR ,OPTIONAL ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Device_ID_List_Size_ExA(PULONG ,PCSTR ,OPTIONAL ULONG ulFlags,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Device_ID_List_Size_ExW(PULONG ,PCWSTR ,OPTIONAL ULONG ulFlags,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Get_Device_ID_List_Size CM_Get_Device_ID_List_SizeW
#define CM_Get_Device_ID_List_Size_Ex CM_Get_Device_ID_List_Size_ExW
#else
#define CM_Get_Device_ID_List_Size CM_Get_Device_ID_List_SizeA
#define CM_Get_Device_ID_List_Size_Ex CM_Get_Device_ID_List_Size_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Get_Device_ID_Size(PULONG ,DEVINST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Device_ID_Size_Ex(PULONG ,DEVINST ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_DevNode_Registry_PropertyA(DEVINST ,ULONG ,PULONG ,OPTIONAL PVOID Buffer,OPTIONAL PULONG pulLength,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_DevNode_Registry_PropertyW(DEVINST ,ULONG ,PULONG ,OPTIONAL PVOID Buffer,OPTIONAL PULONG pulLength,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_DevNode_Registry_Property_ExA(DEVINST ,ULONG ,PULONG ,OPTIONAL PVOID Buffer,OPTIONAL PULONG pulLength,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_DevNode_Registry_Property_ExW(DEVINST ,ULONG ,PULONG ,OPTIONAL PVOID Buffer,OPTIONAL PULONG pulLength,ULONG ,HMACHINE hMachine );
#define CM_Get_DevInst_Registry_PropertyW CM_Get_DevNode_Registry_PropertyW
#define CM_Get_DevInst_Registry_PropertyA CM_Get_DevNode_Registry_PropertyA
#define CM_Get_DevInst_Registry_Property_ExW CM_Get_DevNode_Registry_Property_ExW
#define CM_Get_DevInst_Registry_Property_ExA CM_Get_DevNode_Registry_Property_ExA
#ifdef UNICODE
#define CM_Get_DevInst_Registry_Property CM_Get_DevNode_Registry_PropertyW
#define CM_Get_DevInst_Registry_Property_Ex CM_Get_DevNode_Registry_Property_ExW
#define CM_Get_DevNode_Registry_Property CM_Get_DevNode_Registry_PropertyW
#define CM_Get_DevNode_Registry_Property_Ex CM_Get_DevNode_Registry_Property_ExW
#else
#define CM_Get_DevInst_Registry_Property CM_Get_DevNode_Registry_PropertyA
#define CM_Get_DevInst_Registry_Property_Ex CM_Get_DevNode_Registry_Property_ExA
#define CM_Get_DevNode_Registry_Property CM_Get_DevNode_Registry_PropertyA
#define CM_Get_DevNode_Registry_Property_Ex CM_Get_DevNode_Registry_Property_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Get_DevNode_Custom_PropertyA(DEVINST ,PCSTR ,PULONG ,OPTIONAL PVOID Buffer,OPTIONAL PULONG pulLength,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_DevNode_Custom_PropertyW(DEVINST ,PCWSTR ,PULONG ,OPTIONAL PVOID Buffer,OPTIONAL PULONG pulLength,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_DevNode_Custom_Property_ExA(DEVINST ,PCSTR ,PULONG ,OPTIONAL PVOID Buffer,OPTIONAL PULONG pulLength,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_DevNode_Custom_Property_ExW(DEVINST ,PCWSTR ,PULONG ,OPTIONAL PVOID Buffer,OPTIONAL PULONG pulLength,ULONG ,HMACHINE hMachine );
#define CM_Get_DevInst_Custom_PropertyW CM_Get_DevNode_Custom_PropertyW
#define CM_Get_DevInst_Custom_PropertyA CM_Get_DevNode_Custom_PropertyA
#define CM_Get_DevInst_Custom_Property_ExW CM_Get_DevNode_Custom_Property_ExW
#define CM_Get_DevInst_Custom_Property_ExA CM_Get_DevNode_Custom_Property_ExA
#ifdef UNICODE
#define CM_Get_DevInst_Custom_Property CM_Get_DevNode_Custom_PropertyW
#define CM_Get_DevInst_Custom_Property_Ex CM_Get_DevNode_Custom_Property_ExW
#define CM_Get_DevNode_Custom_Property CM_Get_DevNode_Custom_PropertyW
#define CM_Get_DevNode_Custom_Property_Ex CM_Get_DevNode_Custom_Property_ExW
#else
#define CM_Get_DevInst_Custom_Property CM_Get_DevNode_Custom_PropertyA
#define CM_Get_DevInst_Custom_Property_Ex CM_Get_DevNode_Custom_Property_ExA
#define CM_Get_DevNode_Custom_Property CM_Get_DevNode_Custom_PropertyA
#define CM_Get_DevNode_Custom_Property_Ex CM_Get_DevNode_Custom_Property_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Get_DevNode_Status(PULONG ,PULONG ,DEVINST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_DevNode_Status_Ex(PULONG ,PULONG ,DEVINST ,ULONG ,HMACHINE hMachine );
#define CM_Get_DevInst_Status CM_Get_DevNode_Status
#define CM_Get_DevInst_Status_Ex CM_Get_DevNode_Status_Ex
CMAPI CONFIGRET WINAPI CM_Get_First_Log_Conf(PLOG_CONF ,OPTIONAL DEVINST dnDevInst,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_First_Log_Conf_Ex(PLOG_CONF ,OPTIONAL DEVINST dnDevInst,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Global_State(PULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Global_State_Ex(PULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Hardware_Profile_InfoA(ULONG ,PHWPROFILEINFO_A ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Hardware_Profile_Info_ExA(ULONG ,PHWPROFILEINFO_A ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Hardware_Profile_InfoW(ULONG ,PHWPROFILEINFO_W ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Hardware_Profile_Info_ExW(ULONG ,PHWPROFILEINFO_W ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Get_Hardware_Profile_Info CM_Get_Hardware_Profile_InfoW
#define CM_Get_Hardware_Profile_Info_Ex CM_Get_Hardware_Profile_Info_ExW
#else
#define CM_Get_Hardware_Profile_Info CM_Get_Hardware_Profile_InfoA
#define CM_Get_Hardware_Profile_Info_Ex CM_Get_Hardware_Profile_Info_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Get_HW_Prof_FlagsA(DEVINSTID_A ,ULONG ,PULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_HW_Prof_FlagsW(DEVINSTID_W ,ULONG ,PULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_HW_Prof_Flags_ExA(DEVINSTID_A ,ULONG ,PULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_HW_Prof_Flags_ExW(DEVINSTID_W ,ULONG ,PULONG ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Get_HW_Prof_Flags CM_Get_HW_Prof_FlagsW
#define CM_Get_HW_Prof_Flags_Ex CM_Get_HW_Prof_Flags_ExW
#else
#define CM_Get_HW_Prof_Flags CM_Get_HW_Prof_FlagsA
#define CM_Get_HW_Prof_Flags_Ex CM_Get_HW_Prof_Flags_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Get_Device_Interface_AliasA(LPCSTR ,LPGUID ,LPSTR ,PULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Device_Interface_AliasW(LPCWSTR ,LPGUID ,LPWSTR ,PULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Device_Interface_Alias_ExA(LPCSTR ,LPGUID ,LPSTR ,PULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Device_Interface_Alias_ExW(LPCWSTR ,LPGUID ,LPWSTR ,PULONG ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Get_Device_Interface_Alias CM_Get_Device_Interface_AliasW
#define CM_Get_Device_Interface_Alias_Ex CM_Get_Device_Interface_Alias_ExW
#else
#define CM_Get_Device_Interface_Alias CM_Get_Device_Interface_AliasA
#define CM_Get_Device_Interface_Alias_Ex CM_Get_Device_Interface_Alias_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Get_Device_Interface_ListA(LPGUID ,DEVINSTID_A ,OPTIONAL PCHAR Buffer,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Device_Interface_ListW(LPGUID ,DEVINSTID_W ,OPTIONAL PWCHAR Buffer,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Device_Interface_List_ExA(LPGUID ,DEVINSTID_A ,OPTIONAL PCHAR Buffer,ULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Device_Interface_List_ExW(LPGUID ,DEVINSTID_W ,OPTIONAL PWCHAR Buffer,ULONG ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Get_Device_Interface_List CM_Get_Device_Interface_ListW
#define CM_Get_Device_Interface_List_Ex CM_Get_Device_Interface_List_ExW
#else
#define CM_Get_Device_Interface_List CM_Get_Device_Interface_ListA
#define CM_Get_Device_Interface_List_Ex CM_Get_Device_Interface_List_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Get_Device_Interface_List_SizeA(PULONG ,LPGUID ,DEVINSTID_A ,OPTIONAL ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Device_Interface_List_SizeW(PULONG ,LPGUID ,DEVINSTID_W ,OPTIONAL ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Device_Interface_List_Size_ExA(PULONG ,LPGUID ,DEVINSTID_A ,OPTIONAL ULONG ulFlags,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Device_Interface_List_Size_ExW(PULONG ,LPGUID ,DEVINSTID_W ,OPTIONAL ULONG ulFlags,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Get_Device_Interface_List_Size CM_Get_Device_Interface_List_SizeW
#define CM_Get_Device_Interface_List_Size_Ex CM_Get_Device_Interface_List_Size_ExW
#else
#define CM_Get_Device_Interface_List_Size CM_Get_Device_Interface_List_SizeA
#define CM_Get_Device_Interface_List_Size_Ex CM_Get_Device_Interface_List_Size_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Get_Log_Conf_Priority(LOG_CONF ,PPRIORITY ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Log_Conf_Priority_Ex(LOG_CONF ,PPRIORITY ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Next_Log_Conf(PLOG_CONF ,OPTIONAL LOG_CONF lcLogConf,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Next_Log_Conf_Ex(PLOG_CONF ,OPTIONAL LOG_CONF lcLogConf,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Parent(PDEVINST ,DEVINST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Parent_Ex(PDEVINST ,DEVINST ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Res_Des_Data(RES_DES ,PVOID ,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Res_Des_Data_Ex(RES_DES ,PVOID ,ULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Res_Des_Data_Size(PULONG ,RES_DES ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Res_Des_Data_Size_Ex(PULONG ,RES_DES ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Sibling(PDEVINST ,DEVINST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Sibling_Ex(PDEVINST ,DEVINST ,ULONG ,HMACHINE hMachine );
CMAPI WORD WINAPI CM_Get_Version(VOID );
CMAPI WORD WINAPI CM_Get_Version_Ex(HMACHINE hMachine );
CMAPI BOOL WINAPI CM_Is_Version_Available(WORD wVersion );
CMAPI BOOL WINAPI CM_Is_Version_Available_Ex(WORD ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Intersect_Range_List(RANGE_LIST ,RANGE_LIST ,RANGE_LIST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Invert_Range_List(RANGE_LIST ,RANGE_LIST ,DWORDLONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Locate_DevNodeA(PDEVINST ,DEVINSTID_A ,OPTIONAL ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Locate_DevNodeW(PDEVINST ,DEVINSTID_W ,OPTIONAL ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Locate_DevNode_ExA(PDEVINST ,DEVINSTID_A ,OPTIONAL ULONG ulFlags,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Locate_DevNode_ExW(PDEVINST ,DEVINSTID_W ,OPTIONAL ULONG ulFlags,HMACHINE hMachine );
#define CM_Locate_DevInstA CM_Locate_DevNodeA
#define CM_Locate_DevInstW CM_Locate_DevNodeW
#define CM_Locate_DevInst_ExA CM_Locate_DevNode_ExA
#define CM_Locate_DevInst_ExW CM_Locate_DevNode_ExW
#ifdef UNICODE
#define CM_Locate_DevNode CM_Locate_DevNodeW
#define CM_Locate_DevInst CM_Locate_DevNodeW
#define CM_Locate_DevNode_Ex CM_Locate_DevNode_ExW
#define CM_Locate_DevInst_Ex CM_Locate_DevNode_ExW
#else
#define CM_Locate_DevNode CM_Locate_DevNodeA
#define CM_Locate_DevInst CM_Locate_DevNodeA
#define CM_Locate_DevNode_Ex CM_Locate_DevNode_ExA
#define CM_Locate_DevInst_Ex CM_Locate_DevNode_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Merge_Range_List(RANGE_LIST ,RANGE_LIST ,RANGE_LIST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Modify_Res_Des(PRES_DES ,RES_DES ,RESOURCEID ,PCVOID ,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Modify_Res_Des_Ex(PRES_DES ,RES_DES ,RESOURCEID ,PCVOID ,ULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Move_DevNode(DEVINST ,DEVINST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Move_DevNode_Ex(DEVINST ,DEVINST ,ULONG ,HMACHINE hMachine );
#define CM_Move_DevInst CM_Move_DevNode
#define CM_Move_DevInst_Ex CM_Move_DevNode_Ex
CMAPI CONFIGRET WINAPI CM_Next_Range(PRANGE_ELEMENT ,PDWORDLONG ,PDWORDLONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Next_Res_Des(PRES_DES ,RES_DES ,RESOURCEID ,PRESOURCEID ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Get_Next_Res_Des_Ex(PRES_DES ,RES_DES ,RESOURCEID ,PRESOURCEID ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Open_Class_KeyA(LPGUID ,OPTIONAL LPCSTR pszClassName,OPTIONAL REGSAM samDesired,REGDISPOSITION ,PHKEY ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Open_Class_KeyW(LPGUID ,OPTIONAL LPCWSTR pszClassName,OPTIONAL REGSAM samDesired,REGDISPOSITION ,PHKEY ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Open_Class_Key_ExA(LPGUID ,OPTIONAL LPCSTR pszClassName,OPTIONAL REGSAM samDesired,REGDISPOSITION ,PHKEY ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Open_Class_Key_ExW(LPGUID ,OPTIONAL LPCWSTR pszClassName,OPTIONAL REGSAM samDesired,REGDISPOSITION ,PHKEY ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Open_Class_Key CM_Open_Class_KeyW
#define CM_Open_Class_Key_Ex CM_Open_Class_Key_ExW
#else
#define CM_Open_Class_Key CM_Open_Class_KeyA
#define CM_Open_Class_Key_Ex CM_Open_Class_Key_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Open_DevNode_Key(DEVINST ,REGSAM ,ULONG ,REGDISPOSITION ,PHKEY ,ULONG );
CMAPI CONFIGRET WINAPI CM_Open_DevNode_Key_Ex(DEVINST ,REGSAM ,ULONG ,REGDISPOSITION ,PHKEY ,ULONG ,HMACHINE  );
#define CM_Open_DevInst_Key CM_Open_DevNode_Key
#define CM_Open_DevInst_Key_Ex CM_Open_DevNode_Key_Ex
CMAPI CONFIGRET WINAPI CM_Query_Arbitrator_Free_Data(PVOID ,ULONG ,DEVINST ,RESOURCEID ,ULONG );
CMAPI CONFIGRET WINAPI CM_Query_Arbitrator_Free_Data_Ex(PVOID ,ULONG ,DEVINST ,RESOURCEID ,ULONG ,HMACHINE );
CMAPI CONFIGRET WINAPI CM_Query_Arbitrator_Free_Size(PULONG ,DEVINST ,RESOURCEID ,ULONG );
CMAPI CONFIGRET WINAPI CM_Query_Arbitrator_Free_Size_Ex(PULONG ,DEVINST ,RESOURCEID ,ULONG ,HMACHINE );
CMAPI CONFIGRET WINAPI CM_Query_Remove_SubTree(DEVINST ,ULONG  );
CMAPI CONFIGRET WINAPI CM_Query_Remove_SubTree_Ex(DEVINST ,ULONG ,HMACHINE );
CMAPI CONFIGRET WINAPI CM_Query_And_Remove_SubTreeA(DEVINST ,PPNP_VETO_TYPE ,LPSTR ,ULONG ,ULONG );
CMAPI CONFIGRET WINAPI CM_Query_And_Remove_SubTree_ExA(DEVINST ,PPNP_VETO_TYPE ,LPSTR ,ULONG ,ULONG ,HMACHINE );
CMAPI CONFIGRET WINAPI CM_Query_And_Remove_SubTreeW(DEVINST ,PPNP_VETO_TYPE ,LPWSTR ,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Query_And_Remove_SubTree_ExW(DEVINST ,PPNP_VETO_TYPE ,LPWSTR ,ULONG ,ULONG ,HMACHINE );
#ifdef UNICODE
#define CM_Query_And_Remove_SubTree CM_Query_And_Remove_SubTreeW
#define CM_Query_And_Remove_SubTree_Ex CM_Query_And_Remove_SubTree_ExW
#else
#define CM_Query_And_Remove_SubTree CM_Query_And_Remove_SubTreeA
#define CM_Query_And_Remove_SubTree_Ex CM_Query_And_Remove_SubTree_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Request_Device_EjectA(DEVINST ,PPNP_VETO_TYPE ,LPSTR ,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Request_Device_Eject_ExA(DEVINST ,PPNP_VETO_TYPE ,LPSTR ,ULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Request_Device_EjectW(DEVINST ,PPNP_VETO_TYPE ,LPWSTR ,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Request_Device_Eject_ExW(DEVINST ,PPNP_VETO_TYPE ,LPWSTR ,ULONG ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Request_Device_Eject CM_Request_Device_EjectW
#define CM_Request_Device_Eject_Ex CM_Request_Device_Eject_ExW
#else
#define CM_Request_Device_Eject CM_Request_Device_EjectA
#define CM_Request_Device_Eject_Ex CM_Request_Device_Eject_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Reenumerate_DevNode(DEVINST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Reenumerate_DevNode_Ex(DEVINST ,ULONG ,HMACHINE hMachine );
#define CM_Reenumerate_DevInst CM_Reenumerate_DevNode
#define CM_Reenumerate_DevInst_Ex CM_Reenumerate_DevNode_Ex
CMAPI CONFIGRET WINAPI CM_Register_Device_InterfaceA(DEVINST ,LPGUID ,LPCSTR ,OPTIONAL LPSTR pszDeviceInterface,PULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Register_Device_InterfaceW(DEVINST ,LPGUID ,LPCWSTR ,OPTIONAL LPWSTR pszDeviceInterface,PULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Register_Device_Interface_ExA(DEVINST ,LPGUID ,LPCSTR ,OPTIONAL LPSTR pszDeviceInterface,PULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Register_Device_Interface_ExW(DEVINST ,LPGUID ,LPCWSTR ,OPTIONAL LPWSTR pszDeviceInterface,PULONG ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Register_Device_Interface CM_Register_Device_InterfaceW
#define CM_Register_Device_Interface_Ex CM_Register_Device_Interface_ExW
#else
#define CM_Register_Device_Interface CM_Register_Device_InterfaceA
#define CM_Register_Device_Interface_Ex CM_Register_Device_Interface_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Set_DevNode_Problem_Ex(DEVINST ,ULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Set_DevNode_Problem(DEVINST ,ULONG ,ULONG ulFlags );
#define CM_Set_DevInst_Problem CM_Set_DevNode_Problem
#define CM_Set_DevInst_Problem_Ex CM_Set_DevNode_Problem_Ex
CMAPI CONFIGRET WINAPI CM_Unregister_Device_InterfaceA(LPCSTR ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Unregister_Device_InterfaceW(LPCWSTR ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Unregister_Device_Interface_ExA(LPCSTR ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Unregister_Device_Interface_ExW(LPCWSTR ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Unregister_Device_Interface CM_Unregister_Device_InterfaceW
#define CM_Unregister_Device_Interface_Ex CM_Unregister_Device_Interface_ExW
#else
#define CM_Unregister_Device_Interface CM_Unregister_Device_InterfaceA
#define CM_Unregister_Device_Interface_Ex CM_Unregister_Device_Interface_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Register_Device_Driver(DEVINST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Register_Device_Driver_Ex(DEVINST ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Remove_SubTree(DEVINST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Remove_SubTree_Ex(DEVINST ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Set_DevNode_Registry_PropertyA(DEVINST ,ULONG ,PCVOID ,OPTIONAL ULONG ulLength,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Set_DevNode_Registry_PropertyW(DEVINST ,ULONG ,PCVOID ,OPTIONAL ULONG ulLength,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Set_DevNode_Registry_Property_ExA(DEVINST ,ULONG ,PCVOID ,OPTIONAL ULONG ulLength,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Set_DevNode_Registry_Property_ExW(DEVINST ,ULONG ,PCVOID ,OPTIONAL ULONG ulLength,ULONG ,HMACHINE hMachine );
#define CM_Set_DevInst_Registry_PropertyW CM_Set_DevNode_Registry_PropertyW
#define CM_Set_DevInst_Registry_PropertyA CM_Set_DevNode_Registry_PropertyA
#define CM_Set_DevInst_Registry_Property_ExW CM_Set_DevNode_Registry_Property_ExW
#define CM_Set_DevInst_Registry_Property_ExA CM_Set_DevNode_Registry_Property_ExA
#ifdef UNICODE
#define CM_Set_DevInst_Registry_Property CM_Set_DevNode_Registry_PropertyW
#define CM_Set_DevInst_Registry_Property_Ex CM_Set_DevNode_Registry_Property_ExW
#define CM_Set_DevNode_Registry_Property CM_Set_DevNode_Registry_PropertyW
#define CM_Set_DevNode_Registry_Property_Ex CM_Set_DevNode_Registry_Property_ExW
#else
#define CM_Set_DevInst_Registry_Property CM_Set_DevNode_Registry_PropertyA
#define CM_Set_DevInst_Registry_Property_Ex CM_Set_DevNode_Registry_Property_ExA
#define CM_Set_DevNode_Registry_Property CM_Set_DevNode_Registry_PropertyA
#define CM_Set_DevNode_Registry_Property_Ex CM_Set_DevNode_Registry_Property_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Is_Dock_Station_Present(PBOOL pbPresent );
CMAPI CONFIGRET WINAPI CM_Is_Dock_Station_Present_Ex(PBOOL ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Request_Eject_PC(VOID );
CMAPI CONFIGRET WINAPI CM_Request_Eject_PC_Ex(HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Set_HW_Prof_FlagsA(DEVINSTID_A ,ULONG ,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Set_HW_Prof_FlagsW(DEVINSTID_W ,ULONG ,ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Set_HW_Prof_Flags_ExA(DEVINSTID_A ,ULONG ,ULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Set_HW_Prof_Flags_ExW(DEVINSTID_W ,ULONG ,ULONG ,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Set_HW_Prof_Flags CM_Set_HW_Prof_FlagsW
#define CM_Set_HW_Prof_Flags_Ex CM_Set_HW_Prof_Flags_ExW
#else
#define CM_Set_HW_Prof_Flags CM_Set_HW_Prof_FlagsA
#define CM_Set_HW_Prof_Flags_Ex CM_Set_HW_Prof_Flags_ExA
#endif 
CMAPI CONFIGRET WINAPI CM_Setup_DevNode(DEVINST ,ULONG );
CMAPI CONFIGRET WINAPI CM_Setup_DevNode_Ex(DEVINST ,ULONG ,HMACHINE );
#define CM_Setup_DevInst CM_Setup_DevNode
#define CM_Setup_DevInst_Ex CM_Setup_DevNode_Ex
CMAPI CONFIGRET WINAPI CM_Test_Range_Available(DWORDLONG ,DWORDLONG ,RANGE_LIST ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Uninstall_DevNode(DEVNODE ,ULONG );
CMAPI CONFIGRET WINAPI CM_Uninstall_DevNode_Ex(DEVNODE ,ULONG ,HANDLE );
#define CM_Uninstall_DevInst CM_Uninstall_DevNode
#define CM_Uninstall_DevInst_Ex CM_Uninstall_DevNode_Ex
CMAPI CONFIGRET WINAPI CM_Run_Detection(ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Run_Detection_Ex(ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Set_HW_Prof(ULONG ,ULONG ulFlags );
CMAPI CONFIGRET WINAPI CM_Set_HW_Prof_Ex(ULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Query_Resource_Conflict_List(PCONFLICT_LIST ,DEVINST ,RESOURCEID ,PCVOID ,ULONG ,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Free_Resource_Conflict_Handle(CONFLICT_LIST clConflictList );
CMAPI CONFIGRET WINAPI CM_Get_Resource_Conflict_Count(CONFLICT_LIST ,PULONG pulCount );
CMAPI CONFIGRET WINAPI CM_Get_Resource_Conflict_DetailsA(CONFLICT_LIST ,ULONG ,PCONFLICT_DETAILS_A pConflictDetails );
CMAPI CONFIGRET WINAPI CM_Get_Resource_Conflict_DetailsW(CONFLICT_LIST ,ULONG ,PCONFLICT_DETAILS_W pConflictDetails );
#ifdef UNICODE
#define CM_Get_Resource_Conflict_Details CM_Get_Resource_Conflict_DetailsW
#else
#define CM_Get_Resource_Conflict_Details CM_Get_Resource_Conflict_DetailsA
#endif 
CMAPI CONFIGRET WINAPI CM_Get_Class_Registry_PropertyW(LPGUID ,ULONG ,PULONG ,OPTIONAL PVOID Buffer,OPTIONAL PULONG pulLength,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Set_Class_Registry_PropertyW(LPGUID ,ULONG ,PCVOID ,OPTIONAL ULONG ulLength,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Get_Class_Registry_PropertyA(LPGUID ,ULONG ,PULONG ,OPTIONAL PVOID Buffer,OPTIONAL PULONG pulLength,ULONG ,HMACHINE hMachine );
CMAPI CONFIGRET WINAPI CM_Set_Class_Registry_PropertyA(LPGUID ,ULONG ,PCVOID ,OPTIONAL ULONG ulLength,ULONG ,HMACHINE hMachine );
#ifdef UNICODE
#define CM_Get_Class_Registry_Property CM_Get_Class_Registry_PropertyW
#define CM_Set_Class_Registry_Property CM_Set_Class_Registry_PropertyW
#else
#define CM_Get_Class_Registry_Property CM_Get_Class_Registry_PropertyA
#define CM_Set_Class_Registry_Property CM_Set_Class_Registry_PropertyA
#endif 
#define CM_WaitNoPendingInstallEvents CMP_WaitNoPendingInstallEvents
DWORD WINAPI CM_WaitNoPendingInstallEvents(DWORD dwTimeout );
#define CR_SUCCESS 0
#define CR_DEFAULT 1
#define CR_OUT_OF_MEMORY 2
#define CR_INVALID_POINTER 3
#define CR_INVALID_FLAG 4
#define CR_INVALID_DEVNODE 5
#define CR_INVALID_DEVINST CR_INVALID_DEVNODE
#define CR_INVALID_RES_DES 6
#define CR_INVALID_LOG_CONF 7
#define CR_INVALID_ARBITRATOR 8
#define CR_INVALID_NODELIST 9
#define CR_DEVNODE_HAS_REQS 10
#define CR_DEVINST_HAS_REQS CR_DEVNODE_HAS_REQS
#define CR_INVALID_RESOURCEID 11
#define CR_DLVXD_NOT_FOUND 12  
#define CR_NO_SUCH_DEVNODE 13
#define CR_NO_SUCH_DEVINST CR_NO_SUCH_DEVNODE
#define CR_NO_MORE_LOG_CONF 14
#define CR_NO_MORE_RES_DES 15
#define CR_ALREADY_SUCH_DEVNODE 16
#define CR_ALREADY_SUCH_DEVINST CR_ALREADY_SUCH_DEVNODE
#define CR_INVALID_RANGE_LIST 17
#define CR_INVALID_RANGE 18
#define CR_FAILURE 19
#define CR_NO_SUCH_LOGICAL_DEV 20
#define CR_CREATE_BLOCKED 21
#define CR_NOT_SYSTEM_VM 22  
#define CR_REMOVE_VETOED 23
#define CR_APM_VETOED 24
#define CR_INVALID_LOAD_TYPE 25
#define CR_BUFFER_SMALL 26
#define CR_NO_ARBITRATOR 27
#define CR_NO_REGISTRY_HANDLE 28
#define CR_REGISTRY_ERROR 29
#define CR_INVALID_DEVICE_ID 30
#define CR_INVALID_DATA 31
#define CR_INVALID_API 32
#define CR_DEVLOADER_NOT_READY 33
#define CR_NEED_RESTART 34
#define CR_NO_MORE_HW_PROFILES 35
#define CR_DEVICE_NOT_THERE 36
#define CR_NO_SUCH_VALUE 37
#define CR_WRONG_TYPE 38
#define CR_INVALID_PRIORITY 39
#define CR_NOT_DISABLEABLE 40
#define CR_FREE_RESOURCES 41
#define CR_QUERY_VETOED 42
#define CR_CANT_SHARE_IRQ 43
#define CR_NO_DEPENDENT 44
#define CR_SAME_RESOURCES 45
#define CR_NO_SUCH_REGISTRY_KEY 46
#define CR_INVALID_MACHINENAME 47  
#define CR_REMOTE_COMM_FAILURE 48  
#define CR_MACHINE_UNAVAILABLE 49  
#define CR_NO_CM_SERVICES 50  
#define CR_ACCESS_DENIED 51  
#define CR_CALL_NOT_IMPLEMENTED 52
#define CR_INVALID_PROPERTY 53
#define CR_DEVICE_INTERFACE_ACTIVE 54
#define CR_NO_SUCH_DEVICE_INTERFACE 55
#define CR_INVALID_REFERENCE_STRING 56
#define CR_INVALID_CONFLICT_LIST 57
#define CR_INVALID_INDEX 58
#define CR_INVALID_STRUCTURE_SIZE 59
#define NUM_CR_RESULTS 60
#endif 
