#ifndef __complex_h__
#define __complex_h__
#include <math.h>
#include <iostream.h>
#pragma extensions(push,on)
extern long double log1pl(long double);
//------------------------------------------------------------
// _Complex data structure
// It is now automatically defined by the compiler at startup for
// the types float, double, and long double.
//typedef struct __complex {
//	double re;
//	double im;
//} _Complex;
#define creal(a) ((double)a.re)
#define cimag(a) ((double)a.im)
#define creall(a) ((long double)a.re)
#define cimagl(a) ((long double)a.im)
#define cimagf(a) ((float)a.im)
#define crealf(a) ((float)a.re)
#define complex _Complex
long double _Complex operator -= (long double _Complex &a,const long double _Complex r);
long double _Complex operator *= (long double _Complex &a,const long double _Complex r);
double _Complex operator *=(double _Complex &a,const double _Complex r);
double _Complex operator +(double _Complex x, double _Complex y);
//
// Addition operator
//
long double _Complex operator +(const long double _Complex x, const long double _Complex y);
long double _Complex operator += (long double _Complex a,const long double _Complex r);
long double _Complex operator+(long double,const long double _Complex);
long double _Complex operator+(long double,const long double _Complex);
//
// Minus operator
//
long double _Complex operator -(const long double _Complex x, double y);
long double _Complex operator -(const double y,const long double _Complex x);
long double _Complex operator -(const long double x, const double _Complex y);
long double _Complex operator-(const long double x,const long double _Complex y);
long double _Complex operator- (const long double _Complex,const long double _Complex);
//
// Multiplication
//
long double _Complex operator * (const long double _Complex x, const long double _Complex y);
long double _Complex operator * (const long double _Complex x, long double y);
long double _Complex operator *(const long double x, long double _Complex y);
//long double _Complex operator * (const long double _Complex x, int y);
//
// division
//
double _Complex operator / (const double _Complex x, double y);
long double _Complex operator / (const long double _Complex x,int y);
double _Complex operator /= (double _Complex &a,const double _Complex y);
//double _Complex operator / (const double _Complex x, const double _Complex y);
double _Complex operator / (double x, const double _Complex y);
long double _Complex operator / (const long double _Complex x, long double _Complex y);
double _Complex operator - (const double _Complex x);
int operator == (const double _Complex x, const double _Complex y);
int operator == (const double _Complex x, double y);
int operator == (double x, const double _Complex y);
int operator != (const double _Complex x, const double _Complex y);
int operator != (const double _Complex x, double y);
int operator != (double x, const double _Complex y);
//
// Other operators
//
long double _Complex operator ~(long double complex);
double _Complex operator ~(double _Complex);
float _Complex operator ~(float _Complex);

//
// Casts
//
long double _Complex operator()(double _Complex &a);
double _Complex operator()(long double _Complex &a);
long double _Complex operator()(float _Complex &a);
double _Complex operator()(float _Complex &a);
long double _Complex operator()(long double ld);
double _Complex operator()(double d);
long double _Complex operator()(double);
long double _Complex operator()(long double);
long double _Complex operator()(int);
long double _Complex operator()(unsigned long);
long double _Complex operator()(unsigned long long);
//
//Assignments
//
long double _Complex operator=(long double _Complex &a,long double d);
long double _Complex operator=(long double _Complex &a,double _Complex d);
double _Complex operator=(double _Complex &a,long double _Complex d);
long double _Complex operator=(long double _Complex &a,float _Complex d);
float _Complex operator=(float _Complex &a,long double _Complex d);
double _Complex operator=(double _Complex &a,float _Complex d);
float _Complex operator=(float _Complex &d,double _Complex a);


extern float _Complex I;
#define _Complex_I I
double norm (const double _Complex);
// cabs
double cabs(const double _Complex x);
long double cabsl(long double _Complex);
float cabsf(float _Complex);

double arg(const double _Complex x);
// conj
double _Complex conj(const double _Complex x);
long double _Complex conjl(const long double _Complex x);
float _Complex conjf(const float _Complex x);

//ccos
double _Complex ccos(const double _Complex);
long double _Complex ccosl(const long double _Complex);
float _Complex ccosf(const float _Complex);

//cacos
double _Complex cacos(const double _Complex);
long double _Complex cacosl(const long double _Complex);
float _Complex cacosf(const float _Complex);

// ccosh
double _Complex ccosh (const double _Complex x);
long double _Complex ccoshl(long double _Complex);
float _Complex ccoshf(float _Complex x);

//ctanh
double _Complex ctanh(double _Complex);
long double _Complex ctanhl(long double _Complex);
float _Complex ctanhf(float _Complex);

//ctan
double _Complex ctan(double _Complex);
long double _Complex ctanl(long double _Complex);
float _Complex ctanf(float _Complex);

//catan
double _Complex catan(double _Complex);
long double _Complex catanl(long double _Complex);
float _Complex catanf(float _Complex);

double _Complex c_polar (double r, double t);
// Cexp
double _Complex cexp(const double _Complex x);
long double _Complex cexpl(long double _Complex x);
float _Complex cexpf(float _Complex x);

// Clog
double _Complex clog(const double _Complex x);
long double _Complex clogl(long double _Complex x);
float _Complex clogf(float _Complex x);

// Cpow
double _Complex cpow(const double _Complex x,const double _Complex y);
long double _Complex cpowl(long double _Complex x,long double _Complex y);
float _Complex cpowf(float _Complex x,float _Complex y);

// Csqrt
double _Complex csqrt(const double _Complex x);
long double _Complex csqrtl(long double _Complex x);
float _Complex csqrtf(float _Complex x);

// csin
double _Complex csin(const double _Complex x);
long double _Complex csinl(long double _Complex x);
float _Complex csinf(float _Complex x);

// casin
double _Complex casin(double _Complex);
long double _Complex casinl(long double _Complex);
float _Complex casinf(float _Complex);

double _Complex csinh(const double _Complex);
long double _Complex csinhl(long double _Complex);
float _Complex csinhf(float _Complex);

// CASINH
double _Complex casinh(const double _Complex);
long double _Complex casinhl(long double _Complex);
float _Complex casinhf(float _Complex);

// CACOSH
double _Complex cacosh(const double _Complex);
long double _Complex cacoshl(long double _Complex);
float _Complex cacoshf(float _Complex);

// CATANH
double _Complex catanh(const double _Complex);
long double _Complex catanhl(long double _Complex);
float _Complex catanhf(float _Complex);

double _Complex c_intpow (const double _Complex xin, int y);
//long double _Complex operator()(float _Complex x);
//long double _Complex operator()(double _Complex x);


double carg(const double _Complex);
long double cargl(long double _Complex);

double _Complex ctgamma(double _Complex);
long double _Complex ctgammal(long double _Complex);
long double _Complex clgammal(long double _Complex);
#pragma extensions(pop)
#endif
