#ifndef __REQUIRED_RPCNDR_H_VERSION__
#define __REQUIRED_RPCNDR_H_VERSION__ 440
#endif
#include "rpc.h"
#include "rpcndr.h"
#ifndef __RPCNDR_H_VERSION__
#error this stub requires an updated version of <rpcndr.h>
#endif 
#ifndef COM_NO_WINDOWS_H
#include "windows.h"
#include "ole2.h"
#endif 
#ifndef __confpriv_h__
#define __confpriv_h__
#ifndef __ITParticipant_FWD_DEFINED__
#define __ITParticipant_FWD_DEFINED__
typedef interface ITParticipant ITParticipant;
#endif 
#ifndef __IEnumParticipant_FWD_DEFINED__
#define __IEnumParticipant_FWD_DEFINED__
typedef interface IEnumParticipant IEnumParticipant;
#endif 
#ifndef __ITParticipantControl_FWD_DEFINED__
#define __ITParticipantControl_FWD_DEFINED__
typedef interface ITParticipantControl ITParticipantControl;
#endif 
#ifndef __ITParticipantSubStreamControl_FWD_DEFINED__
#define __ITParticipantSubStreamControl_FWD_DEFINED__
typedef interface ITParticipantSubStreamControl ITParticipantSubStreamControl;
#endif 
#ifndef __ITParticipantEvent_FWD_DEFINED__
#define __ITParticipantEvent_FWD_DEFINED__
typedef interface ITParticipantEvent ITParticipantEvent;
#endif 
#ifndef __ITIPInterfaceControl_FWD_DEFINED__
#define __ITIPInterfaceControl_FWD_DEFINED__
typedef interface ITIPInterfaceControl ITIPInterfaceControl;
#endif 
#include "tapi3if.h"
void * __RPC_USER MIDL_user_allocate(size_t);
void __RPC_USER MIDL_user_free(void *); 
typedef 
enum PARTICIPANT_TYPED_INFO
{	PTI_CANONICALNAME=0, PTI_NAME=PTI_CANONICALNAME + 1,
PTI_EMAILADDRESS=PTI_NAME + 1, PTI_PHONENUMBER=PTI_EMAILADDRESS + 1,
PTI_LOCATION=PTI_PHONENUMBER + 1, PTI_TOOL=PTI_LOCATION + 1,
PTI_NOTES=PTI_TOOL + 1, PTI_PRIVATE=PTI_NOTES + 1
}	PARTICIPANT_TYPED_INFO;
typedef 
enum PARTICIPANT_EVENT
{	PE_NEW_PARTICIPANT=0, PE_INFO_CHANGE=PE_NEW_PARTICIPANT + 1,
PE_PARTICIPANT_LEAVE=PE_INFO_CHANGE + 1, PE_PARTICIPANT_MAPPED_TO_SUBSTREAM=PE_PARTICIPANT_LEAVE + 1,
PE_SUBSTREAM_UNMAPPED=PE_PARTICIPANT_MAPPED_TO_SUBSTREAM + 1, PE_PARTICIPANT_TIMEOUT=PE_SUBSTREAM_UNMAPPED + 1,
PE_PARTICIPANT_RECOVERED=PE_PARTICIPANT_TIMEOUT + 1
}	PARTICIPANT_EVENT;
extern RPC_IF_HANDLE __MIDL_itf_confpriv_0000_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_confpriv_0000_v0_0_s_ifspec;
#ifndef __ITParticipant_INTERFACE_DEFINED__
#define __ITParticipant_INTERFACE_DEFINED__
EXTERN_C const IID IID_ITParticipant;
typedef struct ITParticipantVtbl
{
 BEGIN_INTERFACE
 HRESULT (STDMETHODCALLTYPE *QueryInterface)(ITParticipant *,REFIID,void * *);
 ULONG (STDMETHODCALLTYPE *AddRef)(ITParticipant *);
 ULONG (STDMETHODCALLTYPE *Release)(ITParticipant *);
 HRESULT (STDMETHODCALLTYPE *GetTypeInfoCount)(ITParticipant *,UINT *);
 HRESULT (STDMETHODCALLTYPE *GetTypeInfo)(ITParticipant *,UINT,LCID,ITypeInfo * *);
 HRESULT (STDMETHODCALLTYPE *GetIDsOfNames)(ITParticipant *,REFIID,LPOLESTR *,UINT,LCID,DISPID *);
  HRESULT (STDMETHODCALLTYPE *Invoke)(ITParticipant *,DISPID,REFIID,LCID,WORD,DISPPARAMS *,VARIANT *,EXCEPINFO *,UINT *);
  HRESULT (STDMETHODCALLTYPE *get_ParticipantTypedInfo)(ITParticipant *,PARTICIPANT_TYPED_INFO,BSTR *);
  HRESULT (STDMETHODCALLTYPE *get_MediaTypes)(ITParticipant *,long *);
  HRESULT (STDMETHODCALLTYPE *put_Status)(ITParticipant *,ITStream *,VARIANT_BOOL);
  HRESULT (STDMETHODCALLTYPE *get_Status)(ITParticipant *,ITStream *,VARIANT_BOOL *);
  HRESULT (STDMETHODCALLTYPE *get_Streams)(ITParticipant *,VARIANT *);
  HRESULT (STDMETHODCALLTYPE *EnumerateStreams)(ITParticipant *,IEnumStream * *);
END_INTERFACE
} ITParticipantVtbl;
interface ITParticipant { CONST_VTBL struct ITParticipantVtbl *lpVtbl; };
#ifdef COBJMACROS
#define ITParticipant_QueryInterface(A,B,C) (A)->lpVtbl->QueryInterface(A,B,C)
#define ITParticipant_AddRef(A) (A)->lpVtbl->AddRef(A)
#define ITParticipant_Release(A) (A)->lpVtbl->Release(A)
#define ITParticipant_GetTypeInfoCount(A,B) (A)->lpVtbl->GetTypeInfoCount(A,B)
#define ITParticipant_GetTypeInfo(A,B,C,D) (A)->lpVtbl->GetTypeInfo(A,B,C,D)
#define ITParticipant_GetIDsOfNames(A,B,C,D,E,F) (A)->lpVtbl->GetIDsOfNames(A,B,C,D,E,F)
#define ITParticipant_Invoke(A,B,C,D,E,F,G,H,I) (A)->lpVtbl->Invoke(A,B,C,D,E,F,G,H,I)
#define ITParticipant_get_ParticipantTypedInfo(A,B,C) (A)->lpVtbl->get_ParticipantTypedInfo(A,B,C)
#define ITParticipant_get_MediaTypes(A,B) (A)->lpVtbl->get_MediaTypes(A,B)
#define ITParticipant_put_Status(A,B,C) (A)->lpVtbl->put_Status(A,B,C)
#define ITParticipant_get_Status(A,B,C) (A)->lpVtbl->get_Status(A,B,C)
#define ITParticipant_get_Streams(A,B) (A)->lpVtbl->get_Streams(A,B)
#define ITParticipant_EnumerateStreams(A,B) (A)->lpVtbl->EnumerateStreams(A,B)
#endif 
HRESULT STDMETHODCALLTYPE ITParticipant_get_ParticipantTypedInfo_Proxy(ITParticipant *,PARTICIPANT_TYPED_INFO,BSTR *);
void __RPC_STUB ITParticipant_get_ParticipantTypedInfo_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE ITParticipant_get_MediaTypes_Proxy(ITParticipant *,long *);
void __RPC_STUB ITParticipant_get_MediaTypes_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE ITParticipant_put_Status_Proxy(ITParticipant *,ITStream *,VARIANT_BOOL);
void __RPC_STUB ITParticipant_put_Status_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE ITParticipant_get_Status_Proxy(ITParticipant *,ITStream *,VARIANT_BOOL *);
void __RPC_STUB ITParticipant_get_Status_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE ITParticipant_get_Streams_Proxy(ITParticipant *,VARIANT *);
void __RPC_STUB ITParticipant_get_Streams_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE ITParticipant_EnumerateStreams_Proxy(ITParticipant *,IEnumStream * *);
void __RPC_STUB ITParticipant_EnumerateStreams_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
#endif 
#ifndef __IEnumParticipant_INTERFACE_DEFINED__
#define __IEnumParticipant_INTERFACE_DEFINED__
EXTERN_C const IID IID_IEnumParticipant;
typedef struct IEnumParticipantVtbl
{
 BEGIN_INTERFACE
 HRESULT (STDMETHODCALLTYPE *QueryInterface)(IEnumParticipant *,REFIID,void * *);
 ULONG (STDMETHODCALLTYPE *AddRef)(IEnumParticipant *);
 ULONG (STDMETHODCALLTYPE *Release)(IEnumParticipant *);
 HRESULT (STDMETHODCALLTYPE *Next)(IEnumParticipant *,ULONG,ITParticipant * *,ULONG *);
 HRESULT (STDMETHODCALLTYPE *Reset)(IEnumParticipant *);
 HRESULT (STDMETHODCALLTYPE *Skip)(IEnumParticipant *,ULONG);
 HRESULT (STDMETHODCALLTYPE *Clone)(IEnumParticipant *,IEnumParticipant * *);
END_INTERFACE
} IEnumParticipantVtbl;
interface IEnumParticipant { CONST_VTBL struct IEnumParticipantVtbl *lpVtbl; };
#ifdef COBJMACROS
#define IEnumParticipant_QueryInterface(A,B,C) (A)->lpVtbl->QueryInterface(A,B,C)
#define IEnumParticipant_AddRef(A) (A)->lpVtbl->AddRef(A)
#define IEnumParticipant_Release(A) (A)->lpVtbl->Release(A)
#define IEnumParticipant_Next(A,B,C,D) (A)->lpVtbl->Next(A,B,C,D)
#define IEnumParticipant_Reset(A) (A)->lpVtbl->Reset(A)
#define IEnumParticipant_Skip(A,B) (A)->lpVtbl->Skip(A,B)
#define IEnumParticipant_Clone(A,B) (A)->lpVtbl->Clone(A,B)
#endif 
HRESULT STDMETHODCALLTYPE IEnumParticipant_Next_Proxy(IEnumParticipant *,ULONG,ITParticipant * *,ULONG *);
void __RPC_STUB IEnumParticipant_Next_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE IEnumParticipant_Reset_Proxy(IEnumParticipant * This);
void __RPC_STUB IEnumParticipant_Reset_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE IEnumParticipant_Skip_Proxy(IEnumParticipant *,ULONG);
void __RPC_STUB IEnumParticipant_Skip_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE IEnumParticipant_Clone_Proxy(IEnumParticipant *,IEnumParticipant * *);
void __RPC_STUB IEnumParticipant_Clone_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
#endif 
#ifndef __ITParticipantControl_INTERFACE_DEFINED__
#define __ITParticipantControl_INTERFACE_DEFINED__
EXTERN_C const IID IID_ITParticipantControl;
typedef struct ITParticipantControlVtbl {
 BEGIN_INTERFACE
 HRESULT (STDMETHODCALLTYPE *QueryInterface)(ITParticipantControl *,REFIID,void * *);
 ULONG (STDMETHODCALLTYPE *AddRef)(ITParticipantControl *);
 ULONG (STDMETHODCALLTYPE *Release)(ITParticipantControl *);
 HRESULT (STDMETHODCALLTYPE *GetTypeInfoCount)(ITParticipantControl *,UINT *);
 HRESULT (STDMETHODCALLTYPE *GetTypeInfo)(ITParticipantControl *,UINT,LCID,ITypeInfo * *);
 HRESULT (STDMETHODCALLTYPE *GetIDsOfNames)(ITParticipantControl *,REFIID,LPOLESTR *,UINT,LCID,DISPID *);
  HRESULT (STDMETHODCALLTYPE *Invoke)(ITParticipantControl *,DISPID,REFIID,LCID,WORD,DISPPARAMS *,VARIANT *,EXCEPINFO *,UINT *);
  HRESULT (STDMETHODCALLTYPE *EnumerateParticipants)(ITParticipantControl *,IEnumParticipant * *);
  HRESULT (STDMETHODCALLTYPE *get_Participants)(ITParticipantControl *,VARIANT *);
END_INTERFACE
} ITParticipantControlVtbl;
interface ITParticipantControl { CONST_VTBL struct ITParticipantControlVtbl *lpVtbl; };
#ifdef COBJMACROS
#define ITParticipantControl_QueryInterface(A,B,C) (A)->lpVtbl->QueryInterface(A,B,C)
#define ITParticipantControl_AddRef(A) (A)->lpVtbl->AddRef(A)
#define ITParticipantControl_Release(A) (A)->lpVtbl->Release(A)
#define ITParticipantControl_GetTypeInfoCount(A,B) (A)->lpVtbl->GetTypeInfoCount(A,B)
#define ITParticipantControl_GetTypeInfo(A,B,C,D) (A)->lpVtbl->GetTypeInfo(A,B,C,D)
#define ITParticipantControl_GetIDsOfNames(A,B,C,D,E,F) (A)->lpVtbl->GetIDsOfNames(A,B,C,D,E,F)
#define ITParticipantControl_Invoke(A,B,C,D,E,F,G,H,I) (A)->lpVtbl->Invoke(A,B,C,D,E,F,G,H,I)
#define ITParticipantControl_EnumerateParticipants(A,B) (A)->lpVtbl->EnumerateParticipants(A,B)
#define ITParticipantControl_get_Participants(A,B) (A)->lpVtbl->get_Participants(A,B)
#endif 
HRESULT STDMETHODCALLTYPE ITParticipantControl_EnumerateParticipants_Proxy(ITParticipantControl *,IEnumParticipant * *);
void __RPC_STUB ITParticipantControl_EnumerateParticipants_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE ITParticipantControl_get_Participants_Proxy(ITParticipantControl *,VARIANT *);
void __RPC_STUB ITParticipantControl_get_Participants_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
#endif 
#ifndef __ITParticipantSubStreamControl_INTERFACE_DEFINED__
#define __ITParticipantSubStreamControl_INTERFACE_DEFINED__
EXTERN_C const IID IID_ITParticipantSubStreamControl;
typedef struct ITParticipantSubStreamControlVtbl {
 BEGIN_INTERFACE
 HRESULT (STDMETHODCALLTYPE *QueryInterface)(ITParticipantSubStreamControl *,REFIID,void * *);
 ULONG (STDMETHODCALLTYPE *AddRef)(ITParticipantSubStreamControl *);
 ULONG (STDMETHODCALLTYPE *Release)(ITParticipantSubStreamControl *);
 HRESULT (STDMETHODCALLTYPE *GetTypeInfoCount)(ITParticipantSubStreamControl *,UINT *);
 HRESULT (STDMETHODCALLTYPE *GetTypeInfo)(ITParticipantSubStreamControl *,UINT,LCID,ITypeInfo * *);
 HRESULT (STDMETHODCALLTYPE *GetIDsOfNames)(ITParticipantSubStreamControl *,REFIID,LPOLESTR *,UINT,LCID,DISPID *);
  HRESULT (STDMETHODCALLTYPE *Invoke)(ITParticipantSubStreamControl *,DISPID,REFIID,LCID,WORD,DISPPARAMS *,VARIANT *,EXCEPINFO *,UINT *);
  HRESULT (STDMETHODCALLTYPE *get_SubStreamFromParticipant)(ITParticipantSubStreamControl *,ITParticipant *,ITSubStream * *);
  HRESULT (STDMETHODCALLTYPE *get_ParticipantFromSubStream)(ITParticipantSubStreamControl *,ITSubStream *,ITParticipant * *);
  HRESULT (STDMETHODCALLTYPE *MapParticipantToSubStream)(ITParticipantSubStreamControl *,ITParticipant *,ITSubStream *);
END_INTERFACE
} ITParticipantSubStreamControlVtbl;
interface ITParticipantSubStreamControl
{
CONST_VTBL struct ITParticipantSubStreamControlVtbl *lpVtbl;
};
#ifdef COBJMACROS
#define ITParticipantSubStreamControl_QueryInterface(A,B,C) (A)->lpVtbl->QueryInterface(A,B,C)
#define ITParticipantSubStreamControl_AddRef(A) (A)->lpVtbl->AddRef(A)
#define ITParticipantSubStreamControl_Release(A) (A)->lpVtbl->Release(A)
#define ITParticipantSubStreamControl_GetTypeInfoCount(A,B) (A)->lpVtbl->GetTypeInfoCount(A,B)
#define ITParticipantSubStreamControl_GetTypeInfo(A,B,C,D) (A)->lpVtbl->GetTypeInfo(A,B,C,D)
#define ITParticipantSubStreamControl_GetIDsOfNames(A,B,C,D,E,F) (A)->lpVtbl->GetIDsOfNames(A,B,C,D,E,F)
#define ITParticipantSubStreamControl_Invoke(A,B,C,D,E,F,G,H,I) (A)->lpVtbl->Invoke(A,B,C,D,E,F,G,H,I)
#define ITParticipantSubStreamControl_get_SubStreamFromParticipant(A,B,C) (A)->lpVtbl->get_SubStreamFromParticipant(A,B,C)
#define ITParticipantSubStreamControl_get_ParticipantFromSubStream(A,B,C) (A)->lpVtbl->get_ParticipantFromSubStream(A,B,C)
#define ITParticipantSubStreamControl_MapParticipantToSubStream(A,B,C) (A)->lpVtbl->MapParticipantToSubStream(A,B,C)
#endif 
HRESULT STDMETHODCALLTYPE ITParticipantSubStreamControl_get_SubStreamFromParticipant_Proxy(ITParticipantSubStreamControl *,ITParticipant *,ITSubStream * *);
void __RPC_STUB ITParticipantSubStreamControl_get_SubStreamFromParticipant_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE ITParticipantSubStreamControl_get_ParticipantFromSubStream_Proxy(ITParticipantSubStreamControl *,ITSubStream *,ITParticipant * *);
void __RPC_STUB ITParticipantSubStreamControl_get_ParticipantFromSubStream_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE ITParticipantSubStreamControl_MapParticipantToSubStream_Proxy(ITParticipantSubStreamControl *,ITParticipant *,ITSubStream *);
void __RPC_STUB ITParticipantSubStreamControl_MapParticipantToSubStream_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
#endif 
#ifndef __ITParticipantEvent_INTERFACE_DEFINED__
#define __ITParticipantEvent_INTERFACE_DEFINED__
EXTERN_C const IID IID_ITParticipantEvent;
typedef struct ITParticipantEventVtbl
{
 BEGIN_INTERFACE
 HRESULT (STDMETHODCALLTYPE *QueryInterface)(ITParticipantEvent *,REFIID,void * *);
 ULONG (STDMETHODCALLTYPE *AddRef)(ITParticipantEvent *);
 ULONG (STDMETHODCALLTYPE *Release)(ITParticipantEvent *);
 HRESULT (STDMETHODCALLTYPE *GetTypeInfoCount)(ITParticipantEvent *,UINT *);
 HRESULT (STDMETHODCALLTYPE *GetTypeInfo)(ITParticipantEvent *,UINT,LCID,ITypeInfo * *);
 HRESULT (STDMETHODCALLTYPE *GetIDsOfNames)(ITParticipantEvent *,REFIID,LPOLESTR *,UINT,LCID,DISPID *);
  HRESULT (STDMETHODCALLTYPE *Invoke)(ITParticipantEvent *,DISPID,REFIID,LCID,WORD,DISPPARAMS *,VARIANT *,EXCEPINFO *,UINT *);
  HRESULT (STDMETHODCALLTYPE *get_Call)(ITParticipantEvent *,ITCallInfo * *);
  HRESULT (STDMETHODCALLTYPE *get_Event)(ITParticipantEvent *,PARTICIPANT_EVENT *);
  HRESULT (STDMETHODCALLTYPE *get_Participant)(ITParticipantEvent *,ITParticipant * *);
  HRESULT (STDMETHODCALLTYPE *get_SubStream)(ITParticipantEvent *,ITSubStream * *);
END_INTERFACE
} ITParticipantEventVtbl;
interface ITParticipantEvent
{
CONST_VTBL struct ITParticipantEventVtbl *lpVtbl;
};
#ifdef COBJMACROS
#define ITParticipantEvent_QueryInterface(A,B,C) (A)->lpVtbl->QueryInterface(A,B,C)
#define ITParticipantEvent_AddRef(A) (A)->lpVtbl->AddRef(A)
#define ITParticipantEvent_Release(A) (A)->lpVtbl->Release(A)
#define ITParticipantEvent_GetTypeInfoCount(A,B) (A)->lpVtbl->GetTypeInfoCount(A,B)
#define ITParticipantEvent_GetTypeInfo(A,B,C,D) (A)->lpVtbl->GetTypeInfo(A,B,C,D)
#define ITParticipantEvent_GetIDsOfNames(A,B,C,D,E,F) (A)->lpVtbl->GetIDsOfNames(A,B,C,D,E,F)
#define ITParticipantEvent_Invoke(A,B,C,D,E,F,G,H,I) (A)->lpVtbl->Invoke(A,B,C,D,E,F,G,H,I)
#define ITParticipantEvent_get_Call(A,B) (A)->lpVtbl->get_Call(A,B)
#define ITParticipantEvent_get_Event(A,B) (A)->lpVtbl->get_Event(A,B)
#define ITParticipantEvent_get_Participant(A,B) (A)->lpVtbl->get_Participant(A,B)
#define ITParticipantEvent_get_SubStream(A,B) (A)->lpVtbl->get_SubStream(A,B)
#endif 
HRESULT STDMETHODCALLTYPE ITParticipantEvent_get_Call_Proxy(ITParticipantEvent *,ITCallInfo * *);
void __RPC_STUB ITParticipantEvent_get_Call_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE ITParticipantEvent_get_Event_Proxy(ITParticipantEvent *,PARTICIPANT_EVENT *);
void __RPC_STUB ITParticipantEvent_get_Event_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE ITParticipantEvent_get_Participant_Proxy(ITParticipantEvent *,ITParticipant * *);
void __RPC_STUB ITParticipantEvent_get_Participant_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE ITParticipantEvent_get_SubStream_Proxy(ITParticipantEvent *,ITSubStream * *);
void __RPC_STUB ITParticipantEvent_get_SubStream_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
#endif 
#ifndef __ITIPInterfaceControl_INTERFACE_DEFINED__
#define __ITIPInterfaceControl_INTERFACE_DEFINED__
EXTERN_C const IID IID_ITIPInterfaceControl;
typedef struct ITIPInterfaceControlVtbl
{
 BEGIN_INTERFACE
 HRESULT (STDMETHODCALLTYPE *QueryInterface)(ITIPInterfaceControl *,REFIID,void * *);
 ULONG (STDMETHODCALLTYPE *AddRef)(ITIPInterfaceControl *);
 ULONG (STDMETHODCALLTYPE *Release)(ITIPInterfaceControl *);
 HRESULT (STDMETHODCALLTYPE *GetTypeInfoCount)(ITIPInterfaceControl *,UINT *);
 HRESULT (STDMETHODCALLTYPE *GetTypeInfo)(ITIPInterfaceControl *,UINT,LCID,ITypeInfo * *);
 HRESULT (STDMETHODCALLTYPE *GetIDsOfNames)(ITIPInterfaceControl *,REFIID,LPOLESTR *,UINT,LCID,DISPID *);
  HRESULT (STDMETHODCALLTYPE *Invoke)(ITIPInterfaceControl *,DISPID,REFIID,LCID,WORD,DISPPARAMS *,VARIANT *,EXCEPINFO *,UINT *);
  HRESULT (STDMETHODCALLTYPE *get_DefaultIPInterface)(ITIPInterfaceControl *,BSTR *);
  HRESULT (STDMETHODCALLTYPE *put_DefaultIPInterface)(ITIPInterfaceControl *,BSTR);
  HRESULT (STDMETHODCALLTYPE *get_IPInterfaces)(ITIPInterfaceControl *,VARIANT *);
  HRESULT (STDMETHODCALLTYPE *EnumerateIPInterfaces)(ITIPInterfaceControl *,IEnumBstr * *);
END_INTERFACE
} ITIPInterfaceControlVtbl;
interface ITIPInterfaceControl { CONST_VTBL struct ITIPInterfaceControlVtbl *lpVtbl; };
#ifdef COBJMACROS
#define ITIPInterfaceControl_QueryInterface(A,B,C) (A)->lpVtbl->QueryInterface(A,B,C)
#define ITIPInterfaceControl_AddRef(A) (A)->lpVtbl->AddRef(A)
#define ITIPInterfaceControl_Release(A) (A)->lpVtbl->Release(A)
#define ITIPInterfaceControl_GetTypeInfoCount(A,B) (A)->lpVtbl->GetTypeInfoCount(A,B)
#define ITIPInterfaceControl_GetTypeInfo(A,B,C,D) (A)->lpVtbl->GetTypeInfo(A,B,C,D)
#define ITIPInterfaceControl_GetIDsOfNames(A,B,C,D,E,F) (A)->lpVtbl->GetIDsOfNames(A,B,C,D,E,F)
#define ITIPInterfaceControl_Invoke(A,B,C,D,E,F,G,H,I) (A)->lpVtbl->Invoke(A,B,C,D,E,F,G,H,I)
#define ITIPInterfaceControl_get_DefaultIPInterface(A,B) (A)->lpVtbl->get_DefaultIPInterface(A,B)
#define ITIPInterfaceControl_put_DefaultIPInterface(A,B) (A)->lpVtbl->put_DefaultIPInterface(A,B)
#define ITIPInterfaceControl_get_IPInterfaces(A,B) (A)->lpVtbl->get_IPInterfaces(A,B)
#define ITIPInterfaceControl_EnumerateIPInterfaces(A,B) (A)->lpVtbl->EnumerateIPInterfaces(A,B)
#endif 
HRESULT STDMETHODCALLTYPE ITIPInterfaceControl_get_DefaultIPInterface_Proxy(ITIPInterfaceControl *,BSTR *);
void __RPC_STUB ITIPInterfaceControl_get_DefaultIPInterface_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE ITIPInterfaceControl_put_DefaultIPInterface_Proxy(ITIPInterfaceControl *,BSTR);
void __RPC_STUB ITIPInterfaceControl_put_DefaultIPInterface_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE ITIPInterfaceControl_get_IPInterfaces_Proxy(ITIPInterfaceControl *,VARIANT *);
void __RPC_STUB ITIPInterfaceControl_get_IPInterfaces_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
HRESULT STDMETHODCALLTYPE ITIPInterfaceControl_EnumerateIPInterfaces_Proxy(ITIPInterfaceControl *,IEnumBstr * *);
void __RPC_STUB ITIPInterfaceControl_EnumerateIPInterfaces_Stub(IRpcStubBuffer *,IRpcChannelBuffer *,PRPC_MESSAGE,DWORD *);
#endif 
unsigned long __RPC_USER BSTR_UserSize(unsigned long *, unsigned long,BSTR *); 
unsigned char * __RPC_USER BSTR_UserMarshal(unsigned long *, unsigned char *, BSTR *); 
unsigned char * __RPC_USER BSTR_UserUnmarshal(unsigned long *, unsigned char *, BSTR *); 
void __RPC_USER BSTR_UserFree(unsigned long *, BSTR *); 
unsigned long __RPC_USER VARIANT_UserSize(unsigned long *, unsigned long,VARIANT *); 
unsigned char * __RPC_USER VARIANT_UserMarshal(unsigned long *, unsigned char *, VARIANT *); 
unsigned char * __RPC_USER VARIANT_UserUnmarshal(unsigned long *, unsigned char *, VARIANT *); 
void __RPC_USER VARIANT_UserFree(unsigned long *, VARIANT *); 
#endif
