#ifndef __d3d8caps_h__
#define __d3d8caps_h__
#ifndef DIRECT3D_VERSION
#define DIRECT3D_VERSION 2048
#endif 
#if(DIRECT3D_VERSION >= 2048)
typedef struct _D3DCAPS8
{
D3DDEVTYPE DeviceType;
UINT AdapterOrdinal;
DWORD Caps;
DWORD Caps2;
DWORD Caps3;
DWORD PresentationIntervals;
DWORD CursorCaps;
DWORD DevCaps;
DWORD PrimitiveMiscCaps;
DWORD RasterCaps;
DWORD ZCmpCaps;
DWORD SrcBlendCaps;
DWORD DestBlendCaps;
DWORD AlphaCmpCaps;
DWORD ShadeCaps;
DWORD TextureCaps;
DWORD TextureFilterCaps; 
DWORD CubeTextureFilterCaps; 
DWORD VolumeTextureFilterCaps; 
DWORD TextureAddressCaps; 
DWORD VolumeTextureAddressCaps; 
DWORD LineCaps; 
DWORD MaxTextureWidth, MaxTextureHeight;
DWORD MaxVolumeExtent;
DWORD MaxTextureRepeat;
DWORD MaxTextureAspectRatio;
DWORD MaxAnisotropy;
float MaxVertexW;
float GuardBandLeft;
float GuardBandTop;
float GuardBandRight;
float GuardBandBottom;
float ExtentsAdjust;
DWORD StencilCaps;
DWORD FVFCaps;
DWORD TextureOpCaps;
DWORD MaxTextureBlendStages;
DWORD MaxSimultaneousTextures;
DWORD VertexProcessingCaps;
DWORD MaxActiveLights;
DWORD MaxUserClipPlanes;
DWORD MaxVertexBlendMatrices;
DWORD MaxVertexBlendMatrixIndex;
float MaxPointSize;
DWORD MaxPrimitiveCount; 
DWORD MaxVertexIndex;
DWORD MaxStreams;
DWORD MaxStreamStride; 
DWORD VertexShaderVersion;
DWORD MaxVertexShaderConst; 
DWORD PixelShaderVersion;
float MaxPixelShaderValue; 
} D3DCAPS8;
#define D3DCAPS_READ_SCANLINE 0x20000
#define D3DCAPS2_NO2DDURING3DSCENE 2
#define D3DCAPS2_FULLSCREENGAMMA 0x20000
#define D3DCAPS2_CANRENDERWINDOWED 0x80000
#define D3DCAPS2_CANCALIBRATEGAMMA 0x100000
#define D3DCAPS2_RESERVED 0x2000000
#define D3DCAPS3_RESERVED 0x8000001f
#define D3DPRESENT_INTERVAL_DEFAULT 0
#define D3DPRESENT_INTERVAL_ONE 1
#define D3DPRESENT_INTERVAL_TWO 2
#define D3DPRESENT_INTERVAL_THREE 4
#define D3DPRESENT_INTERVAL_FOUR 8
#define D3DPRESENT_INTERVAL_IMMEDIATE 0x80000000
#define D3DCURSORCAPS_COLOR 1
#define D3DCURSORCAPS_LOWRES 2
#define D3DDEVCAPS_EXECUTESYSTEMMEMORY 16
#define D3DDEVCAPS_EXECUTEVIDEOMEMORY 32
#define D3DDEVCAPS_TLVERTEXSYSTEMMEMORY 64
#define D3DDEVCAPS_TLVERTEXVIDEOMEMORY 128
#define D3DDEVCAPS_TEXTURESYSTEMMEMORY 256
#define D3DDEVCAPS_TEXTUREVIDEOMEMORY 512
#define D3DDEVCAPS_DRAWPRIMTLVERTEX 1024
#define D3DDEVCAPS_CANRENDERAFTERFLIP 2048
#define D3DDEVCAPS_TEXTURENONLOCALVIDMEM 4096
#define D3DDEVCAPS_DRAWPRIMITIVES2 0x2000
#define D3DDEVCAPS_SEPARATETEXTUREMEMORIES 0x4000
#define D3DDEVCAPS_DRAWPRIMITIVES2EX 0x8000
#define D3DDEVCAPS_HWTRANSFORMANDLIGHT 0x10000
#define D3DDEVCAPS_CANBLTSYSTONONLOCAL 0x20000
#define D3DDEVCAPS_HWRASTERIZATION 0x80000
#define D3DDEVCAPS_PUREDEVICE 0x100000
#define D3DDEVCAPS_QUINTICRTPATCHES 0x200000
#define D3DDEVCAPS_RTPATCHES 0x400000
#define D3DDEVCAPS_RTPATCHHANDLEZERO 0x800000
#define D3DDEVCAPS_NPATCHES 0x1000000
#define D3DPMISCCAPS_MASKZ 2
#define D3DPMISCCAPS_LINEPATTERNREP 4
#define D3DPMISCCAPS_CULLNONE 16
#define D3DPMISCCAPS_CULLCW 32
#define D3DPMISCCAPS_CULLCCW 64
#define D3DPMISCCAPS_COLORWRITEENABLE 128
#define D3DPMISCCAPS_CLIPPLANESCALEDPOINTS 256
#define D3DPMISCCAPS_CLIPTLVERTS 512
#define D3DPMISCCAPS_TSSARGTEMP 1024
#define D3DPMISCCAPS_BLENDOP 2048
#define D3DLINECAPS_TEXTURE 1
#define D3DLINECAPS_ZTEST 2
#define D3DLINECAPS_BLEND 4
#define D3DLINECAPS_ALPHACMP 8
#define D3DLINECAPS_FOG 16
#define D3DPRASTERCAPS_DITHER 1
#define D3DPRASTERCAPS_PAT 8
#define D3DPRASTERCAPS_ZTEST 16
#define D3DPRASTERCAPS_FOGVERTEX 128
#define D3DPRASTERCAPS_FOGTABLE 256
#define D3DPRASTERCAPS_ANTIALIASEDGES 4096
#define D3DPRASTERCAPS_MIPMAPLODBIAS 0x2000
#define D3DPRASTERCAPS_ZBIAS 0x4000
#define D3DPRASTERCAPS_ZBUFFERLESSHSR 0x8000
#define D3DPRASTERCAPS_FOGRANGE 0x10000
#define D3DPRASTERCAPS_ANISOTROPY 0x20000
#define D3DPRASTERCAPS_WBUFFER 0x40000
#define D3DPRASTERCAPS_WFOG 0x100000
#define D3DPRASTERCAPS_ZFOG 0x200000
#define D3DPRASTERCAPS_COLORPERSPECTIVE 0x400000
#define D3DPRASTERCAPS_STRETCHBLTMULTISAMPLE 0x800000
#define D3DPCMPCAPS_NEVER 1
#define D3DPCMPCAPS_LESS 2
#define D3DPCMPCAPS_EQUAL 4
#define D3DPCMPCAPS_LESSEQUAL 8
#define D3DPCMPCAPS_GREATER 16
#define D3DPCMPCAPS_NOTEQUAL 32
#define D3DPCMPCAPS_GREATEREQUAL 64
#define D3DPCMPCAPS_ALWAYS 128
#define D3DPBLENDCAPS_ZERO 1
#define D3DPBLENDCAPS_ONE 2
#define D3DPBLENDCAPS_SRCCOLOR 4
#define D3DPBLENDCAPS_INVSRCCOLOR 8
#define D3DPBLENDCAPS_SRCALPHA 16
#define D3DPBLENDCAPS_INVSRCALPHA 32
#define D3DPBLENDCAPS_DESTALPHA 64
#define D3DPBLENDCAPS_INVDESTALPHA 128
#define D3DPBLENDCAPS_DESTCOLOR 256
#define D3DPBLENDCAPS_INVDESTCOLOR 512
#define D3DPBLENDCAPS_SRCALPHASAT 1024
#define D3DPBLENDCAPS_BOTHSRCALPHA 2048
#define D3DPBLENDCAPS_BOTHINVSRCALPHA 4096
#define D3DPSHADECAPS_COLORGOURAUDRGB 8
#define D3DPSHADECAPS_SPECULARGOURAUDRGB 512
#define D3DPSHADECAPS_ALPHAGOURAUDBLEND 0x4000
#define D3DPSHADECAPS_FOGGOURAUD 0x80000
#define D3DPTEXTURECAPS_PERSPECTIVE 1
#define D3DPTEXTURECAPS_POW2 2
#define D3DPTEXTURECAPS_ALPHA 4
#define D3DPTEXTURECAPS_SQUAREONLY 32
#define D3DPTEXTURECAPS_TEXREPEATNOTSCALEDBYSIZE 64
#define D3DPTEXTURECAPS_ALPHAPALETTE 128
#define D3DPTEXTURECAPS_NONPOW2CONDITIONAL 256
#define D3DPTEXTURECAPS_PROJECTED 1024
#define D3DPTEXTURECAPS_CUBEMAP 2048
#define D3DPTEXTURECAPS_VOLUMEMAP 0x2000
#define D3DPTEXTURECAPS_MIPMAP 0x4000
#define D3DPTEXTURECAPS_MIPVOLUMEMAP 0x8000
#define D3DPTEXTURECAPS_MIPCUBEMAP 0x10000
#define D3DPTEXTURECAPS_CUBEMAP_POW2 0x20000
#define D3DPTEXTURECAPS_VOLUMEMAP_POW2 0x40000
#define D3DPTFILTERCAPS_MINFPOINT 256
#define D3DPTFILTERCAPS_MINFLINEAR 512
#define D3DPTFILTERCAPS_MINFANISOTROPIC 1024
#define D3DPTFILTERCAPS_MIPFPOINT 0x10000
#define D3DPTFILTERCAPS_MIPFLINEAR 0x20000
#define D3DPTFILTERCAPS_MAGFPOINT 0x1000000
#define D3DPTFILTERCAPS_MAGFLINEAR 0x2000000
#define D3DPTFILTERCAPS_MAGFANISOTROPIC 0x4000000
#define D3DPTFILTERCAPS_MAGFAFLATCUBIC 0x8000000
#define D3DPTFILTERCAPS_MAGFGAUSSIANCUBIC 0x10000000
#define D3DPTADDRESSCAPS_WRAP 1
#define D3DPTADDRESSCAPS_MIRROR 2
#define D3DPTADDRESSCAPS_CLAMP 4
#define D3DPTADDRESSCAPS_BORDER 8
#define D3DPTADDRESSCAPS_INDEPENDENTUV 16
#define D3DPTADDRESSCAPS_MIRRORONCE 32
#define D3DSTENCILCAPS_KEEP 1
#define D3DSTENCILCAPS_ZERO 2
#define D3DSTENCILCAPS_REPLACE 4
#define D3DSTENCILCAPS_INCRSAT 8
#define D3DSTENCILCAPS_DECRSAT 16
#define D3DSTENCILCAPS_INVERT 32
#define D3DSTENCILCAPS_INCR 64
#define D3DSTENCILCAPS_DECR 128
#define D3DTEXOPCAPS_DISABLE 1
#define D3DTEXOPCAPS_SELECTARG1 2
#define D3DTEXOPCAPS_SELECTARG2 4
#define D3DTEXOPCAPS_MODULATE 8
#define D3DTEXOPCAPS_MODULATE2X 16
#define D3DTEXOPCAPS_MODULATE4X 32
#define D3DTEXOPCAPS_ADD 64
#define D3DTEXOPCAPS_ADDSIGNED 128
#define D3DTEXOPCAPS_ADDSIGNED2X 256
#define D3DTEXOPCAPS_SUBTRACT 512
#define D3DTEXOPCAPS_ADDSMOOTH 1024
#define D3DTEXOPCAPS_BLENDDIFFUSEALPHA 2048
#define D3DTEXOPCAPS_BLENDTEXTUREALPHA 4096
#define D3DTEXOPCAPS_BLENDFACTORALPHA 0x2000
#define D3DTEXOPCAPS_BLENDTEXTUREALPHAPM 0x4000
#define D3DTEXOPCAPS_BLENDCURRENTALPHA 0x8000
#define D3DTEXOPCAPS_PREMODULATE 0x10000
#define D3DTEXOPCAPS_MODULATEALPHA_ADDCOLOR 0x20000
#define D3DTEXOPCAPS_MODULATECOLOR_ADDALPHA 0x40000
#define D3DTEXOPCAPS_MODULATEINVALPHA_ADDCOLOR 0x80000
#define D3DTEXOPCAPS_MODULATEINVCOLOR_ADDALPHA 0x100000
#define D3DTEXOPCAPS_BUMPENVMAP 0x200000
#define D3DTEXOPCAPS_BUMPENVMAPLUMINANCE 0x400000
#define D3DTEXOPCAPS_DOTPRODUCT3 0x800000
#define D3DTEXOPCAPS_MULTIPLYADD 0x1000000
#define D3DTEXOPCAPS_LERP 0x2000000
#define D3DFVFCAPS_TEXCOORDCOUNTMASK 0xffff
#define D3DFVFCAPS_DONOTSTRIPELEMENTS 0x80000
#define D3DFVFCAPS_PSIZE 0x100000
#define D3DVTXPCAPS_TEXGEN 1
#define D3DVTXPCAPS_MATERIALSOURCE7 2
#define D3DVTXPCAPS_DIRECTIONALLIGHTS 8
#define D3DVTXPCAPS_POSITIONALLIGHTS 16
#define D3DVTXPCAPS_LOCALVIEWER 32
#define D3DVTXPCAPS_TWEENING 64
#define D3DVTXPCAPS_NO_VSDT_UBYTE4 128
#endif 
#endif 
