#ifndef _D3DCAPS_H
#define _D3DCAPS_H
#include "ddraw.h"
#ifndef DIRECT3D_VERSION
#define DIRECT3D_VERSION 1792
#endif
typedef struct _D3DTRANSFORMCAPS {
DWORD dwSize;
DWORD dwCaps;
} D3DTRANSFORMCAPS, *LPD3DTRANSFORMCAPS;
#define D3DTRANSFORMCAPS_CLIP 1
typedef struct _D3DLIGHTINGCAPS {
DWORD dwSize;
DWORD dwCaps; 
DWORD dwLightingModel; 
DWORD dwNumLights; 
} D3DLIGHTINGCAPS, *LPD3DLIGHTINGCAPS;
#define D3DLIGHTINGMODEL_RGB 1
#define D3DLIGHTINGMODEL_MONO 2
#define D3DLIGHTCAPS_POINT 1
#define D3DLIGHTCAPS_SPOT 2
#define D3DLIGHTCAPS_DIRECTIONAL 4
#if(DIRECT3D_VERSION < 1792)
#define D3DLIGHTCAPS_PARALLELPOINT 8
#endif
#if(DIRECT3D_VERSION < 1280)
#define D3DLIGHTCAPS_GLSPOT 16
#endif
typedef struct _D3DPrimCaps {
DWORD dwSize;
DWORD dwMiscCaps; 
DWORD dwRasterCaps;
DWORD dwZCmpCaps;
DWORD dwSrcBlendCaps;
DWORD dwDestBlendCaps;
DWORD dwAlphaCmpCaps;
DWORD dwShadeCaps;
DWORD dwTextureCaps;
DWORD dwTextureFilterCaps;
DWORD dwTextureBlendCaps;
DWORD dwTextureAddressCaps;
DWORD dwStippleWidth; 
DWORD dwStippleHeight; 
} D3DPRIMCAPS, *LPD3DPRIMCAPS;
#define D3DPMISCCAPS_MASKPLANES 1
#define D3DPMISCCAPS_MASKZ 2
#define D3DPMISCCAPS_LINEPATTERNREP 4
#define D3DPMISCCAPS_CONFORMANT 8
#define D3DPMISCCAPS_CULLNONE 16
#define D3DPMISCCAPS_CULLCW 32
#define D3DPMISCCAPS_CULLCCW 64
#define D3DPRASTERCAPS_DITHER 1
#define D3DPRASTERCAPS_ROP2 2
#define D3DPRASTERCAPS_XOR 4
#define D3DPRASTERCAPS_PAT 8
#define D3DPRASTERCAPS_ZTEST 16
#define D3DPRASTERCAPS_SUBPIXEL 32
#define D3DPRASTERCAPS_SUBPIXELX 64
#define D3DPRASTERCAPS_FOGVERTEX 128
#define D3DPRASTERCAPS_FOGTABLE 256
#define D3DPRASTERCAPS_STIPPLE 512
#if(DIRECT3D_VERSION >= 1280)
#define D3DPRASTERCAPS_ANTIALIASSORTDEPENDENT 1024
#define D3DPRASTERCAPS_ANTIALIASSORTINDEPENDENT 2048
#define D3DPRASTERCAPS_ANTIALIASEDGES 4096
#define D3DPRASTERCAPS_MIPMAPLODBIAS 0x2000
#define D3DPRASTERCAPS_ZBIAS 0x4000
#define D3DPRASTERCAPS_ZBUFFERLESSHSR 0x8000
#define D3DPRASTERCAPS_FOGRANGE 0x10000
#define D3DPRASTERCAPS_ANISOTROPY 0x20000
#endif 
#if(DIRECT3D_VERSION >= 1536)
#define D3DPRASTERCAPS_WBUFFER 0x40000
#define D3DPRASTERCAPS_TRANSLUCENTSORTINDEPENDENT 0x80000
#define D3DPRASTERCAPS_WFOG 0x100000
#define D3DPRASTERCAPS_ZFOG 0x200000
#endif 
#define D3DPCMPCAPS_NEVER 1
#define D3DPCMPCAPS_LESS 2
#define D3DPCMPCAPS_EQUAL 4
#define D3DPCMPCAPS_LESSEQUAL 8
#define D3DPCMPCAPS_GREATER 16
#define D3DPCMPCAPS_NOTEQUAL 32
#define D3DPCMPCAPS_GREATEREQUAL 64
#define D3DPCMPCAPS_ALWAYS 128
#define D3DPBLENDCAPS_ZERO 1
#define D3DPBLENDCAPS_ONE 2
#define D3DPBLENDCAPS_SRCCOLOR 4
#define D3DPBLENDCAPS_INVSRCCOLOR 8
#define D3DPBLENDCAPS_SRCALPHA 16
#define D3DPBLENDCAPS_INVSRCALPHA 32
#define D3DPBLENDCAPS_DESTALPHA 64
#define D3DPBLENDCAPS_INVDESTALPHA 128
#define D3DPBLENDCAPS_DESTCOLOR 256
#define D3DPBLENDCAPS_INVDESTCOLOR 512
#define D3DPBLENDCAPS_SRCALPHASAT 1024
#define D3DPBLENDCAPS_BOTHSRCALPHA 2048
#define D3DPBLENDCAPS_BOTHINVSRCALPHA 4096
#define D3DPSHADECAPS_COLORFLATMONO 1
#define D3DPSHADECAPS_COLORFLATRGB 2
#define D3DPSHADECAPS_COLORGOURAUDMONO 4
#define D3DPSHADECAPS_COLORGOURAUDRGB 8
#define D3DPSHADECAPS_COLORPHONGMONO 16
#define D3DPSHADECAPS_COLORPHONGRGB 32
#define D3DPSHADECAPS_SPECULARFLATMONO 64
#define D3DPSHADECAPS_SPECULARFLATRGB 128
#define D3DPSHADECAPS_SPECULARGOURAUDMONO 256
#define D3DPSHADECAPS_SPECULARGOURAUDRGB 512
#define D3DPSHADECAPS_SPECULARPHONGMONO 1024
#define D3DPSHADECAPS_SPECULARPHONGRGB 2048
#define D3DPSHADECAPS_ALPHAFLATBLEND 4096
#define D3DPSHADECAPS_ALPHAFLATSTIPPLED 0x2000
#define D3DPSHADECAPS_ALPHAGOURAUDBLEND 0x4000
#define D3DPSHADECAPS_ALPHAGOURAUDSTIPPLED 0x8000
#define D3DPSHADECAPS_ALPHAPHONGBLEND 0x10000
#define D3DPSHADECAPS_ALPHAPHONGSTIPPLED 0x20000
#define D3DPSHADECAPS_FOGFLAT 0x40000
#define D3DPSHADECAPS_FOGGOURAUD 0x80000
#define D3DPSHADECAPS_FOGPHONG 0x100000
#define D3DPTEXTURECAPS_PERSPECTIVE 1
#define D3DPTEXTURECAPS_POW2 2
#define D3DPTEXTURECAPS_ALPHA 4
#define D3DPTEXTURECAPS_TRANSPARENCY 8
#define D3DPTEXTURECAPS_BORDER 16
#define D3DPTEXTURECAPS_SQUAREONLY 32
#if(DIRECT3D_VERSION >= 1536)
#define D3DPTEXTURECAPS_TEXREPEATNOTSCALEDBYSIZE 64
#define D3DPTEXTURECAPS_ALPHAPALETTE 128
#define D3DPTEXTURECAPS_NONPOW2CONDITIONAL 256
#endif 
#if(DIRECT3D_VERSION >= 1792)
#define D3DPTEXTURECAPS_PROJECTED 1024
#define D3DPTEXTURECAPS_CUBEMAP 2048
#define D3DPTEXTURECAPS_COLORKEYBLEND 4096
#endif 
#define D3DPTFILTERCAPS_NEAREST 1
#define D3DPTFILTERCAPS_LINEAR 2
#define D3DPTFILTERCAPS_MIPNEAREST 4
#define D3DPTFILTERCAPS_MIPLINEAR 8
#define D3DPTFILTERCAPS_LINEARMIPNEAREST 16
#define D3DPTFILTERCAPS_LINEARMIPLINEAR 32
#if(DIRECT3D_VERSION >= 1536)
#define D3DPTFILTERCAPS_MINFPOINT 256
#define D3DPTFILTERCAPS_MINFLINEAR 512
#define D3DPTFILTERCAPS_MINFANISOTROPIC 1024
#define D3DPTFILTERCAPS_MIPFPOINT 0x10000
#define D3DPTFILTERCAPS_MIPFLINEAR 0x20000
#define D3DPTFILTERCAPS_MAGFPOINT 0x1000000
#define D3DPTFILTERCAPS_MAGFLINEAR 0x2000000
#define D3DPTFILTERCAPS_MAGFANISOTROPIC 0x4000000
#define D3DPTFILTERCAPS_MAGFAFLATCUBIC 0x8000000
#define D3DPTFILTERCAPS_MAGFGAUSSIANCUBIC 0x10000000
#endif 
#define D3DPTBLENDCAPS_DECAL 1
#define D3DPTBLENDCAPS_MODULATE 2
#define D3DPTBLENDCAPS_DECALALPHA 4
#define D3DPTBLENDCAPS_MODULATEALPHA 8
#define D3DPTBLENDCAPS_DECALMASK 16
#define D3DPTBLENDCAPS_MODULATEMASK 32
#define D3DPTBLENDCAPS_COPY 64
#if(DIRECT3D_VERSION >= 1280)
#define D3DPTBLENDCAPS_ADD 128
#endif 
#define D3DPTADDRESSCAPS_WRAP 1
#define D3DPTADDRESSCAPS_MIRROR 2
#define D3DPTADDRESSCAPS_CLAMP 4
#if(DIRECT3D_VERSION >= 1280)
#define D3DPTADDRESSCAPS_BORDER 8
#define D3DPTADDRESSCAPS_INDEPENDENTUV 16
#endif 
#if(DIRECT3D_VERSION >= 1536)
#define D3DSTENCILCAPS_KEEP 1
#define D3DSTENCILCAPS_ZERO 2
#define D3DSTENCILCAPS_REPLACE 4
#define D3DSTENCILCAPS_INCRSAT 8
#define D3DSTENCILCAPS_DECRSAT 16
#define D3DSTENCILCAPS_INVERT 32
#define D3DSTENCILCAPS_INCR 64
#define D3DSTENCILCAPS_DECR 128
#define D3DTEXOPCAPS_DISABLE 1
#define D3DTEXOPCAPS_SELECTARG1 2
#define D3DTEXOPCAPS_SELECTARG2 4
#define D3DTEXOPCAPS_MODULATE 8
#define D3DTEXOPCAPS_MODULATE2X 16
#define D3DTEXOPCAPS_MODULATE4X 32
#define D3DTEXOPCAPS_ADD 64
#define D3DTEXOPCAPS_ADDSIGNED 128
#define D3DTEXOPCAPS_ADDSIGNED2X 256
#define D3DTEXOPCAPS_SUBTRACT 512
#define D3DTEXOPCAPS_ADDSMOOTH 1024
#define D3DTEXOPCAPS_BLENDDIFFUSEALPHA 2048
#define D3DTEXOPCAPS_BLENDTEXTUREALPHA 4096
#define D3DTEXOPCAPS_BLENDFACTORALPHA 0x2000
#define D3DTEXOPCAPS_BLENDTEXTUREALPHAPM 0x4000
#define D3DTEXOPCAPS_BLENDCURRENTALPHA 0x8000
#define D3DTEXOPCAPS_PREMODULATE 0x10000
#define D3DTEXOPCAPS_MODULATEALPHA_ADDCOLOR 0x20000
#define D3DTEXOPCAPS_MODULATECOLOR_ADDALPHA 0x40000
#define D3DTEXOPCAPS_MODULATEINVALPHA_ADDCOLOR 0x80000
#define D3DTEXOPCAPS_MODULATEINVCOLOR_ADDALPHA 0x100000
#define D3DTEXOPCAPS_BUMPENVMAP 0x200000
#define D3DTEXOPCAPS_BUMPENVMAPLUMINANCE 0x400000
#define D3DTEXOPCAPS_DOTPRODUCT3 0x800000
#define D3DFVFCAPS_TEXCOORDCOUNTMASK 0xffff
#define D3DFVFCAPS_DONOTSTRIPELEMENTS 0x80000
#endif 
typedef struct _D3DDeviceDesc {
DWORD dwSize; 
DWORD dwFlags; 
D3DCOLORMODEL dcmColorModel; 
DWORD dwDevCaps; 
D3DTRANSFORMCAPS dtcTransformCaps; 
BOOL bClipping; 
D3DLIGHTINGCAPS dlcLightingCaps; 
D3DPRIMCAPS dpcLineCaps;
D3DPRIMCAPS dpcTriCaps;
DWORD dwDeviceRenderBitDepth; 
DWORD dwDeviceZBufferBitDepth;
DWORD dwMaxBufferSize; 
DWORD dwMaxVertexCount; 
#if(DIRECT3D_VERSION >= 1280)
DWORD dwMinTextureWidth, dwMinTextureHeight;
DWORD dwMaxTextureWidth, dwMaxTextureHeight;
DWORD dwMinStippleWidth, dwMaxStippleWidth;
DWORD dwMinStippleHeight, dwMaxStippleHeight;
#endif 
#if(DIRECT3D_VERSION >= 1536)
DWORD dwMaxTextureRepeat;
DWORD dwMaxTextureAspectRatio;
DWORD dwMaxAnisotropy;
D3DVALUE dvGuardBandLeft;
D3DVALUE dvGuardBandTop;
D3DVALUE dvGuardBandRight;
D3DVALUE dvGuardBandBottom;
D3DVALUE dvExtentsAdjust;
DWORD dwStencilCaps;
DWORD dwFVFCaps;
DWORD dwTextureOpCaps;
WORD wMaxTextureBlendStages;
WORD wMaxSimultaneousTextures;
#endif 
} D3DDEVICEDESC, *LPD3DDEVICEDESC;
#if(DIRECT3D_VERSION >= 1792)
typedef struct _D3DDeviceDesc7 {
DWORD dwDevCaps; 
D3DPRIMCAPS dpcLineCaps;
D3DPRIMCAPS dpcTriCaps;
DWORD dwDeviceRenderBitDepth; 
DWORD dwDeviceZBufferBitDepth;
DWORD dwMinTextureWidth, dwMinTextureHeight;
DWORD dwMaxTextureWidth, dwMaxTextureHeight;
DWORD dwMaxTextureRepeat;
DWORD dwMaxTextureAspectRatio;
DWORD dwMaxAnisotropy;
D3DVALUE dvGuardBandLeft;
D3DVALUE dvGuardBandTop;
D3DVALUE dvGuardBandRight;
D3DVALUE dvGuardBandBottom;
D3DVALUE dvExtentsAdjust;
DWORD dwStencilCaps;
DWORD dwFVFCaps;
DWORD dwTextureOpCaps;
WORD wMaxTextureBlendStages;
WORD wMaxSimultaneousTextures;
DWORD dwMaxActiveLights;
D3DVALUE dvMaxVertexW;
GUID deviceGUID;
WORD wMaxUserClipPlanes;
WORD wMaxVertexBlendMatrices;
DWORD dwVertexProcessingCaps;
DWORD dwReserved1;
DWORD dwReserved2;
DWORD dwReserved3;
DWORD dwReserved4;
} D3DDEVICEDESC7, *LPD3DDEVICEDESC7;
#endif 
#define D3DDEVICEDESCSIZE (sizeof(D3DDEVICEDESC))
#define D3DDEVICEDESC7SIZE (sizeof(D3DDEVICEDESC7))
typedef HRESULT (CALLBACK * LPD3DENUMDEVICESCALLBACK)(GUID *lpGuid, LPSTR lpDeviceDescription, LPSTR lpDeviceName, LPD3DDEVICEDESC, LPD3DDEVICEDESC, LPVOID);
#if(DIRECT3D_VERSION >= 1792)
typedef HRESULT (CALLBACK * LPD3DENUMDEVICESCALLBACK7)(LPSTR lpDeviceDescription, LPSTR lpDeviceName, LPD3DDEVICEDESC7, LPVOID);
#endif 
#define D3DDD_COLORMODEL 1
#define D3DDD_DEVCAPS 2
#define D3DDD_TRANSFORMCAPS 4
#define D3DDD_LIGHTINGCAPS 8
#define D3DDD_BCLIPPING 16
#define D3DDD_LINECAPS 32
#define D3DDD_TRICAPS 64
#define D3DDD_DEVICERENDERBITDEPTH 128
#define D3DDD_DEVICEZBUFFERBITDEPTH 256
#define D3DDD_MAXBUFFERSIZE 512
#define D3DDD_MAXVERTEXCOUNT 1024
#define D3DDEVCAPS_FLOATTLVERTEX 1
#define D3DDEVCAPS_SORTINCREASINGZ 2
#define D3DDEVCAPS_SORTDECREASINGZ 0X00000004L 
#define D3DDEVCAPS_SORTEXACT 8
#define D3DDEVCAPS_EXECUTESYSTEMMEMORY 16
#define D3DDEVCAPS_EXECUTEVIDEOMEMORY 32
#define D3DDEVCAPS_TLVERTEXSYSTEMMEMORY 64
#define D3DDEVCAPS_TLVERTEXVIDEOMEMORY 128
#define D3DDEVCAPS_TEXTURESYSTEMMEMORY 256
#define D3DDEVCAPS_TEXTUREVIDEOMEMORY 512
#if(DIRECT3D_VERSION >= 1280)
#define D3DDEVCAPS_DRAWPRIMTLVERTEX 1024
#define D3DDEVCAPS_CANRENDERAFTERFLIP 2048
#define D3DDEVCAPS_TEXTURENONLOCALVIDMEM 4096
#endif 
#if(DIRECT3D_VERSION >= 1536)
#define D3DDEVCAPS_DRAWPRIMITIVES2 0x2000
#define D3DDEVCAPS_SEPARATETEXTUREMEMORIES 0x4000
#define D3DDEVCAPS_DRAWPRIMITIVES2EX 0x8000
#endif 
#if(DIRECT3D_VERSION >= 1792)
#define D3DDEVCAPS_HWTRANSFORMANDLIGHT 0x10000
#define D3DDEVCAPS_CANBLTSYSTONONLOCAL 0x20000
#define D3DDEVCAPS_HWRASTERIZATION 0x80000
#define D3DVTXPCAPS_TEXGEN 1
#define D3DVTXPCAPS_MATERIALSOURCE7 2
#define D3DVTXPCAPS_VERTEXFOG 4
#define D3DVTXPCAPS_DIRECTIONALLIGHTS 8
#define D3DVTXPCAPS_POSITIONALLIGHTS 16
#define D3DVTXPCAPS_LOCALVIEWER 32
#endif 
#define D3DFDS_COLORMODEL 1
#define D3DFDS_GUID 2
#define D3DFDS_HARDWARE 4
#define D3DFDS_TRIANGLES 8
#define D3DFDS_LINES 16
#define D3DFDS_MISCCAPS 32
#define D3DFDS_RASTERCAPS 64
#define D3DFDS_ZCMPCAPS 128
#define D3DFDS_ALPHACMPCAPS 256
#define D3DFDS_SRCBLENDCAPS 512
#define D3DFDS_DSTBLENDCAPS 1024
#define D3DFDS_SHADECAPS 2048
#define D3DFDS_TEXTURECAPS 4096
#define D3DFDS_TEXTUREFILTERCAPS 0x2000
#define D3DFDS_TEXTUREBLENDCAPS 0x4000
#define D3DFDS_TEXTUREADDRESSCAPS 0x8000
typedef struct _D3DFINDDEVICESEARCH {
DWORD dwSize;
DWORD dwFlags;
BOOL bHardware;
D3DCOLORMODEL dcmColorModel;
GUID guid;
DWORD dwCaps;
D3DPRIMCAPS dpcPrimCaps;
} D3DFINDDEVICESEARCH, *LPD3DFINDDEVICESEARCH;
typedef struct _D3DFINDDEVICERESULT {
DWORD dwSize;
GUID guid; 
D3DDEVICEDESC ddHwDesc; 
D3DDEVICEDESC ddSwDesc; 
} D3DFINDDEVICERESULT, *LPD3DFINDDEVICERESULT;
typedef struct _D3DExecuteBufferDesc {
DWORD dwSize; 
DWORD dwFlags; 
DWORD dwCaps; 
DWORD dwBufferSize; 
LPVOID lpData; 
} D3DEXECUTEBUFFERDESC, *LPD3DEXECUTEBUFFERDESC;
#define D3DDEB_BUFSIZE 1
#define D3DDEB_CAPS 2
#define D3DDEB_LPDATA 4
#define D3DDEBCAPS_SYSTEMMEMORY 1
#define D3DDEBCAPS_VIDEOMEMORY 2
#define D3DDEBCAPS_MEM (D3DDEBCAPS_SYSTEMMEMORY|D3DDEBCAPS_VIDEOMEMORY)
#if(DIRECT3D_VERSION >= 1792)
typedef struct _D3DDEVINFO_TEXTUREMANAGER {
BOOL bThrashing; 
DWORD dwApproxBytesDownloaded; 
DWORD dwNumEvicts; 
DWORD dwNumVidCreates; 
DWORD dwNumTexturesUsed; 
DWORD dwNumUsedTexInVid; 
DWORD dwWorkingSet; 
DWORD dwWorkingSetBytes; 
DWORD dwTotalManaged; 
DWORD dwTotalBytes; 
DWORD dwLastPri; 
} D3DDEVINFO_TEXTUREMANAGER, *LPD3DDEVINFO_TEXTUREMANAGER;
typedef struct _D3DDEVINFO_TEXTURING {
DWORD dwNumLoads; 
DWORD dwApproxBytesLoaded; 
DWORD dwNumPreLoads; 
DWORD dwNumSet; 
DWORD dwNumCreates; 
DWORD dwNumDestroys; 
DWORD dwNumSetPriorities; 
DWORD dwNumSetLODs; 
DWORD dwNumLocks; 
DWORD dwNumGetDCs; 
} D3DDEVINFO_TEXTURING, *LPD3DDEVINFO_TEXTURING;
#endif 
#endif 
