#ifndef _D3DRMOBJ_H_
#define _D3DRMOBJ_H_
#include <objbase.h> 
#define VIRTUAL
#include "d3drmdef.h"
#include "d3d.h"
#define IUNKNOWN_METHODS(kind) \
	STDMETHOD(QueryInterface) (THIS_ REFIID riid,LPVOID *ppvObj) kind; \
	STDMETHOD_(ULONG,AddRef) (THIS) kind; \
	STDMETHOD_(ULONG,Release) (THIS) kind
#define IDIRECT3DRMOBJECT_METHODS(kind) \
	STDMETHOD(Clone)  (THIS_ LPUNKNOWN pUnkOuter,REFIID riid,LPVOID *ppvObj) kind; \
	STDMETHOD(AddDestroyCallback) (THIS_ D3DRMOBJECTCALLBACK,LPVOID argument) kind; \
	STDMETHOD(DeleteDestroyCallback) (THIS_ D3DRMOBJECTCALLBACK,LPVOID argument) kind; \
	STDMETHOD(SetAppData) (THIS_ DWORD data) kind; \
	STDMETHOD_(DWORD,GetAppData) (THIS) kind; \
	STDMETHOD(SetName)  (THIS_ LPCSTR) kind; \
	STDMETHOD(GetName)  (THIS_ LPDWORD lpdwSize,LPSTR lpName) kind; \
	STDMETHOD(GetClassName) (THIS_ LPDWORD lpdwSize,LPSTR lpName) kind

#define WIN_TYPES(itype,ptype) typedef interface itype *LP##ptype,**LPLP##ptype

WIN_TYPES(IDirect3DRMObject,DIRECT3DRMOBJECT);
WIN_TYPES(IDirect3DRMObject2,DIRECT3DRMOBJECT2);
WIN_TYPES(IDirect3DRMDevice,DIRECT3DRMDEVICE);
WIN_TYPES(IDirect3DRMDevice2,DIRECT3DRMDEVICE2);
WIN_TYPES(IDirect3DRMDevice3,DIRECT3DRMDEVICE3);
WIN_TYPES(IDirect3DRMViewport,DIRECT3DRMVIEWPORT);
WIN_TYPES(IDirect3DRMViewport2,DIRECT3DRMVIEWPORT2);
WIN_TYPES(IDirect3DRMFrame,DIRECT3DRMFRAME);
WIN_TYPES(IDirect3DRMFrame2,DIRECT3DRMFRAME2);
WIN_TYPES(IDirect3DRMFrame3,DIRECT3DRMFRAME3);
WIN_TYPES(IDirect3DRMVisual,DIRECT3DRMVISUAL);
WIN_TYPES(IDirect3DRMMesh,DIRECT3DRMMESH);
WIN_TYPES(IDirect3DRMMeshBuilder,DIRECT3DRMMESHBUILDER);
WIN_TYPES(IDirect3DRMMeshBuilder2,DIRECT3DRMMESHBUILDER2);
WIN_TYPES(IDirect3DRMMeshBuilder3,DIRECT3DRMMESHBUILDER3);
WIN_TYPES(IDirect3DRMFace,DIRECT3DRMFACE);
WIN_TYPES(IDirect3DRMFace2,DIRECT3DRMFACE2);
WIN_TYPES(IDirect3DRMLight,DIRECT3DRMLIGHT);
WIN_TYPES(IDirect3DRMTexture,DIRECT3DRMTEXTURE);
WIN_TYPES(IDirect3DRMTexture2,DIRECT3DRMTEXTURE2);
WIN_TYPES(IDirect3DRMTexture3,DIRECT3DRMTEXTURE3);
WIN_TYPES(IDirect3DRMWrap,DIRECT3DRMWRAP);
WIN_TYPES(IDirect3DRMMaterial,DIRECT3DRMMATERIAL);
WIN_TYPES(IDirect3DRMMaterial2,DIRECT3DRMMATERIAL2);
WIN_TYPES(IDirect3DRMInterpolator,DIRECT3DRMINTERPOLATOR);
WIN_TYPES(IDirect3DRMAnimation,DIRECT3DRMANIMATION);
WIN_TYPES(IDirect3DRMAnimation2,DIRECT3DRMANIMATION2);
WIN_TYPES(IDirect3DRMAnimationSet,DIRECT3DRMANIMATIONSET);
WIN_TYPES(IDirect3DRMAnimationSet2,DIRECT3DRMANIMATIONSET2);
WIN_TYPES(IDirect3DRMUserVisual,DIRECT3DRMUSERVISUAL);
WIN_TYPES(IDirect3DRMShadow,DIRECT3DRMSHADOW);
WIN_TYPES(IDirect3DRMShadow2,DIRECT3DRMSHADOW2);
WIN_TYPES(IDirect3DRMArray,DIRECT3DRMARRAY);
WIN_TYPES(IDirect3DRMObjectArray,DIRECT3DRMOBJECTARRAY);
WIN_TYPES(IDirect3DRMDeviceArray,DIRECT3DRMDEVICEARRAY);
WIN_TYPES(IDirect3DRMFaceArray,DIRECT3DRMFACEARRAY);
WIN_TYPES(IDirect3DRMViewportArray,DIRECT3DRMVIEWPORTARRAY);
WIN_TYPES(IDirect3DRMFrameArray,DIRECT3DRMFRAMEARRAY);
WIN_TYPES(IDirect3DRMAnimationArray,DIRECT3DRMANIMATIONARRAY);
WIN_TYPES(IDirect3DRMVisualArray,DIRECT3DRMVISUALARRAY);
WIN_TYPES(IDirect3DRMPickedArray,DIRECT3DRMPICKEDARRAY);
WIN_TYPES(IDirect3DRMPicked2Array,DIRECT3DRMPICKED2ARRAY);
WIN_TYPES(IDirect3DRMLightArray,DIRECT3DRMLIGHTARRAY);
WIN_TYPES(IDirect3DRMProgressiveMesh,DIRECT3DRMPROGRESSIVEMESH);
WIN_TYPES(IDirect3DRMClippedVisual,DIRECT3DRMCLIPPEDVISUAL);
DEFINE_GUID(CLSID_CDirect3DRMDevice,0x4fa3568e,0x623f,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(CLSID_CDirect3DRMViewport,0x4fa3568f,0x623f,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(CLSID_CDirect3DRMFrame,0x4fa35690,0x623f,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(CLSID_CDirect3DRMMesh,0x4fa35691,0x623f,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(CLSID_CDirect3DRMMeshBuilder,0x4fa35692,0x623f,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(CLSID_CDirect3DRMFace,0x4fa35693,0x623f,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(CLSID_CDirect3DRMLight,0x4fa35694,0x623f,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(CLSID_CDirect3DRMTexture,0x4fa35695,0x623f,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(CLSID_CDirect3DRMWrap,0x4fa35696,0x623f,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(CLSID_CDirect3DRMMaterial,0x4fa35697,0x623f,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(CLSID_CDirect3DRMAnimation,0x4fa35698,0x623f,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(CLSID_CDirect3DRMAnimationSet,0x4fa35699,0x623f,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(CLSID_CDirect3DRMUserVisual,0x4fa3569a,0x623f,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(CLSID_CDirect3DRMShadow,0x4fa3569b,0x623f,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(CLSID_CDirect3DRMViewportInterpolator,
0xde9eaa1,0x3b84,0x11d0,0x9b,0x6d,0x0,0x0,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(CLSID_CDirect3DRMFrameInterpolator,
0xde9eaa2,0x3b84,0x11d0,0x9b,0x6d,0x0,0x0,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(CLSID_CDirect3DRMMeshInterpolator,
0xde9eaa3,0x3b84,0x11d0,0x9b,0x6d,0x0,0x0,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(CLSID_CDirect3DRMLightInterpolator,
0xde9eaa6,0x3b84,0x11d0,0x9b,0x6d,0x0,0x0,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(CLSID_CDirect3DRMMaterialInterpolator,
0xde9eaa7,0x3b84,0x11d0,0x9b,0x6d,0x0,0x0,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(CLSID_CDirect3DRMTextureInterpolator,
0xde9eaa8,0x3b84,0x11d0,0x9b,0x6d,0x0,0x0,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(CLSID_CDirect3DRMProgressiveMesh,0x4516ec40,0x8f20,0x11d0,0x9b,0x6d,0x00,0x00,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(CLSID_CDirect3DRMClippedVisual,0x5434e72d,0x6d66,0x11d1,0xbb,0xb,0x0,0x0,0xf8,0x75,0x86,0x5a);
DEFINE_GUID(IID_IDirect3DRMObject,0xeb16cb00,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMObject2,0x4516ec7c,0x8f20,0x11d0,0x9b,0x6d,0x00,0x00,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(IID_IDirect3DRMDevice,0xe9e19280,0x6e05,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMDevice2,0x4516ec78,0x8f20,0x11d0,0x9b,0x6d,0x00,0x00,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(IID_IDirect3DRMDevice3,0x549f498b,0xbfeb,0x11d1,0x8e,0xd8,0x0,0xa0,0xc9,0x67,0xa4,0x82);
DEFINE_GUID(IID_IDirect3DRMViewport,0xeb16cb02,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMViewport2,0x4a1b1be6,0xbfed,0x11d1,0x8e,0xd8,0x0,0xa0,0xc9,0x67,0xa4,0x82);
DEFINE_GUID(IID_IDirect3DRMFrame,0xeb16cb03,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMFrame2,0xc3dfbd60,0x3988,0x11d0,0x9e,0xc2,0x0,0x0,0xc0,0x29,0x1a,0xc3);
DEFINE_GUID(IID_IDirect3DRMFrame3,0xff6b7f70,0xa40e,0x11d1,0x91,0xf9,0x0,0x0,0xf8,0x75,0x8e,0x66);
DEFINE_GUID(IID_IDirect3DRMVisual,0xeb16cb04,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMMesh,0xa3a80d01,0x6e12,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMMeshBuilder,0xa3a80d02,0x6e12,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMMeshBuilder2,0x4516ec77,0x8f20,0x11d0,0x9b,0x6d,0x0,0x0,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(IID_IDirect3DRMMeshBuilder3,0x4516ec82,0x8f20,0x11d0,0x9b,0x6d,0x00,0x00,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(IID_IDirect3DRMFace,0xeb16cb07,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMFace2,0x4516ec81,0x8f20,0x11d0,0x9b,0x6d,0x00,0x00,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(IID_IDirect3DRMLight,0xeb16cb08,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMTexture,0xeb16cb09,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMTexture2,0x120f30c0,0x1629,0x11d0,0x94,0x1c,0x0,0x80,0xc8,0xc,0xfa,0x7b);
DEFINE_GUID(IID_IDirect3DRMTexture3,0xff6b7f73,0xa40e,0x11d1,0x91,0xf9,0x0,0x0,0xf8,0x75,0x8e,0x66);
DEFINE_GUID(IID_IDirect3DRMWrap,0xeb16cb0a,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMMaterial,0xeb16cb0b,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMMaterial2,0xff6b7f75,0xa40e,0x11d1,0x91,0xf9,0x0,0x0,0xf8,0x75,0x8e,0x66);
DEFINE_GUID(IID_IDirect3DRMAnimation,0xeb16cb0d,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMAnimation2,0xff6b7f77,0xa40e,0x11d1,0x91,0xf9,0x0,0x0,0xf8,0x75,0x8e,0x66);
DEFINE_GUID(IID_IDirect3DRMAnimationSet,0xeb16cb0e,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMAnimationSet2,0xff6b7f79,0xa40e,0x11d1,0x91,0xf9,0x0,0x0,0xf8,0x75,0x8e,0x66);
DEFINE_GUID(IID_IDirect3DRMObjectArray,0x242f6bc2,0x3849,0x11d0,0x9b,0x6d,0x0,0x0,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(IID_IDirect3DRMDeviceArray,0xeb16cb10,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMViewportArray,0xeb16cb11,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMFrameArray,0xeb16cb12,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMVisualArray,0xeb16cb13,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMLightArray,0xeb16cb14,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMPickedArray,0xeb16cb16,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMFaceArray,0xeb16cb17,0xd271,0x11ce,0xac,0x48,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMAnimationArray,
0xd5f1cae0,0x4bd7,0x11d1,0xb9,0x74,0x0,0x60,0x8,0x3e,0x45,0xf3);
DEFINE_GUID(IID_IDirect3DRMUserVisual,0x59163de0,0x6d43,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMShadow,0xaf359780,0x6ba3,0x11cf,0xac,0x4a,0x0,0x0,0xc0,0x38,0x25,0xa1);
DEFINE_GUID(IID_IDirect3DRMShadow2,0x86b44e25,0x9c82,0x11d1,0xbb,0xb,0x0,0xa0,0xc9,0x81,0xa0,0xa6);
DEFINE_GUID(IID_IDirect3DRMInterpolator,0x242f6bc1,0x3849,0x11d0,0x9b,0x6d,0x0,0x0,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(IID_IDirect3DRMProgressiveMesh,0x4516ec79,0x8f20,0x11d0,0x9b,0x6d,0x0,0x0,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(IID_IDirect3DRMPicked2Array,0x4516ec7b,0x8f20,0x11d0,0x9b,0x6d,0x0,0x0,0xc0,0x78,0x1b,0xc3);
DEFINE_GUID(IID_IDirect3DRMClippedVisual,0x5434e733,0x6d66,0x11d1,0xbb,0xb,0x0,0x0,0xf8,0x75,0x86,0x5a);

typedef void (__cdecl *D3DRMOBJECTCALLBACK)(LPDIRECT3DRMOBJECT obj,LPVOID arg);
typedef void (__cdecl *D3DRMFRAMEMOVECALLBACK)(LPDIRECT3DRMFRAME obj,LPVOID arg,D3DVALUE delta);
typedef void (__cdecl *D3DRMFRAME3MOVECALLBACK)(LPDIRECT3DRMFRAME3 obj,LPVOID arg,D3DVALUE delta);
typedef void (__cdecl *D3DRMUPDATECALLBACK)(LPDIRECT3DRMDEVICE obj,LPVOID arg,int,LPD3DRECT);
typedef void (__cdecl *D3DRMDEVICE3UPDATECALLBACK)(LPDIRECT3DRMDEVICE3 obj,LPVOID arg,int,LPD3DRECT);
typedef int (__cdecl *D3DRMUSERVISUALCALLBACK)
	( LPDIRECT3DRMUSERVISUAL obj,LPVOID arg,D3DRMUSERVISUALREASON reason,
	LPDIRECT3DRMDEVICE dev,LPDIRECT3DRMVIEWPORT view
	);
typedef HRESULT (__cdecl *D3DRMLOADTEXTURECALLBACK)
	(char *tex_name,void *arg,LPDIRECT3DRMTEXTURE *);
typedef HRESULT (__cdecl *D3DRMLOADTEXTURE3CALLBACK)
	(char *tex_name,void *arg,LPDIRECT3DRMTEXTURE3 *);
typedef void (__cdecl *D3DRMLOADCALLBACK)
	(LPDIRECT3DRMOBJECT object,REFIID objectguid,LPVOID arg);

typedef HRESULT (__cdecl *D3DRMDOWNSAMPLECALLBACK)
	(LPDIRECT3DRMTEXTURE3 lpDirect3DRMTexture,LPVOID pArg,
	LPDIRECTDRAWSURFACE pDDSSrc,LPDIRECTDRAWSURFACE pDDSDst);
typedef HRESULT (__cdecl *D3DRMVALIDATIONCALLBACK)
	(LPDIRECT3DRMTEXTURE3 lpDirect3DRMTexture,LPVOID pArg,
	DWORD dwFlags,DWORD dwcRects,LPRECT pRects);

typedef struct _D3DRMPICKDESC {
	ULONG ulFaceIdx; LONG lGroupIdx; D3DVECTOR vPosition;
} D3DRMPICKDESC,*LPD3DRMPICKDESC;

typedef struct _D3DRMPICKDESC2 {
	ULONG ulFaceIdx;
	LONG lGroupIdx;
	D3DVECTOR dvPosition;
	D3DVALUE tu;
	D3DVALUE tv;
	D3DVECTOR dvNormal;
	D3DCOLOR dcColor;

} D3DRMPICKDESC2,*LPD3DRMPICKDESC2;
#undef INTERFACE
#define INTERFACE IDirect3DRMObject
DECLARE_INTERFACE_(IDirect3DRMObject,IUnknown)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMObject2
DECLARE_INTERFACE_(IDirect3DRMObject2,IUnknown)
{
	IUNKNOWN_METHODS(PURE);
	STDMETHOD(AddDestroyCallback)(THIS_ D3DRMOBJECTCALLBACK lpFunc,LPVOID pvArg);
	STDMETHOD(Clone)(THIS_ LPUNKNOWN pUnkOuter,REFIID riid,LPVOID *ppvObj); \
	STDMETHOD(DeleteDestroyCallback)(THIS_ D3DRMOBJECTCALLBACK lpFunc,LPVOID pvArg); \
	STDMETHOD(GetClientData)(THIS_ DWORD dwID,LPVOID* lplpvData);
	STDMETHOD(GetDirect3DRM)(THIS_ LPDIRECT3DRM* lplpDirect3DRM);
	STDMETHOD(GetName)(THIS_ LPDWORD lpdwSize,LPSTR lpName);
	STDMETHOD(SetClientData)(THIS_ DWORD dwID,LPVOID lpvData,DWORD dwFlags);
	STDMETHOD(SetName)(THIS_ LPCSTR lpName);
	STDMETHOD(GetAge)(THIS_ DWORD dwFlags,LPDWORD pdwAge);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMVisual

DECLARE_INTERFACE_(IDirect3DRMVisual,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMDevice

DECLARE_INTERFACE_(IDirect3DRMDevice,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(Init)(THIS_ ULONG width,ULONG height);
	STDMETHOD(InitFromD3D)(THIS_ LPDIRECT3D lpD3D,LPDIRECT3DDEVICE lpD3DDev);
	STDMETHOD(InitFromClipper)(THIS_ LPDIRECTDRAWCLIPPER lpDDClipper,LPGUID lpGUID,int width,int height);
	STDMETHOD(Update)(THIS);
	STDMETHOD(AddUpdateCallback)(THIS_ D3DRMUPDATECALLBACK,LPVOID arg);
	STDMETHOD(DeleteUpdateCallback)(THIS_ D3DRMUPDATECALLBACK,LPVOID arg);
	STDMETHOD(SetBufferCount)(THIS_ DWORD);
	STDMETHOD_(DWORD,GetBufferCount)(THIS);

	STDMETHOD(SetDither)(THIS_ BOOL);
	STDMETHOD(SetShades)(THIS_ DWORD);
	STDMETHOD(SetQuality)(THIS_ D3DRMRENDERQUALITY);
	STDMETHOD(SetTextureQuality)(THIS_ D3DRMTEXTUREQUALITY);

	STDMETHOD(GetViewports)(THIS_ LPDIRECT3DRMVIEWPORTARRAY *return_views);

	STDMETHOD_(BOOL,GetDither)(THIS);
	STDMETHOD_(DWORD,GetShades)(THIS);
	STDMETHOD_(DWORD,GetHeight)(THIS);
	STDMETHOD_(DWORD,GetWidth)(THIS);
	STDMETHOD_(DWORD,GetTrianglesDrawn)(THIS);
	STDMETHOD_(DWORD,GetWireframeOptions)(THIS);
	STDMETHOD_(D3DRMRENDERQUALITY,GetQuality)(THIS);
	STDMETHOD_(D3DCOLORMODEL,GetColorModel)(THIS);
	STDMETHOD_(D3DRMTEXTUREQUALITY,GetTextureQuality)(THIS);
	STDMETHOD(GetDirect3DDevice)(THIS_ LPDIRECT3DDEVICE *);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMDevice2

DECLARE_INTERFACE_(IDirect3DRMDevice2,IDirect3DRMDevice)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(Init)(THIS_ ULONG width,ULONG height);
	STDMETHOD(InitFromD3D)(THIS_ LPDIRECT3D lpD3D,LPDIRECT3DDEVICE lpD3DDev);
	STDMETHOD(InitFromClipper)(THIS_ LPDIRECTDRAWCLIPPER lpDDClipper,LPGUID lpGUID,int width,int height);
	STDMETHOD(Update)(THIS);
	STDMETHOD(AddUpdateCallback)(THIS_ D3DRMUPDATECALLBACK,LPVOID arg);
	STDMETHOD(DeleteUpdateCallback)(THIS_ D3DRMUPDATECALLBACK,LPVOID arg);
	STDMETHOD(SetBufferCount)(THIS_ DWORD);
	STDMETHOD_(DWORD,GetBufferCount)(THIS);
	STDMETHOD(SetDither)(THIS_ BOOL);
	STDMETHOD(SetShades)(THIS_ DWORD);
	STDMETHOD(SetQuality)(THIS_ D3DRMRENDERQUALITY);
	STDMETHOD(SetTextureQuality)(THIS_ D3DRMTEXTUREQUALITY);
	STDMETHOD(GetViewports)(THIS_ LPDIRECT3DRMVIEWPORTARRAY *return_views);
	STDMETHOD_(BOOL,GetDither)(THIS);
	STDMETHOD_(DWORD,GetShades)(THIS);
	STDMETHOD_(DWORD,GetHeight)(THIS);
	STDMETHOD_(DWORD,GetWidth)(THIS);
	STDMETHOD_(DWORD,GetTrianglesDrawn)(THIS);
	STDMETHOD_(DWORD,GetWireframeOptions)(THIS);
	STDMETHOD_(D3DRMRENDERQUALITY,GetQuality)(THIS);
	STDMETHOD_(D3DCOLORMODEL,GetColorModel)(THIS);
	STDMETHOD_(D3DRMTEXTUREQUALITY,GetTextureQuality)(THIS);
	STDMETHOD(GetDirect3DDevice)(THIS_ LPDIRECT3DDEVICE *);
	STDMETHOD(InitFromD3D2)(THIS_ LPDIRECT3D2 lpD3D,LPDIRECT3DDEVICE2 lpD3DDev);
	STDMETHOD(InitFromSurface)(THIS_ LPGUID lpGUID,LPDIRECTDRAW lpDD,LPDIRECTDRAWSURFACE lpDDSBack);
	STDMETHOD(SetRenderMode)(THIS_ DWORD dwFlags);
	STDMETHOD_(DWORD,GetRenderMode)(THIS);
	STDMETHOD(GetDirect3DDevice2)(THIS_ LPDIRECT3DDEVICE2 *);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMDevice3

DECLARE_INTERFACE_(IDirect3DRMDevice3,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(Init)(THIS_ ULONG width,ULONG height);
	STDMETHOD(InitFromD3D)(THIS_ LPDIRECT3D lpD3D,LPDIRECT3DDEVICE lpD3DDev);
	STDMETHOD(InitFromClipper)(THIS_ LPDIRECTDRAWCLIPPER lpDDClipper,LPGUID lpGUID,int width,int height);

	STDMETHOD(Update)(THIS);
	STDMETHOD(AddUpdateCallback)(THIS_ D3DRMDEVICE3UPDATECALLBACK,LPVOID arg);
	STDMETHOD(DeleteUpdateCallback)(THIS_ D3DRMDEVICE3UPDATECALLBACK,LPVOID arg);
	STDMETHOD(SetBufferCount)(THIS_ DWORD);
	STDMETHOD_(DWORD,GetBufferCount)(THIS);

	STDMETHOD(SetDither)(THIS_ BOOL);
	STDMETHOD(SetShades)(THIS_ DWORD);
	STDMETHOD(SetQuality)(THIS_ D3DRMRENDERQUALITY);
	STDMETHOD(SetTextureQuality)(THIS_ D3DRMTEXTUREQUALITY);

	STDMETHOD(GetViewports)(THIS_ LPDIRECT3DRMVIEWPORTARRAY *return_views);

	STDMETHOD_(BOOL,GetDither)(THIS);
	STDMETHOD_(DWORD,GetShades)(THIS);
	STDMETHOD_(DWORD,GetHeight)(THIS);
	STDMETHOD_(DWORD,GetWidth)(THIS);
	STDMETHOD_(DWORD,GetTrianglesDrawn)(THIS);
	STDMETHOD_(DWORD,GetWireframeOptions)(THIS);
	STDMETHOD_(D3DRMRENDERQUALITY,GetQuality)(THIS);
	STDMETHOD_(D3DCOLORMODEL,GetColorModel)(THIS);
	STDMETHOD_(D3DRMTEXTUREQUALITY,GetTextureQuality)(THIS);
	STDMETHOD(GetDirect3DDevice)(THIS_ LPDIRECT3DDEVICE *);
	STDMETHOD(InitFromD3D2)(THIS_ LPDIRECT3D2 lpD3D,LPDIRECT3DDEVICE2 lpD3DDev);
	STDMETHOD(InitFromSurface)(THIS_ LPGUID lpGUID,LPDIRECTDRAW lpDD,LPDIRECTDRAWSURFACE lpDDSBack,DWORD dwFlags);
	STDMETHOD(SetRenderMode)(THIS_ DWORD dwFlags);
	STDMETHOD_(DWORD,GetRenderMode)(THIS);
	STDMETHOD(GetDirect3DDevice2)(THIS_ LPDIRECT3DDEVICE2 *);
	STDMETHOD(FindPreferredTextureFormat)(THIS_ DWORD dwBitDepths,DWORD dwFlags,LPDDPIXELFORMAT lpDDPF);
	STDMETHOD(RenderStateChange)(THIS_ D3DRENDERSTATETYPE drsType,DWORD dwVal,DWORD dwFlags);
	STDMETHOD(LightStateChange)(THIS_ D3DLIGHTSTATETYPE drsType,DWORD dwVal,DWORD dwFlags);
	STDMETHOD(GetStateChangeOptions)(THIS_ DWORD dwStateClass,DWORD dwStateNum,LPDWORD pdwFlags);
	STDMETHOD(SetStateChangeOptions)(THIS_ DWORD dwStateClass,DWORD dwStateNum,DWORD dwFlags);
};


#undef INTERFACE
#define INTERFACE IDirect3DRMViewport

DECLARE_INTERFACE_(IDirect3DRMViewport,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(Init)
	( THIS_ LPDIRECT3DRMDEVICE dev,LPDIRECT3DRMFRAME camera,
	DWORD xpos,DWORD ypos,DWORD width,DWORD height
	);
	STDMETHOD(Clear)(THIS);
	STDMETHOD(Render)(THIS_ LPDIRECT3DRMFRAME);

	STDMETHOD(SetFront)(THIS_ D3DVALUE);
	STDMETHOD(SetBack)(THIS_ D3DVALUE);
	STDMETHOD(SetField)(THIS_ D3DVALUE);
	STDMETHOD(SetUniformScaling)(THIS_ BOOL);
	STDMETHOD(SetCamera)(THIS_ LPDIRECT3DRMFRAME);
	STDMETHOD(SetProjection)(THIS_ D3DRMPROJECTIONTYPE);
	STDMETHOD(Transform)(THIS_ D3DRMVECTOR4D *d,D3DVECTOR *s);
	STDMETHOD(InverseTransform)(THIS_ D3DVECTOR *d,D3DRMVECTOR4D *s);
	STDMETHOD(Configure)(THIS_ LONG x,LONG y,DWORD width,DWORD height);
	STDMETHOD(ForceUpdate)(THIS_ DWORD x1,DWORD y1,DWORD x2,DWORD y2);
	STDMETHOD(SetPlane)(THIS_ D3DVALUE left,D3DVALUE right,D3DVALUE bottom,D3DVALUE top);

	STDMETHOD(GetCamera)(THIS_ LPDIRECT3DRMFRAME *);
	STDMETHOD(GetDevice)(THIS_ LPDIRECT3DRMDEVICE *);
	STDMETHOD(GetPlane)(THIS_ D3DVALUE *left,D3DVALUE *right,D3DVALUE *bottom,D3DVALUE *top);
	STDMETHOD(Pick)(THIS_ LONG x,LONG y,LPDIRECT3DRMPICKEDARRAY *return_visuals);

	STDMETHOD_(BOOL,GetUniformScaling)(THIS);
	STDMETHOD_(LONG,GetX)(THIS);
	STDMETHOD_(LONG,GetY)(THIS);
	STDMETHOD_(DWORD,GetWidth)(THIS);
	STDMETHOD_(DWORD,GetHeight)(THIS);
	STDMETHOD_(D3DVALUE,GetField)(THIS);
	STDMETHOD_(D3DVALUE,GetBack)(THIS);
	STDMETHOD_(D3DVALUE,GetFront)(THIS);
	STDMETHOD_(D3DRMPROJECTIONTYPE,GetProjection)(THIS);
	STDMETHOD(GetDirect3DViewport)(THIS_ LPDIRECT3DVIEWPORT *);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMViewport2
DECLARE_INTERFACE_(IDirect3DRMViewport2,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(Init)
	( THIS_ LPDIRECT3DRMDEVICE3 dev,LPDIRECT3DRMFRAME3 camera,
	DWORD xpos,DWORD ypos,DWORD width,DWORD height
	);
	STDMETHOD(Clear)(THIS_ DWORD dwFlags);
	STDMETHOD(Render)(THIS_ LPDIRECT3DRMFRAME3);

	STDMETHOD(SetFront)(THIS_ D3DVALUE);
	STDMETHOD(SetBack)(THIS_ D3DVALUE);
	STDMETHOD(SetField)(THIS_ D3DVALUE);
	STDMETHOD(SetUniformScaling)(THIS_ BOOL);
	STDMETHOD(SetCamera)(THIS_ LPDIRECT3DRMFRAME3);
	STDMETHOD(SetProjection)(THIS_ D3DRMPROJECTIONTYPE);
	STDMETHOD(Transform)(THIS_ D3DRMVECTOR4D *d,D3DVECTOR *s);
	STDMETHOD(InverseTransform)(THIS_ D3DVECTOR *d,D3DRMVECTOR4D *s);
	STDMETHOD(Configure)(THIS_ LONG x,LONG y,DWORD width,DWORD height);
	STDMETHOD(ForceUpdate)(THIS_ DWORD x1,DWORD y1,DWORD x2,DWORD y2);
	STDMETHOD(SetPlane)(THIS_ D3DVALUE left,D3DVALUE right,D3DVALUE bottom,D3DVALUE top);

	STDMETHOD(GetCamera)(THIS_ LPDIRECT3DRMFRAME3 *);
	STDMETHOD(GetDevice)(THIS_ LPDIRECT3DRMDEVICE3 *);
	STDMETHOD(GetPlane)(THIS_ D3DVALUE *left,D3DVALUE *right,D3DVALUE *bottom,D3DVALUE *top);
	STDMETHOD(Pick)(THIS_ LONG x,LONG y,LPDIRECT3DRMPICKEDARRAY *return_visuals);

	STDMETHOD_(BOOL,GetUniformScaling)(THIS);
	STDMETHOD_(LONG,GetX)(THIS);
	STDMETHOD_(LONG,GetY)(THIS);
	STDMETHOD_(DWORD,GetWidth)(THIS);
	STDMETHOD_(DWORD,GetHeight)(THIS);
	STDMETHOD_(D3DVALUE,GetField)(THIS);
	STDMETHOD_(D3DVALUE,GetBack)(THIS);
	STDMETHOD_(D3DVALUE,GetFront)(THIS);
	STDMETHOD_(D3DRMPROJECTIONTYPE,GetProjection)(THIS);
	STDMETHOD(GetDirect3DViewport)(THIS_ LPDIRECT3DVIEWPORT *);
	STDMETHOD(TransformVectors)(THIS_ DWORD dwNumVectors,
	 LPD3DRMVECTOR4D lpDstVectors,
	 LPD3DVECTOR lpSrcVectors);
	STDMETHOD(InverseTransformVectors)(THIS_ DWORD dwNumVectors,
	  LPD3DVECTOR lpDstVectors,
	  LPD3DRMVECTOR4D lpSrcVectors);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMFrame

DECLARE_INTERFACE_(IDirect3DRMFrame,IDirect3DRMVisual)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(AddChild)(THIS_ LPDIRECT3DRMFRAME child);
	STDMETHOD(AddLight)(THIS_ LPDIRECT3DRMLIGHT);
	STDMETHOD(AddMoveCallback)(THIS_ D3DRMFRAMEMOVECALLBACK,VOID *arg);
	STDMETHOD(AddTransform)(THIS_ D3DRMCOMBINETYPE,D3DRMMATRIX4D);
	STDMETHOD(AddTranslation)(THIS_ D3DRMCOMBINETYPE,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(AddScale)(THIS_ D3DRMCOMBINETYPE,D3DVALUE sx,D3DVALUE sy,D3DVALUE sz);
	STDMETHOD(AddRotation)(THIS_ D3DRMCOMBINETYPE,D3DVALUE x,D3DVALUE y,D3DVALUE z,D3DVALUE theta);
	STDMETHOD(AddVisual)(THIS_ LPDIRECT3DRMVISUAL);
	STDMETHOD(GetChildren)(THIS_ LPDIRECT3DRMFRAMEARRAY *children);
	STDMETHOD_(D3DCOLOR,GetColor)(THIS);
	STDMETHOD(GetLights)(THIS_ LPDIRECT3DRMLIGHTARRAY *lights);
	STDMETHOD_(D3DRMMATERIALMODE,GetMaterialMode)(THIS);
	STDMETHOD(GetParent)(THIS_ LPDIRECT3DRMFRAME *);
	STDMETHOD(GetPosition)(THIS_ LPDIRECT3DRMFRAME reference,LPD3DVECTOR return_position);
	STDMETHOD(GetRotation)(THIS_ LPDIRECT3DRMFRAME reference,LPD3DVECTOR axis,LPD3DVALUE return_theta);
	STDMETHOD(GetScene)(THIS_ LPDIRECT3DRMFRAME *);
	STDMETHOD_(D3DRMSORTMODE,GetSortMode)(THIS);
	STDMETHOD(GetTexture)(THIS_ LPDIRECT3DRMTEXTURE *);
	STDMETHOD(GetTransform)(THIS_ D3DRMMATRIX4D return_matrix);
	STDMETHOD(GetVelocity)(THIS_ LPDIRECT3DRMFRAME reference,LPD3DVECTOR return_velocity,BOOL with_rotation);
	STDMETHOD(GetOrientation)(THIS_ LPDIRECT3DRMFRAME reference,LPD3DVECTOR dir,LPD3DVECTOR up);
	STDMETHOD(GetVisuals)(THIS_ LPDIRECT3DRMVISUALARRAY *visuals);
	STDMETHOD(GetTextureTopology)(THIS_ BOOL *wrap_u,BOOL *wrap_v);
	STDMETHOD(InverseTransform)(THIS_ D3DVECTOR *d,D3DVECTOR *s);
	STDMETHOD(Load)(THIS_ LPVOID filename,LPVOID name,D3DRMLOADOPTIONS loadflags,D3DRMLOADTEXTURECALLBACK,LPVOID lpArg);
	STDMETHOD(LookAt)(THIS_ LPDIRECT3DRMFRAME target,LPDIRECT3DRMFRAME reference,D3DRMFRAMECONSTRAINT);
	STDMETHOD(Move)(THIS_ D3DVALUE delta);
	STDMETHOD(DeleteChild)(THIS_ LPDIRECT3DRMFRAME);
	STDMETHOD(DeleteLight)(THIS_ LPDIRECT3DRMLIGHT);
	STDMETHOD(DeleteMoveCallback)(THIS_ D3DRMFRAMEMOVECALLBACK,VOID *arg);
	STDMETHOD(DeleteVisual)(THIS_ LPDIRECT3DRMVISUAL);
	STDMETHOD_(D3DCOLOR,GetSceneBackground)(THIS);
	STDMETHOD(GetSceneBackgroundDepth)(THIS_ LPDIRECTDRAWSURFACE *);
	STDMETHOD_(D3DCOLOR,GetSceneFogColor)(THIS);
	STDMETHOD_(BOOL,GetSceneFogEnable)(THIS);
	STDMETHOD_(D3DRMFOGMODE,GetSceneFogMode)(THIS);
	STDMETHOD(GetSceneFogParams)(THIS_ D3DVALUE *return_start,D3DVALUE *return_end,D3DVALUE *return_density);
	STDMETHOD(SetSceneBackground)(THIS_ D3DCOLOR);
	STDMETHOD(SetSceneBackgroundRGB)(THIS_ D3DVALUE red,D3DVALUE green,D3DVALUE blue);
	STDMETHOD(SetSceneBackgroundDepth)(THIS_ LPDIRECTDRAWSURFACE);
	STDMETHOD(SetSceneBackgroundImage)(THIS_ LPDIRECT3DRMTEXTURE);
	STDMETHOD(SetSceneFogEnable)(THIS_ BOOL);
	STDMETHOD(SetSceneFogColor)(THIS_ D3DCOLOR);
	STDMETHOD(SetSceneFogMode)(THIS_ D3DRMFOGMODE);
	STDMETHOD(SetSceneFogParams)(THIS_ D3DVALUE start,D3DVALUE end,D3DVALUE density);
	STDMETHOD(SetColor)(THIS_ D3DCOLOR);
	STDMETHOD(SetColorRGB)(THIS_ D3DVALUE red,D3DVALUE green,D3DVALUE blue);
	STDMETHOD_(D3DRMZBUFFERMODE,GetZbufferMode)(THIS);
	STDMETHOD(SetMaterialMode)(THIS_ D3DRMMATERIALMODE);
	STDMETHOD(SetOrientation)
	( THIS_ LPDIRECT3DRMFRAME reference,
	D3DVALUE dx,D3DVALUE dy,D3DVALUE dz,
	D3DVALUE ux,D3DVALUE uy,D3DVALUE uz
	);
	STDMETHOD(SetPosition)(THIS_ LPDIRECT3DRMFRAME reference,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(SetRotation)(THIS_ LPDIRECT3DRMFRAME reference,D3DVALUE x,D3DVALUE y,D3DVALUE z,D3DVALUE theta);
	STDMETHOD(SetSortMode)(THIS_ D3DRMSORTMODE);
	STDMETHOD(SetTexture)(THIS_ LPDIRECT3DRMTEXTURE);
	STDMETHOD(SetTextureTopology)(THIS_ BOOL wrap_u,BOOL wrap_v);
	STDMETHOD(SetVelocity)(THIS_ LPDIRECT3DRMFRAME reference,D3DVALUE x,D3DVALUE y,D3DVALUE z,BOOL with_rotation);
	STDMETHOD(SetZbufferMode)(THIS_ D3DRMZBUFFERMODE);
	STDMETHOD(Transform)(THIS_ D3DVECTOR *d,D3DVECTOR *s);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMFrame2

DECLARE_INTERFACE_(IDirect3DRMFrame2,IDirect3DRMFrame)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(AddChild)(THIS_ LPDIRECT3DRMFRAME child);
	STDMETHOD(AddLight)(THIS_ LPDIRECT3DRMLIGHT);
	STDMETHOD(AddMoveCallback)(THIS_ D3DRMFRAMEMOVECALLBACK,VOID *arg);
	STDMETHOD(AddTransform)(THIS_ D3DRMCOMBINETYPE,D3DRMMATRIX4D);
	STDMETHOD(AddTranslation)(THIS_ D3DRMCOMBINETYPE,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(AddScale)(THIS_ D3DRMCOMBINETYPE,D3DVALUE sx,D3DVALUE sy,D3DVALUE sz);
	STDMETHOD(AddRotation)(THIS_ D3DRMCOMBINETYPE,D3DVALUE x,D3DVALUE y,D3DVALUE z,D3DVALUE theta);
	STDMETHOD(AddVisual)(THIS_ LPDIRECT3DRMVISUAL);
	STDMETHOD(GetChildren)(THIS_ LPDIRECT3DRMFRAMEARRAY *children);
	STDMETHOD_(D3DCOLOR,GetColor)(THIS);
	STDMETHOD(GetLights)(THIS_ LPDIRECT3DRMLIGHTARRAY *lights);
	STDMETHOD_(D3DRMMATERIALMODE,GetMaterialMode)(THIS);
	STDMETHOD(GetParent)(THIS_ LPDIRECT3DRMFRAME *);
	STDMETHOD(GetPosition)(THIS_ LPDIRECT3DRMFRAME reference,LPD3DVECTOR return_position);
	STDMETHOD(GetRotation)(THIS_ LPDIRECT3DRMFRAME reference,LPD3DVECTOR axis,LPD3DVALUE return_theta);
	STDMETHOD(GetScene)(THIS_ LPDIRECT3DRMFRAME *);
	STDMETHOD_(D3DRMSORTMODE,GetSortMode)(THIS);
	STDMETHOD(GetTexture)(THIS_ LPDIRECT3DRMTEXTURE *);
	STDMETHOD(GetTransform)(THIS_ D3DRMMATRIX4D return_matrix);
	STDMETHOD(GetVelocity)(THIS_ LPDIRECT3DRMFRAME reference,LPD3DVECTOR return_velocity,BOOL with_rotation);
	STDMETHOD(GetOrientation)(THIS_ LPDIRECT3DRMFRAME reference,LPD3DVECTOR dir,LPD3DVECTOR up);
	STDMETHOD(GetVisuals)(THIS_ LPDIRECT3DRMVISUALARRAY *visuals);
	STDMETHOD(GetTextureTopology)(THIS_ BOOL *wrap_u,BOOL *wrap_v);
	STDMETHOD(InverseTransform)(THIS_ D3DVECTOR *d,D3DVECTOR *s);
	STDMETHOD(Load)(THIS_ LPVOID filename,LPVOID name,D3DRMLOADOPTIONS loadflags,D3DRMLOADTEXTURECALLBACK,LPVOID lpArg);
	STDMETHOD(LookAt)(THIS_ LPDIRECT3DRMFRAME target,LPDIRECT3DRMFRAME reference,D3DRMFRAMECONSTRAINT);
	STDMETHOD(Move)(THIS_ D3DVALUE delta);
	STDMETHOD(DeleteChild)(THIS_ LPDIRECT3DRMFRAME);
	STDMETHOD(DeleteLight)(THIS_ LPDIRECT3DRMLIGHT);
	STDMETHOD(DeleteMoveCallback)(THIS_ D3DRMFRAMEMOVECALLBACK,VOID *arg);
	STDMETHOD(DeleteVisual)(THIS_ LPDIRECT3DRMVISUAL);
	STDMETHOD_(D3DCOLOR,GetSceneBackground)(THIS);
	STDMETHOD(GetSceneBackgroundDepth)(THIS_ LPDIRECTDRAWSURFACE *);
	STDMETHOD_(D3DCOLOR,GetSceneFogColor)(THIS);
	STDMETHOD_(BOOL,GetSceneFogEnable)(THIS);
	STDMETHOD_(D3DRMFOGMODE,GetSceneFogMode)(THIS);
	STDMETHOD(GetSceneFogParams)(THIS_ D3DVALUE *return_start,D3DVALUE *return_end,D3DVALUE *return_density);
	STDMETHOD(SetSceneBackground)(THIS_ D3DCOLOR);
	STDMETHOD(SetSceneBackgroundRGB)(THIS_ D3DVALUE red,D3DVALUE green,D3DVALUE blue);
	STDMETHOD(SetSceneBackgroundDepth)(THIS_ LPDIRECTDRAWSURFACE);
	STDMETHOD(SetSceneBackgroundImage)(THIS_ LPDIRECT3DRMTEXTURE);
	STDMETHOD(SetSceneFogEnable)(THIS_ BOOL);
	STDMETHOD(SetSceneFogColor)(THIS_ D3DCOLOR);
	STDMETHOD(SetSceneFogMode)(THIS_ D3DRMFOGMODE);
	STDMETHOD(SetSceneFogParams)(THIS_ D3DVALUE start,D3DVALUE end,D3DVALUE density);
	STDMETHOD(SetColor)(THIS_ D3DCOLOR);
	STDMETHOD(SetColorRGB)(THIS_ D3DVALUE red,D3DVALUE green,D3DVALUE blue);
	STDMETHOD_(D3DRMZBUFFERMODE,GetZbufferMode)(THIS);
	STDMETHOD(SetMaterialMode)(THIS_ D3DRMMATERIALMODE);
	STDMETHOD(SetOrientation)
	( THIS_ LPDIRECT3DRMFRAME reference,
	D3DVALUE dx,D3DVALUE dy,D3DVALUE dz,
	D3DVALUE ux,D3DVALUE uy,D3DVALUE uz
	);
	STDMETHOD(SetPosition)(THIS_ LPDIRECT3DRMFRAME reference,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(SetRotation)(THIS_ LPDIRECT3DRMFRAME reference,D3DVALUE x,D3DVALUE y,D3DVALUE z,D3DVALUE theta);
	STDMETHOD(SetSortMode)(THIS_ D3DRMSORTMODE);
	STDMETHOD(SetTexture)(THIS_ LPDIRECT3DRMTEXTURE);
	STDMETHOD(SetTextureTopology)(THIS_ BOOL wrap_u,BOOL wrap_v);
	STDMETHOD(SetVelocity)(THIS_ LPDIRECT3DRMFRAME reference,D3DVALUE x,D3DVALUE y,D3DVALUE z,BOOL with_rotation);
	STDMETHOD(SetZbufferMode)(THIS_ D3DRMZBUFFERMODE);
	STDMETHOD(Transform)(THIS_ D3DVECTOR *d,D3DVECTOR *s);
	STDMETHOD(AddMoveCallback2)(THIS_ D3DRMFRAMEMOVECALLBACK,VOID *arg,DWORD dwFlags);
	STDMETHOD(GetBox)(THIS_ LPD3DRMBOX);
	STDMETHOD_(BOOL,GetBoxEnable)(THIS);
	STDMETHOD(GetAxes)(THIS_ LPD3DVECTOR dir,LPD3DVECTOR up);
	STDMETHOD(GetMaterial)(THIS_ LPDIRECT3DRMMATERIAL *);
	STDMETHOD_(BOOL,GetInheritAxes)(THIS);
	STDMETHOD(GetHierarchyBox)(THIS_ LPD3DRMBOX);

	STDMETHOD(SetBox)(THIS_ LPD3DRMBOX);
	STDMETHOD(SetBoxEnable)(THIS_ BOOL);
	STDMETHOD(SetAxes)(THIS_ D3DVALUE dx,D3DVALUE dy,D3DVALUE dz,
	 D3DVALUE ux,D3DVALUE uy,D3DVALUE uz);
	STDMETHOD(SetInheritAxes)(THIS_ BOOL inherit_from_parent);
	STDMETHOD(SetMaterial)(THIS_ LPDIRECT3DRMMATERIAL);
	STDMETHOD(SetQuaternion)(THIS_ LPDIRECT3DRMFRAME reference,D3DRMQUATERNION *q);

	STDMETHOD(RayPick)(THIS_ LPDIRECT3DRMFRAME reference,LPD3DRMRAY ray,DWORD dwFlags,LPDIRECT3DRMPICKED2ARRAY *return_visuals);
	STDMETHOD(Save)(THIS_ LPCSTR filename,D3DRMXOFFORMAT d3dFormat,
	 D3DRMSAVEOPTIONS d3dSaveFlags);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMFrame3

DECLARE_INTERFACE_(IDirect3DRMFrame3,IDirect3DRMVisual)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(AddChild)(THIS_ LPDIRECT3DRMFRAME3 child);
	STDMETHOD(AddLight)(THIS_ LPDIRECT3DRMLIGHT);
	STDMETHOD(AddMoveCallback)(THIS_ D3DRMFRAME3MOVECALLBACK,VOID *arg,DWORD dwFlags);
	STDMETHOD(AddTransform)(THIS_ D3DRMCOMBINETYPE,D3DRMMATRIX4D);
	STDMETHOD(AddTranslation)(THIS_ D3DRMCOMBINETYPE,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(AddScale)(THIS_ D3DRMCOMBINETYPE,D3DVALUE sx,D3DVALUE sy,D3DVALUE sz);
	STDMETHOD(AddRotation)(THIS_ D3DRMCOMBINETYPE,D3DVALUE x,D3DVALUE y,D3DVALUE z,D3DVALUE theta);
	STDMETHOD(AddVisual)(THIS_ LPUNKNOWN);
	STDMETHOD(GetChildren)(THIS_ LPDIRECT3DRMFRAMEARRAY *children);
	STDMETHOD_(D3DCOLOR,GetColor)(THIS);
	STDMETHOD(GetLights)(THIS_ LPDIRECT3DRMLIGHTARRAY *lights);
	STDMETHOD_(D3DRMMATERIALMODE,GetMaterialMode)(THIS);
	STDMETHOD(GetParent)(THIS_ LPDIRECT3DRMFRAME3 *);
	STDMETHOD(GetPosition)(THIS_ LPDIRECT3DRMFRAME3 reference,LPD3DVECTOR return_position);
	STDMETHOD(GetRotation)(THIS_ LPDIRECT3DRMFRAME3 reference,LPD3DVECTOR axis,LPD3DVALUE return_theta);
	STDMETHOD(GetScene)(THIS_ LPDIRECT3DRMFRAME3 *);
	STDMETHOD_(D3DRMSORTMODE,GetSortMode)(THIS);
	STDMETHOD(GetTexture)(THIS_ LPDIRECT3DRMTEXTURE3 *);
	STDMETHOD(GetTransform)(THIS_ LPDIRECT3DRMFRAME3 reference,
	 D3DRMMATRIX4D rmMatrix);
	STDMETHOD(GetVelocity)(THIS_ LPDIRECT3DRMFRAME3 reference,LPD3DVECTOR return_velocity,BOOL with_rotation);
	STDMETHOD(GetOrientation)(THIS_ LPDIRECT3DRMFRAME3 reference,LPD3DVECTOR dir,LPD3DVECTOR up);
	STDMETHOD(GetVisuals)(THIS_ LPDWORD lpdwCount,LPUNKNOWN *);
	STDMETHOD(InverseTransform)(THIS_ D3DVECTOR *d,D3DVECTOR *s);
	STDMETHOD(Load)(THIS_ LPVOID filename,LPVOID name,D3DRMLOADOPTIONS loadflags,D3DRMLOADTEXTURE3CALLBACK,LPVOID lpArg);
	STDMETHOD(LookAt)(THIS_ LPDIRECT3DRMFRAME3 target,LPDIRECT3DRMFRAME3 reference,D3DRMFRAMECONSTRAINT);
	STDMETHOD(Move)(THIS_ D3DVALUE delta);
	STDMETHOD(DeleteChild)(THIS_ LPDIRECT3DRMFRAME3);
	STDMETHOD(DeleteLight)(THIS_ LPDIRECT3DRMLIGHT);
	STDMETHOD(DeleteMoveCallback)(THIS_ D3DRMFRAME3MOVECALLBACK,VOID *arg);
	STDMETHOD(DeleteVisual)(THIS_ LPUNKNOWN);
	STDMETHOD_(D3DCOLOR,GetSceneBackground)(THIS);
	STDMETHOD(GetSceneBackgroundDepth)(THIS_ LPDIRECTDRAWSURFACE *);
	STDMETHOD_(D3DCOLOR,GetSceneFogColor)(THIS);
	STDMETHOD_(BOOL,GetSceneFogEnable)(THIS);
	STDMETHOD_(D3DRMFOGMODE,GetSceneFogMode)(THIS);
	STDMETHOD(GetSceneFogParams)(THIS_ D3DVALUE *return_start,D3DVALUE *return_end,D3DVALUE *return_density);
	STDMETHOD(SetSceneBackground)(THIS_ D3DCOLOR);
	STDMETHOD(SetSceneBackgroundRGB)(THIS_ D3DVALUE red,D3DVALUE green,D3DVALUE blue);
	STDMETHOD(SetSceneBackgroundDepth)(THIS_ LPDIRECTDRAWSURFACE);
	STDMETHOD(SetSceneBackgroundImage)(THIS_ LPDIRECT3DRMTEXTURE3);
	STDMETHOD(SetSceneFogEnable)(THIS_ BOOL);
	STDMETHOD(SetSceneFogColor)(THIS_ D3DCOLOR);
	STDMETHOD(SetSceneFogMode)(THIS_ D3DRMFOGMODE);
	STDMETHOD(SetSceneFogParams)(THIS_ D3DVALUE start,D3DVALUE end,D3DVALUE density);
	STDMETHOD(SetColor)(THIS_ D3DCOLOR);
	STDMETHOD(SetColorRGB)(THIS_ D3DVALUE red,D3DVALUE green,D3DVALUE blue);
	STDMETHOD_(D3DRMZBUFFERMODE,GetZbufferMode)(THIS);
	STDMETHOD(SetMaterialMode)(THIS_ D3DRMMATERIALMODE);
	STDMETHOD(SetOrientation)
	( THIS_ LPDIRECT3DRMFRAME3 reference,
	D3DVALUE dx,D3DVALUE dy,D3DVALUE dz,
	D3DVALUE ux,D3DVALUE uy,D3DVALUE uz
	);
	STDMETHOD(SetPosition)(THIS_ LPDIRECT3DRMFRAME3 reference,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(SetRotation)(THIS_ LPDIRECT3DRMFRAME3 reference,D3DVALUE x,D3DVALUE y,D3DVALUE z,D3DVALUE theta);
	STDMETHOD(SetSortMode)(THIS_ D3DRMSORTMODE);
	STDMETHOD(SetTexture)(THIS_ LPDIRECT3DRMTEXTURE3);
	STDMETHOD(SetVelocity)(THIS_ LPDIRECT3DRMFRAME3 reference,D3DVALUE x,D3DVALUE y,D3DVALUE z,BOOL with_rotation);
	STDMETHOD(SetZbufferMode)(THIS_ D3DRMZBUFFERMODE);
	STDMETHOD(Transform)(THIS_ D3DVECTOR *d,D3DVECTOR *s);
	STDMETHOD(GetBox)(THIS_ LPD3DRMBOX);
	STDMETHOD_(BOOL,GetBoxEnable)(THIS);
	STDMETHOD(GetAxes)(THIS_ LPD3DVECTOR dir,LPD3DVECTOR up);
	STDMETHOD(GetMaterial)(THIS_ LPDIRECT3DRMMATERIAL2 *);
	STDMETHOD_(BOOL,GetInheritAxes)(THIS);
	STDMETHOD(GetHierarchyBox)(THIS_ LPD3DRMBOX);

	STDMETHOD(SetBox)(THIS_ LPD3DRMBOX);
	STDMETHOD(SetBoxEnable)(THIS_ BOOL);
	STDMETHOD(SetAxes)(THIS_ D3DVALUE dx,D3DVALUE dy,D3DVALUE dz,
	 D3DVALUE ux,D3DVALUE uy,D3DVALUE uz);
	STDMETHOD(SetInheritAxes)(THIS_ BOOL inherit_from_parent);
	STDMETHOD(SetMaterial)(THIS_ LPDIRECT3DRMMATERIAL2);
	STDMETHOD(SetQuaternion)(THIS_ LPDIRECT3DRMFRAME3 reference,D3DRMQUATERNION *q);

	STDMETHOD(RayPick)(THIS_ LPDIRECT3DRMFRAME3 reference,LPD3DRMRAY ray,DWORD dwFlags,LPDIRECT3DRMPICKED2ARRAY *return_visuals);
	STDMETHOD(Save)(THIS_ LPCSTR filename,D3DRMXOFFORMAT d3dFormat,
	 D3DRMSAVEOPTIONS d3dSaveFlags);
	STDMETHOD(TransformVectors)(THIS_ LPDIRECT3DRMFRAME3 reference,
	 DWORD dwNumVectors,
	 LPD3DVECTOR lpDstVectors,
	 LPD3DVECTOR lpSrcVectors);
	STDMETHOD(InverseTransformVectors)(THIS_ LPDIRECT3DRMFRAME3 reference,
	  DWORD dwNumVectors,
	  LPD3DVECTOR lpDstVectors,
	  LPD3DVECTOR lpSrcVectors);
	STDMETHOD(SetTraversalOptions)(THIS_ DWORD dwFlags);
	STDMETHOD(GetTraversalOptions)(THIS_ LPDWORD lpdwFlags);
	STDMETHOD(SetSceneFogMethod)(THIS_ DWORD dwFlags);
	STDMETHOD(GetSceneFogMethod)(THIS_ LPDWORD lpdwFlags);
	STDMETHOD(SetMaterialOverride)(THIS_ LPD3DRMMATERIALOVERRIDE);
	STDMETHOD(GetMaterialOverride)(THIS_ LPD3DRMMATERIALOVERRIDE);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMMesh

DECLARE_INTERFACE_(IDirect3DRMMesh,IDirect3DRMVisual)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(Scale)(THIS_ D3DVALUE sx,D3DVALUE sy,D3DVALUE sz);
	STDMETHOD(Translate)(THIS_ D3DVALUE tx,D3DVALUE ty,D3DVALUE tz);
	STDMETHOD(GetBox)(THIS_ D3DRMBOX *);
	STDMETHOD(AddGroup)(THIS_ unsigned vCount,unsigned fCount,unsigned vPerFace,unsigned *fData,D3DRMGROUPINDEX *returnId);
	STDMETHOD(SetVertices)(THIS_ D3DRMGROUPINDEX id,unsigned index,unsigned count,D3DRMVERTEX *values);
	STDMETHOD(SetGroupColor)(THIS_ D3DRMGROUPINDEX id,D3DCOLOR value);
	STDMETHOD(SetGroupColorRGB)(THIS_ D3DRMGROUPINDEX id,D3DVALUE red,D3DVALUE green,D3DVALUE blue);
	STDMETHOD(SetGroupMapping)(THIS_ D3DRMGROUPINDEX id,D3DRMMAPPING value);
	STDMETHOD(SetGroupQuality)(THIS_ D3DRMGROUPINDEX id,D3DRMRENDERQUALITY value);
	STDMETHOD(SetGroupMaterial)(THIS_ D3DRMGROUPINDEX id,LPDIRECT3DRMMATERIAL value);
	STDMETHOD(SetGroupTexture)(THIS_ D3DRMGROUPINDEX id,LPDIRECT3DRMTEXTURE value);

	STDMETHOD_(unsigned,GetGroupCount)(THIS);
	STDMETHOD(GetGroup)(THIS_ D3DRMGROUPINDEX id,unsigned *vCount,unsigned *fCount,unsigned *vPerFace,DWORD *fDataSize,unsigned *fData);
	STDMETHOD(GetVertices)(THIS_ D3DRMGROUPINDEX id,DWORD index,DWORD count,D3DRMVERTEX *returnPtr);
	STDMETHOD_(D3DCOLOR,GetGroupColor)(THIS_ D3DRMGROUPINDEX id);
	STDMETHOD_(D3DRMMAPPING,GetGroupMapping)(THIS_ D3DRMGROUPINDEX id);
	STDMETHOD_(D3DRMRENDERQUALITY,GetGroupQuality)(THIS_ D3DRMGROUPINDEX id);
	STDMETHOD(GetGroupMaterial)(THIS_ D3DRMGROUPINDEX id,LPDIRECT3DRMMATERIAL *returnPtr);
	STDMETHOD(GetGroupTexture)(THIS_ D3DRMGROUPINDEX id,LPDIRECT3DRMTEXTURE *returnPtr);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMProgressiveMesh

DECLARE_INTERFACE_(IDirect3DRMProgressiveMesh,IDirect3DRMVisual)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(Load) (THIS_ LPVOID lpObjLocation,LPVOID lpObjId,
	 D3DRMLOADOPTIONS dloLoadflags,D3DRMLOADTEXTURECALLBACK lpCallback,
	 LPVOID lpArg);
	STDMETHOD(GetLoadStatus) (THIS_ LPD3DRMPMESHLOADSTATUS lpStatus);
	STDMETHOD(SetMinRenderDetail) (THIS_ D3DVALUE d3dVal);
	STDMETHOD(Abort) (THIS_ DWORD dwFlags);
	
	STDMETHOD(GetFaceDetail) (THIS_ LPDWORD lpdwCount);
	STDMETHOD(GetVertexDetail) (THIS_ LPDWORD lpdwCount);
	STDMETHOD(SetFaceDetail) (THIS_ DWORD dwCount);
	STDMETHOD(SetVertexDetail) (THIS_ DWORD dwCount);
	STDMETHOD(GetFaceDetailRange) (THIS_ LPDWORD lpdwMin,LPDWORD lpdwMax);
	STDMETHOD(GetVertexDetailRange) (THIS_ LPDWORD lpdwMin,LPDWORD lpdwMax);
	STDMETHOD(GetDetail) (THIS_ D3DVALUE *lpdvVal);
	STDMETHOD(SetDetail) (THIS_ D3DVALUE d3dVal);

	STDMETHOD(RegisterEvents) (THIS_ HANDLE hEvent,DWORD dwFlags,DWORD dwReserved);
	STDMETHOD(CreateMesh) (THIS_ LPDIRECT3DRMMESH *lplpD3DRMMesh);
	STDMETHOD(Duplicate) (THIS_ LPDIRECT3DRMPROGRESSIVEMESH *lplpD3DRMPMesh);
	STDMETHOD(GetBox) (THIS_ LPD3DRMBOX lpBBox);
	STDMETHOD(SetQuality) (THIS_ D3DRMRENDERQUALITY);
	STDMETHOD(GetQuality) (THIS_ LPD3DRMRENDERQUALITY lpdwquality);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMShadow

DECLARE_INTERFACE_(IDirect3DRMShadow,IDirect3DRMVisual)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(Init)
	( THIS_ LPDIRECT3DRMVISUAL visual,LPDIRECT3DRMLIGHT light,
	D3DVALUE px,D3DVALUE py,D3DVALUE pz,
	D3DVALUE nx,D3DVALUE ny,D3DVALUE nz
	);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMShadow2

DECLARE_INTERFACE_(IDirect3DRMShadow2,IDirect3DRMVisual)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);

	/*
	* IDirect3DRMShadow methods
	*/
	STDMETHOD(Init)
	( THIS_ LPUNKNOWN pUNK,LPDIRECT3DRMLIGHT light,
	D3DVALUE px,D3DVALUE py,D3DVALUE pz,
	D3DVALUE nx,D3DVALUE ny,D3DVALUE nz
	);

	/*
	* IDirect3DRMShadow2 methods
	*/
	STDMETHOD(GetVisual)(THIS_ LPDIRECT3DRMVISUAL *);
	STDMETHOD(SetVisual)(THIS_ LPUNKNOWN pUNK,DWORD);
	STDMETHOD(GetLight)(THIS_ LPDIRECT3DRMLIGHT *);
	STDMETHOD(SetLight)(THIS_ LPDIRECT3DRMLIGHT,DWORD);
	STDMETHOD(GetPlane)(THIS_ LPD3DVALUE px,LPD3DVALUE py,LPD3DVALUE pz,
	 LPD3DVALUE nx,LPD3DVALUE ny,LPD3DVALUE nz);
	STDMETHOD(SetPlane)(THIS_ D3DVALUE px,D3DVALUE py,D3DVALUE pz,
	 D3DVALUE nx,D3DVALUE ny,D3DVALUE nz,DWORD);
	STDMETHOD(GetOptions)(THIS_ LPDWORD);
	STDMETHOD(SetOptions)(THIS_ DWORD);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMFace

DECLARE_INTERFACE_(IDirect3DRMFace,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(AddVertex)(THIS_ D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(AddVertexAndNormalIndexed)(THIS_ DWORD vertex,DWORD normal);
	STDMETHOD(SetColorRGB)(THIS_ D3DVALUE,D3DVALUE,D3DVALUE);
	STDMETHOD(SetColor)(THIS_ D3DCOLOR);
	STDMETHOD(SetTexture)(THIS_ LPDIRECT3DRMTEXTURE);
	STDMETHOD(SetTextureCoordinates)(THIS_ DWORD vertex,D3DVALUE u,D3DVALUE v);
	STDMETHOD(SetMaterial)(THIS_ LPDIRECT3DRMMATERIAL);
	STDMETHOD(SetTextureTopology)(THIS_ BOOL wrap_u,BOOL wrap_v);

	STDMETHOD(GetVertex)(THIS_ DWORD index,D3DVECTOR *vertex,D3DVECTOR *normal);
	STDMETHOD(GetVertices)(THIS_ DWORD *vertex_count,D3DVECTOR *coords,D3DVECTOR *normals);
	STDMETHOD(GetTextureCoordinates)(THIS_ DWORD vertex,D3DVALUE *u,D3DVALUE *v);
	STDMETHOD(GetTextureTopology)(THIS_ BOOL *wrap_u,BOOL *wrap_v);
	STDMETHOD(GetNormal)(THIS_ D3DVECTOR *);
	STDMETHOD(GetTexture)(THIS_ LPDIRECT3DRMTEXTURE *);
	STDMETHOD(GetMaterial)(THIS_ LPDIRECT3DRMMATERIAL *);

	STDMETHOD_(int,GetVertexCount)(THIS);
	STDMETHOD_(int,GetVertexIndex)(THIS_ DWORD which);
	STDMETHOD_(int,GetTextureCoordinateIndex)(THIS_ DWORD which);
	STDMETHOD_(D3DCOLOR,GetColor)(THIS);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMFace2

DECLARE_INTERFACE_(IDirect3DRMFace2,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(AddVertex)(THIS_ D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(AddVertexAndNormalIndexed)(THIS_ DWORD vertex,DWORD normal);
	STDMETHOD(SetColorRGB)(THIS_ D3DVALUE,D3DVALUE,D3DVALUE);
	STDMETHOD(SetColor)(THIS_ D3DCOLOR);
	STDMETHOD(SetTexture)(THIS_ LPDIRECT3DRMTEXTURE3);
	STDMETHOD(SetTextureCoordinates)(THIS_ DWORD vertex,D3DVALUE u,D3DVALUE v);
	STDMETHOD(SetMaterial)(THIS_ LPDIRECT3DRMMATERIAL2);
	STDMETHOD(SetTextureTopology)(THIS_ BOOL wrap_u,BOOL wrap_v);

	STDMETHOD(GetVertex)(THIS_ DWORD index,D3DVECTOR *vertex,D3DVECTOR *normal);
	STDMETHOD(GetVertices)(THIS_ DWORD *vertex_count,D3DVECTOR *coords,D3DVECTOR *normals);
	STDMETHOD(GetTextureCoordinates)(THIS_ DWORD vertex,D3DVALUE *u,D3DVALUE *v);
	STDMETHOD(GetTextureTopology)(THIS_ BOOL *wrap_u,BOOL *wrap_v);
	STDMETHOD(GetNormal)(THIS_ D3DVECTOR *);
	STDMETHOD(GetTexture)(THIS_ LPDIRECT3DRMTEXTURE3 *);
	STDMETHOD(GetMaterial)(THIS_ LPDIRECT3DRMMATERIAL2 *);

	STDMETHOD_(int,GetVertexCount)(THIS);
	STDMETHOD_(int,GetVertexIndex)(THIS_ DWORD which);
	STDMETHOD_(int,GetTextureCoordinateIndex)(THIS_ DWORD which);
	STDMETHOD_(D3DCOLOR,GetColor)(THIS);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMMeshBuilder

DECLARE_INTERFACE_(IDirect3DRMMeshBuilder,IDirect3DRMVisual)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(Load)(THIS_ LPVOID filename,LPVOID name,D3DRMLOADOPTIONS loadflags,D3DRMLOADTEXTURECALLBACK,LPVOID lpArg);
	STDMETHOD(Save)(THIS_ const char *filename,D3DRMXOFFORMAT,D3DRMSAVEOPTIONS save);
	STDMETHOD(Scale)(THIS_ D3DVALUE sx,D3DVALUE sy,D3DVALUE sz);
	STDMETHOD(Translate)(THIS_ D3DVALUE tx,D3DVALUE ty,D3DVALUE tz);
	STDMETHOD(SetColorSource)(THIS_ D3DRMCOLORSOURCE);
	STDMETHOD(GetBox)(THIS_ D3DRMBOX *);
	STDMETHOD(GenerateNormals)(THIS);
	STDMETHOD_(D3DRMCOLORSOURCE,GetColorSource)(THIS);

	STDMETHOD(AddMesh)(THIS_ LPDIRECT3DRMMESH);
	STDMETHOD(AddMeshBuilder)(THIS_ LPDIRECT3DRMMESHBUILDER);
	STDMETHOD(AddFrame)(THIS_ LPDIRECT3DRMFRAME);
	STDMETHOD(AddFace)(THIS_ LPDIRECT3DRMFACE);
	STDMETHOD(AddFaces)
	( THIS_ DWORD vcount,D3DVECTOR *vertices,DWORD ncount,D3DVECTOR *normals,
	DWORD *data,LPDIRECT3DRMFACEARRAY*
	);
	STDMETHOD(ReserveSpace)(THIS_ DWORD vertex_Count,DWORD normal_count,DWORD face_count);
	STDMETHOD(SetColorRGB)(THIS_ D3DVALUE red,D3DVALUE green,D3DVALUE blue);
	STDMETHOD(SetColor)(THIS_ D3DCOLOR);
	STDMETHOD(SetTexture)(THIS_ LPDIRECT3DRMTEXTURE);
	STDMETHOD(SetMaterial)(THIS_ LPDIRECT3DRMMATERIAL);
	STDMETHOD(SetTextureTopology)(THIS_ BOOL wrap_u,BOOL wrap_v);
	STDMETHOD(SetQuality)(THIS_ D3DRMRENDERQUALITY);
	STDMETHOD(SetPerspective)(THIS_ BOOL);
	STDMETHOD(SetVertex)(THIS_ DWORD index,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(SetNormal)(THIS_ DWORD index,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(SetTextureCoordinates)(THIS_ DWORD index,D3DVALUE u,D3DVALUE v);
	STDMETHOD(SetVertexColor)(THIS_ DWORD index,D3DCOLOR);
	STDMETHOD(SetVertexColorRGB)(THIS_ DWORD index,D3DVALUE red,D3DVALUE green,D3DVALUE blue);

	STDMETHOD(GetFaces)(THIS_ LPDIRECT3DRMFACEARRAY*);
	STDMETHOD(GetVertices)
	( THIS_ DWORD *vcount,D3DVECTOR *vertices,DWORD *ncount,D3DVECTOR *normals,DWORD *face_data_size,DWORD *face_data
	);
	STDMETHOD(GetTextureCoordinates)(THIS_ DWORD index,D3DVALUE *u,D3DVALUE *v);

	STDMETHOD_(int,AddVertex)(THIS_ D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD_(int,AddNormal)(THIS_ D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(CreateFace)(THIS_ LPDIRECT3DRMFACE*);
	STDMETHOD_(D3DRMRENDERQUALITY,GetQuality)(THIS);
	STDMETHOD_(BOOL,GetPerspective)(THIS);
	STDMETHOD_(int,GetFaceCount)(THIS);
	STDMETHOD_(int,GetVertexCount)(THIS);
	STDMETHOD_(D3DCOLOR,GetVertexColor)(THIS_ DWORD index);

	STDMETHOD(CreateMesh)(THIS_ LPDIRECT3DRMMESH*);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMMeshBuilder2

DECLARE_INTERFACE_(IDirect3DRMMeshBuilder2,IDirect3DRMMeshBuilder)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(Load)(THIS_ LPVOID filename,LPVOID name,D3DRMLOADOPTIONS loadflags,D3DRMLOADTEXTURECALLBACK,LPVOID lpArg);
	STDMETHOD(Save)(THIS_ const char *filename,D3DRMXOFFORMAT,D3DRMSAVEOPTIONS save);
	STDMETHOD(Scale)(THIS_ D3DVALUE sx,D3DVALUE sy,D3DVALUE sz);
	STDMETHOD(Translate)(THIS_ D3DVALUE tx,D3DVALUE ty,D3DVALUE tz);
	STDMETHOD(SetColorSource)(THIS_ D3DRMCOLORSOURCE);
	STDMETHOD(GetBox)(THIS_ D3DRMBOX *);
	STDMETHOD(GenerateNormals)(THIS);
	STDMETHOD_(D3DRMCOLORSOURCE,GetColorSource)(THIS);

	STDMETHOD(AddMesh)(THIS_ LPDIRECT3DRMMESH);
	STDMETHOD(AddMeshBuilder)(THIS_ LPDIRECT3DRMMESHBUILDER);
	STDMETHOD(AddFrame)(THIS_ LPDIRECT3DRMFRAME);
	STDMETHOD(AddFace)(THIS_ LPDIRECT3DRMFACE);
	STDMETHOD(AddFaces)
	( THIS_ DWORD vcount,D3DVECTOR *vertices,DWORD ncount,D3DVECTOR *normals,
	DWORD *data,LPDIRECT3DRMFACEARRAY*
	);
	STDMETHOD(ReserveSpace)(THIS_ DWORD vertex_Count,DWORD normal_count,DWORD face_count);
	STDMETHOD(SetColorRGB)(THIS_ D3DVALUE red,D3DVALUE green,D3DVALUE blue);
	STDMETHOD(SetColor)(THIS_ D3DCOLOR);
	STDMETHOD(SetTexture)(THIS_ LPDIRECT3DRMTEXTURE);
	STDMETHOD(SetMaterial)(THIS_ LPDIRECT3DRMMATERIAL);
	STDMETHOD(SetTextureTopology)(THIS_ BOOL wrap_u,BOOL wrap_v);
	STDMETHOD(SetQuality)(THIS_ D3DRMRENDERQUALITY);
	STDMETHOD(SetPerspective)(THIS_ BOOL);
	STDMETHOD(SetVertex)(THIS_ DWORD index,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(SetNormal)(THIS_ DWORD index,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(SetTextureCoordinates)(THIS_ DWORD index,D3DVALUE u,D3DVALUE v);
	STDMETHOD(SetVertexColor)(THIS_ DWORD index,D3DCOLOR);
	STDMETHOD(SetVertexColorRGB)(THIS_ DWORD index,D3DVALUE red,D3DVALUE green,D3DVALUE blue);
	STDMETHOD(GetFaces)(THIS_ LPDIRECT3DRMFACEARRAY*);
	STDMETHOD(GetVertices)
	( THIS_ DWORD *vcount,D3DVECTOR *vertices,DWORD *ncount,D3DVECTOR *normals,DWORD *face_data_size,DWORD *face_data
	);
	STDMETHOD(GetTextureCoordinates)(THIS_ DWORD index,D3DVALUE *u,D3DVALUE *v);
	STDMETHOD_(int,AddVertex)(THIS_ D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD_(int,AddNormal)(THIS_ D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(CreateFace)(THIS_ LPDIRECT3DRMFACE*);
	STDMETHOD_(D3DRMRENDERQUALITY,GetQuality)(THIS);
	STDMETHOD_(BOOL,GetPerspective)(THIS);
	STDMETHOD_(int,GetFaceCount)(THIS);
	STDMETHOD_(int,GetVertexCount)(THIS);
	STDMETHOD_(D3DCOLOR,GetVertexColor)(THIS_ DWORD index);
	STDMETHOD(CreateMesh)(THIS_ LPDIRECT3DRMMESH*);
	STDMETHOD(GenerateNormals2)(THIS_ D3DVALUE crease,DWORD dwFlags);
	STDMETHOD(GetFace)(THIS_ DWORD index,LPDIRECT3DRMFACE*);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMMeshBuilder3

DECLARE_INTERFACE_(IDirect3DRMMeshBuilder3,IDirect3DRMVisual)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(Load)(THIS_ LPVOID filename,LPVOID name,D3DRMLOADOPTIONS loadflags,D3DRMLOADTEXTURE3CALLBACK,LPVOID lpArg);
	STDMETHOD(Save)(THIS_ const char *filename,D3DRMXOFFORMAT,D3DRMSAVEOPTIONS save);
	STDMETHOD(Scale)(THIS_ D3DVALUE sx,D3DVALUE sy,D3DVALUE sz);
	STDMETHOD(Translate)(THIS_ D3DVALUE tx,D3DVALUE ty,D3DVALUE tz);
	STDMETHOD(SetColorSource)(THIS_ D3DRMCOLORSOURCE);
	STDMETHOD(GetBox)(THIS_ D3DRMBOX *);
	STDMETHOD(GenerateNormals)(THIS_ D3DVALUE crease,DWORD dwFlags);
	STDMETHOD_(D3DRMCOLORSOURCE,GetColorSource)(THIS);

	STDMETHOD(AddMesh)(THIS_ LPDIRECT3DRMMESH);
	STDMETHOD(AddMeshBuilder)(THIS_ LPDIRECT3DRMMESHBUILDER3,DWORD dwFlags);
	STDMETHOD(AddFrame)(THIS_ LPDIRECT3DRMFRAME3);
	STDMETHOD(AddFace)(THIS_ LPDIRECT3DRMFACE2);
	STDMETHOD(AddFaces)
	( THIS_ DWORD vcount,D3DVECTOR *vertices,DWORD ncount,D3DVECTOR *normals,
	DWORD *data,LPDIRECT3DRMFACEARRAY*
	);
	STDMETHOD(ReserveSpace)(THIS_ DWORD vertex_Count,DWORD normal_count,DWORD face_count);
	STDMETHOD(SetColorRGB)(THIS_ D3DVALUE red,D3DVALUE green,D3DVALUE blue);
	STDMETHOD(SetColor)(THIS_ D3DCOLOR);
	STDMETHOD(SetTexture)(THIS_ LPDIRECT3DRMTEXTURE3);
	STDMETHOD(SetMaterial)(THIS_ LPDIRECT3DRMMATERIAL2);
	STDMETHOD(SetTextureTopology)(THIS_ BOOL wrap_u,BOOL wrap_v);
	STDMETHOD(SetQuality)(THIS_ D3DRMRENDERQUALITY);
	STDMETHOD(SetPerspective)(THIS_ BOOL);
	STDMETHOD(SetVertex)(THIS_ DWORD index,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(SetNormal)(THIS_ DWORD index,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(SetTextureCoordinates)(THIS_ DWORD index,D3DVALUE u,D3DVALUE v);
	STDMETHOD(SetVertexColor)(THIS_ DWORD index,D3DCOLOR);
	STDMETHOD(SetVertexColorRGB)(THIS_ DWORD index,D3DVALUE red,D3DVALUE green,D3DVALUE blue);
	STDMETHOD(GetFaces)(THIS_ LPDIRECT3DRMFACEARRAY*);
	STDMETHOD(GetGeometry)
	( THIS_ DWORD *vcount,D3DVECTOR *vertices,DWORD *ncount,D3DVECTOR *normals,DWORD *face_data_size,DWORD *face_data
	);
	STDMETHOD(GetTextureCoordinates)(THIS_ DWORD index,D3DVALUE *u,D3DVALUE *v);
	STDMETHOD_(int,AddVertex)(THIS_ D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD_(int,AddNormal)(THIS_ D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(CreateFace)(THIS_ LPDIRECT3DRMFACE2 *);
	STDMETHOD_(D3DRMRENDERQUALITY,GetQuality)(THIS);
	STDMETHOD_(BOOL,GetPerspective)(THIS);
	STDMETHOD_(int,GetFaceCount)(THIS);
	STDMETHOD_(int,GetVertexCount)(THIS);
	STDMETHOD_(D3DCOLOR,GetVertexColor)(THIS_ DWORD index);
	STDMETHOD(CreateMesh)(THIS_ LPDIRECT3DRMMESH*);
	STDMETHOD(GetFace)(THIS_ DWORD index,LPDIRECT3DRMFACE2 *);
	STDMETHOD(GetVertex)(THIS_ DWORD dwIndex,LPD3DVECTOR lpVector);
	STDMETHOD(GetNormal)(THIS_ DWORD dwIndex,LPD3DVECTOR lpVector);
	STDMETHOD(DeleteVertices)(THIS_ DWORD dwIndexFirst,DWORD dwCount);
	STDMETHOD(DeleteNormals)(THIS_ DWORD dwIndexFirst,DWORD dwCount);
	STDMETHOD(DeleteFace)(THIS_ LPDIRECT3DRMFACE2);
	STDMETHOD(Empty)(THIS_ DWORD dwFlags);
	STDMETHOD(Optimize)(THIS_ DWORD dwFlags);
	STDMETHOD(AddFacesIndexed)(THIS_ DWORD dwFlags,DWORD *lpdwvIndices,DWORD *dwIndexFirst,DWORD *dwCount);
	STDMETHOD(CreateSubMesh)(THIS_ LPUNKNOWN *);
	STDMETHOD(GetParentMesh)(THIS_ DWORD,LPUNKNOWN *);
	STDMETHOD(GetSubMeshes)(THIS_ LPDWORD lpdwCount,LPUNKNOWN *);
	STDMETHOD(DeleteSubMesh)(THIS_ LPUNKNOWN);
	STDMETHOD(Enable)(THIS_ DWORD);
	STDMETHOD(GetEnable)(THIS_ DWORD *);
	STDMETHOD(AddTriangles)(THIS_ DWORD dwFlags,DWORD dwFormat,
	 DWORD dwVertexCount,LPVOID lpvData);
	STDMETHOD(SetVertices)(THIS_ DWORD dwIndexFirst,DWORD dwCount,LPD3DVECTOR);
	STDMETHOD(GetVertices)(THIS_ DWORD dwIndexFirst,LPDWORD lpdwCount,LPD3DVECTOR);
	STDMETHOD(SetNormals)(THIS_ DWORD dwIndexFirst,DWORD dwCount,LPD3DVECTOR);
	STDMETHOD(GetNormals)(THIS_ DWORD dwIndexFirst,LPDWORD lpdwCount,LPD3DVECTOR);
	STDMETHOD_(int,GetNormalCount)(THIS);
}; 

#undef INTERFACE
#define INTERFACE IDirect3DRMLight

DECLARE_INTERFACE_(IDirect3DRMLight,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(SetType)(THIS_ D3DRMLIGHTTYPE);
	STDMETHOD(SetColor)(THIS_ D3DCOLOR);
	STDMETHOD(SetColorRGB)(THIS_ D3DVALUE red,D3DVALUE green,D3DVALUE blue);
	STDMETHOD(SetRange)(THIS_ D3DVALUE);
	STDMETHOD(SetUmbra)(THIS_ D3DVALUE);
	STDMETHOD(SetPenumbra)(THIS_ D3DVALUE);
	STDMETHOD(SetConstantAttenuation)(THIS_ D3DVALUE);
	STDMETHOD(SetLinearAttenuation)(THIS_ D3DVALUE);
	STDMETHOD(SetQuadraticAttenuation)(THIS_ D3DVALUE);
	STDMETHOD_(D3DVALUE,GetRange)(THIS);
	STDMETHOD_(D3DVALUE,GetUmbra)(THIS);
	STDMETHOD_(D3DVALUE,GetPenumbra)(THIS);
	STDMETHOD_(D3DVALUE,GetConstantAttenuation)(THIS);
	STDMETHOD_(D3DVALUE,GetLinearAttenuation)(THIS);
	STDMETHOD_(D3DVALUE,GetQuadraticAttenuation)(THIS);
	STDMETHOD_(D3DCOLOR,GetColor)(THIS);
	STDMETHOD_(D3DRMLIGHTTYPE,GetType)(THIS);
	STDMETHOD(SetEnableFrame)(THIS_ LPDIRECT3DRMFRAME);
	STDMETHOD(GetEnableFrame)(THIS_ LPDIRECT3DRMFRAME*);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMTexture

DECLARE_INTERFACE_(IDirect3DRMTexture,IDirect3DRMVisual)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(InitFromFile)(THIS_ const char *filename);
	STDMETHOD(InitFromSurface)(THIS_ LPDIRECTDRAWSURFACE lpDDS);
	STDMETHOD(InitFromResource)(THIS_ HRSRC);
	STDMETHOD(Changed)(THIS_ BOOL pixels,BOOL palette);

	STDMETHOD(SetColors)(THIS_ DWORD);
	STDMETHOD(SetShades)(THIS_ DWORD);
	STDMETHOD(SetDecalSize)(THIS_ D3DVALUE width,D3DVALUE height);
	STDMETHOD(SetDecalOrigin)(THIS_ LONG x,LONG y);
	STDMETHOD(SetDecalScale)(THIS_ DWORD);
	STDMETHOD(SetDecalTransparency)(THIS_ BOOL);
	STDMETHOD(SetDecalTransparentColor)(THIS_ D3DCOLOR);

	STDMETHOD(GetDecalSize)(THIS_ D3DVALUE *width_return,D3DVALUE *height_return);
	STDMETHOD(GetDecalOrigin)(THIS_ LONG *x_return,LONG *y_return);

	STDMETHOD_(D3DRMIMAGE *,GetImage)(THIS);
	STDMETHOD_(DWORD,GetShades)(THIS);
	STDMETHOD_(DWORD,GetColors)(THIS);
	STDMETHOD_(DWORD,GetDecalScale)(THIS);
	STDMETHOD_(BOOL,GetDecalTransparency)(THIS);
	STDMETHOD_(D3DCOLOR,GetDecalTransparentColor)(THIS);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMTexture2

DECLARE_INTERFACE_(IDirect3DRMTexture2,IDirect3DRMTexture)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(InitFromFile)(THIS_ const char *filename);
	STDMETHOD(InitFromSurface)(THIS_ LPDIRECTDRAWSURFACE lpDDS);
	STDMETHOD(InitFromResource)(THIS_ HRSRC);
	STDMETHOD(Changed)(THIS_ BOOL pixels,BOOL palette);
	STDMETHOD(SetColors)(THIS_ DWORD);
	STDMETHOD(SetShades)(THIS_ DWORD);
	STDMETHOD(SetDecalSize)(THIS_ D3DVALUE width,D3DVALUE height);
	STDMETHOD(SetDecalOrigin)(THIS_ LONG x,LONG y);
	STDMETHOD(SetDecalScale)(THIS_ DWORD);
	STDMETHOD(SetDecalTransparency)(THIS_ BOOL);
	STDMETHOD(SetDecalTransparentColor)(THIS_ D3DCOLOR);
	STDMETHOD(GetDecalSize)(THIS_ D3DVALUE *width_return,D3DVALUE *height_return);
	STDMETHOD(GetDecalOrigin)(THIS_ LONG *x_return,LONG *y_return);
	STDMETHOD_(D3DRMIMAGE *,GetImage)(THIS);
	STDMETHOD_(DWORD,GetShades)(THIS);
	STDMETHOD_(DWORD,GetColors)(THIS);
	STDMETHOD_(DWORD,GetDecalScale)(THIS);
	STDMETHOD_(BOOL,GetDecalTransparency)(THIS);
	STDMETHOD_(D3DCOLOR,GetDecalTransparentColor)(THIS);
	STDMETHOD(InitFromImage)(THIS_ LPD3DRMIMAGE);
	STDMETHOD(InitFromResource2)(THIS_ HMODULE hModule,LPCTSTR strName,LPCTSTR strType);
	STDMETHOD(GenerateMIPMap)(THIS_ DWORD);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMTexture3

DECLARE_INTERFACE_(IDirect3DRMTexture3,IDirect3DRMVisual)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);

	/*
	* IDirect3DRMTexture3 methods
	*/
	STDMETHOD(InitFromFile)(THIS_ const char *filename);
	STDMETHOD(InitFromSurface)(THIS_ LPDIRECTDRAWSURFACE lpDDS);
	STDMETHOD(InitFromResource)(THIS_ HRSRC);
	STDMETHOD(Changed)(THIS_ DWORD dwFlags,DWORD dwcRects,LPRECT pRects);
	STDMETHOD(SetColors)(THIS_ DWORD);
	STDMETHOD(SetShades)(THIS_ DWORD);
	STDMETHOD(SetDecalSize)(THIS_ D3DVALUE width,D3DVALUE height);
	STDMETHOD(SetDecalOrigin)(THIS_ LONG x,LONG y);
	STDMETHOD(SetDecalScale)(THIS_ DWORD);
	STDMETHOD(SetDecalTransparency)(THIS_ BOOL);
	STDMETHOD(SetDecalTransparentColor)(THIS_ D3DCOLOR);

	STDMETHOD(GetDecalSize)(THIS_ D3DVALUE *width_return,D3DVALUE *height_return);
	STDMETHOD(GetDecalOrigin)(THIS_ LONG *x_return,LONG *y_return);

	STDMETHOD_(D3DRMIMAGE *,GetImage)(THIS);
	STDMETHOD_(DWORD,GetShades)(THIS);
	STDMETHOD_(DWORD,GetColors)(THIS);
	STDMETHOD_(DWORD,GetDecalScale)(THIS);
	STDMETHOD_(BOOL,GetDecalTransparency)(THIS);
	STDMETHOD_(D3DCOLOR,GetDecalTransparentColor)(THIS);
	STDMETHOD(InitFromImage)(THIS_ LPD3DRMIMAGE);
	STDMETHOD(InitFromResource2)(THIS_ HMODULE hModule,LPCTSTR strName,LPCTSTR strType);
	STDMETHOD(GenerateMIPMap)(THIS_ DWORD);
	STDMETHOD(GetSurface)(THIS_ DWORD dwFlags,LPDIRECTDRAWSURFACE* lplpDDS);
	STDMETHOD(SetCacheOptions)(THIS_ LONG lImportance,DWORD dwFlags);
	STDMETHOD(GetCacheOptions)(THIS_ LPLONG lplImportance,LPDWORD lpdwFlags);
	STDMETHOD(SetDownsampleCallback)(THIS_ D3DRMDOWNSAMPLECALLBACK pCallback,LPVOID pArg);
	STDMETHOD(SetValidationCallback)(THIS_ D3DRMVALIDATIONCALLBACK pCallback,LPVOID pArg);
};


#undef INTERFACE
#define INTERFACE IDirect3DRMWrap

DECLARE_INTERFACE_(IDirect3DRMWrap,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);

	/*
	* IDirect3DRMWrap methods
	*/
	STDMETHOD(Init)
	( THIS_ D3DRMWRAPTYPE,LPDIRECT3DRMFRAME ref,
	D3DVALUE ox,D3DVALUE oy,D3DVALUE oz,
	D3DVALUE dx,D3DVALUE dy,D3DVALUE dz,
	D3DVALUE ux,D3DVALUE uy,D3DVALUE uz,
	D3DVALUE ou,D3DVALUE ov,
	D3DVALUE su,D3DVALUE sv
	);
	STDMETHOD(Apply)(THIS_ LPDIRECT3DRMOBJECT);
	STDMETHOD(ApplyRelative)(THIS_ LPDIRECT3DRMFRAME frame,LPDIRECT3DRMOBJECT);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMMaterial

DECLARE_INTERFACE_(IDirect3DRMMaterial,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(SetPower)(THIS_ D3DVALUE power);
	STDMETHOD(SetSpecular)(THIS_ D3DVALUE r,D3DVALUE g,D3DVALUE b);
	STDMETHOD(SetEmissive)(THIS_ D3DVALUE r,D3DVALUE g,D3DVALUE b);
	STDMETHOD_(D3DVALUE,GetPower)(THIS);
	STDMETHOD(GetSpecular)(THIS_ D3DVALUE* r,D3DVALUE* g,D3DVALUE* b);
	STDMETHOD(GetEmissive)(THIS_ D3DVALUE* r,D3DVALUE* g,D3DVALUE* b);
};


#undef INTERFACE
#define INTERFACE IDirect3DRMMaterial2

DECLARE_INTERFACE_(IDirect3DRMMaterial2,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(SetPower)(THIS_ D3DVALUE power);
	STDMETHOD(SetSpecular)(THIS_ D3DVALUE r,D3DVALUE g,D3DVALUE b);
	STDMETHOD(SetEmissive)(THIS_ D3DVALUE r,D3DVALUE g,D3DVALUE b);
	STDMETHOD_(D3DVALUE,GetPower)(THIS);
	STDMETHOD(GetSpecular)(THIS_ D3DVALUE* r,D3DVALUE* g,D3DVALUE* b);
	STDMETHOD(GetEmissive)(THIS_ D3DVALUE* r,D3DVALUE* g,D3DVALUE* b);
	STDMETHOD(GetAmbient)(THIS_ D3DVALUE* r,D3DVALUE* g,D3DVALUE* b);
	STDMETHOD(SetAmbient)(THIS_ D3DVALUE r,D3DVALUE g,D3DVALUE b);
};


#undef INTERFACE
#define INTERFACE IDirect3DRMAnimation

DECLARE_INTERFACE_(IDirect3DRMAnimation,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(SetOptions)(THIS_ D3DRMANIMATIONOPTIONS flags);
	STDMETHOD(AddRotateKey)(THIS_ D3DVALUE time,D3DRMQUATERNION *q);
	STDMETHOD(AddPositionKey)(THIS_ D3DVALUE time,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(AddScaleKey)(THIS_ D3DVALUE time,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(DeleteKey)(THIS_ D3DVALUE time);
	STDMETHOD(SetFrame)(THIS_ LPDIRECT3DRMFRAME frame);
	STDMETHOD(SetTime)(THIS_ D3DVALUE time);

	STDMETHOD_(D3DRMANIMATIONOPTIONS,GetOptions)(THIS);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMAnimation2

DECLARE_INTERFACE_(IDirect3DRMAnimation2,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);

	STDMETHOD(SetOptions)(THIS_ D3DRMANIMATIONOPTIONS flags);
	STDMETHOD(AddRotateKey)(THIS_ D3DVALUE time,D3DRMQUATERNION *q);
	STDMETHOD(AddPositionKey)(THIS_ D3DVALUE time,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(AddScaleKey)(THIS_ D3DVALUE time,D3DVALUE x,D3DVALUE y,D3DVALUE z);
	STDMETHOD(DeleteKey)(THIS_ D3DVALUE time);
	STDMETHOD(SetFrame)(THIS_ LPDIRECT3DRMFRAME3 frame);
	STDMETHOD(SetTime)(THIS_ D3DVALUE time);
	STDMETHOD_(D3DRMANIMATIONOPTIONS,GetOptions)(THIS);
	STDMETHOD(GetFrame)(THIS_ LPDIRECT3DRMFRAME3 *lpD3DFrame);
	STDMETHOD(DeleteKeyByID)(THIS_ DWORD dwID);
	STDMETHOD(AddKey)(THIS_ LPD3DRMANIMATIONKEY lpKey);
	STDMETHOD(ModifyKey)(THIS_ LPD3DRMANIMATIONKEY lpKey);
	STDMETHOD(GetKeys)(THIS_ D3DVALUE dvTimeMin,D3DVALUE dvTimeMax,LPDWORD lpdwNumKeys,LPD3DRMANIMATIONKEY lpKey);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMAnimationSet

DECLARE_INTERFACE_(IDirect3DRMAnimationSet,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);

	STDMETHOD(AddAnimation)(THIS_ LPDIRECT3DRMANIMATION aid);
	STDMETHOD(Load)(THIS_ LPVOID filename,LPVOID name,D3DRMLOADOPTIONS loadflags,D3DRMLOADTEXTURECALLBACK,LPVOID lpArg,LPDIRECT3DRMFRAME parent);
	STDMETHOD(DeleteAnimation)(THIS_ LPDIRECT3DRMANIMATION aid);
	STDMETHOD(SetTime)(THIS_ D3DVALUE time);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMAnimationSet2

DECLARE_INTERFACE_(IDirect3DRMAnimationSet2,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);

	STDMETHOD(AddAnimation)(THIS_ LPDIRECT3DRMANIMATION2 aid);
	STDMETHOD(Load)(THIS_ LPVOID filename,LPVOID name,D3DRMLOADOPTIONS loadflags,D3DRMLOADTEXTURE3CALLBACK,LPVOID lpArg,LPDIRECT3DRMFRAME3 parent);
	STDMETHOD(DeleteAnimation)(THIS_ LPDIRECT3DRMANIMATION2 aid);
	STDMETHOD(SetTime)(THIS_ D3DVALUE time);
	STDMETHOD(GetAnimations)(THIS_ LPDIRECT3DRMANIMATIONARRAY *);
};


#undef INTERFACE
#define INTERFACE IDirect3DRMUserVisual

DECLARE_INTERFACE_(IDirect3DRMUserVisual,IDirect3DRMVisual)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);

	STDMETHOD(Init)(THIS_ D3DRMUSERVISUALCALLBACK fn,void *arg);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMArray

DECLARE_INTERFACE_(IDirect3DRMArray,IUnknown)
{
	IUNKNOWN_METHODS(PURE);

	STDMETHOD_(DWORD,GetSize)(THIS);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMObjectArray

DECLARE_INTERFACE_(IDirect3DRMObjectArray,IDirect3DRMArray)
{
	IUNKNOWN_METHODS(PURE);

	STDMETHOD_(DWORD,GetSize)(THIS);
	STDMETHOD(GetElement)(THIS_ DWORD index,LPDIRECT3DRMOBJECT *);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMDeviceArray

DECLARE_INTERFACE_(IDirect3DRMDeviceArray,IDirect3DRMArray)
{
	IUNKNOWN_METHODS(PURE);

	STDMETHOD_(DWORD,GetSize)(THIS);
	STDMETHOD(GetElement)(THIS_ DWORD index,LPDIRECT3DRMDEVICE *);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMFrameArray

DECLARE_INTERFACE_(IDirect3DRMFrameArray,IDirect3DRMArray)
{
	IUNKNOWN_METHODS(PURE);

	STDMETHOD_(DWORD,GetSize)(THIS);
	STDMETHOD(GetElement)(THIS_ DWORD index,LPDIRECT3DRMFRAME *);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMViewportArray

DECLARE_INTERFACE_(IDirect3DRMViewportArray,IDirect3DRMArray)
{
	IUNKNOWN_METHODS(PURE);

	STDMETHOD_(DWORD,GetSize)(THIS);
	STDMETHOD(GetElement)(THIS_ DWORD index,LPDIRECT3DRMVIEWPORT *);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMVisualArray

DECLARE_INTERFACE_(IDirect3DRMVisualArray,IDirect3DRMArray)
{
	IUNKNOWN_METHODS(PURE);

	STDMETHOD_(DWORD,GetSize)(THIS);
	STDMETHOD(GetElement)(THIS_ DWORD index,LPDIRECT3DRMVISUAL *);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMAnimationArray

DECLARE_INTERFACE_(IDirect3DRMAnimationArray,IDirect3DRMArray)
{
	IUNKNOWN_METHODS(PURE);

	STDMETHOD_(DWORD,GetSize)(THIS);
	STDMETHOD(GetElement)(THIS_ DWORD index,LPDIRECT3DRMANIMATION2 *);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMPickedArray

DECLARE_INTERFACE_(IDirect3DRMPickedArray,IDirect3DRMArray)
{
	IUNKNOWN_METHODS(PURE);

	STDMETHOD_(DWORD,GetSize)(THIS);
	STDMETHOD(GetPick)(THIS_ DWORD index,LPDIRECT3DRMVISUAL *,LPDIRECT3DRMFRAMEARRAY *,LPD3DRMPICKDESC);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMLightArray

DECLARE_INTERFACE_(IDirect3DRMLightArray,IDirect3DRMArray)
{
	IUNKNOWN_METHODS(PURE);

	STDMETHOD_(DWORD,GetSize)(THIS);
	STDMETHOD(GetElement)(THIS_ DWORD index,LPDIRECT3DRMLIGHT *);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMFaceArray

DECLARE_INTERFACE_(IDirect3DRMFaceArray,IDirect3DRMArray)
{
	IUNKNOWN_METHODS(PURE);

	STDMETHOD_(DWORD,GetSize)(THIS);
	STDMETHOD(GetElement)(THIS_ DWORD index,LPDIRECT3DRMFACE *);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMPicked2Array

DECLARE_INTERFACE_(IDirect3DRMPicked2Array,IDirect3DRMArray)
{
	IUNKNOWN_METHODS(PURE);

	STDMETHOD_(DWORD,GetSize)(THIS);
	STDMETHOD(GetPick)(THIS_ DWORD index,LPDIRECT3DRMVISUAL *,LPDIRECT3DRMFRAMEARRAY *,LPD3DRMPICKDESC2);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMInterpolator

DECLARE_INTERFACE_(IDirect3DRMInterpolator,IDirect3DRMObject)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(AttachObject)(THIS_ LPDIRECT3DRMOBJECT);
	STDMETHOD(GetAttachedObjects)(THIS_ LPDIRECT3DRMOBJECTARRAY *);
	STDMETHOD(DetachObject)(THIS_ LPDIRECT3DRMOBJECT);
	STDMETHOD(SetIndex)(THIS_ D3DVALUE);
	STDMETHOD_(D3DVALUE,GetIndex)(THIS);
	STDMETHOD(Interpolate)(THIS_ D3DVALUE,LPDIRECT3DRMOBJECT,D3DRMINTERPOLATIONOPTIONS);
};

#undef INTERFACE
#define INTERFACE IDirect3DRMClippedVisual

DECLARE_INTERFACE_(IDirect3DRMClippedVisual,IDirect3DRMVisual)
{
	IUNKNOWN_METHODS(PURE);
	IDIRECT3DRMOBJECT_METHODS(PURE);
	STDMETHOD(Init) (THIS_ LPDIRECT3DRMVISUAL);
	STDMETHOD(AddPlane) (THIS_ LPDIRECT3DRMFRAME3,LPD3DVECTOR,LPD3DVECTOR,DWORD,LPDWORD);
	STDMETHOD(DeletePlane)(THIS_ DWORD,DWORD);
	STDMETHOD(GetPlaneIDs)(THIS_ LPDWORD,LPDWORD,DWORD);
	STDMETHOD(GetPlane) (THIS_ DWORD,LPDIRECT3DRMFRAME3,LPD3DVECTOR,LPD3DVECTOR,DWORD);
	STDMETHOD(SetPlane) (THIS_ DWORD,LPDIRECT3DRMFRAME3,LPD3DVECTOR,LPD3DVECTOR,DWORD);
};
#endif 

