#include "d3dx8.h"
#ifndef __d3dx8effect_h__
#define __d3dx8effect_h__
typedef enum _D3DXPARAMETERTYPE {
D3DXPT_DWORD=0, D3DXPT_FLOAT=1, D3DXPT_VECTOR=2, D3DXPT_MATRIX=3,
D3DXPT_TEXTURE=4, D3DXPT_VERTEXSHADER=5, D3DXPT_PIXELSHADER=6, D3DXPT_CONSTANT=7,
D3DXPT_FORCE_DWORD=0x7fffffff } D3DXPARAMETERTYPE;
typedef struct _D3DXEFFECT_DESC
{
UINT Parameters;
UINT Techniques;
DWORD Usage;
} D3DXEFFECT_DESC;
typedef struct _D3DXPARAMETER_DESC
{
DWORD Name;
D3DXPARAMETERTYPE Type;
} D3DXPARAMETER_DESC;
typedef struct _D3DXTECHNIQUE_DESC
{
DWORD Name;
UINT Passes;
} D3DXTECHNIQUE_DESC;
typedef struct _D3DXPASS_DESC
{
DWORD Name;
} D3DXPASS_DESC;
typedef struct ID3DXEffect *LPD3DXEFFECT;
typedef struct ID3DXTechnique *LPD3DXTECHNIQUE;
DEFINE_GUID(IID_ID3DXTechnique,  0xa00f378d, 0xaf79, 0x4917, 144, 126, 77, 99, 94, 230, 56, 68);
DECLARE_INTERFACE_(ID3DXTechnique, IUnknown)
{
STDMETHOD(QueryInterface)(THIS_ REFIID iid, LPVOID *ppv) ;
STDMETHOD_(ULONG, AddRef)(THIS) ;
STDMETHOD_(ULONG, Release)(THIS) ;
STDMETHOD(GetDevice)(THIS_ LPDIRECT3DDEVICE8* ppDevice) ;
STDMETHOD(GetDesc)(THIS_ D3DXTECHNIQUE_DESC* pDesc) ;
STDMETHOD(GetPassDesc)(THIS_ UINT Index, D3DXPASS_DESC* pDesc) ;
STDMETHOD_(BOOL, IsParameterUsed)(THIS_ DWORD dwName) ;
STDMETHOD(Validate)(THIS) ;
STDMETHOD(Begin)(THIS_ UINT *pPasses) ;
STDMETHOD(Pass)(THIS_ UINT Index) ;
STDMETHOD(End)(THIS) ;
};
DEFINE_GUID(IID_ID3DXEffect,  0x281bbdd4, 0xaedf, 0x4907, 134, 80, 231, 156, 223, 212, 81, 101);
DECLARE_INTERFACE_(ID3DXEffect, IUnknown)
{
STDMETHOD(QueryInterface)(THIS_ REFIID iid, LPVOID *ppv) ;
STDMETHOD_(ULONG, AddRef)(THIS) ;
STDMETHOD_(ULONG, Release)(THIS) ;
STDMETHOD(GetDevice)(THIS_ LPDIRECT3DDEVICE8* ppDevice) ;
STDMETHOD(GetDesc)(THIS_ D3DXEFFECT_DESC* pDesc) ;
STDMETHOD(GetParameterDesc)(THIS_ UINT Index, D3DXPARAMETER_DESC* pDesc) ;
STDMETHOD(GetTechniqueDesc)(THIS_ UINT Index, D3DXTECHNIQUE_DESC* pDesc) ;
STDMETHOD(SetDword)(THIS_ DWORD Name, DWORD dw) ;
STDMETHOD(GetDword)(THIS_ DWORD Name, DWORD* pdw) ; 
STDMETHOD(SetFloat)(THIS_ DWORD Name, FLOAT f) ;
STDMETHOD(GetFloat)(THIS_ DWORD Name, FLOAT* pf) ;
STDMETHOD(SetVector)(THIS_ DWORD Name, D3DXVECTOR4* pVector) ;
STDMETHOD(GetVector)(THIS_ DWORD Name, D3DXVECTOR4* pVector) ;
STDMETHOD(SetMatrix)(THIS_ DWORD Name, D3DXMATRIX* pMatrix) ;
STDMETHOD(GetMatrix)(THIS_ DWORD Name, D3DXMATRIX* pMatrix) ;
STDMETHOD(SetTexture)(THIS_ DWORD Name, LPDIRECT3DBASETEXTURE8 pTexture) ;
STDMETHOD(GetTexture)(THIS_ DWORD Name, LPDIRECT3DBASETEXTURE8 *ppTexture) ;
STDMETHOD(SetVertexShader)(THIS_ DWORD Name, DWORD Handle) ;
STDMETHOD(GetVertexShader)(THIS_ DWORD Name, DWORD* pHandle) ;
STDMETHOD(SetPixelShader)(THIS_ DWORD Name, DWORD Handle) ;
STDMETHOD(GetPixelShader)(THIS_ DWORD Name, DWORD* pHandle) ;
STDMETHOD(GetTechnique)(THIS_ UINT Index, LPD3DXTECHNIQUE* ppTechnique) ;
STDMETHOD(CloneEffect)(THIS_ LPDIRECT3DDEVICE8 pDevice, DWORD Usage, LPD3DXEFFECT* ppEffect) ;
};
HRESULT WINAPI
D3DXCompileEffectFromFileA(LPCSTR pSrcFile, LPD3DXBUFFER* ppCompiledEffect, LPD3DXBUFFER* ppCompilationErrors);
HRESULT WINAPI
D3DXCompileEffectFromFileW(LPCWSTR pSrcFile, LPD3DXBUFFER* ppCompiledEffect, LPD3DXBUFFER* ppCompilationErrors);
#ifdef UNICODE
#define D3DXCompileEffectFromFile D3DXCompileEffectFromFileW
#else
#define D3DXCompileEffectFromFile D3DXCompileEffectFromFileA
#endif
HRESULT WINAPI
D3DXCompileEffect(LPCVOID pSrcData, UINT SrcDataSize, LPD3DXBUFFER* ppCompiledEffect, LPD3DXBUFFER* ppCompilationErrors);
HRESULT WINAPI
D3DXCreateEffect(LPDIRECT3DDEVICE8 pDevice, LPCVOID pCompiledEffect, UINT CompiledEffectSize, DWORD Usage, LPD3DXEFFECT* ppEffect);
#endif 
