#include "d3dx8.h"
#ifndef __d3dx8mesh_h__
#define __d3dx8mesh_h__
#include "dxfile.h"
DEFINE_GUID(IID_ID3DXBaseMesh, 0xa69ba991, 8061, 4563, 185, 41, 0, 192, 79, 104, 220, 35);
DEFINE_GUID(IID_ID3DXMesh,  0x9d84ac46, 0x6b90, 0x49a9, 167, 33, 8, 92, 122, 62, 61, 174);
DEFINE_GUID(IID_ID3DXPMesh,  0x15981aa8, 6661, 0x48e3, 187, 231, 255, 93, 73, 101, 78, 63);
DEFINE_GUID(IID_ID3DXSPMesh,  0xbc3bbde2, 8061, 4563, 185, 41, 0, 192, 79, 104, 220, 35);
DEFINE_GUID(IID_ID3DXSkinMesh,  0x82a53844, 0xf322, 0x409e, 162, 233, 153, 46, 17, 4, 6, 157);
enum _D3DXMESH {
D3DXMESH_32BIT=1,
D3DXMESH_DONOTCLIP=2,
D3DXMESH_POINTS=4,
D3DXMESH_RTPATCHES=8,
D3DXMESH_NPATCHES=0x4000,
D3DXMESH_VB_SYSTEMMEM=16,
D3DXMESH_VB_MANAGED=32,
D3DXMESH_VB_WRITEONLY=64,
D3DXMESH_VB_DYNAMIC=128,
D3DXMESH_IB_SYSTEMMEM=256,
D3DXMESH_IB_MANAGED=512,
D3DXMESH_IB_WRITEONLY=1024,
D3DXMESH_IB_DYNAMIC=2048,
D3DXMESH_VB_SHARE=4096,
D3DXMESH_USEHWONLY=0x2000,
D3DXMESH_SYSTEMMEM=272,
D3DXMESH_MANAGED=544,
D3DXMESH_WRITEONLY=1088,
D3DXMESH_DYNAMIC=2176,
};
enum _D3DXMESHSIMP { D3DXMESHSIMP_VERTEX=1, D3DXMESHSIMP_FACE=2, };
enum _MAX_FVF_DECL_SIZE { MAX_FVF_DECL_SIZE=20 };
typedef struct ID3DXBaseMesh *LPD3DXBASEMESH;
typedef struct ID3DXMesh *LPD3DXMESH;
typedef struct ID3DXPMesh *LPD3DXPMESH;
typedef struct ID3DXSPMesh *LPD3DXSPMESH;
typedef struct ID3DXSkinMesh *LPD3DXSKINMESH;
typedef struct _D3DXATTRIBUTERANGE
{
DWORD AttribId;
DWORD FaceStart;
DWORD FaceCount;
DWORD VertexStart;
DWORD VertexCount;
} D3DXATTRIBUTERANGE;
typedef D3DXATTRIBUTERANGE* LPD3DXATTRIBUTERANGE;
struct D3DXMATERIAL
{
D3DMATERIAL8 MatD3D;
LPSTR pTextureFilename;
};
typedef struct D3DXMATERIAL *LPD3DXMATERIAL;
typedef struct _D3DXATTRIBUTEWEIGHTS
{
FLOAT Position;
FLOAT Boundary;
FLOAT Normal;
FLOAT Diffuse;
FLOAT Specular;
FLOAT Tex[8];
} D3DXATTRIBUTEWEIGHTS;
typedef D3DXATTRIBUTEWEIGHTS* LPD3DXATTRIBUTEWEIGHTS;
DECLARE_INTERFACE_(ID3DXBaseMesh, IUnknown)
{
STDMETHOD(QueryInterface)(THIS_ REFIID iid, LPVOID *ppv) ;
STDMETHOD_(ULONG, AddRef)(THIS) ;
STDMETHOD_(ULONG, Release)(THIS) ;
STDMETHOD(DrawSubset)(THIS_ DWORD AttribId) ;
STDMETHOD_(DWORD, GetNumFaces)(THIS) ;
STDMETHOD_(DWORD, GetNumVertices)(THIS) ;
STDMETHOD_(DWORD, GetFVF)(THIS) ;
STDMETHOD(GetDeclaration)(THIS_ DWORD Declaration[MAX_FVF_DECL_SIZE]) ;
STDMETHOD_(DWORD, GetOptions)(THIS) ;
STDMETHOD(GetDevice)(THIS_ LPDIRECT3DDEVICE8* ppDevice) ;
STDMETHOD(CloneMeshFVF)(THIS_ DWORD Options,  DWORD FVF, LPDIRECT3DDEVICE8 pD3DDevice, LPD3DXMESH* ppCloneMesh) ;
STDMETHOD(CloneMesh)(THIS_ DWORD Options,  CONST DWORD *pDeclaration, LPDIRECT3DDEVICE8 pD3DDevice, LPD3DXMESH* ppCloneMesh) ;
STDMETHOD(GetVertexBuffer)(THIS_ LPDIRECT3DVERTEXBUFFER8* ppVB) ;
STDMETHOD(GetIndexBuffer)(THIS_ LPDIRECT3DINDEXBUFFER8* ppIB) ;
STDMETHOD(LockVertexBuffer)(THIS_ DWORD Flags, BYTE** ppData) ;
STDMETHOD(UnlockVertexBuffer)(THIS) ;
STDMETHOD(LockIndexBuffer)(THIS_ DWORD Flags, BYTE** ppData) ;
STDMETHOD(UnlockIndexBuffer)(THIS) ;
STDMETHOD(GetAttributeTable)(THIS_ D3DXATTRIBUTERANGE *pAttribTable, DWORD* pAttribTableSize) ;
};
DECLARE_INTERFACE_(ID3DXMesh, ID3DXBaseMesh)
{
STDMETHOD(QueryInterface)(THIS_ REFIID iid, LPVOID *ppv) ;
STDMETHOD_(ULONG, AddRef)(THIS) ;
STDMETHOD_(ULONG, Release)(THIS) ;
STDMETHOD(DrawSubset)(THIS_ DWORD AttribId) ;
STDMETHOD_(DWORD, GetNumFaces)(THIS) ;
STDMETHOD_(DWORD, GetNumVertices)(THIS) ;
STDMETHOD_(DWORD, GetFVF)(THIS) ;
STDMETHOD(GetDeclaration)(THIS_ DWORD Declaration[MAX_FVF_DECL_SIZE]) ;
STDMETHOD_(DWORD, GetOptions)(THIS) ;
STDMETHOD(GetDevice)(THIS_ LPDIRECT3DDEVICE8* ppDevice) ;
STDMETHOD(CloneMeshFVF)(THIS_ DWORD Options,  DWORD FVF, LPDIRECT3DDEVICE8 pD3DDevice, LPD3DXMESH* ppCloneMesh) ;
STDMETHOD(CloneMesh)(THIS_ DWORD Options,  CONST DWORD *pDeclaration, LPDIRECT3DDEVICE8 pD3DDevice, LPD3DXMESH* ppCloneMesh) ;
STDMETHOD(GetVertexBuffer)(THIS_ LPDIRECT3DVERTEXBUFFER8* ppVB) ;
STDMETHOD(GetIndexBuffer)(THIS_ LPDIRECT3DINDEXBUFFER8* ppIB) ;
STDMETHOD(LockVertexBuffer)(THIS_ DWORD Flags, BYTE** ppData) ;
STDMETHOD(UnlockVertexBuffer)(THIS) ;
STDMETHOD(LockIndexBuffer)(THIS_ DWORD Flags, BYTE** ppData) ;
STDMETHOD(UnlockIndexBuffer)(THIS) ;
STDMETHOD(GetAttributeTable)(THIS_ D3DXATTRIBUTERANGE *pAttribTable, DWORD* pAttribTableSize) ;
STDMETHOD(LockAttributeBuffer)(THIS_ DWORD Flags, DWORD** ppData) ;
STDMETHOD(UnlockAttributeBuffer)(THIS) ;
STDMETHOD(ConvertPointRepsToAdjacency)(THIS_ CONST DWORD* pPRep, DWORD* pAdjacency) ;
STDMETHOD(ConvertAdjacencyToPointReps)(THIS_ CONST DWORD* pAdjacency, DWORD* pPRep) ;
STDMETHOD(GenerateAdjacency)(THIS_ FLOAT fEpsilon, DWORD* pAdjacency) ;
STDMETHOD(Optimize)(THIS_ DWORD Flags, CONST DWORD* pAdjacencyIn, DWORD* pAdjacencyOut,  DWORD* pFaceRemap, LPD3DXBUFFER *ppVertexRemap,  LPD3DXMESH* ppOptMesh) ;
STDMETHOD(OptimizeInplace)(THIS_ DWORD Flags, CONST DWORD* pAdjacencyIn, DWORD* pAdjacencyOut,  DWORD* pFaceRemap, LPD3DXBUFFER *ppVertexRemap) ;
};
DECLARE_INTERFACE_(ID3DXPMesh, ID3DXBaseMesh)
{
STDMETHOD(QueryInterface)(THIS_ REFIID iid, LPVOID *ppv) ;
STDMETHOD_(ULONG, AddRef)(THIS) ;
STDMETHOD_(ULONG, Release)(THIS) ;
STDMETHOD(DrawSubset)(THIS_ DWORD AttribId) ;
STDMETHOD_(DWORD, GetNumFaces)(THIS) ;
STDMETHOD_(DWORD, GetNumVertices)(THIS) ;
STDMETHOD_(DWORD, GetFVF)(THIS) ;
STDMETHOD(GetDeclaration)(THIS_ DWORD Declaration[MAX_FVF_DECL_SIZE]) ;
STDMETHOD_(DWORD, GetOptions)(THIS) ;
STDMETHOD(GetDevice)(THIS_ LPDIRECT3DDEVICE8* ppDevice) ;
STDMETHOD(CloneMeshFVF)(THIS_ DWORD Options,  DWORD FVF, LPDIRECT3DDEVICE8 pD3DDevice, LPD3DXMESH* ppCloneMesh) ;
STDMETHOD(CloneMesh)(THIS_ DWORD Options,  CONST DWORD *pDeclaration, LPDIRECT3DDEVICE8 pD3DDevice, LPD3DXMESH* ppCloneMesh) ;
STDMETHOD(GetVertexBuffer)(THIS_ LPDIRECT3DVERTEXBUFFER8* ppVB) ;
STDMETHOD(GetIndexBuffer)(THIS_ LPDIRECT3DINDEXBUFFER8* ppIB) ;
STDMETHOD(LockVertexBuffer)(THIS_ DWORD Flags, BYTE** ppData) ;
STDMETHOD(UnlockVertexBuffer)(THIS) ;
STDMETHOD(LockIndexBuffer)(THIS_ DWORD Flags, BYTE** ppData) ;
STDMETHOD(UnlockIndexBuffer)(THIS) ;
STDMETHOD(GetAttributeTable)(THIS_ D3DXATTRIBUTERANGE *pAttribTable, DWORD* pAttribTableSize) ;
STDMETHOD(ClonePMeshFVF)(THIS_ DWORD Options,  DWORD FVF, LPDIRECT3DDEVICE8 pD3D, LPD3DXPMESH* ppCloneMesh) ;
STDMETHOD(ClonePMesh)(THIS_ DWORD Options,  CONST DWORD *pDeclaration, LPDIRECT3DDEVICE8 pD3D, LPD3DXPMESH* ppCloneMesh) ;
STDMETHOD(SetNumFaces)(THIS_ DWORD Faces) ;
STDMETHOD(SetNumVertices)(THIS_ DWORD Vertices) ;
STDMETHOD_(DWORD, GetMaxFaces)(THIS) ;
STDMETHOD_(DWORD, GetMinFaces)(THIS) ;
STDMETHOD_(DWORD, GetMaxVertices)(THIS) ;
STDMETHOD_(DWORD, GetMinVertices)(THIS) ;
STDMETHOD(Save)(THIS_ IStream *pStream, LPD3DXMATERIAL pMaterials, DWORD NumMaterials) ;
STDMETHOD(Optimize)(THIS_ DWORD Flags, DWORD* pAdjacencyOut,  DWORD* pFaceRemap, LPD3DXBUFFER *ppVertexRemap,  LPD3DXMESH* ppOptMesh) ;
STDMETHOD(GetAdjacency)(THIS_ DWORD* pAdjacency) ;
};
DECLARE_INTERFACE_(ID3DXSPMesh, IUnknown)
{
STDMETHOD(QueryInterface)(THIS_ REFIID iid, LPVOID *ppv) ;
STDMETHOD_(ULONG, AddRef)(THIS) ;
STDMETHOD_(ULONG, Release)(THIS) ;
STDMETHOD_(DWORD, GetNumFaces)(THIS) ;
STDMETHOD_(DWORD, GetNumVertices)(THIS) ;
STDMETHOD_(DWORD, GetFVF)(THIS) ;
STDMETHOD(GetDeclaration)(THIS_ DWORD Declaration[MAX_FVF_DECL_SIZE]) ;
STDMETHOD_(DWORD, GetOptions)(THIS) ;
STDMETHOD(GetDevice)(THIS_ LPDIRECT3DDEVICE8* ppDevice) ;
STDMETHOD(CloneMeshFVF)(THIS_ DWORD Options,  DWORD FVF, LPDIRECT3DDEVICE8 pD3D, DWORD *pAdjacencyOut, DWORD *pVertexRemapOut, LPD3DXMESH* ppCloneMesh) ;
STDMETHOD(CloneMesh)(THIS_ DWORD Options,  CONST DWORD *pDeclaration, LPDIRECT3DDEVICE8 pD3DDevice, DWORD *pAdjacencyOut, DWORD *pVertexRemapOut, LPD3DXMESH* ppCloneMesh) ;
STDMETHOD(ClonePMeshFVF)(THIS_ DWORD Options,  DWORD FVF, LPDIRECT3DDEVICE8 pD3D, DWORD *pVertexRemapOut, LPD3DXPMESH* ppCloneMesh) ;
STDMETHOD(ClonePMesh)(THIS_ DWORD Options,  CONST DWORD *pDeclaration, LPDIRECT3DDEVICE8 pD3D, DWORD *pVertexRemapOut, LPD3DXPMESH* ppCloneMesh) ;
STDMETHOD(ReduceFaces)(THIS_ DWORD Faces) ;
STDMETHOD(ReduceVertices)(THIS_ DWORD Vertices) ;
STDMETHOD_(DWORD, GetMaxFaces)(THIS) ;
STDMETHOD_(DWORD, GetMaxVertices)(THIS) ;
};
#define UNUSED16 0xffff
#define UNUSED32 0xffffffff
enum _D3DXMESHOPT {
D3DXMESHOPT_COMPACT=1,
D3DXMESHOPT_ATTRSORT=2,
D3DXMESHOPT_VERTEXCACHE=4,
D3DXMESHOPT_STRIPREORDER=8,
D3DXMESHOPT_IGNOREVERTS=16,
D3DXMESHOPT_SHAREVB=32,
};
typedef struct _D3DXBONECOMBINATION
{
DWORD AttribId;
DWORD FaceStart;
DWORD FaceCount;
DWORD VertexStart;
DWORD VertexCount;
DWORD* BoneId;
} D3DXBONECOMBINATION, *LPD3DXBONECOMBINATION;
DECLARE_INTERFACE_(ID3DXSkinMesh, IUnknown)
{
STDMETHOD(QueryInterface)(THIS_ REFIID iid, LPVOID *ppv) ;
STDMETHOD_(ULONG, AddRef)(THIS) ;
STDMETHOD_(ULONG, Release)(THIS) ;
STDMETHOD_(DWORD, GetNumFaces)(THIS) ;
STDMETHOD_(DWORD, GetNumVertices)(THIS) ;
STDMETHOD_(DWORD, GetFVF)(THIS) ;
STDMETHOD(GetDeclaration)(THIS_ DWORD Declaration[MAX_FVF_DECL_SIZE]) ;
STDMETHOD_(DWORD, GetOptions)(THIS) ;
STDMETHOD(GetDevice)(THIS_ LPDIRECT3DDEVICE8* ppDevice) ;
STDMETHOD(GetVertexBuffer)(THIS_ LPDIRECT3DVERTEXBUFFER8* ppVB) ;
STDMETHOD(GetIndexBuffer)(THIS_ LPDIRECT3DINDEXBUFFER8* ppIB) ;
STDMETHOD(LockVertexBuffer)(THIS_ DWORD flags, BYTE** ppData) ;
STDMETHOD(UnlockVertexBuffer)(THIS) ;
STDMETHOD(LockIndexBuffer)(THIS_ DWORD flags, BYTE** ppData) ;
STDMETHOD(UnlockIndexBuffer)(THIS) ;
STDMETHOD(LockAttributeBuffer)(THIS_ DWORD flags, DWORD** ppData) ;
STDMETHOD(UnlockAttributeBuffer)(THIS) ;
STDMETHOD_(DWORD, GetNumBones)(THIS) ;
STDMETHOD(GetOriginalMesh)(THIS_ LPD3DXMESH* ppMesh) ;
STDMETHOD(SetBoneInfluence)(THIS_ DWORD bone, DWORD numInfluences, CONST DWORD* vertices, CONST FLOAT* weights) ;
STDMETHOD_(DWORD, GetNumBoneInfluences)(THIS_ DWORD bone) ;
STDMETHOD(GetBoneInfluence)(THIS_ DWORD bone, DWORD* vertices, FLOAT* weights) ;
STDMETHOD(GetMaxVertexInfluences)(THIS_ DWORD* maxVertexInfluences) ;
STDMETHOD(GetMaxFaceInfluences)(THIS_ DWORD* maxFaceInfluences) ;
STDMETHOD(ConvertToBlendedMesh)(THIS_ DWORD options, CONST LPDWORD pAdjacencyIn, LPDWORD pAdjacencyOut, DWORD* pNumBoneCombinations, LPD3DXBUFFER* ppBoneCombinationTable, LPD3DXMESH* ppMesh) ;
STDMETHOD(ConvertToIndexedBlendedMesh)(THIS_ DWORD options,  CONST LPDWORD pAdjacencyIn,  DWORD paletteSize,  LPDWORD pAdjacencyOut,  DWORD* pNumBoneCombinations,  LPD3DXBUFFER* ppBoneCombinationTable,  LPD3DXMESH* ppMesh) ;
STDMETHOD(GenerateSkinnedMesh)(THIS_ DWORD options, FLOAT minWeight, CONST LPDWORD pAdjacencyIn, LPDWORD pAdjacencyOut, LPD3DXMESH* ppMesh) ;
STDMETHOD(UpdateSkinnedMesh)(THIS_ CONST D3DXMATRIX* pBoneTransforms, LPD3DXMESH pMesh) ;
};
HRESULT WINAPI D3DXCreateMesh(DWORD,DWORD,DWORD,CONST DWORD *,LPDIRECT3DDEVICE8,LPD3DXMESH*);
HRESULT WINAPI D3DXCreateMeshFVF(DWORD,DWORD,DWORD,DWORD,LPDIRECT3DDEVICE8,LPD3DXMESH*);
HRESULT WINAPI D3DXCreateSPMesh(LPD3DXMESH,CONST DWORD*,CONST LPD3DXATTRIBUTEWEIGHTS,CONST FLOAT *,LPD3DXSPMESH*);
HRESULT WINAPI D3DXCleanMesh(LPD3DXMESH,CONST DWORD*,LPD3DXMESH*);
HRESULT WINAPI D3DXValidMesh(LPD3DXMESH,CONST DWORD*);
HRESULT WINAPI D3DXGeneratePMesh(LPD3DXMESH,CONST DWORD*,CONST LPD3DXATTRIBUTEWEIGHTS,CONST FLOAT *,DWORD,DWORD,LPD3DXPMESH*);
HRESULT WINAPI
D3DXSimplifyMesh(LPD3DXMESH pMesh,  CONST DWORD* pAdjacency,  CONST LPD3DXATTRIBUTEWEIGHTS pVertexAttributeWeights, CONST FLOAT *pVertexWeights, DWORD MinValue,  DWORD Options,  LPD3DXMESH* ppMesh);
HRESULT WINAPI
D3DXComputeBoundingSphere(PVOID pPointsFVF,  DWORD NumVertices,  DWORD FVF, D3DXVECTOR3 *pCenter,  FLOAT *pRadius);
HRESULT WINAPI
D3DXComputeBoundingBox(PVOID pPointsFVF,  DWORD NumVertices,  DWORD FVF, D3DXVECTOR3 *pMin,  D3DXVECTOR3 *pMax);
HRESULT WINAPI D3DXComputeNormals(LPD3DXBASEMESH,DWORD*);
HRESULT WINAPI D3DXCreateBuffer(DWORD,LPD3DXBUFFER *);
HRESULT WINAPI D3DXLoadMeshFromX(LPSTR,DWORD,LPDIRECT3DDEVICE8,LPD3DXBUFFER *,LPD3DXBUFFER *,PDWORD,LPD3DXMESH *);
HRESULT WINAPI
D3DXSaveMeshToX(LPSTR pFilename, LPD3DXMESH pMesh, CONST DWORD* pAdjacency, CONST LPD3DXMATERIAL pMaterials, DWORD NumMaterials, DWORD Format );
HRESULT WINAPI
D3DXCreatePMeshFromStream(IStream *pStream,  DWORD Options, LPDIRECT3DDEVICE8 pD3DDevice,  LPD3DXBUFFER *ppMaterials, DWORD* pNumMaterials, LPD3DXPMESH *ppPMesh);
HRESULT WINAPI
D3DXCreateSkinMesh(DWORD numFaces,  DWORD numVertices,  DWORD numBones, DWORD options,  CONST DWORD *pDeclaration,  LPDIRECT3DDEVICE8 pD3D,  LPD3DXSKINMESH* ppSkinMesh);
HRESULT WINAPI
D3DXCreateSkinMeshFVF(DWORD numFaces,  DWORD numVertices,  DWORD numBones, DWORD options,  DWORD fvf,  LPDIRECT3DDEVICE8 pD3D,  LPD3DXSKINMESH* ppSkinMesh);
HRESULT WINAPI
D3DXCreateSkinMeshFromMesh(LPD3DXMESH pMesh, DWORD numBones, LPD3DXSKINMESH* ppSkinMesh);
HRESULT WINAPI
D3DXLoadMeshFromXof(LPDIRECTXFILEDATA pXofObjMesh,  DWORD Options,  LPDIRECT3DDEVICE8 pD3DDevice,  LPD3DXBUFFER *ppAdjacency, LPD3DXBUFFER *ppMaterials,  PDWORD pNumMaterials, LPD3DXMESH *ppMesh);
HRESULT WINAPI
D3DXLoadSkinMeshFromXof(LPDIRECTXFILEDATA pxofobjMesh,  DWORD options, LPDIRECT3DDEVICE8 pD3D, LPD3DXBUFFER* ppAdjacency, LPD3DXBUFFER* ppMaterials, PDWORD pMatOut, LPD3DXBUFFER* ppBoneNames, LPD3DXBUFFER* ppBoneTransforms, LPD3DXSKINMESH* ppMesh);
HRESULT WINAPI
D3DXTesselateMesh(LPD3DXMESH pMeshIn,  CONST DWORD* pAdjacency,  FLOAT NumSegs,  BOOL QuadraticInterpNormals,  LPD3DXMESH *ppMeshOut);
HRESULT WINAPI
D3DXDeclaratorFromFVF(DWORD FVF, DWORD Declaration[MAX_FVF_DECL_SIZE]);
HRESULT WINAPI
D3DXFVFFromDeclarator(CONST DWORD *pDeclarator, DWORD *pFVF);
HRESULT WINAPI
D3DXWeldVertices(CONST LPD3DXMESH pMesh,  float fEpsilon,  CONST DWORD *rgdwAdjacencyIn,  DWORD *rgdwAdjacencyOut, DWORD* pFaceRemap,  LPD3DXBUFFER *ppbufVertexRemap);
HRESULT WINAPI
D3DXIntersect(LPD3DXBASEMESH pMesh, CONST D3DXVECTOR3 *pRayPos, CONST D3DXVECTOR3 *pRayDir, BOOL *pHit, DWORD *pFaceIndex, FLOAT *pU, FLOAT *pV, FLOAT *pDist);
BOOL WINAPI D3DXSphereBoundProbe(CONST D3DXVECTOR3 *,FLOAT,D3DXVECTOR3 *,D3DXVECTOR3 *);
BOOL WINAPI D3DXBoxBoundProbe(CONST D3DXVECTOR3 *,CONST D3DXVECTOR3 *,D3DXVECTOR3 *,D3DXVECTOR3 *);
enum _D3DXERR {
D3DXERR_CANNOTMODIFYINDEXBUFFER=MAKE_DDHRESULT(2900),
D3DXERR_INVALIDMESH=MAKE_DDHRESULT(2901),
D3DXERR_CANNOTATTRSORT=MAKE_DDHRESULT(2902),
D3DXERR_SKINNINGNOTSUPPORTED=MAKE_DDHRESULT(2903),
D3DXERR_TOOMANYINFLUENCES=MAKE_DDHRESULT(2904),
D3DXERR_INVALIDDATA=MAKE_DDHRESULT(2905),
};
#endif
