#ifndef _DMUSICF_
#define _DMUSICF_
#include <windows.h>
#define COM_NO_WINDOWS_H
#include <objbase.h>
#include <mmsystem.h>
#pragma pack(push,8)
interface IDirectMusicCollection;
typedef interface IDirectMusicCollection IDirectMusicCollection;
#define DMUS_FOURCC_GUID_CHUNK        mmioFOURCC('g','u','i','d')
#define DMUS_FOURCC_INFO_LIST         mmioFOURCC('I','N','F','O')
#define DMUS_FOURCC_UNFO_LIST         mmioFOURCC('U','N','F','O')
#define DMUS_FOURCC_UNAM_CHUNK         mmioFOURCC('U','N','A','M')
#define DMUS_FOURCC_UART_CHUNK         mmioFOURCC('U','A','R','T')
#define DMUS_FOURCC_UCOP_CHUNK         mmioFOURCC('U','C','O','P')
#define DMUS_FOURCC_USBJ_CHUNK         mmioFOURCC('U','S','B','J')
#define DMUS_FOURCC_UCMT_CHUNK         mmioFOURCC('U','C','M','T')
#define DMUS_FOURCC_CATEGORY_CHUNK    mmioFOURCC('c','a','t','g')
#define DMUS_FOURCC_VERSION_CHUNK     mmioFOURCC('v','e','r','s')
typedef struct _DMUS_IO_SEQ_ITEM
{
    MUSIC_TIME    mtTime;
    MUSIC_TIME    mtDuration;
    DWORD         dwPChannel;
    short         nOffset; 
    BYTE          bStatus;
    BYTE          bByte1;
    BYTE          bByte2;
} DMUS_IO_SEQ_ITEM;
typedef struct _DMUS_IO_CURVE_ITEM
{
    MUSIC_TIME  mtStart;
    MUSIC_TIME  mtDuration;
    MUSIC_TIME  mtResetDuration;
    DWORD       dwPChannel;
    short       nOffset;
    short       nStartValue;
    short       nEndValue;
    short       nResetValue;
    BYTE        bType;
    BYTE        bCurveShape;
    BYTE        bCCData;
    BYTE        bFlags;
} DMUS_IO_CURVE_ITEM;


typedef struct _DMUS_IO_TEMPO_ITEM
{
    MUSIC_TIME    lTime;
    double        dblTempo;
} DMUS_IO_TEMPO_ITEM;
typedef struct _DMUS_IO_SYSEX_ITEM
{
    MUSIC_TIME    mtTime;
    DWORD         dwPChannel;
    DWORD         dwSysExLength;
} DMUS_IO_SYSEX_ITEM;


typedef struct _DMUS_IO_TIMESIGNATURE_ITEM
{
    MUSIC_TIME    lTime;
    BYTE          bBeatsPerMeasure;   
    BYTE          bBeat;              
                                      
    WORD          wGridsPerBeat;      
} DMUS_IO_TIMESIGNATURE_ITEM;


typedef struct _DMUS_COMMAND_PARAM
{
    BYTE bCommand;
    BYTE bGrooveLevel;
    BYTE bGrooveRange;
} DMUS_COMMAND_PARAM;

typedef struct _DMUS_COMMAND_PARAM_2
{
	MUSIC_TIME mtTime;
    BYTE bCommand;
    BYTE bGrooveLevel;
    BYTE bGrooveRange;
} DMUS_COMMAND_PARAM_2;

typedef DMUS_CHORD_KEY DMUS_CHORD_PARAM; 

typedef struct _DMUS_RHYTHM_PARAM
{
    DMUS_TIMESIGNATURE  TimeSig;
    DWORD               dwRhythmPattern;
} DMUS_RHYTHM_PARAM;

typedef struct _DMUS_TEMPO_PARAM
{
    MUSIC_TIME  mtTime;
    double      dblTempo;
} DMUS_TEMPO_PARAM;


typedef struct _DMUS_MUTE_PARAM
{
    DWORD   dwPChannel;
    DWORD   dwPChannelMap;
    BOOL    fMute;
} DMUS_MUTE_PARAM;



#define DMUS_FOURCC_STYLE_FORM        mmioFOURCC('D','M','S','T')
#define DMUS_FOURCC_STYLE_CHUNK       mmioFOURCC('s','t','y','h')
#define DMUS_FOURCC_PART_LIST         mmioFOURCC('p','a','r','t')
#define DMUS_FOURCC_PART_CHUNK        mmioFOURCC('p','r','t','h')
#define DMUS_FOURCC_NOTE_CHUNK        mmioFOURCC('n','o','t','e')
#define DMUS_FOURCC_CURVE_CHUNK       mmioFOURCC('c','r','v','e')
#define DMUS_FOURCC_PATTERN_LIST      mmioFOURCC('p','t','t','n')
#define DMUS_FOURCC_PATTERN_CHUNK     mmioFOURCC('p','t','n','h')
#define DMUS_FOURCC_RHYTHM_CHUNK      mmioFOURCC('r','h','t','m')
#define DMUS_FOURCC_PARTREF_LIST      mmioFOURCC('p','r','e','f')
#define DMUS_FOURCC_PARTREF_CHUNK     mmioFOURCC('p','r','f','c')
#define DMUS_FOURCC_STYLE_PERS_REF_LIST   mmioFOURCC('p', 'r', 'r', 'f')
#define DMUS_FOURCC_MOTIFSETTINGS_CHUNK   mmioFOURCC('m', 't', 'f', 's')
#define DMUS_VARIATIONF_MAJOR        0x0000007F     
#define DMUS_VARIATIONF_MINOR        0x00003F80     
#define DMUS_VARIATIONF_OTHER        0x001FC000     
#define DMUS_VARIATIONF_ROOT_SCALE   0x00200000          
#define DMUS_VARIATIONF_ROOT_FLAT    0x00400000          
#define DMUS_VARIATIONF_ROOT_SHARP   0x00800000          
#define DMUS_VARIATIONF_TYPE_TRIAD   0x01000000   
#define DMUS_VARIATIONF_TYPE_6AND7   0x02000000   
#define DMUS_VARIATIONF_TYPE_COMPLEX 0x04000000   
#define DMUS_VARIATIONF_DEST_TO1     0x08000000   
#define DMUS_VARIATIONF_DEST_TO5     0x10000000   
#define DMUS_VARIATIONF_MODES        0xE0000000
#define DMUS_VARIATIONF_IMA25_MODE   0x00000000
#define DMUS_VARIATIONF_DMUS_MODE    0x20000000
#pragma pack(push,2)
typedef struct _DMUS_IO_TIMESIG
{
    BYTE    bBeatsPerMeasure;   
    BYTE    bBeat;              
    WORD    wGridsPerBeat;      
} DMUS_IO_TIMESIG;

typedef struct _DMUS_IO_STYLE
{
    DMUS_IO_TIMESIG     timeSig;        
    double              dblTempo;   
} DMUS_IO_STYLE;

typedef struct _DMUS_IO_VERSION
{
    DWORD               dwVersionMS;        
    DWORD               dwVersionLS;        
} DMUS_IO_VERSION;

typedef struct _DMUS_IO_PATTERN
{
    DMUS_IO_TIMESIG     timeSig;        
    BYTE                bGrooveBottom;  
    BYTE                bGrooveTop;     
    WORD                wEmbellishment; 
    WORD                wNbrMeasures;   
} DMUS_IO_PATTERN;

typedef struct _DMUS_IO_STYLEPART
{
    DMUS_IO_TIMESIG     timeSig;        
    DWORD               dwVariationChoices[32]; 
    GUID                guidPartID;     
    WORD                wNbrMeasures;   
    BYTE                bPlayModeFlags; 
    BYTE                bInvertUpper;   
    BYTE                bInvertLower;   
} DMUS_IO_STYLEPART;

typedef struct _DMUS_IO_PARTREF
{
    GUID    guidPartID;         
    WORD    wLogicalPartID;     
    BYTE    bVariationLockID;   
                                
    BYTE    bSubChordLevel;     
    BYTE    bPriority;          
                                
                                
    BYTE    bRandomVariation;   
                                
} DMUS_IO_PARTREF;

typedef struct _DMUS_IO_STYLENOTE
{
    MUSIC_TIME  mtGridStart;    
    DWORD       dwVariation;    
    MUSIC_TIME  mtDuration;     
    short       nTimeOffset;    
    WORD        wMusicValue;    
    BYTE        bVelocity;      
    BYTE        bTimeRange;     
    BYTE        bDurRange;      
    BYTE        bVelRange;      
    BYTE        bInversionID;   
    BYTE        bPlayModeFlags; 
} DMUS_IO_STYLENOTE;

typedef struct _DMUS_IO_STYLECURVE
{
    MUSIC_TIME  mtGridStart;    
    DWORD       dwVariation;    
    MUSIC_TIME  mtDuration;     
    MUSIC_TIME  mtResetDuration;
    short       nTimeOffset;    
    short       nStartValue;    
    short       nEndValue;      
    short       nResetValue;    
    BYTE        bEventType;     
    BYTE        bCurveShape;    
    BYTE        bCCData;        
    BYTE        bFlags;         /* Bit 1=TRUE means to send nResetValue. Otherwise, don't.
                                   Other bits are reserved. */
} DMUS_IO_STYLECURVE;

typedef struct _DMUS_IO_MOTIFSETTINGS
{
    DWORD       dwRepeats;      
    MUSIC_TIME  mtPlayStart;    
    MUSIC_TIME  mtLoopStart;    
    MUSIC_TIME  mtLoopEnd;      
    DWORD       dwResolution;   
} DMUS_IO_MOTIFSETTINGS;
#pragma pack(pop)
#define DMUS_FOURCC_CHORDTRACK_LIST         mmioFOURCC('c','o','r','d')
#define DMUS_FOURCC_CHORDTRACKHEADER_CHUNK  mmioFOURCC('c','r','d','h')
#define DMUS_FOURCC_CHORDTRACKBODY_CHUNK    mmioFOURCC('c','r','d','b')
#define DMUS_FOURCC_COMMANDTRACK_CHUNK      mmioFOURCC('c','m','n','d')
typedef struct _DMUS_IO_CHORD
{
    WCHAR       wszName[16];    
    MUSIC_TIME  mtTime;         
    WORD        wMeasure;       
    BYTE        bBeat;          
} DMUS_IO_CHORD;

typedef struct _DMUS_IO_SUBCHORD
{
    DWORD   dwChordPattern;     
    DWORD   dwScalePattern;     
    DWORD   dwInversionPoints;  
    DWORD   dwLevels;           
    BYTE    bChordRoot;         
    BYTE    bScaleRoot;         
} DMUS_IO_SUBCHORD;

typedef struct _DMUS_IO_COMMAND
{
    MUSIC_TIME  mtTime;         
    WORD        wMeasure;       
    BYTE        bBeat;          
    BYTE        bCommand;       
    BYTE        bGrooveLevel;   
    BYTE        bGrooveRange;   
} DMUS_IO_COMMAND;
#define DMUS_FOURCC_TOOLGRAPH_FORM  mmioFOURCC('D','M','T','G')
#define DMUS_FOURCC_TOOL_LIST       mmioFOURCC('t','o','l','l')
#define DMUS_FOURCC_TOOL_FORM       mmioFOURCC('D','M','T','L')
#define DMUS_FOURCC_TOOL_CHUNK      mmioFOURCC('t','o','l','h')
typedef struct _DMUS_IO_TOOL_HEADER
{
    GUID        guidClassID;    
    long        lIndex;         
    DWORD       cPChannels;     
    FOURCC      ckid;           
    FOURCC      fccType;        
    DWORD       dwPChannels[1]; 
} DMUS_IO_TOOL_HEADER;
#define DMUS_FOURCC_BANDTRACK_FORM  mmioFOURCC('D','M','B','T')
#define DMUS_FOURCC_BANDTRACK_CHUNK mmioFOURCC('b','d','t','h')
#define DMUS_FOURCC_BANDS_LIST      mmioFOURCC('l','b','d','l')
#define DMUS_FOURCC_BAND_LIST       mmioFOURCC('l','b','n','d')
#define DMUS_FOURCC_BANDITEM_CHUNK  mmioFOURCC('b','d','i','h')
typedef struct _DMUS_IO_BAND_TRACK_HEADER
{
    BOOL bAutoDownload;     
} DMUS_IO_BAND_TRACK_HEADER;

typedef struct _DMUS_IO_BAND_ITEM_HEADER
{
    MUSIC_TIME lBandTime;   
} DMUS_IO_BAND_ITEM_HEADER;

#define DMUS_FOURCC_BAND_FORM           mmioFOURCC('D','M','B','D')
#define DMUS_FOURCC_INSTRUMENTS_LIST    mmioFOURCC('l','b','i','l')
#define DMUS_FOURCC_INSTRUMENT_LIST     mmioFOURCC('l','b','i','n')
#define DMUS_FOURCC_INSTRUMENT_CHUNK    mmioFOURCC('b','i','n','s')
#define DMUS_IO_INST_PATCH          (1 << 0)        
#define DMUS_IO_INST_BANKSELECT     (1 << 1)        
#define DMUS_IO_INST_ASSIGN_PATCH   (1 << 3)        
#define DMUS_IO_INST_NOTERANGES     (1 << 4)        
#define DMUS_IO_INST_PAN            (1 << 5)        
#define DMUS_IO_INST_VOLUME         (1 << 6 )       
#define DMUS_IO_INST_TRANSPOSE      (1 << 7)        
#define DMUS_IO_INST_GM             (1 << 8)        
#define DMUS_IO_INST_GS             (1 << 9)        
#define DMUS_IO_INST_XG             (1 << 10)       
#define DMUS_IO_INST_CHANNEL_PRIORITY (1 << 11)     
#define DMUS_IO_INST_USE_DEFAULT_GM_SET (1 << 12)   
typedef struct _DMUS_IO_INSTRUMENT
{
    DWORD   dwPatch;            
    DWORD   dwAssignPatch;      
    DWORD   dwNoteRanges[4];    
    DWORD   dwPChannel;         
    DWORD   dwFlags;            
    BYTE    bPan;               
    BYTE    bVolume;            
    short   nTranspose;         
    DWORD   dwChannelPriority;  
} DMUS_IO_INSTRUMENT;
#define DMUS_FOURCC_SEGMENT_FORM    mmioFOURCC('D','M','S','G')
#define DMUS_FOURCC_SEGMENT_CHUNK   mmioFOURCC('s','e','g','h')
#define DMUS_FOURCC_TRACK_LIST      mmioFOURCC('t','r','k','l')
#define DMUS_FOURCC_TRACK_FORM      mmioFOURCC('D','M','T','K')
#define DMUS_FOURCC_TRACK_CHUNK     mmioFOURCC('t','r','k','h')
typedef struct _DMUS_IO_SEGMENT_HEADER
{
    DWORD       dwRepeats;      
    MUSIC_TIME  mtLength;       
    MUSIC_TIME  mtPlayStart;    
    MUSIC_TIME  mtLoopStart;    
    MUSIC_TIME  mtLoopEnd;      
    DWORD       dwResolution;   
} DMUS_IO_SEGMENT_HEADER;
typedef struct _DMUS_IO_TRACK_HEADER
{
    GUID        guidClassID;    
    DWORD       dwPosition;     
    DWORD       dwGroup;        
    FOURCC      ckid;           
    FOURCC      fccType;        
} DMUS_IO_TRACK_HEADER;
#define DMUS_FOURCC_REF_LIST        mmioFOURCC('D','M','R','F')
#define DMUS_FOURCC_REF_CHUNK       mmioFOURCC('r','e','f','h')
#define DMUS_FOURCC_DATE_CHUNK      mmioFOURCC('d','a','t','e')
#define DMUS_FOURCC_NAME_CHUNK      mmioFOURCC('n','a','m','e')
#define DMUS_FOURCC_FILE_CHUNK      mmioFOURCC('f','i','l','e')
typedef struct _DMUS_IO_REFERENCE
{
    GUID    guidClassID;    
    DWORD   dwValidData;    
} DMUS_IO_REFERENCE;
#define DMUS_FOURCC_CHORDMAP_FORM       mmioFOURCC('D','M','P','R')
#define DMUS_FOURCC_IOCHORDMAP_CHUNK    mmioFOURCC('p','e','r','h')
#define DMUS_FOURCC_SUBCHORD_CHUNK      mmioFOURCC('c','h','d','t')
#define DMUS_FOURCC_CHORDENTRY_CHUNK    mmioFOURCC('c','h','e','h')
#define DMUS_FOURCC_SUBCHORDID_CHUNK    mmioFOURCC('s','b','c','n')
#define DMUS_FOURCC_IONEXTCHORD_CHUNK   mmioFOURCC('n','c','r','d')
#define DMUS_FOURCC_NEXTCHORDSEQ_CHUNK  mmioFOURCC('n','c','s','q')
#define DMUS_FOURCC_IOSIGNPOST_CHUNK    mmioFOURCC('s','p','s','h')
#define DMUS_FOURCC_CHORDNAME_CHUNK     mmioFOURCC('I','N','A','M')
#define DMUS_FOURCC_CHORDENTRY_LIST     mmioFOURCC('c','h','o','e')
#define DMUS_FOURCC_CHORDMAP_LIST       mmioFOURCC('c','m','a','p')
#define DMUS_FOURCC_CHORD_LIST          mmioFOURCC('c','h','r','d')
#define DMUS_FOURCC_CHORDPALETTE_LIST   mmioFOURCC('c','h','p','l')
#define DMUS_FOURCC_CADENCE_LIST        mmioFOURCC('c','a','d','e')
#define DMUS_FOURCC_SIGNPOSTITEM_LIST   mmioFOURCC('s','p','s','t')
#define DMUS_FOURCC_SIGNPOST_LIST       mmioFOURCC('s','p','s','q')
#define DMUS_SIGNPOSTF_A        1      
#define DMUS_SIGNPOSTF_B        2
#define DMUS_SIGNPOSTF_C        4
#define DMUS_SIGNPOSTF_D        8
#define DMUS_SIGNPOSTF_E        0x10
#define DMUS_SIGNPOSTF_F        0x20
#define DMUS_SIGNPOSTF_LETTER   (DMUS_SIGNPOSTF_A | DMUS_SIGNPOSTF_B | DMUS_SIGNPOSTF_C | DMUS_SIGNPOSTF_D | DMUS_SIGNPOSTF_E | DMUS_SIGNPOSTF_F)
#define DMUS_SIGNPOSTF_1        0x100
#define DMUS_SIGNPOSTF_2        0x200
#define DMUS_SIGNPOSTF_3        0x400
#define DMUS_SIGNPOSTF_4        0x800
#define DMUS_SIGNPOSTF_5        0x1000
#define DMUS_SIGNPOSTF_6        0x2000
#define DMUS_SIGNPOSTF_7        0x4000
#define DMUS_SIGNPOSTF_ROOT     (DMUS_SIGNPOSTF_1 | DMUS_SIGNPOSTF_2 | DMUS_SIGNPOSTF_3 | DMUS_SIGNPOSTF_4 | DMUS_SIGNPOSTF_5 | DMUS_SIGNPOSTF_6 | DMUS_SIGNPOSTF_7)
#define DMUS_SIGNPOSTF_CADENCE  0x8000
#define DMUS_SPOSTCADENCEF_1  2   
#define DMUS_SPOSTCADENCEF_2  4   
typedef struct _DMUS_IO_CHORDMAP
{
    WCHAR   wszLoadName[20];
    DWORD   dwScalePattern;
    DWORD   dwFlags;
} DMUS_IO_CHORDMAP;

typedef struct _DMUS_IO_CHORDMAP_SUBCHORD
{
    DWORD   dwChordPattern;
    DWORD   dwScalePattern;
    DWORD   dwInvertPattern;
    BYTE    bChordRoot;
    BYTE    bScaleRoot;
    WORD    wCFlags;
    DWORD   dwLevels;   
} DMUS_IO_CHORDMAP_SUBCHORD;
typedef DMUS_IO_CHORDMAP_SUBCHORD DMUS_IO_PERS_SUBCHORD;

typedef struct _DMUS_IO_CHORDENTRY
{
    DWORD   dwFlags;
    WORD    wConnectionID;  
} DMUS_IO_CHORDENTRY;
typedef struct _DMUS_IO_NEXTCHORD
{
    DWORD   dwFlags;
    WORD    nWeight;
    WORD    wMinBeats;
    WORD    wMaxBeats;
    WORD    wConnectionID;  
} DMUS_IO_NEXTCHORD;
typedef struct _DMUS_IO_CHORDMAP_SIGNPOST
{
    DWORD   dwChords;   
    DWORD   dwFlags;
} DMUS_IO_CHORDMAP_SIGNPOST;
typedef DMUS_IO_CHORDMAP_SIGNPOST DMUS_IO_PERS_SIGNPOST;
#define DMUS_FOURCC_SIGNPOST_TRACK_CHUNK     mmioFOURCC( 's', 'g', 'n', 'p' )
typedef struct _DMUS_IO_SIGNPOST
{
    MUSIC_TIME  mtTime;
    DWORD       dwChords;
    WORD        wMeasure;
} DMUS_IO_SIGNPOST;
#define DMUS_FOURCC_MUTE_CHUNK  mmioFOURCC('m','u','t','e')
typedef struct _DMUS_IO_MUTE
{
    MUSIC_TIME  mtTime;
    DWORD       dwPChannel;
    DWORD       dwPChannelMap;
} DMUS_IO_MUTE;
#define DMUS_FOURCC_TIME_STAMP_CHUNK    mmioFOURCC('s', 't', 'm', 'p')
#define DMUS_FOURCC_STYLE_TRACK_LIST    mmioFOURCC('s', 't', 't', 'r')
#define DMUS_FOURCC_STYLE_REF_LIST      mmioFOURCC('s', 't', 'r', 'f')
#define DMUS_FOURCC_PERS_TRACK_LIST mmioFOURCC('p', 'f', 't', 'r')
#define DMUS_FOURCC_PERS_REF_LIST   mmioFOURCC('p', 'f', 'r', 'f')
#define DMUS_FOURCC_TEMPO_TRACK     mmioFOURCC('t','e','t','r')
#define DMUS_FOURCC_SEQ_TRACK       mmioFOURCC('s','e','q','t')
#define DMUS_FOURCC_SEQ_LIST        mmioFOURCC('e','v','t','l')
#define DMUS_FOURCC_CURVE_LIST      mmioFOURCC('c','u','r','l')
#define DMUS_FOURCC_SYSEX_TRACK     mmioFOURCC('s','y','e','x')
#define DMUS_FOURCC_TIMESIGNATURE_TRACK mmioFOURCC('t','i','m','s')
#pragma pack(pop)
#endif 
