#ifndef __dmusici_h__
#define __dmusici_h__
#include <windows.h>
#define COM_NO_WINDOWS_H
#include <objbase.h>
#include <mmsystem.h>
#include "dmusicc.h"
#pragma pack(push,8)
typedef WORD    TRANSITION_TYPE;
typedef __int64   REFERENCE_TIME;
typedef long    MUSIC_TIME;
#define DMUS_PPQ    768   

interface IDirectMusic;
interface IDirectMusicTrack;
interface IDirectMusicPerformance;
interface IDirectMusicTool;
interface IDirectMusicSegment;
interface IDirectMusicSegmentState;
interface IDirectMusicGraph;
interface IDirectMusicPort;
interface IDirectMusicBuffer;
interface IDirectMusicInstrument;
interface IDirectMusicDownloadedInstrument;
interface IDirectMusicBand;
interface IDirectMusicChordMap;
interface IDirectMusicLoader;
interface IDirectMusicObject;
#ifndef __cplusplus 
typedef interface IDirectMusic IDirectMusic;
typedef interface IDirectMusicTrack IDirectMusicTrack;
typedef interface IDirectMusicPerformance IDirectMusicPerformance;
typedef interface IDirectMusicTool IDirectMusicTool;
typedef interface IDirectMusicSegment IDirectMusicSegment;
typedef interface IDirectMusicSegmentState IDirectMusicSegmentState;
typedef interface IDirectMusicGraph IDirectMusicGraph;
typedef interface IDirectMusicPort IDirectMusicPort;
typedef interface IDirectMusicBuffer IDirectMusicBuffer;
typedef interface IDirectMusicInstrument IDirectMusicInstrument;
typedef interface IDirectMusicDownloadedInstrument IDirectMusicDownloadedInstrument;
typedef interface IDirectMusicBand IDirectMusicBand;
typedef interface IDirectMusicChordMap IDirectMusicChordMap;
typedef interface IDirectMusicObject IDirectMusicObject;
typedef interface IDirectMusicLoader IDirectMusicLoader;
#endif

typedef enum enumDMUS_COMMANDT_TYPES
{
  DMUS_COMMANDT_GROOVE    = 0,
  DMUS_COMMANDT_FILL      = 1,
  DMUS_COMMANDT_INTRO     = 2,
  DMUS_COMMANDT_BREAK     = 3,
  DMUS_COMMANDT_END     = 4,
  DMUS_COMMANDT_ENDANDINTRO   = 5
} DMUS_COMMANDT_TYPES;

typedef enum enumDMUS_SHAPET_TYPES
{
  DMUS_SHAPET_FALLING     = 0,
  DMUS_SHAPET_LEVEL     = 1,
  DMUS_SHAPET_LOOPABLE    = 2,
  DMUS_SHAPET_LOUD      = 3,
  DMUS_SHAPET_QUIET     = 4,
  DMUS_SHAPET_PEAKING     = 5,
  DMUS_SHAPET_RANDOM      = 6,
  DMUS_SHAPET_RISING      = 7,
  DMUS_SHAPET_SONG      = 8
} DMUS_SHAPET_TYPES;

typedef enum enumDMUS_COMPOSEF_FLAGS
{   
  DMUS_COMPOSEF_NONE      = 0,
  DMUS_COMPOSEF_ALIGN     = 0x1,
  DMUS_COMPOSEF_OVERLAP     = 0x2,
  DMUS_COMPOSEF_IMMEDIATE   = 0x4,
  DMUS_COMPOSEF_GRID      = 0x8,
  DMUS_COMPOSEF_BEAT      = 0x10,
  DMUS_COMPOSEF_MEASURE     = 0x20,
  DMUS_COMPOSEF_AFTERPREPARETIME  = 0x40,
  DMUS_COMPOSEF_MODULATE    = 0x1000,
  DMUS_COMPOSEF_LONG      = 0x2000
} DMUS_COMPOSEF_FLAGS;

#define DMUS_PMSG_PART                          \
  DWORD     dwSize;                       \
  REFERENCE_TIME  rtTime;         \
  MUSIC_TIME    mtTime;                   \
  DWORD     dwFlags;      \
  DWORD     dwPChannel;       \
                   \
  DWORD     dwVirtualTrackID;             \
  IDirectMusicTool* pTool;              \
  IDirectMusicGraph*  pGraph;             \
  DWORD     dwType;         \
  DWORD     dwVoiceID;      \
                 \
                      \
  DWORD     dwGroupID;               \
  IUnknown*     punkUser;     

typedef struct _DMUS_PMSG { DMUS_PMSG_PART } DMUS_PMSG;


typedef enum enumDMUS_PMSGF_FLAGS
{
  DMUS_PMSGF_REFTIME    = 1,  
  DMUS_PMSGF_MUSICTIME    = 2,  
  DMUS_PMSGF_TOOL_IMMEDIATE = 4,   
  DMUS_PMSGF_TOOL_QUEUE   = 8,  
  DMUS_PMSGF_TOOL_ATTIME  = 16,   
  DMUS_PMSGF_TOOL_FLUSH   = 32  
  
  
} DMUS_PMSGF_FLAGS;


typedef enum enumDMUS_PMSGT_TYPES
{
  DMUS_PMSGT_MIDI     = 0,  
  DMUS_PMSGT_NOTE     = 1,  
  DMUS_PMSGT_SYSEX    = 2,  
  DMUS_PMSGT_NOTIFICATION   = 3,  
  DMUS_PMSGT_TEMPO    = 4,  
  DMUS_PMSGT_CURVE    = 5,  
  DMUS_PMSGT_TIMESIG    = 6,  
  DMUS_PMSGT_PATCH    = 7,  
  DMUS_PMSGT_TRANSPOSE    = 8,  
  DMUS_PMSGT_CHANNEL_PRIORITY = 9,  
  DMUS_PMSGT_STOP     = 10,   
  DMUS_PMSGT_DIRTY    = 11,   
  DMUS_PMSGT_USER     = 255   
} DMUS_PMSGT_TYPES;


typedef enum enumDMUS_SEGF_FLAGS
{
  DMUS_SEGF_REFTIME     = 64,   
  DMUS_SEGF_SECONDARY   = 128,  
  DMUS_SEGF_QUEUE     = 256,  
  DMUS_SEGF_CONTROL     = 512,  
  DMUS_SEGF_AFTERPREPARETIME  = 1<<10,  
  DMUS_SEGF_GRID      = 1<<11,  
  DMUS_SEGF_BEAT      = 1<<12,  
  DMUS_SEGF_MEASURE     = 1<<13,  
  DMUS_SEGF_DEFAULT     = 1<<14,  
  DMUS_SEGF_NOINVALIDATE  = 1<<15 
} DMUS_SEGF_FLAGS;




typedef enum enumDMUS_TIME_RESOLVE_FLAGS
{
  DMUS_TIME_RESOLVE_AFTERPREPARETIME  = 1<<10,  
  DMUS_TIME_RESOLVE_GRID      = 1<<11,  
  DMUS_TIME_RESOLVE_BEAT      = 1<<12,  
  DMUS_TIME_RESOLVE_MEASURE     = 1<<13 
} DMUS_TIME_RESOLVE_FLAGS;



typedef enum enumDMUS_TRACKF_FLAGS
{
  DMUS_TRACKF_SEEK    = 1,  
  DMUS_TRACKF_LOOP    = 2,  
  DMUS_TRACKF_START     = 4,  
  DMUS_TRACKF_FLUSH     = 8,  
  DMUS_TRACKF_DIRTY     = 16,   
} DMUS_TRACKF_FLAGS;

#define DMUS_MAXSUBCHORD 8

typedef struct _DMUS_SUBCHORD
{
  DWORD dwChordPattern;   
  DWORD dwScalePattern;   
  DWORD dwInversionPoints;  
  DWORD dwLevels;     
  BYTE  bChordRoot;   
  BYTE  bScaleRoot;   
} DMUS_SUBCHORD;

typedef struct _DMUS_CHORD_KEY
{
  WCHAR     wszName[16];    
  WORD    wMeasure;     
  BYTE    bBeat;      
  BYTE    bSubChordCount;   
  DMUS_SUBCHORD SubChordList[DMUS_MAXSUBCHORD]; 
  DWORD     dwScale;    
  BYTE    bKey;     
} DMUS_CHORD_KEY;


typedef struct _DMUS_NOTE_PMSG
{
  
  DMUS_PMSG_PART
  

  MUSIC_TIME mtDuration;   
  WORD  wMusicValue;   
  WORD  wMeasure;    
  short nOffset;     
  BYTE  bBeat;     
  BYTE  bGrid;     
  BYTE  bVelocity;   
  BYTE  bFlags;    
  BYTE  bTimeRange;    
  BYTE  bDurRange;   
  BYTE  bVelRange;   
  BYTE  bPlayModeFlags;  
  BYTE  bSubChordLevel;  
  BYTE  bMidiValue;    
  char  cTranspose;    
} DMUS_NOTE_PMSG;

typedef enum enumDMUS_NOTEF_FLAGS
{
  DMUS_NOTEF_NOTEON = 1,   
} DMUS_NOTEF_FLAGS;

typedef enum enumDMUS_PLAYMODE_FLAGS
{
  DMUS_PLAYMODE_KEY_ROOT    = 1,  
  DMUS_PLAYMODE_CHORD_ROOT    = 2,  
  DMUS_PLAYMODE_SCALE_INTERVALS = 4,  
  DMUS_PLAYMODE_CHORD_INTERVALS = 8,  
  DMUS_PLAYMODE_NONE      = 16, 
} DMUS_PLAYMODE_FLAGS;
#define DMUS_PLAYMODE_FIXED     0  
#define DMUS_PLAYMODE_FIXEDTOKEY    DMUS_PLAYMODE_KEY_ROOT
#define DMUS_PLAYMODE_FIXEDTOCHORD  DMUS_PLAYMODE_CHORD_ROOT
#define DMUS_PLAYMODE_PEDALPOINT    (DMUS_PLAYMODE_KEY_ROOT | DMUS_PLAYMODE_SCALE_INTERVALS)
#define DMUS_PLAYMODE_MELODIC     (DMUS_PLAYMODE_CHORD_ROOT | DMUS_PLAYMODE_SCALE_INTERVALS)
#define DMUS_PLAYMODE_NORMALCHORD   (DMUS_PLAYMODE_CHORD_ROOT | DMUS_PLAYMODE_CHORD_INTERVALS)
#define DMUS_PLAYMODE_ALWAYSPLAY    (DMUS_PLAYMODE_MELODIC | DMUS_PLAYMODE_NORMALCHORD)
#define DMUS_PLAYMODE_PURPLEIZED    DMUS_PLAYMODE_ALWAYSPLAY
#define DMUS_PLAYMODE_SCALE_ROOT    DMUS_PLAYMODE_KEY_ROOT
#define DMUS_PLAYMODE_FIXEDTOSCALE  DMUS_PLAYMODE_FIXEDTOKEY



typedef struct _DMUS_MIDI_PMSG
{
  
  DMUS_PMSG_PART
  

  BYTE  bStatus;
  BYTE  bByte1;
  BYTE  bByte2;
  BYTE  bPad[1];
} DMUS_MIDI_PMSG;


typedef struct _DMUS_PATCH_PMSG
{
  
  DMUS_PMSG_PART
  

  BYTE  byInstrument;
  BYTE  byMSB;
  BYTE  byLSB;
  BYTE  byPad[1];
} DMUS_PATCH_PMSG;


typedef struct _DMUS_TRANSPOSE_PMSG
{
  
  DMUS_PMSG_PART
  

  short nTranspose;
} DMUS_TRANSPOSE_PMSG;


typedef struct _DMUS_CHANNEL_PRIORITY_PMSG
{
  
  DMUS_PMSG_PART
  

  DWORD dwChannelPriority;
} DMUS_CHANNEL_PRIORITY_PMSG;


typedef struct _DMUS_TEMPO_PMSG
{
  
  DMUS_PMSG_PART
  

  double  dblTempo;         
} DMUS_TEMPO_PMSG;

#define DMUS_TEMPO_MAX    1000
#define DMUS_TEMPO_MIN    1

#define DMUS_MASTERTEMPO_MAX  100.0f
#define DMUS_MASTERTEMPO_MIN  0.01f


typedef struct _DMUS_SYSEX_PMSG
{
  
  DMUS_PMSG_PART
  

  DWORD dwLen;    
  BYTE  abData[1];  
} DMUS_SYSEX_PMSG;


typedef struct _DMUS_CURVE_PMSG
{
  
  DMUS_PMSG_PART
  

  MUSIC_TIME  mtDuration;  
  MUSIC_TIME  mtOriginalStart; 
  MUSIC_TIME  mtResetDuration; 
  short     nStartValue;   
  short     nEndValue;   
  short     nResetValue;   
  WORD    wMeasure;    
  short     nOffset;   
  BYTE    bBeat;     
  BYTE    bGrid;     
  BYTE    bType;     
  BYTE    bCurveShape;   
  BYTE    bCCData;   
  BYTE    bFlags;     
} DMUS_CURVE_PMSG;

typedef enum enumDMUS_CURVE_FLAGS
{
  DMUS_CURVE_RESET = 1,     
} DMUS_CURVE_FLAGS;


#define DMUS_CURVE_RESET  1    


enum { DMUS_CURVES_LINEAR  = 0, DMUS_CURVES_INSTANT = 1, DMUS_CURVES_EXP   = 2, DMUS_CURVES_LOG   = 3, DMUS_CURVES_SINE  = 4
};

#define DMUS_CURVET_PBCURVE  0x03
#define DMUS_CURVET_CCCURVE  0x04
#define DMUS_CURVET_MATCURVE   0x05
#define DMUS_CURVET_PATCURVE   0x06


typedef struct _DMUS_TIMESIG_PMSG
{
  DMUS_PMSG_PART
  BYTE  bBeatsPerMeasure;   
  BYTE  bBeat;      
  WORD  wGridsPerBeat;    
} DMUS_TIMESIG_PMSG;
#define DMUS_NOTIFICATION_SEGSTART  0
#define DMUS_NOTIFICATION_SEGEND    1
#define DMUS_NOTIFICATION_SEGALMOSTEND  2
#define DMUS_NOTIFICATION_SEGLOOP   3
#define DMUS_NOTIFICATION_SEGABORT  4

#define DMUS_NOTIFICATION_MUSICSTARTED  0
#define DMUS_NOTIFICATION_MUSICSTOPPED  1

#define DMUS_NOTIFICATION_MEASUREBEAT 0

#define DMUS_NOTIFICATION_CHORD   0

#define DMUS_NOTIFICATION_GROOVE    0
#define DMUS_NOTIFICATION_EMBELLISHMENT 1


typedef struct _DMUS_NOTIFICATION_PMSG
{
  
  DMUS_PMSG_PART
  

  GUID  guidNotificationType;
  DWORD dwNotificationOption;
  DWORD dwField1;
  DWORD dwField2;
} DMUS_NOTIFICATION_PMSG;


#define DMUS_MAX_NAME     64   
#define DMUS_MAX_CATEGORY   64   
#define DMUS_MAX_FILENAME   MAX_PATH
  
typedef struct _DMUS_VERSION {
  DWORD  dwVersionMS;
  DWORD  dwVersionLS;
}DMUS_VERSION, FAR *LPDMUS_VERSION;



typedef struct _DMUS_TIMESIGNATURE
{
  MUSIC_TIME mtTime;
  BYTE  bBeatsPerMeasure;   
  BYTE  bBeat;      
            
  WORD  wGridsPerBeat;    
} DMUS_TIMESIGNATURE;




typedef struct _DMUS_OBJECTDESC
{
  DWORD    dwSize;       
  DWORD    dwValidData;    
  GUID     guidObject;     
  GUID     guidClass;      
  FILETIME   ftDate;       
  DMUS_VERSION vVersion;     
  WCHAR    wszName[DMUS_MAX_NAME]; 
  WCHAR    wszCategory[DMUS_MAX_CATEGORY]; 
  WCHAR    wszFileName[DMUS_MAX_FILENAME]; 
  LONGLONG   llMemLength;    
  LPBYTE   pbMemData;      
} DMUS_OBJECTDESC;

typedef DMUS_OBJECTDESC *LPDMUS_OBJECTDESC;
#define DMUS_OBJ_OBJECT   (1 << 0)   
#define DMUS_OBJ_CLASS    (1 << 1)   
#define DMUS_OBJ_NAME     (1 << 2)   
#define DMUS_OBJ_CATEGORY   (1 << 3)   
#define DMUS_OBJ_FILENAME   (1 << 4)   
#define DMUS_OBJ_FULLPATH   (1 << 5)   
#define DMUS_OBJ_URL    (1 << 6)   
#define DMUS_OBJ_VERSION    (1 << 7)   
#define DMUS_OBJ_DATE     (1 << 8)   
#define DMUS_OBJ_LOADED   (1 << 9)   
#define DMUS_OBJ_MEMORY   (1 << 10)  
typedef IDirectMusicObject __RPC_FAR *LPDMUS_OBJECT;
typedef IDirectMusicLoader __RPC_FAR *LPDMUS_LOADER;
typedef IDirectMusicBand __RPC_FAR *LPDMUS_BAND;
#define DMUSB_LOADED  (1 << 0)    
#define DMUSB_DEFAULT (1 << 1)    

#undef  INTERFACE
#define INTERFACE  IDirectMusicBand
DECLARE_INTERFACE_(IDirectMusicBand, IUnknown)
{
  
  STDMETHOD(QueryInterface)   (THIS_ REFIID, LPVOID FAR *) ;
  STDMETHOD_(ULONG,AddRef)    (THIS) ;
  STDMETHOD_(ULONG,Release)   (THIS) ;

  
  STDMETHOD(CreateSegment)    (THIS_ IDirectMusicSegment** ppSegment) ;
  STDMETHOD(Download)     (THIS_ IDirectMusicPerformance* pPerformance) ;   
  STDMETHOD(Unload)     (THIS_ IDirectMusicPerformance* pPerformance) ;   
};

#undef  INTERFACE
#define INTERFACE  IDirectMusicObject
DECLARE_INTERFACE_(IDirectMusicObject, IUnknown)
{
  
  STDMETHOD(QueryInterface)   (THIS_ REFIID, LPVOID FAR *) ;
  STDMETHOD_(ULONG,AddRef)    (THIS) ;
  STDMETHOD_(ULONG,Release)   (THIS) ;

  
  STDMETHOD(GetDescriptor)    (THIS_ LPDMUS_OBJECTDESC pDesc) ;
  STDMETHOD(SetDescriptor)    (THIS_ LPDMUS_OBJECTDESC pDesc) ;
  STDMETHOD(ParseDescriptor)  (THIS_ LPSTREAM pStream, 
               LPDMUS_OBJECTDESC pDesc) ;
};

#undef  INTERFACE
#define INTERFACE  IDirectMusicLoader
DECLARE_INTERFACE_(IDirectMusicLoader, IUnknown)
{
  
  STDMETHOD(QueryInterface)   (THIS_ REFIID, LPVOID FAR *) ;
  STDMETHOD_(ULONG,AddRef)    (THIS) ;
  STDMETHOD_(ULONG,Release)   (THIS) ;

  
  STDMETHOD(GetObject)    (THIS_ LPDMUS_OBJECTDESC pDesc,
               REFIID riid,
               LPVOID FAR *ppv) ;
  STDMETHOD(SetObject)    (THIS_ LPDMUS_OBJECTDESC pDesc) ;
  STDMETHOD(SetSearchDirectory) (THIS_ REFGUID rguidClass, 
               WCHAR *pwzPath, 
               BOOL fClear) ;
  STDMETHOD(ScanDirectory)    (THIS_ REFGUID rguidClass, 
               WCHAR *pwzFileExtension, 
               WCHAR *pwzScanFileName) ;
  STDMETHOD(CacheObject)    (THIS_ IDirectMusicObject * pObject) ;
  STDMETHOD(ReleaseObject)    (THIS_ IDirectMusicObject * pObject) ;
  STDMETHOD(ClearCache)     (THIS_ REFGUID rguidClass) ;
  STDMETHOD(EnableCache)    (THIS_ REFGUID rguidClass, 
               BOOL fEnable) ;
  STDMETHOD(EnumObject)     (THIS_ REFGUID rguidClass, 
               DWORD dwIndex, 
               LPDMUS_OBJECTDESC pDesc) ;
};            



#undef  INTERFACE
#define INTERFACE  IDirectMusicGetLoader
DECLARE_INTERFACE_(IDirectMusicGetLoader, IUnknown)
{
  
  STDMETHOD(QueryInterface)   (THIS_ REFIID, LPVOID FAR *) ;
  STDMETHOD_(ULONG,AddRef)    (THIS) ;
  STDMETHOD_(ULONG,Release)   (THIS) ;

  
  STDMETHOD(GetLoader)    (THIS_ IDirectMusicLoader ** ppLoader) ;
};

#undef  INTERFACE
#define INTERFACE  IDirectMusicSegment
DECLARE_INTERFACE_(IDirectMusicSegment, IUnknown)
{
  
  STDMETHOD(QueryInterface)   (THIS_ REFIID, LPVOID FAR *) ;
  STDMETHOD_(ULONG,AddRef)    (THIS) ;
  STDMETHOD_(ULONG,Release)   (THIS) ;

  
  STDMETHOD(GetLength)      (THIS_ MUSIC_TIME* pmtLength) ;
  STDMETHOD(SetLength)      (THIS_ MUSIC_TIME mtLength) ;
  STDMETHOD(GetRepeats)     (THIS_ DWORD* pdwRepeats) ;
  STDMETHOD(SetRepeats)     (THIS_ DWORD  dwRepeats) ;
  STDMETHOD(GetDefaultResolution)   (THIS_ DWORD* pdwResolution) ;
  STDMETHOD(SetDefaultResolution)   (THIS_ DWORD  dwResolution) ;
  STDMETHOD(GetTrack)       (THIS_ REFGUID rguidType, 
                 DWORD dwGroupBits, 
                 DWORD dwIndex, 
                 IDirectMusicTrack** ppTrack) ;
  STDMETHOD(GetTrackGroup)    (THIS_ IDirectMusicTrack* pTrack, 
                 DWORD* pdwGroupBits) ;
  STDMETHOD(InsertTrack)      (THIS_ IDirectMusicTrack* pTrack, 
                 DWORD dwGroupBits) ;
  STDMETHOD(RemoveTrack)      (THIS_ IDirectMusicTrack* pTrack) ;
  STDMETHOD(InitPlay)       (THIS_ IDirectMusicSegmentState** ppSegState, 
                 IDirectMusicPerformance* pPerformance,
                 DWORD dwFlags) ;
  STDMETHOD(GetGraph)       (THIS_ IDirectMusicGraph** ppGraph) ;
  STDMETHOD(SetGraph)       (THIS_ IDirectMusicGraph* pGraph) ;
  STDMETHOD(AddNotificationType)  (THIS_ REFGUID rguidNotificationType) ;
  STDMETHOD(RemoveNotificationType) (THIS_ REFGUID rguidNotificationType) ;
  STDMETHOD(GetParam)       (THIS_ REFGUID rguidType, 
                 DWORD dwGroupBits, 
                 DWORD dwIndex, 
                 MUSIC_TIME mtTime, 
                 MUSIC_TIME* pmtNext, 
                 void* pParam) ; 
  STDMETHOD(SetParam)       (THIS_ REFGUID rguidType, 
                 DWORD dwGroupBits, 
                 DWORD dwIndex, 
                 MUSIC_TIME mtTime, 
                 void* pParam) ;
  STDMETHOD(Clone)        (THIS_ MUSIC_TIME mtStart, 
                 MUSIC_TIME mtEnd, 
                 IDirectMusicSegment** ppSegment) ;
  STDMETHOD(SetStartPoint)    (THIS_ MUSIC_TIME mtStart) ;
  STDMETHOD(GetStartPoint)    (THIS_ MUSIC_TIME* pmtStart) ;
  STDMETHOD(SetLoopPoints)    (THIS_ MUSIC_TIME mtStart, 
                 MUSIC_TIME mtEnd) ;
  STDMETHOD(GetLoopPoints)    (THIS_ MUSIC_TIME* pmtStart, 
                 MUSIC_TIME* pmtEnd) ;
  STDMETHOD(SetPChannelsUsed)   (THIS_ DWORD dwNumPChannels, 
                 DWORD* paPChannels) ;
};

#undef  INTERFACE
#define INTERFACE  IDirectMusicSegmentState
DECLARE_INTERFACE_(IDirectMusicSegmentState, IUnknown)
{
  
  STDMETHOD(QueryInterface)   (THIS_ REFIID, LPVOID FAR *) ;
  STDMETHOD_(ULONG,AddRef)    (THIS) ;
  STDMETHOD_(ULONG,Release)   (THIS) ;

  
  STDMETHOD(GetRepeats)     (THIS_ DWORD* pdwRepeats) ;
  STDMETHOD(GetSegment )    (THIS_ IDirectMusicSegment** ppSegment) ;
  STDMETHOD(GetStartTime)   (THIS_ MUSIC_TIME* pmtStart) ;
  STDMETHOD(GetSeek)      (THIS_ MUSIC_TIME* pmtSeek) ;
  STDMETHOD(GetStartPoint)    (THIS_ MUSIC_TIME* pmtStart) ;
};
#undef  INTERFACE
#define INTERFACE  IDirectMusicTrack
DECLARE_INTERFACE_(IDirectMusicTrack, IUnknown)
{
  
  STDMETHOD(QueryInterface)   (THIS_ REFIID, LPVOID FAR *) ;
  STDMETHOD_(ULONG,AddRef)    (THIS) ;
  STDMETHOD_(ULONG,Release)   (THIS) ;

  
  STDMETHOD(Init)       (THIS_ IDirectMusicSegment* pSegment) ;
  STDMETHOD(InitPlay)     (THIS_ IDirectMusicSegmentState* pSegmentState, 
               IDirectMusicPerformance* pPerformance, 
               void** ppStateData, 
               DWORD dwVirtualTrackID,
               DWORD dwFlags) ;
  STDMETHOD(EndPlay)      (THIS_ void* pStateData) ;
  STDMETHOD(Play)       (THIS_ void* pStateData, 
               MUSIC_TIME mtStart, 
               MUSIC_TIME mtEnd, 
               MUSIC_TIME mtOffset, 
               DWORD dwFlags, 
               IDirectMusicPerformance* pPerf, 
               IDirectMusicSegmentState* pSegSt, 
               DWORD dwVirtualID) ;
  STDMETHOD(GetParam)     (THIS_ REFGUID rguidType, 
               MUSIC_TIME mtTime, 
               MUSIC_TIME* pmtNext, 
               void* pParam) ; 
  STDMETHOD(SetParam)     (THIS_ REFGUID rguidType, 
               MUSIC_TIME mtTime, 
               void* pParam) ;
  STDMETHOD(IsParamSupported)   (THIS_ REFGUID rguidType) ;
  STDMETHOD(AddNotificationType)  (THIS_ REFGUID rguidNotificationType) ;
  STDMETHOD(RemoveNotificationType) (THIS_ REFGUID rguidNotificationType) ;
  STDMETHOD(Clone)      (THIS_ MUSIC_TIME mtStart, 
               MUSIC_TIME mtEnd, 
               IDirectMusicTrack** ppTrack) ;
};

#undef  INTERFACE
#define INTERFACE  IDirectMusicPerformance
DECLARE_INTERFACE_(IDirectMusicPerformance, IUnknown)
{
  
  STDMETHOD(QueryInterface)   (THIS_ REFIID, LPVOID FAR *) ;
  STDMETHOD_(ULONG,AddRef)    (THIS) ;
  STDMETHOD_(ULONG,Release)   (THIS) ;

  
  STDMETHOD(Init)       (THIS_ IDirectMusic** ppDirectMusic,
               LPDIRECTSOUND pDirectSound,
               HWND hWnd) ;
  STDMETHOD(PlaySegment)    (THIS_ IDirectMusicSegment* pSegment, 
               DWORD dwFlags, 
               __int64 i64StartTime, 
               IDirectMusicSegmentState** ppSegmentState) ;
  STDMETHOD(Stop)       (THIS_ IDirectMusicSegment* pSegment, 
               IDirectMusicSegmentState* pSegmentState, 
               MUSIC_TIME mtTime, 
               DWORD dwFlags) ;
  STDMETHOD(GetSegmentState)  (THIS_ IDirectMusicSegmentState** ppSegmentState, 
               MUSIC_TIME mtTime) ;
  STDMETHOD(SetPrepareTime)   (THIS_ DWORD dwMilliSeconds) ;
  STDMETHOD(GetPrepareTime)   (THIS_ DWORD* pdwMilliSeconds) ;
  STDMETHOD(SetBumperLength)  (THIS_ DWORD dwMilliSeconds) ;
  STDMETHOD(GetBumperLength)  (THIS_ DWORD* pdwMilliSeconds) ;
  STDMETHOD(SendPMsg)     (THIS_ DMUS_PMSG* pPMSG) ;
  STDMETHOD(MusicToReferenceTime) (THIS_ MUSIC_TIME mtTime, 
               REFERENCE_TIME* prtTime) ;
  STDMETHOD(ReferenceToMusicTime) (THIS_ REFERENCE_TIME rtTime, 
               MUSIC_TIME* pmtTime) ;
  STDMETHOD(IsPlaying)    (THIS_ IDirectMusicSegment* pSegment, 
               IDirectMusicSegmentState* pSegState) ;
  STDMETHOD(GetTime)      (THIS_ REFERENCE_TIME* prtNow, 
               MUSIC_TIME* pmtNow) ;
  STDMETHOD(AllocPMsg)    (THIS_ ULONG cb, 
               DMUS_PMSG** ppPMSG) ;
  STDMETHOD(FreePMsg)     (THIS_ DMUS_PMSG* pPMSG) ;
  STDMETHOD(GetGraph)     (THIS_ IDirectMusicGraph** ppGraph) ;
  STDMETHOD(SetGraph)     (THIS_ IDirectMusicGraph* pGraph) ;
  STDMETHOD(SetNotificationHandle)(THIS_ HANDLE hNotification, 
               REFERENCE_TIME rtMinimum) ;
  STDMETHOD(GetNotificationPMsg)  (THIS_ DMUS_NOTIFICATION_PMSG** ppNotificationPMsg) ;
  STDMETHOD(AddNotificationType)  (THIS_ REFGUID rguidNotificationType) ;
  STDMETHOD(RemoveNotificationType)(THIS_ REFGUID rguidNotificationType) ;
  STDMETHOD(AddPort)      (THIS_ IDirectMusicPort* pPort) ;
  STDMETHOD(RemovePort)     (THIS_ IDirectMusicPort* pPort ) ;
  STDMETHOD(AssignPChannelBlock)  (THIS_ DWORD dwBlockNum, 
               IDirectMusicPort* pPort, 
               DWORD dwGroup ) ;
  STDMETHOD(AssignPChannel)   (THIS_ DWORD dwPChannel, 
               IDirectMusicPort* pPort, 
               DWORD dwGroup, 
               DWORD dwMChannel ) ;
  STDMETHOD(PChannelInfo)   (THIS_ DWORD dwPChannel, 
               IDirectMusicPort** ppPort, 
               DWORD* pdwGroup, 
               DWORD* pdwMChannel ) ;
  STDMETHOD(DownloadInstrument) (THIS_ IDirectMusicInstrument* pInst, 
               DWORD dwPChannel, 
               IDirectMusicDownloadedInstrument** ppDownInst, 
               DMUS_NOTERANGE* pNoteRanges, 
               DWORD dwNumNoteRanges, 
               IDirectMusicPort** ppPort, 
               DWORD* pdwGroup, 
               DWORD* pdwMChannel ) ;
  STDMETHOD(Invalidate)     (THIS_ MUSIC_TIME mtTime, 
               DWORD dwFlags) ;
  STDMETHOD(GetParam)     (THIS_ REFGUID rguidType, 
               DWORD dwGroupBits, 
               DWORD dwIndex, 
               MUSIC_TIME mtTime, 
               MUSIC_TIME* pmtNext, 
               void* pParam) ; 
  STDMETHOD(SetParam)     (THIS_ REFGUID rguidType, 
               DWORD dwGroupBits, 
               DWORD dwIndex, 
               MUSIC_TIME mtTime, 
               void* pParam) ;
  STDMETHOD(GetGlobalParam)   (THIS_ REFGUID rguidType, 
               void* pParam, 
               DWORD dwSize) ;
  STDMETHOD(SetGlobalParam)   (THIS_ REFGUID rguidType, 
               void* pParam, 
               DWORD dwSize) ;
  STDMETHOD(GetLatencyTime)   (THIS_ REFERENCE_TIME* prtTime) ;
  STDMETHOD(GetQueueTime)   (THIS_ REFERENCE_TIME* prtTime) ;
  STDMETHOD(AdjustTime)     (THIS_ REFERENCE_TIME rtAmount) ;
  STDMETHOD(CloseDown)    (THIS) ;
  STDMETHOD(GetResolvedTime)  (THIS_ REFERENCE_TIME rtTime,
               REFERENCE_TIME* prtResolved,
               DWORD dwTimeResolveFlags) ;
  STDMETHOD(MIDIToMusic)    (THIS_ BYTE bMIDIValue,
               DMUS_CHORD_KEY* pChord,
               BYTE bPlayMode,
               BYTE bChordLevel,
               WORD *pwMusicValue) ;
  STDMETHOD(MusicToMIDI)    (THIS_ WORD wMusicValue,
               DMUS_CHORD_KEY* pChord,
               BYTE bPlayMode,
               BYTE bChordLevel,
               BYTE *pbMIDIValue) ;
  STDMETHOD(TimeToRhythm)   (THIS_ MUSIC_TIME mtTime,
               DMUS_TIMESIGNATURE *pTimeSig,
               WORD *pwMeasure,
               BYTE *pbBeat,
               BYTE *pbGrid,
               short *pnOffset) ;
  STDMETHOD(RhythmToTime)   (THIS_ WORD wMeasure,
               BYTE bBeat,
               BYTE bGrid,
               short nOffset,
               DMUS_TIMESIGNATURE *pTimeSig,
               MUSIC_TIME *pmtTime) ;              
};

#undef  INTERFACE
#define INTERFACE  IDirectMusicTool
DECLARE_INTERFACE_(IDirectMusicTool, IUnknown)
{
  
  STDMETHOD(QueryInterface)   (THIS_ REFIID, LPVOID FAR *) ;
  STDMETHOD_(ULONG,AddRef)    (THIS) ;
  STDMETHOD_(ULONG,Release)   (THIS) ;

  
  STDMETHOD(Init)       (THIS_ IDirectMusicGraph* pGraph) ;
  STDMETHOD(GetMsgDeliveryType) (THIS_ DWORD* pdwDeliveryType ) ;
  STDMETHOD(GetMediaTypeArraySize)(THIS_ DWORD* pdwNumElements ) ;
  STDMETHOD(GetMediaTypes)    (THIS_ DWORD** padwMediaTypes, 
               DWORD dwNumElements) ;
  STDMETHOD(ProcessPMsg)    (THIS_ IDirectMusicPerformance* pPerf, 
               DMUS_PMSG* pPMSG) ;
  STDMETHOD(Flush)      (THIS_ IDirectMusicPerformance* pPerf, 
               DMUS_PMSG* pPMSG, 
               REFERENCE_TIME rtTime) ;
};

#undef  INTERFACE
#define INTERFACE  IDirectMusicGraph
DECLARE_INTERFACE_(IDirectMusicGraph, IUnknown)
{
  
  STDMETHOD(QueryInterface)   (THIS_ REFIID, LPVOID FAR *) ;
  STDMETHOD_(ULONG,AddRef)    (THIS) ;
  STDMETHOD_(ULONG,Release)   (THIS) ;

  
  STDMETHOD(StampPMsg)    (THIS_ DMUS_PMSG* pPMSG) ;
  STDMETHOD(InsertTool)     (THIS_ IDirectMusicTool* pTool, 
               DWORD* pdwPChannels, 
               DWORD cPChannels, 
               LONG lIndex) ;
  STDMETHOD(GetTool)      (THIS_ DWORD dwIndex, 
               IDirectMusicTool** ppTool) ;
  STDMETHOD(RemoveTool)     (THIS_ IDirectMusicTool* pTool) ;
};

#undef  INTERFACE
#define INTERFACE  IDirectMusicStyle
DECLARE_INTERFACE_(IDirectMusicStyle, IUnknown)
{
  
  STDMETHOD(QueryInterface)   (THIS_ REFIID, LPVOID FAR *) ;
  STDMETHOD_(ULONG,AddRef)    (THIS) ;
  STDMETHOD_(ULONG,Release)   (THIS) ;

  
  STDMETHOD(GetBand)      (THIS_ WCHAR* pwszName, 
               IDirectMusicBand** ppBand) ;
  STDMETHOD(EnumBand)     (THIS_ DWORD dwIndex, 
               WCHAR *pwszName) ;
  STDMETHOD(GetDefaultBand)   (THIS_ IDirectMusicBand** ppBand) ;
  STDMETHOD(EnumMotif)      (THIS_ DWORD dwIndex, 
               WCHAR* pwszName) ;
  STDMETHOD(GetMotif)     (THIS_ WCHAR* pwszName, 
               IDirectMusicSegment** ppSegment) ;
  STDMETHOD(GetDefaultChordMap)   (THIS_ IDirectMusicChordMap** ppChordMap) ;
  STDMETHOD(EnumChordMap)     (THIS_ DWORD dwIndex, 
               WCHAR *pwszName) ;
  STDMETHOD(GetChordMap)    (THIS_ WCHAR* pwszName, 
               IDirectMusicChordMap** ppChordMap) ;
  STDMETHOD(GetTimeSignature)   (THIS_ DMUS_TIMESIGNATURE* pTimeSig) ;
  STDMETHOD(GetEmbellishmentLength) (THIS_ DWORD dwType, 
               DWORD dwLevel, 
               DWORD* pdwMin, 
               DWORD* pdwMax) ;
  STDMETHOD(GetTempo)     (THIS_ double* pTempo) ;
};

#undef  INTERFACE
#define INTERFACE  IDirectMusicChordMap
DECLARE_INTERFACE_(IDirectMusicChordMap, IUnknown)
{
  
  STDMETHOD(QueryInterface)   (THIS_ REFIID, LPVOID FAR *) ;
  STDMETHOD_(ULONG,AddRef)    (THIS) ;
  STDMETHOD_(ULONG,Release)   (THIS) ;

  
  STDMETHOD(GetScale)     (THIS_ DWORD* pdwScale) ;
};
#undef  INTERFACE
#define INTERFACE  IDirectMusicComposer
DECLARE_INTERFACE_(IDirectMusicComposer, IUnknown)
{
  
  STDMETHOD(QueryInterface)     (THIS_ REFIID, LPVOID FAR *) ;
  STDMETHOD_(ULONG,AddRef)      (THIS) ;
  STDMETHOD_(ULONG,Release)     (THIS) ;

  
  STDMETHOD(ComposeSegmentFromTemplate) (THIS_ IDirectMusicStyle* pStyle, 
                 IDirectMusicSegment* pTemplate, 
                 WORD wActivity, 
                 IDirectMusicChordMap* pChordMap, 
                 IDirectMusicSegment** ppSegment) ;
  STDMETHOD(ComposeSegmentFromShape)  (THIS_ IDirectMusicStyle* pStyle, 
                 WORD wNumMeasures, 
                 WORD wShape, 
                 WORD wActivity, 
                 BOOL fIntro, 
                 BOOL fEnd, 
                 IDirectMusicChordMap* pChordMap, 
                 IDirectMusicSegment** ppSegment ) ;
  STDMETHOD(ComposeTransition)    (THIS_ IDirectMusicSegment* pFromSeg, 
                 IDirectMusicSegment* pToSeg, 
                 MUSIC_TIME mtTime, 
                 WORD wCommand, 
                 DWORD dwFlags, 
                 IDirectMusicChordMap* pChordMap, 
                 IDirectMusicSegment** ppTransSeg) ;
  STDMETHOD(AutoTransition)     (THIS_ IDirectMusicPerformance* pPerformance, 
                 IDirectMusicSegment* pToSeg, 
                 WORD wCommand, 
                 DWORD dwFlags, 
                 IDirectMusicChordMap* pChordMap, 
                 IDirectMusicSegment** ppTransSeg, 
                 IDirectMusicSegmentState** ppToSegState, 
                 IDirectMusicSegmentState** ppTransSegState) ;
  STDMETHOD(ComposeTemplateFromShape)   (THIS_ WORD wNumMeasures, 
                 WORD wShape, 
                 BOOL fIntro, 
                 BOOL fEnd, 
                 WORD wEndLength, 
                 IDirectMusicSegment** ppTemplate) ;
  STDMETHOD(ChangeChordMap)    (THIS_ IDirectMusicSegment* pSegment, 
                 BOOL fTrackScale, 
                 IDirectMusicChordMap* pChordMap) ;
};


DEFINE_GUID(CLSID_DirectMusicPerformance,0xd2ac2881, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicSegment,0xd2ac2882, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicSegmentState,0xd2ac2883, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicGraph,0xd2ac2884, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicTempoTrack,0xd2ac2885, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicSeqTrack,0xd2ac2886, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicSysExTrack,0xd2ac2887, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicTimeSigTrack,0xd2ac2888, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicStyle,0xd2ac288a, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicChordTrack,0xd2ac288b, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicCommandTrack,0xd2ac288c, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicStyleTrack,0xd2ac288d, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicMotifTrack,0xd2ac288e, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicChordMap,0xd2ac288f, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicComposer,0xd2ac2890, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicSignPostTrack,0xf17e8672, 0xc3b4, 0x11d1, 0x87, 0xb, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicLoader,0xd2ac2892, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicBandTrack,0xd2ac2894, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicBand,0x79ba9e00, 0xb6ee, 0x11d1, 0x86, 0xbe, 0x0, 0xc0, 0x4f, 0xbf, 0x8f, 0xef);
DEFINE_GUID(CLSID_DirectMusicChordMapTrack,0xd2ac2896, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicMuteTrack,0xd2ac2898, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);


DEFINE_GUID(GUID_DirectMusicAllTypes,0xd2ac2893, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);


DEFINE_GUID(GUID_NOTIFICATION_SEGMENT,0xd2ac2899, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_NOTIFICATION_PERFORMANCE,0x81f75bc5, 0x4e5d, 0x11d2, 0xbc, 0xc7, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(GUID_NOTIFICATION_MEASUREANDBEAT,0xd2ac289a, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_NOTIFICATION_CHORD,0xd2ac289b, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_NOTIFICATION_COMMAND,0xd2ac289c, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);



DEFINE_GUID(GUID_CommandParam,0xd2ac289d, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);


DEFINE_GUID(GUID_CommandParam2, 0x28f97ef7, 0x9538, 0x11d2, 0x97, 0xa9, 0x0, 0xc0, 0x4f, 0xa3, 0x6e, 0x58);
DEFINE_GUID(GUID_ChordParam,0xd2ac289e, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_RhythmParam,0xd2ac289f, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_IDirectMusicStyle,0xd2ac28a1, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_TimeSignature,0xd2ac28a4, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_TempoParam,0xd2ac28a5, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_IDirectMusicBand,0xd2ac28ac, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_IDirectMusicChordMap,0xd2ac28ad, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_MuteParam,0xd2ac28af, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_Download,0xd2ac28a7, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_Unload,0xd2ac28a8, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_ConnectToDLSCollection, 0x1db1ae6b, 0xe92e, 0x11d1, 0xa8, 0xc5, 0x0, 0xc0, 0x4f, 0xa3, 0x72, 0x6e);
DEFINE_GUID(GUID_Enable_Auto_Download,0xd2ac28a9, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_Disable_Auto_Download,0xd2ac28aa, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_Clear_All_Bands,0xd2ac28ab, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_StandardMIDIFile, 0x6621075, 0xe92e, 0x11d1, 0xa8, 0xc5, 0x0, 0xc0, 0x4f, 0xa3, 0x72, 0x6e);
#define GUID_IgnoreBankSelectForGM 	GUID_StandardMIDIFile
DEFINE_GUID(GUID_DisableTimeSig, 0x45fc707b, 0x1db4, 0x11d2, 0xbc, 0xac, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(GUID_EnableTimeSig, 0x45fc707c, 0x1db4, 0x11d2, 0xbc, 0xac, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(GUID_DisableTempo, 0x45fc707d, 0x1db4, 0x11d2, 0xbc, 0xac, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(GUID_EnableTempo, 0x45fc707e, 0x1db4, 0x11d2, 0xbc, 0xac, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(GUID_SeedVariations, 0x65b76fa5, 0xff37, 0x11d2, 0x81, 0x4e, 0x0, 0xc0, 0x4f, 0xa3, 0x6e, 0x58);
DEFINE_GUID(GUID_PerfMasterTempo,0xd2ac28b0, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_PerfMasterVolume,0xd2ac28b1, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_PerfMasterGrooveLevel,0xd2ac28b2, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_PerfAutoDownload, 0xfb09565b, 0x3631, 0x11d2, 0xbc, 0xb8, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(GUID_DefaultGMCollection, 0xf17e8673, 0xc3b4, 0x11d1, 0x87, 0xb, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicLoader, 0x2ffaaca2, 0x5dca, 0x11d2, 0xaf, 0xa6, 0x0, 0xaa, 0x0, 0x24, 0xd8, 0xb6);
DEFINE_GUID(IID_IDirectMusicGetLoader,0x68a04844, 0xd13d, 0x11d1, 0xaf, 0xa6, 0x0, 0xaa, 0x0, 0x24, 0xd8, 0xb6);
DEFINE_GUID(IID_IDirectMusicObject,0xd2ac28b5, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicSegment, 0xf96029a2, 0x4282, 0x11d2, 0x87, 0x17, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicSegmentState, 0xa3afdcc7, 0xd3ee, 0x11d1, 0xbc, 0x8d, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(IID_IDirectMusicTrack, 0xf96029a1, 0x4282, 0x11d2, 0x87, 0x17, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicPerformance,0x7d43d03, 0x6523, 0x11d2, 0x87, 0x1d, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicTool,0xd2ac28ba, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicGraph,0x2befc277, 0x5497, 0x11d2, 0xbc, 0xcb, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(IID_IDirectMusicStyle,0xd2ac28bd, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicChordMap,0xd2ac28be, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicComposer,0xd2ac28bf, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicBand,0xd2ac28c0, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicPerformance2,0x6fc2cae0, 0xbc78, 0x11d2, 0xaf, 0xa6, 0x0, 0xaa, 0x0, 0x24, 0xd8, 0xb6);
DEFINE_GUID(IID_IDirectMusicSegment2, 0xd38894d1, 0xc052, 0x11d2, 0x87, 0x2f, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
#pragma pack(pop)

#endif 
