#ifndef __DPLAY_INCLUDED__
#define __DPLAY_INCLUDED__
#include <ole2.h> 
#ifndef _WIN64
#define DWORD_PTR DWORD
#endif
typedef LPVOID (*LPRGLPVOID)[];
typedef LPRGLPVOID PRGPVOID, LPRGPVOID, PRGLPVOID, PAPVOID, LPAPVOID, PALPVOID, LPALPVOID;
#define VOL volatile
typedef VOID *VOL LPVOIDV;
#define _FACDP 2167
#define MAKE_DPHRESULT(code) MAKE_HRESULT(1, _FACDP, code)
DEFINE_GUID(IID_IDirectPlay2, 0x2b74f7c0, 0x9154, 4559, 169, 205, 0, 170, 0, 104, 134, 227);
DEFINE_GUID(IID_IDirectPlay2A,0x9d460580, 0xa822, 4559, 150, 12, 0, 128, 199, 83, 78, 130);
DEFINE_GUID(IID_IDirectPlay3, 0x133efe40, 0x32dc, 4560, 156, 251, 0, 160, 201, 10, 67, 203);
DEFINE_GUID(IID_IDirectPlay3A,0x133efe41, 0x32dc, 4560, 156, 251, 0, 160, 201, 10, 67, 203);
DEFINE_GUID(IID_IDirectPlay4, 0xab1c530, 0x4745, 4561, 167, 161, 0, 0, 248, 3, 171, 252);
DEFINE_GUID(IID_IDirectPlay4A,0xab1c531, 0x4745, 4561, 167, 161, 0, 0, 248, 3, 171, 252);
DEFINE_GUID(CLSID_DirectPlay,0xd1eb6d20, 0x8923, 4560, 157, 151, 0, 160, 201, 10, 67, 203);
DEFINE_GUID(DPSPGUID_IPX,  0x685bc400, 0x9d2c, 4559, 169, 205, 0, 170, 0, 104, 134, 227);
DEFINE_GUID(DPSPGUID_TCPIP, 0x36e95ee0, 0x8577, 4559, 150, 12, 0, 128, 199, 83, 78, 130);
DEFINE_GUID(DPSPGUID_SERIAL,	 0xf1d6860, 0x88d9, 4559, 156, 78, 0, 160, 201, 5, 66, 94);
DEFINE_GUID(DPSPGUID_MODEM, 0x44eaa760, 0xcb68, 4559, 156, 78, 0, 160, 201, 5, 66, 94);
#ifndef IDIRECTPLAY2_OR_GREATER
typedef struct IDirectPlay *LPDIRECTPLAY;
#else
typedef struct IUnknown *LPDIRECTPLAY;
#endif
typedef struct IDirectPlay2 *LPDIRECTPLAY2;
typedef struct IDirectPlay2 *LPDIRECTPLAY2A;
typedef struct IDirectPlay2 IDirectPlay2A;
typedef struct IDirectPlay3 *LPDIRECTPLAY3;
typedef struct IDirectPlay3 *LPDIRECTPLAY3A;
typedef struct IDirectPlay3 IDirectPlay3A;
typedef struct IDirectPlay4 *LPDIRECTPLAY4;
typedef struct IDirectPlay4 *LPDIRECTPLAY4A;
typedef struct IDirectPlay4 IDirectPlay4A;
typedef DWORD DPID, *LPDPID;
#define DPID_SYSMSG 0
#define DPID_ALLPLAYERS 0
#define DPID_SERVERPLAYER	1
#define DPID_RESERVEDRANGE 100
#define DPID_UNKNOWN	0xffffffff
typedef struct
{
DWORD dwSize; 
DWORD dwFlags; 
DWORD dwMaxBufferSize; 
DWORD dwMaxQueueSize; 
DWORD dwMaxPlayers; 
DWORD dwHundredBaud; 
DWORD dwLatency; 
DWORD dwMaxLocalPlayers; 
DWORD dwHeaderLength; 
DWORD dwTimeout; 
} DPCAPS, *LPDPCAPS;
#define DPCAPS_ISHOST 2
#define DPCAPS_GROUPOPTIMIZED 8
#define DPCAPS_KEEPALIVEOPTIMIZED 16
#define DPCAPS_GUARANTEEDOPTIMIZED 32
#define DPCAPS_GUARANTEEDSUPPORTED 64
#define DPCAPS_SIGNINGSUPPORTED 128
#define DPCAPS_ENCRYPTIONSUPPORTED 256
#define DPPLAYERCAPS_LOCAL	2048
#define DPCAPS_ASYNCCANCELSUPPORTED 4096
#define DPCAPS_ASYNCCANCELALLSUPPORTED 0x2000
#define DPCAPS_SENDTIMEOUTSUPPORTED 0x4000
#define DPCAPS_SENDPRIORITYSUPPORTED 0x8000
#define DPCAPS_ASYNCSUPPORTED 0x10000
typedef struct
{
DWORD dwSize; 
DWORD dwFlags; 
GUID guidInstance; 
GUID guidApplication; 
DWORD dwMaxPlayers; 
DWORD dwCurrentPlayers; 
union
{ 
LPWSTR lpszSessionName; 
LPSTR lpszSessionNameA; 
};
union
{ 
LPWSTR lpszPassword; 
LPSTR lpszPasswordA; 
};
DWORD_PTR dwReserved1; 
DWORD_PTR dwReserved2;
DWORD_PTR dwUser1; 
DWORD_PTR dwUser2;
DWORD_PTR dwUser3;
DWORD_PTR dwUser4;
} DPSESSIONDESC2, *LPDPSESSIONDESC2;
typedef DPSESSIONDESC2 * VOL LPDPSESSIONDESC2_V;
typedef const DPSESSIONDESC2 *LPCDPSESSIONDESC2;
#define DPSESSION_NEWPLAYERSDISABLED 1
#define DPSESSION_MIGRATEHOST 4
#define DPSESSION_NOMESSAGEID 8
#define DPSESSION_JOINDISABLED 32
#define DPSESSION_KEEPALIVE 64
#define DPSESSION_NODATAMESSAGES 128
#define DPSESSION_SECURESERVER 256
#define DPSESSION_PRIVATE 512
#define DPSESSION_PASSWORDREQUIRED 1024
#define DPSESSION_MULTICASTSERVER	2048
#define DPSESSION_CLIENTSERVER	4096
#define DPSESSION_DIRECTPLAYPROTOCOL	0x2000
#define DPSESSION_NOPRESERVEORDER	0x4000
#define DPSESSION_OPTIMIZELATENCY	0x8000
typedef struct 
{
DWORD dwSize; 
DWORD dwFlags; 
union
{ 
LPWSTR lpszShortName; 
LPSTR lpszShortNameA; 
};
union
{ 
LPWSTR lpszLongName; 
LPSTR lpszLongNameA; 
};
} DPNAME, *LPDPNAME;
typedef const DPNAME *LPCDPNAME;
typedef struct 
{
DWORD dwSize; 
DWORD dwFlags; 
union
{ 
LPWSTR lpszUsername; 
LPSTR lpszUsernameA; 
}; 
union
{ 
LPWSTR lpszPassword; 
LPSTR lpszPasswordA; 
}; 
union
{ 
LPWSTR lpszDomain; 
LPSTR lpszDomainA; 
}; 
} DPCREDENTIALS, *LPDPCREDENTIALS;
typedef const DPCREDENTIALS *LPCDPCREDENTIALS;
typedef struct 
{
DWORD dwSize; 
DWORD dwFlags; 
union
{ 
LPWSTR lpszSSPIProvider; 
LPSTR lpszSSPIProviderA; 
};
union
{ 
LPWSTR lpszCAPIProvider; 
LPSTR lpszCAPIProviderA; 
};
DWORD dwCAPIProviderType; 
DWORD dwEncryptionAlgorithm; 
} DPSECURITYDESC, *LPDPSECURITYDESC;
typedef const DPSECURITYDESC *LPCDPSECURITYDESC;
typedef struct 
{
DWORD dwSize; 
DWORD dwFlags; 
union
{ 
LPWSTR lpszAccountID; 
LPSTR lpszAccountIDA; 
};
} DPACCOUNTDESC, *LPDPACCOUNTDESC;
typedef const DPACCOUNTDESC *LPCDPACCOUNTDESC;
typedef const GUID *LPCGUID;
typedef struct
{
DWORD dwSize; 
DWORD dwFlags; 
LPDPSESSIONDESC2 lpSessionDesc; 
LPDPNAME lpPlayerName; 
GUID guidSP; 
LPVOID lpAddress; 
DWORD dwAddressSize; 
} DPLCONNECTION, *LPDPLCONNECTION;
typedef const DPLCONNECTION *LPCDPLCONNECTION;
typedef struct
{
DWORD dwSize;
DWORD dwFlags;
union
{ 
LPWSTR lpszMessage; 
LPSTR lpszMessageA; 
}; 
} DPCHAT, * LPDPCHAT;
typedef struct 
{
UINT len; 
PUCHAR	pData;	
} SGBUFFER, *PSGBUFFER, *LPSGBUFFER;
typedef BOOL (FAR PASCAL * LPDPENUMSESSIONSCALLBACK2)(LPCDPSESSIONDESC2 lpThisSD, LPDWORD lpdwTimeOut, DWORD dwFlags, LPVOID lpContext);
#define DPESC_TIMEDOUT 1
typedef BOOL (FAR PASCAL *LPDPENUMPLAYERSCALLBACK2)(DPID dpId, DWORD dwPlayerType, LPCDPNAME lpName, DWORD dwFlags, LPVOID lpContext);
typedef BOOL (FAR PASCAL * LPDPENUMDPCALLBACK)(LPGUID lpguidSP, LPWSTR lpSPName, DWORD dwMajorVersion, DWORD dwMinorVersion, LPVOID lpContext);
typedef BOOL (FAR PASCAL * LPDPENUMDPCALLBACKA)(LPGUID lpguidSP, LPSTR lpSPName, DWORD dwMajorVersion,  DWORD dwMinorVersion, LPVOID lpContext);
typedef BOOL (FAR PASCAL * LPDPENUMCONNECTIONSCALLBACK)(LPCGUID lpguidSP, LPVOID	lpConnection, DWORD	dwConnectionSize, LPCDPNAME lpName, DWORD dwFlags, LPVOID lpContext);
#ifdef UNICODE
#define DirectPlayEnumerate DirectPlayEnumerateW
#else
#define DirectPlayEnumerate DirectPlayEnumerateA
#endif 
extern HRESULT WINAPI DirectPlayEnumerateA(LPDPENUMDPCALLBACKA, LPVOID);
extern HRESULT WINAPI DirectPlayEnumerateW(LPDPENUMDPCALLBACK, LPVOID);
extern HRESULT WINAPI DirectPlayCreate(LPGUID lpGUID, LPDIRECTPLAY *lplpDP, IUnknown *pUnk);
#undef INTERFACE
#define INTERFACE IDirectPlay2
DECLARE_INTERFACE_(IDirectPlay2, IUnknown)
{
STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID * ppvObj) ;
STDMETHOD_(ULONG,AddRef) (THIS) ;
STDMETHOD_(ULONG,Release) (THIS) ;
STDMETHOD(AddPlayerToGroup) (THIS_ DPID, DPID) ;
STDMETHOD(Close) (THIS) ;
STDMETHOD(CreateGroup) (THIS_ LPDPID,LPDPNAME,LPVOID,DWORD,DWORD) ;
STDMETHOD(CreatePlayer) (THIS_ LPDPID,LPDPNAME,HANDLE,LPVOID,DWORD,DWORD) ;
STDMETHOD(DeletePlayerFromGroup)(THIS_ DPID,DPID) ;
STDMETHOD(DestroyGroup) (THIS_ DPID) ;
STDMETHOD(DestroyPlayer) (THIS_ DPID) ;
STDMETHOD(EnumGroupPlayers) (THIS_ DPID,LPGUID,LPDPENUMPLAYERSCALLBACK2,LPVOID,DWORD) ;
STDMETHOD(EnumGroups) (THIS_ LPGUID,LPDPENUMPLAYERSCALLBACK2,LPVOID,DWORD) ;
STDMETHOD(EnumPlayers) (THIS_ LPGUID,LPDPENUMPLAYERSCALLBACK2,LPVOID,DWORD) ;
STDMETHOD(EnumSessions) (THIS_ LPDPSESSIONDESC2,DWORD,LPDPENUMSESSIONSCALLBACK2,LPVOID,DWORD) ;
STDMETHOD(GetCaps) (THIS_ LPDPCAPS,DWORD) ;
STDMETHOD(GetGroupData) (THIS_ DPID,LPVOID,LPDWORD,DWORD) ;
STDMETHOD(GetGroupName) (THIS_ DPID,LPVOID,LPDWORD) ;
STDMETHOD(GetMessageCount) (THIS_ DPID, LPDWORD) ;
STDMETHOD(GetPlayerAddress) (THIS_ DPID,LPVOID,LPDWORD) ;
STDMETHOD(GetPlayerCaps) (THIS_ DPID,LPDPCAPS,DWORD) ;
STDMETHOD(GetPlayerData) (THIS_ DPID,LPVOID,LPDWORD,DWORD) ;
STDMETHOD(GetPlayerName) (THIS_ DPID,LPVOID,LPDWORD) ;
STDMETHOD(GetSessionDesc) (THIS_ LPVOID,LPDWORD) ;
STDMETHOD(Initialize) (THIS_ LPGUID) ;
STDMETHOD(Open) (THIS_ LPDPSESSIONDESC2,DWORD) ;
STDMETHOD(Receive) (THIS_ LPDPID,LPDPID,DWORD,LPVOID,LPDWORD) ;
STDMETHOD(Send) (THIS_ DPID, DPID, DWORD, LPVOID, DWORD) ;
STDMETHOD(SetGroupData) (THIS_ DPID,LPVOID,DWORD,DWORD) ;
STDMETHOD(SetGroupName) (THIS_ DPID,LPDPNAME,DWORD) ;
STDMETHOD(SetPlayerData) (THIS_ DPID,LPVOID,DWORD,DWORD) ;
STDMETHOD(SetPlayerName) (THIS_ DPID,LPDPNAME,DWORD) ;
STDMETHOD(SetSessionDesc) (THIS_ LPDPSESSIONDESC2,DWORD) ;
};
#define IDirectPlay2_QueryInterface(p,a,b) (p)->lpVtbl->QueryInterface(p,a,b)
#define IDirectPlay2_AddRef(p) (p)->lpVtbl->AddRef(p)
#define IDirectPlay2_Release(p) (p)->lpVtbl->Release(p)
#define IDirectPlay2_AddPlayerToGroup(p,a,b) (p)->lpVtbl->AddPlayerToGroup(p,a,b)
#define IDirectPlay2_Close(p) (p)->lpVtbl->Close(p)
#define IDirectPlay2_CreateGroup(p,a,b,c,d,e) (p)->lpVtbl->CreateGroup(p,a,b,c,d,e)
#define IDirectPlay2_CreatePlayer(p,a,b,c,d,e,f) (p)->lpVtbl->CreatePlayer(p,a,b,c,d,e,f)
#define IDirectPlay2_DeletePlayerFromGroup(p,a,b) (p)->lpVtbl->DeletePlayerFromGroup(p,a,b)
#define IDirectPlay2_DestroyGroup(p,a) (p)->lpVtbl->DestroyGroup(p,a)
#define IDirectPlay2_DestroyPlayer(p,a) (p)->lpVtbl->DestroyPlayer(p,a)
#define IDirectPlay2_EnumGroupPlayers(p,a,b,c,d,e) (p)->lpVtbl->EnumGroupPlayers(p,a,b,c,d,e)
#define IDirectPlay2_EnumGroups(p,a,b,c,d) (p)->lpVtbl->EnumGroups(p,a,b,c,d)
#define IDirectPlay2_EnumPlayers(p,a,b,c,d) (p)->lpVtbl->EnumPlayers(p,a,b,c,d)
#define IDirectPlay2_EnumSessions(p,a,b,c,d,e) (p)->lpVtbl->EnumSessions(p,a,b,c,d,e)
#define IDirectPlay2_GetCaps(p,a,b) (p)->lpVtbl->GetCaps(p,a,b)
#define IDirectPlay2_GetMessageCount(p,a,b) (p)->lpVtbl->GetMessageCount(p,a,b)
#define IDirectPlay2_GetGroupData(p,a,b,c,d) (p)->lpVtbl->GetGroupData(p,a,b,c,d)
#define IDirectPlay2_GetGroupName(p,a,b,c) (p)->lpVtbl->GetGroupName(p,a,b,c)
#define IDirectPlay2_GetPlayerAddress(p,a,b,c) (p)->lpVtbl->GetPlayerAddress(p,a,b,c)
#define IDirectPlay2_GetPlayerCaps(p,a,b,c) (p)->lpVtbl->GetPlayerCaps(p,a,b,c)
#define IDirectPlay2_GetPlayerData(p,a,b,c,d) (p)->lpVtbl->GetPlayerData(p,a,b,c,d)
#define IDirectPlay2_GetPlayerName(p,a,b,c) (p)->lpVtbl->GetPlayerName(p,a,b,c)
#define IDirectPlay2_GetSessionDesc(p,a,b) (p)->lpVtbl->GetSessionDesc(p,a,b)
#define IDirectPlay2_Initialize(p,a) (p)->lpVtbl->Initialize(p,a)
#define IDirectPlay2_Open(p,a,b) (p)->lpVtbl->Open(p,a,b)
#define IDirectPlay2_Receive(p,a,b,c,d,e) (p)->lpVtbl->Receive(p,a,b,c,d,e)
#define IDirectPlay2_Send(p,a,b,c,d,e) (p)->lpVtbl->Send(p,a,b,c,d,e)
#define IDirectPlay2_SetGroupData(p,a,b,c,d) (p)->lpVtbl->SetGroupData(p,a,b,c,d)
#define IDirectPlay2_SetGroupName(p,a,b,c) (p)->lpVtbl->SetGroupName(p,a,b,c)
#define IDirectPlay2_SetPlayerData(p,a,b,c,d) (p)->lpVtbl->SetPlayerData(p,a,b,c,d)
#define IDirectPlay2_SetPlayerName(p,a,b,c) (p)->lpVtbl->SetPlayerName(p,a,b,c)
#define IDirectPlay2_SetSessionDesc(p,a,b) (p)->lpVtbl->SetSessionDesc(p,a,b)
#undef INTERFACE
#define INTERFACE IDirectPlay3
DECLARE_INTERFACE_(IDirectPlay3, IDirectPlay2)
{
STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID * ppvObj) ;
STDMETHOD_(ULONG,AddRef) (THIS) ;
STDMETHOD_(ULONG,Release) (THIS) ;
STDMETHOD(AddPlayerToGroup) (THIS_ DPID, DPID) ;
STDMETHOD(Close) (THIS) ;
STDMETHOD(CreateGroup) (THIS_ LPDPID,LPDPNAME,LPVOID,DWORD,DWORD) ;
STDMETHOD(CreatePlayer) (THIS_ LPDPID,LPDPNAME,HANDLE,LPVOID,DWORD,DWORD) ;
STDMETHOD(DeletePlayerFromGroup)(THIS_ DPID,DPID) ;
STDMETHOD(DestroyGroup) (THIS_ DPID) ;
STDMETHOD(DestroyPlayer) (THIS_ DPID) ;
STDMETHOD(EnumGroupPlayers) (THIS_ DPID,LPGUID,LPDPENUMPLAYERSCALLBACK2,LPVOID,DWORD) ;
STDMETHOD(EnumGroups) (THIS_ LPGUID,LPDPENUMPLAYERSCALLBACK2,LPVOID,DWORD) ;
STDMETHOD(EnumPlayers) (THIS_ LPGUID,LPDPENUMPLAYERSCALLBACK2,LPVOID,DWORD) ;
STDMETHOD(EnumSessions) (THIS_ LPDPSESSIONDESC2,DWORD,LPDPENUMSESSIONSCALLBACK2,LPVOID,DWORD) ;
STDMETHOD(GetCaps) (THIS_ LPDPCAPS,DWORD) ;
STDMETHOD(GetGroupData) (THIS_ DPID,LPVOID,LPDWORD,DWORD) ;
STDMETHOD(GetGroupName) (THIS_ DPID,LPVOID,LPDWORD) ;
STDMETHOD(GetMessageCount) (THIS_ DPID, LPDWORD) ;
STDMETHOD(GetPlayerAddress) (THIS_ DPID,LPVOID,LPDWORD) ;
STDMETHOD(GetPlayerCaps) (THIS_ DPID,LPDPCAPS,DWORD) ;
STDMETHOD(GetPlayerData) (THIS_ DPID,LPVOID,LPDWORD,DWORD) ;
STDMETHOD(GetPlayerName) (THIS_ DPID,LPVOID,LPDWORD) ;
STDMETHOD(GetSessionDesc) (THIS_ LPVOID,LPDWORD) ;
STDMETHOD(Initialize) (THIS_ LPGUID) ;
STDMETHOD(Open) (THIS_ LPDPSESSIONDESC2,DWORD) ;
STDMETHOD(Receive) (THIS_ LPDPID,LPDPID,DWORD,LPVOID,LPDWORD) ;
STDMETHOD(Send) (THIS_ DPID, DPID, DWORD, LPVOID, DWORD) ;
STDMETHOD(SetGroupData) (THIS_ DPID,LPVOID,DWORD,DWORD) ;
STDMETHOD(SetGroupName) (THIS_ DPID,LPDPNAME,DWORD) ;
STDMETHOD(SetPlayerData) (THIS_ DPID,LPVOID,DWORD,DWORD) ;
STDMETHOD(SetPlayerName) (THIS_ DPID,LPDPNAME,DWORD) ;
STDMETHOD(SetSessionDesc) (THIS_ LPDPSESSIONDESC2,DWORD) ;
STDMETHOD(AddGroupToGroup) (THIS_ DPID, DPID) ;
STDMETHOD(CreateGroupInGroup) (THIS_ DPID,LPDPID,LPDPNAME,LPVOID,DWORD,DWORD) ;
STDMETHOD(DeleteGroupFromGroup)	(THIS_ DPID,DPID) ;	
STDMETHOD(EnumConnections) (THIS_ LPCGUID,LPDPENUMCONNECTIONSCALLBACK,LPVOID,DWORD) ;
STDMETHOD(EnumGroupsInGroup)	(THIS_ DPID,LPGUID,LPDPENUMPLAYERSCALLBACK2,LPVOID,DWORD) ;
STDMETHOD(GetGroupConnectionSettings)(THIS_ DWORD, DPID, LPVOID, LPDWORD) ;
STDMETHOD(InitializeConnection) (THIS_ LPVOID,DWORD) ;
STDMETHOD(SecureOpen) (THIS_ LPCDPSESSIONDESC2,DWORD,LPCDPSECURITYDESC,LPCDPCREDENTIALS) ;
STDMETHOD(SendChatMessage) (THIS_ DPID,DPID,DWORD,LPDPCHAT) ;
STDMETHOD(SetGroupConnectionSettings)(THIS_ DWORD,DPID,LPDPLCONNECTION) ;
STDMETHOD(StartSession) (THIS_ DWORD,DPID) ;
STDMETHOD(GetGroupFlags) (THIS_ DPID,LPDWORD) ;
STDMETHOD(GetGroupParent) (THIS_ DPID,LPDPID) ;
STDMETHOD(GetPlayerAccount) (THIS_ DPID, DWORD, LPVOID, LPDWORD) ;
STDMETHOD(GetPlayerFlags) (THIS_ DPID,LPDWORD) ;
};
#define IDirectPlay3_QueryInterface(p,a,b) (p)->lpVtbl->QueryInterface(p,a,b)
#define IDirectPlay3_AddRef(p) (p)->lpVtbl->AddRef(p)
#define IDirectPlay3_Release(p) (p)->lpVtbl->Release(p)
#define IDirectPlay3_AddPlayerToGroup(p,a,b) (p)->lpVtbl->AddPlayerToGroup(p,a,b)
#define IDirectPlay3_Close(p) (p)->lpVtbl->Close(p)
#define IDirectPlay3_CreateGroup(p,a,b,c,d,e) (p)->lpVtbl->CreateGroup(p,a,b,c,d,e)
#define IDirectPlay3_CreatePlayer(p,a,b,c,d,e,f) (p)->lpVtbl->CreatePlayer(p,a,b,c,d,e,f)
#define IDirectPlay3_DeletePlayerFromGroup(p,a,b) (p)->lpVtbl->DeletePlayerFromGroup(p,a,b)
#define IDirectPlay3_DestroyGroup(p,a) (p)->lpVtbl->DestroyGroup(p,a)
#define IDirectPlay3_DestroyPlayer(p,a) (p)->lpVtbl->DestroyPlayer(p,a)
#define IDirectPlay3_EnumGroupPlayers(p,a,b,c,d,e) (p)->lpVtbl->EnumGroupPlayers(p,a,b,c,d,e)
#define IDirectPlay3_EnumGroups(p,a,b,c,d) (p)->lpVtbl->EnumGroups(p,a,b,c,d)
#define IDirectPlay3_EnumPlayers(p,a,b,c,d) (p)->lpVtbl->EnumPlayers(p,a,b,c,d)
#define IDirectPlay3_EnumSessions(p,a,b,c,d,e) (p)->lpVtbl->EnumSessions(p,a,b,c,d,e)
#define IDirectPlay3_GetCaps(p,a,b) (p)->lpVtbl->GetCaps(p,a,b)
#define IDirectPlay3_GetMessageCount(p,a,b) (p)->lpVtbl->GetMessageCount(p,a,b)
#define IDirectPlay3_GetGroupData(p,a,b,c,d) (p)->lpVtbl->GetGroupData(p,a,b,c,d)
#define IDirectPlay3_GetGroupName(p,a,b,c) (p)->lpVtbl->GetGroupName(p,a,b,c)
#define IDirectPlay3_GetPlayerAddress(p,a,b,c) (p)->lpVtbl->GetPlayerAddress(p,a,b,c)
#define IDirectPlay3_GetPlayerCaps(p,a,b,c) (p)->lpVtbl->GetPlayerCaps(p,a,b,c)
#define IDirectPlay3_GetPlayerData(p,a,b,c,d) (p)->lpVtbl->GetPlayerData(p,a,b,c,d)
#define IDirectPlay3_GetPlayerName(p,a,b,c) (p)->lpVtbl->GetPlayerName(p,a,b,c)
#define IDirectPlay3_GetSessionDesc(p,a,b) (p)->lpVtbl->GetSessionDesc(p,a,b)
#define IDirectPlay3_Initialize(p,a) (p)->lpVtbl->Initialize(p,a)
#define IDirectPlay3_Open(p,a,b) (p)->lpVtbl->Open(p,a,b)
#define IDirectPlay3_Receive(p,a,b,c,d,e) (p)->lpVtbl->Receive(p,a,b,c,d,e)
#define IDirectPlay3_Send(p,a,b,c,d,e) (p)->lpVtbl->Send(p,a,b,c,d,e)
#define IDirectPlay3_SetGroupData(p,a,b,c,d) (p)->lpVtbl->SetGroupData(p,a,b,c,d)
#define IDirectPlay3_SetGroupName(p,a,b,c) (p)->lpVtbl->SetGroupName(p,a,b,c)
#define IDirectPlay3_SetPlayerData(p,a,b,c,d) (p)->lpVtbl->SetPlayerData(p,a,b,c,d)
#define IDirectPlay3_SetPlayerName(p,a,b,c) (p)->lpVtbl->SetPlayerName(p,a,b,c)
#define IDirectPlay3_SetSessionDesc(p,a,b) (p)->lpVtbl->SetSessionDesc(p,a,b)
#define IDirectPlay3_AddGroupToGroup(p,a,b) (p)->lpVtbl->AddGroupToGroup(p,a,b)
#define IDirectPlay3_CreateGroupInGroup(p,a,b,c,d,e,f) (p)->lpVtbl->CreateGroupInGroup(p,a,b,c,d,e,f)
#define IDirectPlay3_DeleteGroupFromGroup(p,a,b) (p)->lpVtbl->DeleteGroupFromGroup(p,a,b)
#define IDirectPlay3_EnumConnections(p,a,b,c,d) (p)->lpVtbl->EnumConnections(p,a,b,c,d)
#define IDirectPlay3_EnumGroupsInGroup(p,a,b,c,d,e) (p)->lpVtbl->EnumGroupsInGroup(p,a,b,c,d,e)
#define IDirectPlay3_GetGroupConnectionSettings(p,a,b,c,d) (p)->lpVtbl->GetGroupConnectionSettings(p,a,b,c,d)
#define IDirectPlay3_InitializeConnection(p,a,b) (p)->lpVtbl->InitializeConnection(p,a,b)
#define IDirectPlay3_SecureOpen(p,a,b,c,d) (p)->lpVtbl->SecureOpen(p,a,b,c,d)
#define IDirectPlay3_SendChatMessage(p,a,b,c,d) (p)->lpVtbl->SendChatMessage(p,a,b,c,d)
#define IDirectPlay3_SetGroupConnectionSettings(p,a,b,c) (p)->lpVtbl->SetGroupConnectionSettings(p,a,b,c)
#define IDirectPlay3_StartSession(p,a,b) (p)->lpVtbl->StartSession(p,a,b)
#define IDirectPlay3_GetGroupFlags(p,a,b) (p)->lpVtbl->GetGroupFlags(p,a,b)
#define IDirectPlay3_GetGroupParent(p,a,b) (p)->lpVtbl->GetGroupParent(p,a,b)
#define IDirectPlay3_GetPlayerAccount(p,a,b,c,d) (p)->lpVtbl->GetPlayerAccount(p,a,b,c,d)
#define IDirectPlay3_GetPlayerFlags(p,a,b) (p)->lpVtbl->GetPlayerFlags(p,a,b)
#undef INTERFACE
#define INTERFACE IDirectPlay4
DECLARE_INTERFACE_(IDirectPlay4, IDirectPlay3)
{
STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID * ppvObj) ;
STDMETHOD_(ULONG,AddRef) (THIS) ;
STDMETHOD_(ULONG,Release) (THIS) ;
STDMETHOD(AddPlayerToGroup) (THIS_ DPID, DPID) ;
STDMETHOD(Close) (THIS) ;
STDMETHOD(CreateGroup) (THIS_ LPDPID,LPDPNAME,LPVOID,DWORD,DWORD) ;
STDMETHOD(CreatePlayer) (THIS_ LPDPID,LPDPNAME,HANDLE,LPVOID,DWORD,DWORD) ;
STDMETHOD(DeletePlayerFromGroup)(THIS_ DPID,DPID) ;
STDMETHOD(DestroyGroup) (THIS_ DPID) ;
STDMETHOD(DestroyPlayer) (THIS_ DPID) ;
STDMETHOD(EnumGroupPlayers) (THIS_ DPID,LPGUID,LPDPENUMPLAYERSCALLBACK2,LPVOID,DWORD) ;
STDMETHOD(EnumGroups) (THIS_ LPGUID,LPDPENUMPLAYERSCALLBACK2,LPVOID,DWORD) ;
STDMETHOD(EnumPlayers) (THIS_ LPGUID,LPDPENUMPLAYERSCALLBACK2,LPVOID,DWORD) ;
STDMETHOD(EnumSessions) (THIS_ LPDPSESSIONDESC2,DWORD,LPDPENUMSESSIONSCALLBACK2,LPVOID,DWORD) ;
STDMETHOD(GetCaps) (THIS_ LPDPCAPS,DWORD) ;
STDMETHOD(GetGroupData) (THIS_ DPID,LPVOID,LPDWORD,DWORD) ;
STDMETHOD(GetGroupName) (THIS_ DPID,LPVOID,LPDWORD) ;
STDMETHOD(GetMessageCount) (THIS_ DPID, LPDWORD) ;
STDMETHOD(GetPlayerAddress) (THIS_ DPID,LPVOID,LPDWORD) ;
STDMETHOD(GetPlayerCaps) (THIS_ DPID,LPDPCAPS,DWORD) ;
STDMETHOD(GetPlayerData) (THIS_ DPID,LPVOID,LPDWORD,DWORD) ;
STDMETHOD(GetPlayerName) (THIS_ DPID,LPVOID,LPDWORD) ;
STDMETHOD(GetSessionDesc) (THIS_ LPVOID,LPDWORD) ;
STDMETHOD(Initialize) (THIS_ LPGUID) ;
STDMETHOD(Open) (THIS_ LPDPSESSIONDESC2,DWORD) ;
STDMETHOD(Receive) (THIS_ LPDPID,LPDPID,DWORD,LPVOID,LPDWORD) ;
STDMETHOD(Send) (THIS_ DPID, DPID, DWORD, LPVOID, DWORD) ;
STDMETHOD(SetGroupData) (THIS_ DPID,LPVOID,DWORD,DWORD) ;
STDMETHOD(SetGroupName) (THIS_ DPID,LPDPNAME,DWORD) ;
STDMETHOD(SetPlayerData) (THIS_ DPID,LPVOID,DWORD,DWORD) ;
STDMETHOD(SetPlayerName) (THIS_ DPID,LPDPNAME,DWORD) ;
STDMETHOD(SetSessionDesc) (THIS_ LPDPSESSIONDESC2,DWORD) ;
STDMETHOD(AddGroupToGroup) (THIS_ DPID, DPID) ;
STDMETHOD(CreateGroupInGroup) (THIS_ DPID,LPDPID,LPDPNAME,LPVOID,DWORD,DWORD) ;
STDMETHOD(DeleteGroupFromGroup)	(THIS_ DPID,DPID) ;	
STDMETHOD(EnumConnections) (THIS_ LPCGUID,LPDPENUMCONNECTIONSCALLBACK,LPVOID,DWORD) ;
STDMETHOD(EnumGroupsInGroup)	(THIS_ DPID,LPGUID,LPDPENUMPLAYERSCALLBACK2,LPVOID,DWORD) ;
STDMETHOD(GetGroupConnectionSettings)(THIS_ DWORD, DPID, LPVOID, LPDWORD) ;
STDMETHOD(InitializeConnection) (THIS_ LPVOID,DWORD) ;
STDMETHOD(SecureOpen) (THIS_ LPCDPSESSIONDESC2,DWORD,LPCDPSECURITYDESC,LPCDPCREDENTIALS) ;
STDMETHOD(SendChatMessage) (THIS_ DPID,DPID,DWORD,LPDPCHAT) ;
STDMETHOD(SetGroupConnectionSettings)(THIS_ DWORD,DPID,LPDPLCONNECTION) ;
STDMETHOD(StartSession) (THIS_ DWORD,DPID) ;
STDMETHOD(GetGroupFlags) (THIS_ DPID,LPDWORD) ;
STDMETHOD(GetGroupParent) (THIS_ DPID,LPDPID) ;
STDMETHOD(GetPlayerAccount) (THIS_ DPID, DWORD, LPVOID, LPDWORD) ;
STDMETHOD(GetPlayerFlags) (THIS_ DPID,LPDWORD) ;
STDMETHOD(GetGroupOwner) (THIS_ DPID, LPDPID) ;
STDMETHOD(SetGroupOwner) (THIS_ DPID, DPID) ;
STDMETHOD(SendEx) (THIS_ DPID, DPID, DWORD, LPVOID, DWORD, DWORD, DWORD, LPVOID, DWORD_PTR *) ;
STDMETHOD(GetMessageQueue) (THIS_ DPID, DPID, DWORD, LPDWORD, LPDWORD) ;
STDMETHOD(CancelMessage) (THIS_ DWORD, DWORD) ;
STDMETHOD(CancelPriority) (THIS_ DWORD, DWORD, DWORD) ;
};
#define IDirectPlayX_QueryInterface(p,a,b) (p)->lpVtbl->QueryInterface(p,a,b)
#define IDirectPlayX_AddRef(p) (p)->lpVtbl->AddRef(p)
#define IDirectPlayX_Release(p) (p)->lpVtbl->Release(p)
#define IDirectPlayX_AddPlayerToGroup(p,a,b) (p)->lpVtbl->AddPlayerToGroup(p,a,b)
#define IDirectPlayX_CancelMessage(p,a,b) (p)->lpVtbl->CancelMessage(p,a,b)
#define IDirectPlayX_CancelPriority(p,a,b,c) (p)->lpVtbl->CancelPriority(p,a,b,c)
#define IDirectPlayX_Close(p) (p)->lpVtbl->Close(p)
#define IDirectPlayX_CreateGroup(p,a,b,c,d,e) (p)->lpVtbl->CreateGroup(p,a,b,c,d,e)
#define IDirectPlayX_CreatePlayer(p,a,b,c,d,e,f) (p)->lpVtbl->CreatePlayer(p,a,b,c,d,e,f)
#define IDirectPlayX_DeletePlayerFromGroup(p,a,b) (p)->lpVtbl->DeletePlayerFromGroup(p,a,b)
#define IDirectPlayX_DestroyGroup(p,a) (p)->lpVtbl->DestroyGroup(p,a)
#define IDirectPlayX_DestroyPlayer(p,a) (p)->lpVtbl->DestroyPlayer(p,a)
#define IDirectPlayX_EnumGroupPlayers(p,a,b,c,d,e) (p)->lpVtbl->EnumGroupPlayers(p,a,b,c,d,e)
#define IDirectPlayX_EnumGroups(p,a,b,c,d) (p)->lpVtbl->EnumGroups(p,a,b,c,d)
#define IDirectPlayX_EnumPlayers(p,a,b,c,d) (p)->lpVtbl->EnumPlayers(p,a,b,c,d)
#define IDirectPlayX_EnumSessions(p,a,b,c,d,e) (p)->lpVtbl->EnumSessions(p,a,b,c,d,e)
#define IDirectPlayX_GetCaps(p,a,b) (p)->lpVtbl->GetCaps(p,a,b)
#define IDirectPlayX_GetMessageCount(p,a,b) (p)->lpVtbl->GetMessageCount(p,a,b)
#define IDirectPlayX_GetMessageQueue(p,a,b,c,d,e) (p)->lpVtbl->GetMessageQueue(p,a,b,c,d,e)
#define IDirectPlayX_GetGroupData(p,a,b,c,d) (p)->lpVtbl->GetGroupData(p,a,b,c,d)
#define IDirectPlayX_GetGroupName(p,a,b,c) (p)->lpVtbl->GetGroupName(p,a,b,c)
#define IDirectPlayX_GetPlayerAddress(p,a,b,c) (p)->lpVtbl->GetPlayerAddress(p,a,b,c)
#define IDirectPlayX_GetPlayerCaps(p,a,b,c) (p)->lpVtbl->GetPlayerCaps(p,a,b,c)
#define IDirectPlayX_GetPlayerData(p,a,b,c,d) (p)->lpVtbl->GetPlayerData(p,a,b,c,d)
#define IDirectPlayX_GetPlayerName(p,a,b,c) (p)->lpVtbl->GetPlayerName(p,a,b,c)
#define IDirectPlayX_GetSessionDesc(p,a,b) (p)->lpVtbl->GetSessionDesc(p,a,b)
#define IDirectPlayX_Initialize(p,a) (p)->lpVtbl->Initialize(p,a)
#define IDirectPlayX_Open(p,a,b) (p)->lpVtbl->Open(p,a,b)
#define IDirectPlayX_Receive(p,a,b,c,d,e) (p)->lpVtbl->Receive(p,a,b,c,d,e)
#define IDirectPlayX_Send(p,a,b,c,d,e) (p)->lpVtbl->Send(p,a,b,c,d,e)
#define IDirectPlayX_SendEx(p,a,b,c,d,e,f,g,h,i) (p)->lpVtbl->SendEx(p,a,b,c,d,e,f,g,h,i)
#define IDirectPlayX_SetGroupData(p,a,b,c,d) (p)->lpVtbl->SetGroupData(p,a,b,c,d)
#define IDirectPlayX_SetGroupName(p,a,b,c) (p)->lpVtbl->SetGroupName(p,a,b,c)
#define IDirectPlayX_SetPlayerData(p,a,b,c,d) (p)->lpVtbl->SetPlayerData(p,a,b,c,d)
#define IDirectPlayX_SetPlayerName(p,a,b,c) (p)->lpVtbl->SetPlayerName(p,a,b,c)
#define IDirectPlayX_SetSessionDesc(p,a,b) (p)->lpVtbl->SetSessionDesc(p,a,b)
#define IDirectPlayX_AddGroupToGroup(p,a,b) (p)->lpVtbl->AddGroupToGroup(p,a,b)
#define IDirectPlayX_CreateGroupInGroup(p,a,b,c,d,e,f) (p)->lpVtbl->CreateGroupInGroup(p,a,b,c,d,e,f)
#define IDirectPlayX_DeleteGroupFromGroup(p,a,b) (p)->lpVtbl->DeleteGroupFromGroup(p,a,b)
#define IDirectPlayX_EnumConnections(p,a,b,c,d) (p)->lpVtbl->EnumConnections(p,a,b,c,d)
#define IDirectPlayX_EnumGroupsInGroup(p,a,b,c,d,e) (p)->lpVtbl->EnumGroupsInGroup(p,a,b,c,d,e)
#define IDirectPlayX_GetGroupConnectionSettings(p,a,b,c,d) (p)->lpVtbl->GetGroupConnectionSettings(p,a,b,c,d)
#define IDirectPlayX_InitializeConnection(p,a,b) (p)->lpVtbl->InitializeConnection(p,a,b)
#define IDirectPlayX_SecureOpen(p,a,b,c,d) (p)->lpVtbl->SecureOpen(p,a,b,c,d)
#define IDirectPlayX_SendChatMessage(p,a,b,c,d) (p)->lpVtbl->SendChatMessage(p,a,b,c,d)
#define IDirectPlayX_SetGroupConnectionSettings(p,a,b,c) (p)->lpVtbl->SetGroupConnectionSettings(p,a,b,c)
#define IDirectPlayX_StartSession(p,a,b) (p)->lpVtbl->StartSession(p,a,b)
#define IDirectPlayX_GetGroupFlags(p,a,b) (p)->lpVtbl->GetGroupFlags(p,a,b)
#define IDirectPlayX_GetGroupParent(p,a,b) (p)->lpVtbl->GetGroupParent(p,a,b)
#define IDirectPlayX_GetPlayerAccount(p,a,b,c,d) (p)->lpVtbl->GetPlayerAccount(p,a,b,c,d)
#define IDirectPlayX_GetPlayerFlags(p,a,b) (p)->lpVtbl->GetPlayerFlags(p,a,b)
#define IDirectPlayX_GetGroupOwner(p,a,b) (p)->lpVtbl->GetGroupOwner(p,a,b)
#define IDirectPlayX_SetGroupOwner(p,a,b) (p)->lpVtbl->SetGroupOwner(p,a,b)
#define DPCONNECTION_DIRECTPLAY 1
#define DPCONNECTION_DIRECTPLAYLOBBY 2
#define DPENUMPLAYERS_ALL 0
#define DPENUMGROUPS_ALL DPENUMPLAYERS_ALL
#define DPENUMPLAYERS_LOCAL 8
#define DPENUMGROUPS_LOCAL	DPENUMPLAYERS_LOCAL
#define DPENUMPLAYERS_REMOTE 16
#define DPENUMGROUPS_REMOTE	DPENUMPLAYERS_REMOTE
#define DPENUMPLAYERS_GROUP 32
#define DPENUMPLAYERS_SESSION 128
#define DPENUMGROUPS_SESSION	DPENUMPLAYERS_SESSION
#define DPENUMPLAYERS_SERVERPLAYER 256
#define DPENUMPLAYERS_SPECTATOR 512
#define DPENUMGROUPS_SHORTCUT 1024
#define DPENUMGROUPS_STAGINGAREA 2048
#define DPENUMGROUPS_HIDDEN 4096
#define DPENUMPLAYERS_OWNER	0x2000
#define DPPLAYER_SERVERPLAYER DPENUMPLAYERS_SERVERPLAYER
#define DPPLAYER_SPECTATOR DPENUMPLAYERS_SPECTATOR
#define DPPLAYER_LOCAL DPENUMPLAYERS_LOCAL
#define DPPLAYER_OWNER DPENUMPLAYERS_OWNER
#define DPGROUP_STAGINGAREA DPENUMGROUPS_STAGINGAREA
#define DPGROUP_LOCAL DPENUMGROUPS_LOCAL
#define DPGROUP_HIDDEN DPENUMGROUPS_HIDDEN
#define DPENUMSESSIONS_AVAILABLE 1
#define DPENUMSESSIONS_ALL 2
#define DPENUMSESSIONS_ASYNC	16
#define DPENUMSESSIONS_STOPASYNC	32
#define DPENUMSESSIONS_PASSWORDREQUIRED	64
#define DPENUMSESSIONS_RETURNSTATUS 128
#define DPGETCAPS_GUARANTEED 1
#define DPGET_REMOTE 0
#define DPGET_LOCAL 1
#define DPOPEN_JOIN 1
#define DPOPEN_CREATE 2
#define DPOPEN_RETURNSTATUS	DPENUMSESSIONS_RETURNSTATUS
#define DPLCONNECTION_CREATESESSION	DPOPEN_CREATE
#define DPLCONNECTION_JOINSESSION	DPOPEN_JOIN
#define DPRECEIVE_ALL 1
#define DPRECEIVE_TOPLAYER 2
#define DPRECEIVE_FROMPLAYER 4
#define DPRECEIVE_PEEK 8
#define DPSEND_GUARANTEED 1
#define DPSEND_HIGHPRIORITY 2
#define DPSEND_OPENSTREAM 8
#define DPSEND_CLOSESTREAM 16
#define DPSEND_SIGNED 32
#define DPSEND_ENCRYPTED 64
#define DPSEND_LOBBYSYSTEMMESSAGE	128
#define DPSEND_ASYNC	512
#define DPSEND_NOSENDCOMPLETEMSG 1024
#define DPSEND_MAX_PRI 0xffff
#define DPSEND_MAX_PRIORITY DPSEND_MAX_PRI
#define DPSET_REMOTE 0
#define DPSET_LOCAL 1
#define DPSET_GUARANTEED 2
#define DPMESSAGEQUEUE_SEND 1
#define DPMESSAGEQUEUE_RECEIVE 2
#define DPCONNECT_RETURNSTATUS (DPENUMSESSIONS_RETURNSTATUS)
#define DPSYS_CREATEPLAYERORGROUP 3
#define DPSYS_DESTROYPLAYERORGROUP 5
#define DPSYS_ADDPLAYERTOGROUP 7
#define DPSYS_DELETEPLAYERFROMGROUP 33
#define DPSYS_SESSIONLOST 49
#define DPSYS_HOST 257
#define DPSYS_SETPLAYERORGROUPDATA 258
#define DPSYS_SETPLAYERORGROUPNAME 259
#define DPSYS_SETSESSIONDESC 260
#define DPSYS_ADDGROUPTOGROUP 261
#define DPSYS_DELETEGROUPFROMGROUP 262
#define DPSYS_SECUREMESSAGE 263
#define DPSYS_STARTSESSION 264
#define DPSYS_CHAT 265
#define DPSYS_SETGROUPOWNER 266
#define DPSYS_SENDCOMPLETE 269
#define DPPLAYERTYPE_GROUP 0
#define DPPLAYERTYPE_PLAYER 1
typedef struct
{
DWORD dwType; 
} DPMSG_GENERIC, *LPDPMSG_GENERIC;
typedef struct
{
DWORD dwType; 
DWORD dwPlayerType; 
DPID dpId; 
DWORD dwCurrentPlayers; 
LPVOID lpData; 
DWORD dwDataSize; 
DPNAME dpnName; 
DPID	dpIdParent; 
DWORD	dwFlags;	
} DPMSG_CREATEPLAYERORGROUP, *LPDPMSG_CREATEPLAYERORGROUP;
typedef struct
{
DWORD dwType; 
DWORD dwPlayerType; 
DPID dpId; 
LPVOID lpLocalData; 
DWORD dwLocalDataSize; 
LPVOID lpRemoteData; 
DWORD dwRemoteDataSize; 
DPNAME dpnName; 
DPID	dpIdParent; 
DWORD	dwFlags;	
} DPMSG_DESTROYPLAYERORGROUP, *LPDPMSG_DESTROYPLAYERORGROUP;
typedef struct
{
DWORD dwType; 
DPID dpIdGroup; 
DPID dpIdPlayer; 
} DPMSG_ADDPLAYERTOGROUP, *LPDPMSG_ADDPLAYERTOGROUP;
typedef DPMSG_ADDPLAYERTOGROUP DPMSG_DELETEPLAYERFROMGROUP;
typedef DPMSG_DELETEPLAYERFROMGROUP *LPDPMSG_DELETEPLAYERFROMGROUP;
typedef struct
{
DWORD dwType; 
DPID dpIdParentGroup; 
DPID dpIdGroup; 
} DPMSG_ADDGROUPTOGROUP, *LPDPMSG_ADDGROUPTOGROUP;
typedef DPMSG_ADDGROUPTOGROUP DPMSG_DELETEGROUPFROMGROUP;
typedef DPMSG_DELETEGROUPFROMGROUP *LPDPMSG_DELETEGROUPFROMGROUP;
typedef struct
{
DWORD dwType; 
DWORD dwPlayerType; 
DPID dpId; 
LPVOID lpData; 
DWORD dwDataSize; 
} DPMSG_SETPLAYERORGROUPDATA, *LPDPMSG_SETPLAYERORGROUPDATA;
typedef struct
{
DWORD dwType; 
DWORD dwPlayerType; 
DPID dpId; 
DPNAME dpnName; 
} DPMSG_SETPLAYERORGROUPNAME, *LPDPMSG_SETPLAYERORGROUPNAME;
typedef struct
{
DWORD dwType; 
DPSESSIONDESC2 dpDesc; 
} DPMSG_SETSESSIONDESC, *LPDPMSG_SETSESSIONDESC;
typedef DPMSG_GENERIC DPMSG_HOST;
typedef DPMSG_HOST *LPDPMSG_HOST;
typedef DPMSG_GENERIC DPMSG_SESSIONLOST;
typedef DPMSG_SESSIONLOST *LPDPMSG_SESSIONLOST;
typedef struct 
{
DWORD	dwType; 
DWORD	dwFlags; 
DPID dpIdFrom; 
LPVOID	lpData; 
DWORD	dwDataSize; 
} DPMSG_SECUREMESSAGE, *LPDPMSG_SECUREMESSAGE;
typedef struct
{
DWORD dwType; 
LPDPLCONNECTION lpConn; 
} DPMSG_STARTSESSION, *LPDPMSG_STARTSESSION;
typedef struct
{
DWORD dwType; 
DWORD dwFlags; 
DPID idFromPlayer; 
DPID idToPlayer; 
DPID idToGroup; 
LPDPCHAT lpChat;	
} DPMSG_CHAT, *LPDPMSG_CHAT;
typedef struct
{
DWORD dwType; 
DPID idGroup; 
DPID idNewOwner; 
DPID idOldOwner; 
} DPMSG_SETGROUPOWNER, *LPDPMSG_SETGROUPOWNER;
typedef struct
{
DWORD dwType;
DPID	idFrom;
DPID	idTo;
DWORD	dwFlags;
DWORD	dwPriority;
DWORD	dwTimeout;
LPVOID	lpvContext;
DWORD	dwMsgID;
HRESULT hr;
DWORD dwSendTime;
} DPMSG_SENDCOMPLETE, *LPDPMSG_SENDCOMPLETE;
#define DP_OK S_OK
#define DPERR_ALREADYINITIALIZED MAKE_DPHRESULT(5)
#define DPERR_ACCESSDENIED MAKE_DPHRESULT(10)
#define DPERR_ACTIVEPLAYERS MAKE_DPHRESULT(20)
#define DPERR_BUFFERTOOSMALL MAKE_DPHRESULT(30)
#define DPERR_CANTADDPLAYER MAKE_DPHRESULT(40)
#define DPERR_CANTCREATEGROUP MAKE_DPHRESULT(50)
#define DPERR_CANTCREATEPLAYER MAKE_DPHRESULT(60)
#define DPERR_CANTCREATESESSION MAKE_DPHRESULT(70)
#define DPERR_CAPSNOTAVAILABLEYET MAKE_DPHRESULT(80)
#define DPERR_EXCEPTION MAKE_DPHRESULT(90)
#define DPERR_GENERIC E_FAIL
#define DPERR_INVALIDFLAGS MAKE_DPHRESULT(120)
#define DPERR_INVALIDOBJECT MAKE_DPHRESULT(130)
#define DPERR_INVALIDPARAM E_INVALIDARG
#define DPERR_INVALIDPARAMS DPERR_INVALIDPARAM
#define DPERR_INVALIDPLAYER MAKE_DPHRESULT(150)
#define DPERR_INVALIDGROUP MAKE_DPHRESULT(155)
#define DPERR_NOCAPS MAKE_DPHRESULT(160)
#define DPERR_NOCONNECTION MAKE_DPHRESULT(170)
#define DPERR_NOMEMORY E_OUTOFMEMORY
#define DPERR_OUTOFMEMORY DPERR_NOMEMORY
#define DPERR_NOMESSAGES MAKE_DPHRESULT(190)
#define DPERR_NONAMESERVERFOUND MAKE_DPHRESULT(200)
#define DPERR_NOPLAYERS MAKE_DPHRESULT(210)
#define DPERR_NOSESSIONS MAKE_DPHRESULT(220)
#define DPERR_PENDING	E_PENDING
#define DPERR_SENDTOOBIG	MAKE_DPHRESULT(230)
#define DPERR_TIMEOUT MAKE_DPHRESULT(240)
#define DPERR_UNAVAILABLE MAKE_DPHRESULT(250)
#define DPERR_UNSUPPORTED E_NOTIMPL
#define DPERR_BUSY MAKE_DPHRESULT(270)
#define DPERR_USERCANCEL MAKE_DPHRESULT(280) 
#define DPERR_NOINTERFACE E_NOINTERFACE
#define DPERR_CANNOTCREATESERVER MAKE_DPHRESULT(290)
#define DPERR_PLAYERLOST MAKE_DPHRESULT(300)
#define DPERR_SESSIONLOST MAKE_DPHRESULT(310)
#define DPERR_UNINITIALIZED MAKE_DPHRESULT(320)
#define DPERR_NONEWPLAYERS MAKE_DPHRESULT(330)
#define DPERR_INVALIDPASSWORD MAKE_DPHRESULT(340)
#define DPERR_CONNECTING MAKE_DPHRESULT(350)
#define DPERR_CONNECTIONLOST MAKE_DPHRESULT(360)
#define DPERR_UNKNOWNMESSAGE MAKE_DPHRESULT(370)
#define DPERR_CANCELFAILED MAKE_DPHRESULT(380)
#define DPERR_INVALIDPRIORITY MAKE_DPHRESULT(390)
#define DPERR_NOTHANDLED MAKE_DPHRESULT(400)
#define DPERR_CANCELLED MAKE_DPHRESULT(410)
#define DPERR_ABORTED MAKE_DPHRESULT(420)
#define DPERR_BUFFERTOOLARGE MAKE_DPHRESULT(1000)
#define DPERR_CANTCREATEPROCESS MAKE_DPHRESULT(1010)
#define DPERR_APPNOTSTARTED MAKE_DPHRESULT(1020)
#define DPERR_INVALIDINTERFACE MAKE_DPHRESULT(1030)
#define DPERR_NOSERVICEPROVIDER MAKE_DPHRESULT(1040)
#define DPERR_UNKNOWNAPPLICATION MAKE_DPHRESULT(1050)
#define DPERR_NOTLOBBIED MAKE_DPHRESULT(1070)
#define DPERR_SERVICEPROVIDERLOADED	MAKE_DPHRESULT(1080)
#define DPERR_ALREADYREGISTERED	MAKE_DPHRESULT(1090)
#define DPERR_NOTREGISTERED	MAKE_DPHRESULT(1100)
#define DPERR_AUTHENTICATIONFAILED MAKE_DPHRESULT(2000)
#define DPERR_CANTLOADSSPI MAKE_DPHRESULT(2010)
#define DPERR_ENCRYPTIONFAILED MAKE_DPHRESULT(2020)
#define DPERR_SIGNFAILED MAKE_DPHRESULT(2030)
#define DPERR_CANTLOADSECURITYPACKAGE MAKE_DPHRESULT(2040)
#define DPERR_ENCRYPTIONNOTSUPPORTED MAKE_DPHRESULT(2050)
#define DPERR_CANTLOADCAPI MAKE_DPHRESULT(2060)
#define DPERR_NOTLOGGEDIN MAKE_DPHRESULT(2070)
#define DPERR_LOGONDENIED MAKE_DPHRESULT(2080)
#ifndef IDIRECTPLAY2_OR_GREATER
#define DPOPEN_OPENSESSION DPOPEN_JOIN
#define DPOPEN_CREATESESSION DPOPEN_CREATE
#define DPENUMSESSIONS_PREVIOUS 4
#define DPENUMPLAYERS_PREVIOUS 4
#define DPSEND_GUARANTEE DPSEND_GUARANTEED
#define DPSEND_TRYONCE 4
#define DPCAPS_NAMESERVICE 1
#define DPCAPS_NAMESERVER DPCAPS_ISHOST
#define DPCAPS_GUARANTEED 4
#define DPLONGNAMELEN 52
#define DPSHORTNAMELEN 20
#define DPSESSIONNAMELEN 32
#define DPPASSWORDLEN 16
#define DPUSERRESERVED 16
#define DPSYS_ADDPLAYER 3
#define DPSYS_DELETEPLAYER 5
#define DPSYS_DELETEGROUP 32
#define DPSYS_DELETEPLAYERFROMGRP 33
#define DPSYS_CONNECT 0x484b
typedef struct
{
DWORD dwType;
DWORD dwPlayerType;
DPID dpId;
char szLongName[DPLONGNAMELEN];
char szShortName[DPSHORTNAMELEN];
DWORD dwCurrentPlayers;
} DPMSG_ADDPLAYER;
typedef DPMSG_ADDPLAYER DPMSG_ADDGROUP;
typedef struct
{
DWORD dwType;
DPID dpIdGroup;
DPID dpIdPlayer;
} DPMSG_GROUPADD;
typedef DPMSG_GROUPADD DPMSG_GROUPDELETE;
typedef struct
{
DWORD dwType;
DPID dpId;
} DPMSG_DELETEPLAYER;
typedef BOOL (PASCAL *LPDPENUMPLAYERSCALLBACK)(DPID dpId, LPSTR lpFriendlyName, LPSTR lpFormalName, DWORD dwFlags, LPVOID lpContext);
typedef struct
{
DWORD dwSize;
GUID guidSession; 
DWORD_PTR dwSession; 
DWORD dwMaxPlayers; 
DWORD dwCurrentPlayers; 
DWORD dwFlags; 
char szSessionName[DPSESSIONNAMELEN];
char szUserField[DPUSERRESERVED];
DWORD_PTR dwReserved1; 
char szPassword[DPPASSWORDLEN]; 
DWORD_PTR dwReserved2; 
DWORD_PTR dwUser1;
DWORD_PTR dwUser2;
DWORD_PTR dwUser3;
DWORD_PTR dwUser4;
} DPSESSIONDESC,*LPDPSESSIONDESC;
typedef BOOL (PASCAL * LPDPENUMSESSIONSCALLBACK)(LPDPSESSIONDESC lpDPSessionDesc, LPVOID lpContext, LPDWORD lpdwTimeOut, DWORD dwFlags);
#undef INTERFACE
#define INTERFACE IDirectPlay
DECLARE_INTERFACE_(IDirectPlay, IUnknown)
{
STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID * ppvObj) ;
STDMETHOD_(ULONG,AddRef) (THIS) ;
STDMETHOD_(ULONG,Release) (THIS) ;
STDMETHOD(AddPlayerToGroup) (THIS_ DPID, DPID) ;
STDMETHOD(Close) (THIS) ;
STDMETHOD(CreatePlayer) (THIS_ LPDPID,LPSTR,LPSTR,LPHANDLE) ;
STDMETHOD(CreateGroup) (THIS_ LPDPID,LPSTR,LPSTR) ;
STDMETHOD(DeletePlayerFromGroup)(THIS_ DPID,DPID) ;
STDMETHOD(DestroyPlayer) (THIS_ DPID) ;
STDMETHOD(DestroyGroup) (THIS_ DPID) ;
STDMETHOD(EnableNewPlayers) (THIS_ BOOL) ;
STDMETHOD(EnumGroupPlayers) (THIS_ DPID, LPDPENUMPLAYERSCALLBACK,LPVOID,DWORD) ;
STDMETHOD(EnumGroups) (THIS_ DWORD, LPDPENUMPLAYERSCALLBACK,LPVOID,DWORD) ;
STDMETHOD(EnumPlayers) (THIS_ DWORD, LPDPENUMPLAYERSCALLBACK,LPVOID,DWORD) ;
STDMETHOD(EnumSessions) (THIS_ LPDPSESSIONDESC,DWORD,LPDPENUMSESSIONSCALLBACK,LPVOID,DWORD) ;
STDMETHOD(GetCaps) (THIS_ LPDPCAPS) ;
STDMETHOD(GetMessageCount) (THIS_ DPID, LPDWORD) ;
STDMETHOD(GetPlayerCaps) (THIS_ DPID, LPDPCAPS) ;
STDMETHOD(GetPlayerName) (THIS_ DPID,LPSTR,LPDWORD,LPSTR,LPDWORD) ;
STDMETHOD(Initialize) (THIS_ LPGUID) ;
STDMETHOD(Open) (THIS_ LPDPSESSIONDESC) ;
STDMETHOD(Receive) (THIS_ LPDPID,LPDPID,DWORD,LPVOID,LPDWORD) ;
STDMETHOD(SaveSession) (THIS_ LPSTR) ;
STDMETHOD(Send) (THIS_ DPID, DPID, DWORD, LPVOID, DWORD) ;
STDMETHOD(SetPlayerName) (THIS_ DPID,LPSTR,LPSTR) ;
};
#define IDirectPlay_AddPlayerToGroup(p,a,b) (p)->lpVtbl->AddPlayerToGroup(p,a,b)
#define IDirectPlay_Close(p) (p)->lpVtbl->Close(p)
#define IDirectPlay_CreateGroup(p,a,b,c) (p)->lpVtbl->CreateGroup(p,a,b,c)
#define IDirectPlay_CreatePlayer(p,a,b,c,d) (p)->lpVtbl->CreatePlayer(p,a,b,c,d)
#define IDirectPlay_DeletePlayerFromGroup(p,a,b) (p)->lpVtbl->DeletePlayerFromGroup(p,a,b)
#define IDirectPlay_DestroyGroup(p,a) (p)->lpVtbl->DestroyGroup(p,a)
#define IDirectPlay_DestroyPlayer(p,a) (p)->lpVtbl->DestroyPlayer(p,a)
#define IDirectPlay_EnableNewPlayers(p,a) (p)->lpVtbl->EnableNewPlayers(p,a)
#define IDirectPlay_EnumGroupPlayers(p,a,b,c,d) (p)->lpVtbl->EnumGroupPlayers(p,a,b,c,d)
#define IDirectPlay_EnumGroups(p,a,b,c,d) (p)->lpVtbl->EnumGroups(p,a,b,c,d)
#define IDirectPlay_EnumPlayers(p,a,b,c,d) (p)->lpVtbl->EnumPlayers(p,a,b,c,d)
#define IDirectPlay_EnumSessions(p,a,b,c,d,e) (p)->lpVtbl->EnumSessions(p,a,b,c,d,e)
#define IDirectPlay_GetCaps(p,a) (p)->lpVtbl->GetCaps(p,a)
#define IDirectPlay_GetMessageCount(p,a,b) (p)->lpVtbl->GetMessageCount(p,a,b)
#define IDirectPlay_GetPlayerCaps(p,a,b) (p)->lpVtbl->GetPlayerCaps(p,a,b)
#define IDirectPlay_GetPlayerName(p,a,b,c,d,e) (p)->lpVtbl->GetPlayerName(p,a,b,c,d,e)
#define IDirectPlay_Initialize(p,a) (p)->lpVtbl->Initialize(p,a)
#define IDirectPlay_Open(p,a) (p)->lpVtbl->Open(p,a)
#define IDirectPlay_Receive(p,a,b,c,d,e) (p)->lpVtbl->Receive(p,a,b,c,d,e)
#define IDirectPlay_SaveSession(p,a) (p)->lpVtbl->SaveSession(p,a)
#define IDirectPlay_Send(p,a,b,c,d,e) (p)->lpVtbl->Send(p,a,b,c,d,e)
#define IDirectPlay_SetPlayerName(p,a,b,c) (p)->lpVtbl->SetPlayerName(p,a,b,c)
DEFINE_GUID(IID_IDirectPlay, 0x5454e9a0, 0xdb65, 4558, 146, 28, 0, 170, 0, 108, 73, 114);
#endif 
#define IDirectPlay_QueryInterface(p,a,b) (p)->lpVtbl->QueryInterface(p,a,b)
#define IDirectPlay_AddRef(p) (p)->lpVtbl->AddRef(p)
#define IDirectPlay_Release(p) (p)->lpVtbl->Release(p)
#endif
