#ifndef __DVP_INCLUDED__
#define __DVP_INCLUDED__
#if defined(_WIN32) && !defined(_NO_COM)
#define COM_NO_WINDOWS_H
#include <objbase.h>
#else
#define IUnknown	void
#endif
#ifndef MAXULONG_PTR
#define ULONG_PTR DWORD
#endif 
#if defined(_WIN32) && (!defined(_NO_COM) || defined(DEFINE_GUID))
DEFINE_GUID(IID_IDDVideoPortContainer,	0x6c142760,0xa733,4558,165,33,0,32,175,11,229,96);
DEFINE_GUID(IID_IDirectDrawVideoPort,	0xb36d93e0,0x2b43,4559,162,222,0,170,0,185,51,86);
DEFINE_GUID(DDVPTYPE_E_HREFH_VREFH, 0x54f39980,0xda60,4559,155,6,0,160,201,3,163,184);
DEFINE_GUID(DDVPTYPE_E_HREFH_VREFL, 0x92783220,0xda60,4559,155,6,0,160,201,3,163,184);
DEFINE_GUID(DDVPTYPE_E_HREFL_VREFH, 0xa07a02e0,0xda60,4559,155,6,0,160,201,3,163,184);
DEFINE_GUID(DDVPTYPE_E_HREFL_VREFL, 0xe09c77e0,0xda60,4559,155,6,0,160,201,3,163,184);
DEFINE_GUID(DDVPTYPE_CCIR656,	0xfca326a0,0xda60,4559,155,6,0,160,201,3,163,184);
DEFINE_GUID(DDVPTYPE_BROOKTREE, 0x1352a560,0xda61,4559,155,6,0,160,201,3,163,184);
DEFINE_GUID(DDVPTYPE_PHILIPS,	0x332cf160,0xda61,4559,155,6,0,160,201,3,163,184);
#endif
struct IDirectDraw;
struct IDirectDrawSurface;
struct IDirectDrawPalette;
struct IDirectDrawClipper;
typedef struct IDDVideoPortContainer	*LPDDVIDEOPORTCONTAINER;
typedef struct IDirectDrawVideoPort	*LPDIRECTDRAWVIDEOPORT;
typedef struct _DDVIDEOPORTCONNECT	*LPDDVIDEOPORTCONNECT;
typedef struct _DDVIDEOPORTCAPS	*LPDDVIDEOPORTCAPS;
typedef struct _DDVIDEOPORTDESC	*LPDDVIDEOPORTDESC;
typedef struct _DDVIDEOPORTINFO	*LPDDVIDEOPORTINFO;
typedef struct _DDVIDEOPORTBANDWIDTH	*LPDDVIDEOPORTBANDWIDTH;
typedef struct _DDVIDEOPORTSTATUS	*LPDDVIDEOPORTSTATUS;
typedef struct IDDVideoPortContainerVtbl DDVIDEOPORTCONTAINERCALLBACKS;
typedef struct IDirectDrawVideoPortVtbl DIRECTDRAWVIDEOPORTCALLBACKS;
typedef HRESULT (FAR PASCAL * LPDDENUMVIDEOCALLBACK)(LPDDVIDEOPORTCAPS, LPVOID);
#if defined(_WIN32) && !defined(_NO_COM)
#undef INTERFACE
#define INTERFACE IDDVideoPortContainer
DECLARE_INTERFACE_(IDDVideoPortContainer, IUnknown)
{
STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID * ppvObj) ;
STDMETHOD_(ULONG,AddRef) (THIS) ;
STDMETHOD_(ULONG,Release) (THIS) ;
STDMETHOD(CreateVideoPort)(THIS_ DWORD, LPDDVIDEOPORTDESC, LPDIRECTDRAWVIDEOPORT *, IUnknown *) ;
STDMETHOD(EnumVideoPorts)(THIS_ DWORD, LPDDVIDEOPORTCAPS, LPVOID,LPDDENUMVIDEOCALLBACK) ;
STDMETHOD(GetVideoPortConnectInfo)(THIS_ DWORD, LPDWORD, LPDDVIDEOPORTCONNECT) ;
STDMETHOD(QueryVideoPortStatus)(THIS_ DWORD, LPDDVIDEOPORTSTATUS) ;
};
#define IVideoPortContainer_QueryInterface(p, a, b) (p)->lpVtbl->QueryInterface(p, a, b)
#define IVideoPortContainer_AddRef(p) (p)->lpVtbl->AddRef(p)
#define IVideoPortContainer_Release(p) (p)->lpVtbl->Release(p)
#define IVideoPortContainer_CreateVideoPort(p, a, b, c, d) (p)->lpVtbl->CreateVideoPort(p, a, b, c, d)
#define IVideoPortContainer_EnumVideoPorts(p, a, b, c, d) (p)->lpVtbl->EnumVideoPorts(p, a, b, c, d)
#define IVideoPortContainer_GetVideoPortConnectInfo(p, a, b, c) (p)->lpVtbl->GetVideoPortConnectInfo(p, a, b, c)
#define IVideoPortContainer_QueryVideoPortStatus(p, a, b) (p)->lpVtbl->QueryVideoPortStatus(p, a, b)
#endif
#if defined(_WIN32) && !defined(_NO_COM)
#undef INTERFACE
#define INTERFACE IDirectDrawVideoPort
DECLARE_INTERFACE_(IDirectDrawVideoPort, IUnknown)
{
STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID * ppvObj) ;
STDMETHOD_(ULONG,AddRef) (THIS) ;
STDMETHOD_(ULONG,Release) (THIS) ;
STDMETHOD(Flip)(THIS_ LPDIRECTDRAWSURFACE, DWORD) ;
STDMETHOD(GetBandwidthInfo)(THIS_ LPDDPIXELFORMAT, DWORD, DWORD, DWORD, LPDDVIDEOPORTBANDWIDTH) ;
STDMETHOD(GetColorControls)(THIS_ LPDDCOLORCONTROL) ;
STDMETHOD(GetInputFormats)(THIS_ LPDWORD, LPDDPIXELFORMAT, DWORD) ;
STDMETHOD(GetOutputFormats)(THIS_ LPDDPIXELFORMAT, LPDWORD, LPDDPIXELFORMAT, DWORD) ;
STDMETHOD(GetFieldPolarity)(THIS_ LPBOOL) ;
STDMETHOD(GetVideoLine)(THIS_ LPDWORD) ;
STDMETHOD(GetVideoSignalStatus)(THIS_ LPDWORD) ;
STDMETHOD(SetColorControls)(THIS_ LPDDCOLORCONTROL) ;
STDMETHOD(SetTargetSurface)(THIS_ LPDIRECTDRAWSURFACE, DWORD) ;
STDMETHOD(StartVideo)(THIS_ LPDDVIDEOPORTINFO) ;
STDMETHOD(StopVideo)(THIS) ;
STDMETHOD(UpdateVideo)(THIS_ LPDDVIDEOPORTINFO) ;
STDMETHOD(WaitForSync)(THIS_ DWORD, DWORD, DWORD) ;
};
#define IVideoPort_QueryInterface(p,a,b) (p)->lpVtbl->QueryInterface(p,a,b)
#define IVideoPort_AddRef(p) (p)->lpVtbl->AddRef(p)
#define IVideoPort_Release(p) (p)->lpVtbl->Release(p)
#define IVideoPort_SetTargetSurface(p,a,b)	(p)->lpVtbl->SetTargetSurface(p,a,b)
#define IVideoPort_Flip(p,a,b)	(p)->lpVtbl->Flip(p,a,b)
#define IVideoPort_GetBandwidthInfo(p,a,b,c,d,e) (p)->lpVtbl->GetBandwidthInfo(p,a,b,c,d,e)
#define IVideoPort_GetColorControls(p,a) (p)->lpVtbl->GetColorControls(p,a)
#define IVideoPort_GetInputFormats(p,a,b,c)	(p)->lpVtbl->GetInputFormats(p,a,b,c)
#define IVideoPort_GetOutputFormats(p,a,b,c,d)	(p)->lpVtbl->GetOutputFormats(p,a,b,c,d)
#define IVideoPort_GetFieldPolarity(p,a)	(p)->lpVtbl->GetFieldPolarity(p,a)
#define IVideoPort_GetVideoLine(p,a)	(p)->lpVtbl->GetVideoLine(p,a)
#define IVideoPort_GetVideoSignalStatus(p,a)	(p)->lpVtbl->GetVideoSignalStatus(p,a)
#define IVideoPort_SetColorControls(p,a)	(p)->lpVtbl->SetColorControls(p,a)
#define IVideoPort_StartVideo(p,a)	(p)->lpVtbl->StartVideo(p,a)
#define IVideoPort_StopVideo(p)	(p)->lpVtbl->StopVideo(p)
#define IVideoPort_UpdateVideo(p,a)	(p)->lpVtbl->UpdateVideo(p,a)
#define IVideoPort_WaitForSync(p,a,b,c)	(p)->lpVtbl->WaitForSync(p,a,b,c)
#endif
typedef struct _DDVIDEOPORTCONNECT
{
DWORD dwSize; 
DWORD dwPortWidth; 
GUID guidTypeID; 
DWORD dwFlags; 
ULONG_PTR dwReserved1; 
} DDVIDEOPORTCONNECT;
typedef struct _DDVIDEOPORTCAPS
{
DWORD dwSize;	
DWORD dwFlags;	
DWORD dwMaxWidth;	
DWORD dwMaxVBIWidth;	
DWORD dwMaxHeight; 
DWORD dwVideoPortID;	
DWORD dwCaps;	
DWORD dwFX;	
DWORD dwNumAutoFlipSurfaces;	
DWORD dwAlignVideoPortBoundary;	
DWORD dwAlignVideoPortPrescaleWidth;
DWORD dwAlignVideoPortCropBoundary;	
DWORD dwAlignVideoPortCropWidth;	
DWORD dwPreshrinkXStep;	
DWORD dwPreshrinkYStep;	
DWORD dwNumVBIAutoFlipSurfaces;	
DWORD dwNumPreferredAutoflip;	
WORD wNumFilterTapsX; 
WORD wNumFilterTapsY; 
} DDVIDEOPORTCAPS;
#define DDVPD_WIDTH	1
#define DDVPD_HEIGHT	2
#define DDVPD_ID	4
#define DDVPD_CAPS	8
#define DDVPD_FX	16
#define DDVPD_AUTOFLIP	32
#define DDVPD_ALIGN	64
#define DDVPD_PREFERREDAUTOFLIP 128
#define DDVPD_FILTERQUALITY 256
typedef struct _DDVIDEOPORTDESC
{
DWORD dwSize;	
DWORD dwFieldWidth;	
DWORD dwVBIWidth;	
DWORD dwFieldHeight;	
DWORD dwMicrosecondsPerField;	
DWORD dwMaxPixelsPerSecond;	
DWORD dwVideoPortID;	
DWORD dwReserved1;	
DDVIDEOPORTCONNECT VideoPortType; 
ULONG_PTR dwReserved2;	
ULONG_PTR dwReserved3;	
} DDVIDEOPORTDESC;
typedef struct _DDVIDEOPORTINFO
{
DWORD dwSize;	
DWORD dwOriginX;	
DWORD dwOriginY;	
DWORD dwVPFlags;	
RECT rCrop;	
DWORD dwPrescaleWidth;	
DWORD dwPrescaleHeight;	
LPDDPIXELFORMAT lpddpfInputFormat;	
LPDDPIXELFORMAT lpddpfVBIInputFormat; 
LPDDPIXELFORMAT lpddpfVBIOutputFormat;
DWORD dwVBIHeight;	
ULONG_PTR dwReserved1;	
ULONG_PTR dwReserved2;	
} DDVIDEOPORTINFO;
typedef struct _DDVIDEOPORTBANDWIDTH
{
DWORD dwSize;	
DWORD dwCaps;
DWORD dwOverlay; 
DWORD dwColorkey;	
DWORD dwYInterpolate;	
DWORD dwYInterpAndColorkey;	
ULONG_PTR dwReserved1;	
ULONG_PTR dwReserved2;	
} DDVIDEOPORTBANDWIDTH;
typedef struct _DDVIDEOPORTSTATUS
{
DWORD dwSize;	
BOOL bInUse;	
DWORD dwFlags; 
DWORD dwReserved1;	
DDVIDEOPORTCONNECT VideoPortType;	
ULONG_PTR dwReserved2;	
ULONG_PTR dwReserved3;	
} DDVIDEOPORTSTATUS;
#define DDVPCONNECT_DOUBLECLOCK	1
#define DDVPCONNECT_VACT	2
#define DDVPCONNECT_INVERTPOLARITY	4
#define DDVPCONNECT_DISCARDSVREFDATA	8
#define DDVPCONNECT_HALFLINE	16
#define DDVPCONNECT_INTERLACED	32
#define DDVPCONNECT_SHAREEVEN	64
#define DDVPCONNECT_SHAREODD	128
#define DDVPCAPS_AUTOFLIP	1
#define DDVPCAPS_INTERLACED	2
#define DDVPCAPS_NONINTERLACED	4
#define DDVPCAPS_READBACKFIELD	8
#define DDVPCAPS_READBACKLINE	16
#define DDVPCAPS_SHAREABLE	32
#define DDVPCAPS_SKIPEVENFIELDS	64
#define DDVPCAPS_SKIPODDFIELDS	128
#define DDVPCAPS_SYNCMASTER	256
#define DDVPCAPS_VBISURFACE	512
#define DDVPCAPS_COLORCONTROL	1024
#define DDVPCAPS_OVERSAMPLEDVBI	2048
#define DDVPCAPS_SYSTEMMEMORY	4096
#define DDVPCAPS_VBIANDVIDEOINDEPENDENT	0x2000
#define DDVPCAPS_HARDWAREDEINTERLACE	0x4000
#define DDVPFX_CROPTOPDATA	1
#define DDVPFX_CROPX	2
#define DDVPFX_CROPY	4
#define DDVPFX_INTERLEAVE	8
#define DDVPFX_MIRRORLEFTRIGHT	16
#define DDVPFX_MIRRORUPDOWN	32
#define DDVPFX_PRESHRINKX	64
#define DDVPFX_PRESHRINKY	128
#define DDVPFX_PRESHRINKXB	256
#define DDVPFX_PRESHRINKYB	512
#define DDVPFX_PRESHRINKXS	1024
#define DDVPFX_PRESHRINKYS	2048
#define DDVPFX_PRESTRETCHX	4096
#define DDVPFX_PRESTRETCHY	0x2000
#define DDVPFX_PRESTRETCHXN	0x4000
#define DDVPFX_PRESTRETCHYN	0x8000
#define DDVPFX_VBICONVERT	0x10000
#define DDVPFX_VBINOSCALE	0x20000
#define DDVPFX_IGNOREVBIXCROP	0x40000
#define DDVPFX_VBINOINTERLEAVE	0x80000
#define DDVP_AUTOFLIP	1
#define DDVP_CONVERT	2
#define DDVP_CROP	4
#define DDVP_INTERLEAVE	8
#define DDVP_MIRRORLEFTRIGHT	16
#define DDVP_MIRRORUPDOWN	32
#define DDVP_PRESCALE	64
#define DDVP_SKIPEVENFIELDS	128
#define DDVP_SKIPODDFIELDS	256
#define DDVP_SYNCMASTER	512
#define DDVP_VBICONVERT	1024
#define DDVP_VBINOSCALE	2048
#define DDVP_OVERRIDEBOBWEAVE	4096
#define DDVP_IGNOREVBIXCROP	0x2000
#define DDVP_VBINOINTERLEAVE	0x4000
#define DDVP_HARDWAREDEINTERLACE	0x8000
#define DDVPFORMAT_VIDEO	1
#define DDVPFORMAT_VBI	2
#define DDVPTARGET_VIDEO	1
#define DDVPTARGET_VBI	2
#define DDVPWAIT_BEGIN	1
#define DDVPWAIT_END	2
#define DDVPWAIT_LINE	3
#define DDVPFLIP_VIDEO	1
#define DDVPFLIP_VBI	2
#define DDVPSQ_NOSIGNAL	1
#define DDVPSQ_SIGNALOK	2
#define DDVPB_VIDEOPORT	1
#define DDVPB_OVERLAY	2
#define DDVPB_TYPE	4
#define DDVPBCAPS_SOURCE	1
#define DDVPBCAPS_DESTINATION	2
#define DDVPCREATE_VBIONLY	1
#define DDVPCREATE_VIDEOONLY	2
#define DDVPSTATUS_VBIONLY	1
#define DDVPSTATUS_VIDEOONLY	2
#endif
