#include <windows.h>
#pragma pack(push,1)
//
// List of names with the internal name as generated by the compiler, and
// the external name as exported from the dll.
typedef struct _namesList {
	struct _namesList *Next;
	char *InternalName;
	char *ExportedName;
} NAMES_LIST;
//
// The list of dlls that this object file needs
//
typedef struct _DllList {
	struct _DllList *Next;
	char *Name;
	NAMES_LIST *Functions;
	int Flags;
	HANDLE h;
} DLL_LIST;
// The flags field in the structure above
#define DLL_LOADED	1

typedef struct _OpenImgPointers {
	PIMAGE_NT_HEADERS NTHeader;
	PIMAGE_FILE_HEADER ImageFileHeader;
	unsigned int cSymbols;
	PIMAGE_SYMBOL SymbolTable;
	PIMAGE_SECTION_HEADER Sections;
	char *StringTable;
	char *BoundImportTable;
	DLL_LIST *Dlls;
	int dataSize;
	int bssSize;
	unsigned int bssStart;
} OPEN_IMAGE_POINTERS;

typedef struct _OpenImg {
	char *Name;
	HANDLE hFile;
	HANDLE hFileMapping;
	unsigned char *Data;
	unsigned int FileSize;
	int Flags;
	OPEN_IMAGE_POINTERS *Pointers;
} OPEN_IMAGE;
typedef struct _image_symbol {
	char *Name;
	unsigned long Address;
} IMG_SYMBOL;

typedef struct _objectFile {
	// The name of the file
	char *FileName;
	// The number of public .text symbols
	int NumberOfFunctions;
	// The number of public .data symbols
	int NumberOfVariables;
	// The Functions table
	IMG_SYMBOL *Functions;
	// The variables table (data)
	IMG_SYMBOL *Variables;
	// The number of undefined code symbols
	int CodeUndefined;
	// The number of variables undefined
	int DataUndefined;
	// The start of the code
	void *Code;
	// The start of the data
	unsigned char *Data;
	// The dlls this object file uses
	DLL_LIST *Dlls;
	// The import table
	unsigned long *ImportTable;
	// The index into the import table
	unsigned int iTablePtr;
} OBJECT_FILE;
#pragma pack(pop)
#define EXECUTABLE_IMAGE	1
#define COFF_OBJECT			2
#define COFF_LIBRARY		4

OBJECT_FILE *LoadObjectFile(unsigned char *Name);
typedef OBJECT_FILE *(*LOADFN_PTR)(unsigned char *);
void *GetProcedureAddress(OBJECT_FILE *obj,unsigned char *name);
typedef void *(*GETPROCFN_PTR)(OBJECT_FILE *,unsigned char *);
void UnloadObjectFile(OBJECT_FILE *obj);
typedef void (*UNLOADFN_PTR)(OBJECT_FILE *);
int GetSymbolName(OPEN_IMAGE *oi,PIMAGE_SYMBOL sym,unsigned char *buf,int len);
OPEN_IMAGE *OpenImgFile(LPSTR filename);
int IterateSymbolTable(OPEN_IMAGE *oi,int (*fn)(PIMAGE_SYMBOL,void *),void *pUserData);
void CloseImgFile(OPEN_IMAGE *oi);
