#ifndef __evntrace_h__
#define __evntrace_h__
#define WMIAPI __stdcall
#include <guiddef.h>
DEFINE_GUID (EventTraceGuid, 0x68fdd900, 0x4a3e, 4561, 132, 244, 0, 0, 248, 4, 100, 227 );
DEFINE_GUID (SystemTraceControlGuid, 0x9e814aad, 0x3204, 4562, 154, 130, 0, 96, 8, 168, 105, 57 );
#define MAX_MOF_FIELDS 16 
typedef ULONG64 TRACEHANDLE, *PTRACEHANDLE;
typedef struct _TRACE_ENABLE_CONTEXT {
USHORT LoggerId; 
UCHAR Level; 
UCHAR InternalFlag; 
ULONG EnableFlags; 
} TRACE_ENABLE_CONTEXT, *PTRACE_ENABLE_CONTEXT;
#define EVENT_TRACE_TYPE_INFO 0
#define EVENT_TRACE_TYPE_START 1
#define EVENT_TRACE_TYPE_END 2
#define EVENT_TRACE_TYPE_DC_START 3
#define EVENT_TRACE_TYPE_DC_END 4
#define EVENT_TRACE_TYPE_EXTENSION 5
#define EVENT_TRACE_TYPE_REPLY 6
#define EVENT_TRACE_TYPE_RESERVED7 7
#define EVENT_TRACE_TYPE_RESERVED8 8
#define EVENT_TRACE_TYPE_RESERVED9 9
#define EVENT_TRACE_TYPE_LOAD 10
#define EVENT_TRACE_TYPE_IO_READ 10
#define EVENT_TRACE_TYPE_IO_WRITE 11
#define EVENT_TRACE_TYPE_MM_TF 10
#define EVENT_TRACE_TYPE_MM_DZF 11
#define EVENT_TRACE_TYPE_MM_COW 12
#define EVENT_TRACE_TYPE_MM_GPF 13
#define EVENT_TRACE_TYPE_MM_HPF 14
#define EVENT_TRACE_TYPE_SEND 10
#define EVENT_TRACE_TYPE_RECEIVE 11
#define EVENT_TRACE_TYPE_CONNECT 12
#define EVENT_TRACE_TYPE_DISCONNECT 13
#define EVENT_TRACE_TYPE_GUIDMAP 10
#define EVENT_TRACE_TYPE_CONFIG 11
#define EVENT_TRACE_TYPE_SIDINFO 12
#define EVENT_TRACE_TYPE_SECURITY 13
#define EVENT_TRACE_TYPE_REGCREATE 10
#define EVENT_TRACE_TYPE_REGOPEN 11
#define EVENT_TRACE_TYPE_REGDELETE 12
#define EVENT_TRACE_TYPE_REGQUERY 13
#define EVENT_TRACE_TYPE_REGSETVALUE 14
#define EVENT_TRACE_TYPE_REGDELETEVALUE 15
#define EVENT_TRACE_TYPE_REGQUERYVALUE 16
#define EVENT_TRACE_TYPE_REGENUMERATEKEY 17
#define EVENT_TRACE_TYPE_REGENUMERATEVALUEKEY 18
#define EVENT_TRACE_TYPE_REGQUERYMULTIPLEVALUE 19
#define EVENT_TRACE_TYPE_REGSETINFORMATION 20
#define EVENT_TRACE_TYPE_REGFLUSH 21
#define EVENT_TRACE_FLAG_PROCESS 1
#define EVENT_TRACE_FLAG_THREAD 2
#define EVENT_TRACE_FLAG_IMAGE_LOAD 4
#define EVENT_TRACE_FLAG_DISK_IO 256
#define EVENT_TRACE_FLAG_DISK_FILE_IO 512
#define EVENT_TRACE_FLAG_MEMORY_PAGE_FAULTS 4096
#define EVENT_TRACE_FLAG_MEMORY_HARD_FAULTS 0x2000
#define EVENT_TRACE_FLAG_NETWORK_TCPIP 0x10000
#define EVENT_TRACE_FLAG_REGISTRY 0x20000
#define EVENT_TRACE_FLAG_EXTENSION 0x80000000
#define EVENT_TRACE_FLAG_FORWARD_WMI 0x40000000
#define EVENT_TRACE_FLAG_ENABLE_RESERVE 0x20000000
#define EVENT_TRACE_FILE_MODE_NONE 0
#define EVENT_TRACE_FILE_MODE_SEQUENTIAL 1
#define EVENT_TRACE_FILE_MODE_CIRCULAR 2
#define EVENT_TRACE_FILE_MODE_NEWFILE 4
#define EVENT_TRACE_REAL_TIME_MODE 256
#define EVENT_TRACE_DELAY_OPEN_FILE_MODE 512
#define EVENT_TRACE_BUFFERING_MODE 1024
#define EVENT_TRACE_PRIVATE_LOGGER_MODE 2048
#define EVENT_TRACE_ADD_HEADER_MODE 4096
#define EVENT_TRACE_CONTROL_QUERY 0
#define EVENT_TRACE_CONTROL_STOP 1
#define EVENT_TRACE_CONTROL_UPDATE 2
typedef struct _EVENT_TRACE_HEADER { 
USHORT Size; 
UCHAR HeaderType; 
UCHAR MarkerFlags; 
union {
ULONG Version;
struct {
UCHAR Type; 
UCHAR Level; 
USHORT Version; 
} Class;
};
ULONGLONG ThreadId; 
LARGE_INTEGER TimeStamp; 
union {
GUID Guid; 
ULONGLONG GuidPtr; 
};
union {
struct {
ULONG ClientContext; 
ULONG Flags; 
};
struct {
ULONG KernelTime; 
ULONG UserTime; 
};
ULONG64 ProcessorTime; 
};
} EVENT_TRACE_HEADER, *PEVENT_TRACE_HEADER;
typedef struct _EVENT_INSTANCE_HEADER {
USHORT Size;
UCHAR HeaderType;
UCHAR MarkerFlags;
union {
ULONG Version;
struct {
UCHAR Type;
UCHAR Level;
USHORT Version;
} Class;
};
ULONGLONG ThreadId;
LARGE_INTEGER TimeStamp;
ULONGLONG RegHandle;
ULONG InstanceId;
ULONG ParentInstanceId;
union {
struct {
ULONG ClientContext; 
ULONG Flags; 
};
struct {
ULONG KernelTime; 
ULONG UserTime; 
};
ULONG64 ProcessorTime; 
};
ULONGLONG ParentRegHandle;
} EVENT_INSTANCE_HEADER, *PEVENT_INSTANCE_HEADER;
#define DEFINE_TRACE_MOF_FIELD(MOF, ptr, length, type) \
(MOF)->DataPtr=(ULONG64) ptr; \
(MOF)->Length=(ULONG) length; \
(MOF)->DataType=(ULONG) type;
#define EVENT_TRACE_MOF_TYPE_UNKNOWN 0 
#define EVENT_TRACE_MOF_TYPE_8BIT 1 
#define EVENT_TRACE_MOF_TYPE_16BIT 2 
#define EVENT_TRACE_MOF_TYPE_32BIT 3 
#define EVENT_TRACE_MOF_TYPE_64BIT 4 
#define EVENT_TRACE_MOF_TYPE_CSTRING 5 
#define EVENT_TRACE_MOF_TYPE_C2STRING 6 
#define EVENT_TRACE_MOF_TYPE_CWSTRING 7 
#define EVENT_TRACE_MOF_TYPE_CLSTRING 8 
#define EVENT_TRACE_MOF_TYPE_STRING 9 
#define EVENT_TRACE_MOF_TYPE_WSTRING 10 
typedef struct _MOF_FIELD {
ULONG64 DataPtr; 
ULONG Length; 
ULONG DataType; 
} MOF_FIELD, *PMOF_FIELD;
#if !defined(_NTDDK_) || defined(_WMIKM_)
typedef struct _TRACE_LOGFILE_HEADER {
ULONG BufferSize; 
union {
ULONG Version; 
struct {
UCHAR MajorVersion;
UCHAR MinorVersion;
UCHAR SubVersion;
UCHAR SubMinorVersion;
} VersionDetail;
};
ULONG ProviderVersion; 
ULONG NumberOfProcessors; 
LARGE_INTEGER EndTime; 
ULONG TimerResolution; 
ULONG MaximumFileSize; 
ULONG LogFileMode; 
ULONG BuffersWritten; 
union {
GUID LogInstanceGuid; 
struct {
ULONG StartBuffers; 
ULONG Reserved32; 
ULONG64 Reserved64; 
};
};
#if defined(_WMIKM_)
PWCHAR LoggerName;
PWCHAR LogFileName;
RTL_TIME_ZONE_INFORMATION TimeZone;
#else
LPWSTR LoggerName;
LPWSTR LogFileName;
TIME_ZONE_INFORMATION TimeZone;
#endif
LARGE_INTEGER BootTime;
LARGE_INTEGER PerfFreq; 
LARGE_INTEGER StartTime; 
ULONG ReservedFlags; 
ULONG PrivateUse;
} TRACE_LOGFILE_HEADER, *PTRACE_LOGFILE_HEADER;
#endif 
typedef struct EVENT_INSTANCE_INFO {
HANDLE RegHandle;
ULONG InstanceId;
} EVENT_INSTANCE_INFO, *PEVENT_INSTANCE_INFO;
#if !defined(_WMIKM_) && !defined(_NTDDK_)
typedef struct _EVENT_TRACE_PROPERTIES {
WNODE_HEADER Wnode;
ULONG BufferSize; 
ULONG MinimumBuffers; 
ULONG MaximumBuffers; 
ULONG MaximumFileSize; 
ULONG LogFileMode; 
ULONG FlushTimer; 
ULONG EnableFlags; 
LONG AgeLimit; 
ULONG NumberOfBuffers; 
ULONG FreeBuffers; 
ULONG EventsLost; 
ULONG BuffersWritten; 
ULONG LogBuffersLost; 
ULONG RealTimeBuffersLost; 
HANDLE LoggerThreadId; 
ULONG LogFileNameOffset; 
ULONG LoggerNameOffset; 
} EVENT_TRACE_PROPERTIES, *PEVENT_TRACE_PROPERTIES;
typedef struct _TRACE_GUID_REGISTRATION {
LPGUID Guid; 
HANDLE RegHandle; 
} TRACE_GUID_REGISTRATION, *PTRACE_GUID_REGISTRATION;
typedef struct _EVENT_TRACE {
EVENT_TRACE_HEADER Header; 
ULONG InstanceId; 
ULONG ParentInstanceId; 
GUID ParentGuid; 
PVOID MofData; 
ULONG MofLength; 
ULONG ClientContext; 
} EVENT_TRACE, *PEVENT_TRACE;
typedef struct _EVENT_TRACE_LOGFILEW
EVENT_TRACE_LOGFILEW, *PEVENT_TRACE_LOGFILEW;
typedef struct _EVENT_TRACE_LOGFILEA
EVENT_TRACE_LOGFILEA, *PEVENT_TRACE_LOGFILEA;
typedef ULONG (*PEVENT_TRACE_BUFFER_CALLBACKW)
(PEVENT_TRACE_LOGFILEW Logfile);
typedef ULONG (*PEVENT_TRACE_BUFFER_CALLBACKA)
(PEVENT_TRACE_LOGFILEA Logfile);
typedef VOID (*PEVENT_CALLBACK)(PEVENT_TRACE pEvent);
typedef ULONG (
#ifndef MIDL_PASS 
WINAPI 
#endif 
*WMIDPREQUEST)(WMIDPREQUESTCODE RequestCode, PVOID RequestContext, ULONG *BufferSize, PVOID Buffer );
struct _EVENT_TRACE_LOGFILEW {
LPWSTR LogFileName; 
LPWSTR LoggerName; 
LONGLONG CurrentTime; 
ULONG BuffersRead; 
ULONG LogFileMode; 
EVENT_TRACE CurrentEvent; 
TRACE_LOGFILE_HEADER LogfileHeader; 
PEVENT_TRACE_BUFFER_CALLBACKW 
BufferCallback; 
ULONG BufferSize;
ULONG Filled;
ULONG EventsLost;
PEVENT_CALLBACK EventCallback; 
ULONG IsKernelTrace; 
PVOID Context; 
};
struct _EVENT_TRACE_LOGFILEA {
LPSTR LogFileName; 
LPSTR LoggerName; 
LONGLONG CurrentTime; 
ULONG BuffersRead; 
ULONG LogFileMode; 
EVENT_TRACE CurrentEvent; 
TRACE_LOGFILE_HEADER LogfileHeader; 
PEVENT_TRACE_BUFFER_CALLBACKA 
BufferCallback; 
ULONG BufferSize;
ULONG Filled;
ULONG EventsLost;
PEVENT_CALLBACK EventCallback; 
ULONG IsKernelTrace; 
PVOID Context; 
};
#if defined(_UNICODE) || defined(UNICODE)
#define PEVENT_TRACE_BUFFER_CALLBACK PEVENT_TRACE_BUFFER_CALLBACKW
#define EVENT_TRACE_LOGFILE EVENT_TRACE_LOGFILEW
#define PEVENT_TRACE_LOGFILE PEVENT_TRACE_LOGFILEW
#else
#define PEVENT_TRACE_BUFFER_CALLBACK PEVENT_TRACE_BUFFER_CALLBACKA
#define EVENT_TRACE_LOGFILE EVENT_TRACE_LOGFILEA
#define PEVENT_TRACE_LOGFILE PEVENT_TRACE_LOGFILEA
#endif
EXTERN_C ULONG WMIAPI StartTraceW( PTRACEHANDLE TraceHandle, LPCWSTR InstanceName, PEVENT_TRACE_PROPERTIES Properties );
EXTERN_C ULONG WMIAPI StartTraceA( PTRACEHANDLE TraceHandle, LPCSTR InstanceName, PEVENT_TRACE_PROPERTIES Properties );
EXTERN_C ULONG WMIAPI ControlTraceW(TRACEHANDLE TraceHandle, LPCWSTR InstanceName, PEVENT_TRACE_PROPERTIES Properties, ULONG ControlCode );
EXTERN_C ULONG WMIAPI ControlTraceA(TRACEHANDLE TraceHandle, LPCSTR InstanceName, PEVENT_TRACE_PROPERTIES Properties, ULONG ControlCode );
EXTERN_C ULONG WMIAPI QueryAllTracesW(PEVENT_TRACE_PROPERTIES *PropertyArray, ULONG PropertyArrayCount, PULONG LoggerCount );
EXTERN_C ULONG WMIAPI QueryAllTracesA(PEVENT_TRACE_PROPERTIES *PropertyArray, ULONG PropertyArrayCount, PULONG LoggerCount );
EXTERN_C ULONG WMIAPI CreateTraceInstanceId(HANDLE RegHandle, PEVENT_INSTANCE_INFO pInstInfo );
EXTERN_C ULONG WMIAPI EnableTrace( ULONG Enable, ULONG EnableFlag, ULONG EnableLevel, LPCGUID ControlGuid, TRACEHANDLE TraceHandle );
EXTERN_C ULONG WMIAPI TraceEvent( TRACEHANDLE TraceHandle, PEVENT_TRACE_HEADER EventTrace );
EXTERN_C ULONG WMIAPI TraceEventInstance(TRACEHANDLE TraceHandle, PEVENT_INSTANCE_HEADER EventTrace, PEVENT_INSTANCE_INFO pInstInfo, PEVENT_INSTANCE_INFO pParentInstInfo );
EXTERN_C ULONG WMIAPI RegisterTraceGuidsW(WMIDPREQUEST RequestAddress, PVOID RequestContext, LPCGUID ControlGuid, ULONG GuidCount, PTRACE_GUID_REGISTRATION TraceGuidReg, LPCWSTR MofImagePath, LPCWSTR MofResourceName, PTRACEHANDLE RegistrationHandle );
EXTERN_C ULONG WMIAPI RegisterTraceGuidsA(WMIDPREQUEST RequestAddress, PVOID RequestContext, LPCGUID ControlGuid, ULONG GuidCount, PTRACE_GUID_REGISTRATION TraceGuidReg, LPCSTR MofImagePath, LPCSTR MofResourceName, PTRACEHANDLE RegistrationHandle );
EXTERN_C ULONG WMIAPI UnregisterTraceGuids(TRACEHANDLE RegistrationHandle );
EXTERN_C TRACEHANDLE WMIAPI GetTraceLoggerHandle(PVOID Buffer );
EXTERN_C UCHAR WMIAPI GetTraceEnableLevel(TRACEHANDLE TraceHandle );
EXTERN_C ULONG WMIAPI GetTraceEnableFlags(TRACEHANDLE TraceHandle );
EXTERN_C TRACEHANDLE WMIAPI OpenTraceA( PEVENT_TRACE_LOGFILEA Logfile );
EXTERN_C TRACEHANDLE WMIAPI OpenTraceW( PEVENT_TRACE_LOGFILEW Logfile );
EXTERN_C ULONG WMIAPI ProcessTrace( PTRACEHANDLE HandleArray, ULONG HandleCount, LPFILETIME StartTime, LPFILETIME EndTime );
EXTERN_C ULONG WMIAPI CloseTrace( TRACEHANDLE TraceHandle );
EXTERN_C ULONG WMIAPI SetTraceCallback(LPCGUID pGuid, PEVENT_CALLBACK EventCallback );
EXTERN_C ULONG WMIAPI RemoveTraceCallback (LPCGUID pGuid );
#if defined(UNICODE) || defined(_UNICODE)
#define RegisterTraceGuids RegisterTraceGuidsW
#define StartTrace StartTraceW
#define ControlTrace ControlTraceW
#define StopTrace(a,b,c) ControlTraceW((a),(b),(c),EVENT_TRACE_CONTROL_STOP)
#define QueryTrace(a,b,c) ControlTraceW((a),(b),(c),EVENT_TRACE_CONTROL_QUERY)
#define UpdateTrace(a,b,c) ControlTraceW((a),(b),(c),EVENT_TRACE_CONTROL_UPDATE)
#define QueryAllTraces QueryAllTracesW
#define OpenTrace OpenTraceW
#else
#define RegisterTraceGuids RegisterTraceGuidsA
#define StartTrace StartTraceA
#define ControlTrace ControlTraceA
#define StopTrace(a,b,c) ControlTraceA((a),(b),(c),EVENT_TRACE_CONTROL_STOP)
#define QueryTrace(a,b,c) ControlTraceA((a),(b),(c),EVENT_TRACE_CONTROL_QUERY)
#define UpdateTrace(a,b,c) ControlTraceA((a),(b),(c),EVENT_TRACE_CONTROL_UPDATE)
#define QueryAllTraces QueryAllTracesA
#define OpenTrace OpenTraceA
#endif 
#endif 
#endif 
