#ifndef __gpedit_h__
#define __gpedit_h__
#ifndef __windows_h__
#include <windows.h>
#endif
#define GPEDITAPI
#include <objbase.h>
#define GPO_SECTION_ROOT 0 
#define GPO_SECTION_USER 1 
#define GPO_SECTION_MACHINE 2 
typedef enum _GROUP_POLICY_OBJECT_TYPE {
GPOTypeLocal=0,
GPOTypeRemote,
GPOTypeDS 
} GROUP_POLICY_OBJECT_TYPE,*PGROUP_POLICY_OBJECT_TYPE;
typedef enum _GROUP_POLICY_HINT_TYPE {
GPHintUnknown=0,
GPHintMachine,
GPHintSite,
GPHintDomain,
GPHintOrganizationalUnit,
} GROUP_POLICY_HINT_TYPE,*PGROUP_POLICY_HINT_TYPE;
#undef INTERFACE
#define INTERFACE IGPEInformation
DECLARE_INTERFACE_(IGPEInformation,IUnknown)
{
STDMETHOD(QueryInterface) (THIS_ REFIID ,LPVOID *);
STDMETHOD_(ULONG,AddRef) (THIS);
STDMETHOD_(ULONG,Release) (THIS);
STDMETHOD(GetName) (THIS_ LPOLESTR ,int );
STDMETHOD(GetDisplayName) (THIS_ LPOLESTR ,int );
STDMETHOD(GetRegistryKey) (THIS_ DWORD ,HKEY *);
STDMETHOD(GetDSPath) (THIS_ DWORD ,LPOLESTR ,int );
STDMETHOD(GetFileSysPath) (THIS_ DWORD ,LPOLESTR ,int );
STDMETHOD(GetOptions) (THIS_ DWORD *);
STDMETHOD(GetType) (THIS_ GROUP_POLICY_OBJECT_TYPE *);
STDMETHOD(GetHint) (THIS_ GROUP_POLICY_HINT_TYPE *);
STDMETHOD(PolicyChanged) (THIS_ BOOL ,BOOL ,GUID *,GUID *);
};
typedef IGPEInformation *LPGPEINFORMATION;
#define GPO_OPEN_LOAD_REGISTRY 1
#define GPO_OPEN_READ_ONLY 2
#define GPO_OPTION_DISABLE_USER 1
#define GPO_OPTION_DISABLE_MACHINE 2
#undef INTERFACE
#define INTERFACE IGroupPolicyObject
DECLARE_INTERFACE_(IGroupPolicyObject,IUnknown)
{
STDMETHOD(QueryInterface) (THIS_ REFIID ,LPVOID *);
STDMETHOD_(ULONG,AddRef) (THIS);
STDMETHOD_(ULONG,Release) (THIS);
STDMETHOD(New) (THIS_ LPOLESTR ,LPOLESTR ,DWORD );
STDMETHOD(OpenDSGPO) (THIS_ LPOLESTR ,DWORD );
STDMETHOD(OpenLocalMachineGPO) (THIS_ DWORD );
STDMETHOD(OpenRemoteMachineGPO) (THIS_ LPOLESTR ,DWORD );
STDMETHOD(Save) (THIS_ BOOL ,BOOL ,GUID *,GUID *);
STDMETHOD(Delete) (THIS);
STDMETHOD(GetName) (THIS_ LPOLESTR ,int );
STDMETHOD(GetDisplayName) (THIS_ LPOLESTR ,int );
STDMETHOD(SetDisplayName) (THIS_ LPOLESTR );
STDMETHOD(GetPath) (THIS_ LPOLESTR ,int );
STDMETHOD(GetDSPath) (THIS_ DWORD ,LPOLESTR ,int );
STDMETHOD(GetFileSysPath) (THIS_ DWORD ,LPOLESTR ,int );
STDMETHOD(GetRegistryKey) (THIS_ DWORD ,HKEY *);
STDMETHOD(GetOptions) (THIS_ DWORD *);
STDMETHOD(SetOptions) (THIS_ DWORD ,DWORD );
STDMETHOD(GetType) (THIS_ GROUP_POLICY_OBJECT_TYPE *);
STDMETHOD(GetMachineName) (THIS_ LPOLESTR ,int );
STDMETHOD(GetPropertySheetPages) (THIS_ HPROPSHEETPAGE **,UINT *);
};
typedef IGroupPolicyObject *LPGROUPPOLICYOBJECT;
#define RSOP_INFO_FLAG_DIAGNOSTIC_MODE 1
#undef INTERFACE
#define INTERFACE IRSOPInformation
DECLARE_INTERFACE_(IRSOPInformation,IUnknown)
{
STDMETHOD(QueryInterface) (THIS_ REFIID ,LPVOID *);
STDMETHOD_(ULONG,AddRef) (THIS);
STDMETHOD_(ULONG,Release) (THIS);
STDMETHOD(GetNamespace) (THIS_ DWORD ,LPOLESTR ,int );
STDMETHOD(GetFlags) (THIS_ DWORD *);
STDMETHOD(GetEventLogEntryText) (THIS_ LPOLESTR ,LPOLESTR ,LPOLESTR ,DWORD ,LPOLESTR *);
};
typedef IRSOPInformation *LPRSOPINFORMATION;
GPEDITAPI HRESULT WINAPI CreateGPOLink(LPOLESTR ,LPOLESTR ,BOOL );
GPEDITAPI HRESULT WINAPI DeleteGPOLink(LPOLESTR ,LPOLESTR );
GPEDITAPI HRESULT WINAPI DeleteAllGPOLinks(LPOLESTR );
#define GPO_BROWSE_DISABLENEW 1
#define GPO_BROWSE_NOCOMPUTERS 2
#define GPO_BROWSE_NODSGPOS 4
#define GPO_BROWSE_OPENBUTTON 8
#define GPO_BROWSE_INITTOALL 16
typedef struct tag_GPOBROWSEINFO
{
DWORD dwSize; 
DWORD dwFlags; 
HWND hwndOwner; 
LPOLESTR lpTitle; 
LPOLESTR lpInitialOU; 
LPOLESTR lpDSPath; 
DWORD dwDSPathSize; 
LPOLESTR lpName; 
DWORD dwNameSize; 
GROUP_POLICY_OBJECT_TYPE gpoType; 
GROUP_POLICY_HINT_TYPE gpoHint; 
} GPOBROWSEINFO,*LPGPOBROWSEINFO;
GPEDITAPI HRESULT WINAPI BrowseForGPO(LPGPOBROWSEINFO );
GPEDITAPI HRESULT WINAPI ImportRSoPData(LPOLESTR ,LPOLESTR );
GPEDITAPI HRESULT WINAPI ExportRSoPData(LPOLESTR ,LPOLESTR );
#endif 
