#ifndef _LMDFS_
#define _LMDFS_
#define DFS_VOLUME_STATE_OK 1
#define DFS_VOLUME_STATE_INCONSISTENT 2
#define DFS_VOLUME_STATE_OFFLINE 3
#define DFS_VOLUME_STATE_ONLINE 4
#define DFS_STORAGE_STATE_OFFLINE 1
#define DFS_STORAGE_STATE_ONLINE 2
#define DFS_STORAGE_STATE_ACTIVE 4
typedef struct _DFS_INFO_1 {
 LPWSTR EntryPath; 
} DFS_INFO_1, *PDFS_INFO_1, *LPDFS_INFO_1;
typedef struct _DFS_INFO_2 {
 LPWSTR EntryPath; 
 LPWSTR Comment; 
 DWORD State; 
 DWORD NumberOfStorages; 
} DFS_INFO_2, *PDFS_INFO_2, *LPDFS_INFO_2;
typedef struct _DFS_STORAGE_INFO {
 ULONG State; 
 LPWSTR ServerName; 
 LPWSTR ShareName; 
} DFS_STORAGE_INFO, *PDFS_STORAGE_INFO, *LPDFS_STORAGE_INFO;
typedef struct _DFS_INFO_3 {
 LPWSTR EntryPath; 
 LPWSTR Comment; 
 DWORD State; 
 DWORD NumberOfStorages; 
 LPDFS_STORAGE_INFO Storage; 
} DFS_INFO_3, *PDFS_INFO_3, *LPDFS_INFO_3;
typedef struct _DFS_INFO_4 {
 LPWSTR EntryPath; 
 LPWSTR Comment; 
 DWORD State; 
 ULONG Timeout; 
 GUID Guid; 
 DWORD NumberOfStorages; 
 LPDFS_STORAGE_INFO Storage; 
} DFS_INFO_4, *PDFS_INFO_4, *LPDFS_INFO_4;
typedef struct _DFS_INFO_100 {
 LPWSTR Comment; 
} DFS_INFO_100, *PDFS_INFO_100, *LPDFS_INFO_100;
typedef struct _DFS_INFO_101 {
 DWORD State; 
} DFS_INFO_101, *PDFS_INFO_101, *LPDFS_INFO_101;
typedef struct _DFS_INFO_102 {
 ULONG Timeout; 
} DFS_INFO_102, *PDFS_INFO_102, *LPDFS_INFO_102;
typedef struct _DFS_INFO_200 {
 LPWSTR FtDfsName; 
} DFS_INFO_200, *PDFS_INFO_200, *LPDFS_INFO_200;
NET_API_STATUS NET_API_FUNCTION NetDfsAdd( LPWSTR DfsEntryPath, LPWSTR ServerName, LPWSTR ShareName, LPWSTR Comment , DWORD Flags );
#define DFS_ADD_VOLUME 1 
#define DFS_RESTORE_VOLUME 2 
NET_API_STATUS NET_API_FUNCTION NetDfsAddStdRoot( LPWSTR ServerName, LPWSTR RootShare, LPWSTR Comment , DWORD Flags );
NET_API_STATUS NET_API_FUNCTION NetDfsRemoveStdRoot( LPWSTR ServerName, LPWSTR RootShare, DWORD Flags );
NET_API_STATUS NET_API_FUNCTION NetDfsAddFtRoot( LPWSTR ServerName, LPWSTR RootShare, LPWSTR FtDfsName, LPWSTR Comment, DWORD Flags );
NET_API_STATUS NET_API_FUNCTION NetDfsRemoveFtRoot( LPWSTR ServerName, LPWSTR RootShare, LPWSTR FtDfsName, DWORD Flags );
NET_API_STATUS NET_API_FUNCTION NetDfsRemoveFtRootForced( LPWSTR DomainName, LPWSTR ServerName, LPWSTR RootShare, LPWSTR FtDfsName, DWORD Flags );
NET_API_STATUS NET_API_FUNCTION NetDfsManagerInitialize( LPWSTR ServerName, DWORD Flags );
NET_API_STATUS NET_API_FUNCTION NetDfsAddStdRootForced( LPWSTR ServerName, LPWSTR RootShare, LPWSTR Comment , LPWSTR Store );
NET_API_STATUS NET_API_FUNCTION NetDfsGetDcAddress( LPWSTR ServerName, LPWSTR *DcIpAddress, BOOLEAN *IsRoot, ULONG *Timeout );
NET_API_STATUS NET_API_FUNCTION NetDfsSetDcAddress( LPWSTR ServerName, LPWSTR DcIpAddress, ULONG Timeout, DWORD Flags );
#define NET_DFS_SETDC_FLAGS 0x00000000
#define NET_DFS_SETDC_TIMEOUT 0x00000001
#define NET_DFS_SETDC_INITPKT 0x00000002
typedef struct {
 ULONG SiteFlags; 
 LPWSTR SiteName;
} DFS_SITENAME_INFO, *PDFS_SITENAME_INFO, *LPDFS_SITENAME_INFO;
#define DFS_SITE_PRIMARY 0x1 
typedef struct {
 ULONG cSites;
 DFS_SITENAME_INFO Site[1];
} DFS_SITELIST_INFO, *PDFS_SITELIST_INFO, *LPDFS_SITELIST_INFO;
NET_API_STATUS NET_API_FUNCTION NetDfsRemove( LPWSTR DfsEntryPath, LPWSTR ServerName, LPWSTR ShareName );
NET_API_STATUS NET_API_FUNCTION NetDfsEnum( LPWSTR DfsName, DWORD Level, DWORD PrefMaxLen, LPBYTE* Buffer, LPDWORD EntriesRead, LPDWORD ResumeHandle );
NET_API_STATUS NET_API_FUNCTION NetDfsGetInfo( LPWSTR DfsEntryPath, LPWSTR ServerName, LPWSTR ShareName, DWORD Level, LPBYTE* Buffer );
NET_API_STATUS NET_API_FUNCTION NetDfsSetInfo( LPWSTR DfsEntryPath, LPWSTR ServerName, LPWSTR ShareName, DWORD Level, LPBYTE Buffer );
NET_API_STATUS NET_API_FUNCTION NetDfsGetClientInfo( LPWSTR DfsEntryPath, LPWSTR ServerName, LPWSTR ShareName, DWORD Level, LPBYTE* Buffer );
NET_API_STATUS NET_API_FUNCTION NetDfsSetClientInfo( LPWSTR DfsEntryPath, LPWSTR ServerName , LPWSTR ShareName, DWORD Level, LPBYTE Buffer );
NET_API_STATUS NET_API_FUNCTION NetDfsMove( LPWSTR DfsEntryPath, LPWSTR DfsNewEntryPath ); 
NET_API_STATUS NET_API_FUNCTION NetDfsRename( LPWSTR Path, LPWSTR NewPath );
#endif 
