#ifndef __lmshare_h__
#define __lmshare_h__
NET_API_STATUS NET_API_FUNCTION NetShareAdd (
    LPTSTR  servername,
    DWORD   level,
    LPBYTE  buf,
   LPDWORD parm_err
    );

NET_API_STATUS NET_API_FUNCTION
NetShareEnum (
    LPTSTR      servername,
    DWORD       level,
   LPBYTE      *bufptr,
    DWORD       prefmaxlen,
   LPDWORD     entriesread,
   LPDWORD     totalentries,
  LPDWORD  resume_handle
    );

NET_API_STATUS NET_API_FUNCTION
NetShareEnumSticky (
    LPTSTR      servername,
    DWORD       level,
   LPBYTE      *bufptr,
    DWORD       prefmaxlen,
   LPDWORD     entriesread,
   LPDWORD     totalentries,
  LPDWORD  resume_handle
    );

NET_API_STATUS NET_API_FUNCTION
NetShareGetInfo (
    LPTSTR  servername,
    LPTSTR  netname,
    DWORD   level,
   LPBYTE  *bufptr
    );

NET_API_STATUS NET_API_FUNCTION
NetShareSetInfo (
    LPTSTR  servername,
    LPTSTR  netname,
    DWORD   level,
    LPBYTE  buf,
   LPDWORD parm_err
    );

NET_API_STATUS NET_API_FUNCTION
NetShareDel     (
    LPTSTR  servername,
    LPTSTR  netname,
    DWORD   reserved
    );

NET_API_STATUS NET_API_FUNCTION
NetShareDelSticky (
    LPTSTR  servername,
    LPTSTR  netname,
    DWORD   reserved
    );

NET_API_STATUS NET_API_FUNCTION
NetShareCheck   (
    LPTSTR  servername,
    LPTSTR  device,
   LPDWORD type
    );

typedef struct _SHARE_INFO_0 {
    LPTSTR  shi0_netname;
} SHARE_INFO_0, *PSHARE_INFO_0, *LPSHARE_INFO_0;

typedef struct _SHARE_INFO_1 {
    LPTSTR  shi1_netname;
    DWORD   shi1_type;
    LPTSTR  shi1_remark;
} SHARE_INFO_1, *PSHARE_INFO_1, *LPSHARE_INFO_1;

typedef struct _SHARE_INFO_2 {
    LPTSTR  shi2_netname;
    DWORD   shi2_type;
    LPTSTR  shi2_remark;
    DWORD   shi2_permissions;
    DWORD   shi2_max_uses;
    DWORD   shi2_current_uses;
    LPTSTR  shi2_path;
    LPTSTR  shi2_passwd;
} SHARE_INFO_2, *PSHARE_INFO_2, *LPSHARE_INFO_2;

typedef struct _SHARE_INFO_501 {
    LPTSTR  shi501_netname;
    DWORD   shi501_type;
    LPTSTR  shi501_remark;
    DWORD   shi501_flags;
} SHARE_INFO_501, *PSHARE_INFO_501, *LPSHARE_INFO_501;

typedef struct _SHARE_INFO_502 {
    LPTSTR  shi502_netname;
    DWORD   shi502_type;
    LPTSTR  shi502_remark;
    DWORD   shi502_permissions;
    DWORD   shi502_max_uses;
    DWORD   shi502_current_uses;
    LPTSTR  shi502_path;
    LPTSTR  shi502_passwd;
    DWORD   shi502_reserved;
    PSECURITY_DESCRIPTOR  shi502_security_descriptor;
} SHARE_INFO_502, *PSHARE_INFO_502, *LPSHARE_INFO_502;

typedef struct _SHARE_INFO_1004 {
    LPTSTR  shi1004_remark;
} SHARE_INFO_1004, *PSHARE_INFO_1004, *LPSHARE_INFO_1004;

typedef struct _SHARE_INFO_1005 {
    DWORD  shi1005_flags;
} SHARE_INFO_1005, *PSHARE_INFO_1005, *LPSHARE_INFO_1005;

typedef struct _SHARE_INFO_1006 {
    DWORD   shi1006_max_uses;
} SHARE_INFO_1006, *PSHARE_INFO_1006, *LPSHARE_INFO_1006;

typedef struct _SHARE_INFO_1007 {
    DWORD  shi1007_flags;
    LPTSTR shi1007_AlternateDirectoryName;
} SHARE_INFO_1007, *PSHARE_INFO_1007, *LPSHARE_INFO_1007;

typedef struct _SHARE_INFO_1501 {
    DWORD   shi1501_reserved;
    PSECURITY_DESCRIPTOR  shi1501_security_descriptor;
} SHARE_INFO_1501, *PSHARE_INFO_1501, *LPSHARE_INFO_1501;

#define SHARE_NETNAME_PARMNUM         1
#define SHARE_TYPE_PARMNUM            3
#define SHARE_REMARK_PARMNUM          4
#define SHARE_PERMISSIONS_PARMNUM     5
#define SHARE_MAX_USES_PARMNUM        6
#define SHARE_CURRENT_USES_PARMNUM    7
#define SHARE_PATH_PARMNUM            8
#define SHARE_PASSWD_PARMNUM          9
#define SHARE_FILE_SD_PARMNUM       501
#define SHARE_REMARK_INFOLEVEL          \
            (PARMNUM_BASE_INFOLEVEL + SHARE_REMARK_PARMNUM)
#define SHARE_MAX_USES_INFOLEVEL        \
            (PARMNUM_BASE_INFOLEVEL + SHARE_MAX_USES_PARMNUM)
#define SHARE_FILE_SD_INFOLEVEL         \
            (PARMNUM_BASE_INFOLEVEL + SHARE_FILE_SD_PARMNUM)

#define SHI1_NUM_ELEMENTS       4
#define SHI2_NUM_ELEMENTS       10
#define STYPE_DISKTREE          0
#define STYPE_PRINTQ            1
#define STYPE_DEVICE            2
#define STYPE_IPC               3
#define STYPE_SPECIAL           0x80000000
#define SHI_USES_UNLIMITED      (DWORD)-1
#define SHI1005_FLAGS_DFS       0x01    
#define SHI1005_FLAGS_DFS_ROOT  0x02    
#define COW_PERMACHINE          0x04    
#define COW_PERUSER             0x08    
#define CSC_CACHEABLE           0x10    
#define CSC_NOFLOWOPS           0x20    
#define CSC_AUTO_INWARD         0x40    
#define CSC_AUTO_OUTWARD        0x80    
#define SHI1005_VALID_FLAGS_SET (CSC_CACHEABLE|CSC_NOFLOWOPS|CSC_AUTO_INWARD|CSC_AUTO_OUTWARD|COW_PERMACHINE|COW_PERUSER) 
#define SHI1007_VALID_FLAGS_SET SHI1005_VALID_FLAGS_SET
#endif
#ifndef _LMSESSION_
#define _LMSESSION_
NET_API_STATUS NET_API_FUNCTION
NetSessionEnum (
    LPTSTR      servername ,
    LPTSTR      UncClientName ,
    LPTSTR      username ,
    DWORD       level,
   LPBYTE      *bufptr,
    DWORD       prefmaxlen,
   LPDWORD     entriesread,
   LPDWORD     totalentries,
  LPDWORD  resume_handle 
    );

NET_API_STATUS NET_API_FUNCTION
NetSessionDel (
    LPTSTR      servername,
    LPTSTR      UncClientName,
    LPTSTR      username
    );

NET_API_STATUS NET_API_FUNCTION
NetSessionGetInfo (
    LPTSTR      servername,
    LPTSTR      UncClientName,
    LPTSTR      username,
    DWORD       level,
   LPBYTE      *bufptr
    );
typedef struct _SESSION_INFO_0 {
    LPTSTR    sesi0_cname;              
} SESSION_INFO_0, *PSESSION_INFO_0, *LPSESSION_INFO_0;

typedef struct _SESSION_INFO_1 {
    LPTSTR    sesi1_cname;              
    LPTSTR    sesi1_username;
    DWORD     sesi1_num_opens;
    DWORD     sesi1_time;
    DWORD     sesi1_idle_time;
    DWORD     sesi1_user_flags;
} SESSION_INFO_1, *PSESSION_INFO_1, *LPSESSION_INFO_1;

typedef struct _SESSION_INFO_2 {
    LPTSTR    sesi2_cname;              
    LPTSTR    sesi2_username;
    DWORD     sesi2_num_opens;
    DWORD     sesi2_time;
    DWORD     sesi2_idle_time;
    DWORD     sesi2_user_flags;
    LPTSTR    sesi2_cltype_name;
} SESSION_INFO_2, *PSESSION_INFO_2, *LPSESSION_INFO_2;

typedef struct _SESSION_INFO_10 {
    LPTSTR    sesi10_cname;             
    LPTSTR    sesi10_username;
    DWORD     sesi10_time;
    DWORD     sesi10_idle_time;
} SESSION_INFO_10, *PSESSION_INFO_10, *LPSESSION_INFO_10;

typedef struct _SESSION_INFO_502 {
    LPTSTR    sesi502_cname;             
    LPTSTR    sesi502_username;
    DWORD     sesi502_num_opens;
    DWORD     sesi502_time;
    DWORD     sesi502_idle_time;
    DWORD     sesi502_user_flags;
    LPTSTR    sesi502_cltype_name;
    LPTSTR    sesi502_transport;
} SESSION_INFO_502, *PSESSION_INFO_502, *LPSESSION_INFO_502;

#define SESS_GUEST          0x00000001  
#define SESS_NOENCRYPTION   0x00000002  
#define SESI1_NUM_ELEMENTS  8
#define SESI2_NUM_ELEMENTS  9
#endif 
#ifndef _LMCONNECTION_
#define _LMCONNECTION_
NET_API_STATUS NET_API_FUNCTION
NetConnectionEnum (
    LPTSTR  servername,
    LPTSTR  qualifier,
    DWORD   level,
   LPBYTE  *bufptr,
    DWORD   prefmaxlen,
   LPDWORD entriesread,
   LPDWORD totalentries,
  LPDWORD resume_handle
    );
typedef struct _CONNECTION_INFO_0 {
    DWORD   coni0_id;
} CONNECTION_INFO_0, *PCONNECTION_INFO_0, *LPCONNECTION_INFO_0;

typedef struct _CONNECTION_INFO_1 {
    DWORD   coni1_id;
    DWORD   coni1_type;
    DWORD   coni1_num_opens;
    DWORD   coni1_num_users;
    DWORD   coni1_time;
    LPTSTR  coni1_username;
    LPTSTR  coni1_netname;
} CONNECTION_INFO_1, *PCONNECTION_INFO_1, *LPCONNECTION_INFO_1;

#endif 
#ifndef _LMFILE_
#define _LMFILE_
NET_API_STATUS NET_API_FUNCTION
NetFileClose (
   LPTSTR   servername,
   DWORD    fileid
    );

NET_API_STATUS NET_API_FUNCTION
NetFileEnum (
    LPTSTR      servername,
    LPTSTR      basepath,
    LPTSTR      username,
    DWORD       level,
   LPBYTE      *bufptr,
    DWORD       prefmaxlen,
   LPDWORD     entriesread,
   LPDWORD     totalentries,
  LPDWORD  resume_handle 
    );

NET_API_STATUS NET_API_FUNCTION
NetFileGetInfo (
    LPTSTR  servername,
    DWORD   fileid,
    DWORD   level,
   LPBYTE  *bufptr
    );
typedef struct _FILE_INFO_2 {
    DWORD     fi2_id;
} FILE_INFO_2, *PFILE_INFO_2, *LPFILE_INFO_2;

typedef struct _FILE_INFO_3 {
    DWORD     fi3_id;
    DWORD     fi3_permissions;
    DWORD     fi3_num_locks;
    LPTSTR    fi3_pathname;
    LPTSTR    fi3_username;
} FILE_INFO_3, *PFILE_INFO_3, *LPFILE_INFO_3;
#define PERM_FILE_READ      0x1 
#define PERM_FILE_WRITE     0x2 
#define PERM_FILE_CREATE    0x4 
#endif 
