#ifndef	__mprapi_h__
#define	__mprapi_h__
#include	<windows.h>
#include	<lmcons.h>
#define	RRAS_SERVICE_NAME TEXT("RemoteAccess")
#define	PID_IPX 0x0000002B
#define	PID_IP 0x00000021
#define	PID_NBF 0x0000003F
#define	MAX_INTERFACE_NAME_LEN 256
#define	MAX_TRANSPORT_NAME_LEN 40
#define	MAX_MEDIA_NAME 16
#define	MAX_PORT_NAME 16
#define	MAX_DEVICE_NAME 128
#define	MAX_PHONE_NUMBER_LEN 128
#define	MAX_DEVICETYPE_NAME 16
typedef	enum _ROUTER_INTERFACE_TYPE {
	ROUTER_IF_TYPE_CLIENT,
	ROUTER_IF_TYPE_HOME_ROUTER,
	ROUTER_IF_TYPE_FULL_ROUTER,
	ROUTER_IF_TYPE_DEDICATED,
	ROUTER_IF_TYPE_INTERNAL,
	ROUTER_IF_TYPE_LOOPBACK,
	ROUTER_IF_TYPE_TUNNEL1
}	ROUTER_INTERFACE_TYPE;
typedef	enum _ROUTER_CONNECTION_STATE {
	ROUTER_IF_STATE_UNREACHABLE,
	ROUTER_IF_STATE_DISCONNECTED,
	ROUTER_IF_STATE_CONNECTING,
	ROUTER_IF_STATE_CONNECTED
}	ROUTER_CONNECTION_STATE;
#define	MPR_INTERFACE_OUT_OF_RESOURCES 0x00000001
#define	MPR_INTERFACE_ADMIN_DISABLED 0x00000002
#define	MPR_INTERFACE_CONNECTION_FAILURE 0x00000004
#define	MPR_INTERFACE_SERVICE_PAUSED 0x00000008
#define	MPR_INTERFACE_DIALOUT_HOURS_RESTRICTION 0x00000010
typedef	struct _MPR_INTERFACE_0 {
	unsigned short wszInterfaceName[MAX_INTERFACE_NAME_LEN+1];
	HANDLE hInterface;
	BOOL fEnabled;
	ROUTER_INTERFACE_TYPE dwIfType;
	ROUTER_CONNECTION_STATE dwConnectionState;
	DWORD fUnReachabilityReasons;
	DWORD dwLastError;
}	MPR_INTERFACE_0, *PMPR_INTERFACE_0;
typedef	struct _MPR_INTERFACE_1
{
	WCHAR wszInterfaceName[MAX_INTERFACE_NAME_LEN+1];
	HANDLE hInterface;
	BOOL fEnabled;
	ROUTER_INTERFACE_TYPE dwIfType;
	ROUTER_CONNECTION_STATE dwConnectionState;
	DWORD fUnReachabilityReasons;
	DWORD dwLastError;
	LPWSTR lpwsDialoutHoursRestriction;
}	MPR_INTERFACE_1, *PMPR_INTERFACE_1;
typedef	struct _MPR_TRANSPORT_0 {
	DWORD dwTransportId;
	HANDLE hTransport;
	WCHAR wszTransportName[MAX_TRANSPORT_NAME_LEN+1];
}	MPR_TRANSPORT_0, *PMPR_TRANSPORT_0;
typedef	struct _MPR_IFTRANSPORT_0 {
	DWORD dwTransportId;
	HANDLE hIfTransport;
	WCHAR wszIfTransportName[MAX_TRANSPORT_NAME_LEN+1];
}	MPR_IFTRANSPORT_0, *PMPR_IFTRANSPORT_0;
typedef	struct _MPR_SERVER_0 {
	BOOL fLanOnlyMode;
	DWORD dwUpTime; 
	DWORD dwTotalPorts;
	DWORD dwPortsInUse;
}	MPR_SERVER_0, *PMPR_SERVER_0;
typedef	enum _RAS_PORT_CONDITION {
	RAS_PORT_NON_OPERATIONAL,
	RAS_PORT_DISCONNECTED,	
	RAS_PORT_CALLING_BACK,
	RAS_PORT_LISTENING,
	RAS_PORT_AUTHENTICATING,
	RAS_PORT_AUTHENTICATED,	
	RAS_PORT_INITIALIZING
}	RAS_PORT_CONDITION;
typedef	enum _RAS_HARDWARE_CONDITION { RAS_HARDWARE_OPERATIONAL, RAS_HARDWARE_FAILURE } RAS_HARDWARE_CONDITION;
typedef	struct _RAS_PORT_0 {
	HANDLE hPort;
	HANDLE hConnection;
	RAS_PORT_CONDITION dwPortCondition;
	DWORD dwTotalNumberOfCalls;
	DWORD dwConnectDuration; 
	WCHAR wszPortName[ MAX_PORT_NAME + 1 ];
	WCHAR wszMediaName[ MAX_MEDIA_NAME + 1 ];
	WCHAR wszDeviceName[ MAX_DEVICE_NAME + 1 ];
	WCHAR wszDeviceType[ MAX_DEVICETYPE_NAME + 1 ];
}	RAS_PORT_0, *PRAS_PORT_0;
typedef	struct _RAS_PORT_1 {
	HANDLE hPort;
	HANDLE hConnection;
	RAS_HARDWARE_CONDITION dwHardwareCondition;
	DWORD dwLineSpeed; 
	DWORD dwBytesXmited;
	DWORD dwBytesRcved;
	DWORD dwFramesXmited;
	DWORD dwFramesRcved;
	DWORD dwCrcErr;
	DWORD dwTimeoutErr;
	DWORD dwAlignmentErr;
	DWORD dwHardwareOverrunErr;
	DWORD dwFramingErr;
	DWORD dwBufferOverrunErr;
	DWORD dwCompressionRatioIn;
	DWORD dwCompressionRatioOut;
}	RAS_PORT_1, *PRAS_PORT_1;
#define	IPADDRESSLEN 15
#define	IPXADDRESSLEN 22
#define	ATADDRESSLEN 32
typedef	struct _PPP_NBFCP_INFO {
	DWORD dwError;
	WCHAR wszWksta[ NETBIOS_NAME_LEN + 1 ];
}
PPP_NBFCP_INFO;
typedef	struct _PPP_IPCP_INFO {
	DWORD dwError;
	WCHAR wszAddress[ IPADDRESSLEN + 1 ];
	WCHAR wszRemoteAddress[ IPADDRESSLEN + 1 ];
}	PPP_IPCP_INFO;
typedef	struct _PPP_IPXCP_INFO {
	DWORD dwError;
	WCHAR wszAddress[ IPXADDRESSLEN + 1 ];
}
PPP_IPXCP_INFO;

typedef	struct _PPP_ATCP_INFO {
	DWORD dwError;
	WCHAR wszAddress[ ATADDRESSLEN + 1 ];
}
PPP_ATCP_INFO;
typedef	struct _PPP_INFO {
	PPP_NBFCP_INFO nbf;
	PPP_IPCP_INFO ip;
	PPP_IPXCP_INFO ipx;
	PPP_ATCP_INFO at;
}	PPP_INFO;
#define	RAS_FLAGS_PPP_CONNECTION 0x00000001
#define	RAS_FLAGS_MESSENGER_PRESENT 0x00000002
#define	RAS_FLAGS_RAS_CONNECTION 0x00000004
#define	RAS_FLAGS_ARAP_CONNECTION 0x00000008
typedef	struct _RAS_CONNECTION_0 {
	HANDLE hConnection;
	HANDLE hInterface;
	DWORD dwConnectDuration; 
	ROUTER_INTERFACE_TYPE dwInterfaceType;
	DWORD dwConnectionFlags;
	WCHAR wszInterfaceName[ MAX_INTERFACE_NAME_LEN + 1 ];
	WCHAR wszUserName[ UNLEN + 1 ];
	WCHAR wszLogonDomain[ DNLEN + 1 ];
	WCHAR wszRemoteComputer[ NETBIOS_NAME_LEN + 1 ];
}	RAS_CONNECTION_0, *PRAS_CONNECTION_0;
typedef	struct _RAS_CONNECTION_1 {
	HANDLE hConnection;
	HANDLE hInterface;
	PPP_INFO PppInfo;
	DWORD dwBytesXmited;
	DWORD dwBytesRcved;
	DWORD dwFramesXmited;
	DWORD dwFramesRcved;
	DWORD dwCrcErr;
	DWORD dwTimeoutErr;
	DWORD dwAlignmentErr;
	DWORD dwHardwareOverrunErr;
	DWORD dwFramingErr;
	DWORD dwBufferOverrunErr;
	DWORD dwCompressionRatioIn;
	DWORD dwCompressionRatioOut;
}	RAS_CONNECTION_1, *PRAS_CONNECTION_1;
typedef	struct _RAS_CONNECTION_2 {
	HANDLE hConnection;
	WCHAR wszUserName[ UNLEN + 1 ];
	ROUTER_INTERFACE_TYPE dwInterfaceType;
	GUID guid;
}	RAS_CONNECTION_2, *PRAS_CONNECTION_2;
#define	RASPRIV_NoCallback 0x01
#define	RASPRIV_AdminSetCallback 0x02
#define	RASPRIV_CallerSetCallback 0x04
#define	RASPRIV_DialinPrivilege 0x08
#define	RASPRIV_CallbackType (RASPRIV_AdminSetCallback|RASPRIV_CallerSetCallback | RASPRIV_NoCallback)
typedef	struct _RAS_USER_0 {
	BYTE bfPrivilege;
	WCHAR wszPhoneNumber[ MAX_PHONE_NUMBER_LEN + 1];
}	RAS_USER_0, *PRAS_USER_0;
typedef	HANDLE RAS_SERVER_HANDLE;
typedef	HANDLE MPR_SERVER_HANDLE;
typedef	HANDLE MIB_SERVER_HANDLE;
DWORD	APIENTRY MprAdminConnectionEnum(RAS_SERVER_HANDLE,DWORD,LPBYTE *,DWORD,LPDWORD,LPDWORD,LPDWORD);
DWORD	APIENTRY MprAdminPortEnum(RAS_SERVER_HANDLE,DWORD,HANDLE,LPBYTE *,DWORD,LPDWORD,LPDWORD,LPDWORD);
DWORD	APIENTRY MprAdminConnectionGetInfo(RAS_SERVER_HANDLE,DWORD,HANDLE,LPBYTE *);
DWORD	APIENTRY MprAdminPortGetInfo(RAS_SERVER_HANDLE,DWORD,HANDLE,LPBYTE *);
DWORD	APIENTRY MprAdminConnectionClearStats(RAS_SERVER_HANDLE,HANDLE);
DWORD	APIENTRY MprAdminPortClearStats(RAS_SERVER_HANDLE,HANDLE);
DWORD	APIENTRY MprAdminPortReset(RAS_SERVER_HANDLE,HANDLE);
DWORD	APIENTRY MprAdminPortDisconnect(RAS_SERVER_HANDLE,HANDLE);
BOOL	APIENTRY MprAdminAcceptNewConnection (RAS_CONNECTION_0 *,RAS_CONNECTION_1 *);
BOOL	APIENTRY MprAdminAcceptNewLink(RAS_PORT_0 *,RAS_PORT_1 *);
VOID	APIENTRY MprAdminConnectionHangupNotification (RAS_CONNECTION_0 *,RAS_CONNECTION_1 *);
VOID	APIENTRY MprAdminLinkHangupNotification (RAS_PORT_0 *,RAS_PORT_1 *);
DWORD	APIENTRY MprAdminGetIpAddressForUser (WCHAR *,WCHAR *,DWORD *,BOOL *);
VOID	APIENTRY MprAdminReleaseIpAddress (WCHAR *,WCHAR *,DWORD *);
DWORD	APIENTRY MprAdminInitializeDll( VOID );
DWORD	APIENTRY MprAdminTerminateDll( VOID );
DWORD	APIENTRY MprAdminUserGetInfo(const WCHAR *,const WCHAR *,DWORD,LPBYTE);
DWORD	APIENTRY MprAdminUserSetInfo(const WCHAR *,const WCHAR *,DWORD,const LPBYTE);
DWORD	APIENTRY MprAdminSendUserMessage(MPR_SERVER_HANDLE,HANDLE,LPWSTR);
DWORD	APIENTRY MprAdminGetPDCServer(const WCHAR *,const WCHAR *,LPWSTR);
BOOL	APIENTRY MprAdminIsServiceRunning(LPWSTR lpwsServerName );
DWORD	APIENTRY MprAdminServerConnect(LPWSTR,MPR_SERVER_HANDLE *);
VOID	APIENTRY MprAdminServerDisconnect(MPR_SERVER_HANDLE);
DWORD	APIENTRY MprAdminBufferFree(LPVOID);
DWORD	APIENTRY MprAdminGetErrorString(DWORD,LPWSTR *);
DWORD	APIENTRY MprAdminServerGetInfo(MPR_SERVER_HANDLE,DWORD,LPBYTE *);
DWORD	APIENTRY MprAdminTransportSetInfo(MPR_SERVER_HANDLE,DWORD,LPBYTE,DWORD,LPBYTE,DWORD);
DWORD	APIENTRY MprAdminTransportGetInfo(MPR_SERVER_HANDLE,DWORD,LPBYTE *,LPDWORD,LPBYTE *,LPDWORD);
DWORD	APIENTRY MprAdminInterfaceGetHandle(MPR_SERVER_HANDLE,LPWSTR,HANDLE *,BOOL);
DWORD	APIENTRY MprAdminInterfaceCreate(MPR_SERVER_HANDLE,DWORD,LPBYTE,HANDLE *);
DWORD	APIENTRY MprAdminInterfaceGetInfo(MPR_SERVER_HANDLE,HANDLE,DWORD,LPBYTE *);
DWORD	APIENTRY MprAdminInterfaceSetInfo(MPR_SERVER_HANDLE,HANDLE,DWORD,LPBYTE);
DWORD	APIENTRY MprAdminInterfaceDelete(MPR_SERVER_HANDLE,HANDLE);
DWORD	APIENTRY MprAdminInterfaceTransportRemove(MPR_SERVER_HANDLE,HANDLE,DWORD);
DWORD	APIENTRY MprAdminInterfaceTransportAdd(MPR_SERVER_HANDLE,HANDLE,DWORD,LPBYTE,DWORD);
DWORD	APIENTRY MprAdminInterfaceTransportGetInfo(MPR_SERVER_HANDLE,HANDLE,DWORD,LPBYTE *,LPDWORD);
DWORD	APIENTRY MprAdminInterfaceTransportSetInfo(MPR_SERVER_HANDLE,HANDLE,DWORD,LPBYTE,DWORD);
DWORD	APIENTRY MprAdminInterfaceEnum(MPR_SERVER_HANDLE,DWORD,LPBYTE *,DWORD,LPDWORD,LPDWORD,LPDWORD);
DWORD	APIENTRY MprAdminInterfaceSetCredentials(LPWSTR,LPWSTR,LPWSTR,LPWSTR,LPWSTR);
DWORD	APIENTRY MprAdminInterfaceGetCredentials(LPWSTR,LPWSTR,LPWSTR,LPWSTR,LPWSTR);
DWORD	APIENTRY MprAdminInterfaceConnect(MPR_SERVER_HANDLE,HANDLE,HANDLE,BOOL);
DWORD	APIENTRY MprAdminInterfaceDisconnect(MPR_SERVER_HANDLE,HANDLE);
DWORD	APIENTRY MprAdminInterfaceUpdateRoutes(MPR_SERVER_HANDLE,HANDLE,DWORD,HANDLE);
DWORD	APIENTRY MprAdminInterfaceQueryUpdateResult(MPR_SERVER_HANDLE,HANDLE,DWORD,LPDWORD);
DWORD	APIENTRY MprAdminInterfaceUpdatePhonebookInfo(MPR_SERVER_HANDLE,HANDLE);
DWORD	APIENTRY MprAdminRegisterConnectionNotification(MPR_SERVER_HANDLE,HANDLE);
DWORD	APIENTRY MprAdminDeregisterConnectionNotification(MPR_SERVER_HANDLE,HANDLE);
DWORD	APIENTRY MprAdminMIBServerConnect(LPWSTR,MIB_SERVER_HANDLE *);
VOID	APIENTRY MprAdminMIBServerDisconnect(MIB_SERVER_HANDLE);
DWORD	APIENTRY MprAdminMIBEntryCreate(MIB_SERVER_HANDLE,DWORD,DWORD,LPVOID,DWORD);
DWORD	APIENTRY MprAdminMIBEntryDelete(MIB_SERVER_HANDLE,DWORD,DWORD,LPVOID,DWORD);
DWORD	APIENTRY MprAdminMIBEntrySet(MIB_SERVER_HANDLE,DWORD,DWORD,LPVOID,DWORD);
DWORD	APIENTRY MprAdminMIBEntryGet(MIB_SERVER_HANDLE,DWORD,DWORD,LPVOID,DWORD,LPVOID*,LPDWORD);
DWORD	APIENTRY MprAdminMIBEntryGetFirst(MIB_SERVER_HANDLE,DWORD,DWORD,LPVOID,DWORD,LPVOID*,LPDWORD);
DWORD	APIENTRY MprAdminMIBEntryGetNext(MIB_SERVER_HANDLE,DWORD,DWORD,LPVOID,DWORD,LPVOID*,LPDWORD);
DWORD	APIENTRY MprAdminMIBGetTrapInfo(MIB_SERVER_HANDLE,DWORD,DWORD,LPVOID,DWORD,LPVOID*,LPDWORD);
DWORD	APIENTRY MprAdminMIBSetTrapInfo(DWORD,DWORD,HANDLE,LPVOID,DWORD,LPVOID*,LPDWORD);
DWORD	APIENTRY MprAdminMIBBufferFree(LPVOID);
DWORD	APIENTRY MprConfigServerConnect(LPWSTR,HANDLE*);
VOID	APIENTRY MprConfigServerDisconnect(HANDLE);
DWORD	APIENTRY MprConfigBufferFree(LPVOID);
DWORD	APIENTRY MprConfigServerGetInfo(HANDLE,DWORD,LPBYTE *);
DWORD	APIENTRY MprConfigServerBackup(HANDLE,LPWSTR);
DWORD	APIENTRY MprConfigServerRestore(HANDLE,LPWSTR);
DWORD	APIENTRY MprConfigTransportCreate(HANDLE,DWORD,LPWSTR,LPBYTE,DWORD,LPBYTE,DWORD,LPWSTR,HANDLE*);
DWORD	APIENTRY MprConfigTransportDelete(HANDLE,HANDLE);
DWORD	APIENTRY MprConfigTransportGetHandle(HANDLE,DWORD,HANDLE*);
DWORD	APIENTRY MprConfigTransportSetInfo(HANDLE,HANDLE,LPBYTE,DWORD,LPBYTE,DWORD,LPWSTR);
DWORD	APIENTRY MprConfigTransportGetInfo(HANDLE,HANDLE,LPBYTE*,LPDWORD,LPBYTE*,LPDWORD,LPWSTR*);
DWORD	APIENTRY MprConfigTransportEnum(HANDLE,DWORD,LPBYTE*,DWORD,LPDWORD,LPDWORD,LPDWORD);
DWORD	APIENTRY MprConfigInterfaceCreate(HANDLE,DWORD,LPBYTE,HANDLE*);
DWORD	APIENTRY MprConfigInterfaceDelete(HANDLE,HANDLE);
DWORD	APIENTRY MprConfigInterfaceGetHandle(HANDLE,LPWSTR,HANDLE*);
DWORD	APIENTRY MprConfigInterfaceGetInfo(HANDLE,HANDLE,DWORD,LPBYTE*,LPDWORD);
DWORD	APIENTRY MprConfigInterfaceSetInfo(HANDLE,HANDLE,DWORD,LPBYTE);
DWORD	APIENTRY MprConfigInterfaceEnum(HANDLE,DWORD,LPBYTE*,DWORD,LPDWORD,LPDWORD,LPDWORD);
DWORD	APIENTRY MprConfigInterfaceTransportAdd(HANDLE,HANDLE,DWORD,LPWSTR,LPBYTE,DWORD,HANDLE*);
DWORD	APIENTRY MprConfigInterfaceTransportRemove(HANDLE,HANDLE,HANDLE);
DWORD	APIENTRY MprConfigInterfaceTransportGetHandle(HANDLE,HANDLE,DWORD,HANDLE*);
DWORD	APIENTRY MprConfigInterfaceTransportGetInfo(HANDLE,HANDLE,HANDLE,LPBYTE*,LPDWORD);
DWORD	APIENTRY MprConfigInterfaceTransportSetInfo(HANDLE,HANDLE,HANDLE,LPBYTE,DWORD);
DWORD	APIENTRY MprConfigInterfaceTransportEnum(HANDLE,HANDLE,DWORD,LPBYTE*,DWORD,LPDWORD,LPDWORD,LPDWORD);
DWORD	APIENTRY MprConfigGetFriendlyName(HANDLE,PWCHAR,PWCHAR,DWORD);
DWORD	APIENTRY MprConfigGetGuidName(HANDLE,PWCHAR,PWCHAR,DWORD);
DWORD	APIENTRY MprInfoCreate(DWORD,LPVOID*);
DWORD	APIENTRY MprInfoDelete(LPVOID);
DWORD	APIENTRY MprInfoRemoveAll(LPVOID,LPVOID*);
DWORD	APIENTRY MprInfoDuplicate(LPVOID,LPVOID*);
DWORD	APIENTRY MprInfoBlockAdd(LPVOID,DWORD,DWORD,DWORD,LPBYTE,LPVOID*);
DWORD	APIENTRY MprInfoBlockRemove(LPVOID,DWORD,LPVOID*);
DWORD	APIENTRY MprInfoBlockSet(LPVOID,DWORD,DWORD,DWORD,LPBYTE,LPVOID*);
DWORD	APIENTRY MprInfoBlockFind(LPVOID,DWORD,LPDWORD,LPDWORD,LPBYTE*);
#define	MprInfoBlockExists(h,t) (MprInfoBlockFind((h),(t),NULL,NULL,NULL) == NO_ERROR)
#endif	

