#ifndef __mq_h__
#define __mq_h__
#ifndef __transact_h__
typedef void ITransaction;
#endif
#if defined(_MSC_VER) && (_MSC_VER < 1020)
typedef struct tagMQPROPVARIANT MQPROPVARIANT;
#define TYPEDEF_CA(type, name) typedef struct tag##name { ULONG cElems; type * pElems; } name 
#ifndef _tagCAUB_DEFINED
#define _tagCAUB_DEFINED
TYPEDEF_CA(unsigned char, CAUB);
#endif
#ifndef _tagCAI_DEFINED
#define _tagCAI_DEFINED
TYPEDEF_CA(short, CAI);
#endif
#ifndef _tagCAUI_DEFINED
#define _tagCAUI_DEFINED
TYPEDEF_CA(USHORT, CAUI);
#endif
#ifndef _tagCAL_DEFINED
#define _tagCAL_DEFINED
TYPEDEF_CA(long, CAL);
#endif
#ifndef _tagCAUL_DEFINED
#define _tagCAUL_DEFINED
TYPEDEF_CA(ULONG, CAUL);
#endif
#ifndef _tagCACLSID_DEFINED
#define _tagCACLSID_DEFINED
TYPEDEF_CA(CLSID, CACLSID);
#endif
#ifndef _tagCABSTR_DEFINED
#define _tagCABSTR_DEFINED
TYPEDEF_CA(LPOLESTR, CABSTR);
#endif
#ifndef _tagCALPWSTR_DEFINED
#define _tagCALPWSTR_DEFINED
TYPEDEF_CA(LPWSTR, CALPWSTR);
#endif
#ifndef _tagCAMQPROPVARIANT_DEFINED
#define _tagCAMQPROPVARIANT_DEFINED
TYPEDEF_CA(MQPROPVARIANT, CAMQPROPVARIANT);
#endif
struct tagMQPROPVARIANT {
VARTYPE vt;
WORD wReserved1;
WORD wReserved2;
WORD wReserved3;
union {
UCHAR bVal;
short iVal;
USHORT uiVal;
VARIANT_BOOL boolVal;
long lVal;
ULONG ulVal;
SCODE scode;
DATE date;
CLSID *puuid;
BLOB blob;
LPOLESTR bstrVal;
LPSTR pszVal;
LPWSTR pwszVal;
CAUB caub;
CAI cai;
CAUI caui;
CAL cal;
CAUL caul;
CACLSID cauuid;
CABSTR cabstr;
CALPWSTR calpwstr;
CAMQPROPVARIANT capropvar;
};
};
#else 
#ifdef __midl
typedef struct tag_inner_PROPVARIANT tagMQPROPVARIANT;
#else
typedef struct tagPROPVARIANT tagMQPROPVARIANT;
#endif
typedef tagMQPROPVARIANT MQPROPVARIANT;
#endif 
#define	PRLT	(0)
#define	PRLE	(1)
#define	PRGT	(2)
#define	PRGE	(3)
#define	PREQ	(4)
#define	PRNE	(5)
typedef struct tagMQPROPERTYRESTRICTION
{
ULONG rel;
PROPID prop;
MQPROPVARIANT prval;
}	MQPROPERTYRESTRICTION;
typedef struct tagMQRESTRICTION
{
ULONG cRes;
MQPROPERTYRESTRICTION *paPropRes;
}	MQRESTRICTION;
typedef struct tagMQCOLUMNSET {
ULONG cCol;
PROPID *aCol;
}	MQCOLUMNSET;
#define	QUERY_SORTASCEND	0
#define	QUERY_SORTDESCEND	1
typedef struct tagMQSORTKEY {
PROPID propColumn;
ULONG dwOrder;
}	MQSORTKEY;
typedef struct tagMQSORTSET {
ULONG cCol;
MQSORTKEY *aCol;
}	MQSORTSET;
#define MQ_MAX_Q_NAME_LEN 124 
#define MQ_MAX_Q_LABEL_LEN 124
#define MQ_MAX_MSG_LABEL_LEN 250
typedef HANDLE QUEUEHANDLE;
typedef PROPID MSGPROPID;
typedef PROPID QUEUEPROPID;
typedef PROPID QMPROPID;
typedef struct tagMQMSGPROPS
{
DWORD cProp;
MSGPROPID* aPropID;
MQPROPVARIANT* aPropVar;
HRESULT* aStatus;
} MQMSGPROPS;
typedef struct tagMQQUEUEPROPS
{
DWORD cProp;
QUEUEPROPID* aPropID;
MQPROPVARIANT* aPropVar;
HRESULT* aStatus;
} MQQUEUEPROPS;
typedef struct tagMQQMPROPS
{
DWORD cProp;
QMPROPID* aPropID;
MQPROPVARIANT* aPropVar;
HRESULT* aStatus;
} MQQMPROPS;
#define MQ_RECEIVE_ACCESS 1
#define MQ_SEND_ACCESS 2
#define MQ_PEEK_ACCESS 32
#define MQ_DENY_NONE 0
#define MQ_DENY_RECEIVE_SHARE 1
#define MQ_ACTION_RECEIVE 0
#define MQ_ACTION_PEEK_CURRENT 0x80000000
#define MQ_ACTION_PEEK_NEXT 0x80000001
#define MQ_NO_TRANSACTION NULL
#define MQ_MTS_TRANSACTION (ITransaction *)1
#define MQ_XA_TRANSACTION (ITransaction *)2
#define MQ_SINGLE_MESSAGE (ITransaction *)3
#define MQ_MIN_PRIORITY 0 
#define MQ_MAX_PRIORITY 7 
#define PROPID_M_BASE 0
#define PROPID_M_CLASS (PROPID_M_BASE + 1) 
#define PROPID_M_MSGID (PROPID_M_BASE + 2) 
#define PROPID_M_CORRELATIONID (PROPID_M_BASE + 3) 
#define PROPID_M_PRIORITY (PROPID_M_BASE + 4) 
#define PROPID_M_DELIVERY (PROPID_M_BASE + 5) 
#define PROPID_M_ACKNOWLEDGE (PROPID_M_BASE + 6) 
#define PROPID_M_JOURNAL (PROPID_M_BASE + 7) 
#define PROPID_M_APPSPECIFIC (PROPID_M_BASE + 8) 
#define PROPID_M_BODY (PROPID_M_BASE + 9) 
#define PROPID_M_BODY_SIZE (PROPID_M_BASE + 10) 
#define PROPID_M_LABEL (PROPID_M_BASE + 11) 
#define PROPID_M_LABEL_LEN (PROPID_M_BASE + 12) 
#define PROPID_M_TIME_TO_REACH_QUEUE (PROPID_M_BASE + 13) 
#define PROPID_M_TIME_TO_BE_RECEIVED (PROPID_M_BASE + 14) 
#define PROPID_M_RESP_QUEUE (PROPID_M_BASE + 15) 
#define PROPID_M_RESP_QUEUE_LEN (PROPID_M_BASE + 16) 
#define PROPID_M_ADMIN_QUEUE (PROPID_M_BASE + 17) 
#define PROPID_M_ADMIN_QUEUE_LEN (PROPID_M_BASE + 18) 
#define PROPID_M_VERSION (PROPID_M_BASE + 19) 
#define PROPID_M_SENDERID (PROPID_M_BASE + 20) 
#define PROPID_M_SENDERID_LEN (PROPID_M_BASE + 21) 
#define PROPID_M_SENDERID_TYPE (PROPID_M_BASE + 22) 
#define PROPID_M_PRIV_LEVEL (PROPID_M_BASE + 23) 
#define PROPID_M_AUTH_LEVEL (PROPID_M_BASE + 24) 
#define PROPID_M_AUTHENTICATED (PROPID_M_BASE + 25) 
#define PROPID_M_HASH_ALG (PROPID_M_BASE + 26) 
#define PROPID_M_ENCRYPTION_ALG (PROPID_M_BASE + 27) 
#define PROPID_M_SENDER_CERT (PROPID_M_BASE + 28) 
#define PROPID_M_SENDER_CERT_LEN (PROPID_M_BASE + 29) 
#define PROPID_M_SRC_MACHINE_ID (PROPID_M_BASE + 30) 
#define PROPID_M_SENTTIME (PROPID_M_BASE + 31) 
#define PROPID_M_ARRIVEDTIME (PROPID_M_BASE + 32) 
#define PROPID_M_DEST_QUEUE (PROPID_M_BASE + 33) 
#define PROPID_M_DEST_QUEUE_LEN (PROPID_M_BASE + 34) 
#define PROPID_M_EXTENSION (PROPID_M_BASE + 35) 
#define PROPID_M_EXTENSION_LEN (PROPID_M_BASE + 36) 
#define PROPID_M_SECURITY_CONTEXT (PROPID_M_BASE + 37) 
#define PROPID_M_CONNECTOR_TYPE (PROPID_M_BASE + 38) 
#define PROPID_M_XACT_STATUS_QUEUE (PROPID_M_BASE + 39) 
#define PROPID_M_XACT_STATUS_QUEUE_LEN (PROPID_M_BASE + 40) 
#define PROPID_M_TRACE (PROPID_M_BASE + 41) 
#define PROPID_M_BODY_TYPE (PROPID_M_BASE + 42) 
#define PROPID_M_DEST_SYMM_KEY (PROPID_M_BASE + 43) 
#define PROPID_M_DEST_SYMM_KEY_LEN (PROPID_M_BASE + 44) 
#define PROPID_M_SIGNATURE (PROPID_M_BASE + 45) 
#define PROPID_M_SIGNATURE_LEN (PROPID_M_BASE + 46) 
#define PROPID_M_PROV_TYPE (PROPID_M_BASE + 47) 
#define PROPID_M_PROV_NAME (PROPID_M_BASE + 48) 
#define PROPID_M_PROV_NAME_LEN (PROPID_M_BASE + 49) 
#define PROPID_M_MSGID_SIZE 20
#define PROPID_M_CORRELATIONID_SIZE 20
#define MQCLASS_CODE(s, r, code) ((USHORT)(((s) << 15) | ((r) << 14) | (code)))
#define MQCLASS_NACK(c) ((c) & 0x8000)
#define MQCLASS_RECEIVE(c) ((c) & 0x4000)
#define MQMSG_CLASS_NORMAL MQCLASS_CODE(0, 0, 0)
#define MQMSG_CLASS_REPORT MQCLASS_CODE(0, 0, 1)
#define MQMSG_CLASS_ACK_REACH_QUEUE MQCLASS_CODE(0, 0, 2)
#define MQMSG_CLASS_ACK_RECEIVE MQCLASS_CODE(0, 1, 0)
#define MQMSG_CLASS_NACK_BAD_DST_Q MQCLASS_CODE(1, 0, 0)
#define MQMSG_CLASS_NACK_PURGED MQCLASS_CODE(1, 0, 1)
#define MQMSG_CLASS_NACK_REACH_QUEUE_TIMEOUT MQCLASS_CODE(1, 0, 2)
#define MQMSG_CLASS_NACK_Q_EXCEED_QUOTA MQCLASS_CODE(1, 0, 3)
#define MQMSG_CLASS_NACK_ACCESS_DENIED MQCLASS_CODE(1, 0, 4)
#define MQMSG_CLASS_NACK_HOP_COUNT_EXCEEDED MQCLASS_CODE(1, 0, 5)
#define MQMSG_CLASS_NACK_BAD_SIGNATURE MQCLASS_CODE(1, 0, 6)
#define MQMSG_CLASS_NACK_BAD_ENCRYPTION MQCLASS_CODE(1, 0, 7)
#define MQMSG_CLASS_NACK_COULD_NOT_ENCRYPT MQCLASS_CODE(1, 0, 8)
#define MQMSG_CLASS_NACK_NOT_TRANSACTIONAL_Q MQCLASS_CODE(1, 0, 9)
#define MQMSG_CLASS_NACK_NOT_TRANSACTIONAL_MSG MQCLASS_CODE(1, 0, 10)
#define MQMSG_CLASS_NACK_UNSUPPORTED_CRYPTO_PROVIDER MQCLASS_CODE(1, 0, 11)
#define MQMSG_CLASS_NACK_Q_DELETED MQCLASS_CODE(1, 1, 0)
#define MQMSG_CLASS_NACK_Q_PURGED MQCLASS_CODE(1, 1, 1)
#define MQMSG_CLASS_NACK_RECEIVE_TIMEOUT MQCLASS_CODE(1, 1, 2)
#define MQMSG_CLASS_NACK_RECEIVE_TIMEOUT_AT_SENDER MQCLASS_CODE(1, 1, 3)
#define MQMSG_ACKNOWLEDGMENT_NONE 0
#define MQMSG_ACKNOWLEDGMENT_POS_ARRIVAL 1
#define MQMSG_ACKNOWLEDGMENT_POS_RECEIVE 2
#define MQMSG_ACKNOWLEDGMENT_NEG_ARRIVAL 4
#define MQMSG_ACKNOWLEDGMENT_NEG_RECEIVE 8
#define MQMSG_ACKNOWLEDGMENT_NACK_REACH_QUEUE ((UCHAR)(MQMSG_ACKNOWLEDGMENT_NEG_ARRIVAL))
#define MQMSG_ACKNOWLEDGMENT_FULL_REACH_QUEUE ((UCHAR)(MQMSG_ACKNOWLEDGMENT_NEG_ARRIVAL | MQMSG_ACKNOWLEDGMENT_POS_ARRIVAL))
#define MQMSG_ACKNOWLEDGMENT_NACK_RECEIVE ((UCHAR)(MQMSG_ACKNOWLEDGMENT_NEG_ARRIVAL | MQMSG_ACKNOWLEDGMENT_NEG_RECEIVE))
#define MQMSG_ACKNOWLEDGMENT_FULL_RECEIVE ((UCHAR)(MQMSG_ACKNOWLEDGMENT_NEG_ARRIVAL | MQMSG_ACKNOWLEDGMENT_NEG_RECEIVE | MQMSG_ACKNOWLEDGMENT_POS_RECEIVE))
#define MQMSG_DELIVERY_EXPRESS 0
#define MQMSG_DELIVERY_RECOVERABLE 1
#define MQMSG_JOURNAL_NONE 0
#define MQMSG_DEADLETTER 1
#define MQMSG_JOURNAL 2
#define MQMSG_TRACE_NONE 0
#define MQMSG_SEND_ROUTE_TO_REPORT_QUEUE 1
#define MQMSG_SENDERID_TYPE_NONE 0
#define MQMSG_SENDERID_TYPE_SID 1
#define MQMSG_PRIV_LEVEL_NONE 0
#define MQMSG_PRIV_LEVEL_BODY 1
#define MQMSG_PRIV_LEVEL_BODY_BASE 1
#define MQMSG_PRIV_LEVEL_BODY_ENHANCED 3
#define MQMSG_AUTH_LEVEL_NONE 0
#define MQMSG_AUTH_LEVEL_ALWAYS 1
#define MQMSG_AUTHENTICATION_NOT_REQUESTED 0
#define MQMSG_AUTHENTICATION_REQUESTED 1
#define PROPID_Q_BASE 100
#define PROPID_Q_INSTANCE (PROPID_Q_BASE + 1) 
#define PROPID_Q_TYPE (PROPID_Q_BASE + 2) 
#define PROPID_Q_PATHNAME (PROPID_Q_BASE + 3) 
#define PROPID_Q_JOURNAL (PROPID_Q_BASE + 4) 
#define PROPID_Q_QUOTA (PROPID_Q_BASE + 5) 
#define PROPID_Q_BASEPRIORITY (PROPID_Q_BASE + 6) 
#define PROPID_Q_JOURNAL_QUOTA (PROPID_Q_BASE + 7) 
#define PROPID_Q_LABEL (PROPID_Q_BASE + 8) 
#define PROPID_Q_CREATE_TIME (PROPID_Q_BASE + 9) 
#define PROPID_Q_MODIFY_TIME (PROPID_Q_BASE + 10) 
#define PROPID_Q_AUTHENTICATE (PROPID_Q_BASE + 11) 
#define PROPID_Q_PRIV_LEVEL (PROPID_Q_BASE + 12) 
#define PROPID_Q_TRANSACTION (PROPID_Q_BASE + 13) 
#define PROPID_Q_PATHNAME_DNS (PROPID_Q_BASE + 24) 
#define MQ_JOURNAL_NONE (unsigned char)0
#define MQ_JOURNAL (unsigned char)1
#define MQ_QTYPE_REPORT {0x55ee8f32, 0xcce9, 4559, {177, 8, 0, 32, 175, 214, 28, 233}}
#define MQ_QTYPE_TEST {0x55ee8f33, 0xcce9, 4559, {177, 8, 0, 32, 175, 214, 28, 233}}
#define MQ_TRANSACTIONAL_NONE (unsigned char)0
#define MQ_TRANSACTIONAL (unsigned char)1
#define MQ_AUTHENTICATE_NONE (unsigned char)0
#define MQ_AUTHENTICATE (unsigned char)1
#define MQ_PRIV_LEVEL_NONE (unsigned long)0
#define MQ_PRIV_LEVEL_OPTIONAL (unsigned long)1
#define MQ_PRIV_LEVEL_BODY (unsigned long)2
#define PROPID_QM_BASE 200
#define PROPID_QM_SITE_ID (PROPID_QM_BASE + 1) 
#define PROPID_QM_MACHINE_ID (PROPID_QM_BASE + 2) 
#define PROPID_QM_PATHNAME (PROPID_QM_BASE + 3) 
#define PROPID_QM_CONNECTION (PROPID_QM_BASE + 4) 
#define PROPID_QM_ENCRYPTION_PK (PROPID_QM_BASE + 5) 
#define PROPID_QM_ENCRYPTION_PK_BASE (PROPID_QM_BASE + 31) 
#define PROPID_QM_ENCRYPTION_PK_ENHANCED (PROPID_QM_BASE + 32) 
#define PROPID_QM_PATHNAME_DNS (PROPID_QM_BASE + 33) 
#define LONG_LIVED 0xfffffffe
#define MQ_OK 0L
#ifndef FACILITY_MSMQ
#define FACILITY_MSMQ 14
#endif
#define MQ_ERROR 0xc00e0001
#define MQ_ERROR_PROPERTY 0xc00e0002
#define MQ_ERROR_QUEUE_NOT_FOUND 0xc00e0003
#define MQ_ERROR_QUEUE_EXISTS 0xc00e0005
#define MQ_ERROR_INVALID_PARAMETER 0xc00e0006
#define MQ_ERROR_INVALID_HANDLE 0xc00e0007
#define MQ_ERROR_OPERATION_CANCELLED 0xc00e0008
#define MQ_ERROR_SHARING_VIOLATION 0xc00e0009
#define MQ_ERROR_SERVICE_NOT_AVAILABLE 0xc00e000b
#define MQ_ERROR_MACHINE_NOT_FOUND 0xc00e000d
#define MQ_ERROR_ILLEGAL_SORT 0xc00e0010
#define MQ_ERROR_ILLEGAL_USER 0xc00e0011
#define MQ_ERROR_NO_DS 0xc00e0013
#define MQ_ERROR_ILLEGAL_QUEUE_PATHNAME 0xc00e0014
#define MQ_ERROR_ILLEGAL_PROPERTY_VALUE 0xc00e0018
#define MQ_ERROR_ILLEGAL_PROPERTY_VT 0xc00e0019
#define MQ_ERROR_BUFFER_OVERFLOW 0xc00e001a
#define MQ_ERROR_IO_TIMEOUT 0xc00e001b
#define MQ_ERROR_ILLEGAL_CURSOR_ACTION 0xc00e001c
#define MQ_ERROR_MESSAGE_ALREADY_RECEIVED 0xc00e001d
#define MQ_ERROR_ILLEGAL_FORMATNAME 0xc00e001e
#define MQ_ERROR_FORMATNAME_BUFFER_TOO_SMALL 0xc00e001f
#define MQ_ERROR_UNSUPPORTED_FORMATNAME_OPERATION 0xc00e0020
#define MQ_ERROR_ILLEGAL_SECURITY_DESCRIPTOR 0xc00e0021
#define MQ_ERROR_SENDERID_BUFFER_TOO_SMALL 0xc00e0022
#define MQ_ERROR_SECURITY_DESCRIPTOR_TOO_SMALL 0xc00e0023
#define MQ_ERROR_CANNOT_IMPERSONATE_CLIENT 0xc00e0024
#define MQ_ERROR_ACCESS_DENIED 0xc00e0025
#define MQ_ERROR_PRIVILEGE_NOT_HELD 0xc00e0026
#define MQ_ERROR_INSUFFICIENT_RESOURCES 0xc00e0027
#define MQ_ERROR_USER_BUFFER_TOO_SMALL 0xc00e0028
#define MQ_ERROR_MESSAGE_STORAGE_FAILED 0xc00e002a
#define MQ_ERROR_SENDER_CERT_BUFFER_TOO_SMALL 0xc00e002b
#define MQ_ERROR_INVALID_CERTIFICATE 0xc00e002c
#define MQ_ERROR_CORRUPTED_INTERNAL_CERTIFICATE 0xc00e002d
#define MQ_ERROR_NO_INTERNAL_USER_CERT 0xc00e002f
#define MQ_ERROR_CORRUPTED_SECURITY_DATA 0xc00e0030
#define MQ_ERROR_CORRUPTED_PERSONAL_CERT_STORE 0xc00e0031
#define MQ_ERROR_COMPUTER_DOES_NOT_SUPPORT_ENCRYPTION 0xc00e0033
#define MQ_ERROR_BAD_SECURITY_CONTEXT 0xc00e0035
#define MQ_ERROR_COULD_NOT_GET_USER_SID 0xc00e0036
#define MQ_ERROR_COULD_NOT_GET_ACCOUNT_INFO 0xc00e0037
#define MQ_ERROR_ILLEGAL_MQCOLUMNS 0xc00e0038
#define MQ_ERROR_ILLEGAL_PROPID 0xc00e0039
#define MQ_ERROR_ILLEGAL_RELATION 0xc00e003a
#define MQ_ERROR_ILLEGAL_PROPERTY_SIZE 0xc00e003b
#define MQ_ERROR_ILLEGAL_RESTRICTION_PROPID 0xc00e003c
#define MQ_ERROR_ILLEGAL_MQQUEUEPROPS 0xc00e003d
#define MQ_ERROR_PROPERTY_NOTALLOWED 0xc00e003e
#define MQ_ERROR_INSUFFICIENT_PROPERTIES 0xc00e003f
#define MQ_ERROR_MACHINE_EXISTS 0xc00e0040
#define MQ_ERROR_ILLEGAL_MQQMPROPS 0xc00e0041
#define MQ_ERROR_DS_IS_FULL 0xc00e0042
#define MQ_ERROR_DS_ERROR 0xc00e0043
#define MQ_ERROR_INVALID_OWNER 0xc00e0044
#define MQ_ERROR_UNSUPPORTED_ACCESS_MODE 0xc00e0045
#define MQ_ERROR_RESULT_BUFFER_TOO_SMALL 0xc00e0046
#define MQ_ERROR_DELETE_CN_IN_USE 0xc00e0048
#define MQ_ERROR_NO_RESPONSE_FROM_OBJECT_SERVER 0xc00e0049
#define MQ_ERROR_OBJECT_SERVER_NOT_AVAILABLE 0xc00e004a
#define MQ_ERROR_QUEUE_NOT_AVAILABLE 0xc00e004b
#define MQ_ERROR_DTC_CONNECT 0xc00e004c
#define MQ_ERROR_TRANSACTION_IMPORT 0xc00e004e
#define MQ_ERROR_TRANSACTION_USAGE 0xc00e0050
#define MQ_ERROR_TRANSACTION_SEQUENCE 0xc00e0051
#define MQ_ERROR_MISSING_CONNECTOR_TYPE 0xc00e0055
#define MQ_ERROR_STALE_HANDLE 0xc00e0056
#define MQ_ERROR_TRANSACTION_ENLIST 0xc00e0058
#define MQ_ERROR_QUEUE_DELETED 0xc00e005a
#define MQ_ERROR_ILLEGAL_CONTEXT 0xc00e005b
#define MQ_ERROR_ILLEGAL_SORT_PROPID 0xc00e005c
#define MQ_ERROR_LABEL_TOO_LONG 0xc00e005d
#define MQ_ERROR_LABEL_BUFFER_TOO_SMALL 0xc00e005e
#define MQ_ERROR_MQIS_SERVER_EMPTY 0xc00e005f
#define MQ_ERROR_MQIS_READONLY_MODE 0xc00e0060
#define MQ_ERROR_SYMM_KEY_BUFFER_TOO_SMALL 0xc00e0061
#define MQ_ERROR_SIGNATURE_BUFFER_TOO_SMALL 0xc00e0062
#define MQ_ERROR_PROV_NAME_BUFFER_TOO_SMALL 0xc00e0063
#define MQ_ERROR_ILLEGAL_OPERATION 0xc00e0064
#define MQ_ERROR_WRITE_NOT_ALLOWED 0xc00e0065
#define MQ_ERROR_WKS_CANT_SERVE_CLIENT 0xc00e0066
#define MQ_ERROR_DEPEND_WKS_LICENSE_OVERFLOW 0xc00e0067
#define MQ_CORRUPTED_QUEUE_WAS_DELETED 0xc00e0068
#define MQ_ERROR_REMOTE_MACHINE_NOT_AVAILABLE 0xc00e0069
#define MQ_ERROR_UNSUPPORTED_OPERATION 0xc00e006a
#define MQ_ERROR_ENCRYPTION_PROVIDER_NOT_SUPPORTED 0xc00e006b
#define MQ_ERROR_CANNOT_SET_CRYPTO_SEC_DESCR 0xc00e006c
#define MQ_ERROR_CERTIFICATE_NOT_PROVIDED 0xc00e006d
#define MQ_INFORMATION_PROPERTY 0x400e0001
#define MQ_INFORMATION_ILLEGAL_PROPERTY 0x400e0002
#define MQ_INFORMATION_PROPERTY_IGNORED 0x400e0003
#define MQ_INFORMATION_UNSUPPORTED_PROPERTY 0x400e0004
#define MQ_INFORMATION_DUPLICATE_PROPERTY 0x400e0005
#define MQ_INFORMATION_OPERATION_PENDING 0x400e0006
#define MQ_INFORMATION_FORMATNAME_BUFFER_TOO_SMALL 0x400e0009
#define MQ_INFORMATION_INTERNAL_USER_CERT_EXIST 0x400e000a
#define MQCERT_REGISTER_ALWAYS 1
#define MQCERT_REGISTER_IF_NOT_EXIST 2
#define MQSEC_DELETE_MESSAGE 1
#define MQSEC_PEEK_MESSAGE 2
#define MQSEC_WRITE_MESSAGE 4
#define MQSEC_DELETE_JOURNAL_MESSAGE 8
#define MQSEC_SET_QUEUE_PROPERTIES 16
#define MQSEC_GET_QUEUE_PROPERTIES 32
#define MQSEC_DELETE_QUEUE DELETE
#define MQSEC_GET_QUEUE_PERMISSIONS READ_CONTROL
#define MQSEC_CHANGE_QUEUE_PERMISSIONS WRITE_DAC
#define MQSEC_TAKE_QUEUE_OWNERSHIP WRITE_OWNER
#define MQSEC_RECEIVE_MESSAGE (MQSEC_DELETE_MESSAGE | MQSEC_PEEK_MESSAGE)
#define MQSEC_RECEIVE_JOURNAL_MESSAGE (MQSEC_DELETE_JOURNAL_MESSAGE | MQSEC_PEEK_MESSAGE)
#define MQSEC_QUEUE_GENERIC_READ (MQSEC_GET_QUEUE_PROPERTIES | MQSEC_GET_QUEUE_PERMISSIONS | MQSEC_RECEIVE_MESSAGE | MQSEC_RECEIVE_JOURNAL_MESSAGE)
#define MQSEC_QUEUE_GENERIC_WRITE (MQSEC_GET_QUEUE_PROPERTIES | MQSEC_GET_QUEUE_PERMISSIONS | MQSEC_WRITE_MESSAGE) 
#define MQSEC_QUEUE_GENERIC_EXECUTE 0
#define MQSEC_QUEUE_GENERIC_ALL (MQSEC_RECEIVE_MESSAGE | MQSEC_RECEIVE_JOURNAL_MESSAGE | MQSEC_WRITE_MESSAGE | MQSEC_SET_QUEUE_PROPERTIES | \
MQSEC_GET_QUEUE_PROPERTIES | MQSEC_DELETE_QUEUE | MQSEC_GET_QUEUE_PERMISSIONS | MQSEC_CHANGE_QUEUE_PERMISSIONS | MQSEC_TAKE_QUEUE_OWNERSHIP) 
typedef VOID (APIENTRY *PMQRECEIVECALLBACK)(HRESULT hrStatus, QUEUEHANDLE hSource, DWORD dwTimeout, DWORD dwAction, MQMSGPROPS* pMessageProps, LPOVERLAPPED lpOverlapped, HANDLE hCursor);
HRESULT APIENTRY MQCreateQueue(PSECURITY_DESCRIPTOR pSecurityDescriptor, MQQUEUEPROPS* pQueueProps, LPWSTR lpwcsFormatName, LPDWORD lpdwFormatNameLength);
HRESULT APIENTRY MQDeleteQueue(LPCWSTR lpwcsFormatName);
HRESULT APIENTRY MQLocateBegin(LPCWSTR lpwcsContext, MQRESTRICTION* pRestriction, MQCOLUMNSET* pColumns, MQSORTSET* pSort, PHANDLE phEnum);
HRESULT APIENTRY MQLocateNext(HANDLE hEnum, DWORD* pcProps, MQPROPVARIANT aPropVar[]);
HRESULT APIENTRY MQLocateEnd(HANDLE hEnum);
HRESULT APIENTRY MQOpenQueue(LPCWSTR lpwcsFormatName, DWORD dwAccess, DWORD dwShareMode, QUEUEHANDLE* phQueue);
HRESULT APIENTRY MQSendMessage(QUEUEHANDLE hDestinationQueue, MQMSGPROPS* pMessageProps, ITransaction *pTransaction);
HRESULT APIENTRY MQReceiveMessage(QUEUEHANDLE hSource, DWORD dwTimeout, DWORD dwAction, MQMSGPROPS* pMessageProps, LPOVERLAPPED lpOverlapped, PMQRECEIVECALLBACK fnReceiveCallback, HANDLE hCursor, ITransaction* pTransaction); 
HRESULT APIENTRY MQCreateCursor(QUEUEHANDLE hQueue, PHANDLE phCursor);
HRESULT APIENTRY MQCloseCursor(HANDLE hCursor);
HRESULT APIENTRY MQCloseQueue(HANDLE hQueue);
HRESULT APIENTRY MQSetQueueProperties(LPCWSTR lpwcsFormatName, MQQUEUEPROPS* pQueueProps);
HRESULT APIENTRY MQGetQueueProperties(LPCWSTR lpwcsFormatName, MQQUEUEPROPS* pQueueProps);
HRESULT APIENTRY MQGetQueueSecurity(LPCWSTR lpwcsFormatName, SECURITY_INFORMATION RequestedInformation, PSECURITY_DESCRIPTOR pSecurityDescriptor, DWORD nLength, LPDWORD lpnLengthNeeded);
HRESULT APIENTRY MQSetQueueSecurity(LPCWSTR lpwcsFormatName, SECURITY_INFORMATION SecurityInformation, PSECURITY_DESCRIPTOR pSecurityDescriptor);
HRESULT APIENTRY MQPathNameToFormatName(LPCWSTR lpwcsPathName, LPWSTR lpwcsFormatName, LPDWORD lpdwFormatNameLength);
HRESULT APIENTRY MQHandleToFormatName(QUEUEHANDLE hQueue, LPWSTR lpwcsFormatName, LPDWORD lpdwFormatNameLength); 
HRESULT APIENTRY MQInstanceToFormatName(GUID* pGuid, LPWSTR lpwcsFormatName, LPDWORD lpdwFormatNameLength);
void APIENTRY MQFreeMemory(PVOID pvMemory); 
HRESULT APIENTRY MQGetMachineProperties(LPCWSTR lpwcsMachineName, const GUID* pguidMachineId, MQQMPROPS* pQMProps); 
HRESULT APIENTRY MQGetSecurityContext(PVOID lpCertBuffer, DWORD dwCertBufferLength, HANDLE* hSecurityContext); 
void APIENTRY MQFreeSecurityContext(HANDLE hSecurityContext); 
HRESULT APIENTRY MQRegisterCertificate(DWORD dwFlags, PVOID lpCertBuffer, DWORD dwCertBufferLength) ;
HRESULT APIENTRY MQBeginTransaction(ITransaction **ppTransaction);
#endif 
