#ifndef _MSMQ_H_
#define _MSMQ_H_
DEFINE_GUID(LIBID_MSMQ,0xD7D6E071L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
#ifndef BEGIN_INTERFACE
#define BEGIN_INTERFACE
#endif
#ifndef __windows_h__
typedef unsigned char BYTE;
typedef unsigned long ULONG;
typedef unsigned long DWORD;
typedef int BOOL;
#endif
interface IMSMQQuery;
interface IMSMQQueueInfo;
interface IMSMQQueue;
interface IMSMQMessage;
interface IMSMQQueueInfos;
interface IMSMQEvent;
interface IMSMQTransaction;
interface IMSMQCoordinatedTransactionDispenser;
interface IMSMQTransactionDispenser;
typedef enum _MQCALG {
 MQMSG_CALG_MD2 = 32769,
 MQMSG_CALG_MD4 = 32770,
 MQMSG_CALG_MD5 = 32771,
 MQMSG_CALG_SHA = 32772,
 MQMSG_CALG_MAC = 32773,
 MQMSG_CALG_RSA_SIGN = 9216,
 MQMSG_CALG_DSS_SIGN = 8704,
 MQMSG_CALG_RSA_KEYX = 41984,
 MQMSG_CALG_DES = 26113,
 MQMSG_CALG_RC2 = 26114,
 MQMSG_CALG_RC4 = 26625,
 MQMSG_CALG_SEAL = 26626
} MQCALG;
#ifndef MQ_NO_TRANSACTION
typedef enum _MQTRANSACTION {
 MQ_NO_TRANSACTION = 0,
 MQ_MTS_TRANSACTION = 1,
 MQ_XA_TRANSACTION = 2,
 MQ_SINGLE_MESSAGE = 3
} MQTRANSACTION;
#endif
typedef enum _RELOPS {
 REL_NOP = 0,
 REL_EQ,
 REL_NEQ,
 REL_LT,
 REL_GT,
 REL_LE,
 REL_GE
} RELOPS;

typedef enum _MQMSGCURSOR {
 MQMSG_FIRST = 0,
 MQMSG_CURRENT = 1,
 MQMSG_NEXT = 2
} MQMSGCURSOR;

#ifndef MQMSG_CLASS_NORMAL
typedef enum _MQMSGCLASS {
 MQMSG_CLASS_NORMAL = 0,
 MQMSG_CLASS_REPORT = 1,
 MQMSG_CLASS_ACK_REACH_QUEUE = 2,
 MQMSG_CLASS_ACK_RECEIVE = 16384,
 MQMSG_CLASS_NACK_BAD_DST_Q = 32768,
 MQMSG_CLASS_NACK_PURGED = 32769,
 MQMSG_CLASS_NACK_REACH_QUEUE_TIMEOUT = 32770,
 MQMSG_CLASS_NACK_Q_EXCEED_QUOTA = 32771,
 MQMSG_CLASS_NACK_ACCESS_DENIED = 32772,
 MQMSG_CLASS_NACK_HOP_COUNT_EXCEEDED = 32773,
 MQMSG_CLASS_NACK_BAD_SIGNATURE = 32774,
 MQMSG_CLASS_NACK_BAD_ENCRYPTION = 32775,
 MQMSG_CLASS_NACK_COULD_NOT_ENCRYPT = 32776,
 MQMSG_CLASS_NACK_NOT_TRANSACTIONAL_Q = 32777,
 MQMSG_CLASS_NACK_NOT_TRANSACTIONAL_MSG = 32778,
 MQMSG_CLASS_NACK_Q_DELETED = 49152,
 MQMSG_CLASS_NACK_Q_PURGED = 49153,
 MQMSG_CLASS_NACK_RECEIVE_TIMEOUT = 49154
} MQMSGCLASS;
#endif
#ifndef MQMSG_DELIVERY_EXPRESS
typedef enum _MQMSGDELIVERY {
 MQMSG_DELIVERY_EXPRESS = 0,
 MQMSG_DELIVERY_RECOVERABLE = 1
} MQMSGDELIVERY;
#endif
#ifndef MQMSG_ACKNOWLEDGMENT_NONE
typedef enum _MQMSGACKNOWLEDGEMENT {
 MQMSG_ACKNOWLEDGMENT_NONE = 0,
 MQMSG_ACKNOWLEDGMENT_POS_ARRIVAL = 1,
 MQMSG_ACKNOWLEDGMENT_POS_RECEIVE = 2,
 MQMSG_ACKNOWLEDGMENT_NEG_ARRIVAL = 4,
 MQMSG_ACKNOWLEDGMENT_NEG_RECEIVE = 8,
 MQMSG_ACKNOWLEDGMENT_NACK_REACH_QUEUE = 4,
 MQMSG_ACKNOWLEDGMENT_FULL_REACH_QUEUE = 5,
 MQMSG_ACKNOWLEDGMENT_NACK_RECEIVE = 12,
 MQMSG_ACKNOWLEDGMENT_FULL_RECEIVE = 14
} MQMSGACKNOWLEDGEMENT;
#endif
typedef enum _MQMSGJOURNAL {
 MQMSG_JOURNAL_NONE = 0,
 MQMSG_DEADLETTER = 1,
 MQMSG_JOURNAL = 2
} MQMSGJOURNAL;

typedef enum _MQMSGTRACE {
 MQMSG_TRACE_NONE = 0,
 MQMSG_SEND_ROUTE_TO_REPORT_QUEUE = 1
} MQMSGTRACE;

typedef enum _MQMSGSENDERIDTYPE {
 MQMSG_SENDERID_TYPE_NONE = 0,
 MQMSG_SENDERID_TYPE_SID = 1
} MQMSGSENDERIDTYPE;

typedef enum _MQMSGPRIVLEVEL {
 MQMSG_PRIV_LEVEL_NONE = 0,
 MQMSG_PRIV_LEVEL_BODY = 1
} MQMSGPRIVLEVEL;

typedef enum _MQMSGAUTHLEVEL {
 MQMSG_AUTH_LEVEL_NONE = 0,
 MQMSG_AUTH_LEVEL_ALWAYS = 1
} MQMSGAUTHLEVEL;

typedef enum _MQMSGIDSIZE {
 MQMSG_MSGID_SIZE = 20,
 MQMSG_CORRELATIONID_SIZE = 20
} MQMSGIDSIZE;

typedef enum _MQMSGMAX {
 MQ_MAX_MSG_LABEL_LEN = 249
} MQMSGMAX;

typedef enum _MQSHARE {
 MQ_DENY_NONE = 0,
 MQ_DENY_RECEIVE_SHARE = 1
} MQSHARE;

typedef enum _MQACCESS {
 MQ_RECEIVE_ACCESS = 1,
 MQ_SEND_ACCESS = 2,
 MQ_PEEK_ACCESS = 32
} MQACCESS;

typedef enum _MQJOURNAL {
 MQ_JOURNAL_NONE = 0,
 MQ_JOURNAL = 1
} MQJOURNAL;

typedef enum _MQTRANSACTIONAL {
 MQ_TRANSACTIONAL_NONE = 0,
 MQ_TRANSACTIONAL = 1
} MQTRANSACTIONAL;

typedef enum _MQAUTHENTICATE {
 MQ_AUTHENTICATE_NONE = 0,
 MQ_AUTHENTICATE = 1
} MQAUTHENTICATE;

typedef enum _MQPRIVLEVEL {
 MQ_PRIV_LEVEL_NONE = 0,
 MQ_PRIV_LEVEL_OPTIONAL = 1,
 MQ_PRIV_LEVEL_BODY = 2
} MQPRIVLEVEL;

typedef enum _MQPRIORITY {
 MQ_MIN_PRIORITY = 0,
 MQ_MAX_PRIORITY = 7
} MQPRIORITY;

typedef enum _MQMAX {
 MQ_MAX_Q_NAME_LEN = 124,
 MQ_MAX_Q_LABEL_LEN = 124
} MQMAX;

typedef enum _MQDEFAULT {
 DEFAULT_M_PRIORITY = 3,
 DEFAULT_M_DELIVERY = 0,
 DEFAULT_M_ACKNOWLEDGE = 0,
 DEFAULT_M_JOURNAL = 0,
 DEFAULT_M_APPSPECIFIC = 0,
 DEFAULT_M_PRIV_LEVEL = 0,
 DEFAULT_M_AUTH_LEVEL = 0,
 DEFAULT_M_SENDERID_TYPE = 1,
 DEFAULT_Q_JOURNAL = 0,
 DEFAULT_Q_BASEPRIORITY = 0,
 DEFAULT_Q_QUOTA = -1,
 DEFAULT_Q_JOURNAL_QUOTA = -1,
 DEFAULT_Q_TRANSACTION = 0,
 DEFAULT_Q_AUTHENTICATE = 0,
 DEFAULT_Q_PRIV_LEVEL = 1
} MQDEFAULT;

typedef enum _MQERROR {
 MQ_ERROR = -1072824319,
 MQ_ERROR_PROPERTY = -1072824318,
 MQ_ERROR_QUEUE_NOT_FOUND = -1072824317,
 MQ_ERROR_QUEUE_EXISTS = -1072824315,
 MQ_ERROR_INVALID_PARAMETER = -1072824314,
 MQ_ERROR_INVALID_HANDLE = -1072824313,
 MQ_ERROR_OPERATION_CANCELLED = -1072824312,
 MQ_ERROR_SHARING_VIOLATION = -1072824311,
 MQ_ERROR_SERVICE_NOT_AVAILABLE = -1072824309,
 MQ_ERROR_MACHINE_NOT_FOUND = -1072824307,
 MQ_ERROR_ILLEGAL_SORT = -1072824304,
 MQ_ERROR_ILLEGAL_USER = -1072824303,
 MQ_ERROR_UNSUPPORTED_DBMS = -1072824302,
 MQ_ERROR_NO_DS = -1072824301,
 MQ_ERROR_ILLEGAL_QUEUE_PATHNAME = -1072824300,
 MQ_ERROR_ILLEGAL_PROPERTY_VALUE = -1072824296,
 MQ_ERROR_ILLEGAL_PROPERTY_VT = -1072824295,
 MQ_ERROR_BUFFER_OVERFLOW = -1072824294,
 MQ_ERROR_IO_TIMEOUT = -1072824293,
 MQ_ERROR_ILLEGAL_CURSOR_ACTION = -1072824292,
 MQ_ERROR_MESSAGE_ALREADY_RECEIVED = -1072824291,
 MQ_ERROR_ILLEGAL_FORMATNAME = -1072824290,
 MQ_ERROR_FORMATNAME_BUFFER_TOO_SMALL = -1072824289,
 MQ_ERROR_UNSUPPORTED_FORMATNAME_OPERATION = -1072824288,
 MQ_ERROR_ILLEGAL_SECURITY_DESCRIPTOR = -1072824287,
 MQ_ERROR_SENDERID_BUFFER_TOO_SMALL = -1072824286,
 MQ_ERROR_SECURITY_DESCRIPTOR_TOO_SMALL = -1072824285,
 MQ_ERROR_CANNOT_IMPERSONATE_CLIENT = -1072824284,
 MQ_ERROR_ACCESS_DENIED = -1072824283,
 MQ_ERROR_PRIVILEGE_NOT_HELD = -1072824282,
 MQ_ERROR_INSUFFICIENT_RESOURCES = -1072824281,
 MQ_ERROR_USER_BUFFER_TOO_SMALL = -1072824280,
 MQ_ERROR_MESSAGE_STORAGE_FAILED = -1072824278,
 MQ_ERROR_SENDER_CERT_BUFFER_TOO_SMALL = -1072824277,
 MQ_ERROR_INVALID_CERTIFICATE = -1072824276,
 MQ_ERROR_CORRUPTED_INTERNAL_CERTIFICATE = -1072824275,
 MQ_ERROR_INTERNAL_USER_CERT_EXIST = -1072824274,
 MQ_ERROR_NO_INTERNAL_USER_CERT = -1072824273,
 MQ_ERROR_CORRUPTED_SECURITY_DATA = -1072824272,
 MQ_ERROR_CORRUPTED_PERSONAL_CERT_STORE = -1072824271,
 MQ_ERROR_COMPUTER_DOES_NOT_SUPPORT_ENCRYPTION = -1072824269,
 MQ_ERROR_BAD_SECURITY_CONTEXT = -1072824267,
 MQ_ERROR_COULD_NOT_GET_USER_SID = -1072824266,
 MQ_ERROR_COULD_NOT_GET_ACCOUNT_INFO = -1072824265,
 MQ_ERROR_ILLEGAL_MQCOLUMNS = -1072824264,
 MQ_ERROR_ILLEGAL_PROPID = -1072824263,
 MQ_ERROR_ILLEGAL_RELATION = -1072824262,
 MQ_ERROR_ILLEGAL_PROPERTY_SIZE = -1072824261,
 MQ_ERROR_ILLEGAL_RESTRICTION_PROPID = -1072824260,
 MQ_ERROR_ILLEGAL_MQQUEUEPROPS = -1072824259,
 MQ_ERROR_PROPERTY_NOTALLOWED = -1072824258,
 MQ_ERROR_INSUFFICIENT_PROPERTIES = -1072824257,
 MQ_ERROR_MACHINE_EXISTS = -1072824256,
 MQ_ERROR_ILLEGAL_MQQMPROPS = -1072824255,
 MQ_ERROR_DS_IS_FULL = -1072824254,
 MQ_ERROR_DS_ERROR = -1072824253,
 MQ_ERROR_INVALID_OWNER = -1072824252,
 MQ_ERROR_UNSUPPORTED_ACCESS_MODE = -1072824251,
 MQ_ERROR_RESULT_BUFFER_TOO_SMALL = -1072824250,
 MQ_ERROR_DELETE_CN_IN_USE = -1072824248,
 MQ_ERROR_NO_RESPONSE_FROM_OBJECT_SERVER = -1072824247,
 MQ_ERROR_OBJECT_SERVER_NOT_AVAILABLE = -1072824246,
 MQ_ERROR_QUEUE_NOT_AVAILABLE = -1072824245,
 MQ_ERROR_DTC_CONNECT = -1072824244,
 MQ_ERROR_TRANSACTION_IMPORT = -1072824242,
 MQ_ERROR_TRANSACTION_USAGE = -1072824240,
 MQ_ERROR_TRANSACTION_SEQUENCE = -1072824239,
 MQ_ERROR_MISSING_CONNECTOR_TYPE = -1072824235,
 MQ_ERROR_STALE_HANDLE = -1072824234,
 MQ_ERROR_TRANSACTION_ENLIST = -1072824232,
 MQ_ERROR_QUEUE_DELETED = -1072824230,
 MQ_ERROR_ILLEGAL_CONTEXT = -1072824229,
 MQ_ERROR_ILLEGAL_SORT_PROPID = -1072824228,
 MQ_ERROR_LABEL_TOO_LONG = -1072824227,
 MQ_ERROR_LABEL_BUFFER_TOO_SMALL = -1072824226,
 MQ_ERROR_MQIS_SERVER_EMPTY = -1072824225,
 MQ_ERROR_MQIS_READONLY_MODE = -1072824224,
 MQ_ERROR_SYMM_KEY_BUFFER_TOO_SMALL = -1072824223,
 MQ_ERROR_SIGNATURE_BUFFER_TOO_SMALL = -1072824222,
 MQ_ERROR_PROV_NAME_BUFFER_TOO_SMALL = -1072824221,
 MQ_ERROR_ILLEGAL_OPERATION = -1072824220,
 MQ_ERROR_WRITE_NOT_ALLOWED = -1072824219
} MQERROR;

typedef enum _MQWARNING {
 MQ_INFORMATION_PROPERTY = 1074659329,
 MQ_INFORMATION_ILLEGAL_PROPERTY = 1074659330,
 MQ_INFORMATION_PROPERTY_IGNORED = 1074659331,
 MQ_INFORMATION_UNSUPPORTED_PROPERTY = 1074659332,
 MQ_INFORMATION_DUPLICATE_PROPERTY = 1074659333,
 MQ_INFORMATION_OPERATION_PENDING = 1074659334,
 MQ_INFORMATION_FORMATNAME_BUFFER_TOO_SMALL = 1074659337
} MQWARNING;

DEFINE_GUID(IID_IMSMQQuery,0xD7D6E072L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
#undef INTERFACE
#define INTERFACE IMSMQQuery
DECLARE_INTERFACE_(IMSMQQuery, IDispatch) {
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS
STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID * ppvObj) ;
 STDMETHOD_(ULONG, AddRef)(THIS) ;
 STDMETHOD_(ULONG, Release)(THIS) ;
STDMETHOD(GetTypeInfoCount)(THIS_ UINT * pctinfo) ;
STDMETHOD(GetTypeInfo)( THIS_ UINT itinfo, LCID lcid, ITypeInfo * * pptinfo) ;
STDMETHOD(GetIDsOfNames)( THIS_ REFIID riid, OLECHAR * * rgszNames, UINT cNames, LCID lcid, DISPID * rgdispid) ;
STDMETHOD(Invoke)( THIS_ DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS * pdispparams, VARIANT * pvarResult, EXCEPINFO * pexcepinfo, UINT * puArgErr) ;
#endif
STDMETHOD(LookupQueue)(THIS_ VARIANT * QueueGuid, VARIANT * ServiceTypeGuid, VARIANT * Label, VARIANT * CreateTime, VARIANT * ModifyTime, VARIANT * RelServiceType, VARIANT * RelLabel, VARIANT * RelCreateTime, VARIANT * RelModifyTime, IMSMQQueueInfos * * ppqinfos) ;
};

DEFINE_GUID(CLSID_MSMQQuery,0xD7D6E073L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
DEFINE_GUID(IID_IMSMQMessage,0xD7D6E074L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
#undef INTERFACE
#define INTERFACE IMSMQMessage
DECLARE_INTERFACE_(IMSMQMessage, IDispatch) {
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS
STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID * ppvObj) ;
 STDMETHOD_(ULONG, AddRef)(THIS) ;
 STDMETHOD_(ULONG, Release)(THIS) ;
STDMETHOD(GetTypeInfoCount)(THIS_ UINT * pctinfo) ;
STDMETHOD(GetTypeInfo)( THIS_ UINT itinfo, LCID lcid, ITypeInfo * * pptinfo) ;
STDMETHOD(GetIDsOfNames)( THIS_ REFIID riid, OLECHAR * * rgszNames, UINT cNames, LCID lcid, DISPID * rgdispid) ; 
 STDMETHOD(Invoke)( THIS_ DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS * pdispparams, VARIANT * pvarResult, EXCEPINFO * pexcepinfo, UINT * puArgErr) ;
#endif
STDMETHOD(get_Class)(THIS_ long * plClass) ;
 STDMETHOD(get_PrivLevel)(THIS_ long * plPrivLevel) ;
 STDMETHOD(put_PrivLevel)(THIS_ long lPrivLevel) ;
 STDMETHOD(get_AuthLevel)(THIS_ long * plAuthLevel) ;
 STDMETHOD(put_AuthLevel)(THIS_ long lAuthLevel) ;
 STDMETHOD(get_IsAuthenticated)(THIS_ VARIANT_BOOL * pisAuthenticated) ;
 STDMETHOD(get_Delivery)(THIS_ long * plDelivery) ;
 STDMETHOD(put_Delivery)(THIS_ long lDelivery) ;
 STDMETHOD(get_Trace)(THIS_ long * plTrace) ;
 STDMETHOD(put_Trace)(THIS_ long lTrace) ;
 STDMETHOD(get_Priority)(THIS_ long * plPriority) ;
 STDMETHOD(put_Priority)(THIS_ long lPriority) ;
 STDMETHOD(get_Journal)(THIS_ long * plJournal) ;
 STDMETHOD(put_Journal)(THIS_ long lJournal) ;
 STDMETHOD(get_ResponseQueueInfo)(THIS_ IMSMQQueueInfo * * ppqinfoResponse) ;
 STDMETHOD(putref_ResponseQueueInfo)(THIS_ IMSMQQueueInfo * pqinfoResponse) ;
 STDMETHOD(get_AppSpecific)(THIS_ long * plAppSpecific) ;
 STDMETHOD(put_AppSpecific)(THIS_ long lAppSpecific) ;
 STDMETHOD(get_SourceMachineGuid)(THIS_ BSTR * pbstrGuidSrcMachine) ;
 STDMETHOD(get_BodyLength)(THIS_ long * pcbBody) ;
 STDMETHOD(get_Body)(THIS_ VARIANT * pvarBody) ;
 STDMETHOD(put_Body)(THIS_ VARIANT varBody) ;
 STDMETHOD(get_AdminQueueInfo)(THIS_ IMSMQQueueInfo * * ppqinfoAdmin) ;
 STDMETHOD(putref_AdminQueueInfo)(THIS_ IMSMQQueueInfo * pqinfoAdmin) ;
 STDMETHOD(get_Id)(THIS_ VARIANT * pvarMsgId) ;
 STDMETHOD(get_CorrelationId)(THIS_ VARIANT * pvarMsgId) ;
 STDMETHOD(put_CorrelationId)(THIS_ VARIANT varMsgId) ;
 STDMETHOD(get_Ack)(THIS_ long * plAck) ;
 STDMETHOD(put_Ack)(THIS_ long lAck) ;
 STDMETHOD(get_Label)(THIS_ BSTR * pbstrLabel) ;
 STDMETHOD(put_Label)(THIS_ BSTR bstrLabel) ;
 STDMETHOD(get_MaxTimeToReachQueue)(THIS_ long * plMaxTimeToReachQueue) ;
 STDMETHOD(put_MaxTimeToReachQueue)(THIS_ long lMaxTimeToReachQueue) ;
 STDMETHOD(get_MaxTimeToReceive)(THIS_ long * plMaxTimeToReceive) ;
 STDMETHOD(put_MaxTimeToReceive)(THIS_ long lMaxTimeToReceive) ;
 STDMETHOD(get_HashAlgorithm)(THIS_ long * plHashAlg) ;
 STDMETHOD(put_HashAlgorithm)(THIS_ long lHashAlg) ;
 STDMETHOD(get_EncryptAlgorithm)(THIS_ long * plEncryptAlg) ;
 STDMETHOD(put_EncryptAlgorithm)(THIS_ long lEncryptAlg) ;
 STDMETHOD(get_SentTime)(THIS_ VARIANT * pvarSentTime) ;
 STDMETHOD(get_ArrivedTime)(THIS_ VARIANT * plArrivedTime) ;
 STDMETHOD(get_DestinationQueueInfo)(THIS_ IMSMQQueueInfo * * ppqinfoDest) ;
 STDMETHOD(get_SenderCertificate)(THIS_ VARIANT * pvarSenderCert) ;
 STDMETHOD(put_SenderCertificate)(THIS_ VARIANT varSenderCert) ;
 STDMETHOD(get_SenderId)(THIS_ VARIANT * pvarSenderId) ;
 STDMETHOD(get_SenderIdType)(THIS_ long * plSenderIdType) ;
 STDMETHOD(put_SenderIdType)(THIS_ long lSenderIdType) ;
 STDMETHOD(Send)(THIS_ IMSMQQueue * DestinationQueue, VARIANT * Transaction) ;
 STDMETHOD(AttachCurrentSecurityContext)(THIS) ;
};
DEFINE_GUID(CLSID_MSMQMessage,0xD7D6E075L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
DEFINE_GUID(IID_IMSMQQueue,0xD7D6E076L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
#undef INTERFACE
#define INTERFACE IMSMQQueue
DECLARE_INTERFACE_(IMSMQQueue, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS
 STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID * ppvObj) ;
 STDMETHOD_(ULONG, AddRef)(THIS) ;
 STDMETHOD_(ULONG, Release)(THIS) ;
 STDMETHOD(GetTypeInfoCount)(THIS_ UINT * pctinfo) ;
 STDMETHOD(GetTypeInfo)( THIS_ UINT itinfo, LCID lcid, ITypeInfo * * pptinfo) ;
STDMETHOD(GetIDsOfNames)( THIS_ REFIID riid, OLECHAR * * rgszNames, UINT cNames, LCID lcid, DISPID * rgdispid) ; 
 STDMETHOD(Invoke)( THIS_ DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS * pdispparams, VARIANT * pvarResult, EXCEPINFO * pexcepinfo, UINT * puArgErr) ;
#endif
STDMETHOD(get_Access)(THIS_ long * plAccess) ;
 STDMETHOD(get_ShareMode)(THIS_ long * plShareMode) ;
 STDMETHOD(get_QueueInfo)(THIS_ IMSMQQueueInfo * * ppqinfo) ;
 STDMETHOD(get_Handle)(THIS_ long * plHandle) ;
 STDMETHOD(get_IsOpen)(THIS_ VARIANT_BOOL * pisOpen) ;
 STDMETHOD(Close)(THIS) ;
 STDMETHOD(Receive)(THIS_ VARIANT * Transaction, VARIANT * WantDestinationQueue, VARIANT * WantBody, VARIANT * ReceiveTimeout, IMSMQMessage * * ppmsg) ;
 STDMETHOD(Peek)(THIS_ VARIANT * WantDestinationQueue, VARIANT * WantBody, VARIANT * ReceiveTimeout, IMSMQMessage * * ppmsg) ;
 STDMETHOD(EnableNotification)(THIS_ IMSMQEvent * Event, VARIANT * Cursor, VARIANT * ReceiveTimeout) ;
 STDMETHOD(Reset)(THIS) ;
 STDMETHOD(ReceiveCurrent)(THIS_ VARIANT * Transaction, VARIANT * WantDestinationQueue, VARIANT * WantBody, VARIANT * ReceiveTimeout, IMSMQMessage * * ppmsg) ;
 STDMETHOD(PeekNext)(THIS_ VARIANT * WantDestinationQueue, VARIANT * WantBody, VARIANT * ReceiveTimeout, IMSMQMessage * * ppmsg) ;
 STDMETHOD(PeekCurrent)(THIS_ VARIANT * WantDestinationQueue, VARIANT * WantBody, VARIANT * ReceiveTimeout, IMSMQMessage * * ppmsg) ;
};
DEFINE_GUID(IID_IMSMQEvent,0xD7D6E077L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
#undef INTERFACE
#define INTERFACE IMSMQEvent
DECLARE_INTERFACE_(IMSMQEvent, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS
STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID * ppvObj) ;
 STDMETHOD_(ULONG, AddRef)(THIS) ;
 STDMETHOD_(ULONG, Release)(THIS) ;
STDMETHOD(GetTypeInfoCount)(THIS_ UINT * pctinfo) ;
STDMETHOD(GetTypeInfo)( THIS_ UINT itinfo, LCID lcid, ITypeInfo * * pptinfo) ;
STDMETHOD(GetIDsOfNames)( THIS_ REFIID riid, OLECHAR * * rgszNames, UINT cNames, LCID lcid, DISPID * rgdispid) ; 
 STDMETHOD(Invoke)( THIS_ DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS * pdispparams, VARIANT * pvarResult, EXCEPINFO * pexcepinfo, UINT * puArgErr) ;
#endif
};

DEFINE_GUID(DIID__DMSMQEventEvents,0xD7D6E078L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);


#undef INTERFACE
#define INTERFACE _DMSMQEventEvents

DECLARE_INTERFACE_(_DMSMQEventEvents, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS
STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID * ppvObj) ;
 STDMETHOD_(ULONG, AddRef)(THIS) ;
 STDMETHOD_(ULONG, Release)(THIS) ;
STDMETHOD(GetTypeInfoCount)(THIS_ UINT * pctinfo) ;
STDMETHOD(GetTypeInfo)( THIS_ UINT itinfo, LCID lcid, ITypeInfo * * pptinfo) ; 
 STDMETHOD(GetIDsOfNames)( THIS_ REFIID riid, OLECHAR * * rgszNames, UINT cNames, LCID lcid, DISPID * rgdispid) ; 
 STDMETHOD(Invoke)( THIS_ DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS * pdispparams, VARIANT * pvarResult, EXCEPINFO * pexcepinfo, UINT * puArgErr) ;
#endif
};
DEFINE_GUID(CLSID_MSMQQueue,0xD7D6E079L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
DEFINE_GUID(CLSID_MSMQEvent,0xD7D6E07AL,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
DEFINE_GUID(IID_IMSMQQueueInfo,0xD7D6E07BL,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
#undef INTERFACE
#define INTERFACE IMSMQQueueInfo
DECLARE_INTERFACE_(IMSMQQueueInfo, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS
 STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID * ppvObj) ;
 STDMETHOD_(ULONG, AddRef)(THIS) ;
 STDMETHOD_(ULONG, Release)(THIS) ;
 STDMETHOD(GetTypeInfoCount)(THIS_ UINT * pctinfo) ;

 STDMETHOD(GetTypeInfo)( THIS_ UINT itinfo, LCID lcid, ITypeInfo * * pptinfo) ; 
 STDMETHOD(GetIDsOfNames)( THIS_ REFIID riid, OLECHAR * * rgszNames, UINT cNames, LCID lcid, DISPID * rgdispid) ;
STDMETHOD(Invoke)( THIS_ DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS * pdispparams, VARIANT * pvarResult, EXCEPINFO * pexcepinfo, UINT * puArgErr) ;
#endif
STDMETHOD(get_QueueGuid)(THIS_ BSTR * pbstrGuidQueue) ;
 STDMETHOD(get_ServiceTypeGuid)(THIS_ BSTR * pbstrGuidServiceType) ;
 STDMETHOD(put_ServiceTypeGuid)(THIS_ BSTR bstrGuidServiceType) ;
 STDMETHOD(get_Label)(THIS_ BSTR * pbstrLabel) ;
 STDMETHOD(put_Label)(THIS_ BSTR bstrLabel) ;
 STDMETHOD(get_PathName)(THIS_ BSTR * pbstrPathName) ;
 STDMETHOD(put_PathName)(THIS_ BSTR bstrPathName) ;
 STDMETHOD(get_FormatName)(THIS_ BSTR * pbstrFormatName) ;
 STDMETHOD(put_FormatName)(THIS_ BSTR bstrFormatName) ;
 STDMETHOD(get_IsTransactional)(THIS_ VARIANT_BOOL * pisTransactional) ;
 STDMETHOD(get_PrivLevel)(THIS_ long * plPrivLevel) ;
 STDMETHOD(put_PrivLevel)(THIS_ long lPrivLevel) ;
 STDMETHOD(get_Journal)(THIS_ long * plJournal) ;
 STDMETHOD(put_Journal)(THIS_ long lJournal) ;
 STDMETHOD(get_Quota)(THIS_ long * plQuota) ;
 STDMETHOD(put_Quota)(THIS_ long lQuota) ;
 STDMETHOD(get_BasePriority)(THIS_ long * plBasePriority) ;
 STDMETHOD(put_BasePriority)(THIS_ long lBasePriority) ;
 STDMETHOD(get_CreateTime)(THIS_ VARIANT * pvarCreateTime) ;
 STDMETHOD(get_ModifyTime)(THIS_ VARIANT * pvarModifyTime) ;
 STDMETHOD(get_Authenticate)(THIS_ long * plAuthenticate) ;
 STDMETHOD(put_Authenticate)(THIS_ long lAuthenticate) ;
 STDMETHOD(get_JournalQuota)(THIS_ long * plJournalQuota) ;
 STDMETHOD(put_JournalQuota)(THIS_ long lJournalQuota) ;
 STDMETHOD(get_IsWorldReadable)(THIS_ VARIANT_BOOL * pisWorldReadable) ;
 STDMETHOD(Create)(THIS_ VARIANT * IsTransactional, VARIANT * IsWorldReadable) ;
 STDMETHOD(Delete)(THIS) ;
 STDMETHOD(Open)(THIS_ long Access, long ShareMode, IMSMQQueue * * ppq) ;
 STDMETHOD(Refresh)(THIS) ;
 STDMETHOD(Update)(THIS) ;
};

DEFINE_GUID(CLSID_MSMQQueueInfo,0xD7D6E07CL,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
DEFINE_GUID(IID_IMSMQQueueInfos,0xD7D6E07DL,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
#undef INTERFACE
#define INTERFACE IMSMQQueueInfos
DECLARE_INTERFACE_(IMSMQQueueInfos, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS
 STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID * ppvObj) ;
 STDMETHOD_(ULONG, AddRef)(THIS) ;
 STDMETHOD_(ULONG, Release)(THIS) ;
 STDMETHOD(GetTypeInfoCount)(THIS_ UINT * pctinfo) ;
 STDMETHOD(GetTypeInfo)( THIS_ UINT itinfo, LCID lcid, ITypeInfo * * pptinfo) ; 
 STDMETHOD(GetIDsOfNames)( THIS_ REFIID riid, OLECHAR * * rgszNames, UINT cNames, LCID lcid, DISPID * rgdispid) ;
 STDMETHOD(Invoke)( THIS_ DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS * pdispparams, VARIANT * pvarResult, EXCEPINFO * pexcepinfo, UINT * puArgErr) ;
#endif
 STDMETHOD(Reset)(THIS) ;
 STDMETHOD(Next)(THIS_ IMSMQQueueInfo * * ppqinfoNext) ;
};

DEFINE_GUID(CLSID_MSMQQueueInfos,0xD7D6E07EL,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
typedef struct _MQBOID {
 BYTE rgb[16];
} MQBOID;

typedef struct _MQBOID MQXACTUOW;
typedef long MQISOLEVEL;
typedef struct _MQXACTTRANSINFO {
 MQXACTUOW uow;
 MQISOLEVEL isoLevel;
 ULONG isoFlags;
 DWORD grfTCSupported;
 DWORD grfRMSupported;
 DWORD grfTCSupportedRetaining;
 DWORD grfRMSupportedRetaining;
} MQXACTTRANSINFO;

DEFINE_GUID(IID_IMSMQTransaction,0xD7D6E07FL,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
#undef INTERFACE
#define INTERFACE IMSMQTransaction
DECLARE_INTERFACE_(IMSMQTransaction, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS
 STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID * ppvObj) ;
 STDMETHOD_(ULONG, AddRef)(THIS) ;
 STDMETHOD_(ULONG, Release)(THIS) ;
 STDMETHOD(GetTypeInfoCount)(THIS_ UINT * pctinfo) ;
 STDMETHOD(GetTypeInfo)( THIS_ UINT itinfo, LCID lcid, ITypeInfo * * pptinfo) ;
 STDMETHOD(GetIDsOfNames)( THIS_ REFIID riid, OLECHAR * * rgszNames, UINT cNames, LCID lcid, DISPID * rgdispid) ;
 STDMETHOD(Invoke)( THIS_ DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS * pdispparams, VARIANT * pvarResult, EXCEPINFO * pexcepinfo, UINT * puArgErr) ;
#endif
 STDMETHOD(get_Transaction)(THIS_ long * plTransaction) ;
 STDMETHOD(Commit)(THIS_ VARIANT * fRetaining, VARIANT * grfTC, VARIANT * grfRM) ;
 STDMETHOD(Abort)(THIS_ VARIANT * fRetaining, VARIANT * fAsync) ;
};
DEFINE_GUID(CLSID_MSMQTransaction,0xD7D6E080L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
DEFINE_GUID(IID_IMSMQCoordinatedTransactionDispenser,0xD7D6E081L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
#undef INTERFACE
#define INTERFACE IMSMQCoordinatedTransactionDispenser
DECLARE_INTERFACE_(IMSMQCoordinatedTransactionDispenser, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS
 STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID * ppvObj) ;
 STDMETHOD_(ULONG, AddRef)(THIS) ;
 STDMETHOD_(ULONG, Release)(THIS) ;
 STDMETHOD(GetTypeInfoCount)(THIS_ UINT * pctinfo) ;
 STDMETHOD(GetTypeInfo)( THIS_ UINT itinfo, LCID lcid, ITypeInfo * * pptinfo) ;
 STDMETHOD(GetIDsOfNames)( THIS_ REFIID riid, OLECHAR * * rgszNames, UINT cNames, LCID lcid, DISPID * rgdispid) ;
 STDMETHOD(Invoke)( THIS_ DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS * pdispparams, VARIANT * pvarResult, EXCEPINFO * pexcepinfo, UINT * puArgErr) ;
#endif
 STDMETHOD(BeginTransaction)(THIS_ IMSMQTransaction * * ptransaction) ;
};
DEFINE_GUID(CLSID_MSMQCoordinatedTransactionDispenser,0xD7D6E082L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
DEFINE_GUID(IID_IMSMQTransactionDispenser,0xD7D6E083L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
#undef INTERFACE
#define INTERFACE IMSMQTransactionDispenser
DECLARE_INTERFACE_(IMSMQTransactionDispenser, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS
 STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID * ppvObj) ;
 STDMETHOD_(ULONG, AddRef)(THIS) ;
 STDMETHOD_(ULONG, Release)(THIS) ;
 STDMETHOD(GetTypeInfoCount)(THIS_ UINT * pctinfo) ;
 STDMETHOD(GetTypeInfo)( THIS_ UINT itinfo, LCID lcid, ITypeInfo * * pptinfo) ; 
 STDMETHOD(GetIDsOfNames)( THIS_ REFIID riid, OLECHAR * * rgszNames, UINT cNames, LCID lcid, DISPID * rgdispid) ; 
 STDMETHOD(Invoke)( THIS_ DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS * pdispparams, VARIANT * pvarResult, EXCEPINFO * pexcepinfo, UINT * puArgErr) ;
#endif
 STDMETHOD(BeginTransaction)(THIS_ IMSMQTransaction * * ptransaction) ;
};

DEFINE_GUID(CLSID_MSMQTransactionDispenser,0xD7D6E084L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
DEFINE_GUID(IID_IMSMQApplication,0xD7D6E085L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
#undef INTERFACE
#define INTERFACE IMSMQApplication
DECLARE_INTERFACE_(IMSMQApplication, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS
 STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID * ppvObj) ;
 STDMETHOD_(ULONG, AddRef)(THIS) ;
 STDMETHOD_(ULONG, Release)(THIS) ;
 STDMETHOD(GetTypeInfoCount)(THIS_ UINT * pctinfo) ;
 STDMETHOD(GetTypeInfo)( THIS_ UINT itinfo, LCID lcid, ITypeInfo * * pptinfo) ;
 STDMETHOD(GetIDsOfNames)( THIS_ REFIID riid, OLECHAR * * rgszNames, UINT cNames, LCID lcid, DISPID * rgdispid) ;
 STDMETHOD(Invoke)( THIS_ DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS * pdispparams, VARIANT * pvarResult, EXCEPINFO * pexcepinfo, UINT * puArgErr) ;
#endif
 STDMETHOD(MachineIdOfMachineName)(THIS_ BSTR MachineName, BSTR * pbstrGuid) ;
};
DEFINE_GUID(CLSID_MSMQApplication,0xD7D6E086L,0xDCCD,0x11D0,0xAA,0x4B,0x00,0x60,0x97,0x0D,0xEB,0xAE);
#endif
