#ifndef __msi_h__
#define __msi_h__
#ifndef _WIN32_MSI
#if (_WIN32_WINNT >= 1281)
#define _WIN32_MSI 200
#elif (_WIN32_WINNT >= 1280)
#define _WIN32_MSI 110
#else
#define _WIN32_MSI 100
#endif 
#endif 
#if (_WIN32_MSI >= 150)
#ifndef _MSI_NO_CRYPTO
#include "wincrypt.h"
#endif 
#endif 
typedef unsigned long MSIHANDLE; 
UINT WINAPI MsiCloseHandle(MSIHANDLE );
UINT WINAPI MsiCloseAllHandles();
typedef enum tagINSTALLMESSAGE { INSTALLMESSAGE_FATALEXIT=0,
INSTALLMESSAGE_ERROR=0x1000000, INSTALLMESSAGE_WARNING=0x2000000,
INSTALLMESSAGE_USER=0x3000000, INSTALLMESSAGE_INFO=0x4000000,
INSTALLMESSAGE_FILESINUSE=0x5000000, INSTALLMESSAGE_RESOLVESOURCE=0x6000000,
INSTALLMESSAGE_OUTOFDISKSPACE=0x7000000, INSTALLMESSAGE_ACTIONSTART=0x8000000,
INSTALLMESSAGE_ACTIONDATA=0x9000000, INSTALLMESSAGE_PROGRESS=0xa000000,
INSTALLMESSAGE_COMMONDATA=0xb000000, INSTALLMESSAGE_INITIALIZE=0xc000000,
INSTALLMESSAGE_TERMINATE=0xd000000, INSTALLMESSAGE_SHOWDIALOG=0xe000000,
} INSTALLMESSAGE;
typedef int (WINAPI *INSTALLUI_HANDLERA)(LPVOID ,UINT ,LPCSTR );
typedef int (WINAPI *INSTALLUI_HANDLERW)(LPVOID ,UINT ,LPCWSTR );
#ifdef UNICODE
#define INSTALLUI_HANDLER INSTALLUI_HANDLERW
#else
#define INSTALLUI_HANDLER INSTALLUI_HANDLERA
#endif 
typedef enum tagINSTALLUILEVEL { INSTALLUILEVEL_NOCHANGE=0,
INSTALLUILEVEL_DEFAULT=1, INSTALLUILEVEL_NONE=2, INSTALLUILEVEL_BASIC=3,
INSTALLUILEVEL_REDUCED=4, INSTALLUILEVEL_FULL=5, INSTALLUILEVEL_ENDDIALOG=128,
INSTALLUILEVEL_PROGRESSONLY=64, INSTALLUILEVEL_HIDECANCEL=32, INSTALLUILEVEL_SOURCERESONLY=256,
} INSTALLUILEVEL;
typedef enum tagINSTALLSTATE { INSTALLSTATE_NOTUSED=-7,
INSTALLSTATE_BADCONFIG=-6, INSTALLSTATE_INCOMPLETE=-5,
INSTALLSTATE_SOURCEABSENT=-4, INSTALLSTATE_MOREDATA=-3,
INSTALLSTATE_INVALIDARG=-2, INSTALLSTATE_UNKNOWN=-1,
INSTALLSTATE_BROKEN=0, INSTALLSTATE_ADVERTISED=1,
INSTALLSTATE_REMOVED=1, INSTALLSTATE_ABSENT=2,
INSTALLSTATE_LOCAL=3, INSTALLSTATE_SOURCE=4,
INSTALLSTATE_DEFAULT=5, } INSTALLSTATE;
typedef enum tagUSERINFOSTATE { USERINFOSTATE_MOREDATA=-3,
USERINFOSTATE_INVALIDARG=-2, USERINFOSTATE_UNKNOWN=-1,
USERINFOSTATE_ABSENT=0, USERINFOSTATE_PRESENT=1,
} USERINFOSTATE;
typedef enum tagINSTALLLEVEL { INSTALLLEVEL_DEFAULT=0,
INSTALLLEVEL_MINIMUM=1, INSTALLLEVEL_MAXIMUM=0xffff,
} INSTALLLEVEL; 
typedef enum tagREINSTALLMODE { REINSTALLMODE_REPAIR=1,
REINSTALLMODE_FILEMISSING=2, REINSTALLMODE_FILEOLDERVERSION=4,
REINSTALLMODE_FILEEQUALVERSION=8, REINSTALLMODE_FILEEXACT=16,
REINSTALLMODE_FILEVERIFY=32, REINSTALLMODE_FILEREPLACE=64,
REINSTALLMODE_MACHINEDATA=128,
REINSTALLMODE_USERDATA=256,
REINSTALLMODE_SHORTCUT=512,
REINSTALLMODE_PACKAGE=1024,
} REINSTALLMODE;
typedef enum tagINSTALLOGMODE 
{
INSTALLLOGMODE_FATALEXIT=(1 << (INSTALLMESSAGE_FATALEXIT >> 24)),
INSTALLLOGMODE_ERROR=(1 << (INSTALLMESSAGE_ERROR >> 24)),
INSTALLLOGMODE_WARNING=(1 << (INSTALLMESSAGE_WARNING >> 24)),
INSTALLLOGMODE_USER=(1 << (INSTALLMESSAGE_USER >> 24)),
INSTALLLOGMODE_INFO=(1 << (INSTALLMESSAGE_INFO >> 24)),
INSTALLLOGMODE_RESOLVESOURCE=(1 << (INSTALLMESSAGE_RESOLVESOURCE >> 24)),
INSTALLLOGMODE_OUTOFDISKSPACE=(1 << (INSTALLMESSAGE_OUTOFDISKSPACE >> 24)),
INSTALLLOGMODE_ACTIONSTART=(1 << (INSTALLMESSAGE_ACTIONSTART >> 24)),
INSTALLLOGMODE_ACTIONDATA=(1 << (INSTALLMESSAGE_ACTIONDATA >> 24)),
INSTALLLOGMODE_COMMONDATA=(1 << (INSTALLMESSAGE_COMMONDATA >> 24)),
INSTALLLOGMODE_PROPERTYDUMP=(1 << (INSTALLMESSAGE_PROGRESS >> 24)),
INSTALLLOGMODE_VERBOSE=(1 << (INSTALLMESSAGE_INITIALIZE >> 24)),
INSTALLLOGMODE_EXTRADEBUG=(1 << (INSTALLMESSAGE_TERMINATE >> 24)),
INSTALLLOGMODE_PROGRESS=(1 << (INSTALLMESSAGE_PROGRESS >> 24)),
INSTALLLOGMODE_INITIALIZE=(1 << (INSTALLMESSAGE_INITIALIZE >> 24)),
INSTALLLOGMODE_TERMINATE=(1 << (INSTALLMESSAGE_TERMINATE >> 24)),
INSTALLLOGMODE_SHOWDIALOG=(1 << (INSTALLMESSAGE_SHOWDIALOG >> 24)),
} INSTALLLOGMODE;
typedef enum tagINSTALLLOGATTRIBUTES 
{
INSTALLLOGATTRIBUTES_APPEND=(1 << 0),
INSTALLLOGATTRIBUTES_FLUSHEACHLINE=(1 << 1),
} INSTALLLOGATTRIBUTES;
typedef enum tagINSTALLFEATUREATTRIBUTE 
{
INSTALLFEATUREATTRIBUTE_FAVORLOCAL=1 << 0,
INSTALLFEATUREATTRIBUTE_FAVORSOURCE=1 << 1,
INSTALLFEATUREATTRIBUTE_FOLLOWPARENT=1 << 2,
INSTALLFEATUREATTRIBUTE_FAVORADVERTISE=1 << 3,
INSTALLFEATUREATTRIBUTE_DISALLOWADVERTISE=1 << 4,
INSTALLFEATUREATTRIBUTE_NOUNSUPPORTEDADVERTISE=1 << 5,
} INSTALLFEATUREATTRIBUTE;
typedef enum tagINSTALLMODE
{
INSTALLMODE_NOSOURCERESOLUTION=-3,
INSTALLMODE_NODETECTION=-2,
INSTALLMODE_EXISTING=-1,
INSTALLMODE_DEFAULT=0,
} INSTALLMODE;
#define MAX_FEATURE_CHARS 38 
#define INSTALLPROPERTY_PACKAGENAME __TEXT("PackageName")
#define INSTALLPROPERTY_TRANSFORMS __TEXT("Transforms")
#define INSTALLPROPERTY_LANGUAGE __TEXT("Language")
#define INSTALLPROPERTY_PRODUCTNAME __TEXT("ProductName")
#define INSTALLPROPERTY_ASSIGNMENTTYPE __TEXT("AssignmentType")
#if (_WIN32_MSI >= 150)
#define INSTALLPROPERTY_INSTANCETYPE __TEXT("InstanceType")
#endif 
#define INSTALLPROPERTY_PACKAGECODE __TEXT("PackageCode")
#define INSTALLPROPERTY_VERSION __TEXT("Version")
#if (_WIN32_MSI >= 110)
#define INSTALLPROPERTY_PRODUCTICON __TEXT("ProductIcon")
#endif 
#define INSTALLPROPERTY_INSTALLEDPRODUCTNAME __TEXT("InstalledProductName")
#define INSTALLPROPERTY_VERSIONSTRING __TEXT("VersionString")
#define INSTALLPROPERTY_HELPLINK __TEXT("HelpLink")
#define INSTALLPROPERTY_HELPTELEPHONE __TEXT("HelpTelephone")
#define INSTALLPROPERTY_INSTALLLOCATION __TEXT("InstallLocation")
#define INSTALLPROPERTY_INSTALLSOURCE __TEXT("InstallSource")
#define INSTALLPROPERTY_INSTALLDATE __TEXT("InstallDate")
#define INSTALLPROPERTY_PUBLISHER __TEXT("Publisher")
#define INSTALLPROPERTY_LOCALPACKAGE __TEXT("LocalPackage")
#define INSTALLPROPERTY_URLINFOABOUT __TEXT("URLInfoAbout")
#define INSTALLPROPERTY_URLUPDATEINFO __TEXT("URLUpdateInfo")
#define INSTALLPROPERTY_VERSIONMINOR __TEXT("VersionMinor")
#define INSTALLPROPERTY_VERSIONMAJOR __TEXT("VersionMajor")
typedef enum tagSCRIPTFLAGS
{
SCRIPTFLAGS_CACHEINFO=1,
SCRIPTFLAGS_SHORTCUTS=4,
SCRIPTFLAGS_MACHINEASSIGN=8,
SCRIPTFLAGS_REGDATA_CNFGINFO=32,
SCRIPTFLAGS_VALIDATE_TRANSFORMS_LIST=64,
#if (_WIN32_MSI >= 110)
SCRIPTFLAGS_REGDATA_CLASSINFO=128,
SCRIPTFLAGS_REGDATA_EXTENSIONINFO=256,
SCRIPTFLAGS_REGDATA_APPINFO=SCRIPTFLAGS_REGDATA_CLASSINFO | SCRIPTFLAGS_REGDATA_EXTENSIONINFO,
#else 
SCRIPTFLAGS_REGDATA_APPINFO=16,
#endif 
SCRIPTFLAGS_REGDATA=SCRIPTFLAGS_REGDATA_APPINFO | SCRIPTFLAGS_REGDATA_CNFGINFO,
}SCRIPTFLAGS;
typedef enum tagADVERTISEFLAGS
{
ADVERTISEFLAGS_MACHINEASSIGN=0,
ADVERTISEFLAGS_USERASSIGN=1,
}ADVERTISEFLAGS;
typedef enum tagINSTALLTYPE
{
INSTALLTYPE_DEFAULT=0,
INSTALLTYPE_NETWORK_IMAGE=1,
INSTALLTYPE_SINGLE_INSTANCE=2,
}INSTALLTYPE;
#if (_WIN32_MSI >= 150)
typedef struct _MSIFILEHASHINFO {
ULONG dwFileHashInfoSize;
ULONG dwData [ 4 ];
} MSIFILEHASHINFO,*PMSIFILEHASHINFO;
typedef enum tagMSIARCHITECTUREFLAGS
{
MSIARCHITECTUREFLAGS_X86=1,
MSIARCHITECTUREFLAGS_IA64=2,
MSIARCHITECTUREFLAGS_AMD64=4
}MSIARCHITECTUREFLAGS;
typedef enum tagMSIOPENPACKAGEFLAGS
{
MSIOPENPACKAGEFLAGS_IGNOREMACHINESTATE=1,
}MSIOPENPACKAGEFLAGS;
typedef enum tagMSIADVERTISEOPTIONFLAGS
{
MSIADVERTISEOPTIONFLAGS_INSTANCE=1,
}MSIADVERTISEOPTIONFLAGS;
#endif 
INSTALLUILEVEL WINAPI MsiSetInternalUI(INSTALLUILEVEL ,HWND *); 
INSTALLUI_HANDLERA WINAPI MsiSetExternalUIA(INSTALLUI_HANDLERA ,DWORD ,LPVOID ); 
INSTALLUI_HANDLERW WINAPI MsiSetExternalUIW(INSTALLUI_HANDLERW ,DWORD ,LPVOID ); 
#ifdef UNICODE
#define MsiSetExternalUI MsiSetExternalUIW
#else
#define MsiSetExternalUI MsiSetExternalUIA
#endif 
UINT WINAPI MsiEnableLogA(DWORD ,LPCSTR ,DWORD ); 
UINT WINAPI MsiEnableLogW(DWORD ,LPCWSTR ,DWORD ); 
#ifdef UNICODE
#define MsiEnableLog MsiEnableLogW
#else
#define MsiEnableLog MsiEnableLogA
#endif 
INSTALLSTATE WINAPI MsiQueryProductStateA(LPCSTR );
INSTALLSTATE WINAPI MsiQueryProductStateW(LPCWSTR );
#ifdef UNICODE
#define MsiQueryProductState MsiQueryProductStateW
#else
#define MsiQueryProductState MsiQueryProductStateA
#endif 
UINT WINAPI MsiGetProductInfoA(LPCSTR ,LPCSTR ,LPSTR ,DWORD *); 
UINT WINAPI MsiGetProductInfoW(LPCWSTR ,LPCWSTR ,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiGetProductInfo MsiGetProductInfoW
#else
#define MsiGetProductInfo MsiGetProductInfoA
#endif 
UINT WINAPI MsiInstallProductA(LPCSTR ,LPCSTR ); 
UINT WINAPI MsiInstallProductW(LPCWSTR ,LPCWSTR ); 
#ifdef UNICODE
#define MsiInstallProduct MsiInstallProductW
#else
#define MsiInstallProduct MsiInstallProductA
#endif 
UINT WINAPI MsiConfigureProductA(LPCSTR ,int ,INSTALLSTATE ); 
UINT WINAPI MsiConfigureProductW(LPCWSTR ,int ,INSTALLSTATE ); 
#ifdef UNICODE
#define MsiConfigureProduct MsiConfigureProductW
#else
#define MsiConfigureProduct MsiConfigureProductA
#endif 
UINT WINAPI MsiConfigureProductExA(LPCSTR ,int ,INSTALLSTATE ,LPCSTR ); 
UINT WINAPI MsiConfigureProductExW(LPCWSTR ,int ,INSTALLSTATE ,LPCWSTR ); 
#ifdef UNICODE
#define MsiConfigureProductEx MsiConfigureProductExW
#else
#define MsiConfigureProductEx MsiConfigureProductExA
#endif 
UINT WINAPI MsiReinstallProductA(LPCSTR ,DWORD ); 
UINT WINAPI MsiReinstallProductW(LPCWSTR ,DWORD ); 
#ifdef UNICODE
#define MsiReinstallProduct MsiReinstallProductW
#else
#define MsiReinstallProduct MsiReinstallProductA
#endif 
#if (_WIN32_MSI >= 150)
UINT WINAPI MsiAdvertiseProductExA(LPCSTR	,LPCSTR ,LPCSTR ,LANGID ,DWORD ,DWORD ); 
UINT WINAPI MsiAdvertiseProductExW(LPCWSTR	,LPCWSTR ,LPCWSTR ,LANGID ,DWORD ,DWORD ); 
#ifdef UNICODE
#define MsiAdvertiseProductEx MsiAdvertiseProductExW
#else
#define MsiAdvertiseProductEx MsiAdvertiseProductExA
#endif 
#endif 
UINT WINAPI MsiAdvertiseProductA(LPCSTR ,LPCSTR ,LPCSTR ,LANGID ); 
UINT WINAPI MsiAdvertiseProductW(LPCWSTR ,LPCWSTR ,LPCWSTR ,LANGID ); 
#ifdef UNICODE
#define MsiAdvertiseProduct MsiAdvertiseProductW
#else
#define MsiAdvertiseProduct MsiAdvertiseProductA
#endif 
#if (_WIN32_MSI >= 150)
UINT WINAPI MsiProcessAdvertiseScriptA(LPCSTR ,LPCSTR ,HKEY ,BOOL ,BOOL ); 
UINT WINAPI MsiProcessAdvertiseScriptW(LPCWSTR ,LPCWSTR ,HKEY ,BOOL ,BOOL ); 
#ifdef UNICODE
#define MsiProcessAdvertiseScript MsiProcessAdvertiseScriptW
#else
#define MsiProcessAdvertiseScript MsiProcessAdvertiseScriptA
#endif 
#endif 
UINT WINAPI MsiAdvertiseScriptA(LPCSTR ,DWORD ,PHKEY ,BOOL ); 
UINT WINAPI MsiAdvertiseScriptW(LPCWSTR ,DWORD ,PHKEY ,BOOL ); 
#ifdef UNICODE
#define MsiAdvertiseScript MsiAdvertiseScriptW
#else
#define MsiAdvertiseScript MsiAdvertiseScriptA
#endif 
UINT WINAPI MsiGetProductInfoFromScriptA(LPCSTR ,LPSTR ,LANGID *,DWORD *,LPSTR ,DWORD *,LPSTR ,DWORD *);
UINT WINAPI MsiGetProductInfoFromScriptW(LPCWSTR ,LPWSTR ,LANGID *,DWORD *,LPWSTR ,DWORD *,LPWSTR ,DWORD *);
#ifdef UNICODE
#define MsiGetProductInfoFromScript MsiGetProductInfoFromScriptW
#else
#define MsiGetProductInfoFromScript MsiGetProductInfoFromScriptA
#endif 
UINT WINAPI MsiGetProductCodeA(LPCSTR ,LPSTR ); 
UINT WINAPI MsiGetProductCodeW(LPCWSTR ,LPWSTR ); 
#ifdef UNICODE
#define MsiGetProductCode MsiGetProductCodeW
#else
#define MsiGetProductCode MsiGetProductCodeA
#endif 
USERINFOSTATE WINAPI MsiGetUserInfoA(LPCSTR ,LPSTR ,DWORD *,LPSTR ,DWORD *,LPSTR ,DWORD *); 
USERINFOSTATE WINAPI MsiGetUserInfoW(LPCWSTR ,LPWSTR ,DWORD *,LPWSTR ,DWORD *,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiGetUserInfo MsiGetUserInfoW
#else
#define MsiGetUserInfo MsiGetUserInfoA
#endif 
UINT WINAPI MsiCollectUserInfoA(LPCSTR ); 
UINT WINAPI MsiCollectUserInfoW(LPCWSTR ); 
#ifdef UNICODE
#define MsiCollectUserInfo MsiCollectUserInfoW
#else
#define MsiCollectUserInfo MsiCollectUserInfoA
#endif 
UINT WINAPI MsiApplyPatchA(LPCSTR ,LPCSTR ,INSTALLTYPE ,LPCSTR ); 
UINT WINAPI MsiApplyPatchW(LPCWSTR ,LPCWSTR ,INSTALLTYPE ,LPCWSTR ); 
#ifdef UNICODE
#define MsiApplyPatch MsiApplyPatchW
#else
#define MsiApplyPatch MsiApplyPatchA
#endif 
UINT WINAPI MsiGetPatchInfoA(LPCSTR ,LPCSTR ,LPSTR ,DWORD *); 
UINT WINAPI MsiGetPatchInfoW(LPCWSTR ,LPCWSTR ,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiGetPatchInfo MsiGetPatchInfoW
#else
#define MsiGetPatchInfo MsiGetPatchInfoA
#endif 
UINT WINAPI MsiEnumPatchesA(LPCSTR ,DWORD ,LPSTR ,LPSTR ,DWORD *);
UINT WINAPI MsiEnumPatchesW(LPCWSTR ,DWORD ,LPWSTR ,LPWSTR ,DWORD *);
#ifdef UNICODE
#define MsiEnumPatches MsiEnumPatchesW
#else
#define MsiEnumPatches MsiEnumPatchesA
#endif 
INSTALLSTATE WINAPI MsiQueryFeatureStateA(LPCSTR ,LPCSTR );
INSTALLSTATE WINAPI MsiQueryFeatureStateW(LPCWSTR ,LPCWSTR );
#ifdef UNICODE
#define MsiQueryFeatureState MsiQueryFeatureStateW
#else
#define MsiQueryFeatureState MsiQueryFeatureStateA
#endif 
INSTALLSTATE WINAPI MsiUseFeatureA(LPCSTR ,LPCSTR );
INSTALLSTATE WINAPI MsiUseFeatureW(LPCWSTR ,LPCWSTR );
#ifdef UNICODE
#define MsiUseFeature MsiUseFeatureW
#else
#define MsiUseFeature MsiUseFeatureA
#endif 
INSTALLSTATE WINAPI MsiUseFeatureExA(LPCSTR ,LPCSTR ,DWORD ,DWORD ); 
INSTALLSTATE WINAPI MsiUseFeatureExW(LPCWSTR ,LPCWSTR ,DWORD ,DWORD ); 
#ifdef UNICODE
#define MsiUseFeatureEx MsiUseFeatureExW
#else
#define MsiUseFeatureEx MsiUseFeatureExA
#endif 
UINT WINAPI MsiGetFeatureUsageA(LPCSTR ,LPCSTR ,DWORD *,WORD *); 
UINT WINAPI MsiGetFeatureUsageW(LPCWSTR ,LPCWSTR ,DWORD *,WORD *); 
#ifdef UNICODE
#define MsiGetFeatureUsage MsiGetFeatureUsageW
#else
#define MsiGetFeatureUsage MsiGetFeatureUsageA
#endif 
UINT WINAPI MsiConfigureFeatureA(LPCSTR ,LPCSTR ,INSTALLSTATE ); 
UINT WINAPI MsiConfigureFeatureW(LPCWSTR ,LPCWSTR ,INSTALLSTATE ); 
#ifdef UNICODE
#define MsiConfigureFeature MsiConfigureFeatureW
#else
#define MsiConfigureFeature MsiConfigureFeatureA
#endif 
UINT WINAPI MsiReinstallFeatureA(LPCSTR ,LPCSTR ,DWORD ); 
UINT WINAPI MsiReinstallFeatureW(LPCWSTR ,LPCWSTR ,DWORD ); 
#ifdef UNICODE
#define MsiReinstallFeature MsiReinstallFeatureW
#else
#define MsiReinstallFeature MsiReinstallFeatureA
#endif 
UINT WINAPI MsiProvideComponentA(LPCSTR ,LPCSTR ,LPCSTR ,DWORD ,LPSTR ,DWORD *);
UINT WINAPI MsiProvideComponentW(LPCWSTR ,LPCWSTR ,LPCWSTR ,DWORD ,LPWSTR ,DWORD *);
#ifdef UNICODE
#define MsiProvideComponent MsiProvideComponentW
#else
#define MsiProvideComponent MsiProvideComponentA
#endif 
UINT WINAPI MsiProvideQualifiedComponentA(LPCSTR ,LPCSTR ,DWORD ,LPSTR ,DWORD *); 
UINT WINAPI MsiProvideQualifiedComponentW(LPCWSTR ,LPCWSTR ,DWORD ,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiProvideQualifiedComponent MsiProvideQualifiedComponentW
#else
#define MsiProvideQualifiedComponent MsiProvideQualifiedComponentA
#endif 
UINT WINAPI MsiProvideQualifiedComponentExA(LPCSTR ,LPCSTR ,DWORD ,LPCSTR ,DWORD ,DWORD ,LPSTR ,DWORD *); 
UINT WINAPI MsiProvideQualifiedComponentExW(LPCWSTR ,LPCWSTR ,DWORD ,LPCWSTR ,DWORD ,DWORD ,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiProvideQualifiedComponentEx MsiProvideQualifiedComponentExW
#else
#define MsiProvideQualifiedComponentEx MsiProvideQualifiedComponentExA
#endif 
INSTALLSTATE WINAPI MsiGetComponentPathA(LPCSTR ,LPCSTR ,LPSTR ,DWORD *); 
INSTALLSTATE WINAPI MsiGetComponentPathW(LPCWSTR ,LPCWSTR ,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiGetComponentPath MsiGetComponentPathW
#else
#define MsiGetComponentPath MsiGetComponentPathA
#endif 
#if (_WIN32_MSI >= 150)
#define MSIASSEMBLYINFO_NETASSEMBLY 0 
#define MSIASSEMBLYINFO_WIN32ASSEMBLY 1 
UINT WINAPI MsiProvideAssemblyA(LPCSTR ,LPCSTR ,DWORD ,DWORD ,LPSTR ,DWORD *); 
UINT WINAPI MsiProvideAssemblyW(LPCWSTR ,LPCWSTR ,DWORD ,DWORD ,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiProvideAssembly MsiProvideAssemblyW
#else
#define MsiProvideAssembly MsiProvideAssemblyA
#endif 
#endif 
UINT WINAPI MsiEnumProductsA(DWORD ,LPSTR ); 
UINT WINAPI MsiEnumProductsW(DWORD ,LPWSTR ); 
#ifdef UNICODE
#define MsiEnumProducts MsiEnumProductsW
#else
#define MsiEnumProducts MsiEnumProductsA
#endif 
#if (_WIN32_MSI >= 110)
UINT WINAPI MsiEnumRelatedProductsA(LPCSTR ,DWORD ,DWORD ,LPSTR ); 
UINT WINAPI MsiEnumRelatedProductsW(LPCWSTR ,DWORD ,DWORD ,LPWSTR ); 
#ifdef UNICODE
#define MsiEnumRelatedProducts MsiEnumRelatedProductsW
#else
#define MsiEnumRelatedProducts MsiEnumRelatedProductsA
#endif 
#endif 
UINT WINAPI MsiEnumFeaturesA(LPCSTR ,DWORD ,LPSTR ,LPSTR ); 
UINT WINAPI MsiEnumFeaturesW(LPCWSTR ,DWORD ,LPWSTR ,LPWSTR ); 
#ifdef UNICODE
#define MsiEnumFeatures MsiEnumFeaturesW
#else
#define MsiEnumFeatures MsiEnumFeaturesA
#endif 
UINT WINAPI MsiEnumComponentsA(DWORD ,LPSTR ); 
UINT WINAPI MsiEnumComponentsW(DWORD ,LPWSTR ); 
#ifdef UNICODE
#define MsiEnumComponents MsiEnumComponentsW
#else
#define MsiEnumComponents MsiEnumComponentsA
#endif 
UINT WINAPI MsiEnumClientsA(LPCSTR ,DWORD ,LPSTR ); 
UINT WINAPI MsiEnumClientsW(LPCWSTR ,DWORD ,LPWSTR ); 
#ifdef UNICODE
#define MsiEnumClients MsiEnumClientsW
#else
#define MsiEnumClients MsiEnumClientsA
#endif 
UINT WINAPI MsiEnumComponentQualifiersA(LPCSTR ,DWORD ,LPSTR ,DWORD *,LPSTR ,DWORD *); 
UINT WINAPI MsiEnumComponentQualifiersW(LPCWSTR ,DWORD ,LPWSTR ,DWORD *,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiEnumComponentQualifiers MsiEnumComponentQualifiersW
#else
#define MsiEnumComponentQualifiers MsiEnumComponentQualifiersA
#endif 
UINT WINAPI MsiOpenProductA(LPCSTR ,MSIHANDLE *); 
UINT WINAPI MsiOpenProductW(LPCWSTR ,MSIHANDLE *); 
#ifdef UNICODE
#define MsiOpenProduct MsiOpenProductW
#else
#define MsiOpenProduct MsiOpenProductA
#endif 
UINT WINAPI MsiOpenPackageA(LPCSTR ,MSIHANDLE *); 
UINT WINAPI MsiOpenPackageW(LPCWSTR ,MSIHANDLE *); 
#ifdef UNICODE
#define MsiOpenPackage MsiOpenPackageW
#else
#define MsiOpenPackage MsiOpenPackageA
#endif 
#if (_WIN32_MSI >= 150)
UINT WINAPI MsiOpenPackageExA(LPCSTR ,DWORD ,MSIHANDLE *); 
UINT WINAPI MsiOpenPackageExW(LPCWSTR ,DWORD ,MSIHANDLE *); 
#ifdef UNICODE
#define MsiOpenPackageEx MsiOpenPackageExW
#else
#define MsiOpenPackageEx MsiOpenPackageExA
#endif 
#endif 
UINT WINAPI MsiGetProductPropertyA(MSIHANDLE ,LPCSTR ,LPSTR ,DWORD *); 
UINT WINAPI MsiGetProductPropertyW(MSIHANDLE ,LPCWSTR ,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiGetProductProperty MsiGetProductPropertyW
#else
#define MsiGetProductProperty MsiGetProductPropertyA
#endif 
UINT WINAPI MsiVerifyPackageA(LPCSTR ); 
UINT WINAPI MsiVerifyPackageW(LPCWSTR ); 
#ifdef UNICODE
#define MsiVerifyPackage MsiVerifyPackageW
#else
#define MsiVerifyPackage MsiVerifyPackageA
#endif 
UINT WINAPI MsiGetFeatureInfoA(MSIHANDLE ,LPCSTR ,DWORD *,LPSTR ,DWORD *,LPSTR ,DWORD *); 
UINT WINAPI MsiGetFeatureInfoW(MSIHANDLE ,LPCWSTR ,DWORD *,LPWSTR ,DWORD *,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiGetFeatureInfo MsiGetFeatureInfoW
#else
#define MsiGetFeatureInfo MsiGetFeatureInfoA
#endif 
UINT WINAPI MsiInstallMissingComponentA(LPCSTR ,LPCSTR ,INSTALLSTATE ); 
UINT WINAPI MsiInstallMissingComponentW(LPCWSTR ,LPCWSTR ,INSTALLSTATE ); 
#ifdef UNICODE
#define MsiInstallMissingComponent MsiInstallMissingComponentW
#else
#define MsiInstallMissingComponent MsiInstallMissingComponentA
#endif 
UINT WINAPI MsiInstallMissingFileA(LPCSTR ,LPCSTR ); 
UINT WINAPI MsiInstallMissingFileW(LPCWSTR ,LPCWSTR ); 
#ifdef UNICODE
#define MsiInstallMissingFile MsiInstallMissingFileW
#else
#define MsiInstallMissingFile MsiInstallMissingFileA
#endif 
INSTALLSTATE WINAPI MsiLocateComponentA(LPCSTR ,LPSTR ,DWORD *); 
INSTALLSTATE WINAPI MsiLocateComponentW(LPCWSTR ,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiLocateComponent MsiLocateComponentW
#else
#define MsiLocateComponent MsiLocateComponentA
#endif 
#if (_WIN32_MSI >= 110)
UINT WINAPI MsiSourceListClearAllA(LPCSTR ,LPCSTR ,DWORD ); 
UINT WINAPI MsiSourceListClearAllW(LPCWSTR ,LPCWSTR ,DWORD ); 
#ifdef UNICODE
#define MsiSourceListClearAll MsiSourceListClearAllW
#else
#define MsiSourceListClearAll MsiSourceListClearAllA
#endif 
UINT WINAPI MsiSourceListAddSourceA(LPCSTR ,LPCSTR ,DWORD ,LPCSTR ); 
UINT WINAPI MsiSourceListAddSourceW(LPCWSTR ,LPCWSTR ,DWORD ,LPCWSTR ); 
#ifdef UNICODE
#define MsiSourceListAddSource MsiSourceListAddSourceW
#else
#define MsiSourceListAddSource MsiSourceListAddSourceA
#endif 
UINT WINAPI MsiSourceListForceResolutionA(LPCSTR ,LPCSTR ,DWORD ); 
UINT WINAPI MsiSourceListForceResolutionW(LPCWSTR ,LPCWSTR ,DWORD ); 
#ifdef UNICODE
#define MsiSourceListForceResolution MsiSourceListForceResolutionW
#else
#define MsiSourceListForceResolution MsiSourceListForceResolutionA
#endif 
#endif 
UINT WINAPI MsiGetFileVersionA(LPCSTR ,LPSTR ,DWORD *,LPSTR ,DWORD *); 
UINT WINAPI MsiGetFileVersionW(LPCWSTR ,LPWSTR ,DWORD *,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiGetFileVersion MsiGetFileVersionW
#else
#define MsiGetFileVersion MsiGetFileVersionA
#endif 
#if (_WIN32_MSI >= 150)
UINT WINAPI MsiGetFileHashA(LPCSTR ,DWORD ,PMSIFILEHASHINFO ); 
UINT WINAPI MsiGetFileHashW(LPCWSTR ,DWORD ,PMSIFILEHASHINFO ); 
#ifdef UNICODE
#define MsiGetFileHash MsiGetFileHashW
#else
#define MsiGetFileHash MsiGetFileHashA
#endif 
#endif 
#if (_WIN32_MSI >= 150)
#ifndef _MSI_NO_CRYPTO
HRESULT WINAPI MsiGetFileSignatureInformationA(LPCSTR	,DWORD ,PCCERT_CONTEXT *,BYTE *,DWORD *); 
HRESULT WINAPI MsiGetFileSignatureInformationW(LPCWSTR	,DWORD ,PCCERT_CONTEXT *,BYTE *,DWORD *); 
#ifdef UNICODE
#define MsiGetFileSignatureInformation MsiGetFileSignatureInformationW
#else
#define MsiGetFileSignatureInformation MsiGetFileSignatureInformationA
#endif 
#define MSI_INVALID_HASH_IS_FATAL 1
#endif
#endif 
#if (_WIN32_MSI >= 110)
UINT WINAPI MsiGetShortcutTargetA(LPCSTR ,LPSTR ,LPSTR ,LPSTR ); 
UINT WINAPI MsiGetShortcutTargetW(LPCWSTR ,LPWSTR ,LPWSTR ,LPWSTR ); 
#ifdef UNICODE
#define MsiGetShortcutTarget MsiGetShortcutTargetW
#else
#define MsiGetShortcutTarget MsiGetShortcutTargetA
#endif 
#endif 
#if (_WIN32_MSI >= 110)
UINT WINAPI MsiIsProductElevatedA(LPCSTR ,BOOL *); 
UINT WINAPI MsiIsProductElevatedW(LPCWSTR ,BOOL *); 
#ifdef UNICODE
#define MsiIsProductElevated MsiIsProductElevatedW
#else
#define MsiIsProductElevated MsiIsProductElevatedA
#endif 
#endif 
#ifndef ERROR_INSTALL_FAILURE
#define ERROR_INSTALL_USEREXIT 1602L 
#define ERROR_INSTALL_FAILURE 1603L 
#define ERROR_INSTALL_SUSPEND 1604L 
#define ERROR_UNKNOWN_PRODUCT 1605L 
#define ERROR_UNKNOWN_FEATURE 1606L 
#define ERROR_UNKNOWN_COMPONENT 1607L 
#define ERROR_UNKNOWN_PROPERTY 1608L 
#define ERROR_INVALID_HANDLE_STATE 1609L 
#define ERROR_BAD_CONFIGURATION 1610L 
#define ERROR_INDEX_ABSENT 1611L 
#define ERROR_INSTALL_SOURCE_ABSENT 1612L 
#define ERROR_PRODUCT_UNINSTALLED 1614L 
#define ERROR_BAD_QUERY_SYNTAX 1615L 
#define ERROR_INVALID_FIELD 1616L 
#endif
#ifndef ERROR_INSTALL_SERVICE_FAILURE
#define ERROR_INSTALL_SERVICE_FAILURE 1601L 
#define ERROR_INSTALL_PACKAGE_VERSION 1613L 
#define ERROR_INSTALL_ALREADY_RUNNING 1618L 
#define ERROR_INSTALL_PACKAGE_OPEN_FAILED 1619L 
#define ERROR_INSTALL_PACKAGE_INVALID 1620L 
#define ERROR_INSTALL_UI_FAILURE 1621L 
#define ERROR_INSTALL_LOG_FAILURE 1622L 
#define ERROR_INSTALL_LANGUAGE_UNSUPPORTED 1623L 
#define ERROR_INSTALL_PACKAGE_REJECTED 1625L 
#define ERROR_FUNCTION_NOT_CALLED 1626L 
#define ERROR_FUNCTION_FAILED 1627L 
#define ERROR_INVALID_TABLE 1628L 
#define ERROR_DATATYPE_MISMATCH 1629L 
#define ERROR_UNSUPPORTED_TYPE 1630L 
#define ERROR_CREATE_FAILED 1631L 
#endif
#ifndef ERROR_INSTALL_TEMP_UNWRITABLE 
#define ERROR_INSTALL_TEMP_UNWRITABLE 1632L 
#endif
#ifndef ERROR_INSTALL_PLATFORM_UNSUPPORTED
#define ERROR_INSTALL_PLATFORM_UNSUPPORTED 1633L 
#endif
#ifndef ERROR_INSTALL_NOTUSED
#define ERROR_INSTALL_NOTUSED 1634L 
#endif
#ifndef ERROR_INSTALL_TRANSFORM_FAILURE
#define ERROR_INSTALL_TRANSFORM_FAILURE 1624L 
#endif
#ifndef ERROR_PATCH_PACKAGE_OPEN_FAILED
#define ERROR_PATCH_PACKAGE_OPEN_FAILED 1635L 
#define ERROR_PATCH_PACKAGE_INVALID 1636L 
#define ERROR_PATCH_PACKAGE_UNSUPPORTED 1637L 
#endif
#ifndef ERROR_PRODUCT_VERSION
#define ERROR_PRODUCT_VERSION 1638L 
#endif
#ifndef ERROR_INVALID_COMMAND_LINE
#define ERROR_INVALID_COMMAND_LINE 1639L 
#endif
#ifndef ERROR_INSTALL_REMOTE_DISALLOWED
#define ERROR_INSTALL_REMOTE_DISALLOWED 1640L 
#endif
#ifndef ERROR_SUCCESS_REBOOT_INITIATED
#define ERROR_SUCCESS_REBOOT_INITIATED 1641L 
#endif
#ifndef ERROR_PATCH_TARGET_NOT_FOUND
#define ERROR_PATCH_TARGET_NOT_FOUND 1642L 
#endif
#ifndef ERROR_PATCH_PACKAGE_REJECTED
#define ERROR_PATCH_PACKAGE_REJECTED 1643L 
#endif
#ifndef ERROR_INSTALL_TRANSFORM_REJECTED
#define ERROR_INSTALL_TRANSFORM_REJECTED 1644L 
#endif
#ifndef ERROR_INSTALL_REMOTE_PROHIBITED
#define ERROR_INSTALL_REMOTE_PROHIBITED 1645L 
#endif
#endif 
