#ifndef __msiquery_h__
#define __msiquery_h__
#include "msi.h" 
#define MSI_NULL_INTEGER 0x80000000
#define MSIDBOPEN_READONLY (LPCTSTR)0 
#define MSIDBOPEN_TRANSACT (LPCTSTR)1 
#define MSIDBOPEN_DIRECT (LPCTSTR)2 
#define MSIDBOPEN_CREATE (LPCTSTR)3 
#define MSIDBOPEN_CREATEDIRECT (LPCTSTR)4 
#define MSIDBOPEN_PATCHFILE 32/sizeof(*MSIDBOPEN_READONLY) 
typedef enum tagMSIDBSTATE
{
MSIDBSTATE_ERROR=-1,
MSIDBSTATE_READ=0,
MSIDBSTATE_WRITE=1,
} MSIDBSTATE;
typedef enum tagMSIMODIFY
{
MSIMODIFY_SEEK=-1,
MSIMODIFY_REFRESH=0,
MSIMODIFY_INSERT=1,
MSIMODIFY_UPDATE=2,
MSIMODIFY_ASSIGN=3,
MSIMODIFY_REPLACE=4,
MSIMODIFY_MERGE=5,
MSIMODIFY_DELETE=6,
MSIMODIFY_INSERT_TEMPORARY=7,
MSIMODIFY_VALIDATE=8,
MSIMODIFY_VALIDATE_NEW=9,
MSIMODIFY_VALIDATE_FIELD=10,
MSIMODIFY_VALIDATE_DELETE=11,
} MSIMODIFY;
typedef enum tagMSICOLINFO
{
MSICOLINFO_NAMES=0,
MSICOLINFO_TYPES=1,
} MSICOLINFO;
typedef enum tagMSICONDITION
{
MSICONDITION_FALSE=0,
MSICONDITION_TRUE=1,
MSICONDITION_NONE=2,
MSICONDITION_ERROR=3,
} MSICONDITION;
typedef enum tagMSICOSTTREE
{
MSICOSTTREE_SELFONLY=0,
MSICOSTTREE_CHILDREN=1,
MSICOSTTREE_PARENTS=2,
MSICOSTTREE_RESERVED=3,
} MSICOSTTREE;
typedef enum tagMSIDBERROR
{
MSIDBERROR_INVALIDARG=-3,
MSIDBERROR_MOREDATA=-2,
MSIDBERROR_FUNCTIONERROR=-1,
MSIDBERROR_NOERROR=0,
MSIDBERROR_DUPLICATEKEY=1,
MSIDBERROR_REQUIRED=2,
MSIDBERROR_BADLINK=3,
MSIDBERROR_OVERFLOW=4,
MSIDBERROR_UNDERFLOW=5,
MSIDBERROR_NOTINSET=6,
MSIDBERROR_BADVERSION=7,
MSIDBERROR_BADCASE=8,
MSIDBERROR_BADGUID=9,
MSIDBERROR_BADWILDCARD=10,
MSIDBERROR_BADIDENTIFIER=11,
MSIDBERROR_BADLANGUAGE=12,
MSIDBERROR_BADFILENAME=13,
MSIDBERROR_BADPATH=14,
MSIDBERROR_BADCONDITION=15,
MSIDBERROR_BADFORMATTED=16,
MSIDBERROR_BADTEMPLATE=17,
MSIDBERROR_BADDEFAULTDIR=18,
MSIDBERROR_BADREGPATH=19,
MSIDBERROR_BADCUSTOMSOURCE=20,
MSIDBERROR_BADPROPERTY=21,
MSIDBERROR_MISSINGDATA=22,
MSIDBERROR_BADCATEGORY=23,
MSIDBERROR_BADKEYTABLE=24,
MSIDBERROR_BADMAXMINVALUES=25,
MSIDBERROR_BADCABINET=26,
MSIDBERROR_BADSHORTCUT=27,
MSIDBERROR_STRINGOVERFLOW=28,
MSIDBERROR_BADLOCALIZEATTRIB=29 
} MSIDBERROR;
typedef enum tagMSIRUNMODE
{
MSIRUNMODE_ADMIN=0,
MSIRUNMODE_ADVERTISE=1,
MSIRUNMODE_MAINTENANCE=2,
MSIRUNMODE_ROLLBACKENABLED=3,
MSIRUNMODE_LOGENABLED=4,
MSIRUNMODE_OPERATIONS=5,
MSIRUNMODE_REBOOTATEND=6,
MSIRUNMODE_REBOOTNOW=7,
MSIRUNMODE_CABINET=8,
MSIRUNMODE_SOURCESHORTNAMES= 9,
MSIRUNMODE_TARGETSHORTNAMES= 10,
MSIRUNMODE_RESERVED11=11,
MSIRUNMODE_WINDOWS9X=12,
MSIRUNMODE_ZAWENABLED=13,
MSIRUNMODE_RESERVED14=14,
MSIRUNMODE_RESERVED15=15,
MSIRUNMODE_SCHEDULED=16,
MSIRUNMODE_ROLLBACK=17,
MSIRUNMODE_COMMIT=18,
} MSIRUNMODE;
#define INSTALLMESSAGE_TYPEMASK=0xff000000
typedef enum tagMSITRANSFORM_ERROR
{
MSITRANSFORM_ERROR_ADDEXISTINGROW=1,
MSITRANSFORM_ERROR_DELMISSINGROW=2,
MSITRANSFORM_ERROR_ADDEXISTINGTABLE=4,
MSITRANSFORM_ERROR_DELMISSINGTABLE=8,
MSITRANSFORM_ERROR_UPDATEMISSINGROW=16,
MSITRANSFORM_ERROR_CHANGECODEPAGE=32,
MSITRANSFORM_ERROR_VIEWTRANSFORM=256,
} MSITRANSFORM_ERROR;
typedef enum tagMSITRANSFORM_VALIDATE
{
MSITRANSFORM_VALIDATE_LANGUAGE=1,
MSITRANSFORM_VALIDATE_PRODUCT=2,
MSITRANSFORM_VALIDATE_PLATFORM=4,
MSITRANSFORM_VALIDATE_MAJORVERSION=8,
MSITRANSFORM_VALIDATE_MINORVERSION=16,
MSITRANSFORM_VALIDATE_UPDATEVERSION=32,
MSITRANSFORM_VALIDATE_NEWLESSBASEVERSION=64,
MSITRANSFORM_VALIDATE_NEWLESSEQUALBASEVERSION=128,
MSITRANSFORM_VALIDATE_NEWEQUALBASEVERSION=256,
MSITRANSFORM_VALIDATE_NEWGREATEREQUALBASEVERSION=512,
MSITRANSFORM_VALIDATE_NEWGREATERBASEVERSION=1024,
MSITRANSFORM_VALIDATE_UPGRADECODE=2048,
} MSITRANSFORM_VALIDATE;
UINT WINAPI MsiDatabaseOpenViewA(MSIHANDLE ,LPCSTR ,MSIHANDLE* phView); 
UINT WINAPI MsiDatabaseOpenViewW(MSIHANDLE ,LPCWSTR ,MSIHANDLE* phView); 
#ifdef UNICODE
#define MsiDatabaseOpenView MsiDatabaseOpenViewW
#else
#define MsiDatabaseOpenView MsiDatabaseOpenViewA
#endif 
MSIDBERROR WINAPI MsiViewGetErrorA(MSIHANDLE ,LPSTR ,DWORD* pcchBuf);	
MSIDBERROR WINAPI MsiViewGetErrorW(MSIHANDLE ,LPWSTR ,DWORD* pcchBuf);	
#ifdef UNICODE
#define MsiViewGetError MsiViewGetErrorW
#else
#define MsiViewGetError MsiViewGetErrorA
#endif 
UINT WINAPI MsiViewExecute(MSIHANDLE ,MSIHANDLE ); 
UINT WINAPI MsiViewFetch(MSIHANDLE ,MSIHANDLE *); 
UINT WINAPI MsiViewModify(MSIHANDLE ,MSIMODIFY ,MSIHANDLE ); 
UINT WINAPI MsiViewGetColumnInfo(MSIHANDLE ,MSICOLINFO ,MSIHANDLE *); 
UINT WINAPI MsiViewClose(MSIHANDLE );
UINT WINAPI MsiDatabaseGetPrimaryKeysA(MSIHANDLE ,LPCSTR ,MSIHANDLE *); 
UINT WINAPI MsiDatabaseGetPrimaryKeysW(MSIHANDLE ,LPCWSTR ,MSIHANDLE *); 
#ifdef UNICODE
#define MsiDatabaseGetPrimaryKeys MsiDatabaseGetPrimaryKeysW
#else
#define MsiDatabaseGetPrimaryKeys MsiDatabaseGetPrimaryKeysA
#endif 
MSICONDITION WINAPI MsiDatabaseIsTablePersistentA(MSIHANDLE ,LPCSTR ); 
MSICONDITION WINAPI MsiDatabaseIsTablePersistentW(MSIHANDLE ,LPCWSTR ); 
#ifdef UNICODE
#define MsiDatabaseIsTablePersistent MsiDatabaseIsTablePersistentW
#else
#define MsiDatabaseIsTablePersistent MsiDatabaseIsTablePersistentA
#endif 
UINT WINAPI MsiGetSummaryInformationA(MSIHANDLE ,LPCSTR ,UINT ,MSIHANDLE *); 
UINT WINAPI MsiGetSummaryInformationW(MSIHANDLE ,LPCWSTR ,UINT ,MSIHANDLE *); 
#ifdef UNICODE
#define MsiGetSummaryInformation MsiGetSummaryInformationW
#else
#define MsiGetSummaryInformation MsiGetSummaryInformationA
#endif 
UINT WINAPI MsiSummaryInfoGetPropertyCount(MSIHANDLE ,UINT *); 
UINT WINAPI MsiSummaryInfoSetPropertyA(MSIHANDLE ,UINT ,UINT ,INT ,FILETIME *,LPCSTR ); 
UINT WINAPI MsiSummaryInfoSetPropertyW(MSIHANDLE ,UINT ,UINT ,INT ,FILETIME *,LPCWSTR ); 
#ifdef UNICODE
#define MsiSummaryInfoSetProperty MsiSummaryInfoSetPropertyW
#else
#define MsiSummaryInfoSetProperty MsiSummaryInfoSetPropertyA
#endif 
UINT WINAPI MsiSummaryInfoGetPropertyA(MSIHANDLE ,UINT ,UINT *,INT *,FILETIME *,LPSTR ,DWORD *); 
UINT WINAPI MsiSummaryInfoGetPropertyW(MSIHANDLE ,UINT ,UINT *,INT *,FILETIME *,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiSummaryInfoGetProperty MsiSummaryInfoGetPropertyW
#else
#define MsiSummaryInfoGetProperty MsiSummaryInfoGetPropertyA
#endif 
UINT WINAPI MsiSummaryInfoPersist(MSIHANDLE );
UINT WINAPI MsiOpenDatabaseA(LPCSTR ,LPCSTR ,MSIHANDLE* phDatabase); 
UINT WINAPI MsiOpenDatabaseW(LPCWSTR ,LPCWSTR ,MSIHANDLE* phDatabase); 
#ifdef UNICODE
#define MsiOpenDatabase MsiOpenDatabaseW
#else
#define MsiOpenDatabase MsiOpenDatabaseA
#endif 
UINT WINAPI MsiDatabaseImportA(MSIHANDLE ,LPCSTR ,LPCSTR ); 
UINT WINAPI MsiDatabaseImportW(MSIHANDLE ,LPCWSTR ,LPCWSTR ); 
#ifdef UNICODE
#define MsiDatabaseImport MsiDatabaseImportW
#else
#define MsiDatabaseImport MsiDatabaseImportA
#endif 
UINT WINAPI MsiDatabaseExportA(MSIHANDLE ,LPCSTR ,LPCSTR ,LPCSTR ); 
UINT WINAPI MsiDatabaseExportW(MSIHANDLE ,LPCWSTR ,LPCWSTR ,LPCWSTR ); 
#ifdef UNICODE
#define MsiDatabaseExport MsiDatabaseExportW
#else
#define MsiDatabaseExport MsiDatabaseExportA
#endif 
UINT WINAPI MsiDatabaseMergeA(MSIHANDLE ,MSIHANDLE ,LPCSTR ); 
UINT WINAPI MsiDatabaseMergeW(MSIHANDLE ,MSIHANDLE ,LPCWSTR ); 
#ifdef UNICODE
#define MsiDatabaseMerge MsiDatabaseMergeW
#else
#define MsiDatabaseMerge MsiDatabaseMergeA
#endif 
UINT WINAPI MsiDatabaseGenerateTransformA(MSIHANDLE ,MSIHANDLE ,LPCSTR ,int ,int ); 
UINT WINAPI MsiDatabaseGenerateTransformW(MSIHANDLE ,MSIHANDLE ,LPCWSTR ,int ,int ); 
#ifdef UNICODE
#define MsiDatabaseGenerateTransform MsiDatabaseGenerateTransformW
#else
#define MsiDatabaseGenerateTransform MsiDatabaseGenerateTransformA
#endif 
UINT WINAPI MsiDatabaseApplyTransformA(MSIHANDLE ,LPCSTR ,int ); 
UINT WINAPI MsiDatabaseApplyTransformW(MSIHANDLE ,LPCWSTR ,int ); 
#ifdef UNICODE
#define MsiDatabaseApplyTransform MsiDatabaseApplyTransformW
#else
#define MsiDatabaseApplyTransform MsiDatabaseApplyTransformA
#endif 
UINT WINAPI MsiCreateTransformSummaryInfoA(MSIHANDLE ,MSIHANDLE ,LPCSTR ,int ,int ); 
UINT WINAPI MsiCreateTransformSummaryInfoW(MSIHANDLE ,MSIHANDLE ,LPCWSTR ,int ,int ); 
#ifdef UNICODE
#define MsiCreateTransformSummaryInfo MsiCreateTransformSummaryInfoW
#else
#define MsiCreateTransformSummaryInfo MsiCreateTransformSummaryInfoA
#endif 
UINT WINAPI MsiDatabaseCommit(MSIHANDLE );
MSIDBSTATE WINAPI MsiGetDatabaseState(MSIHANDLE );
MSIHANDLE WINAPI MsiCreateRecord(UINT ); 
BOOL WINAPI MsiRecordIsNull(MSIHANDLE ,UINT );
UINT WINAPI MsiRecordDataSize(MSIHANDLE ,UINT );
UINT WINAPI MsiRecordSetInteger(MSIHANDLE ,UINT ,int );
UINT WINAPI MsiRecordSetStringA(MSIHANDLE ,UINT ,LPCSTR );
UINT WINAPI MsiRecordSetStringW(MSIHANDLE ,UINT ,LPCWSTR );
#ifdef UNICODE
#define MsiRecordSetString MsiRecordSetStringW
#else
#define MsiRecordSetString MsiRecordSetStringA
#endif 
int WINAPI MsiRecordGetInteger(MSIHANDLE ,UINT );
UINT WINAPI MsiRecordGetStringA(MSIHANDLE ,UINT ,LPSTR ,DWORD *); 
UINT WINAPI MsiRecordGetStringW(MSIHANDLE ,UINT ,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiRecordGetString MsiRecordGetStringW
#else
#define MsiRecordGetString MsiRecordGetStringA
#endif 
UINT WINAPI MsiRecordGetFieldCount(MSIHANDLE );
UINT WINAPI MsiRecordSetStreamA(MSIHANDLE ,UINT ,LPCSTR ); 
UINT WINAPI MsiRecordSetStreamW(MSIHANDLE ,UINT ,LPCWSTR ); 
#ifdef UNICODE
#define MsiRecordSetStream MsiRecordSetStreamW
#else
#define MsiRecordSetStream MsiRecordSetStreamA
#endif 
UINT WINAPI MsiRecordReadStream(MSIHANDLE ,UINT ,char *,DWORD *); 
UINT WINAPI MsiRecordClearData(MSIHANDLE );
MSIHANDLE WINAPI MsiGetActiveDatabase(MSIHANDLE ); 
UINT WINAPI MsiSetPropertyA(MSIHANDLE ,LPCSTR ,LPCSTR ); 
UINT WINAPI MsiSetPropertyW(MSIHANDLE ,LPCWSTR ,LPCWSTR ); 
#ifdef UNICODE
#define MsiSetProperty MsiSetPropertyW
#else
#define MsiSetProperty MsiSetPropertyA
#endif 
UINT WINAPI MsiGetPropertyA(MSIHANDLE ,LPCSTR ,LPSTR ,DWORD *); 
UINT WINAPI MsiGetPropertyW(MSIHANDLE ,LPCWSTR ,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiGetProperty MsiGetPropertyW
#else
#define MsiGetProperty MsiGetPropertyA
#endif 
LANGID WINAPI MsiGetLanguage(MSIHANDLE );
BOOL WINAPI MsiGetMode(MSIHANDLE ,MSIRUNMODE ); 
UINT WINAPI MsiSetMode(MSIHANDLE ,MSIRUNMODE ,BOOL ); 
UINT WINAPI MsiFormatRecordA(MSIHANDLE ,MSIHANDLE ,LPSTR ,DWORD *); 
UINT WINAPI MsiFormatRecordW(MSIHANDLE ,MSIHANDLE ,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiFormatRecord MsiFormatRecordW
#else
#define MsiFormatRecord MsiFormatRecordA
#endif 
UINT WINAPI MsiDoActionA(MSIHANDLE ,LPCSTR ); 
UINT WINAPI MsiDoActionW(MSIHANDLE ,LPCWSTR ); 
#ifdef UNICODE
#define MsiDoAction MsiDoActionW
#else
#define MsiDoAction MsiDoActionA
#endif 
UINT WINAPI MsiSequenceA(MSIHANDLE ,LPCSTR ,INT ); 
UINT WINAPI MsiSequenceW(MSIHANDLE ,LPCWSTR ,INT ); 
#ifdef UNICODE
#define MsiSequence MsiSequenceW
#else
#define MsiSequence MsiSequenceA
#endif 
int WINAPI MsiProcessMessage(MSIHANDLE ,INSTALLMESSAGE ,MSIHANDLE ); 
MSICONDITION WINAPI MsiEvaluateConditionA(MSIHANDLE ,LPCSTR );
MSICONDITION WINAPI MsiEvaluateConditionW(MSIHANDLE ,LPCWSTR );
#ifdef UNICODE
#define MsiEvaluateCondition MsiEvaluateConditionW
#else
#define MsiEvaluateCondition MsiEvaluateConditionA
#endif 
UINT WINAPI MsiGetFeatureStateA(MSIHANDLE ,LPCSTR ,INSTALLSTATE *,INSTALLSTATE *); 
UINT WINAPI MsiGetFeatureStateW(MSIHANDLE ,LPCWSTR ,INSTALLSTATE *,INSTALLSTATE *); 
#ifdef UNICODE
#define MsiGetFeatureState MsiGetFeatureStateW
#else
#define MsiGetFeatureState MsiGetFeatureStateA
#endif 
UINT WINAPI MsiSetFeatureStateA(MSIHANDLE ,LPCSTR ,INSTALLSTATE ); 
UINT WINAPI MsiSetFeatureStateW(MSIHANDLE ,LPCWSTR ,INSTALLSTATE ); 
#ifdef UNICODE
#define MsiSetFeatureState MsiSetFeatureStateW
#else
#define MsiSetFeatureState MsiSetFeatureStateA
#endif 
#if (_WIN32_MSI >= 110)
UINT WINAPI MsiSetFeatureAttributesA(MSIHANDLE ,LPCSTR ,DWORD ); 
UINT WINAPI MsiSetFeatureAttributesW(MSIHANDLE ,LPCWSTR ,DWORD ); 
#ifdef UNICODE
#define MsiSetFeatureAttributes MsiSetFeatureAttributesW
#else
#define MsiSetFeatureAttributes MsiSetFeatureAttributesA
#endif 
#endif 
UINT WINAPI MsiGetComponentStateA(MSIHANDLE ,LPCSTR ,INSTALLSTATE *,INSTALLSTATE *); 
UINT WINAPI MsiGetComponentStateW(MSIHANDLE ,LPCWSTR ,INSTALLSTATE *,INSTALLSTATE *); 
#ifdef UNICODE
#define MsiGetComponentState MsiGetComponentStateW
#else
#define MsiGetComponentState MsiGetComponentStateA
#endif 
UINT WINAPI MsiSetComponentStateA(MSIHANDLE ,LPCSTR ,INSTALLSTATE ); 
UINT WINAPI MsiSetComponentStateW(MSIHANDLE ,LPCWSTR ,INSTALLSTATE ); 
#ifdef UNICODE
#define MsiSetComponentState MsiSetComponentStateW
#else
#define MsiSetComponentState MsiSetComponentStateA
#endif 
UINT WINAPI MsiGetFeatureCostA(MSIHANDLE ,LPCSTR ,MSICOSTTREE ,INSTALLSTATE ,INT *); 
UINT WINAPI MsiGetFeatureCostW(MSIHANDLE ,LPCWSTR ,MSICOSTTREE ,INSTALLSTATE ,INT *); 
#ifdef UNICODE
#define MsiGetFeatureCost MsiGetFeatureCostW
#else
#define MsiGetFeatureCost MsiGetFeatureCostA
#endif 
#if (_WIN32_MSI >= 150)
UINT WINAPI MsiEnumComponentCostsA(MSIHANDLE ,LPCSTR ,DWORD ,INSTALLSTATE ,LPSTR ,DWORD *,INT *,INT *); 
UINT WINAPI MsiEnumComponentCostsW(MSIHANDLE ,LPCWSTR ,DWORD ,INSTALLSTATE ,LPWSTR ,DWORD *,INT *,INT *); 
#ifdef UNICODE
#define MsiEnumComponentCosts MsiEnumComponentCostsW
#else
#define MsiEnumComponentCosts MsiEnumComponentCostsA
#endif 
#endif 
UINT WINAPI MsiSetInstallLevel(MSIHANDLE ,int );
UINT WINAPI MsiGetFeatureValidStatesA(MSIHANDLE ,LPCSTR ,DWORD *);
UINT WINAPI MsiGetFeatureValidStatesW(MSIHANDLE ,LPCWSTR ,DWORD *);
#ifdef UNICODE
#define MsiGetFeatureValidStates MsiGetFeatureValidStatesW
#else
#define MsiGetFeatureValidStates MsiGetFeatureValidStatesA
#endif 
UINT WINAPI MsiGetSourcePathA(MSIHANDLE ,LPCSTR ,LPSTR ,DWORD *); 
UINT WINAPI MsiGetSourcePathW(MSIHANDLE ,LPCWSTR ,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiGetSourcePath MsiGetSourcePathW
#else
#define MsiGetSourcePath MsiGetSourcePathA
#endif 
UINT WINAPI MsiGetTargetPathA(MSIHANDLE ,LPCSTR ,LPSTR ,DWORD *); 
UINT WINAPI MsiGetTargetPathW(MSIHANDLE ,LPCWSTR ,LPWSTR ,DWORD *); 
#ifdef UNICODE
#define MsiGetTargetPath MsiGetTargetPathW
#else
#define MsiGetTargetPath MsiGetTargetPathA
#endif 
UINT WINAPI MsiSetTargetPathA(MSIHANDLE ,LPCSTR ,LPCSTR ); 
UINT WINAPI MsiSetTargetPathW(MSIHANDLE ,LPCWSTR ,LPCWSTR ); 
#ifdef UNICODE
#define MsiSetTargetPath MsiSetTargetPathW
#else
#define MsiSetTargetPath MsiSetTargetPathA
#endif 
UINT WINAPI MsiVerifyDiskSpace(MSIHANDLE );
UINT WINAPI MsiEnableUIPreview(MSIHANDLE ,MSIHANDLE* phPreview); 
UINT WINAPI MsiPreviewDialogA(MSIHANDLE ,LPCSTR ); 
UINT WINAPI MsiPreviewDialogW(MSIHANDLE ,LPCWSTR ); 
#ifdef UNICODE
#define MsiPreviewDialog MsiPreviewDialogW
#else
#define MsiPreviewDialog MsiPreviewDialogA
#endif 
UINT WINAPI MsiPreviewBillboardA(MSIHANDLE ,LPCSTR ,LPCSTR ); 
UINT WINAPI MsiPreviewBillboardW(MSIHANDLE ,LPCWSTR ,LPCWSTR ); 
#ifdef UNICODE
#define MsiPreviewBillboard MsiPreviewBillboardW
#else
#define MsiPreviewBillboard MsiPreviewBillboardA
#endif 
MSIHANDLE WINAPI MsiGetLastErrorRecord(); 
#endif 
