#ifndef __ntdsapi_h__
#define __ntdsapi_h__
#ifndef __windows_h__
#include "windows.h"
#endif
#include "rpc.h"
#include "winioctl.h"
#pragma once
#include "schedule.h"
#define NTDSAPI
#define DS_BEHAVIOR_WIN2000 0
#define DS_BEHAVIOR_WIN2003_WITH_MIXED_DOMAINS 1
#define DS_BEHAVIOR_WIN2003 2
#define DS_DEFAULT_LOCALE (MAKELCID(MAKELANGID(LANG_ENGLISH,SUBLANG_ENGLISH_US), SORT_DEFAULT))
#define DS_DEFAULT_LOCALE_COMPARE_FLAGS (NORM_IGNORECASE | NORM_IGNOREKANATYPE | NORM_IGNORENONSPACE | NORM_IGNOREWIDTH | SORT_STRINGSORT)
#define DS_SYNCED_EVENT_NAME "NTDSInitialSyncsCompleted"
#define DS_SYNCED_EVENT_NAME_W L"NTDSInitialSyncsCompleted"
#ifndef _DS_CONTROL_BITS_DEFINED_
#define _DS_CONTROL_BITS_DEFINED_
#define ACTRL_DS_OPEN 0
#define ACTRL_DS_CREATE_CHILD 1
#define ACTRL_DS_DELETE_CHILD 2
#define ACTRL_DS_LIST 4
#define ACTRL_DS_SELF 8
#define ACTRL_DS_READ_PROP 16
#define ACTRL_DS_WRITE_PROP 32
#define ACTRL_DS_DELETE_TREE 64
#define ACTRL_DS_LIST_OBJECT 128
#define ACTRL_DS_CONTROL_ACCESS 256
#define DS_GENERIC_READ ((STANDARD_RIGHTS_READ) | (ACTRL_DS_LIST) |  (ACTRL_DS_READ_PROP) |  (ACTRL_DS_LIST_OBJECT))
#define DS_GENERIC_EXECUTE ((STANDARD_RIGHTS_EXECUTE) | (ACTRL_DS_LIST))
#define DS_GENERIC_WRITE ((STANDARD_RIGHTS_WRITE) | (ACTRL_DS_SELF) |  (ACTRL_DS_WRITE_PROP))
#define DS_GENERIC_ALL ((STANDARD_RIGHTS_REQUIRED) | (ACTRL_DS_CREATE_CHILD) |  (ACTRL_DS_DELETE_CHILD) |  (ACTRL_DS_DELETE_TREE) |  (ACTRL_DS_READ_PROP) |  (ACTRL_DS_WRITE_PROP) |  (ACTRL_DS_LIST) |  (ACTRL_DS_LIST_OBJECT) |  (ACTRL_DS_CONTROL_ACCESS) |  (ACTRL_DS_SELF))
#endif
typedef enum
{
DS_UNKNOWN_NAME=0,
DS_FQDN_1779_NAME=1,
DS_NT4_ACCOUNT_NAME=2,
DS_DISPLAY_NAME=3,
DS_UNIQUE_ID_NAME=6,
DS_CANONICAL_NAME=7,
DS_USER_PRINCIPAL_NAME=8,
DS_CANONICAL_NAME_EX=9,
DS_SERVICE_PRINCIPAL_NAME=10,
DS_SID_OR_SID_HISTORY_NAME=11,
DS_DNS_DOMAIN_NAME=12
} DS_NAME_FORMAT;
#define DS_DOMAIN_SIMPLE_NAME DS_USER_PRINCIPAL_NAME
#define DS_ENTERPRISE_SIMPLE_NAME DS_USER_PRINCIPAL_NAME
typedef enum
{
DS_NAME_NO_FLAGS=0,
DS_NAME_FLAG_SYNTACTICAL_ONLY=1,
DS_NAME_FLAG_EVAL_AT_DC=2,
DS_NAME_FLAG_GCVERIFY=4,
DS_NAME_FLAG_TRUST_REFERRAL=8
} DS_NAME_FLAGS;
typedef enum
{
DS_NAME_NO_ERROR=0,
DS_NAME_ERROR_RESOLVING=1,
DS_NAME_ERROR_NOT_FOUND=2,
DS_NAME_ERROR_NOT_UNIQUE=3,
DS_NAME_ERROR_NO_MAPPING=4,
DS_NAME_ERROR_DOMAIN_ONLY=5,
DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING=6,
DS_NAME_ERROR_TRUST_REFERRAL=7
} DS_NAME_ERROR;
#define DS_NAME_LEGAL_FLAGS (DS_NAME_FLAG_SYNTACTICAL_ONLY)
typedef enum {
DS_SPN_DNS_HOST=0,
DS_SPN_DN_HOST=1,
DS_SPN_NB_HOST=2,
DS_SPN_DOMAIN=3,
DS_SPN_NB_DOMAIN=4,
DS_SPN_SERVICE=5
} DS_SPN_NAME_TYPE;
typedef enum { 
DS_SPN_ADD_SPN_OP=0,
DS_SPN_REPLACE_SPN_OP=1,
DS_SPN_DELETE_SPN_OP=2 
} DS_SPN_WRITE_OP;
typedef struct
{
DWORD status; 
#ifdef MIDL_PASS
[string,unique] CHAR *pDomain; 
[string,unique] CHAR *pName; 
#else
LPSTR pDomain; 
LPSTR pName; 
#endif
} DS_NAME_RESULT_ITEMA,*PDS_NAME_RESULT_ITEMA;
typedef struct
{
DWORD cItems; 
#ifdef MIDL_PASS
[size_is(cItems)] PDS_NAME_RESULT_ITEMA rItems;
#else
PDS_NAME_RESULT_ITEMA rItems; 
#endif
} DS_NAME_RESULTA,*PDS_NAME_RESULTA;
typedef struct
{
DWORD status; 
#ifdef MIDL_PASS
[string,unique] WCHAR *pDomain; 
[string,unique] WCHAR *pName; 
#else
LPWSTR pDomain; 
LPWSTR pName; 
#endif
} DS_NAME_RESULT_ITEMW,*PDS_NAME_RESULT_ITEMW;
typedef struct
{
DWORD cItems; 
#ifdef MIDL_PASS
[size_is(cItems)] PDS_NAME_RESULT_ITEMW rItems;
#else
PDS_NAME_RESULT_ITEMW rItems; 
#endif
} DS_NAME_RESULTW,*PDS_NAME_RESULTW;
#ifdef UNICODE
#define DS_NAME_RESULT DS_NAME_RESULTW
#define PDS_NAME_RESULT PDS_NAME_RESULTW
#define DS_NAME_RESULT_ITEM DS_NAME_RESULT_ITEMW
#define PDS_NAME_RESULT_ITEM PDS_NAME_RESULT_ITEMW
#else
#define DS_NAME_RESULT DS_NAME_RESULTA
#define PDS_NAME_RESULT PDS_NAME_RESULTA
#define DS_NAME_RESULT_ITEM DS_NAME_RESULT_ITEMA
#define PDS_NAME_RESULT_ITEM PDS_NAME_RESULT_ITEMA
#endif
#define NTDSAPI_BIND_ALLOW_DELEGATION	1
#define DS_REPSYNC_ASYNCHRONOUS_OPERATION 1
#define DS_REPSYNC_WRITEABLE 2
#define DS_REPSYNC_PERIODIC 4
#define DS_REPSYNC_INTERSITE_MESSAGING 8
#define DS_REPSYNC_ALL_SOURCES 16
#define DS_REPSYNC_FULL 32
#define DS_REPSYNC_URGENT 64
#define DS_REPSYNC_NO_DISCARD 128
#define DS_REPSYNC_FORCE 256
#define DS_REPSYNC_ADD_REFERENCE 512
#define DS_REPSYNC_NEVER_COMPLETED 1024
#define DS_REPSYNC_TWO_WAY 2048
#define DS_REPSYNC_NEVER_NOTIFY 4096
#define DS_REPSYNC_INITIAL 0x2000
#define DS_REPSYNC_USE_COMPRESSION 0x4000
#define DS_REPSYNC_ABANDONED 0x8000
#define DS_REPSYNC_INITIAL_IN_PROGRESS 0x10000
#define DS_REPSYNC_PARTIAL_ATTRIBUTE_SET 0x20000
#define DS_REPSYNC_REQUEUE 0x40000
#define DS_REPSYNC_NOTIFICATION 0x80000
#define DS_REPSYNC_ASYNCHRONOUS_REPLICA 0x100000
#define DS_REPSYNC_CRITICAL 0x200000
#define DS_REPSYNC_FULL_IN_PROGRESS 0x400000
#define DS_REPSYNC_PREEMPTED 0x800000
#define DS_REPADD_ASYNCHRONOUS_OPERATION 1
#define DS_REPADD_WRITEABLE 2
#define DS_REPADD_INITIAL 4
#define DS_REPADD_PERIODIC 8
#define DS_REPADD_INTERSITE_MESSAGING 16
#define DS_REPADD_ASYNCHRONOUS_REPLICA 32
#define DS_REPADD_DISABLE_NOTIFICATION 64
#define DS_REPADD_DISABLE_PERIODIC 128
#define DS_REPADD_USE_COMPRESSION 256
#define DS_REPADD_NEVER_NOTIFY 512
#define DS_REPADD_TWO_WAY 1024
#define DS_REPADD_CRITICAL 2048
#define DS_REPDEL_ASYNCHRONOUS_OPERATION 1
#define DS_REPDEL_WRITEABLE 2
#define DS_REPDEL_INTERSITE_MESSAGING 4
#define DS_REPDEL_IGNORE_ERRORS 8
#define DS_REPDEL_LOCAL_ONLY 16
#define DS_REPDEL_NO_SOURCE 32
#define DS_REPDEL_REF_OK 64
#define DS_REPMOD_ASYNCHRONOUS_OPERATION 1
#define DS_REPMOD_WRITEABLE 2
#define DS_REPMOD_UPDATE_FLAGS 1
#define DS_REPMOD_UPDATE_ADDRESS 2
#define DS_REPMOD_UPDATE_SCHEDULE 4
#define DS_REPMOD_UPDATE_RESULT 8
#define DS_REPMOD_UPDATE_TRANSPORT 16
#define DS_REPUPD_ASYNCHRONOUS_OPERATION 1
#define DS_REPUPD_WRITEABLE 2
#define DS_REPUPD_ADD_REFERENCE 4
#define DS_REPUPD_DELETE_REFERENCE 8
#define DS_INSTANCETYPE_IS_NC_HEAD 1
#define DS_INSTANCETYPE_NC_IS_WRITEABLE 4
#define DS_INSTANCETYPE_NC_COMING 16
#define DS_INSTANCETYPE_NC_GOING 32
#define NTDSDSA_OPT_IS_GC (1 << 0) 
#define NTDSDSA_OPT_DISABLE_INBOUND_REPL (1 << 1) 
#define NTDSDSA_OPT_DISABLE_OUTBOUND_REPL (1 << 2) 
#define NTDSDSA_OPT_DISABLE_NTDSCONN_XLATE (1 << 3) 
#define NTDSCONN_OPT_IS_GENERATED (1 << 0) 
#define NTDSCONN_OPT_TWOWAY_SYNC (1 << 1) 
#define NTDSCONN_OPT_OVERRIDE_NOTIFY_DEFAULT (1 << 2) 
#define NTDSCONN_OPT_USE_NOTIFY (1 << 3) 
#define NTDSCONN_OPT_DISABLE_INTERSITE_COMPRESSION (1 << 4)
#define NTDSCONN_OPT_USER_OWNED_SCHEDULE (1 << 5)
#define NTDSCONN_KCC_NO_REASON (0) 
#define NTDSCONN_KCC_GC_TOPOLOGY (1 << 0) 
#define NTDSCONN_KCC_RING_TOPOLOGY (1 << 1) 
#define NTDSCONN_KCC_MINIMIZE_HOPS_TOPOLOGY (1 << 2) 
#define NTDSCONN_KCC_STALE_SERVERS_TOPOLOGY (1 << 3) 
#define NTDSCONN_KCC_OSCILLATING_CONNECTION_TOPOLOGY (1 << 4) 
#define NTDSCONN_KCC_INTERSITE_GC_TOPOLOGY (1 << 5) 
#define NTDSCONN_KCC_INTERSITE_TOPOLOGY (1 << 6) 
#define NTDSCONN_KCC_SERVER_FAILOVER_TOPOLOGY (1 << 7) 
#define NTDSCONN_KCC_SITE_FAILOVER_TOPOLOGY (1 << 8) 
#define NTDSCONN_KCC_REDUNDANT_SERVER_TOPOLOGY (1 << 9) 
#define FRSCONN_PRIORITY_MASK	0x70000000
#define FRSCONN_MAX_PRIORITY	8
#define NTDSCONN_OPT_IGNORE_SCHEDULE_MASK 0x80000000
#define	NTDSCONN_IGNORE_SCHEDULE(_options_)\
(((_options_) & NTDSCONN_OPT_IGNORE_SCHEDULE_MASK) >> 31)
#define	FRSCONN_GET_PRIORITY(_options_) \
(((((_options_) & FRSCONN_PRIORITY_MASK) >> 28) != 0) ? (((_options_) & FRSCONN_PRIORITY_MASK) >> 28) :  FRSCONN_MAX_PRIORITY  )
#define NTDSSETTINGS_OPT_IS_AUTO_TOPOLOGY_DISABLED (1 << 0) 
#define NTDSSETTINGS_OPT_IS_TOPL_CLEANUP_DISABLED (1 << 1) 
#define NTDSSETTINGS_OPT_IS_TOPL_MIN_HOPS_DISABLED (1 << 2) 
#define NTDSSETTINGS_OPT_IS_TOPL_DETECT_STALE_DISABLED (1 << 3) 
#define NTDSSETTINGS_OPT_IS_INTER_SITE_AUTO_TOPOLOGY_DISABLED (1 << 4) 
#define NTDSSETTINGS_OPT_IS_GROUP_CACHING_ENABLED (1 << 5) 
#define NTDSSETTINGS_OPT_FORCE_KCC_WHISTLER_BEHAVIOR (1 << 6) 
#define NTDSSETTINGS_OPT_FORCE_KCC_W2K_ELECTION (1 << 7) 
#define NTDSSETTINGS_OPT_IS_RAND_BH_SELECTION_DISABLED (1 << 8) 
#define NTDSSETTINGS_OPT_IS_SCHEDULE_HASHING_ENABLED (1 << 9) 
#define NTDSSETTINGS_OPT_IS_REDUNDANT_SERVER_TOPOLOGY_ENABLED (1 << 10) 
#define NTDSSETTINGS_DEFAULT_SERVER_REDUNDANCY 2
#define NTDSTRANSPORT_OPT_IGNORE_SCHEDULES (1 << 0) 
#define NTDSTRANSPORT_OPT_BRIDGES_REQUIRED (1 << 1) 
#define NTDSSITECONN_OPT_USE_NOTIFY (1 << 0) 
#define NTDSSITECONN_OPT_TWOWAY_SYNC (1 << 1) 
#define NTDSSITECONN_OPT_DISABLE_COMPRESSION (1 << 2)
#define NTDSSITELINK_OPT_USE_NOTIFY (1 << 0) 
#define NTDSSITELINK_OPT_TWOWAY_SYNC (1 << 1) 
#define NTDSSITELINK_OPT_DISABLE_COMPRESSION (1 << 2)
#define GUID_USERS_CONTAINER_A "a9d1ca15768811d1aded00c04fd8d5cd"
#define GUID_COMPUTRS_CONTAINER_A "aa312825768811d1aded00c04fd8d5cd"
#define GUID_SYSTEMS_CONTAINER_A "ab1d30f3768811d1aded00c04fd8d5cd"
#define GUID_DOMAIN_CONTROLLERS_CONTAINER_A "a361b2ffffd211d1aa4b00c04fd7d83a"
#define GUID_INFRASTRUCTURE_CONTAINER_A "2fbac1870ade11d297c400c04fd8d5cd"
#define GUID_DELETED_OBJECTS_CONTAINER_A "18e2ea80684f11d2b9aa00c04f79f805"
#define GUID_LOSTANDFOUND_CONTAINER_A "ab8153b7768811d1aded00c04fd8d5cd"
#define GUID_FOREIGNSECURITYPRINCIPALS_CONTAINER_A "22b70c67d56e4efb91e9300fca3dc1aa"
#define GUID_PROGRAM_DATA_CONTAINER_A "09460c08ae1e4a4ea0f64aee7daa1e5a"
#define GUID_MICROSOFT_PROGRAM_DATA_CONTAINER_A "f4be92a4c777485e878e9421d53087db" 
#define GUID_NTDS_QUOTAS_CONTAINER_A "6227f0af1fc2410d8e3bb10615bb5b0f" 
#define GUID_USERS_CONTAINER_W L"a9d1ca15768811d1aded00c04fd8d5cd"
#define GUID_COMPUTRS_CONTAINER_W L"aa312825768811d1aded00c04fd8d5cd"
#define GUID_SYSTEMS_CONTAINER_W L"ab1d30f3768811d1aded00c04fd8d5cd"
#define GUID_DOMAIN_CONTROLLERS_CONTAINER_W L"a361b2ffffd211d1aa4b00c04fd7d83a"
#define GUID_INFRASTRUCTURE_CONTAINER_W L"2fbac1870ade11d297c400c04fd8d5cd"
#define GUID_DELETED_OBJECTS_CONTAINER_W L"18e2ea80684f11d2b9aa00c04f79f805"
#define GUID_LOSTANDFOUND_CONTAINER_W L"ab8153b7768811d1aded00c04fd8d5cd"
#define GUID_FOREIGNSECURITYPRINCIPALS_CONTAINER_W L"22b70c67d56e4efb91e9300fca3dc1aa"
#define GUID_PROGRAM_DATA_CONTAINER_W L"09460c08ae1e4a4ea0f64aee7daa1e5a"
#define GUID_MICROSOFT_PROGRAM_DATA_CONTAINER_W L"f4be92a4c777485e878e9421d53087db"
#define GUID_NTDS_QUOTAS_CONTAINER_W L"6227f0af1fc2410d8e3bb10615bb5b0f" 
#define GUID_USERS_CONTAINER_BYTE "\xa9\xd1\xca\x15\x76\x88\x11\xd1\xad\xed\x00\xc0\x4f\xd8\xd5\xcd"
#define GUID_COMPUTRS_CONTAINER_BYTE "\xaa\x31\x28\x25\x76\x88\x11\xd1\xad\xed\x00\xc0\x4f\xd8\xd5\xcd"
#define GUID_SYSTEMS_CONTAINER_BYTE "\xab\x1d\x30\xf3\x76\x88\x11\xd1\xad\xed\x00\xc0\x4f\xd8\xd5\xcd"
#define GUID_DOMAIN_CONTROLLERS_CONTAINER_BYTE "\xa3\x61\xb2\xff\xff\xd2\x11\xd1\xaa\x4b\x00\xc0\x4f\xd7\xd8\x3a"
#define GUID_INFRASTRUCTURE_CONTAINER_BYTE "\x2f\xba\xc1\x87\x0a\xde\x11\xd2\x97\xc4\x00\xc0\x4f\xd8\xd5\xcd"
#define GUID_DELETED_OBJECTS_CONTAINER_BYTE "\x18\xe2\xea\x80\x68\x4f\x11\xd2\xb9\xaa\x00\xc0\x4f\x79\xf8\x05"
#define GUID_LOSTANDFOUND_CONTAINER_BYTE "\xab\x81\x53\xb7\x76\x88\x11\xd1\xad\xed\x00\xc0\x4f\xd8\xd5\xcd"
#define GUID_FOREIGNSECURITYPRINCIPALS_CONTAINER_BYTE "\x22\xb7\x0c\x67\xd5\x6e\x4e\xfb\x91\xe9\x30\x0f\xca\x3d\xc1\xaa"
#define GUID_PROGRAM_DATA_CONTAINER_BYTE "\x09\x46\x0c\x08\xae\x1e\x4a\x4e\xa0\xf6\x4a\xee\x7d\xaa\x1e\x5a"
#define GUID_MICROSOFT_PROGRAM_DATA_CONTAINER_BYTE "\xf4\xbe\x92\xa4\xc7\x77\x48\x5e\x87\x8e\x94\x21\xd5\x30\x87\xdb"
#define GUID_NTDS_QUOTAS_CONTAINER_BYTE "\x62\x27\xf0\xaf\x1f\xc2\x41\x0d\x8e\x3b\xb1\x06\x15\xbb\x5b\x0f" 
typedef enum _DS_MANGLE_FOR {
DS_MANGLE_UNKNOWN=0,
DS_MANGLE_OBJECT_RDN_FOR_DELETION,
DS_MANGLE_OBJECT_RDN_FOR_NAME_CONFLICT,
} DS_MANGLE_FOR;
DWORD WINAPI DsBindW(LPCWSTR ,LPCWSTR ,HANDLE *);
DWORD WINAPI DsBindA(LPCSTR ,LPCSTR ,HANDLE *);
#ifdef UNICODE
#define DsBind DsBindW
#else
#define DsBind DsBindA
#endif
DWORD WINAPI DsBindWithCredW(LPCWSTR ,LPCWSTR ,HANDLE ,HANDLE *);
DWORD WINAPI DsBindWithCredA(LPCSTR ,LPCSTR ,HANDLE ,HANDLE *);
#ifdef UNICODE
#define DsBindWithCred DsBindWithCredW
#else
#define DsBindWithCred DsBindWithCredA
#endif
DWORD WINAPI DsBindWithSpnW(LPCWSTR ,LPCWSTR ,HANDLE ,LPCWSTR ,HANDLE *);
NTDSAPI 
DWORD 
WINAPI 
DsBindWithSpnA(LPCSTR ,LPCSTR ,HANDLE ,LPCSTR ,HANDLE *);
#ifdef UNICODE
#define DsBindWithSpn DsBindWithSpnW
#else
#define DsBindWithSpn DsBindWithSpnA
#endif
DWORD WINAPI DsBindWithSpnExW(LPCWSTR ,LPCWSTR ,HANDLE ,LPCWSTR ,DWORD ,HANDLE *);
DWORD WINAPI DsBindWithSpnExA(LPCSTR ,LPCSTR ,HANDLE ,LPCSTR ,DWORD ,HANDLE *);
#ifdef UNICODE
#define DsBindWithSpnEx DsBindWithSpnExW
#else
#define DsBindWithSpnEx DsBindWithSpnExA
#endif
DWORD WINAPI DsBindToISTGW(LPCWSTR ,HANDLE *);
DWORD WINAPI DsBindToISTGA(LPCSTR ,HANDLE *);
#ifdef UNICODE
#define DsBindToISTG DsBindToISTGW
#else
#define DsBindToISTG DsBindToISTGA
#endif
DWORD WINAPI DsBindingSetTimeout(HANDLE ,ULONG cTimeoutSecs );
DWORD WINAPI DsUnBindW(HANDLE *); 
DWORD WINAPI DsUnBindA(HANDLE *); 
#ifdef UNICODE
#define DsUnBind DsUnBindW
#else
#define DsUnBind DsUnBindA
#endif
DWORD WINAPI DsMakePasswordCredentialsW(LPCWSTR ,LPCWSTR ,LPCWSTR ,HANDLE *pAuthIdentity );
DWORD WINAPI DsMakePasswordCredentialsA(LPCSTR ,LPCSTR ,LPCSTR ,HANDLE *pAuthIdentity );
#ifdef UNICODE
#define DsMakePasswordCredentials DsMakePasswordCredentialsW
#else
#define DsMakePasswordCredentials DsMakePasswordCredentialsA
#endif
VOID WINAPI DsFreePasswordCredentials(HANDLE AuthIdentity );
#define DsFreePasswordCredentialsW DsFreePasswordCredentials
#define DsFreePasswordCredentialsA DsFreePasswordCredentials
DWORD WINAPI DsCrackNamesW(HANDLE ,DS_NAME_FLAGS ,DS_NAME_FORMAT ,DS_NAME_FORMAT ,DWORD , const LPCWSTR *rpNames,PDS_NAME_RESULTW *); 
DWORD WINAPI DsCrackNamesA(HANDLE ,DS_NAME_FLAGS ,DS_NAME_FORMAT ,DS_NAME_FORMAT ,DWORD , const LPCSTR *rpNames,PDS_NAME_RESULTA *); 
#ifdef UNICODE
#define DsCrackNames DsCrackNamesW
#else
#define DsCrackNames DsCrackNamesA
#endif
void WINAPI DsFreeNameResultW(DS_NAME_RESULTW *); 
void WINAPI DsFreeNameResultA(DS_NAME_RESULTA *); 
#ifdef UNICODE
#define DsFreeNameResult DsFreeNameResultW
#else
#define DsFreeNameResult DsFreeNameResultA
#endif
DWORD WINAPI DsMakeSpnW(LPCWSTR ,LPCWSTR ,LPCWSTR ,USHORT ,LPCWSTR ,DWORD *,LPWSTR pszSpn );
DWORD WINAPI DsMakeSpnA(LPCSTR ,LPCSTR ,LPCSTR ,USHORT ,LPCSTR ,DWORD *,LPSTR pszSpn );
#ifdef UNICODE
#define DsMakeSpn DsMakeSpnW
#else
#define DsMakeSpn DsMakeSpnA
#endif
DWORD WINAPI DsGetSpnA(DS_SPN_NAME_TYPE ,LPCSTR ,LPCSTR ,USHORT ,USHORT ,LPCSTR *, const USHORT *pInstancePorts,DWORD *,LPSTR **prpszSpn );
DWORD WINAPI DsGetSpnW(DS_SPN_NAME_TYPE ,LPCWSTR ,LPCWSTR ,USHORT ,USHORT ,LPCWSTR *, const USHORT *pInstancePorts,DWORD *,LPWSTR **prpszSpn );
#ifdef UNICODE
#define DsGetSpn DsGetSpnW
#else
#define DsGetSpn DsGetSpnA
#endif
void WINAPI DsFreeSpnArrayA(DWORD ,LPSTR *rpszSpn );
void WINAPI DsFreeSpnArrayW(DWORD ,LPWSTR *rpszSpn );
#ifdef UNICODE
#define DsFreeSpnArray DsFreeSpnArrayW
#else
#define DsFreeSpnArray DsFreeSpnArrayA
#endif
DWORD WINAPI DsCrackSpnA(LPCSTR ,LPDWORD ,LPSTR ,LPDWORD ,LPSTR ,LPDWORD ,LPSTR ,USHORT *pInstancePort );
DWORD WINAPI DsCrackSpnW(LPCWSTR ,DWORD *,LPWSTR ,DWORD *,LPWSTR ,DWORD *,LPWSTR ,USHORT *pInstancePort );
#ifdef UNICODE
#define DsCrackSpn DsCrackSpnW
#else
#define DsCrackSpn DsCrackSpnA
#endif
DWORD WINAPI DsWriteAccountSpnA(HANDLE ,DS_SPN_WRITE_OP ,LPCSTR ,DWORD ,LPCSTR *rpszSpn );
DWORD WINAPI DsWriteAccountSpnW(HANDLE ,DS_SPN_WRITE_OP ,LPCWSTR ,DWORD ,LPCWSTR *rpszSpn );
#ifdef UNICODE
#define DsWriteAccountSpn DsWriteAccountSpnW
#else
#define DsWriteAccountSpn DsWriteAccountSpnA
#endif
DWORD WINAPI DsClientMakeSpnForTargetServerW(LPCWSTR ,LPCWSTR ,DWORD *,LPWSTR pszSpn );
DWORD WINAPI DsClientMakeSpnForTargetServerA(LPCSTR ,LPCSTR ,DWORD *,LPSTR pszSpn );
#ifdef UNICODE
#define DsClientMakeSpnForTargetServer DsClientMakeSpnForTargetServerW
#else
#define DsClientMakeSpnForTargetServer DsClientMakeSpnForTargetServerA
#endif
DWORD WINAPI DsServerRegisterSpnA(DS_SPN_WRITE_OP ,LPCSTR ,LPCSTR UserObjectDN );
DWORD WINAPI DsServerRegisterSpnW(DS_SPN_WRITE_OP ,LPCWSTR ,LPCWSTR UserObjectDN );
#ifdef UNICODE
#define DsServerRegisterSpn DsServerRegisterSpnW
#else
#define DsServerRegisterSpn DsServerRegisterSpnA
#endif
DWORD WINAPI DsReplicaSyncA(HANDLE ,LPCSTR , const UUID *pUuidDsaSrc,ULONG Options );
DWORD WINAPI DsReplicaSyncW(HANDLE ,LPCWSTR , const UUID *pUuidDsaSrc,ULONG Options );
#ifdef UNICODE
#define DsReplicaSync DsReplicaSyncW
#else
#define DsReplicaSync DsReplicaSyncA
#endif
DWORD WINAPI DsReplicaAddA(HANDLE ,LPCSTR ,LPCSTR ,LPCSTR ,LPCSTR , const PSCHEDULE pSchedule,DWORD Options );
DWORD WINAPI DsReplicaAddW(HANDLE ,LPCWSTR ,LPCWSTR ,LPCWSTR ,LPCWSTR , const PSCHEDULE pSchedule,DWORD Options );
#ifdef UNICODE
#define DsReplicaAdd DsReplicaAddW
#else
#define DsReplicaAdd DsReplicaAddA
#endif
DWORD WINAPI DsReplicaDelA(HANDLE ,LPCSTR ,LPCSTR ,ULONG Options );
DWORD WINAPI DsReplicaDelW(HANDLE ,LPCWSTR ,LPCWSTR ,ULONG Options );
#ifdef UNICODE
#define DsReplicaDel DsReplicaDelW
#else
#define DsReplicaDel DsReplicaDelA
#endif
DWORD WINAPI DsReplicaModifyA(HANDLE ,LPCSTR , const UUID *pUuidSourceDsa,LPCSTR ,LPCSTR , const PSCHEDULE pSchedule,DWORD ,DWORD ,DWORD Options );
DWORD WINAPI DsReplicaModifyW(HANDLE ,LPCWSTR , const UUID *pUuidSourceDsa,LPCWSTR ,LPCWSTR , const PSCHEDULE pSchedule,DWORD ,DWORD ,DWORD Options );
#ifdef UNICODE
#define DsReplicaModify DsReplicaModifyW
#else
#define DsReplicaModify DsReplicaModifyA
#endif
DWORD WINAPI DsReplicaUpdateRefsA(HANDLE ,LPCSTR ,LPCSTR , const UUID *pUuidDsaDest,ULONG Options );
DWORD WINAPI DsReplicaUpdateRefsW(HANDLE ,LPCWSTR ,LPCWSTR , const UUID *pUuidDsaDest,ULONG Options );
#ifdef UNICODE
#define DsReplicaUpdateRefs DsReplicaUpdateRefsW
#else
#define DsReplicaUpdateRefs DsReplicaUpdateRefsA
#endif
typedef enum {
DS_REPSYNCALL_WIN32_ERROR_CONTACTING_SERVER=0,
DS_REPSYNCALL_WIN32_ERROR_REPLICATING=1,
DS_REPSYNCALL_SERVER_UNREACHABLE=2
} DS_REPSYNCALL_ERROR;
typedef enum {
DS_REPSYNCALL_EVENT_ERROR=0,
DS_REPSYNCALL_EVENT_SYNC_STARTED=1,
DS_REPSYNCALL_EVENT_SYNC_COMPLETED=2,
DS_REPSYNCALL_EVENT_FINISHED=3
} DS_REPSYNCALL_EVENT;
typedef struct {
LPSTR	pszSrcId;
LPSTR	pszDstId;
LPSTR pszNC;
GUID * pguidSrc;
GUID * pguidDst;
} DS_REPSYNCALL_SYNCA,* PDS_REPSYNCALL_SYNCA;
typedef struct {
LPWSTR	pszSrcId;
LPWSTR	pszDstId;
LPWSTR pszNC;
GUID * pguidSrc;
GUID * pguidDst;
} DS_REPSYNCALL_SYNCW,* PDS_REPSYNCALL_SYNCW;
typedef struct {
LPSTR	pszSvrId;
DS_REPSYNCALL_ERROR	error;
DWORD	dwWin32Err;
LPSTR	pszSrcId;
} DS_REPSYNCALL_ERRINFOA,* PDS_REPSYNCALL_ERRINFOA;
typedef struct {
LPWSTR	pszSvrId;
DS_REPSYNCALL_ERROR	error;
DWORD	dwWin32Err;
LPWSTR	pszSrcId;
} DS_REPSYNCALL_ERRINFOW,* PDS_REPSYNCALL_ERRINFOW;
typedef struct {
DS_REPSYNCALL_EVENT	event;
DS_REPSYNCALL_ERRINFOA *	pErrInfo;
DS_REPSYNCALL_SYNCA *	pSync;
} DS_REPSYNCALL_UPDATEA,* PDS_REPSYNCALL_UPDATEA;
typedef struct {
DS_REPSYNCALL_EVENT	event;
DS_REPSYNCALL_ERRINFOW *	pErrInfo;
DS_REPSYNCALL_SYNCW *	pSync;
} DS_REPSYNCALL_UPDATEW,* PDS_REPSYNCALL_UPDATEW;
#ifdef UNICODE
#define DS_REPSYNCALL_SYNC DS_REPSYNCALL_SYNCW
#define DS_REPSYNCALL_ERRINFO DS_REPSYNCALL_ERRINFOW
#define DS_REPSYNCALL_UPDATE DS_REPSYNCALL_UPDATEW
#define PDS_REPSYNCALL_SYNC PDS_REPSYNCALL_SYNCW
#define PDS_REPSYNCALL_ERRINFO PDS_REPSYNCALL_ERRINFOW
#define PDS_REPSYNCALL_UPDATE PDS_REPSYNCALL_UPDATEW
#else
#define DS_REPSYNCALL_SYNC DS_REPSYNCALL_SYNCA
#define DS_REPSYNCALL_ERRINFO DS_REPSYNCALL_ERRINFOA
#define DS_REPSYNCALL_UPDATE DS_REPSYNCALL_UPDATEA
#define PDS_REPSYNCALL_SYNC PDS_REPSYNCALL_SYNCA
#define PDS_REPSYNCALL_ERRINFO PDS_REPSYNCALL_ERRINFOA
#define PDS_REPSYNCALL_UPDATE PDS_REPSYNCALL_UPDATEA
#endif
#define DS_REPSYNCALL_NO_OPTIONS	0
#define	DS_REPSYNCALL_ABORT_IF_SERVER_UNAVAILABLE	1
#define DS_REPSYNCALL_SYNC_ADJACENT_SERVERS_ONLY	2
#define DS_REPSYNCALL_ID_SERVERS_BY_DN	4
#define DS_REPSYNCALL_DO_NOT_SYNC	8
#define DS_REPSYNCALL_SKIP_INITIAL_CHECK	16
#define DS_REPSYNCALL_PUSH_CHANGES_OUTWARD 32
#define DS_REPSYNCALL_CROSS_SITE_BOUNDARIES 64
NTDSAPI 
DWORD 
WINAPI 
DsReplicaSyncAllA (HANDLE	,LPCSTR	,ULONG	,BOOL (__stdcall *pFnCallBack) (LPVOID,PDS_REPSYNCALL_UPDATEA),LPVOID	,PDS_REPSYNCALL_ERRINFOA **pErrors );
NTDSAPI 
DWORD 
WINAPI 
DsReplicaSyncAllW (HANDLE	,LPCWSTR	,ULONG	,BOOL (__stdcall *pFnCallBack) (LPVOID,PDS_REPSYNCALL_UPDATEW),LPVOID	,PDS_REPSYNCALL_ERRINFOW **pErrors );
#ifdef UNICODE
#define DsReplicaSyncAll DsReplicaSyncAllW
#else
#define DsReplicaSyncAll DsReplicaSyncAllA
#endif
NTDSAPI 
DWORD 
WINAPI 
DsRemoveDsServerW(HANDLE ,LPWSTR ,LPWSTR ,BOOL *,BOOL fCommit );
NTDSAPI 
DWORD 
WINAPI 
DsRemoveDsServerA(HANDLE ,LPSTR ,LPSTR ,BOOL *,BOOL fCommit );
#ifdef UNICODE
#define DsRemoveDsServer DsRemoveDsServerW
#else
#define DsRemoveDsServer DsRemoveDsServerA
#endif
NTDSAPI 
DWORD 
WINAPI 
DsRemoveDsDomainW(HANDLE ,LPWSTR DomainDN );
NTDSAPI 
DWORD 
WINAPI 
DsRemoveDsDomainA(HANDLE ,LPSTR DomainDN );
#ifdef UNICODE
#define DsRemoveDsDomain DsRemoveDsDomainW
#else
#define DsRemoveDsDomain DsRemoveDsDomainA
#endif
NTDSAPI 
DWORD 
WINAPI 
DsListSitesA(HANDLE ,PDS_NAME_RESULTA *); 
NTDSAPI 
DWORD 
WINAPI 
DsListSitesW(HANDLE ,PDS_NAME_RESULTW *); 
#ifdef UNICODE
#define DsListSites DsListSitesW
#else
#define DsListSites DsListSitesA
#endif
NTDSAPI 
DWORD 
WINAPI 
DsListServersInSiteA(HANDLE ,LPCSTR ,PDS_NAME_RESULTA *); 
NTDSAPI 
DWORD 
WINAPI 
DsListServersInSiteW(HANDLE ,LPCWSTR ,PDS_NAME_RESULTW *); 
#ifdef UNICODE
#define DsListServersInSite DsListServersInSiteW
#else
#define DsListServersInSite DsListServersInSiteA
#endif
NTDSAPI 
DWORD 
WINAPI 
DsListDomainsInSiteA(HANDLE ,LPCSTR ,PDS_NAME_RESULTA *); 
NTDSAPI 
DWORD 
WINAPI 
DsListDomainsInSiteW(HANDLE ,LPCWSTR ,PDS_NAME_RESULTW *); 
#ifdef UNICODE
#define DsListDomainsInSite DsListDomainsInSiteW
#else
#define DsListDomainsInSite DsListDomainsInSiteA
#endif
NTDSAPI 
DWORD 
WINAPI 
DsListServersForDomainInSiteA(HANDLE ,LPCSTR ,LPCSTR ,PDS_NAME_RESULTA *); 
NTDSAPI 
DWORD 
WINAPI 
DsListServersForDomainInSiteW(HANDLE ,LPCWSTR ,LPCWSTR ,PDS_NAME_RESULTW *); 
#ifdef UNICODE
#define DsListServersForDomainInSite DsListServersForDomainInSiteW
#else
#define DsListServersForDomainInSite DsListServersForDomainInSiteA
#endif
#define DS_LIST_DSA_OBJECT_FOR_SERVER 0
#define DS_LIST_DNS_HOST_NAME_FOR_SERVER 1
#define DS_LIST_ACCOUNT_OBJECT_FOR_SERVER 2
NTDSAPI 
DWORD 
WINAPI 
DsListInfoForServerA(HANDLE ,LPCSTR ,PDS_NAME_RESULTA *); 
NTDSAPI 
DWORD 
WINAPI 
DsListInfoForServerW(HANDLE ,LPCWSTR ,PDS_NAME_RESULTW *); 
#ifdef UNICODE
#define DsListInfoForServer DsListInfoForServerW
#else
#define DsListInfoForServer DsListInfoForServerA
#endif
#define DS_ROLE_SCHEMA_OWNER 0
#define DS_ROLE_DOMAIN_OWNER 1
#define DS_ROLE_PDC_OWNER 2
#define DS_ROLE_RID_OWNER 3
#define DS_ROLE_INFRASTRUCTURE_OWNER 4
NTDSAPI 
DWORD 
WINAPI 
DsListRolesA(HANDLE ,PDS_NAME_RESULTA *); 
NTDSAPI 
DWORD 
WINAPI 
DsListRolesW(HANDLE ,PDS_NAME_RESULTW *); 
#ifdef UNICODE
#define DsListRoles DsListRolesW
#else
#define DsListRoles DsListRolesA
#endif
typedef struct {
DWORD errorCode;
DWORD cost;
} DS_SITE_COST_INFO,*PDS_SITE_COST_INFO;
DWORD WINAPI DsQuerySitesByCostW(HANDLE ,LPWSTR ,LPWSTR *,DWORD ,DWORD ,PDS_SITE_COST_INFO *prgSiteInfo );
DWORD WINAPI DsQuerySitesByCostA(HANDLE ,LPSTR ,LPSTR *,DWORD ,DWORD ,PDS_SITE_COST_INFO *prgSiteInfo );
#ifdef UNICODE
#define DsQuerySitesByCost DsQuerySitesByCostW
#else
#define DsQuerySitesByCost DsQuerySitesByCostA
#endif
VOID 
DsQuerySitesFree(PDS_SITE_COST_INFO rgSiteInfo );
#define DS_SCHEMA_GUID_NOT_FOUND 0
#define DS_SCHEMA_GUID_ATTR 1
#define DS_SCHEMA_GUID_ATTR_SET 2
#define DS_SCHEMA_GUID_CLASS 3
#define DS_SCHEMA_GUID_CONTROL_RIGHT 4
typedef struct
{
GUID guid; 
DWORD guidType; 
#ifdef MIDL_PASS
[string,unique] CHAR *pName; 
#else
LPSTR pName; 
#endif
} DS_SCHEMA_GUID_MAPA,*PDS_SCHEMA_GUID_MAPA;
typedef struct
{
GUID guid; 
DWORD guidType; 
#ifdef MIDL_PASS
[string,unique] WCHAR *pName; 
#else
LPWSTR pName; 
#endif
} DS_SCHEMA_GUID_MAPW,*PDS_SCHEMA_GUID_MAPW;
NTDSAPI 
DWORD 
WINAPI 
DsMapSchemaGuidsA(HANDLE ,DWORD ,GUID *,DS_SCHEMA_GUID_MAPA **); 
NTDSAPI 
VOID 
WINAPI 
DsFreeSchemaGuidMapA(PDS_SCHEMA_GUID_MAPA ); 
NTDSAPI 
DWORD 
WINAPI 
DsMapSchemaGuidsW(HANDLE ,DWORD ,GUID *,DS_SCHEMA_GUID_MAPW **); 
NTDSAPI 
VOID 
WINAPI 
DsFreeSchemaGuidMapW(PDS_SCHEMA_GUID_MAPW ); 
#ifdef UNICODE
#define DS_SCHEMA_GUID_MAP DS_SCHEMA_GUID_MAPW
#define PDS_SCHEMA_GUID_MAP PDS_SCHEMA_GUID_MAPW
#define DsMapSchemaGuids DsMapSchemaGuidsW
#define DsFreeSchemaGuidMap DsFreeSchemaGuidMapW
#else
#define DS_SCHEMA_GUID_MAP DS_SCHEMA_GUID_MAPA
#define PDS_SCHEMA_GUID_MAP PDS_SCHEMA_GUID_MAPA
#define DsMapSchemaGuids DsMapSchemaGuidsA
#define DsFreeSchemaGuidMap DsFreeSchemaGuidMapA
#endif
typedef struct
{
#ifdef MIDL_PASS
[string,unique] CHAR *NetbiosName; 
[string,unique] CHAR *DnsHostName; 
[string,unique] CHAR *SiteName; 
[string,unique] CHAR *ComputerObjectName; 
[string,unique] CHAR *ServerObjectName; 
#else
LPSTR NetbiosName; 
LPSTR DnsHostName; 
LPSTR SiteName; 
LPSTR ComputerObjectName; 
LPSTR ServerObjectName; 
#endif
BOOL fIsPdc;
BOOL fDsEnabled;
} DS_DOMAIN_CONTROLLER_INFO_1A,*PDS_DOMAIN_CONTROLLER_INFO_1A;
typedef struct
{
#ifdef MIDL_PASS
[string,unique] WCHAR *NetbiosName; 
[string,unique] WCHAR *DnsHostName; 
[string,unique] WCHAR *SiteName; 
[string,unique] WCHAR *ComputerObjectName; 
[string,unique] WCHAR *ServerObjectName; 
#else
LPWSTR NetbiosName; 
LPWSTR DnsHostName; 
LPWSTR SiteName; 
LPWSTR ComputerObjectName; 
LPWSTR ServerObjectName; 
#endif
BOOL fIsPdc;
BOOL fDsEnabled;
} DS_DOMAIN_CONTROLLER_INFO_1W,*PDS_DOMAIN_CONTROLLER_INFO_1W;
typedef struct
{
#ifdef MIDL_PASS
[string,unique] CHAR *NetbiosName; 
[string,unique] CHAR *DnsHostName; 
[string,unique] CHAR *SiteName; 
[string,unique] CHAR *SiteObjectName; 
[string,unique] CHAR *ComputerObjectName; 
[string,unique] CHAR *ServerObjectName; 
[string,unique] CHAR *NtdsDsaObjectName; 
#else
LPSTR NetbiosName; 
LPSTR DnsHostName; 
LPSTR SiteName; 
LPSTR SiteObjectName; 
LPSTR ComputerObjectName; 
LPSTR ServerObjectName; 
LPSTR NtdsDsaObjectName; 
#endif
BOOL fIsPdc;
BOOL fDsEnabled;
BOOL fIsGc;
GUID SiteObjectGuid;
GUID ComputerObjectGuid;
GUID ServerObjectGuid;
GUID NtdsDsaObjectGuid;
} DS_DOMAIN_CONTROLLER_INFO_2A,*PDS_DOMAIN_CONTROLLER_INFO_2A;
typedef struct
{
#ifdef MIDL_PASS
[string,unique] WCHAR *NetbiosName; 
[string,unique] WCHAR *DnsHostName; 
[string,unique] WCHAR *SiteName; 
[string,unique] WCHAR *SiteObjectName; 
[string,unique] WCHAR *ComputerObjectName; 
[string,unique] WCHAR *ServerObjectName; 
[string,unique] WCHAR *NtdsDsaObjectName; 
#else
LPWSTR NetbiosName; 
LPWSTR DnsHostName; 
LPWSTR SiteName; 
LPWSTR SiteObjectName; 
LPWSTR ComputerObjectName; 
LPWSTR ServerObjectName; 
LPWSTR NtdsDsaObjectName; 
#endif
BOOL fIsPdc;
BOOL fDsEnabled;
BOOL fIsGc;
GUID SiteObjectGuid;
GUID ComputerObjectGuid;
GUID ServerObjectGuid;
GUID NtdsDsaObjectGuid;
} DS_DOMAIN_CONTROLLER_INFO_2W,*PDS_DOMAIN_CONTROLLER_INFO_2W;
NTDSAPI 
DWORD 
WINAPI 
DsGetDomainControllerInfoA(HANDLE ,LPCSTR ,DWORD ,DWORD *,VOID **); 
NTDSAPI 
DWORD 
WINAPI 
DsGetDomainControllerInfoW(HANDLE ,LPCWSTR ,DWORD ,DWORD *,VOID **); 
NTDSAPI 
VOID 
WINAPI 
DsFreeDomainControllerInfoA(DWORD ,DWORD ,VOID *); 
NTDSAPI 
VOID 
WINAPI 
DsFreeDomainControllerInfoW(DWORD ,DWORD ,VOID *); 
#ifdef UNICODE
#define DS_DOMAIN_CONTROLLER_INFO_1 DS_DOMAIN_CONTROLLER_INFO_1W
#define DS_DOMAIN_CONTROLLER_INFO_2 DS_DOMAIN_CONTROLLER_INFO_2W
#define PDS_DOMAIN_CONTROLLER_INFO_1 PDS_DOMAIN_CONTROLLER_INFO_1W
#define PDS_DOMAIN_CONTROLLER_INFO_2 PDS_DOMAIN_CONTROLLER_INFO_2W
#define DsGetDomainControllerInfo DsGetDomainControllerInfoW
#define DsFreeDomainControllerInfo DsFreeDomainControllerInfoW
#else
#define DS_DOMAIN_CONTROLLER_INFO_1 DS_DOMAIN_CONTROLLER_INFO_1A
#define DS_DOMAIN_CONTROLLER_INFO_2 DS_DOMAIN_CONTROLLER_INFO_2A
#define PDS_DOMAIN_CONTROLLER_INFO_1 PDS_DOMAIN_CONTROLLER_INFO_1A
#define PDS_DOMAIN_CONTROLLER_INFO_2 PDS_DOMAIN_CONTROLLER_INFO_2A
#define DsGetDomainControllerInfo DsGetDomainControllerInfoA
#define DsFreeDomainControllerInfo DsFreeDomainControllerInfoA
#endif
typedef enum {
DS_KCC_TASKID_UPDATE_TOPOLOGY=0
} DS_KCC_TASKID;
#define DS_KCC_FLAG_ASYNC_OP (1 << 0)
#define DS_KCC_FLAG_DAMPED (1 << 1)
NTDSAPI 
DWORD 
WINAPI 
DsReplicaConsistencyCheck(HANDLE ,DS_KCC_TASKID ,DWORD ); 
NTDSAPI 
DWORD 
WINAPI 
DsReplicaVerifyObjectsW(HANDLE ,LPCWSTR , const UUID * pUuidDsaSrc,ULONG ); 
NTDSAPI 
DWORD 
WINAPI 
DsReplicaVerifyObjectsA(HANDLE ,LPCSTR , const UUID * pUuidDsaSrc,ULONG ); 
#ifdef UNICODE
#define DsReplicaVerifyObjects DsReplicaVerifyObjectsW
#else
#define DsReplicaVerifyObjects DsReplicaVerifyObjectsA
#endif
#define DS_EXIST_ADVISORY_MODE 1
typedef enum _DS_REPL_INFO_TYPE {
DS_REPL_INFO_NEIGHBORS=0,
DS_REPL_INFO_CURSORS_FOR_NC=1,
DS_REPL_INFO_METADATA_FOR_OBJ=2,
DS_REPL_INFO_KCC_DSA_CONNECT_FAILURES=3,
DS_REPL_INFO_KCC_DSA_LINK_FAILURES=4,
DS_REPL_INFO_PENDING_OPS=5,
DS_REPL_INFO_METADATA_FOR_ATTR_VALUE=6,
DS_REPL_INFO_CURSORS_2_FOR_NC=7,
DS_REPL_INFO_CURSORS_3_FOR_NC=8,
DS_REPL_INFO_METADATA_2_FOR_OBJ=9,
DS_REPL_INFO_METADATA_2_FOR_ATTR_VALUE=10,
DS_REPL_INFO_TYPE_MAX
} DS_REPL_INFO_TYPE;
#define DS_REPL_INFO_FLAG_IMPROVE_LINKED_ATTRS 1
#define DS_REPL_NBR_WRITEABLE 16
#define DS_REPL_NBR_SYNC_ON_STARTUP 32
#define DS_REPL_NBR_DO_SCHEDULED_SYNCS 64
#define DS_REPL_NBR_USE_ASYNC_INTERSITE_TRANSPORT 128
#define DS_REPL_NBR_TWO_WAY_SYNC 512
#define DS_REPL_NBR_RETURN_OBJECT_PARENTS 2048
#define DS_REPL_NBR_FULL_SYNC_IN_PROGRESS 0x10000
#define DS_REPL_NBR_FULL_SYNC_NEXT_PACKET 0x20000
#define DS_REPL_NBR_NEVER_SYNCED 0x200000
#define DS_REPL_NBR_PREEMPTED 0x1000000
#define DS_REPL_NBR_IGNORE_CHANGE_NOTIFICATIONS 0x4000000
#define DS_REPL_NBR_DISABLE_SCHEDULED_SYNC 0x8000000
#define DS_REPL_NBR_COMPRESS_CHANGES 0x10000000
#define DS_REPL_NBR_NO_CHANGE_NOTIFICATIONS 0x20000000
#define DS_REPL_NBR_PARTIAL_ATTRIBUTE_SET 0x40000000
#define DS_REPL_NBR_MODIFIABLE_MASK ( DS_REPL_NBR_SYNC_ON_STARTUP |  DS_REPL_NBR_DO_SCHEDULED_SYNCS |  DS_REPL_NBR_TWO_WAY_SYNC |  DS_REPL_NBR_IGNORE_CHANGE_NOTIFICATIONS |  DS_REPL_NBR_DISABLE_SCHEDULED_SYNC |  DS_REPL_NBR_COMPRESS_CHANGES |  DS_REPL_NBR_NO_CHANGE_NOTIFICATIONS  )
typedef struct _DS_REPL_NEIGHBORW {
LPWSTR pszNamingContext;
LPWSTR pszSourceDsaDN;
LPWSTR pszSourceDsaAddress;
LPWSTR pszAsyncIntersiteTransportDN;
DWORD dwReplicaFlags;
DWORD dwReserved; 
UUID uuidNamingContextObjGuid;
UUID uuidSourceDsaObjGuid;
UUID uuidSourceDsaInvocationID;
UUID uuidAsyncIntersiteTransportObjGuid;
USN usnLastObjChangeSynced;
USN usnAttributeFilter;
FILETIME ftimeLastSyncSuccess;
FILETIME ftimeLastSyncAttempt;
DWORD dwLastSyncResult;
DWORD cNumConsecutiveSyncFailures;
} DS_REPL_NEIGHBORW;
typedef struct _DS_REPL_NEIGHBORW_BLOB {
DWORD oszNamingContext;
DWORD oszSourceDsaDN;
DWORD oszSourceDsaAddress;
DWORD oszAsyncIntersiteTransportDN;
DWORD dwReplicaFlags;
DWORD dwReserved; 
UUID uuidNamingContextObjGuid;
UUID uuidSourceDsaObjGuid;
UUID uuidSourceDsaInvocationID;
UUID uuidAsyncIntersiteTransportObjGuid;
USN usnLastObjChangeSynced;
USN usnAttributeFilter;
FILETIME ftimeLastSyncSuccess;
FILETIME ftimeLastSyncAttempt;
DWORD dwLastSyncResult;
DWORD cNumConsecutiveSyncFailures;
} DS_REPL_NEIGHBORW_BLOB;
typedef struct _DS_REPL_NEIGHBORSW {
DWORD cNumNeighbors;
DWORD dwReserved; 
#ifdef MIDL_PASS
[size_is(cNumNeighbors)] DS_REPL_NEIGHBORW rgNeighbor[];
#else
DS_REPL_NEIGHBORW rgNeighbor[1];
#endif
} DS_REPL_NEIGHBORSW;
typedef struct _DS_REPL_CURSOR {
UUID uuidSourceDsaInvocationID;
USN usnAttributeFilter;
} DS_REPL_CURSOR;
typedef struct _DS_REPL_CURSOR_2 {
UUID uuidSourceDsaInvocationID;
USN usnAttributeFilter;
FILETIME ftimeLastSyncSuccess;
} DS_REPL_CURSOR_2;
typedef struct _DS_REPL_CURSOR_3W {
UUID uuidSourceDsaInvocationID;
USN usnAttributeFilter;
FILETIME ftimeLastSyncSuccess;
LPWSTR pszSourceDsaDN;
} DS_REPL_CURSOR_3W;
typedef struct _DS_REPL_CURSOR_BLOB {
UUID uuidSourceDsaInvocationID;
USN usnAttributeFilter;
FILETIME ftimeLastSyncSuccess;
DWORD oszSourceDsaDN;
} DS_REPL_CURSOR_BLOB;
typedef struct _DS_REPL_CURSORS {
DWORD cNumCursors;
DWORD dwReserved; 
#ifdef MIDL_PASS
[size_is(cNumCursors)] DS_REPL_CURSOR rgCursor[];
#else
DS_REPL_CURSOR rgCursor[1];
#endif
} DS_REPL_CURSORS;
typedef struct _DS_REPL_CURSORS_2 {
DWORD cNumCursors;
DWORD dwEnumerationContext;
#ifdef MIDL_PASS
[size_is(cNumCursors)] DS_REPL_CURSOR_2 rgCursor[];
#else
DS_REPL_CURSOR_2 rgCursor[1];
#endif
} DS_REPL_CURSORS_2;
typedef struct _DS_REPL_CURSORS_3W {
DWORD cNumCursors;
DWORD dwEnumerationContext;
#ifdef MIDL_PASS
[size_is(cNumCursors)] DS_REPL_CURSOR_3W rgCursor[];
#else
DS_REPL_CURSOR_3W rgCursor[1];
#endif
} DS_REPL_CURSORS_3W;
typedef struct _DS_REPL_ATTR_META_DATA {
LPWSTR pszAttributeName;
DWORD dwVersion;
FILETIME ftimeLastOriginatingChange;
UUID uuidLastOriginatingDsaInvocationID;
USN usnOriginatingChange; 
USN usnLocalChange; 
} DS_REPL_ATTR_META_DATA;
typedef struct _DS_REPL_ATTR_META_DATA_2 {
LPWSTR pszAttributeName;
DWORD dwVersion;
FILETIME ftimeLastOriginatingChange;
UUID uuidLastOriginatingDsaInvocationID;
USN usnOriginatingChange; 
USN usnLocalChange; 
LPWSTR pszLastOriginatingDsaDN;
} DS_REPL_ATTR_META_DATA_2;
typedef struct _DS_REPL_ATTR_META_DATA_BLOB {
DWORD oszAttributeName;
DWORD dwVersion;
FILETIME ftimeLastOriginatingChange;
UUID uuidLastOriginatingDsaInvocationID;
USN usnOriginatingChange; 
USN usnLocalChange; 
DWORD oszLastOriginatingDsaDN;
} DS_REPL_ATTR_META_DATA_BLOB;
typedef struct _DS_REPL_OBJ_META_DATA {
DWORD cNumEntries;
DWORD dwReserved; 
#ifdef MIDL_PASS
[size_is(cNumEntries)] DS_REPL_ATTR_META_DATA rgMetaData[];
#else
DS_REPL_ATTR_META_DATA rgMetaData[1];
#endif
} DS_REPL_OBJ_META_DATA;
typedef struct _DS_REPL_OBJ_META_DATA_2 {
DWORD cNumEntries;
DWORD dwReserved; 
#ifdef MIDL_PASS
[size_is(cNumEntries)] DS_REPL_ATTR_META_DATA_2 rgMetaData[];
#else
DS_REPL_ATTR_META_DATA_2 rgMetaData[1];
#endif
} DS_REPL_OBJ_META_DATA_2;
typedef struct _DS_REPL_KCC_DSA_FAILUREW {
LPWSTR pszDsaDN;
UUID uuidDsaObjGuid;
FILETIME ftimeFirstFailure;
DWORD cNumFailures;
DWORD dwLastResult; 
} DS_REPL_KCC_DSA_FAILUREW;
typedef struct _DS_REPL_KCC_DSA_FAILUREW_BLOB {
DWORD oszDsaDN;
UUID uuidDsaObjGuid;
FILETIME ftimeFirstFailure;
DWORD cNumFailures;
DWORD dwLastResult; 
} DS_REPL_KCC_DSA_FAILUREW_BLOB;
typedef struct _DS_REPL_KCC_DSA_FAILURESW {
DWORD cNumEntries;
DWORD dwReserved; 
#ifdef MIDL_PASS
[size_is(cNumEntries)] DS_REPL_KCC_DSA_FAILUREW rgDsaFailure[];
#else
DS_REPL_KCC_DSA_FAILUREW rgDsaFailure[1];
#endif
} DS_REPL_KCC_DSA_FAILURESW;
typedef enum _DS_REPL_OP_TYPE {
DS_REPL_OP_TYPE_SYNC=0,
DS_REPL_OP_TYPE_ADD,
DS_REPL_OP_TYPE_DELETE,
DS_REPL_OP_TYPE_MODIFY,
DS_REPL_OP_TYPE_UPDATE_REFS
} DS_REPL_OP_TYPE;
typedef struct _DS_REPL_OPW {
FILETIME ftimeEnqueued; 
ULONG ulSerialNumber; 
ULONG ulPriority; 
DS_REPL_OP_TYPE OpType;
ULONG ulOptions; 
LPWSTR pszNamingContext;
LPWSTR pszDsaDN;
LPWSTR pszDsaAddress;
UUID uuidNamingContextObjGuid;
UUID uuidDsaObjGuid;
} DS_REPL_OPW;
typedef struct _DS_REPL_OPW_BLOB {
FILETIME ftimeEnqueued; 
ULONG ulSerialNumber; 
ULONG ulPriority; 
DS_REPL_OP_TYPE OpType;
ULONG ulOptions; 
DWORD oszNamingContext;
DWORD oszDsaDN;
DWORD oszDsaAddress;
UUID uuidNamingContextObjGuid;
UUID uuidDsaObjGuid;
} DS_REPL_OPW_BLOB;
typedef struct _DS_REPL_PENDING_OPSW {
FILETIME ftimeCurrentOpStarted;
DWORD cNumPendingOps;
#ifdef MIDL_PASS
[size_is(cNumPendingOps)] DS_REPL_OPW rgPendingOp[];
#else
DS_REPL_OPW rgPendingOp[1];
#endif
} DS_REPL_PENDING_OPSW;
typedef struct _DS_REPL_VALUE_META_DATA {
LPWSTR pszAttributeName;
LPWSTR pszObjectDn;
DWORD cbData;
#ifdef MIDL_PASS
[size_is(cbData),ptr] BYTE *pbData;
#else
BYTE *pbData;
#endif
FILETIME ftimeDeleted;
FILETIME ftimeCreated;
DWORD dwVersion;
FILETIME ftimeLastOriginatingChange;
UUID uuidLastOriginatingDsaInvocationID;
USN usnOriginatingChange; 
USN usnLocalChange; 
} DS_REPL_VALUE_META_DATA;
typedef struct _DS_REPL_VALUE_META_DATA_2 {
LPWSTR pszAttributeName;
LPWSTR pszObjectDn;
DWORD cbData;
#ifdef MIDL_PASS
[size_is(cbData),ptr] BYTE *pbData;
#else
BYTE *pbData;
#endif
FILETIME ftimeDeleted;
FILETIME ftimeCreated;
DWORD dwVersion;
FILETIME ftimeLastOriginatingChange;
UUID uuidLastOriginatingDsaInvocationID;
USN usnOriginatingChange; 
USN usnLocalChange; 
LPWSTR pszLastOriginatingDsaDN;
} DS_REPL_VALUE_META_DATA_2;
typedef struct _DS_REPL_VALUE_META_DATA_BLOB {
DWORD oszAttributeName;
DWORD oszObjectDn;
DWORD cbData;
DWORD obData;
FILETIME ftimeDeleted;
FILETIME ftimeCreated;
DWORD dwVersion;
FILETIME ftimeLastOriginatingChange;
UUID uuidLastOriginatingDsaInvocationID;
USN usnOriginatingChange; 
USN usnLocalChange; 
DWORD oszLastOriginatingDsaDN;
} DS_REPL_VALUE_META_DATA_BLOB;
typedef struct _DS_REPL_ATTR_VALUE_META_DATA {
DWORD cNumEntries;
DWORD dwEnumerationContext;
#ifdef MIDL_PASS
[size_is(cNumEntries)] DS_REPL_VALUE_META_DATA rgMetaData[];
#else
DS_REPL_VALUE_META_DATA rgMetaData[1];
#endif
} DS_REPL_ATTR_VALUE_META_DATA;
typedef struct _DS_REPL_ATTR_VALUE_META_DATA_2 {
DWORD cNumEntries;
DWORD dwEnumerationContext;
#ifdef MIDL_PASS
[size_is(cNumEntries)] DS_REPL_VALUE_META_DATA_2 rgMetaData[];
#else
DS_REPL_VALUE_META_DATA_2 rgMetaData[1];
#endif
} DS_REPL_ATTR_VALUE_META_DATA_2;
typedef struct _DS_REPL_QUEUE_STATISTICSW
{
FILETIME ftimeCurrentOpStarted;
DWORD cNumPendingOps;
FILETIME ftimeOldestSync;
FILETIME ftimeOldestAdd;
FILETIME ftimeOldestMod;
FILETIME ftimeOldestDel;
FILETIME ftimeOldestUpdRefs;
} DS_REPL_QUEUE_STATISTICSW;
typedef struct _DS_REPL_QUEUE_STATISTICSW DS_REPL_QUEUE_STATISTICSW_BLOB;
NTDSAPI 
DWORD 
WINAPI 
DsReplicaGetInfoW(HANDLE ,DS_REPL_INFO_TYPE ,LPCWSTR ,UUID *,VOID **); 
NTDSAPI 
DWORD 
WINAPI 
DsReplicaGetInfo2W(HANDLE ,DS_REPL_INFO_TYPE ,LPCWSTR ,UUID *,LPCWSTR ,LPCWSTR ,DWORD ,DWORD ,VOID **); 
NTDSAPI 
void 
WINAPI 
DsReplicaFreeInfo(DS_REPL_INFO_TYPE ,VOID *); 
#ifdef UNICODE
#define DsReplicaGetInfo DsReplicaGetInfoW
#define DsReplicaGetInfo2 DsReplicaGetInfo2W
#define DS_REPL_NEIGHBOR DS_REPL_NEIGHBORW
#define DS_REPL_NEIGHBORS DS_REPL_NEIGHBORSW
#define DS_REPL_CURSOR_3 DS_REPL_CURSOR_3W
#define DS_REPL_CURSORS_3 DS_REPL_CURSORS_3W
#define DS_REPL_KCC_DSA_FAILURES DS_REPL_KCC_DSA_FAILURESW
#define DS_REPL_KCC_DSA_FAILURE DS_REPL_KCC_DSA_FAILUREW
#define DS_REPL_OP DS_REPL_OPW
#define DS_REPL_PENDING_OPS DS_REPL_PENDING_OPSW
#else
#endif
DWORD WINAPI DsAddSidHistoryW(HANDLE ,DWORD ,LPCWSTR ,LPCWSTR ,LPCWSTR ,RPC_AUTH_IDENTITY_HANDLE ,LPCWSTR ,LPCWSTR ); 
DWORD WINAPI DsAddSidHistoryA(HANDLE ,DWORD ,LPCSTR ,LPCSTR ,LPCSTR ,RPC_AUTH_IDENTITY_HANDLE ,LPCSTR ,LPCSTR ); 
#ifdef UNICODE
#define DsAddSidHistory DsAddSidHistoryW
#else
#define DsAddSidHistory DsAddSidHistoryA
#endif
DWORD WINAPI DsInheritSecurityIdentityW(HANDLE ,DWORD ,LPCWSTR ,LPCWSTR ); 
DWORD WINAPI DsInheritSecurityIdentityA(HANDLE ,DWORD ,LPCSTR ,LPCSTR ); 
#ifdef UNICODE
#define DsInheritSecurityIdentity DsInheritSecurityIdentityW
#else
#define DsInheritSecurityIdentity DsInheritSecurityIdentityA
#endif
#ifndef MIDL_PASS
DWORD WINAPI DsQuoteRdnValueW(DWORD ,LPCWCH ,DWORD *,LPWCH psQuotedRdnValue );
DWORD WINAPI DsQuoteRdnValueA(DWORD ,LPCCH ,DWORD *,LPCH psQuotedRdnValue );
#ifdef UNICODE
#define DsQuoteRdnValue DsQuoteRdnValueW
#else
#define DsQuoteRdnValue DsQuoteRdnValueA
#endif
DWORD WINAPI DsUnquoteRdnValueW(DWORD ,LPCWCH ,DWORD *,LPWCH psUnquotedRdnValue );
DWORD WINAPI DsUnquoteRdnValueA(DWORD ,LPCCH ,DWORD *,LPCH psUnquotedRdnValue );
#ifdef UNICODE
#define DsUnquoteRdnValue DsUnquoteRdnValueW
#else
#define DsUnquoteRdnValue DsUnquoteRdnValueA
#endif
DWORD WINAPI DsGetRdnW(LPCWCH *,DWORD *,LPCWCH *,DWORD *,LPCWCH *,DWORD *pcVal );
BOOL WINAPI DsCrackUnquotedMangledRdnW(LPCWSTR ,DWORD ,GUID *,DS_MANGLE_FOR *peDsMangleFor );
BOOL WINAPI DsCrackUnquotedMangledRdnA(LPCSTR ,DWORD ,GUID *,DS_MANGLE_FOR *peDsMangleFor );
#ifdef UNICODE
#define DsCrackUnquotedMangledRdn DsCrackUnquotedMangledRdnW
#else
#define DsCrackUnquotedMangledRdn DsCrackUnquotedMangledRdnA
#endif
BOOL WINAPI DsIsMangledRdnValueW(LPCWSTR ,DWORD ,DS_MANGLE_FOR eDsMangleForDesired );
BOOL WINAPI DsIsMangledRdnValueA(LPCSTR ,DWORD ,DS_MANGLE_FOR eDsMangleForDesired );
#ifdef UNICODE
#define DsIsMangledRdnValue DsIsMangledRdnValueW
#else
#define DsIsMangledRdnValue DsIsMangledRdnValueA
#endif
BOOL WINAPI DsIsMangledDnA(LPCSTR ,DS_MANGLE_FOR eDsMangleFor );
BOOL WINAPI DsIsMangledDnW(LPCWSTR ,DS_MANGLE_FOR eDsMangleFor );
#ifdef UNICODE
#define DsIsMangledDn DsIsMangledDnW
#else
#define DsIsMangledDn DsIsMangledDnA
#endif
#endif
#endif 
