#ifndef __ntdsbcli_h__
#define __ntdsbcli_h__
#ifndef __windows_h__
#include "windows.h"
#endif
#pragma once
#ifdef	MIDL_PASS
#define	xRPC_STRING [string]
#else
#define	xRPC_STRING
#endif
#ifndef _NTDSBCLI_DEFINED
#define NTDSBCLI_API _stdcall
#else
#define NTDSBCLI_API
#endif
#ifndef _HRESULT_DEFINED
#define _HRESULT_DEFINED
typedef LONG HRESULT;
#endif 
#define g_wszBackupAnnotation L"NTDS Backup Interface"
#define g_aszBackupAnnotation "NTDS Backup Interface"
#define g_wszRestoreAnnotation L"NTDS Restore Interface"
#define g_aszRestoreAnnotation "NTDS Restore Interface"
#ifdef UNICODE
#define g_szBackupAnnotation g_wszBackupAnnotation
#define g_szRestoreAnnotation g_wszRestoreAnnotation
#else
#define g_szBackupAnnotation g_aszBackupAnnotation
#define g_szRestoreAnnotation g_aszRestoreAnnotation
#endif 
#define	BACKUP_TYPE_FULL	1
#define	BACKUP_TYPE_LOGS_ONLY	2
#define BACKUP_TYPE_INCREMENTAL 4
#define RESTORE_TYPE_AUTHORATATIVE 1
#define RESTORE_TYPE_ONLINE 2
#define RESTORE_TYPE_CATCHUP 4
#define BACKUP_DISABLE_INCREMENTAL 0xffffffff
#ifdef UNICODE
typedef WCHAR BFT;
#else
typedef CHAR BFT;
#endif
#define	BFT_DIRECTORY	128
#define BFT_DATABASE_DIRECTORY	64
#define	BFT_LOG_DIRECTORY	32
#define	BFT_LOG	(BFT)(TEXT('\x01') | BFT_LOG_DIRECTORY)
#define	BFT_LOG_DIR	(BFT)(TEXT('\x02') | BFT_DIRECTORY)
#define	BFT_CHECKPOINT_DIR	(BFT)(TEXT('\x03') | BFT_DIRECTORY)
#define	BFT_NTDS_DATABASE	(BFT)(TEXT('\x04') | BFT_DATABASE_DIRECTORY)
#define	BFT_PATCH_FILE	(BFT)(TEXT('\x05') | BFT_LOG_DIRECTORY)
#define	BFT_UNKNOWN	(BFT)(TEXT('\x0f'))
#include "ntdsbmsg.h"
typedef void *HBC;
typedef struct tagEDB_RSTMAPA
{
xRPC_STRING char	*szDatabaseName;
xRPC_STRING char	*szNewDatabaseName;
} EDB_RSTMAPA,*PEDB_RSTMAPA;	
#define	UNICODE_RSTMAP
typedef struct tagEDB_RSTMAPW {
xRPC_STRING WCHAR *wszDatabaseName;
xRPC_STRING WCHAR *wszNewDatabaseName;
} EDB_RSTMAPW,*PEDB_RSTMAPW;
#ifdef UNICODE
#define EDB_RSTMAP EDB_RSTMAPW
#define PEDB_RSTMAP PEDB_RSTMAPW
#else
#define EDB_RSTMAP EDB_RSTMAPA
#define PEDB_RSTMAP PEDB_RSTMAPA
#endif
#ifdef UNICODE
#define DsIsNTDSOnline DsIsNTDSOnlineW
#define DsBackupPrepare DsBackupPrepareW
#define DsBackupGetDatabaseNames DsBackupGetDatabaseNamesW
#define DsBackupOpenFile DsBackupOpenFileW
#define DsBackupGetBackupLogs DsBackupGetBackupLogsW
#define DsRestoreGetDatabaseLocations DsRestoreGetDatabaseLocationsW
#define DsRestorePrepare DsRestorePrepareW
#define DsRestoreRegister DsRestoreRegisterW
#define DsSetCurrentBackupLog DsSetCurrentBackupLogW
#define DsSetAuthIdentity DsSetAuthIdentityW
#else
#define DsIsNTDSOnline DsIsNTDSOnlineA
#define DsBackupPrepare DsBackupPrepareA
#define DsBackupGetDatabaseNames DsBackupGetDatabaseNamesA
#define DsBackupOpenFile DsBackupOpenFileA
#define DsBackupGetBackupLogs DsBackupGetBackupLogsA
#define DsRestoreGetDatabaseLocations DsRestoreGetDatabaseLocationsA
#define DsRestorePrepare DsRestorePrepareA
#define DsRestoreRegister DsRestoreRegisterA
#define DsSetCurrentBackupLog DsSetCurrentBackupLogA
#define DsSetAuthIdentity DsSetAuthIdentityA
#endif 
HRESULT NTDSBCLI_API DsIsNTDSOnlineA(LPCSTR ,BOOL *pfNTDSOnline );
HRESULT NTDSBCLI_API DsIsNTDSOnlineW(LPCWSTR ,BOOL *pfNTDSOnline );
HRESULT NTDSBCLI_API DsBackupPrepareA(LPCSTR ,ULONG ,ULONG ,PVOID *,LPDWORD ,HBC *phbc );
HRESULT NTDSBCLI_API DsBackupPrepareW(LPCWSTR ,ULONG ,ULONG ,PVOID *,LPDWORD ,HBC *phbc );
HRESULT NTDSBCLI_API DsBackupGetDatabaseNamesA(HBC ,LPSTR *,LPDWORD pcbSize );
HRESULT NTDSBCLI_API DsBackupGetDatabaseNamesW(HBC ,LPWSTR *,LPDWORD pcbSize );
HRESULT NTDSBCLI_API DsBackupOpenFileA(HBC ,LPCSTR ,DWORD ,LARGE_INTEGER *pliFileSize );
HRESULT NTDSBCLI_API DsBackupOpenFileW(HBC ,LPCWSTR ,DWORD ,LARGE_INTEGER *pliFileSize );
HRESULT NTDSBCLI_API DsBackupRead(HBC ,PVOID ,DWORD ,PDWORD pcbRead );
HRESULT NTDSBCLI_API DsBackupClose(HBC hbc );
HRESULT NTDSBCLI_API DsBackupGetBackupLogsA(HBC ,LPSTR *,LPDWORD pcbSize );
HRESULT NTDSBCLI_API DsBackupGetBackupLogsW(HBC ,LPWSTR *,LPDWORD pcbSize );
HRESULT NTDSBCLI_API DsBackupTruncateLogs(HBC hbc );
HRESULT NTDSBCLI_API DsBackupEnd(HBC hbc );
VOID NTDSBCLI_API DsBackupFree(PVOID pvBuffer );
HRESULT NTDSBCLI_API DsRestoreGetDatabaseLocationsA(HBC ,LPSTR *,LPDWORD pcbSize );
HRESULT NTDSBCLI_API DsRestoreGetDatabaseLocationsW(HBC ,LPWSTR *,LPDWORD pcbSize );
HRESULT NTDSBCLI_API DsRestorePrepareA(LPCSTR ,ULONG ,PVOID ,DWORD ,HBC *phbc );
HRESULT NTDSBCLI_API DsRestorePrepareW(LPCWSTR ,ULONG ,PVOID ,DWORD ,HBC *phbc );
HRESULT NTDSBCLI_API DsRestoreRegisterA(HBC ,LPCSTR ,LPCSTR ,EDB_RSTMAPA rgrstmap[],LONG ,LPCSTR ,ULONG ,ULONG genHigh );
HRESULT NTDSBCLI_API DsRestoreRegisterW(HBC ,LPCWSTR ,LPCWSTR ,EDB_RSTMAPW rgrstmap[],LONG ,LPCWSTR ,ULONG ,ULONG genHigh );
HRESULT NTDSBCLI_API DsRestoreRegisterComplete(HBC ,HRESULT hrRestoreState );
HRESULT NTDSBCLI_API DsRestoreEnd(HBC hbc );
HRESULT NTDSBCLI_API DsSetCurrentBackupLogA(LPCSTR ,DWORD dwCurrentLog );
HRESULT NTDSBCLI_API DsSetCurrentBackupLogW(LPCWSTR ,DWORD dwCurrentLog );
HRESULT NTDSBCLI_API DsSetAuthIdentityA(LPCSTR ,LPCSTR ,LPCSTR szPassword );
HRESULT NTDSBCLI_API DsSetAuthIdentityW(LPCWSTR ,LPCWSTR ,LPCWSTR szPassword );
#endif 
