#ifndef __rpcdce_h__
#define __rpcdce_h__
#pragma once
#ifndef IN
#define IN
#endif
#ifndef OUT
#define OUT
#endif
#ifndef OPTIONAL
#define OPTIONAL
#endif
#ifndef DECLSPEC_NORETURN
#define DECLSPEC_NORETURN
#endif
typedef I_RPC_HANDLE RPC_BINDING_HANDLE;
typedef RPC_BINDING_HANDLE handle_t;
#define rpc_binding_handle_t RPC_BINDING_HANDLE
#ifndef GUID_DEFINED
#include <guiddef.h>
#endif 
#ifndef UUID_DEFINED
#define UUID_DEFINED
typedef GUID UUID;
#ifndef uuid_t
#define uuid_t UUID
#endif
#endif
typedef struct _RPC_BINDING_VECTOR {
unsigned long Count;
RPC_BINDING_HANDLE BindingH[1];
} RPC_BINDING_VECTOR;
#ifndef rpc_binding_vector_t
#define rpc_binding_vector_t RPC_BINDING_VECTOR
#endif
typedef struct _UUID_VECTOR
{
unsigned long Count;
UUID *Uuid[1];
} UUID_VECTOR;
#ifndef uuid_vector_t
#define uuid_vector_t UUID_VECTOR
#endif
typedef void * RPC_IF_HANDLE;
#ifndef IFID_DEFINED
#define IFID_DEFINED
typedef struct _RPC_IF_ID {
UUID Uuid;
unsigned short VersMajor;
unsigned short VersMinor;
} RPC_IF_ID;
#endif
#define RPC_C_BINDING_INFINITE_TIMEOUT 10
#define RPC_C_BINDING_MIN_TIMEOUT 0
#define RPC_C_BINDING_DEFAULT_TIMEOUT 5
#define RPC_C_BINDING_MAX_TIMEOUT 9
#define RPC_C_CANCEL_INFINITE_TIMEOUT -1
#define RPC_C_LISTEN_MAX_CALLS_DEFAULT 1234
#define RPC_C_PROTSEQ_MAX_REQS_DEFAULT 10
#define RPC_C_BIND_TO_ALL_NICS 1
#define RPC_C_USE_INTERNET_PORT 1
#define RPC_C_USE_INTRANET_PORT 2
#define RPC_C_DONT_FAIL 4
#define RPC_C_MQ_TEMPORARY 0
#define RPC_C_MQ_PERMANENT 1
#define RPC_C_MQ_CLEAR_ON_OPEN 2
#define RPC_C_MQ_USE_EXISTING_SECURITY 4
#define RPC_C_MQ_AUTHN_LEVEL_NONE 0
#define RPC_C_MQ_AUTHN_LEVEL_PKT_INTEGRITY 8
#define RPC_C_MQ_AUTHN_LEVEL_PKT_PRIVACY 16
#define RPC_C_OPT_MQ_DELIVERY 1
#define RPC_C_OPT_MQ_PRIORITY 2
#define RPC_C_OPT_MQ_JOURNAL 3
#define RPC_C_OPT_MQ_ACKNOWLEDGE 4
#define RPC_C_OPT_MQ_AUTHN_SERVICE 5
#define RPC_C_OPT_MQ_AUTHN_LEVEL 6
#define RPC_C_OPT_MQ_TIME_TO_REACH_QUEUE 7
#define RPC_C_OPT_MQ_TIME_TO_BE_RECEIVED 8
#define RPC_C_OPT_BINDING_NONCAUSAL 9
#define RPC_C_OPT_SECURITY_CALLBACK 10
#define RPC_C_OPT_UNIQUE_BINDING 11
#define RPC_C_OPT_MAX_OPTIONS 12
#define RPC_C_MQ_EXPRESS 0 
#define RPC_C_MQ_RECOVERABLE 1
#define RPC_C_MQ_JOURNAL_NONE 0 
#define RPC_C_MQ_JOURNAL_DEADLETTER 1
#define RPC_C_MQ_JOURNAL_ALWAYS 2
#define RPC_C_FULL_CERT_CHAIN 1
#ifdef RPC_UNICODE_SUPPORTED
typedef struct _RPC_PROTSEQ_VECTORA {
unsigned int Count;
unsigned char * Protseq[1];
} RPC_PROTSEQ_VECTORA;
typedef struct _RPC_PROTSEQ_VECTORW
{
unsigned int Count;
unsigned short * Protseq[1];
} RPC_PROTSEQ_VECTORW;
#ifdef UNICODE
#define RPC_PROTSEQ_VECTOR RPC_PROTSEQ_VECTORW
#else 
#define RPC_PROTSEQ_VECTOR RPC_PROTSEQ_VECTORA
#endif 
#else 
typedef struct _RPC_PROTSEQ_VECTOR
{
unsigned int Count;
unsigned char * Protseq[1];
} RPC_PROTSEQ_VECTOR;
#endif 
typedef struct _RPC_POLICY {
unsigned int Length ;
unsigned long EndpointFlags ;
unsigned long NICFlags ;
} RPC_POLICY,*PRPC_POLICY ;
typedef void __RPC_USER
RPC_OBJECT_INQ_FN(UUID * ObjectUuid,UUID * TypeUuid,RPC_STATUS * Status);
typedef RPC_STATUS RPC_ENTRY
RPC_IF_CALLBACK_FN(RPC_IF_HANDLE InterfaceUuid,void *Context) ;
typedef void RPC_ENTRY
RPC_SECURITY_CALLBACK_FN(void *Context) ;
#define RPC_MGR_EPV void
typedef struct
{
unsigned int Count;
unsigned long Stats[1];
} RPC_STATS_VECTOR;
#define RPC_C_STATS_CALLS_IN 0
#define RPC_C_STATS_CALLS_OUT 1
#define RPC_C_STATS_PKTS_IN 2
#define RPC_C_STATS_PKTS_OUT 3
typedef struct { unsigned long Count; RPC_IF_ID * IfId[1]; } RPC_IF_ID_VECTOR;
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingCopy(RPC_BINDING_HANDLE SourceBinding,RPC_BINDING_HANDLE * DestinationBinding);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingFree(RPC_BINDING_HANDLE * Binding);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingSetOption(IN RPC_BINDING_HANDLE hBinding,unsigned long option,ULONG_PTR optionValue);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingInqOption(IN RPC_BINDING_HANDLE hBinding,unsigned long option,ULONG_PTR *pOptionValue);
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingFromStringBindingA(unsigned char * StringBinding,RPC_BINDING_HANDLE * Binding);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingFromStringBindingW(unsigned short * StringBinding,RPC_BINDING_HANDLE * Binding);
#ifdef UNICODE
#define RpcBindingFromStringBinding RpcBindingFromStringBindingW
#else 
#define RpcBindingFromStringBinding RpcBindingFromStringBindingA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingFromStringBinding(unsigned char * StringBinding,RPC_BINDING_HANDLE * Binding);
#endif 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcSsGetContextBinding(void *ContextHandle,RPC_BINDING_HANDLE * Binding);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingInqObject(RPC_BINDING_HANDLE Binding,UUID * ObjectUuid);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingReset(RPC_BINDING_HANDLE Binding);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingSetObject(RPC_BINDING_HANDLE Binding,UUID * ObjectUuid);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtInqDefaultProtectLevel(unsigned long AuthnSvc,unsigned long *AuthnLevel);
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingToStringBindingA(RPC_BINDING_HANDLE Binding,unsigned char * * StringBinding);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingToStringBindingW(RPC_BINDING_HANDLE Binding,unsigned short * * StringBinding);
#ifdef UNICODE
#define RpcBindingToStringBinding RpcBindingToStringBindingW
#else 
#define RpcBindingToStringBinding RpcBindingToStringBindingA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingToStringBinding(RPC_BINDING_HANDLE Binding,unsigned char * * StringBinding);
#endif 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingVectorFree(RPC_BINDING_VECTOR * * BindingVector);
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcStringBindingComposeA(unsigned char * ObjUuid,unsigned char * Protseq,unsigned char * NetworkAddr, unsigned char * Endpoint, unsigned char * Options, unsigned char * * StringBinding);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcStringBindingComposeW(unsigned short * ObjUuid,unsigned short * Protseq,unsigned short * NetworkAddr, unsigned short * Endpoint, unsigned short * Options, unsigned short * * StringBinding);
#ifdef UNICODE
#define RpcStringBindingCompose RpcStringBindingComposeW
#else 
#define RpcStringBindingCompose RpcStringBindingComposeA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcStringBindingCompose(unsigned char * ObjUuid,unsigned char * Protseq,unsigned char * NetworkAddr, unsigned char * Endpoint, unsigned char * Options, unsigned char * * StringBinding);
#endif 
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcStringBindingParseA(unsigned char * StringBinding,unsigned char * * ObjUuid,unsigned char * * Protseq, unsigned char * * NetworkAddr, unsigned char * * Endpoint, unsigned char * * NetworkOptions);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcStringBindingParseW(unsigned short * StringBinding,unsigned short * * ObjUuid,unsigned short * * Protseq, unsigned short * * NetworkAddr, unsigned short * * Endpoint, unsigned short * * NetworkOptions);
#ifdef UNICODE
#define RpcStringBindingParse RpcStringBindingParseW
#else 
#define RpcStringBindingParse RpcStringBindingParseA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcStringBindingParse(unsigned char * StringBinding,unsigned char * * ObjUuid,unsigned char * * Protseq, unsigned char * * NetworkAddr, unsigned char * * Endpoint, unsigned char * * NetworkOptions);
#endif 
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcStringFreeA(unsigned char * * String);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcStringFreeW(unsigned short * * String);
#ifdef UNICODE
#define RpcStringFree RpcStringFreeW
#else 
#define RpcStringFree RpcStringFreeA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcStringFree(unsigned char * * String);
#endif 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcIfInqId(RPC_IF_HANDLE RpcIfHandle,RPC_IF_ID * RpcIfId);
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcNetworkIsProtseqValidA(unsigned char * Protseq);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcNetworkIsProtseqValidW(unsigned short * Protseq);
#ifdef UNICODE
#define RpcNetworkIsProtseqValid RpcNetworkIsProtseqValidW
#else 
#define RpcNetworkIsProtseqValid RpcNetworkIsProtseqValidA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcNetworkIsProtseqValid(unsigned char * Protseq);
#endif 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtInqComTimeout(RPC_BINDING_HANDLE Binding,unsigned int * Timeout);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtSetComTimeout(RPC_BINDING_HANDLE Binding,unsigned int Timeout);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtSetCancelTimeout(long Timeout);
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcNetworkInqProtseqsA(RPC_PROTSEQ_VECTORA * * ProtseqVector);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcNetworkInqProtseqsW(RPC_PROTSEQ_VECTORW * * ProtseqVector);
#ifdef UNICODE
#define RpcNetworkInqProtseqs RpcNetworkInqProtseqsW
#else 
#define RpcNetworkInqProtseqs RpcNetworkInqProtseqsA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcNetworkInqProtseqs(RPC_PROTSEQ_VECTOR * * ProtseqVector);
#endif 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcObjectInqType(UUID * ObjUuid,UUID * TypeUuid);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcObjectSetInqFn(RPC_OBJECT_INQ_FN * InquiryFn);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcObjectSetType(UUID * ObjUuid,UUID * TypeUuid);
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcProtseqVectorFreeA(RPC_PROTSEQ_VECTORA * * ProtseqVector);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcProtseqVectorFreeW(RPC_PROTSEQ_VECTORW * * ProtseqVector);
#ifdef UNICODE
#define RpcProtseqVectorFree RpcProtseqVectorFreeW
#else 
#define RpcProtseqVectorFree RpcProtseqVectorFreeA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcProtseqVectorFree(RPC_PROTSEQ_VECTOR * * ProtseqVector);
#endif 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerInqBindings(RPC_BINDING_VECTOR * * BindingVector);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerInqIf(RPC_IF_HANDLE IfSpec,UUID * MgrTypeUuid,RPC_MGR_EPV * * MgrEpv);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerListen(unsigned int MinimumCallThreads,unsigned int MaxCalls,unsigned int DontWait);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerRegisterIf(RPC_IF_HANDLE IfSpec,UUID * MgrTypeUuid,RPC_MGR_EPV * MgrEpv);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerRegisterIfEx(RPC_IF_HANDLE IfSpec,UUID * MgrTypeUuid,RPC_MGR_EPV * MgrEpv, unsigned int Flags, unsigned int MaxCalls, RPC_IF_CALLBACK_FN *IfCallback);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerRegisterIf2(RPC_IF_HANDLE IfSpec,UUID * MgrTypeUuid,RPC_MGR_EPV * MgrEpv, unsigned int Flags, unsigned int MaxCalls, unsigned int MaxRpcSize, RPC_IF_CALLBACK_FN *IfCallbackFn);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUnregisterIf(RPC_IF_HANDLE IfSpec,UUID * MgrTypeUuid,unsigned int WaitForCallsToComplete);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseAllProtseqs(unsigned int MaxCalls,void * SecurityDescriptor);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseAllProtseqsEx(unsigned int MaxCalls,void * SecurityDescriptor,PRPC_POLICY Policy);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseAllProtseqsIf(unsigned int MaxCalls,RPC_IF_HANDLE IfSpec,void * SecurityDescriptor);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseAllProtseqsIfEx(unsigned int MaxCalls,RPC_IF_HANDLE IfSpec,void * SecurityDescriptor, PRPC_POLICY Policy);
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqA(unsigned char * Protseq,unsigned int MaxCalls,void * SecurityDescriptor);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqExA(unsigned char * Protseq,unsigned int MaxCalls,void * SecurityDescriptor, PRPC_POLICY Policy);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqW(unsigned short * Protseq,unsigned int MaxCalls,void * SecurityDescriptor);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqExW(unsigned short * Protseq,unsigned int MaxCalls,void * SecurityDescriptor, PRPC_POLICY Policy);
#ifdef UNICODE
#define RpcServerUseProtseq RpcServerUseProtseqW
#define RpcServerUseProtseqEx RpcServerUseProtseqExW
#else 
#define RpcServerUseProtseq RpcServerUseProtseqA
#define RpcServerUseProtseqEx RpcServerUseProtseqExA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseq(unsigned char * Protseq,unsigned int MaxCalls,void * SecurityDescriptor);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqEx(unsigned char * Protseq,unsigned int MaxCalls,void * SecurityDescriptor, PRPC_POLICY Policy);
#endif 
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqEpA(unsigned char * Protseq,unsigned int MaxCalls,unsigned char * Endpoint, void * SecurityDescriptor);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqEpExA(unsigned char * Protseq,unsigned int MaxCalls,unsigned char * Endpoint, void * SecurityDescriptor, PRPC_POLICY Policy);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqEpW(unsigned short * Protseq,unsigned int MaxCalls,unsigned short * Endpoint, void * SecurityDescriptor);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqEpExW(unsigned short * Protseq,unsigned int MaxCalls,unsigned short * Endpoint, void * SecurityDescriptor, PRPC_POLICY Policy);
#ifdef UNICODE
#define RpcServerUseProtseqEp RpcServerUseProtseqEpW
#define RpcServerUseProtseqEpEx RpcServerUseProtseqEpExW
#else 
#define RpcServerUseProtseqEp RpcServerUseProtseqEpA
#define RpcServerUseProtseqEpEx RpcServerUseProtseqEpExA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqEp(unsigned char * Protseq,unsigned int MaxCalls,unsigned char * Endpoint, void * SecurityDescriptor);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqEpEx(unsigned char * Protseq,unsigned int MaxCalls,unsigned char * Endpoint, void * SecurityDescriptor, PRPC_POLICY Policy);
#endif 
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqIfA(unsigned char * Protseq,unsigned int MaxCalls,RPC_IF_HANDLE IfSpec, void * SecurityDescriptor);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqIfExA(unsigned char * Protseq,unsigned int MaxCalls,RPC_IF_HANDLE IfSpec, void * SecurityDescriptor, PRPC_POLICY Policy);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqIfW(unsigned short * Protseq,unsigned int MaxCalls,RPC_IF_HANDLE IfSpec, void * SecurityDescriptor);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqIfExW(unsigned short * Protseq,unsigned int MaxCalls,RPC_IF_HANDLE IfSpec, void * SecurityDescriptor, PRPC_POLICY Policy);
#ifdef UNICODE
#define RpcServerUseProtseqIf RpcServerUseProtseqIfW
#define RpcServerUseProtseqIfEx RpcServerUseProtseqIfExW
#else 
#define RpcServerUseProtseqIf RpcServerUseProtseqIfA
#define RpcServerUseProtseqIfEx RpcServerUseProtseqIfExA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqIf(unsigned char * Protseq,unsigned int MaxCalls,RPC_IF_HANDLE IfSpec, void * SecurityDescriptor);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerUseProtseqIfEx(unsigned char * Protseq,unsigned int MaxCalls,RPC_IF_HANDLE IfSpec, void * SecurityDescriptor, PRPC_POLICY Policy);
#endif 
RPCRTAPI void RPC_ENTRY RpcServerYield();
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtStatsVectorFree(RPC_STATS_VECTOR ** StatsVector);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtInqStats(RPC_BINDING_HANDLE Binding,RPC_STATS_VECTOR ** Statistics);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtIsServerListening(RPC_BINDING_HANDLE Binding);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtStopServerListening(RPC_BINDING_HANDLE Binding);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtWaitServerListen(void);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtSetServerStackSize(unsigned long ThreadStackSize);
RPCRTAPI void RPC_ENTRY RpcSsDontSerializeContext(void);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtEnableIdleCleanup(void);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtInqIfIds(RPC_BINDING_HANDLE Binding,RPC_IF_ID_VECTOR * * IfIdVector);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcIfIdVectorFree(RPC_IF_ID_VECTOR * * IfIdVector);
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtInqServerPrincNameA(RPC_BINDING_HANDLE Binding,unsigned long AuthnSvc,unsigned char * * ServerPrincName);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtInqServerPrincNameW(RPC_BINDING_HANDLE Binding,unsigned long AuthnSvc,unsigned short * * ServerPrincName);
#ifdef UNICODE
#define RpcMgmtInqServerPrincName RpcMgmtInqServerPrincNameW
#else 
#define RpcMgmtInqServerPrincName RpcMgmtInqServerPrincNameA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtInqServerPrincName(RPC_BINDING_HANDLE Binding,unsigned long AuthnSvc,unsigned char * * ServerPrincName);
#endif 
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerInqDefaultPrincNameA(unsigned long AuthnSvc,unsigned char * * PrincName);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerInqDefaultPrincNameW(unsigned long AuthnSvc,unsigned short * * PrincName);
#ifdef UNICODE
#define RpcServerInqDefaultPrincName RpcServerInqDefaultPrincNameW
#else 
#define RpcServerInqDefaultPrincName RpcServerInqDefaultPrincNameA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerInqDefaultPrincName(unsigned long AuthnSvc,unsigned char * * PrincName);
#endif 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcEpResolveBinding(RPC_BINDING_HANDLE Binding,RPC_IF_HANDLE IfSpec);
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcNsBindingInqEntryNameA(RPC_BINDING_HANDLE Binding,unsigned long EntryNameSyntax,unsigned char * * EntryName);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcNsBindingInqEntryNameW(RPC_BINDING_HANDLE Binding,unsigned long EntryNameSyntax,unsigned short * * EntryName);
#ifdef UNICODE
#define RpcNsBindingInqEntryName RpcNsBindingInqEntryNameW
#else 
#define RpcNsBindingInqEntryName RpcNsBindingInqEntryNameA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcNsBindingInqEntryName(RPC_BINDING_HANDLE Binding,unsigned long EntryNameSyntax,unsigned char * * EntryName);
#endif 
typedef void * RPC_AUTH_IDENTITY_HANDLE;
typedef void * RPC_AUTHZ_HANDLE;
#define RPC_C_AUTHN_LEVEL_DEFAULT 0
#define RPC_C_AUTHN_LEVEL_NONE 1
#define RPC_C_AUTHN_LEVEL_CONNECT 2
#define RPC_C_AUTHN_LEVEL_CALL 3
#define RPC_C_AUTHN_LEVEL_PKT 4
#define RPC_C_AUTHN_LEVEL_PKT_INTEGRITY 5
#define RPC_C_AUTHN_LEVEL_PKT_PRIVACY 6
#define RPC_C_IMP_LEVEL_DEFAULT 0
#define RPC_C_IMP_LEVEL_ANONYMOUS 1
#define RPC_C_IMP_LEVEL_IDENTIFY 2
#define RPC_C_IMP_LEVEL_IMPERSONATE 3
#define RPC_C_IMP_LEVEL_DELEGATE 4
#define RPC_C_QOS_IDENTITY_STATIC 0
#define RPC_C_QOS_IDENTITY_DYNAMIC 1
#define RPC_C_QOS_CAPABILITIES_DEFAULT 0
#define RPC_C_QOS_CAPABILITIES_MUTUAL_AUTH 1
#define RPC_C_QOS_CAPABILITIES_MAKE_FULLSIC 2
#define RPC_C_QOS_CAPABILITIES_ANY_AUTHORITY 4
#define RPC_C_PROTECT_LEVEL_DEFAULT(RPC_C_AUTHN_LEVEL_DEFAULT)
#define RPC_C_PROTECT_LEVEL_NONE(RPC_C_AUTHN_LEVEL_NONE)
#define RPC_C_PROTECT_LEVEL_CONNECT(RPC_C_AUTHN_LEVEL_CONNECT)
#define RPC_C_PROTECT_LEVEL_CALL(RPC_C_AUTHN_LEVEL_CALL)
#define RPC_C_PROTECT_LEVEL_PKT(RPC_C_AUTHN_LEVEL_PKT)
#define RPC_C_PROTECT_LEVEL_PKT_INTEGRITY(RPC_C_AUTHN_LEVEL_PKT_INTEGRITY)
#define RPC_C_PROTECT_LEVEL_PKT_PRIVACY(RPC_C_AUTHN_LEVEL_PKT_PRIVACY)
#define RPC_C_AUTHN_NONE 0
#define RPC_C_AUTHN_DCE_PRIVATE 1
#define RPC_C_AUTHN_DCE_PUBLIC 2
#define RPC_C_AUTHN_DEC_PUBLIC 4
#define RPC_C_AUTHN_GSS_NEGOTIATE 9
#define RPC_C_AUTHN_WINNT 10
#define RPC_C_AUTHN_GSS_SCHANNEL 14
#define RPC_C_AUTHN_GSS_KERBEROS 16
#define RPC_C_AUTHN_DPA 17
#define RPC_C_AUTHN_MSN 18
#define RPC_C_AUTHN_MQ 100
#define RPC_C_AUTHN_DEFAULT 0xffffffff
#define RPC_C_NO_CREDENTIALS ((RPC_AUTH_IDENTITY_HANDLE) ~0UL)
#define RPC_C_SECURITY_QOS_VERSION 1L
typedef struct _RPC_SECURITY_QOS {
unsigned long Version;
unsigned long Capabilities;
unsigned long IdentityTracking;
unsigned long ImpersonationType;
} RPC_SECURITY_QOS,*PRPC_SECURITY_QOS;
#if defined(__RPC_DOS__) || defined(__RPC_WIN16__)
typedef struct _SEC_WINNT_AUTH_IDENTITY
{
char *User;
char *Domain;
char *Password;
} SEC_WINNT_AUTH_IDENTITY;
#else
#define SEC_WINNT_AUTH_IDENTITY_ANSI 1
#define SEC_WINNT_AUTH_IDENTITY_UNICODE 2
typedef struct _SEC_WINNT_AUTH_IDENTITY_W {
unsigned short *User;
unsigned long UserLength;
unsigned short *Domain;
unsigned long DomainLength;
unsigned short *Password;
unsigned long PasswordLength;
unsigned long Flags;
} SEC_WINNT_AUTH_IDENTITY_W,*PSEC_WINNT_AUTH_IDENTITY_W;
typedef struct _SEC_WINNT_AUTH_IDENTITY_A {
unsigned char *User;
unsigned long UserLength;
unsigned char *Domain;
unsigned long DomainLength;
unsigned char *Password;
unsigned long PasswordLength;
unsigned long Flags;
} SEC_WINNT_AUTH_IDENTITY_A,*PSEC_WINNT_AUTH_IDENTITY_A;
#ifdef UNICODE
#define SEC_WINNT_AUTH_IDENTITY SEC_WINNT_AUTH_IDENTITY_W
#define PSEC_WINNT_AUTH_IDENTITY PSEC_WINNT_AUTH_IDENTITY_W
#define _SEC_WINNT_AUTH_IDENTITY _SEC_WINNT_AUTH_IDENTITY_W
#else 
#define SEC_WINNT_AUTH_IDENTITY SEC_WINNT_AUTH_IDENTITY_A
#define PSEC_WINNT_AUTH_IDENTITY PSEC_WINNT_AUTH_IDENTITY_A
#define _SEC_WINNT_AUTH_IDENTITY _SEC_WINNT_AUTH_IDENTITY_A
#endif 
#endif 
#define RPC_C_AUTHZ_NONE 0
#define RPC_C_AUTHZ_NAME 1
#define RPC_C_AUTHZ_DCE 2
#define RPC_C_AUTHZ_DEFAULT 0xffffffff
RPCRTAPI RPC_STATUS RPC_ENTRY RpcImpersonateClient(RPC_BINDING_HANDLE BindingHandle);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcRevertToSelfEx(RPC_BINDING_HANDLE BindingHandle);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcRevertToSelf();
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingInqAuthClientA(RPC_BINDING_HANDLE ClientBinding,RPC_AUTHZ_HANDLE * Privs,unsigned char * * ServerPrincName, unsigned long * AuthnLevel,  unsigned long * AuthnSvc, unsigned long * AuthzSvc);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingInqAuthClientW(RPC_BINDING_HANDLE ClientBinding,RPC_AUTHZ_HANDLE * Privs,unsigned short * * ServerPrincName,  unsigned long * AuthnLevel,  unsigned long * AuthnSvc, unsigned long * AuthzSvc);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingInqAuthClientExA(RPC_BINDING_HANDLE ClientBinding,RPC_AUTHZ_HANDLE * Privs,unsigned char * * ServerPrincName, unsigned long * AuthnLevel, unsigned long * AuthnSvc, unsigned long * AuthzSvc, unsigned long Flags);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingInqAuthClientExW(RPC_BINDING_HANDLE ClientBinding,RPC_AUTHZ_HANDLE * Privs,unsigned short * * ServerPrincName, unsigned long * AuthnLevel, unsigned long * AuthnSvc, unsigned long * AuthzSvc, unsigned long Flags);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingInqAuthInfoA(RPC_BINDING_HANDLE Binding,unsigned char * * ServerPrincName,unsigned long * AuthnLevel, unsigned long * AuthnSvc, RPC_AUTH_IDENTITY_HANDLE * AuthIdentity, unsigned long * AuthzSvc);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingInqAuthInfoW(RPC_BINDING_HANDLE Binding,unsigned short * * ServerPrincName,unsigned long * AuthnLevel, unsigned long * AuthnSvc, RPC_AUTH_IDENTITY_HANDLE * AuthIdentity, unsigned long * AuthzSvc);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingSetAuthInfoA(RPC_BINDING_HANDLE Binding,unsigned char * ServerPrincName,unsigned long AuthnLevel, unsigned long AuthnSvc, RPC_AUTH_IDENTITY_HANDLE AuthIdentity, unsigned long AuthzSvc);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingSetAuthInfoExA(RPC_BINDING_HANDLE Binding,unsigned char * ServerPrincName,unsigned long AuthnLevel, unsigned long AuthnSvc, RPC_AUTH_IDENTITY_HANDLE AuthIdentity, unsigned long AuthzSvc, RPC_SECURITY_QOS *SecurityQos);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingSetAuthInfoW(RPC_BINDING_HANDLE Binding,unsigned short * ServerPrincName,unsigned long AuthnLevel, unsigned long AuthnSvc, RPC_AUTH_IDENTITY_HANDLE AuthIdentity, unsigned long AuthzSvc);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingSetAuthInfoExW(RPC_BINDING_HANDLE Binding,unsigned short * ServerPrincName,unsigned long AuthnLevel, unsigned long AuthnSvc, RPC_AUTH_IDENTITY_HANDLE AuthIdentity, unsigned long AuthzSvc, RPC_SECURITY_QOS *SecurityQOS);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingInqAuthInfoExA(RPC_BINDING_HANDLE Binding,unsigned char * * ServerPrincName,unsigned long * AuthnLevel, unsigned long * AuthnSvc, RPC_AUTH_IDENTITY_HANDLE * AuthIdentity, unsigned long * AuthzSvc, unsigned long RpcQosVersion, RPC_SECURITY_QOS *SecurityQOS);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingInqAuthInfoExW(RPC_BINDING_HANDLE Binding,unsigned short * * ServerPrincName,unsigned long * AuthnLevel, unsigned long * AuthnSvc, RPC_AUTH_IDENTITY_HANDLE * AuthIdentity, unsigned long * AuthzSvc, unsigned long RpcQosVersion, RPC_SECURITY_QOS *SecurityQOS);
typedef void
(__RPC_USER * RPC_AUTH_KEY_RETRIEVAL_FN)(void * Arg,unsigned short * ServerPrincName,unsigned long KeyVer, void * * Key, RPC_STATUS * Status);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerRegisterAuthInfoA(unsigned char * ServerPrincName,unsigned long AuthnSvc,RPC_AUTH_KEY_RETRIEVAL_FN GetKeyFn, void * Arg);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerRegisterAuthInfoW(unsigned short * ServerPrincName,unsigned long AuthnSvc,RPC_AUTH_KEY_RETRIEVAL_FN GetKeyFn, void * Arg);
#ifdef UNICODE
#define RpcBindingInqAuthClient RpcBindingInqAuthClientW
#define RpcBindingInqAuthClientEx RpcBindingInqAuthClientExW
#define RpcBindingInqAuthInfo RpcBindingInqAuthInfoW
#define RpcBindingSetAuthInfo RpcBindingSetAuthInfoW
#define RpcServerRegisterAuthInfo RpcServerRegisterAuthInfoW
#define RpcBindingInqAuthInfoEx RpcBindingInqAuthInfoExW
#define RpcBindingSetAuthInfoEx RpcBindingSetAuthInfoExW
#else 
#define RpcBindingInqAuthClient RpcBindingInqAuthClientA
#define RpcBindingInqAuthClientEx RpcBindingInqAuthClientExA
#define RpcBindingInqAuthInfo RpcBindingInqAuthInfoA
#define RpcBindingSetAuthInfo RpcBindingSetAuthInfoA
#define RpcServerRegisterAuthInfo RpcServerRegisterAuthInfoA
#define RpcBindingInqAuthInfoEx RpcBindingInqAuthInfoExA
#define RpcBindingSetAuthInfoEx RpcBindingSetAuthInfoExA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingInqAuthClient(RPC_BINDING_HANDLE ClientBinding,RPC_AUTHZ_HANDLE * Privs,unsigned char * * ServerPrincName, unsigned long * AuthnLevel, unsigned long * AuthnSvc, unsigned long * AuthzSvc);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingInqAuthClientEx(RPC_BINDING_HANDLE ClientBinding,RPC_AUTHZ_HANDLE * Privs,unsigned char * * ServerPrincName, unsigned long * AuthnLevel, unsigned long * AuthnSvc, unsigned long * AuthzSvc, unsigned long Flags);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingInqAuthInfo(RPC_BINDING_HANDLE Binding,unsigned char * * ServerPrincName,unsigned long * AuthnLevel, unsigned long * AuthnSvc, RPC_AUTH_IDENTITY_HANDLE * AuthIdentity, unsigned long * AuthzSvc);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingSetAuthInfo(RPC_BINDING_HANDLE Binding,unsigned char * ServerPrincName,unsigned long AuthnLevel, unsigned long AuthnSvc, RPC_AUTH_IDENTITY_HANDLE AuthIdentity, unsigned long AuthzSvc);
typedef void
(__RPC_USER * RPC_AUTH_KEY_RETRIEVAL_FN)(void * Arg,unsigned char * ServerPrincName,unsigned long KeyVer, void * * Key, RPC_STATUS * Status);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerRegisterAuthInfo(unsigned char * ServerPrincName,unsigned long AuthnSvc,RPC_AUTH_KEY_RETRIEVAL_FN GetKeyFn, void * Arg);
#endif 
typedef struct {
unsigned char * UserName;
unsigned char * ComputerName;
unsigned short Privilege;
unsigned long AuthFlags;
} RPC_CLIENT_INFORMATION1,* PRPC_CLIENT_INFORMATION1;
RPCRTAPI RPC_STATUS RPC_ENTRY RpcBindingServerFromClient(RPC_BINDING_HANDLE ClientBinding,RPC_BINDING_HANDLE * ServerBinding);
RPCRTAPI DECLSPEC_NORETURN
void RPC_ENTRY RpcRaiseException(RPC_STATUS exception);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcTestCancel();
RPCRTAPI RPC_STATUS RPC_ENTRY RpcServerTestCancel(RPC_BINDING_HANDLE BindingHandle);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcCancelThread(void * Thread);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcCancelThreadEx(void * Thread,long Timeout);
RPCRTAPI RPC_STATUS RPC_ENTRY UuidCreate(UUID * Uuid);
RPCRTAPI RPC_STATUS RPC_ENTRY UuidCreateSequential(UUID * Uuid);
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY UuidToStringA(UUID *,unsigned char * * );
RPCRTAPI RPC_STATUS RPC_ENTRY UuidFromStringA(unsigned char *,UUID *);
RPCRTAPI RPC_STATUS RPC_ENTRY UuidToStringW(UUID *,unsigned short * *);
RPCRTAPI RPC_STATUS RPC_ENTRY UuidFromStringW(unsigned short *,UUID *);
#ifdef UNICODE
#define UuidFromString UuidFromStringW
#define UuidToString UuidToStringW
#else 
#define UuidFromString UuidFromStringA
#define UuidToString UuidToStringA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY UuidToString(UUID *,unsigned char * *);
RPCRTAPI RPC_STATUS RPC_ENTRY UuidFromString(unsigned char *,UUID *);
#endif 
RPCRTAPI signed int
RPC_ENTRY UuidCompare(UUID *,UUID *,RPC_STATUS *);
RPCRTAPI RPC_STATUS RPC_ENTRY UuidCreateNil(UUID * NilUuid);
RPCRTAPI int RPC_ENTRY UuidEqual(UUID * Uuid1,UUID * Uuid2,RPC_STATUS * Status);
RPCRTAPI unsigned short
RPC_ENTRY UuidHash(UUID * Uuid,RPC_STATUS * Status);
RPCRTAPI int RPC_ENTRY UuidIsNil(UUID * Uuid,RPC_STATUS * Status);
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcEpRegisterNoReplaceA(RPC_IF_HANDLE IfSpec,RPC_BINDING_VECTOR * BindingVector,UUID_VECTOR * UuidVector, unsigned char * Annotation);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcEpRegisterNoReplaceW(RPC_IF_HANDLE IfSpec,RPC_BINDING_VECTOR * BindingVector,UUID_VECTOR * UuidVector, unsigned short * Annotation);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcEpRegisterA(RPC_IF_HANDLE IfSpec,RPC_BINDING_VECTOR * BindingVector,UUID_VECTOR * UuidVector, unsigned char * Annotation);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcEpRegisterW(RPC_IF_HANDLE IfSpec,RPC_BINDING_VECTOR * BindingVector,UUID_VECTOR * UuidVector, unsigned short * Annotation);
#ifdef UNICODE
#define RpcEpRegisterNoReplace RpcEpRegisterNoReplaceW
#define RpcEpRegister RpcEpRegisterW
#else 
#define RpcEpRegisterNoReplace RpcEpRegisterNoReplaceA
#define RpcEpRegister RpcEpRegisterA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcEpRegisterNoReplace(RPC_IF_HANDLE IfSpec,RPC_BINDING_VECTOR * BindingVector,UUID_VECTOR * UuidVector, unsigned char * Annotation);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcEpRegister(RPC_IF_HANDLE IfSpec,RPC_BINDING_VECTOR * BindingVector,UUID_VECTOR * UuidVector, unsigned char * Annotation);
#endif 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcEpUnregister(RPC_IF_HANDLE IfSpec,RPC_BINDING_VECTOR * BindingVector,UUID_VECTOR * UuidVector);
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY DceErrorInqTextA(RPC_STATUS RpcStatus,unsigned char * ErrorText);
RPCRTAPI RPC_STATUS RPC_ENTRY DceErrorInqTextW(RPC_STATUS RpcStatus,unsigned short * ErrorText);
#ifdef UNICODE
#define DceErrorInqText DceErrorInqTextW
#else 
#define DceErrorInqText DceErrorInqTextA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY DceErrorInqText(RPC_STATUS,unsigned char *);
#endif 
#define DCE_C_ERROR_STRING_LEN 256
typedef I_RPC_HANDLE * RPC_EP_INQ_HANDLE;
#define RPC_C_EP_ALL_ELTS 0
#define RPC_C_EP_MATCH_BY_IF 1
#define RPC_C_EP_MATCH_BY_OBJ 2
#define RPC_C_EP_MATCH_BY_BOTH 3
#define RPC_C_VERS_ALL 1
#define RPC_C_VERS_COMPATIBLE 2
#define RPC_C_VERS_EXACT 3
#define RPC_C_VERS_MAJOR_ONLY 4
#define RPC_C_VERS_UPTO 5
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtEpEltInqBegin(RPC_BINDING_HANDLE,unsigned long,RPC_IF_ID *,unsigned long,UUID *,RPC_EP_INQ_HANDLE *);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtEpEltInqDone(RPC_EP_INQ_HANDLE * InquiryContext);
#ifdef RPC_UNICODE_SUPPORTED
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtEpEltInqNextA(RPC_EP_INQ_HANDLE,RPC_IF_ID *,RPC_BINDING_HANDLE *,UUID *,unsigned char * *);
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtEpEltInqNextW(RPC_EP_INQ_HANDLE,RPC_IF_ID *,RPC_BINDING_HANDLE *,UUID *,unsigned short * *);
#ifdef UNICODE
#define RpcMgmtEpEltInqNext RpcMgmtEpEltInqNextW
#else 
#define RpcMgmtEpEltInqNext RpcMgmtEpEltInqNextA
#endif 
#else 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtEpEltInqNext(RPC_EP_INQ_HANDLE,RPC_IF_ID *,RPC_BINDING_HANDLE *,unsigned char * *);
#endif 
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtEpUnregister(RPC_BINDING_HANDLE,RPC_IF_ID *,RPC_BINDING_HANDLE,UUID *);
typedef int
(__RPC_API * RPC_MGMT_AUTHORIZATION_FN)(RPC_BINDING_HANDLE,unsigned long,RPC_STATUS *);
#define RPC_C_MGMT_INQ_IF_IDS 0
#define RPC_C_MGMT_INQ_PRINC_NAME 1
#define RPC_C_MGMT_INQ_STATS 2
#define RPC_C_MGMT_IS_SERVER_LISTEN 3
#define RPC_C_MGMT_STOP_SERVER_LISTEN 4
RPCRTAPI RPC_STATUS RPC_ENTRY RpcMgmtSetAuthorizationFn(RPC_MGMT_AUTHORIZATION_FN);
#define RPC_C_PARM_MAX_PACKET_LENGTH 1
#define RPC_C_PARM_BUFFER_LENGTH 2
#define RPC_IF_AUTOLISTEN 1
#define RPC_IF_OLE 2
#define RPC_IF_ALLOW_UNKNOWN_AUTHORITY 4
#define RPC_IF_ALLOW_SECURE_ONLY 8
#include <rpcdcep.h>
#endif 
