#if	!defined(_INC_RTP_H_)
#define	_INC_RTP_H_
#define	RTP_TYPE 2
#define	RTP_VERSION RTP_TYPE
#define	RTP_MAX_SDES 256
#define	RTP_MAX_EKEY 32
#define	NUM_COLLISION_ENTRIES	10
#define	MAX_ADDR_LEN	80
typedef	struct _RTP_SDES_ITEM {
	BYTE Type;
	BYTE TextLength;
	BYTE Text[RTP_MAX_SDES];
}	RTCP_SDES_ITEM, *PRTCP_SDES_ITEM;
typedef	enum { RTCP_SDES_END,	 RTCP_SDES_CNAME,RTCP_SDES_NAME,	
	RTCP_SDES_EMAIL, RTCP_SDES_PHONE, RTCP_SDES_LOC, RTCP_SDES_TOOL,	
	RTCP_SDES_NOTE,	RTCP_SDES_PRIV,	RTCP_SDES_LAST	}
RTCP_SDES_TYPE_T;
typedef	struct _RTCP_SENDER_REPORT {
	DWORD NtpTimestampSec;
	DWORD NtpTimestampFrac;
	DWORD RtpTimestamp;
	DWORD TotalPackets;
	DWORD TotalOctets;
}	RTCP_SENDER_REPORT, *PRTCP_SENDER_REPORT;
typedef	struct _RTCP_RECEIVER_REPORT {
	DWORD FractionLost:8;
	DWORD TotalLostPackets:24;
	DWORD HighestSequenceNum;
	DWORD InterarrivalJitter;
	DWORD LastSRTimestamp;
	DWORD DelaySinceLastSR;
}	RTCP_RECEIVER_REPORT, *PRTCP_RECEIVER_REPORT;
typedef	struct _RTCP_PARTICIPANT_REPORT {
	DWORD SSRC;
	RTCP_SENDER_REPORT LastSR;
	RTCP_RECEIVER_REPORT LastIncomingRR;
	RTCP_RECEIVER_REPORT LastOutgoingRR;
}	RTCP_PARTICIPANT_REPORT, *PRTCP_PARTICIPANT_REPORT;
	
typedef	struct _RTP_HEADER {
	WORD NumCSRC:4; 
	WORD fExtHeader:1; 
	WORD fPadding:1; 
	WORD Version:2; 
	WORD PayloadType:7;
	WORD fMarker:1;
	WORD SequenceNum;
	DWORD Timestamp;
	DWORD SSRC;
}	RTP_HEADER, *PRTP_HEADER;
typedef	struct _RTP_HEADER_X {
	WORD Identifier;
	WORD DataLength;
	DWORD Data[1];
}	RTP_HEADER_X, *PRTP_HEADER_X;
typedef	struct _RTP_ENCRYPTION_INFO {
	DWORD Scheme;
	DWORD Key[RTP_MAX_EKEY];
}	RTP_ENCRYPTION_INFO, *PRTP_ENCRYPTION_INFO;
#define	B2M(b) (1 << (b))
#define	DXMRTP_EVENTBASE (EC_USER+0)
typedef	enum 
{
	DXMRTP_NO_EVENT,
	DXMRTP_NEW_SOURCE_EVENT,	
	DXMRTP_RECV_RTCP_RECV_REPORT_EVENT,	
	DXMRTP_RECV_RTCP_SNDR_REPORT_EVENT,	
	DXMRTP_LOCAL_COLLISION_EVENT,	
	DXMRTP_REMOTE_COLLISION_EVENT,	
	DXMRTP_TIMEOUT_EVENT,	
	DXMRTP_BYE_EVENT,	
	DXMRTP_RTCP_WS_RCV_ERROR,	
	DXMRTP_RTCP_WS_XMT_ERROR,	
	DXMRTP_LAST_EVENT
}	DXMRTP_EVENT_T;
typedef	struct _SDES_DATA
{
	DWORD	dwSdesType;	
	char	sdesBfr[RTP_MAX_SDES];
	DWORD	dwSdesLength;	
	DWORD	dwSdesFrequency;	
	DWORD	dwSdesEncrypted;	
}	SDES_DATA, *PSDES_DATA;
#define	DXMRTP_QOSEVENTBASE (DXMRTP_EVENTBASE + 32)
typedef	enum {
	DXMRTP_QOSEVENT_NOQOS,
	DXMRTP_QOSEVENT_RECEIVERS,
	DXMRTP_QOSEVENT_SENDERS,
	DXMRTP_QOSEVENT_NO_SENDERS,
	DXMRTP_QOSEVENT_NO_RECEIVERS,
	DXMRTP_QOSEVENT_REQUEST_CONFIRMED,
	DXMRTP_QOSEVENT_ADMISSION_FAILURE,
	DXMRTP_QOSEVENT_POLICY_FAILURE,
	DXMRTP_QOSEVENT_BAD_STYLE,
	DXMRTP_QOSEVENT_BAD_OBJECT,
	DXMRTP_QOSEVENT_TRAFFIC_CTRL_ERROR,
	DXMRTP_QOSEVENT_GENERIC_ERROR,
	DXMRTP_QOSEVENT_NOT_ALLOWEDTOSEND,
	DXMRTP_QOSEVENT_ALLOWEDTOSEND,
	DXMRTP_QOSEVENT_LAST
}	DXMRTP_QOSEVENT_T;
#if	!defined(RTPDMX_EVENTBASE)
#define	RTPDMX_EVENTBASE (EC_USER+100)
typedef	enum { RTPDEMUX_SSRC_MAPPED, RTPDEMUX_SSRC_UNMAPPED, 
	RTPDEMUX_PIN_MAPPED,	RTPDEMUX_PIN_UNMAPPED, RTPDEMUX_NO_PINS_AVAILABLE, 
	RTPDEMUX_NO_PAYLOAD_TYPE	} RTPDEMUX_EVENT_t;
#endif
#define	RTP_MAX_CLASSES 4
enum	{ RTP_CLASS_AUDIO, RTP_CLASS_VIDEO };
enum	{ DXMRTP_RESERVE_WILCARD, DXMRTP_RESERVE_EXPLICIT };
#endif	



