#ifndef __seh_h__
#define __seh_h__
typedef enum _EXCEPTION_DISPOSITION {
	ExceptionContinueExecution,
	ExceptionContinueSearch,
	ExceptionNestedException,
	ExceptionCollidedUnwind
} EXCEPTION_DISPOSITION;
//
// Legal values for the expression in except()
//
#define EXCEPTION_EXECUTE_HANDLER       1
#define EXCEPTION_CONTINUE_SEARCH       0
#define EXCEPTION_CONTINUE_EXECUTION    -1
// The exception record structure
#ifndef _EXCEPTION_RECORD_DEFINED_
#define _EXCEPTION_RECORD_DEFINED_
#define EXCEPTION_MAXIMUM_PARAMETERS 15
typedef struct _EXCEPTION_RECORD {
	unsigned ExceptionCode;
	unsigned ExceptionFlags;
	struct _EXCEPTION_RECORD *ExceptionRecord;
	void *ExceptionAddress;
	unsigned NumberParameters;
	unsigned ExceptionInformation[EXCEPTION_MAXIMUM_PARAMETERS];
} EXCEPTION_RECORD,*PEXCEPTION_RECORD,*LPEXCEPTION_RECORD;
#endif
#ifndef _CONTEXT_DEFINED_
#define _CONTEXT_DEFINED_
#define MAXIMUM_SUPPORTED_EXTENSION	512
typedef struct _FLOATING_SAVE_AREA {
	unsigned ControlWord;
	unsigned StatusWord;
	unsigned TagWord;
	unsigned ErrorOffset;
	unsigned ErrorSelector;
	unsigned DataOffset;
	unsigned DataSelector;
	unsigned char RegisterArea[80];
	unsigned Cr0NpxState;
} FLOATING_SAVE_AREA;
typedef struct _CONTEXT {
	unsigned ContextFlags;
	unsigned Dr0;
	unsigned Dr1;
	unsigned Dr2;
	unsigned Dr3;
	unsigned Dr6;
	unsigned Dr7;
	FLOATING_SAVE_AREA FloatSave;
	unsigned SegGs;
	unsigned SegFs;
	unsigned SegEs;
	unsigned SegDs;
	unsigned Edi;
	unsigned Esi;
	unsigned Ebx;
	unsigned Edx;
	unsigned Ecx;
	unsigned Eax;
	unsigned Ebp;
	unsigned Eip;
	unsigned SegCs;
	unsigned EFlags;
	unsigned Esp;
	unsigned SegSs;
	unsigned char ExtendedRegisters[MAXIMUM_SUPPORTED_EXTENSION];
} CONTEXT,*PCONTEXT,*LPCONTEXT;
#endif
#ifndef _EXCEPTION_POINTERS_DEFINED_
#define _EXCEPTION_POINTERS_DEFINED_
typedef struct _EXCEPTION_POINTERS {
	PEXCEPTION_RECORD ExceptionRecord;
	CONTEXT *ContextRecord;
} EXCEPTION_POINTERS,*PEXCEPTION_POINTERS,*LPEXCEPTION_POINTERS;
#endif
EXCEPTION_POINTERS *GetExceptionInformation(void);
extern EXCEPTION_POINTERS _ExceptionPointers;
#define GetExceptionInformation() (&_ExceptionPointers)
extern unsigned int _ExceptionCode;
#define GetExceptionCode() (_ExceptionCode)
#endif
