#ifndef __setupapi_h__
#define __setupapi_h__
#ifndef __windows_h__
#include "windows.h"
#endif
#ifndef __oledlg_h__
#include "oledlg.h"
#endif
#define DECLSPEC_IMPORT
#ifndef __LPGUID_DEFINED__
#define __LPGUID_DEFINED__
typedef GUID *LPGUID;
#endif
#include <commctrl.h>
#define LINE_LEN 256 
#define MAX_INF_STRING_LENGTH 4096 
#define MAX_TITLE_LEN 60
#define MAX_INSTRUCTION_LEN 256
#define MAX_LABEL_LEN 30
#define MAX_SERVICE_NAME_LEN 256
#define MAX_SUBTITLE_LEN 256
#define SP_MAX_MACHINENAME_LENGTH (MAX_COMPUTERNAME_LENGTH + 3)
typedef PVOID HINF;
typedef struct _INFCONTEXT {
PVOID Inf;
PVOID CurrentInf;
UINT Section;
UINT Line;
} INFCONTEXT,*PINFCONTEXT;
typedef struct _SP_INF_INFORMATION {
DWORD InfStyle;
DWORD InfCount;
BYTE VersionData[ANYSIZE_ARRAY];
} SP_INF_INFORMATION,*PSP_INF_INFORMATION;
typedef struct _SP_ALTPLATFORM_INFO {
DWORD cbSize;
DWORD Platform;
DWORD MajorVersion;
DWORD MinorVersion;
WORD ProcessorArchitecture;
WORD Reserved; 
} SP_ALTPLATFORM_INFO,*PSP_ALTPLATFORM_INFO;
typedef struct _SP_ORIGINAL_FILE_INFO_A {
DWORD cbSize;
CHAR OriginalInfName[MAX_PATH];
CHAR OriginalCatalogName[MAX_PATH];
} SP_ORIGINAL_FILE_INFO_A,*PSP_ORIGINAL_FILE_INFO_A;
typedef struct _SP_ORIGINAL_FILE_INFO_W {
DWORD cbSize;
WCHAR OriginalInfName[MAX_PATH];
WCHAR OriginalCatalogName[MAX_PATH];
} SP_ORIGINAL_FILE_INFO_W,*PSP_ORIGINAL_FILE_INFO_W;
#ifdef UNICODE
typedef SP_ORIGINAL_FILE_INFO_W SP_ORIGINAL_FILE_INFO;
typedef PSP_ORIGINAL_FILE_INFO_W PSP_ORIGINAL_FILE_INFO;
#else
typedef SP_ORIGINAL_FILE_INFO_A SP_ORIGINAL_FILE_INFO;
typedef PSP_ORIGINAL_FILE_INFO_A PSP_ORIGINAL_FILE_INFO;
#endif
#define INF_STYLE_NONE 0
#define INF_STYLE_OLDNT 1
#define INF_STYLE_WIN4 2
#define INF_STYLE_CACHE_ENABLE 16
#define INF_STYLE_CACHE_DISABLE 32
#define DIRID_ABSOLUTE -1 
#define DIRID_ABSOLUTE_16BIT 0xffff
#define DIRID_NULL 0
#define DIRID_SRCPATH 1
#define DIRID_WINDOWS 10
#define DIRID_SYSTEM 11 
#define DIRID_DRIVERS 12
#define DIRID_IOSUBSYS DIRID_DRIVERS
#define DIRID_INF 17
#define DIRID_HELP 18
#define DIRID_FONTS 20
#define DIRID_VIEWERS 21
#define DIRID_COLOR 23
#define DIRID_APPS 24
#define DIRID_SHARED 25
#define DIRID_BOOT 30
#define DIRID_SYSTEM16 50
#define DIRID_SPOOL 51
#define DIRID_SPOOLDRIVERS 52
#define DIRID_USERPROFILE 53
#define DIRID_LOADER 54
#define DIRID_PRINTPROCESSOR 55
#define DIRID_DEFAULT DIRID_SYSTEM
#define DIRID_COMMON_STARTMENU 16406 
#define DIRID_COMMON_PROGRAMS 16407 
#define DIRID_COMMON_STARTUP 16408 
#define DIRID_COMMON_DESKTOPDIRECTORY 16409 
#define DIRID_COMMON_FAVORITES 16415 
#define DIRID_COMMON_APPDATA 16419 
#define DIRID_PROGRAM_FILES 16422 
#define DIRID_PROGRAM_FILES_COMMON 16427 
#define DIRID_PROGRAM_FILES_COMMONX86 16428 
#define DIRID_COMMON_TEMPLATES 16429 
#define DIRID_COMMON_DOCUMENTS 16430 
#define DIRID_USER 0x8000
typedef UINT (CALLBACK* PSP_FILE_CALLBACK_A)(PVOID ,UINT ,UINT_PTR ,UINT_PTR Param2 );
typedef UINT (CALLBACK* PSP_FILE_CALLBACK_W)(PVOID ,UINT ,UINT_PTR ,UINT_PTR Param2 );
#ifdef UNICODE
#define PSP_FILE_CALLBACK PSP_FILE_CALLBACK_W
#else
#define PSP_FILE_CALLBACK PSP_FILE_CALLBACK_A
#endif
#define SPFILENOTIFY_STARTQUEUE 1
#define SPFILENOTIFY_ENDQUEUE 2
#define SPFILENOTIFY_STARTSUBQUEUE 3
#define SPFILENOTIFY_ENDSUBQUEUE 4
#define SPFILENOTIFY_STARTDELETE 5
#define SPFILENOTIFY_ENDDELETE 6
#define SPFILENOTIFY_DELETEERROR 7
#define SPFILENOTIFY_STARTRENAME 8
#define SPFILENOTIFY_ENDRENAME 9
#define SPFILENOTIFY_RENAMEERROR 10
#define SPFILENOTIFY_STARTCOPY 11
#define SPFILENOTIFY_ENDCOPY 12
#define SPFILENOTIFY_COPYERROR 13
#define SPFILENOTIFY_NEEDMEDIA 14
#define SPFILENOTIFY_QUEUESCAN 15
#define SPFILENOTIFY_CABINETINFO 16
#define SPFILENOTIFY_FILEINCABINET 17
#define SPFILENOTIFY_NEEDNEWCABINET 18
#define SPFILENOTIFY_FILEEXTRACTED 19
#define SPFILENOTIFY_FILEOPDELAYED 20
#define SPFILENOTIFY_STARTBACKUP 21
#define SPFILENOTIFY_BACKUPERROR 22
#define SPFILENOTIFY_ENDBACKUP 23
#define SPFILENOTIFY_QUEUESCAN_EX 24
#define SPFILENOTIFY_LANGMISMATCH 0x10000
#define SPFILENOTIFY_TARGETEXISTS 0x20000
#define SPFILENOTIFY_TARGETNEWER 0x40000
#define FILEOP_COPY 0
#define FILEOP_RENAME 1
#define FILEOP_DELETE 2
#define FILEOP_BACKUP 3
#define FILEOP_ABORT 0
#define FILEOP_DOIT 1
#define FILEOP_SKIP 2
#define FILEOP_RETRY FILEOP_DOIT
#define FILEOP_NEWPATH 4
#define COPYFLG_WARN_IF_SKIP 1
#define COPYFLG_NOSKIP 2
#define COPYFLG_NOVERSIONCHECK 4
#define COPYFLG_FORCE_FILE_IN_USE 8
#define COPYFLG_NO_OVERWRITE 16
#define COPYFLG_NO_VERSION_DIALOG 32
#define COPYFLG_OVERWRITE_OLDER_ONLY 64
#define COPYFLG_REPLACEONLY 1024
#define COPYFLG_NODECOMP 2048
#define COPYFLG_REPLACE_BOOT_FILE 4096
#define COPYFLG_NOPRUNE 0x2000
#define DELFLG_IN_USE 1
#define DELFLG_IN_USE1 0x10000
typedef struct _FILEPATHS_A {
PCSTR Target;
PCSTR Source; 
UINT Win32Error;
DWORD Flags; 
} FILEPATHS_A,*PFILEPATHS_A;
typedef struct _FILEPATHS_W {
PCWSTR Target;
PCWSTR Source; 
UINT Win32Error;
DWORD Flags; 
} FILEPATHS_W,*PFILEPATHS_W;
#ifdef UNICODE
typedef FILEPATHS_W FILEPATHS;
typedef PFILEPATHS_W PFILEPATHS;
#else
typedef FILEPATHS_A FILEPATHS;
typedef PFILEPATHS_A PFILEPATHS;
#endif
typedef struct _SOURCE_MEDIA_A {
PCSTR Reserved;
PCSTR Tagfile; 
PCSTR Description;
PCSTR SourcePath;
PCSTR SourceFile;
DWORD Flags; 
} SOURCE_MEDIA_A,*PSOURCE_MEDIA_A;
typedef struct _SOURCE_MEDIA_W {
PCWSTR Reserved;
PCWSTR Tagfile; 
PCWSTR Description;
PCWSTR SourcePath;
PCWSTR SourceFile;
DWORD Flags; 
} SOURCE_MEDIA_W,*PSOURCE_MEDIA_W;
#ifdef UNICODE
typedef SOURCE_MEDIA_W SOURCE_MEDIA;
typedef PSOURCE_MEDIA_W PSOURCE_MEDIA;
#else
typedef SOURCE_MEDIA_A SOURCE_MEDIA;
typedef PSOURCE_MEDIA_A PSOURCE_MEDIA;
#endif
typedef struct _CABINET_INFO_A {
PCSTR CabinetPath;
PCSTR CabinetFile;
PCSTR DiskName;
USHORT SetId;
USHORT CabinetNumber;
} CABINET_INFO_A,*PCABINET_INFO_A;
typedef struct _CABINET_INFO_W {
PCWSTR CabinetPath;
PCWSTR CabinetFile;
PCWSTR DiskName;
USHORT SetId;
USHORT CabinetNumber;
} CABINET_INFO_W,*PCABINET_INFO_W;
#ifdef UNICODE
typedef CABINET_INFO_W CABINET_INFO;
typedef PCABINET_INFO_W PCABINET_INFO;
#else
typedef CABINET_INFO_A CABINET_INFO;
typedef PCABINET_INFO_A PCABINET_INFO;
#endif
typedef struct _FILE_IN_CABINET_INFO_A {
PCSTR NameInCabinet;
DWORD FileSize;
DWORD Win32Error;
WORD DosDate;
WORD DosTime;
WORD DosAttribs;
CHAR FullTargetName[MAX_PATH];
} FILE_IN_CABINET_INFO_A,*PFILE_IN_CABINET_INFO_A;
typedef struct _FILE_IN_CABINET_INFO_W {
PCWSTR NameInCabinet;
DWORD FileSize;
DWORD Win32Error;
WORD DosDate;
WORD DosTime;
WORD DosAttribs;
WCHAR FullTargetName[MAX_PATH];
} FILE_IN_CABINET_INFO_W,*PFILE_IN_CABINET_INFO_W;
#ifdef UNICODE
typedef FILE_IN_CABINET_INFO_W FILE_IN_CABINET_INFO;
typedef PFILE_IN_CABINET_INFO_W PFILE_IN_CABINET_INFO;
#else
typedef FILE_IN_CABINET_INFO_A FILE_IN_CABINET_INFO;
typedef PFILE_IN_CABINET_INFO_A PFILE_IN_CABINET_INFO;
#endif
typedef PVOID HSPFILEQ;
typedef struct _SP_FILE_COPY_PARAMS_A {
DWORD cbSize;
HSPFILEQ QueueHandle;
PCSTR SourceRootPath; 
PCSTR SourcePath; 
PCSTR SourceFilename;
PCSTR SourceDescription; 
PCSTR SourceTagfile; 
PCSTR TargetDirectory;
PCSTR TargetFilename; 
DWORD CopyStyle;
HINF LayoutInf; 
PCSTR SecurityDescriptor; 
} SP_FILE_COPY_PARAMS_A,*PSP_FILE_COPY_PARAMS_A;
typedef struct _SP_FILE_COPY_PARAMS_W {
DWORD cbSize;
HSPFILEQ QueueHandle;
PCWSTR SourceRootPath; 
PCWSTR SourcePath; 
PCWSTR SourceFilename;
PCWSTR SourceDescription; 
PCWSTR SourceTagfile; 
PCWSTR TargetDirectory;
PCWSTR TargetFilename; 
DWORD CopyStyle;
HINF LayoutInf; 
PCWSTR SecurityDescriptor; 
} SP_FILE_COPY_PARAMS_W,*PSP_FILE_COPY_PARAMS_W;
#ifdef UNICODE
typedef SP_FILE_COPY_PARAMS_W SP_FILE_COPY_PARAMS;
typedef PSP_FILE_COPY_PARAMS_W PSP_FILE_COPY_PARAMS;
#else
typedef SP_FILE_COPY_PARAMS_A SP_FILE_COPY_PARAMS;
typedef PSP_FILE_COPY_PARAMS_A PSP_FILE_COPY_PARAMS;
#endif
typedef PVOID HDSKSPC;
typedef PVOID HDEVINFO;
typedef struct _SP_DEVINFO_DATA {
DWORD cbSize;
GUID ClassGuid;
DWORD DevInst; 
ULONG_PTR Reserved;
} SP_DEVINFO_DATA,*PSP_DEVINFO_DATA;
typedef struct _SP_DEVICE_INTERFACE_DATA {
DWORD cbSize;
GUID InterfaceClassGuid;
DWORD Flags;
ULONG_PTR Reserved;
} SP_DEVICE_INTERFACE_DATA,*PSP_DEVICE_INTERFACE_DATA;
#define SPINT_ACTIVE 1
#define SPINT_DEFAULT 2
#define SPINT_REMOVED 4
typedef SP_DEVICE_INTERFACE_DATA SP_INTERFACE_DEVICE_DATA;
typedef PSP_DEVICE_INTERFACE_DATA PSP_INTERFACE_DEVICE_DATA;
#define SPID_ACTIVE SPINT_ACTIVE
#define SPID_DEFAULT SPINT_DEFAULT
#define SPID_REMOVED SPINT_REMOVED
typedef struct _SP_DEVICE_INTERFACE_DETAIL_DATA_A {
DWORD cbSize;
CHAR DevicePath[ANYSIZE_ARRAY];
} SP_DEVICE_INTERFACE_DETAIL_DATA_A,*PSP_DEVICE_INTERFACE_DETAIL_DATA_A;
typedef struct _SP_DEVICE_INTERFACE_DETAIL_DATA_W {
DWORD cbSize;
WCHAR DevicePath[ANYSIZE_ARRAY];
} SP_DEVICE_INTERFACE_DETAIL_DATA_W,*PSP_DEVICE_INTERFACE_DETAIL_DATA_W;
#ifdef UNICODE
typedef SP_DEVICE_INTERFACE_DETAIL_DATA_W SP_DEVICE_INTERFACE_DETAIL_DATA;
typedef PSP_DEVICE_INTERFACE_DETAIL_DATA_W PSP_DEVICE_INTERFACE_DETAIL_DATA;
#else
typedef SP_DEVICE_INTERFACE_DETAIL_DATA_A SP_DEVICE_INTERFACE_DETAIL_DATA;
typedef PSP_DEVICE_INTERFACE_DETAIL_DATA_A PSP_DEVICE_INTERFACE_DETAIL_DATA;
#endif
typedef SP_DEVICE_INTERFACE_DETAIL_DATA_W SP_INTERFACE_DEVICE_DETAIL_DATA_W;
typedef PSP_DEVICE_INTERFACE_DETAIL_DATA_W PSP_INTERFACE_DEVICE_DETAIL_DATA_W;
typedef SP_DEVICE_INTERFACE_DETAIL_DATA_A SP_INTERFACE_DEVICE_DETAIL_DATA_A;
typedef PSP_DEVICE_INTERFACE_DETAIL_DATA_A PSP_INTERFACE_DEVICE_DETAIL_DATA_A;
#ifdef UNICODE
typedef SP_INTERFACE_DEVICE_DETAIL_DATA_W SP_INTERFACE_DEVICE_DETAIL_DATA;
typedef PSP_INTERFACE_DEVICE_DETAIL_DATA_W PSP_INTERFACE_DEVICE_DETAIL_DATA;
#else
typedef SP_INTERFACE_DEVICE_DETAIL_DATA_A SP_INTERFACE_DEVICE_DETAIL_DATA;
typedef PSP_INTERFACE_DEVICE_DETAIL_DATA_A PSP_INTERFACE_DEVICE_DETAIL_DATA;
#endif
typedef struct _SP_DEVINFO_LIST_DETAIL_DATA_A {
DWORD cbSize;
GUID ClassGuid;
HANDLE RemoteMachineHandle;
CHAR RemoteMachineName[SP_MAX_MACHINENAME_LENGTH];
} SP_DEVINFO_LIST_DETAIL_DATA_A,*PSP_DEVINFO_LIST_DETAIL_DATA_A;
typedef struct _SP_DEVINFO_LIST_DETAIL_DATA_W {
DWORD cbSize;
GUID ClassGuid;
HANDLE RemoteMachineHandle;
WCHAR RemoteMachineName[SP_MAX_MACHINENAME_LENGTH];
} SP_DEVINFO_LIST_DETAIL_DATA_W,*PSP_DEVINFO_LIST_DETAIL_DATA_W;
#ifdef UNICODE
typedef SP_DEVINFO_LIST_DETAIL_DATA_W SP_DEVINFO_LIST_DETAIL_DATA;
typedef PSP_DEVINFO_LIST_DETAIL_DATA_W PSP_DEVINFO_LIST_DETAIL_DATA;
#else
typedef SP_DEVINFO_LIST_DETAIL_DATA_A SP_DEVINFO_LIST_DETAIL_DATA;
typedef PSP_DEVINFO_LIST_DETAIL_DATA_A PSP_DEVINFO_LIST_DETAIL_DATA;
#endif
#define DIF_SELECTDEVICE 1
#define DIF_INSTALLDEVICE 2
#define DIF_ASSIGNRESOURCES 3
#define DIF_PROPERTIES 4
#define DIF_REMOVE 5
#define DIF_FIRSTTIMESETUP 6
#define DIF_FOUNDDEVICE 7
#define DIF_SELECTCLASSDRIVERS 8
#define DIF_VALIDATECLASSDRIVERS 9
#define DIF_INSTALLCLASSDRIVERS 10
#define DIF_CALCDISKSPACE 11
#define DIF_DESTROYPRIVATEDATA 12
#define DIF_VALIDATEDRIVER 13
#define DIF_MOVEDEVICE 14
#define DIF_DETECT 15
#define DIF_INSTALLWIZARD 16
#define DIF_DESTROYWIZARDDATA 17
#define DIF_PROPERTYCHANGE 18
#define DIF_ENABLECLASS 19
#define DIF_DETECTVERIFY 20
#define DIF_INSTALLDEVICEFILES 21
#define DIF_UNREMOVE 22
#define DIF_SELECTBESTCOMPATDRV 23
#define DIF_ALLOW_INSTALL 24
#define DIF_REGISTERDEVICE 25
#define DIF_NEWDEVICEWIZARD_PRESELECT 26
#define DIF_NEWDEVICEWIZARD_SELECT 27
#define DIF_NEWDEVICEWIZARD_PREANALYZE 28
#define DIF_NEWDEVICEWIZARD_POSTANALYZE 29
#define DIF_NEWDEVICEWIZARD_FINISHINSTALL 30
#define DIF_UNUSED1 31
#define DIF_INSTALLINTERFACES 32
#define DIF_DETECTCANCEL 33
#define DIF_REGISTER_COINSTALLERS 34
#define DIF_ADDPROPERTYPAGE_ADVANCED 35
#define DIF_ADDPROPERTYPAGE_BASIC 36
#define DIF_RESERVED1 37
#define DIF_TROUBLESHOOTER 38
typedef UINT DI_FUNCTION; 
typedef struct _SP_DEVINSTALL_PARAMS_A {
DWORD cbSize;
DWORD Flags;
DWORD FlagsEx;
HWND hwndParent;
PSP_FILE_CALLBACK InstallMsgHandler;
PVOID InstallMsgHandlerContext;
HSPFILEQ FileQueue;
ULONG_PTR ClassInstallReserved;
DWORD Reserved;
CHAR DriverPath[MAX_PATH];
} SP_DEVINSTALL_PARAMS_A,*PSP_DEVINSTALL_PARAMS_A;
typedef struct _SP_DEVINSTALL_PARAMS_W {
DWORD cbSize;
DWORD Flags;
DWORD FlagsEx;
HWND hwndParent;
PSP_FILE_CALLBACK InstallMsgHandler;
PVOID InstallMsgHandlerContext;
HSPFILEQ FileQueue;
ULONG_PTR ClassInstallReserved;
DWORD Reserved;
WCHAR DriverPath[MAX_PATH];
} SP_DEVINSTALL_PARAMS_W,*PSP_DEVINSTALL_PARAMS_W;
#ifdef UNICODE
typedef SP_DEVINSTALL_PARAMS_W SP_DEVINSTALL_PARAMS;
typedef PSP_DEVINSTALL_PARAMS_W PSP_DEVINSTALL_PARAMS;
#else
typedef SP_DEVINSTALL_PARAMS_A SP_DEVINSTALL_PARAMS;
typedef PSP_DEVINSTALL_PARAMS_A PSP_DEVINSTALL_PARAMS;
#endif
#define DI_SHOWOEM 1
#define DI_SHOWCOMPAT 2
#define DI_SHOWCLASS 4
#define DI_SHOWALL 7
#define DI_NOVCP 8
#define DI_DIDCOMPAT 16
#define DI_DIDCLASS 32
#define DI_AUTOASSIGNRES 64
#define DI_NEEDRESTART 128
#define DI_NEEDREBOOT 256
#define DI_NOBROWSE 512
#define DI_MULTMFGS 1024
#define DI_DISABLED 2048
#define DI_GENERALPAGE_ADDED 4096
#define DI_RESOURCEPAGE_ADDED 0x2000
#define DI_PROPERTIES_CHANGE 0x4000
#define DI_INF_IS_SORTED 0x8000
#define DI_ENUMSINGLEINF 0x10000
#define DI_DONOTCALLCONFIGMG 0x20000
#define DI_INSTALLDISABLED 0x40000
#define DI_COMPAT_FROM_CLASS 0x80000
#define DI_CLASSINSTALLPARAMS 0x100000
#define DI_NODI_DEFAULTACTION 0x200000
#define DI_QUIETINSTALL 0x800000
#define DI_NOFILECOPY 0x1000000
#define DI_FORCECOPY 0x2000000
#define DI_DRIVERPAGE_ADDED 0x4000000
#define DI_USECI_SELECTSTRINGS 0x8000000
#define DI_OVERRIDE_INFFLAGS 0x10000000
#define DI_PROPS_NOCHANGEUSAGE 0x20000000
#define DI_NOSELECTICONS 0x40000000
#define DI_NOWRITE_IDS 0x80000000
#define DI_FLAGSEX_USEOLDINFSEARCH 1
#define DI_FLAGSEX_AUTOSELECTRANK0 2
#define DI_FLAGSEX_CI_FAILED 4
#define DI_FLAGSEX_DIDINFOLIST 16
#define DI_FLAGSEX_DIDCOMPATINFO 32
#define DI_FLAGSEX_FILTERCLASSES 64
#define DI_FLAGSEX_SETFAILEDINSTALL 128
#define DI_FLAGSEX_DEVICECHANGE 256
#define DI_FLAGSEX_ALWAYSWRITEIDS 512
#define DI_FLAGSEX_PROPCHANGE_PENDING 1024
#define DI_FLAGSEX_ALLOWEXCLUDEDDRVS 2048
#define DI_FLAGSEX_NOUIONQUERYREMOVE 4096
#define DI_FLAGSEX_USECLASSFORCOMPAT 0x2000
#define DI_FLAGSEX_OLDINF_IN_CLASSLIST 0x4000
#define DI_FLAGSEX_NO_DRVREG_MODIFY 0x8000
#define DI_FLAGSEX_IN_SYSTEM_SETUP 0x10000
#define DI_FLAGSEX_INET_DRIVER 0x20000
#define DI_FLAGSEX_APPENDDRIVERLIST 0x40000
#define DI_FLAGSEX_PREINSTALLBACKUP 0x80000
#define DI_FLAGSEX_BACKUPONREPLACE 0x100000
#define DI_FLAGSEX_DRIVERLIST_FROM_URL 0x200000
#define DI_FLAGSEX_RESERVED1 0x400000
#define DI_FLAGSEX_EXCLUDE_OLD_INET_DRIVERS 0x800000
#define DI_FLAGSEX_RESERVED1 0x400000
typedef struct _SP_CLASSINSTALL_HEADER {
DWORD cbSize;
DI_FUNCTION InstallFunction;
} SP_CLASSINSTALL_HEADER,*PSP_CLASSINSTALL_HEADER;
typedef struct _SP_ENABLECLASS_PARAMS {
SP_CLASSINSTALL_HEADER ClassInstallHeader;
GUID ClassGuid;
DWORD EnableMessage;
} SP_ENABLECLASS_PARAMS,*PSP_ENABLECLASS_PARAMS;
#define ENABLECLASS_QUERY 0
#define ENABLECLASS_SUCCESS 1
#define ENABLECLASS_FAILURE 2
typedef struct _SP_MOVEDEV_PARAMS {
SP_CLASSINSTALL_HEADER ClassInstallHeader;
SP_DEVINFO_DATA SourceDeviceInfoData;
} SP_MOVEDEV_PARAMS,*PSP_MOVEDEV_PARAMS;
#define DICS_ENABLE 1
#define DICS_DISABLE 2
#define DICS_PROPCHANGE 3
#define DICS_START 4
#define DICS_STOP 5
#define DICS_FLAG_GLOBAL 1
#define DICS_FLAG_CONFIGSPECIFIC 2
#define DICS_FLAG_CONFIGGENERAL 4
typedef struct _SP_PROPCHANGE_PARAMS {
SP_CLASSINSTALL_HEADER ClassInstallHeader;
DWORD StateChange;
DWORD Scope;
DWORD HwProfile;
} SP_PROPCHANGE_PARAMS,*PSP_PROPCHANGE_PARAMS;
typedef struct _SP_REMOVEDEVICE_PARAMS {
SP_CLASSINSTALL_HEADER ClassInstallHeader;
DWORD Scope;
DWORD HwProfile;
} SP_REMOVEDEVICE_PARAMS,*PSP_REMOVEDEVICE_PARAMS;
#define DI_REMOVEDEVICE_GLOBAL 1
#define DI_REMOVEDEVICE_CONFIGSPECIFIC 2
typedef struct _SP_UNREMOVEDEVICE_PARAMS {
SP_CLASSINSTALL_HEADER ClassInstallHeader;
DWORD Scope;
DWORD HwProfile;
} SP_UNREMOVEDEVICE_PARAMS,*PSP_UNREMOVEDEVICE_PARAMS;
#define DI_UNREMOVEDEVICE_CONFIGSPECIFIC 2
typedef struct _SP_SELECTDEVICE_PARAMS_A {
SP_CLASSINSTALL_HEADER ClassInstallHeader;
CHAR Title[MAX_TITLE_LEN];
CHAR Instructions[MAX_INSTRUCTION_LEN];
CHAR ListLabel[MAX_LABEL_LEN];
CHAR SubTitle[MAX_SUBTITLE_LEN];
BYTE Reserved[2]; 
} SP_SELECTDEVICE_PARAMS_A,*PSP_SELECTDEVICE_PARAMS_A;
typedef struct _SP_SELECTDEVICE_PARAMS_W {
SP_CLASSINSTALL_HEADER ClassInstallHeader;
WCHAR Title[MAX_TITLE_LEN];
WCHAR Instructions[MAX_INSTRUCTION_LEN];
WCHAR ListLabel[MAX_LABEL_LEN];
WCHAR SubTitle[MAX_SUBTITLE_LEN];
} SP_SELECTDEVICE_PARAMS_W,*PSP_SELECTDEVICE_PARAMS_W;
#ifdef UNICODE
typedef SP_SELECTDEVICE_PARAMS_W SP_SELECTDEVICE_PARAMS;
typedef PSP_SELECTDEVICE_PARAMS_W PSP_SELECTDEVICE_PARAMS;
#else
typedef SP_SELECTDEVICE_PARAMS_A SP_SELECTDEVICE_PARAMS;
typedef PSP_SELECTDEVICE_PARAMS_A PSP_SELECTDEVICE_PARAMS;
#endif
typedef BOOL (CALLBACK* PDETECT_PROGRESS_NOTIFY)(PVOID ,DWORD DetectComplete );
typedef struct _SP_DETECTDEVICE_PARAMS {
SP_CLASSINSTALL_HEADER ClassInstallHeader;
PDETECT_PROGRESS_NOTIFY DetectProgressNotify;
PVOID ProgressNotifyParam;
} SP_DETECTDEVICE_PARAMS,*PSP_DETECTDEVICE_PARAMS;
#define MAX_INSTALLWIZARD_DYNAPAGES 20
typedef struct _SP_INSTALLWIZARD_DATA {
SP_CLASSINSTALL_HEADER ClassInstallHeader;
DWORD Flags;
HPROPSHEETPAGE DynamicPages[MAX_INSTALLWIZARD_DYNAPAGES];
DWORD NumDynamicPages;
DWORD DynamicPageFlags;
DWORD PrivateFlags;
LPARAM PrivateData;
HWND hwndWizardDlg;
} SP_INSTALLWIZARD_DATA,*PSP_INSTALLWIZARD_DATA;
#define NDW_INSTALLFLAG_DIDFACTDEFS 1
#define NDW_INSTALLFLAG_HARDWAREALLREADYIN 2
#define NDW_INSTALLFLAG_NEEDRESTART DI_NEEDRESTART
#define NDW_INSTALLFLAG_NEEDREBOOT DI_NEEDREBOOT
#define NDW_INSTALLFLAG_NEEDSHUTDOWN 512
#define NDW_INSTALLFLAG_EXPRESSINTRO 1024
#define NDW_INSTALLFLAG_SKIPISDEVINSTALLED 2048
#define NDW_INSTALLFLAG_NODETECTEDDEVS 4096
#define NDW_INSTALLFLAG_INSTALLSPECIFIC 0x2000
#define NDW_INSTALLFLAG_SKIPCLASSLIST 0x4000
#define NDW_INSTALLFLAG_CI_PICKED_OEM 0x8000
#define NDW_INSTALLFLAG_PCMCIAMODE 0x10000
#define NDW_INSTALLFLAG_PCMCIADEVICE 0x20000
#define NDW_INSTALLFLAG_USERCANCEL 0x40000
#define NDW_INSTALLFLAG_KNOWNCLASS 0x80000
#define DYNAWIZ_FLAG_PAGESADDED 1
#define DYNAWIZ_FLAG_ANALYZE_HANDLECONFLICT 8
#define DYNAWIZ_FLAG_INSTALLDET_NEXT 2
#define DYNAWIZ_FLAG_INSTALLDET_PREV 4
#define MIN_IDD_DYNAWIZ_RESOURCE_ID 10000
#define MAX_IDD_DYNAWIZ_RESOURCE_ID 11000
#define IDD_DYNAWIZ_FIRSTPAGE 10000
#define IDD_DYNAWIZ_SELECT_PREVPAGE 10001
#define IDD_DYNAWIZ_SELECT_NEXTPAGE 10002
#define IDD_DYNAWIZ_ANALYZE_PREVPAGE 10003
#define IDD_DYNAWIZ_ANALYZE_NEXTPAGE 10004
#define IDD_DYNAWIZ_SELECTDEV_PAGE 10009
#define IDD_DYNAWIZ_ANALYZEDEV_PAGE 10010
#define IDD_DYNAWIZ_INSTALLDETECTEDDEVS_PAGE 10011
#define IDD_DYNAWIZ_SELECTCLASS_PAGE 10012
#define IDD_DYNAWIZ_INSTALLDETECTED_PREVPAGE 10006
#define IDD_DYNAWIZ_INSTALLDETECTED_NEXTPAGE 10007
#define IDD_DYNAWIZ_INSTALLDETECTED_NODEVS 10008
typedef struct _SP_NEWDEVICEWIZARD_DATA {
SP_CLASSINSTALL_HEADER ClassInstallHeader;
DWORD Flags; 
HPROPSHEETPAGE DynamicPages[MAX_INSTALLWIZARD_DYNAPAGES];
DWORD NumDynamicPages;
HWND hwndWizardDlg;
} SP_NEWDEVICEWIZARD_DATA,*PSP_NEWDEVICEWIZARD_DATA;
typedef SP_NEWDEVICEWIZARD_DATA SP_ADDPROPERTYPAGE_DATA;
typedef PSP_NEWDEVICEWIZARD_DATA PSP_ADDPROPERTYPAGE_DATA;
typedef struct _SP_TROUBLESHOOTER_PARAMS_A {
SP_CLASSINSTALL_HEADER ClassInstallHeader;
CHAR ChmFile[MAX_PATH];
CHAR HtmlTroubleShooter[MAX_PATH];
} SP_TROUBLESHOOTER_PARAMS_A,*PSP_TROUBLESHOOTER_PARAMS_A;
typedef struct _SP_TROUBLESHOOTER_PARAMS_W {
SP_CLASSINSTALL_HEADER ClassInstallHeader;
WCHAR ChmFile[MAX_PATH];
WCHAR HtmlTroubleShooter[MAX_PATH];
} SP_TROUBLESHOOTER_PARAMS_W,*PSP_TROUBLESHOOTER_PARAMS_W;
#ifdef UNICODE
typedef SP_TROUBLESHOOTER_PARAMS_W SP_TROUBLESHOOTER_PARAMS;
typedef PSP_TROUBLESHOOTER_PARAMS_W PSP_TROUBLESHOOTER_PARAMS;
#else
typedef SP_TROUBLESHOOTER_PARAMS_A SP_TROUBLESHOOTER_PARAMS;
typedef PSP_TROUBLESHOOTER_PARAMS_A PSP_TROUBLESHOOTER_PARAMS;
#endif
typedef struct _SP_DRVINFO_DATA_A {
DWORD cbSize;
DWORD DriverType;
ULONG_PTR Reserved;
CHAR Description[LINE_LEN];
CHAR MfgName[LINE_LEN];
CHAR ProviderName[LINE_LEN];
FILETIME DriverDate;
DWORDLONG DriverVersion;
} SP_DRVINFO_DATA_A,*PSP_DRVINFO_DATA_A;
typedef struct _SP_DRVINFO_DATA_W {
DWORD cbSize;
DWORD DriverType;
ULONG_PTR Reserved;
WCHAR Description[LINE_LEN];
WCHAR MfgName[LINE_LEN];
WCHAR ProviderName[LINE_LEN];
FILETIME DriverDate;
DWORDLONG DriverVersion;
} SP_DRVINFO_DATA_W,*PSP_DRVINFO_DATA_W;
typedef struct _SP_DRVINFO_DATA_V1_A {
DWORD cbSize;
DWORD DriverType;
ULONG_PTR Reserved;
CHAR Description[LINE_LEN];
CHAR MfgName[LINE_LEN];
CHAR ProviderName[LINE_LEN];
} SP_DRVINFO_DATA_V1_A,*PSP_DRVINFO_DATA_V1_A;
typedef struct _SP_DRVINFO_DATA_V1_W {
DWORD cbSize;
DWORD DriverType;
ULONG_PTR Reserved;
WCHAR Description[LINE_LEN];
WCHAR MfgName[LINE_LEN];
WCHAR ProviderName[LINE_LEN];
} SP_DRVINFO_DATA_V1_W,*PSP_DRVINFO_DATA_V1_W;
#ifdef UNICODE
typedef SP_DRVINFO_DATA_V1_W SP_DRVINFO_DATA_V1;
typedef PSP_DRVINFO_DATA_V1_W PSP_DRVINFO_DATA_V1;
#else
typedef SP_DRVINFO_DATA_V1_A SP_DRVINFO_DATA_V1;
typedef PSP_DRVINFO_DATA_V1_A PSP_DRVINFO_DATA_V1;
#endif
#if USE_SP_DRVINFO_DATA_V1 
#ifdef UNICODE
typedef SP_DRVINFO_DATA_V1_W SP_DRVINFO_DATA;
typedef PSP_DRVINFO_DATA_V1_W PSP_DRVINFO_DATA;
#else
typedef SP_DRVINFO_DATA_V1_A SP_DRVINFO_DATA;
typedef PSP_DRVINFO_DATA_V1_A PSP_DRVINFO_DATA;
#endif
#else 
#ifdef UNICODE
typedef SP_DRVINFO_DATA_W SP_DRVINFO_DATA;
typedef PSP_DRVINFO_DATA_W PSP_DRVINFO_DATA;
#else
typedef SP_DRVINFO_DATA_A SP_DRVINFO_DATA;
typedef PSP_DRVINFO_DATA_A PSP_DRVINFO_DATA;
#endif
#endif 
typedef struct _SP_DRVINFO_DETAIL_DATA_A {
DWORD cbSize;
FILETIME InfDate;
DWORD CompatIDsOffset;
DWORD CompatIDsLength;
ULONG_PTR Reserved;
CHAR SectionName[LINE_LEN];
CHAR InfFileName[MAX_PATH];
CHAR DrvDescription[LINE_LEN];
CHAR HardwareID[ANYSIZE_ARRAY];
} SP_DRVINFO_DETAIL_DATA_A,*PSP_DRVINFO_DETAIL_DATA_A;
typedef struct _SP_DRVINFO_DETAIL_DATA_W {
DWORD cbSize;
FILETIME InfDate;
DWORD CompatIDsOffset;
DWORD CompatIDsLength;
ULONG_PTR Reserved;
WCHAR SectionName[LINE_LEN];
WCHAR InfFileName[MAX_PATH];
WCHAR DrvDescription[LINE_LEN];
WCHAR HardwareID[ANYSIZE_ARRAY];
} SP_DRVINFO_DETAIL_DATA_W,*PSP_DRVINFO_DETAIL_DATA_W;
#ifdef UNICODE
typedef SP_DRVINFO_DETAIL_DATA_W SP_DRVINFO_DETAIL_DATA;
typedef PSP_DRVINFO_DETAIL_DATA_W PSP_DRVINFO_DETAIL_DATA;
#else
typedef SP_DRVINFO_DETAIL_DATA_A SP_DRVINFO_DETAIL_DATA;
typedef PSP_DRVINFO_DETAIL_DATA_A PSP_DRVINFO_DETAIL_DATA;
#endif
typedef struct _SP_DRVINSTALL_PARAMS {
DWORD cbSize;
DWORD Rank;
DWORD Flags;
DWORD_PTR PrivateData;
DWORD Reserved;
} SP_DRVINSTALL_PARAMS,*PSP_DRVINSTALL_PARAMS;
#define DNF_DUPDESC 1
#define DNF_OLDDRIVER 2
#define DNF_EXCLUDEFROMLIST 4
#define DNF_NODRIVER 8
#define DNF_LEGACYINF 16
#define DNF_CLASS_DRIVER 32
#define DNF_COMPATIBLE_DRIVER 64
#define DNF_INET_DRIVER 128
#define DNF_UNUSED1 256
#define DNF_INDEXED_DRIVER 512
#define DNF_OLD_INET_DRIVER 1024
#define DNF_BAD_DRIVER 2048
#define DRIVER_HARDWAREID_RANK 4095
typedef DWORD (CALLBACK* PSP_DETSIG_CMPPROC)(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DEVINFO_DATA ,PVOID );
typedef struct _COINSTALLER_CONTEXT_DATA {
BOOL PostProcessing;
DWORD InstallResult;
PVOID PrivateData;
} COINSTALLER_CONTEXT_DATA,*PCOINSTALLER_CONTEXT_DATA;
typedef struct _SP_CLASSIMAGELIST_DATA {
DWORD cbSize;
HIMAGELIST ImageList;
ULONG_PTR Reserved;
} SP_CLASSIMAGELIST_DATA,*PSP_CLASSIMAGELIST_DATA;
typedef struct _SP_PROPSHEETPAGE_REQUEST {
DWORD cbSize;
DWORD PageRequested;
HDEVINFO DeviceInfoSet;
PSP_DEVINFO_DATA DeviceInfoData;
} SP_PROPSHEETPAGE_REQUEST,*PSP_PROPSHEETPAGE_REQUEST;
#define SPPSR_SELECT_DEVICE_RESOURCES 1 
#define SPPSR_ENUM_BASIC_DEVICE_PROPERTIES 2 
#define SPPSR_ENUM_ADV_DEVICE_PROPERTIES 3 
typedef struct _SP_BACKUP_QUEUE_PARAMS_A {
DWORD cbSize;
CHAR FullInfPath[MAX_PATH]; 
INT FilenameOffset; 
} SP_BACKUP_QUEUE_PARAMS_A,*PSP_BACKUP_QUEUE_PARAMS_A;
typedef struct _SP_BACKUP_QUEUE_PARAMS_W {
DWORD cbSize;
WCHAR FullInfPath[MAX_PATH]; 
INT FilenameOffset; 
} SP_BACKUP_QUEUE_PARAMS_W,*PSP_BACKUP_QUEUE_PARAMS_W;
#ifdef UNICODE
typedef SP_BACKUP_QUEUE_PARAMS_W SP_BACKUP_QUEUE_PARAMS;
typedef PSP_BACKUP_QUEUE_PARAMS_W PSP_BACKUP_QUEUE_PARAMS;
#else
typedef SP_BACKUP_QUEUE_PARAMS_A SP_BACKUP_QUEUE_PARAMS;
typedef PSP_BACKUP_QUEUE_PARAMS_A PSP_BACKUP_QUEUE_PARAMS;
#endif
#define ERROR_EXPECTED_SECTION_NAME (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|0)
#define ERROR_BAD_SECTION_NAME_LINE (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|1)
#define ERROR_SECTION_NAME_TOO_LONG (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|2)
#define ERROR_GENERAL_SYNTAX (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|3)
#define ERROR_WRONG_INF_STYLE (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|256)
#define ERROR_SECTION_NOT_FOUND (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|257)
#define ERROR_LINE_NOT_FOUND (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|258)
#define ERROR_NO_BACKUP (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|259)
#define ERROR_NO_ASSOCIATED_CLASS (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|512)
#define ERROR_CLASS_MISMATCH (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|513)
#define ERROR_DUPLICATE_FOUND (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|514)
#define ERROR_NO_DRIVER_SELECTED (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|515)
#define ERROR_KEY_DOES_NOT_EXIST (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|516)
#define ERROR_INVALID_DEVINST_NAME (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|517)
#define ERROR_INVALID_CLASS (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|518)
#define ERROR_DEVINST_ALREADY_EXISTS (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|519)
#define ERROR_DEVINFO_NOT_REGISTERED (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|520)
#define ERROR_INVALID_REG_PROPERTY (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|521)
#define ERROR_NO_INF (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|522)
#define ERROR_NO_SUCH_DEVINST (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|523)
#define ERROR_CANT_LOAD_CLASS_ICON (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|524)
#define ERROR_INVALID_CLASS_INSTALLER (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|525)
#define ERROR_DI_DO_DEFAULT (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|526)
#define ERROR_DI_NOFILECOPY (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|527)
#define ERROR_INVALID_HWPROFILE (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|528)
#define ERROR_NO_DEVICE_SELECTED (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|529)
#define ERROR_DEVINFO_LIST_LOCKED (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|530)
#define ERROR_DEVINFO_DATA_LOCKED (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|531)
#define ERROR_DI_BAD_PATH (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|532)
#define ERROR_NO_CLASSINSTALL_PARAMS (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|533)
#define ERROR_FILEQUEUE_LOCKED (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|534)
#define ERROR_BAD_SERVICE_INSTALLSECT (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|535)
#define ERROR_NO_CLASS_DRIVER_LIST (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|536)
#define ERROR_NO_ASSOCIATED_SERVICE (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|537)
#define ERROR_NO_DEFAULT_DEVICE_INTERFACE (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|538)
#define ERROR_DEVICE_INTERFACE_ACTIVE (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|539)
#define ERROR_DEVICE_INTERFACE_REMOVED (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|540)
#define ERROR_BAD_INTERFACE_INSTALLSECT (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|541)
#define ERROR_NO_SUCH_INTERFACE_CLASS (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|542)
#define ERROR_INVALID_REFERENCE_STRING (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|543)
#define ERROR_INVALID_MACHINENAME (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|544)
#define ERROR_REMOTE_COMM_FAILURE (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|545)
#define ERROR_MACHINE_UNAVAILABLE (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|546)
#define ERROR_NO_CONFIGMGR_SERVICES (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|547)
#define ERROR_INVALID_PROPPAGE_PROVIDER (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|548)
#define ERROR_NO_SUCH_DEVICE_INTERFACE (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|549)
#define ERROR_DI_POSTPROCESSING_REQUIRED (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|550)
#define ERROR_INVALID_COINSTALLER (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|551)
#define ERROR_NO_COMPAT_DRIVERS (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|552)
#define ERROR_NO_DEVICE_ICON (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|553)
#define ERROR_INVALID_INF_LOGCONFIG (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|554)
#define ERROR_DI_DONT_INSTALL (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|555)
#define ERROR_INVALID_FILTER_DRIVER (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|556)
#define ERROR_NON_WINDOWS_NT_DRIVER (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|557)
#define ERROR_NON_WINDOWS_DRIVER (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|558)
#define ERROR_NO_CATALOG_FOR_OEM_INF (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|559)
#define ERROR_DEVINSTALL_QUEUE_NONNATIVE (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|560)
#define ERROR_NOT_DISABLEABLE (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|561)
#define ERROR_CANT_REMOVE_DEVINST (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|562)
#define ERROR_NO_DEFAULT_INTERFACE_DEVICE ERROR_NO_DEFAULT_DEVICE_INTERFACE
#define ERROR_INTERFACE_DEVICE_ACTIVE ERROR_DEVICE_INTERFACE_ACTIVE
#define ERROR_INTERFACE_DEVICE_REMOVED ERROR_DEVICE_INTERFACE_REMOVED
#define ERROR_NO_SUCH_INTERFACE_DEVICE ERROR_NO_SUCH_DEVICE_INTERFACE
#define ERROR_NOT_INSTALLED (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR|4096)
BOOL WINAPI SetupGetInfInformationA(LPCVOID ,DWORD ,PSP_INF_INFORMATION ,DWORD,PDWORD);
BOOL WINAPI SetupGetInfInformationW(LPCVOID ,DWORD ,PSP_INF_INFORMATION ,DWORD,PDWORD);
#define INFINFO_INF_SPEC_IS_HINF 1
#define INFINFO_INF_NAME_IS_ABSOLUTE 2
#define INFINFO_DEFAULT_SEARCH 3
#define INFINFO_REVERSE_DEFAULT_SEARCH 4
#define INFINFO_INF_PATH_LIST_SEARCH 5
#ifdef UNICODE
#define SetupGetInfInformation SetupGetInfInformationW
#else
#define SetupGetInfInformation SetupGetInfInformationA
#endif
BOOL WINAPI SetupQueryInfFileInformationA(PSP_INF_INFORMATION ,UINT ,PSTR ,DWORD,PDWORD);
BOOL WINAPI SetupQueryInfFileInformationW(PSP_INF_INFORMATION ,UINT ,PWSTR ,DWORD,PDWORD);
#ifdef UNICODE
#define SetupQueryInfFileInformation SetupQueryInfFileInformationW
#else
#define SetupQueryInfFileInformation SetupQueryInfFileInformationA
#endif
BOOL WINAPI SetupQueryInfOriginalFileInformationA(PSP_INF_INFORMATION ,UINT ,PSP_ALTPLATFORM_INFO ,PSP_ORIGINAL_FILE_INFO_A );
BOOL WINAPI SetupQueryInfOriginalFileInformationW(PSP_INF_INFORMATION ,UINT ,PSP_ALTPLATFORM_INFO ,PSP_ORIGINAL_FILE_INFO_W );
#ifdef UNICODE
#define SetupQueryInfOriginalFileInformation SetupQueryInfOriginalFileInformationW
#else
#define SetupQueryInfOriginalFileInformation SetupQueryInfOriginalFileInformationA
#endif
BOOL WINAPI SetupQueryInfVersionInformationA(PSP_INF_INFORMATION ,UINT ,PCSTR ,PSTR,DWORD ,PDWORD);
BOOL WINAPI SetupQueryInfVersionInformationW(PSP_INF_INFORMATION ,UINT ,PCWSTR ,PWSTR ,DWORD,PDWORD);
#ifdef UNICODE
#define SetupQueryInfVersionInformation SetupQueryInfVersionInformationW
#else
#define SetupQueryInfVersionInformation SetupQueryInfVersionInformationA
#endif
BOOL WINAPI SetupGetInfFileListA(PCSTR ,DWORD ,PSTR ,DWORD ,PDWORD );
BOOL WINAPI SetupGetInfFileListW(PCWSTR ,DWORD ,PWSTR ,DWORD ,PDWORD);
#ifdef UNICODE
#define SetupGetInfFileList SetupGetInfFileListW
#else
#define SetupGetInfFileList SetupGetInfFileListA
#endif
HINF WINAPI SetupOpenInfFileW(PCWSTR ,PCWSTR,DWORD ,PUINT);
HINF WINAPI SetupOpenInfFileA(PCSTR ,PCSTR ,DWORD,PUINT);
#ifdef UNICODE
#define SetupOpenInfFile SetupOpenInfFileW
#else
#define SetupOpenInfFile SetupOpenInfFileA
#endif
HINF WINAPI SetupOpenMasterInf(VOID );
BOOL WINAPI SetupOpenAppendInfFileW(PCWSTR ,HINF ,PUINT);
BOOL WINAPI SetupOpenAppendInfFileA(PCSTR ,HINF ,PUINT);
#ifdef UNICODE
#define SetupOpenAppendInfFile SetupOpenAppendInfFileW
#else
#define SetupOpenAppendInfFile SetupOpenAppendInfFileA
#endif
VOID WINAPI SetupCloseInfFile(HINF);
BOOL WINAPI SetupFindFirstLineA(HINF ,PCSTR ,PCSTR ,PINFCONTEXT);
BOOL WINAPI SetupFindFirstLineW(HINF ,PCWSTR ,PCWSTR ,PINFCONTEXT);
#ifdef UNICODE
#define SetupFindFirstLine SetupFindFirstLineW
#else
#define SetupFindFirstLine SetupFindFirstLineA
#endif
BOOL WINAPI SetupFindNextLine(PINFCONTEXT ,PINFCONTEXT);
BOOL WINAPI SetupFindNextMatchLineA(PINFCONTEXT ,PCSTR ,INFCONTEXT);
BOOL WINAPI SetupFindNextMatchLineW(PINFCONTEXT ,PCWSTR ,PINFCONTEXT);
#ifdef UNICODE
#define SetupFindNextMatchLine SetupFindNextMatchLineW
#else
#define SetupFindNextMatchLine SetupFindNextMatchLineA
#endif
BOOL WINAPI SetupGetLineByIndexA(HINF ,PCSTR ,DWORD ,PINFCONTEXT Context );
BOOL WINAPI SetupGetLineByIndexW(HINF ,PCWSTR ,DWORD ,PINFCONTEXT Context );
#ifdef UNICODE
#define SetupGetLineByIndex SetupGetLineByIndexW
#else
#define SetupGetLineByIndex SetupGetLineByIndexA
#endif
LONG WINAPI SetupGetLineCountA(HINF ,PCSTR Section );
LONG WINAPI SetupGetLineCountW(HINF ,PCWSTR Section );
#ifdef UNICODE
#define SetupGetLineCount SetupGetLineCountW
#else
#define SetupGetLineCount SetupGetLineCountA
#endif
BOOL WINAPI SetupGetLineTextA(PINFCONTEXT ,HINF ,PCSTR, PCSTR,PSTR,DWORD,PDWORD);
BOOL WINAPI SetupGetLineTextW(PINFCONTEXT ,HINF ,PCWSTR,PCWSTR ,PWSTR,DWORD,PDWORD);
#ifdef UNICODE
#define SetupGetLineText SetupGetLineTextW
#else
#define SetupGetLineText SetupGetLineTextA
#endif
DWORD WINAPI SetupGetFieldCount(PINFCONTEXT Context );
BOOL WINAPI SetupGetStringFieldA(PINFCONTEXT ,DWORD ,PSTR ,DWORD,PDWORD);
BOOL WINAPI SetupGetStringFieldW(PINFCONTEXT ,DWORD ,PWSTR ,DWORD,PDWORD);
#ifdef UNICODE
#define SetupGetStringField SetupGetStringFieldW
#else
#define SetupGetStringField SetupGetStringFieldA
#endif
BOOL WINAPI SetupGetIntField(PINFCONTEXT ,DWORD ,PINT IntegerValue );
BOOL WINAPI SetupGetMultiSzFieldA(PINFCONTEXT ,DWORD ,PSTR ,DWORD,LPDWORD);
BOOL WINAPI SetupGetMultiSzFieldW(PINFCONTEXT ,DWORD ,PWSTR ,DWORD,LPDWORD);
#ifdef UNICODE
#define SetupGetMultiSzField SetupGetMultiSzFieldW
#else
#define SetupGetMultiSzField SetupGetMultiSzFieldA
#endif
BOOL WINAPI SetupGetBinaryField(PINFCONTEXT ,DWORD ,PBYTE ,DWORD,LPDWORD);
DWORD WINAPI SetupGetFileCompressionInfoA(PCSTR ,PSTR *,PDWORD ,PDWORD ,PUINT);
DWORD WINAPI SetupGetFileCompressionInfoW(PCWSTR ,PWSTR *,PDWORD ,PDWORD ,PUINT);
#ifdef UNICODE
#define SetupGetFileCompressionInfo SetupGetFileCompressionInfoW
#else
#define SetupGetFileCompressionInfo SetupGetFileCompressionInfoA
#endif
#define FILE_COMPRESSION_NONE 0
#define FILE_COMPRESSION_WINLZA 1
#define FILE_COMPRESSION_MSZIP 2
#define FILE_COMPRESSION_NTCAB 3
DWORD WINAPI SetupDecompressOrCopyFileA(PCSTR ,PCSTR ,PUINT);
DWORD WINAPI SetupDecompressOrCopyFileW(PCWSTR ,PCWSTR ,PUINT);
#ifdef UNICODE
#define SetupDecompressOrCopyFile SetupDecompressOrCopyFileW
#else
#define SetupDecompressOrCopyFile SetupDecompressOrCopyFileA
#endif
BOOL WINAPI SetupGetSourceFileLocationA(HINF ,PINFCONTEXT ,PCSTR,PUINT,PSTR ,DWORD,PDWORD);
BOOL WINAPI SetupGetSourceFileLocationW(HINF ,PINFCONTEXT ,PCWSTR ,PUINT,PWSTR ,DWORD,PDWORD);
#ifdef UNICODE
#define SetupGetSourceFileLocation SetupGetSourceFileLocationW
#else
#define SetupGetSourceFileLocation SetupGetSourceFileLocationA
#endif
BOOL WINAPI SetupGetSourceFileSizeA(HINF ,PINFCONTEXT ,PCSTR , PCSTR ,PDWORD ,UINT);
BOOL WINAPI SetupGetSourceFileSizeW(HINF ,PINFCONTEXT ,PCWSTR ,PCWSTR,PDWORD,UINT);
#ifdef UNICODE
#define SetupGetSourceFileSize SetupGetSourceFileSizeW
#else
#define SetupGetSourceFileSize SetupGetSourceFileSizeA
#endif
BOOL WINAPI SetupGetTargetPathA(HINF ,PINFCONTEXT ,PCSTR ,PSTR,DWORD ,PDWORD );
BOOL WINAPI SetupGetTargetPathW(HINF ,PINFCONTEXT ,PCWSTR ,PWSTR,DWORD ,PDWORD );
#ifdef UNICODE
#define SetupGetTargetPath SetupGetTargetPathW
#else
#define SetupGetTargetPath SetupGetTargetPathA
#endif
#define SRCLIST_TEMPORARY 1
#define SRCLIST_NOBROWSE 2
#define SRCLIST_SYSTEM 16
#define SRCLIST_USER 32
#define SRCLIST_SYSIFADMIN 64
#define SRCLIST_SUBDIRS 256
#define SRCLIST_APPEND 512
#define SRCLIST_NOSTRIPPLATFORM 1024
BOOL WINAPI SetupSetSourceListA(DWORD ,PCSTR *,UINT SourceCount );
BOOL WINAPI SetupSetSourceListW(DWORD ,PCWSTR *,UINT SourceCount );
#ifdef UNICODE
#define SetupSetSourceList SetupSetSourceListW
#else
#define SetupSetSourceList SetupSetSourceListA
#endif
BOOL WINAPI SetupCancelTemporarySourceList(VOID );
BOOL WINAPI SetupAddToSourceListA(DWORD ,PCSTR Source );
BOOL WINAPI SetupAddToSourceListW(DWORD ,PCWSTR Source );
#ifdef UNICODE
#define SetupAddToSourceList SetupAddToSourceListW
#else
#define SetupAddToSourceList SetupAddToSourceListA
#endif
BOOL WINAPI SetupRemoveFromSourceListA(DWORD ,PCSTR Source );
BOOL WINAPI SetupRemoveFromSourceListW(DWORD ,PCWSTR Source );
#ifdef UNICODE
#define SetupRemoveFromSourceList SetupRemoveFromSourceListW
#else
#define SetupRemoveFromSourceList SetupRemoveFromSourceListA
#endif
BOOL WINAPI SetupQuerySourceListA(DWORD ,PCSTR **,PUINT Count );
BOOL WINAPI SetupQuerySourceListW(DWORD ,PCWSTR **,PUINT Count );
#ifdef UNICODE
#define SetupQuerySourceList SetupQuerySourceListW
#else
#define SetupQuerySourceList SetupQuerySourceListA
#endif
BOOL WINAPI SetupFreeSourceListA(PCSTR **,UINT Count );
BOOL WINAPI SetupFreeSourceListW(PCWSTR **,UINT Count );
#ifdef UNICODE
#define SetupFreeSourceList SetupFreeSourceListW
#else
#define SetupFreeSourceList SetupFreeSourceListA
#endif
UINT WINAPI SetupPromptForDiskA(HWND ,PCSTR ,PCSTR,PCSTR ,PCSTR ,PCSTR ,DWORD,PSTR ,DWORD ,PDWORD);
UINT WINAPI SetupPromptForDiskW(HWND ,PCWSTR ,PCWSTR ,PCWSTR,PCWSTR ,PCWSTR ,DWORD,PWSTR ,DWORD ,PDWORD);
#ifdef UNICODE
#define SetupPromptForDisk SetupPromptForDiskW
#else
#define SetupPromptForDisk SetupPromptForDiskA
#endif
UINT WINAPI SetupCopyErrorA(HWND ,PCSTR ,PCSTR ,PCSTR,PCSTR ,PCSTR ,UINT,DWORD ,PSTR ,DWORD,PDWORD);
UINT WINAPI SetupCopyErrorW(HWND ,PCWSTR ,PCWSTR ,PCWSTR PathToSource,PCWSTR ,PCWSTR ,UINT,DWORD ,PWSTR ,DWORD ,PDWORD);
#ifdef UNICODE
#define SetupCopyError SetupCopyErrorW
#else
#define SetupCopyError SetupCopyErrorA
#endif
UINT WINAPI SetupRenameErrorA(HWND ,PCSTR ,PCSTR ,PCSTR ,UINT ,DWORD);
UINT WINAPI SetupRenameErrorW(HWND ,PCWSTR ,PCWSTR ,PCWSTR ,UINT ,DWORD);
#ifdef UNICODE
#define SetupRenameError SetupRenameErrorW
#else
#define SetupRenameError SetupRenameErrorA
#endif
UINT WINAPI SetupDeleteErrorA(HWND ,PCSTR ,PCSTR,UINT ,DWORD);
UINT WINAPI SetupDeleteErrorW(HWND ,PCWSTR ,PCWSTR ,UINT ,DWORD);
#ifdef UNICODE
#define SetupDeleteError SetupDeleteErrorW
#else
#define SetupDeleteError SetupDeleteErrorA
#endif
UINT WINAPI SetupBackupErrorA(HWND ,PCSTR ,PCSTR ,PCSTR ,UINT ,DWORD );
UINT WINAPI SetupBackupErrorW(HWND ,PCWSTR ,PCWSTR ,PCWSTR ,UINT ,DWORD  );
#ifdef UNICODE
#define SetupBackupError SetupBackupErrorW
#else
#define SetupBackupError SetupBackupErrorA
#endif
#define IDF_NOBROWSE 1
#define IDF_NOSKIP 2
#define IDF_NODETAILS 4
#define IDF_NOCOMPRESSED 8
#define IDF_CHECKFIRST 256
#define IDF_NOBEEP 512
#define IDF_NOFOREGROUND 1024
#define IDF_WARNIFSKIP 2048
#define IDF_OEMDISK 0x80000000
#define DPROMPT_SUCCESS 0
#define DPROMPT_CANCEL 1
#define DPROMPT_SKIPFILE 2
#define DPROMPT_BUFFERTOOSMALL 3
#define DPROMPT_OUTOFMEMORY 4
BOOL WINAPI SetupSetDirectoryIdA(HINF ,DWORD ,PCSTR);
BOOL WINAPI SetupSetDirectoryIdW(HINF ,DWORD ,PCWSTR);
#ifdef UNICODE
#define SetupSetDirectoryId SetupSetDirectoryIdW
#else
#define SetupSetDirectoryId SetupSetDirectoryIdA
#endif
BOOL WINAPI SetupSetDirectoryIdExA(HINF ,DWORD ,PCSTR,DWORD,DWORD ,PVOID);
BOOL WINAPI SetupSetDirectoryIdExW(HINF ,DWORD ,PCWSTR,DWORD,DWORD ,PVOID );
#ifdef UNICODE
#define SetupSetDirectoryIdEx SetupSetDirectoryIdExW
#else
#define SetupSetDirectoryIdEx SetupSetDirectoryIdExA
#endif
#define SETDIRID_NOT_FULL_PATH 1
BOOL WINAPI SetupGetSourceInfoA(HINF ,UINT ,UINT ,PSTR ,DWORD ReturnBufferSize,PDWORD RequiredSize );
BOOL WINAPI SetupGetSourceInfoW(HINF ,UINT ,UINT ,PWSTR ,DWORD ReturnBufferSize,PDWORD RequiredSize );
#ifdef UNICODE
#define SetupGetSourceInfo SetupGetSourceInfoW
#else
#define SetupGetSourceInfo SetupGetSourceInfoA
#endif
#define SRCINFO_PATH 1
#define SRCINFO_TAGFILE 2
#define SRCINFO_DESCRIPTION 3
#define SRCINFO_FLAGS 4
BOOL WINAPI SetupInstallFileA(HINF ,PINFCONTEXT InfContext,PCSTR SourceFile,PCSTR SourcePathRoot,PCSTR DestinationName,DWORD CopyStyle,PSP_FILE_CALLBACK_A ,PVOID );
BOOL WINAPI SetupInstallFileW(HINF ,PINFCONTEXT InfContext,PCWSTR SourceFile,PCWSTR SourcePathRoot,PCWSTR DestinationName, DWORD ,PSP_FILE_CALLBACK_W ,PVOID);
#ifdef UNICODE
#define SetupInstallFile SetupInstallFileW
#else
#define SetupInstallFile SetupInstallFileA
#endif
BOOL WINAPI SetupInstallFileExA(HINF ,PINFCONTEXT InfContext,PCSTR SourceFile,PCSTR SourcePathRoot,PCSTR DestinationName,DWORD CopyStyle,PSP_FILE_CALLBACK_A ,PVOID Context,PBOOL FileWasInUse );
BOOL WINAPI SetupInstallFileExW(HINF ,PINFCONTEXT InfContext,PCWSTR SourceFile,PCWSTR SourcePathRoot,PCWSTR DestinationName,DWORD CopyStyle,PSP_FILE_CALLBACK_W ,PVOID Context,PBOOL FileWasInUse );
#ifdef UNICODE
#define SetupInstallFileEx SetupInstallFileExW
#else
#define SetupInstallFileEx SetupInstallFileExA
#endif
#define SP_COPY_DELETESOURCE 1
#define SP_COPY_REPLACEONLY 2
#define SP_COPY_NEWER 4
#define SP_COPY_NEWER_OR_SAME SP_COPY_NEWER
#define SP_COPY_NOOVERWRITE 8
#define SP_COPY_NODECOMP 16
#define SP_COPY_LANGUAGEAWARE 32
#define SP_COPY_SOURCE_ABSOLUTE 64
#define SP_COPY_SOURCEPATH_ABSOLUTE 128
#define SP_COPY_IN_USE_NEEDS_REBOOT 256
#define SP_COPY_FORCE_IN_USE 512
#define SP_COPY_NOSKIP 1024
#define SP_FLAG_CABINETCONTINUATION 2048
#define SP_COPY_FORCE_NOOVERWRITE 4096
#define SP_COPY_FORCE_NEWER 0x2000
#define SP_COPY_WARNIFSKIP 0x4000
#define SP_COPY_NOBROWSE 0x8000
#define SP_COPY_NEWER_ONLY 0x10000
#define SP_COPY_SOURCE_SIS_MASTER 0x20000
#define SP_COPY_OEMINF_CATALOG_ONLY 0x40000
#define SP_COPY_REPLACE_BOOT_FILE 0x80000
#define SP_COPY_NOPRUNE 0x100000
HSPFILEQ WINAPI SetupOpenFileQueue(VOID );
BOOL WINAPI SetupCloseFileQueue(HSPFILEQ QueueHandle );
BOOL WINAPI SetupSetFileQueueAlternatePlatformA(HSPFILEQ ,PSP_ALTPLATFORM_INFO ,PCSTR AlternateDefaultCatalogFile );
BOOL WINAPI SetupSetFileQueueAlternatePlatformW(HSPFILEQ ,PSP_ALTPLATFORM_INFO ,PCWSTR AlternateDefaultCatalogFile );
#ifdef UNICODE
#define SetupSetFileQueueAlternatePlatform SetupSetFileQueueAlternatePlatformW
#else
#define SetupSetFileQueueAlternatePlatform SetupSetFileQueueAlternatePlatformA
#endif
BOOL WINAPI SetupSetPlatformPathOverrideA(PCSTR Override );
BOOL WINAPI SetupSetPlatformPathOverrideW(PCWSTR Override );
#ifdef UNICODE
#define SetupSetPlatformPathOverride SetupSetPlatformPathOverrideW
#else
#define SetupSetPlatformPathOverride SetupSetPlatformPathOverrideA
#endif
BOOL WINAPI SetupQueueCopyA(HSPFILEQ ,PCSTR ,PCSTR SourcePath,PCSTR SourceFilename,PCSTR ,PCSTR SourceTagfile,PCSTR TargetDirectory,PCSTR ,DWORD CopyStyle );
BOOL WINAPI SetupQueueCopyW(HSPFILEQ ,PCWSTR ,PCWSTR SourcePath,PCWSTR SourceFilename,PCWSTR ,PCWSTR SourceTagfile,PCWSTR TargetDirectory,PCWSTR ,DWORD CopyStyle );
#ifdef UNICODE
#define SetupQueueCopy SetupQueueCopyW
#else
#define SetupQueueCopy SetupQueueCopyA
#endif
BOOL WINAPI SetupQueueCopyIndirectA(PSP_FILE_COPY_PARAMS_A CopyParams );
BOOL WINAPI SetupQueueCopyIndirectW(PSP_FILE_COPY_PARAMS_W CopyParams );
#ifdef UNICODE
#define SetupQueueCopyIndirect SetupQueueCopyIndirectW
#else
#define SetupQueueCopyIndirect SetupQueueCopyIndirectA
#endif
BOOL WINAPI SetupQueueDefaultCopyA(HSPFILEQ ,HINF ,PCSTR ,PCSTR ,PCSTR ,DWORD CopyStyle );
BOOL WINAPI SetupQueueDefaultCopyW(HSPFILEQ ,HINF ,PCWSTR ,PCWSTR ,PCWSTR ,DWORD CopyStyle );
#ifdef UNICODE
#define SetupQueueDefaultCopy SetupQueueDefaultCopyW
#else
#define SetupQueueDefaultCopy SetupQueueDefaultCopyA
#endif
BOOL WINAPI SetupQueueCopySectionA(HSPFILEQ ,PCSTR ,HINF ,HINF ,PCSTR Section,DWORD CopyStyle );
BOOL WINAPI SetupQueueCopySectionW(HSPFILEQ ,PCWSTR ,HINF ,HINF ,PCWSTR Section,DWORD CopyStyle );
#ifdef UNICODE
#define SetupQueueCopySection SetupQueueCopySectionW
#else
#define SetupQueueCopySection SetupQueueCopySectionA
#endif
BOOL WINAPI SetupQueueDeleteA(HSPFILEQ ,PCSTR ,PCSTR PathPart2 );
BOOL WINAPI SetupQueueDeleteW(HSPFILEQ ,PCWSTR ,PCWSTR PathPart2 );
#ifdef UNICODE
#define SetupQueueDelete SetupQueueDeleteW
#else
#define SetupQueueDelete SetupQueueDeleteA
#endif
BOOL WINAPI SetupQueueDeleteSectionA(HSPFILEQ ,HINF ,HINF ,PCSTR Section );
BOOL WINAPI SetupQueueDeleteSectionW(HSPFILEQ ,HINF ,HINF ,PCWSTR Section );
#ifdef UNICODE
#define SetupQueueDeleteSection SetupQueueDeleteSectionW
#else
#define SetupQueueDeleteSection SetupQueueDeleteSectionA
#endif
BOOL WINAPI SetupQueueRenameA(HSPFILEQ ,PCSTR ,PCSTR ,PCSTR TargetPath,PCSTR TargetFilename );
BOOL WINAPI SetupQueueRenameW(HSPFILEQ ,PCWSTR ,PCWSTR ,PCWSTR TargetPath,PCWSTR TargetFilename );
#ifdef UNICODE
#define SetupQueueRename SetupQueueRenameW
#else
#define SetupQueueRename SetupQueueRenameA
#endif
BOOL WINAPI SetupQueueRenameSectionA(HSPFILEQ ,HINF ,HINF ,PCSTR Section );
BOOL WINAPI SetupQueueRenameSectionW(HSPFILEQ ,HINF ,HINF ,PCWSTR Section );
#ifdef UNICODE
#define SetupQueueRenameSection SetupQueueRenameSectionW
#else
#define SetupQueueRenameSection SetupQueueRenameSectionA
#endif
BOOL WINAPI SetupCommitFileQueueA(HWND ,HSPFILEQ QueueHandle,PSP_FILE_CALLBACK_A ,PVOID Context );
BOOL WINAPI SetupCommitFileQueueW(HWND ,HSPFILEQ QueueHandle,PSP_FILE_CALLBACK_W ,PVOID Context );
#ifdef UNICODE
#define SetupCommitFileQueue SetupCommitFileQueueW
#else
#define SetupCommitFileQueue SetupCommitFileQueueA
#endif
BOOL WINAPI SetupScanFileQueueA(HSPFILEQ ,DWORD ,HWND ,PSP_FILE_CALLBACK_A CallbackRoutine,PVOID CallbackContext,PDWORD Result );
BOOL WINAPI SetupScanFileQueueW(HSPFILEQ ,DWORD ,HWND ,PSP_FILE_CALLBACK_W CallbackRoutine,PVOID CallbackContext,PDWORD Result );
#ifdef UNICODE
#define SetupScanFileQueue SetupScanFileQueueW
#else
#define SetupScanFileQueue SetupScanFileQueueA
#endif
#define SPQ_SCAN_FILE_PRESENCE 1
#define SPQ_SCAN_FILE_VALIDITY 2
#define SPQ_SCAN_USE_CALLBACK 4
#define SPQ_SCAN_USE_CALLBACKEX 8
#define SPQ_SCAN_INFORM_USER 16
#define SPQ_SCAN_PRUNE_COPY_QUEUE 32
#define SPQ_DELAYED_COPY 1
#define SPOST_NONE 0
#define SPOST_PATH 1
#define SPOST_URL 2
#define SPOST_MAX 3
BOOL WINAPI SetupCopyOEMInfA(PCSTR ,PCSTR ,DWORD OEMSourceMediaType,DWORD ,PSTR ,DWORD DestinationInfFileNameSize,PDWORD ,PSTR *DestinationInfFileNameComponent );
BOOL WINAPI SetupCopyOEMInfW(PCWSTR ,PCWSTR ,DWORD OEMSourceMediaType,DWORD ,PWSTR ,DWORD DestinationInfFileNameSize,PDWORD ,PWSTR *DestinationInfFileNameComponent );
#ifdef UNICODE
#define SetupCopyOEMInf SetupCopyOEMInfW
#else
#define SetupCopyOEMInf SetupCopyOEMInfA
#endif
HDSKSPC WINAPI SetupCreateDiskSpaceListA(PVOID ,DWORD ,UINT Flags );
HDSKSPC WINAPI SetupCreateDiskSpaceListW(PVOID ,DWORD ,UINT Flags );
#ifdef UNICODE
#define SetupCreateDiskSpaceList SetupCreateDiskSpaceListW
#else
#define SetupCreateDiskSpaceList SetupCreateDiskSpaceListA
#endif
#define SPDSL_IGNORE_DISK 1
#define SPDSL_DISALLOW_NEGATIVE_ADJUST 2
HDSKSPC WINAPI SetupDuplicateDiskSpaceListA(HDSKSPC ,PVOID ,DWORD ,UINT Flags );
HDSKSPC WINAPI SetupDuplicateDiskSpaceListW(HDSKSPC ,PVOID ,DWORD ,UINT Flags );
#ifdef UNICODE
#define SetupDuplicateDiskSpaceList SetupDuplicateDiskSpaceListW
#else
#define SetupDuplicateDiskSpaceList SetupDuplicateDiskSpaceListA
#endif
BOOL WINAPI SetupDestroyDiskSpaceList(HDSKSPC DiskSpace );
BOOL WINAPI SetupQueryDrivesInDiskSpaceListA(HDSKSPC ,PSTR ,DWORD ReturnBufferSize,PDWORD RequiredSize );
BOOL WINAPI SetupQueryDrivesInDiskSpaceListW(HDSKSPC ,PWSTR ,DWORD ReturnBufferSize,PDWORD RequiredSize );
#ifdef UNICODE
#define SetupQueryDrivesInDiskSpaceList SetupQueryDrivesInDiskSpaceListW
#else
#define SetupQueryDrivesInDiskSpaceList SetupQueryDrivesInDiskSpaceListA
#endif
BOOL WINAPI SetupQuerySpaceRequiredOnDriveA(HDSKSPC ,PCSTR ,LONGLONG *,PVOID ,UINT Reserved2 );
BOOL WINAPI SetupQuerySpaceRequiredOnDriveW(HDSKSPC ,PCWSTR ,LONGLONG *,PVOID ,UINT Reserved2 );
#ifdef UNICODE
#define SetupQuerySpaceRequiredOnDrive SetupQuerySpaceRequiredOnDriveW
#else
#define SetupQuerySpaceRequiredOnDrive SetupQuerySpaceRequiredOnDriveA
#endif
BOOL WINAPI SetupAdjustDiskSpaceListA(HDSKSPC ,LPCSTR ,LONGLONG ,PVOID ,UINT Reserved2 );
BOOL WINAPI SetupAdjustDiskSpaceListW(HDSKSPC ,LPCWSTR ,LONGLONG ,PVOID ,UINT Reserved2 );
#ifdef UNICODE
#define SetupAdjustDiskSpaceList SetupAdjustDiskSpaceListW
#else
#define SetupAdjustDiskSpaceList SetupAdjustDiskSpaceListA
#endif
BOOL WINAPI SetupAddToDiskSpaceListA(HDSKSPC ,PCSTR ,LONGLONG ,UINT ,PVOID ,UINT Reserved2 );
BOOL WINAPI SetupAddToDiskSpaceListW(HDSKSPC ,PCWSTR ,LONGLONG ,UINT ,PVOID ,UINT Reserved2 );
#ifdef UNICODE
#define SetupAddToDiskSpaceList SetupAddToDiskSpaceListW
#else
#define SetupAddToDiskSpaceList SetupAddToDiskSpaceListA
#endif
BOOL WINAPI SetupAddSectionToDiskSpaceListA(HDSKSPC ,HINF ,HINF ,PCSTR SectionName,UINT ,PVOID ,UINT Reserved2 );
BOOL WINAPI SetupAddSectionToDiskSpaceListW(HDSKSPC ,HINF ,HINF ,PCWSTR SectionName,UINT ,PVOID ,UINT Reserved2 );
#ifdef UNICODE
#define SetupAddSectionToDiskSpaceList SetupAddSectionToDiskSpaceListW
#else
#define SetupAddSectionToDiskSpaceList SetupAddSectionToDiskSpaceListA
#endif
BOOL WINAPI SetupAddInstallSectionToDiskSpaceListA(HDSKSPC ,HINF ,HINF ,PCSTR SectionName,PVOID ,UINT Reserved2 );
BOOL WINAPI SetupAddInstallSectionToDiskSpaceListW(HDSKSPC ,HINF ,HINF ,PCWSTR SectionName,PVOID ,UINT Reserved2 );
#ifdef UNICODE
#define SetupAddInstallSectionToDiskSpaceList SetupAddInstallSectionToDiskSpaceListW
#else
#define SetupAddInstallSectionToDiskSpaceList SetupAddInstallSectionToDiskSpaceListA
#endif
BOOL WINAPI SetupRemoveFromDiskSpaceListA(HDSKSPC ,PCSTR ,UINT ,PVOID ,UINT Reserved2 );
BOOL WINAPI SetupRemoveFromDiskSpaceListW(HDSKSPC ,PCWSTR ,UINT ,PVOID ,UINT Reserved2 );
#ifdef UNICODE
#define SetupRemoveFromDiskSpaceList SetupRemoveFromDiskSpaceListW
#else
#define SetupRemoveFromDiskSpaceList SetupRemoveFromDiskSpaceListA
#endif
BOOL WINAPI SetupRemoveSectionFromDiskSpaceListA(HDSKSPC ,HINF ,HINF ,PCSTR SectionName,UINT ,PVOID ,UINT Reserved2 );
BOOL WINAPI SetupRemoveSectionFromDiskSpaceListW(HDSKSPC ,HINF ,HINF ,PCWSTR SectionName,UINT ,PVOID ,UINT Reserved2 );
#ifdef UNICODE
#define SetupRemoveSectionFromDiskSpaceList SetupRemoveSectionFromDiskSpaceListW
#else
#define SetupRemoveSectionFromDiskSpaceList SetupRemoveSectionFromDiskSpaceListA
#endif
BOOL WINAPI SetupRemoveInstallSectionFromDiskSpaceListA(HDSKSPC ,HINF ,HINF ,PCSTR SectionName,PVOID ,UINT Reserved2 );
BOOL WINAPI SetupRemoveInstallSectionFromDiskSpaceListW(HDSKSPC ,HINF ,HINF ,PCWSTR SectionName,PVOID ,UINT Reserved2 );
#ifdef UNICODE
#define SetupRemoveInstallSectionFromDiskSpaceList SetupRemoveInstallSectionFromDiskSpaceListW
#else
#define SetupRemoveInstallSectionFromDiskSpaceList SetupRemoveInstallSectionFromDiskSpaceListA
#endif
BOOL WINAPI SetupIterateCabinetA(PCSTR ,DWORD ,PSP_FILE_CALLBACK_A ,PVOID Context );
BOOL WINAPI SetupIterateCabinetW(PCWSTR ,DWORD ,PSP_FILE_CALLBACK_W ,PVOID Context );
#ifdef UNICODE
#define SetupIterateCabinet SetupIterateCabinetW
#else
#define SetupIterateCabinet SetupIterateCabinetA
#endif
INT WINAPI SetupPromptReboot(HSPFILEQ ,HWND Owner,BOOL ScanOnly );
#define SPFILEQ_FILE_IN_USE 1
#define SPFILEQ_REBOOT_RECOMMENDED 2
#define SPFILEQ_REBOOT_IN_PROGRESS 4
PVOID WINAPI SetupInitDefaultQueueCallback(HWND OwnerWindow );
PVOID WINAPI SetupInitDefaultQueueCallbackEx(HWND ,HWND ,UINT ProgressMessage,DWORD ,PVOID Reserved2 );
VOID WINAPI SetupTermDefaultQueueCallback(PVOID Context );
UINT WINAPI SetupDefaultQueueCallbackA(PVOID ,UINT ,UINT_PTR ,UINT_PTR Param2 );
UINT WINAPI SetupDefaultQueueCallbackW(PVOID ,UINT ,UINT_PTR ,UINT_PTR Param2 );
#ifdef UNICODE
#define SetupDefaultQueueCallback SetupDefaultQueueCallbackW
#else
#define SetupDefaultQueueCallback SetupDefaultQueueCallbackA
#endif
#define FLG_ADDREG_BINVALUETYPE 1
#define FLG_ADDREG_NOCLOBBER 2
#define FLG_ADDREG_DELVAL 4
#define FLG_ADDREG_APPEND 8 
#define FLG_ADDREG_KEYONLY 16 
#define FLG_ADDREG_OVERWRITEONLY 32 
#define FLG_ADDREG_TYPE_MASK (0xffff0000| FLG_ADDREG_BINVALUETYPE)
#define FLG_ADDREG_TYPE_SZ 0
#define FLG_ADDREG_TYPE_MULTI_SZ 0x10000
#define FLG_ADDREG_TYPE_EXPAND_SZ 0x20000
#define FLG_ADDREG_TYPE_BINARY (0| FLG_ADDREG_BINVALUETYPE)
#define FLG_ADDREG_TYPE_DWORD (0x10000| FLG_ADDREG_BINVALUETYPE)
#define FLG_ADDREG_TYPE_NONE (0x20000| FLG_ADDREG_BINVALUETYPE)
#define FLG_BITREG_CLEARBITS 0
#define FLG_BITREG_SETBITS 1
#define FLG_REGSVR_DLLREGISTER 1
#define FLG_REGSVR_DLLINSTALL 2
#define FLG_PROFITEM_CURRENTUSER 1
#define FLG_PROFITEM_DELETE 2
#define FLG_PROFITEM_GROUP 4
BOOL WINAPI SetupInstallFromInfSectionA(HWND ,HINF ,PCSTR ,UINT ,HKEY ,PCSTR SourceRootPath,UINT CopyFlags,PSP_FILE_CALLBACK_A ,PVOID ,HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupInstallFromInfSectionW(HWND ,HINF ,PCWSTR ,UINT ,HKEY ,PCWSTR SourceRootPath,UINT CopyFlags,PSP_FILE_CALLBACK_W ,PVOID ,HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData );
#ifdef UNICODE
#define SetupInstallFromInfSection SetupInstallFromInfSectionW
#else
#define SetupInstallFromInfSection SetupInstallFromInfSectionA
#endif
#define SPINST_LOGCONFIG 1
#define SPINST_INIFILES 2
#define SPINST_REGISTRY 4
#define SPINST_INI2REG 8
#define SPINST_FILES 16
#define SPINST_BITREG 32
#define SPINST_REGSVR 64
#define SPINST_UNREGSVR 128
#define SPINST_PROFILEITEMS 256
#define SPINST_ALL 511
#define SPINST_SINGLESECTION 0x10000
#define SPINST_LOGCONFIG_IS_FORCED 0x20000
#define SPINST_LOGCONFIGS_ARE_OVERRIDES 0x40000
BOOL WINAPI SetupInstallFilesFromInfSectionA(HINF ,HINF ,HSPFILEQ FileQueue,PCSTR ,PCSTR ,UINT CopyFlags );
BOOL WINAPI SetupInstallFilesFromInfSectionW(HINF ,HINF ,HSPFILEQ FileQueue,PCWSTR ,PCWSTR ,UINT CopyFlags );
#ifdef UNICODE
#define SetupInstallFilesFromInfSection SetupInstallFilesFromInfSectionW
#else
#define SetupInstallFilesFromInfSection SetupInstallFilesFromInfSectionA
#endif
#define SPSVCINST_TAGTOFRONT 1
#define SPSVCINST_ASSOCSERVICE 2
#define SPSVCINST_DELETEEVENTLOGENTRY 4
#define SPSVCINST_NOCLOBBER_DISPLAYNAME 8
#define SPSVCINST_NOCLOBBER_STARTTYPE 16
#define SPSVCINST_NOCLOBBER_ERRORCONTROL 32
#define SPSVCINST_NOCLOBBER_LOADORDERGROUP 64
#define SPSVCINST_NOCLOBBER_DEPENDENCIES 128
#define SPSVCINST_NOCLOBBER_DESCRIPTION 256
BOOL WINAPI SetupInstallServicesFromInfSectionA(HINF ,PCSTR ,DWORD Flags );
BOOL WINAPI SetupInstallServicesFromInfSectionW(HINF ,PCWSTR ,DWORD Flags );
#ifdef UNICODE
#define SetupInstallServicesFromInfSection SetupInstallServicesFromInfSectionW
#else
#define SetupInstallServicesFromInfSection SetupInstallServicesFromInfSectionA
#endif
BOOL WINAPI SetupInstallServicesFromInfSectionExA(HINF ,PCSTR ,DWORD ,HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData,PVOID Reserved1,PVOID Reserved2 );
BOOL WINAPI SetupInstallServicesFromInfSectionExW(HINF ,PCWSTR ,DWORD ,HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData,PVOID Reserved1,PVOID Reserved2 );
#ifdef UNICODE
#define SetupInstallServicesFromInfSectionEx SetupInstallServicesFromInfSectionExW
#else
#define SetupInstallServicesFromInfSectionEx SetupInstallServicesFromInfSectionExA
#endif
typedef PVOID HSPFILELOG;
HSPFILELOG WINAPI SetupInitializeFileLogA(PCSTR ,DWORD Flags );
HSPFILELOG WINAPI SetupInitializeFileLogW(PCWSTR ,DWORD Flags );
#ifdef UNICODE
#define SetupInitializeFileLog SetupInitializeFileLogW
#else
#define SetupInitializeFileLog SetupInitializeFileLogA
#endif
#define SPFILELOG_SYSTEMLOG 1
#define SPFILELOG_FORCENEW 2
#define SPFILELOG_QUERYONLY 4
BOOL WINAPI SetupTerminateFileLog(HSPFILELOG FileLogHandle );
BOOL WINAPI SetupLogFileA(HSPFILELOG ,PCSTR ,PCSTR SourceFilename,PCSTR ,DWORD ,PCSTR DiskTagfile,PCSTR DiskDescription,PCSTR OtherInfo,DWORD Flags );
BOOL WINAPI SetupLogFileW(HSPFILELOG ,PCWSTR ,PCWSTR SourceFilename,PCWSTR ,DWORD ,PCWSTR DiskTagfile,PCWSTR DiskDescription,PCWSTR OtherInfo,DWORD Flags );
#ifdef UNICODE
#define SetupLogFile SetupLogFileW
#else
#define SetupLogFile SetupLogFileA
#endif
#define SPFILELOG_OEMFILE 1
BOOL WINAPI SetupRemoveFileLogEntryA(HSPFILELOG ,PCSTR ,PCSTR TargetFilename );
BOOL WINAPI SetupRemoveFileLogEntryW(HSPFILELOG ,PCWSTR ,PCWSTR TargetFilename );
#ifdef UNICODE
#define SetupRemoveFileLogEntry SetupRemoveFileLogEntryW
#else
#define SetupRemoveFileLogEntry SetupRemoveFileLogEntryA
#endif
typedef enum {
SetupFileLogSourceFilename,
SetupFileLogChecksum,
SetupFileLogDiskTagfile,
SetupFileLogDiskDescription,
SetupFileLogOtherInfo,
SetupFileLogMax
} SetupFileLogInfo;
BOOL WINAPI SetupQueryFileLogA(HSPFILELOG ,PCSTR ,PCSTR TargetFilename,SetupFileLogInfo ,PSTR ,DWORD ReturnBufferSize,PDWORD RequiredSize );
BOOL WINAPI SetupQueryFileLogW(HSPFILELOG ,PCWSTR ,PCWSTR TargetFilename,SetupFileLogInfo ,PWSTR ,DWORD ReturnBufferSize,PDWORD RequiredSize );
#ifdef UNICODE
#define SetupQueryFileLog SetupQueryFileLogW
#else
#define SetupQueryFileLog SetupQueryFileLogA
#endif
#define LogSeverity DWORD
#define LogSevInformation 0
#define LogSevWarning 1
#define LogSevError 2
#define LogSevFatalError 3
#define LogSevMaximum 4
BOOL WINAPI SetupOpenLog (BOOL Erase );
BOOL WINAPI SetupLogErrorA (LPCSTR ,LogSeverity Severity );
BOOL WINAPI SetupLogErrorW (LPCWSTR ,LogSeverity Severity );
#ifdef UNICODE
#define SetupLogError SetupLogErrorW
#else
#define SetupLogError SetupLogErrorA
#endif
VOID WINAPI SetupCloseLog (VOID );
BOOL WINAPI SetupGetBackupInformationA(HSPFILEQ ,PSP_BACKUP_QUEUE_PARAMS_A BackupParams );
BOOL WINAPI SetupGetBackupInformationW(HSPFILEQ ,PSP_BACKUP_QUEUE_PARAMS_W BackupParams );
#ifdef UNICODE
#define SetupGetBackupInformation SetupGetBackupInformationW
#else
#define SetupGetBackupInformation SetupGetBackupInformationA
#endif
HDEVINFO WINAPI SetupDiCreateDeviceInfoList(CONST GUID *ClassGuid,HWND hwndParent );
HDEVINFO WINAPI SetupDiCreateDeviceInfoListExA(CONST GUID *ClassGuid,HWND hwndParent,PCSTR MachineName,PVOID Reserved );
HDEVINFO WINAPI SetupDiCreateDeviceInfoListExW(CONST GUID *ClassGuid,HWND hwndParent,PCWSTR MachineName,PVOID Reserved );
#ifdef UNICODE
#define SetupDiCreateDeviceInfoListEx SetupDiCreateDeviceInfoListExW
#else
#define SetupDiCreateDeviceInfoListEx SetupDiCreateDeviceInfoListExA
#endif
BOOL WINAPI SetupDiGetDeviceInfoListClass(HDEVINFO ,LPGUID ClassGuid );
BOOL WINAPI SetupDiGetDeviceInfoListDetailA(HDEVINFO ,PSP_DEVINFO_LIST_DETAIL_DATA_A DeviceInfoSetDetailData );
BOOL WINAPI SetupDiGetDeviceInfoListDetailW(HDEVINFO ,PSP_DEVINFO_LIST_DETAIL_DATA_W DeviceInfoSetDetailData );
#ifdef UNICODE
#define SetupDiGetDeviceInfoListDetail SetupDiGetDeviceInfoListDetailW
#else
#define SetupDiGetDeviceInfoListDetail SetupDiGetDeviceInfoListDetailA
#endif
#define DICD_GENERATE_ID 1
#define DICD_INHERIT_CLASSDRVS 2
BOOL WINAPI SetupDiCreateDeviceInfoA(HDEVINFO ,PCSTR ,CONST GUID *ClassGuid,PCSTR ,HWND hwndParent,DWORD CreationFlags,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiCreateDeviceInfoW(HDEVINFO ,PCWSTR ,CONST GUID *ClassGuid,PCWSTR ,HWND hwndParent,DWORD CreationFlags,PSP_DEVINFO_DATA DeviceInfoData );
#ifdef UNICODE
#define SetupDiCreateDeviceInfo SetupDiCreateDeviceInfoW
#else
#define SetupDiCreateDeviceInfo SetupDiCreateDeviceInfoA
#endif
#define DIOD_INHERIT_CLASSDRVS 2
#define DIOD_CANCEL_REMOVE 4
BOOL WINAPI SetupDiOpenDeviceInfoA(HDEVINFO ,PCSTR ,HWND ,DWORD OpenFlags,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiOpenDeviceInfoW(HDEVINFO ,PCWSTR ,HWND ,DWORD OpenFlags,PSP_DEVINFO_DATA DeviceInfoData );
#ifdef UNICODE
#define SetupDiOpenDeviceInfo SetupDiOpenDeviceInfoW
#else
#define SetupDiOpenDeviceInfo SetupDiOpenDeviceInfoA
#endif
BOOL WINAPI SetupDiGetDeviceInstanceIdA(HDEVINFO ,PSP_DEVINFO_DATA ,PSTR ,DWORD ,PDWORD RequiredSize );
BOOL WINAPI SetupDiGetDeviceInstanceIdW(HDEVINFO ,PSP_DEVINFO_DATA ,PWSTR ,DWORD ,PDWORD RequiredSize );
#ifdef UNICODE
#define SetupDiGetDeviceInstanceId SetupDiGetDeviceInstanceIdW
#else
#define SetupDiGetDeviceInstanceId SetupDiGetDeviceInstanceIdA
#endif
BOOL WINAPI SetupDiDeleteDeviceInfo(HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiEnumDeviceInfo(HDEVINFO ,DWORD ,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiDestroyDeviceInfoList(HDEVINFO DeviceInfoSet );
BOOL WINAPI SetupDiEnumDeviceInterfaces(HDEVINFO ,PSP_DEVINFO_DATA ,CONST GUID *InterfaceClassGuid,DWORD ,PSP_DEVICE_INTERFACE_DATA DeviceInterfaceData );
#define SetupDiEnumInterfaceDevice SetupDiEnumDeviceInterfaces
BOOL WINAPI SetupDiCreateDeviceInterfaceA(HDEVINFO ,PSP_DEVINFO_DATA ,CONST GUID *InterfaceClassGuid,PCSTR ,DWORD CreationFlags,PSP_DEVICE_INTERFACE_DATA DeviceInterfaceData );
BOOL WINAPI SetupDiCreateDeviceInterfaceW(HDEVINFO ,PSP_DEVINFO_DATA ,CONST GUID *InterfaceClassGuid,PCWSTR ,DWORD CreationFlags,PSP_DEVICE_INTERFACE_DATA DeviceInterfaceData );
#ifdef UNICODE
#define SetupDiCreateDeviceInterface SetupDiCreateDeviceInterfaceW
#else
#define SetupDiCreateDeviceInterface SetupDiCreateDeviceInterfaceA
#endif
#define SetupDiCreateInterfaceDeviceW SetupDiCreateDeviceInterfaceW
#define SetupDiCreateInterfaceDeviceA SetupDiCreateDeviceInterfaceA
#ifdef UNICODE
#define SetupDiCreateInterfaceDevice SetupDiCreateDeviceInterfaceW
#else
#define SetupDiCreateInterfaceDevice SetupDiCreateDeviceInterfaceA
#endif
#define DIODI_NO_ADD 1
BOOL WINAPI SetupDiOpenDeviceInterfaceA(HDEVINFO ,PCSTR ,DWORD ,PSP_DEVICE_INTERFACE_DATA DeviceInterfaceData );
BOOL WINAPI SetupDiOpenDeviceInterfaceW(HDEVINFO ,PCWSTR ,DWORD ,PSP_DEVICE_INTERFACE_DATA DeviceInterfaceData );
#ifdef UNICODE
#define SetupDiOpenDeviceInterface SetupDiOpenDeviceInterfaceW
#else
#define SetupDiOpenDeviceInterface SetupDiOpenDeviceInterfaceA
#endif
#define SetupDiOpenInterfaceDeviceW SetupDiOpenDeviceInterfaceW
#define SetupDiOpenInterfaceDeviceA SetupDiOpenDeviceInterfaceA
#ifdef UNICODE
#define SetupDiOpenInterfaceDevice SetupDiOpenDeviceInterfaceW
#else
#define SetupDiOpenInterfaceDevice SetupDiOpenDeviceInterfaceA
#endif
BOOL WINAPI SetupDiGetDeviceInterfaceAlias(HDEVINFO ,PSP_DEVICE_INTERFACE_DATA ,CONST GUID *AliasInterfaceClassGuid,PSP_DEVICE_INTERFACE_DATA AliasDeviceInterfaceData );
#define SetupDiGetInterfaceDeviceAlias SetupDiGetDeviceInterfaceAlias
BOOL WINAPI SetupDiDeleteDeviceInterfaceData(HDEVINFO ,PSP_DEVICE_INTERFACE_DATA DeviceInterfaceData );
#define SetupDiDeleteInterfaceDeviceData SetupDiDeleteDeviceInterfaceData
BOOL WINAPI SetupDiRemoveDeviceInterface(HDEVINFO ,PSP_DEVICE_INTERFACE_DATA DeviceInterfaceData );
#define SetupDiRemoveInterfaceDevice SetupDiRemoveDeviceInterface
BOOL WINAPI SetupDiGetDeviceInterfaceDetailA(HDEVINFO ,PSP_DEVICE_INTERFACE_DATA ,PSP_DEVICE_INTERFACE_DETAIL_DATA_A ,DWORD DeviceInterfaceDetailDataSize,PDWORD ,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiGetDeviceInterfaceDetailW(HDEVINFO ,PSP_DEVICE_INTERFACE_DATA ,PSP_DEVICE_INTERFACE_DETAIL_DATA_W ,DWORD DeviceInterfaceDetailDataSize,PDWORD ,PSP_DEVINFO_DATA DeviceInfoData );
#ifdef UNICODE
#define SetupDiGetDeviceInterfaceDetail SetupDiGetDeviceInterfaceDetailW
#else
#define SetupDiGetDeviceInterfaceDetail SetupDiGetDeviceInterfaceDetailA
#endif
#define SetupDiGetInterfaceDeviceDetailW SetupDiGetDeviceInterfaceDetailW
#define SetupDiGetInterfaceDeviceDetailA SetupDiGetDeviceInterfaceDetailA
#ifdef UNICODE
#define SetupDiGetInterfaceDeviceDetail SetupDiGetDeviceInterfaceDetailW
#else
#define SetupDiGetInterfaceDeviceDetail SetupDiGetDeviceInterfaceDetailA
#endif
BOOL WINAPI SetupDiInstallDeviceInterfaces(HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData );
#define SetupDiInstallInterfaceDevices SetupDiInstallDeviceInterfaces
#define SPRDI_FIND_DUPS 1
BOOL WINAPI SetupDiRegisterDeviceInfo(HDEVINFO ,PSP_DEVINFO_DATA ,DWORD ,PSP_DETSIG_CMPPROC ,PVOID CompareContext,PSP_DEVINFO_DATA DupDeviceInfoData );
#define SPDIT_NODRIVER 0
#define SPDIT_CLASSDRIVER 1
#define SPDIT_COMPATDRIVER 2
BOOL WINAPI SetupDiBuildDriverInfoList(HDEVINFO ,PSP_DEVINFO_DATA ,DWORD DriverType );
BOOL WINAPI SetupDiCancelDriverInfoSearch(HDEVINFO DeviceInfoSet );
BOOL WINAPI SetupDiEnumDriverInfoA(HDEVINFO ,PSP_DEVINFO_DATA ,DWORD DriverType,DWORD ,PSP_DRVINFO_DATA_A DriverInfoData );
BOOL WINAPI SetupDiEnumDriverInfoW(HDEVINFO ,PSP_DEVINFO_DATA ,DWORD DriverType,DWORD ,PSP_DRVINFO_DATA_W DriverInfoData );
#ifdef UNICODE
#define SetupDiEnumDriverInfo SetupDiEnumDriverInfoW
#else
#define SetupDiEnumDriverInfo SetupDiEnumDriverInfoA
#endif
BOOL WINAPI SetupDiGetSelectedDriverA(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DRVINFO_DATA_A DriverInfoData );
BOOL WINAPI SetupDiGetSelectedDriverW(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DRVINFO_DATA_W DriverInfoData );
#ifdef UNICODE
#define SetupDiGetSelectedDriver SetupDiGetSelectedDriverW
#else
#define SetupDiGetSelectedDriver SetupDiGetSelectedDriverA
#endif
BOOL WINAPI SetupDiSetSelectedDriverA(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DRVINFO_DATA_A DriverInfoData );
BOOL WINAPI SetupDiSetSelectedDriverW(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DRVINFO_DATA_W DriverInfoData );
#ifdef UNICODE
#define SetupDiSetSelectedDriver SetupDiSetSelectedDriverW
#else
#define SetupDiSetSelectedDriver SetupDiSetSelectedDriverA
#endif
BOOL WINAPI SetupDiGetDriverInfoDetailA(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DRVINFO_DATA_A DriverInfoData,PSP_DRVINFO_DETAIL_DATA_A ,DWORD DriverInfoDetailDataSize,PDWORD RequiredSize );
BOOL WINAPI SetupDiGetDriverInfoDetailW(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DRVINFO_DATA_W DriverInfoData,PSP_DRVINFO_DETAIL_DATA_W ,DWORD DriverInfoDetailDataSize,PDWORD RequiredSize );
#ifdef UNICODE
#define SetupDiGetDriverInfoDetail SetupDiGetDriverInfoDetailW
#else
#define SetupDiGetDriverInfoDetail SetupDiGetDriverInfoDetailA
#endif
BOOL WINAPI SetupDiDestroyDriverInfoList(HDEVINFO ,PSP_DEVINFO_DATA ,DWORD DriverType );
#define DIGCF_DEFAULT 1
#define DIGCF_PRESENT 2
#define DIGCF_ALLCLASSES 4
#define DIGCF_PROFILE 8
#define DIGCF_DEVICEINTERFACE 16
#define DIGCF_INTERFACEDEVICE DIGCF_DEVICEINTERFACE
HDEVINFO WINAPI SetupDiGetClassDevsA(CONST GUID *ClassGuid,PCSTR Enumerator,HWND hwndParent,DWORD Flags );
HDEVINFO WINAPI SetupDiGetClassDevsW(CONST GUID *ClassGuid,PCWSTR Enumerator,HWND hwndParent,DWORD Flags );
#ifdef UNICODE
#define SetupDiGetClassDevs SetupDiGetClassDevsW
#else
#define SetupDiGetClassDevs SetupDiGetClassDevsA
#endif
HDEVINFO WINAPI SetupDiGetClassDevsExA(CONST GUID *ClassGuid,PCSTR Enumerator,HWND hwndParent,DWORD Flags,HDEVINFO ,PCSTR MachineName,PVOID Reserved );
HDEVINFO WINAPI SetupDiGetClassDevsExW(CONST GUID *ClassGuid,PCWSTR Enumerator,HWND hwndParent,DWORD Flags,HDEVINFO ,PCWSTR MachineName,PVOID Reserved );
#ifdef UNICODE
#define SetupDiGetClassDevsEx SetupDiGetClassDevsExW
#else
#define SetupDiGetClassDevsEx SetupDiGetClassDevsExA
#endif
BOOL WINAPI SetupDiGetINFClassA(PCSTR ,LPGUID ,PSTR ,DWORD ,PDWORD RequiredSize );
BOOL WINAPI SetupDiGetINFClassW(PCWSTR ,LPGUID ,PWSTR ,DWORD ,PDWORD RequiredSize );
#ifdef UNICODE
#define SetupDiGetINFClass SetupDiGetINFClassW
#else
#define SetupDiGetINFClass SetupDiGetINFClassA
#endif
#define DIBCI_NOINSTALLCLASS 1
#define DIBCI_NODISPLAYCLASS 2
BOOL WINAPI SetupDiBuildClassInfoList(DWORD ,LPGUID ,DWORD ,PDWORD RequiredSize );
BOOL WINAPI SetupDiBuildClassInfoListExA(DWORD ,LPGUID ,DWORD ,PDWORD ,PCSTR ,PVOID Reserved );
BOOL WINAPI SetupDiBuildClassInfoListExW(DWORD ,LPGUID ,DWORD ,PDWORD ,PCWSTR ,PVOID Reserved );
#ifdef UNICODE
#define SetupDiBuildClassInfoListEx SetupDiBuildClassInfoListExW
#else
#define SetupDiBuildClassInfoListEx SetupDiBuildClassInfoListExA
#endif
BOOL WINAPI SetupDiGetClassDescriptionA(CONST GUID *ClassGuid,PSTR ,DWORD ,PDWORD RequiredSize );
BOOL WINAPI SetupDiGetClassDescriptionW(CONST GUID *ClassGuid,PWSTR ,DWORD ,PDWORD RequiredSize );
#ifdef UNICODE
#define SetupDiGetClassDescription SetupDiGetClassDescriptionW
#else
#define SetupDiGetClassDescription SetupDiGetClassDescriptionA
#endif
BOOL WINAPI SetupDiGetClassDescriptionExA(CONST GUID *ClassGuid,PSTR ,DWORD ,PDWORD ,PCSTR MachineName,PVOID Reserved );
BOOL WINAPI SetupDiGetClassDescriptionExW(CONST GUID *ClassGuid,PWSTR ,DWORD ,PDWORD ,PCWSTR MachineName,PVOID Reserved );
#ifdef UNICODE
#define SetupDiGetClassDescriptionEx SetupDiGetClassDescriptionExW
#else
#define SetupDiGetClassDescriptionEx SetupDiGetClassDescriptionExA
#endif
BOOL WINAPI SetupDiCallClassInstaller(DI_FUNCTION ,HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiSelectDevice(HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiSelectBestCompatDrv(HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiInstallDevice(HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiInstallDriverFiles(HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiRegisterCoDeviceInstallers(HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiRemoveDevice(HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiUnremoveDevice(HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiMoveDuplicateDevice(HDEVINFO ,PSP_DEVINFO_DATA DestinationDeviceInfoData );
BOOL WINAPI SetupDiChangeState(HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiInstallClassA(HWND ,PCSTR InfFileName,DWORD ,HSPFILEQ FileQueue );
BOOL WINAPI SetupDiInstallClassW(HWND ,PCWSTR InfFileName,DWORD ,HSPFILEQ FileQueue );
#ifdef UNICODE
#define SetupDiInstallClass SetupDiInstallClassW
#else
#define SetupDiInstallClass SetupDiInstallClassA
#endif
BOOL WINAPI SetupDiInstallClassExA(HWND ,PCSTR ,DWORD ,HSPFILEQ ,CONST GUID *,PVOID,PVOID);
BOOL WINAPI SetupDiInstallClassExW(HWND ,PCWSTR,DWORD ,HSPFILEQ ,CONST GUID *,PVOID,PVOID);
#ifdef UNICODE
#define SetupDiInstallClassEx SetupDiInstallClassExW
#else
#define SetupDiInstallClassEx SetupDiInstallClassExA
#endif
HKEY WINAPI SetupDiOpenClassRegKey(CONST GUID *ClassGuid,REGSAM samDesired );
#define DIOCR_INSTALLER 1
#define DIOCR_INTERFACE 2
HKEY WINAPI SetupDiOpenClassRegKeyExA(CONST GUID *ClassGuid,REGSAM samDesired,DWORD ,PCSTR ,PVOID Reserved );
HKEY WINAPI SetupDiOpenClassRegKeyExW(CONST GUID *ClassGuid,REGSAM samDesired,DWORD ,PCWSTR ,PVOID Reserved );
#ifdef UNICODE
#define SetupDiOpenClassRegKeyEx SetupDiOpenClassRegKeyExW
#else
#define SetupDiOpenClassRegKeyEx SetupDiOpenClassRegKeyExA
#endif
HKEY WINAPI SetupDiCreateDeviceInterfaceRegKeyA(HDEVINFO ,PSP_DEVICE_INTERFACE_DATA ,DWORD ,REGSAM ,HINF ,PCSTR InfSectionName );
HKEY WINAPI SetupDiCreateDeviceInterfaceRegKeyW(HDEVINFO ,PSP_DEVICE_INTERFACE_DATA ,DWORD ,REGSAM ,HINF ,PCWSTR InfSectionName );
#ifdef UNICODE
#define SetupDiCreateDeviceInterfaceRegKey SetupDiCreateDeviceInterfaceRegKeyW
#else
#define SetupDiCreateDeviceInterfaceRegKey SetupDiCreateDeviceInterfaceRegKeyA
#endif
#define SetupDiCreateInterfaceDeviceRegKeyW SetupDiCreateDeviceInterfaceRegKeyW
#define SetupDiCreateInterfaceDeviceRegKeyA SetupDiCreateDeviceInterfaceRegKeyA
#ifdef UNICODE
#define SetupDiCreateInterfaceDeviceRegKey SetupDiCreateDeviceInterfaceRegKeyW
#else
#define SetupDiCreateInterfaceDeviceRegKey SetupDiCreateDeviceInterfaceRegKeyA
#endif
HKEY WINAPI SetupDiOpenDeviceInterfaceRegKey(HDEVINFO ,PSP_DEVICE_INTERFACE_DATA ,DWORD ,REGSAM samDesired );
#define SetupDiOpenInterfaceDeviceRegKey SetupDiOpenDeviceInterfaceRegKey
BOOL WINAPI SetupDiDeleteDeviceInterfaceRegKey(HDEVINFO ,PSP_DEVICE_INTERFACE_DATA ,DWORD Reserved );
#define SetupDiDeleteInterfaceDeviceRegKey SetupDiDeleteDeviceInterfaceRegKey
#define DIREG_DEV 1
#define DIREG_DRV 2
#define DIREG_BOTH 4
HKEY WINAPI SetupDiCreateDevRegKeyA(HDEVINFO ,PSP_DEVINFO_DATA ,DWORD ,DWORD ,DWORD ,HINF ,PCSTR InfSectionName );
HKEY WINAPI SetupDiCreateDevRegKeyW(HDEVINFO ,PSP_DEVINFO_DATA ,DWORD ,DWORD ,DWORD ,HINF ,PCWSTR InfSectionName );
#ifdef UNICODE
#define SetupDiCreateDevRegKey SetupDiCreateDevRegKeyW
#else
#define SetupDiCreateDevRegKey SetupDiCreateDevRegKeyA
#endif
HKEY WINAPI SetupDiOpenDevRegKey(HDEVINFO ,PSP_DEVINFO_DATA ,DWORD ,DWORD ,DWORD ,REGSAM samDesired );
BOOL WINAPI SetupDiDeleteDevRegKey(HDEVINFO ,PSP_DEVINFO_DATA ,DWORD ,DWORD ,DWORD KeyType );
BOOL WINAPI SetupDiGetHwProfileList(PDWORD ,DWORD ,PDWORD ,PDWORD CurrentlyActiveIndex );
BOOL WINAPI SetupDiGetHwProfileListExA(PDWORD ,DWORD ,PDWORD ,PDWORD ,PCSTR MachineName,PVOID Reserved );
BOOL WINAPI SetupDiGetHwProfileListExW(PDWORD ,DWORD ,PDWORD ,PDWORD ,PCWSTR MachineName,PVOID Reserved );
#ifdef UNICODE
#define SetupDiGetHwProfileListEx SetupDiGetHwProfileListExW
#else
#define SetupDiGetHwProfileListEx SetupDiGetHwProfileListExA
#endif
#define SPDRP_DEVICEDESC 0  
#define SPDRP_HARDWAREID 1  
#define SPDRP_COMPATIBLEIDS 2  
#define SPDRP_UNUSED0 3  
#define SPDRP_SERVICE 4  
#define SPDRP_UNUSED1 5  
#define SPDRP_UNUSED2 6  
#define SPDRP_CLASS 7  
#define SPDRP_CLASSGUID 8  
#define SPDRP_DRIVER 9  
#define SPDRP_CONFIGFLAGS 10  
#define SPDRP_MFG 11  
#define SPDRP_FRIENDLYNAME 12  
#define SPDRP_LOCATION_INFORMATION 13  
#define SPDRP_PHYSICAL_DEVICE_OBJECT_NAME 14  
#define SPDRP_CAPABILITIES 15  
#define SPDRP_UI_NUMBER 16  
#define SPDRP_UPPERFILTERS 17  
#define SPDRP_LOWERFILTERS 18  
#define SPDRP_BUSTYPEGUID 19  
#define SPDRP_LEGACYBUSTYPE 20  
#define SPDRP_BUSNUMBER 21  
#define SPDRP_ENUMERATOR_NAME 22  
#define SPDRP_SECURITY 23  
#define SPDRP_SECURITY_SDS 24  
#define SPDRP_DEVTYPE 25  
#define SPDRP_EXCLUSIVE 26  
#define SPDRP_CHARACTERISTICS 27  
#define SPDRP_ADDRESS 28  
#define SPDRP_MAXIMUM_PROPERTY 29  
#define SPCRP_SECURITY 23  
#define SPCRP_SECURITY_SDS 24  
#define SPCRP_DEVTYPE 25  
#define SPCRP_EXCLUSIVE 26  
#define SPCRP_CHARACTERISTICS 27  
#define SPCRP_MAXIMUM_PROPERTY 28  
BOOL WINAPI SetupDiGetDeviceRegistryPropertyA(HDEVINFO ,PSP_DEVINFO_DATA ,DWORD ,PDWORD ,PBYTE PropertyBuffer,DWORD ,PDWORD RequiredSize );
BOOL WINAPI SetupDiGetDeviceRegistryPropertyW(HDEVINFO ,PSP_DEVINFO_DATA ,DWORD ,PDWORD ,PBYTE PropertyBuffer,DWORD ,PDWORD RequiredSize );
#ifdef UNICODE
#define SetupDiGetDeviceRegistryProperty SetupDiGetDeviceRegistryPropertyW
#else
#define SetupDiGetDeviceRegistryProperty SetupDiGetDeviceRegistryPropertyA
#endif
BOOL WINAPI SetupDiGetClassRegistryPropertyA(LPGUID ,DWORD ,PDWORD ,PBYTE PropertyBuffer,DWORD ,PDWORD ,PCSTR MachineName,PVOID Reserved );
BOOL WINAPI SetupDiGetClassRegistryPropertyW(LPGUID ,DWORD ,PDWORD ,PBYTE PropertyBuffer,DWORD ,PDWORD ,PCWSTR MachineName,PVOID Reserved );
#ifdef UNICODE
#define SetupDiGetClassRegistryProperty SetupDiGetClassRegistryPropertyW
#else
#define SetupDiGetClassRegistryProperty SetupDiGetClassRegistryPropertyA
#endif
BOOL WINAPI SetupDiSetDeviceRegistryPropertyA(HDEVINFO ,PSP_DEVINFO_DATA ,DWORD ,CONST BYTE* PropertyBuffer,DWORD PropertyBufferSize );
BOOL WINAPI SetupDiSetDeviceRegistryPropertyW(HDEVINFO ,PSP_DEVINFO_DATA ,DWORD ,CONST BYTE* PropertyBuffer,DWORD PropertyBufferSize );
#ifdef UNICODE
#define SetupDiSetDeviceRegistryProperty SetupDiSetDeviceRegistryPropertyW
#else
#define SetupDiSetDeviceRegistryProperty SetupDiSetDeviceRegistryPropertyA
#endif
BOOL WINAPI SetupDiSetClassRegistryPropertyA(LPGUID ,DWORD ,CONST BYTE* PropertyBuffer,DWORD PropertyBufferSize,PCSTR ,PVOID Reserved );
BOOL WINAPI SetupDiSetClassRegistryPropertyW(LPGUID ,DWORD ,CONST BYTE* PropertyBuffer,DWORD PropertyBufferSize,PCWSTR ,PVOID Reserved );
#ifdef UNICODE
#define SetupDiSetClassRegistryProperty SetupDiSetClassRegistryPropertyW
#else
#define SetupDiSetClassRegistryProperty SetupDiSetClassRegistryPropertyA
#endif
BOOL WINAPI SetupDiGetDeviceInstallParamsA(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DEVINSTALL_PARAMS_A DeviceInstallParams );
BOOL WINAPI SetupDiGetDeviceInstallParamsW(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DEVINSTALL_PARAMS_W DeviceInstallParams );
#ifdef UNICODE
#define SetupDiGetDeviceInstallParams SetupDiGetDeviceInstallParamsW
#else
#define SetupDiGetDeviceInstallParams SetupDiGetDeviceInstallParamsA
#endif
BOOL WINAPI SetupDiGetClassInstallParamsA(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_CLASSINSTALL_HEADER ClassInstallParams,DWORD ClassInstallParamsSize,PDWORD RequiredSize );
BOOL WINAPI SetupDiGetClassInstallParamsW(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_CLASSINSTALL_HEADER ClassInstallParams,DWORD ClassInstallParamsSize,PDWORD RequiredSize );
#ifdef UNICODE
#define SetupDiGetClassInstallParams SetupDiGetClassInstallParamsW
#else
#define SetupDiGetClassInstallParams SetupDiGetClassInstallParamsA
#endif
BOOL WINAPI SetupDiSetDeviceInstallParamsA(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DEVINSTALL_PARAMS_A DeviceInstallParams );
BOOL WINAPI SetupDiSetDeviceInstallParamsW(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DEVINSTALL_PARAMS_W DeviceInstallParams );
#ifdef UNICODE
#define SetupDiSetDeviceInstallParams SetupDiSetDeviceInstallParamsW
#else
#define SetupDiSetDeviceInstallParams SetupDiSetDeviceInstallParamsA
#endif
BOOL WINAPI SetupDiSetClassInstallParamsA(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_CLASSINSTALL_HEADER ClassInstallParams,DWORD ClassInstallParamsSize );
BOOL WINAPI SetupDiSetClassInstallParamsW(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_CLASSINSTALL_HEADER ClassInstallParams,DWORD ClassInstallParamsSize );
#ifdef UNICODE
#define SetupDiSetClassInstallParams SetupDiSetClassInstallParamsW
#else
#define SetupDiSetClassInstallParams SetupDiSetClassInstallParamsA
#endif
BOOL WINAPI SetupDiGetDriverInstallParamsA(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DRVINFO_DATA_A DriverInfoData,PSP_DRVINSTALL_PARAMS DriverInstallParams );
BOOL WINAPI SetupDiGetDriverInstallParamsW(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DRVINFO_DATA_W DriverInfoData,PSP_DRVINSTALL_PARAMS DriverInstallParams );
#ifdef UNICODE
#define SetupDiGetDriverInstallParams SetupDiGetDriverInstallParamsW
#else
#define SetupDiGetDriverInstallParams SetupDiGetDriverInstallParamsA
#endif
BOOL WINAPI SetupDiSetDriverInstallParamsA(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DRVINFO_DATA_A DriverInfoData,PSP_DRVINSTALL_PARAMS DriverInstallParams );
BOOL WINAPI SetupDiSetDriverInstallParamsW(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_DRVINFO_DATA_W DriverInfoData,PSP_DRVINSTALL_PARAMS DriverInstallParams );
#ifdef UNICODE
#define SetupDiSetDriverInstallParams SetupDiSetDriverInstallParamsW
#else
#define SetupDiSetDriverInstallParams SetupDiSetDriverInstallParamsA
#endif
BOOL WINAPI SetupDiLoadClassIcon(CONST GUID *ClassGuid,HICON *,PINT MiniIconIndex );
#define DMI_MASK 1
#define DMI_BKCOLOR 2
#define DMI_USERECT 4
INT WINAPI SetupDiDrawMiniIcon(HDC ,RECT ,INT ,DWORD Flags );
BOOL WINAPI SetupDiGetClassBitmapIndex(CONST GUID *ClassGuid,PINT MiniIconIndex );
BOOL WINAPI SetupDiGetClassImageList(PSP_CLASSIMAGELIST_DATA ClassImageListData );
BOOL WINAPI SetupDiGetClassImageListExA(PSP_CLASSIMAGELIST_DATA ,PCSTR ,PVOID Reserved );
BOOL WINAPI SetupDiGetClassImageListExW(PSP_CLASSIMAGELIST_DATA ,PCWSTR ,PVOID Reserved );
#ifdef UNICODE
#define SetupDiGetClassImageListEx SetupDiGetClassImageListExW
#else
#define SetupDiGetClassImageListEx SetupDiGetClassImageListExA
#endif
BOOL WINAPI SetupDiGetClassImageIndex(PSP_CLASSIMAGELIST_DATA ,CONST GUID *ClassGuid,PINT ImageIndex );
BOOL WINAPI SetupDiDestroyClassImageList(PSP_CLASSIMAGELIST_DATA ClassImageListData );
#define DIGCDP_FLAG_BASIC 1
#define DIGCDP_FLAG_ADVANCED 2
BOOL WINAPI SetupDiGetClassDevPropertySheetsA(HDEVINFO ,PSP_DEVINFO_DATA ,LPPROPSHEETHEADERA ,DWORD ,PDWORD ,DWORD);
BOOL WINAPI SetupDiGetClassDevPropertySheetsW(HDEVINFO ,PSP_DEVINFO_DATA ,LPPROPSHEETHEADERW ,DWORD ,PDWORD ,DWORD);
#ifdef UNICODE
#define SetupDiGetClassDevPropertySheets SetupDiGetClassDevPropertySheetsW
#else
#define SetupDiGetClassDevPropertySheets SetupDiGetClassDevPropertySheetsA
#endif
#define IDI_RESOURCEFIRST 159
#define IDI_RESOURCE 159
#define IDI_RESOURCELAST 161
#define IDI_RESOURCEOVERLAYFIRST 161
#define IDI_RESOURCEOVERLAYLAST 161
#define IDI_CONFLICT 161
#define IDI_CLASSICON_OVERLAYFIRST 500
#define IDI_CLASSICON_OVERLAYLAST 502
#define IDI_PROBLEM_OVL 500
#define IDI_DISABLED_OVL 501
#define IDI_FORCED_OVL 502
BOOL WINAPI SetupDiAskForOEMDisk(HDEVINFO ,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiSelectOEMDrv(HWND ,HDEVINFO DeviceInfoSet,PSP_DEVINFO_DATA DeviceInfoData );
BOOL WINAPI SetupDiClassNameFromGuidA(CONST GUID *ClassGuid,PSTR ,DWORD ,PDWORD RequiredSize );
BOOL WINAPI SetupDiClassNameFromGuidW(CONST GUID *ClassGuid,PWSTR ,DWORD ,PDWORD RequiredSize );
#ifdef UNICODE
#define SetupDiClassNameFromGuid SetupDiClassNameFromGuidW
#else
#define SetupDiClassNameFromGuid SetupDiClassNameFromGuidA
#endif
BOOL WINAPI SetupDiClassNameFromGuidExA(CONST GUID *ClassGuid,PSTR ,DWORD ,PDWORD ,PCSTR MachineName,PVOID Reserved );
BOOL WINAPI SetupDiClassNameFromGuidExW(CONST GUID *ClassGuid,PWSTR ,DWORD ,PDWORD ,PCWSTR MachineName,PVOID Reserved );
#ifdef UNICODE
#define SetupDiClassNameFromGuidEx SetupDiClassNameFromGuidExW
#else
#define SetupDiClassNameFromGuidEx SetupDiClassNameFromGuidExA
#endif
BOOL WINAPI SetupDiClassGuidsFromNameA(PCSTR ,LPGUID ,DWORD ,PDWORD RequiredSize );
BOOL WINAPI SetupDiClassGuidsFromNameW(PCWSTR ,LPGUID ,DWORD ,PDWORD RequiredSize );
#ifdef UNICODE
#define SetupDiClassGuidsFromName SetupDiClassGuidsFromNameW
#else
#define SetupDiClassGuidsFromName SetupDiClassGuidsFromNameA
#endif
BOOL WINAPI SetupDiClassGuidsFromNameExA(PCSTR ,LPGUID ,DWORD ,PDWORD ,PCSTR ,PVOID Reserved );
BOOL WINAPI SetupDiClassGuidsFromNameExW(PCWSTR ,LPGUID ,DWORD ,PDWORD ,PCWSTR ,PVOID Reserved );
#ifdef UNICODE
#define SetupDiClassGuidsFromNameEx SetupDiClassGuidsFromNameExW
#else
#define SetupDiClassGuidsFromNameEx SetupDiClassGuidsFromNameExA
#endif
BOOL WINAPI SetupDiGetHwProfileFriendlyNameA(DWORD ,PSTR ,DWORD ,PDWORD RequiredSize );
BOOL WINAPI SetupDiGetHwProfileFriendlyNameW(DWORD ,PWSTR ,DWORD ,PDWORD RequiredSize );
#ifdef UNICODE
#define SetupDiGetHwProfileFriendlyName SetupDiGetHwProfileFriendlyNameW
#else
#define SetupDiGetHwProfileFriendlyName SetupDiGetHwProfileFriendlyNameA
#endif
BOOL WINAPI SetupDiGetHwProfileFriendlyNameExA(DWORD ,PSTR ,DWORD ,PDWORD ,PCSTR MachineName,PVOID Reserved );
BOOL WINAPI SetupDiGetHwProfileFriendlyNameExW(DWORD ,PWSTR ,DWORD ,PDWORD ,PCWSTR MachineName,PVOID Reserved );
#ifdef UNICODE
#define SetupDiGetHwProfileFriendlyNameEx SetupDiGetHwProfileFriendlyNameExW
#else
#define SetupDiGetHwProfileFriendlyNameEx SetupDiGetHwProfileFriendlyNameExA
#endif
#define SPWPT_SELECTDEVICE 1
#define SPWP_USE_DEVINFO_DATA 1
HPROPSHEETPAGE
WINAPI SetupDiGetWizardPage(HDEVINFO ,PSP_DEVINFO_DATA ,PSP_INSTALLWIZARD_DATA ,DWORD ,DWORD);
BOOL WINAPI SetupDiGetSelectedDevice(HDEVINFO ,PSP_DEVINFO_DATA  );
BOOL WINAPI SetupDiSetSelectedDevice(HDEVINFO ,PSP_DEVINFO_DATA  );
BOOL WINAPI SetupDiGetActualSectionToInstallA(HINF ,PCSTR ,PSTR ,DWORD,PDWORD ,PSTR *);
BOOL WINAPI SetupDiGetActualSectionToInstallW(HINF ,PCWSTR ,PWSTR ,DWORD,PDWORD ,PWSTR *);
#ifdef UNICODE
#define SetupDiGetActualSectionToInstall SetupDiGetActualSectionToInstallW
#else
#define SetupDiGetActualSectionToInstall SetupDiGetActualSectionToInstallA
#endif
#endif 
