#ifndef __sqltypes_h__
#define __sqltypes_h__
#ifndef __windows_h__
#include <windows.h>
#endif
#ifndef ODBCVER
#define ODBCVER	849
#endif
#ifndef EXPORT
#define EXPORT
#endif
#define SQL_API __stdcall
#ifndef RC_INVOKED
typedef unsigned char SQLCHAR;
#if (ODBCVER >= 768)
typedef signed char SQLSCHAR;
typedef unsigned char SQLDATE;
typedef unsigned char SQLDECIMAL;
typedef double SQLDOUBLE;
typedef double SQLFLOAT;
#endif
typedef long SQLINTEGER;
typedef unsigned long SQLUINTEGER;
#define SQLROWSETSIZE SQLUINTEGER
#ifdef _WIN64
typedef INT64 SQLLEN;
typedef INT64 SQLROWOFFSET;
typedef UINT64 SQLROWCOUNT;
typedef UINT64 SQLULEN;
typedef UINT64 SQLTRANSID;
typedef unsigned long SQLSETPOSIROW;
#else
#define SQLLEN SQLINTEGER
#define SQLROWOFFSET SQLINTEGER
#define SQLROWCOUNT SQLUINTEGER
#define SQLULEN SQLUINTEGER
#define SQLTRANSID DWORD
#define SQLSETPOSIROW SQLUSMALLINT
#endif
#if (ODBCVER >= 768)
typedef unsigned char SQLNUMERIC;
#endif
typedef void * SQLPOINTER;
#if (ODBCVER >= 768)
typedef float SQLREAL;
#endif
typedef short SQLSMALLINT;
typedef unsigned short SQLUSMALLINT;
#if (ODBCVER >= 768)
typedef unsigned char SQLTIME;
typedef unsigned char SQLTIMESTAMP;
typedef unsigned char SQLVARCHAR;
#endif
typedef SQLSMALLINT SQLRETURN;
#if (ODBCVER >= 768)
#if defined(WIN32)
typedef void*	SQLHANDLE;
#else
typedef SQLINTEGER	SQLHANDLE;
#endif
typedef SQLHANDLE SQLHENV;
typedef SQLHANDLE SQLHDBC;
typedef SQLHANDLE SQLHSTMT;
typedef SQLHANDLE SQLHDESC;
#else
#if defined(WIN32)
typedef void*	SQLHENV;
typedef void*	SQLHDBC;
typedef void*	SQLHSTMT;
#else
typedef SQLINTEGER SQLHENV;
typedef SQLINTEGER SQLHDBC;
typedef SQLINTEGER SQLHSTMT;
#endif
#endif

#ifndef __sql_types_defined__
#define __sql_types_defined__
typedef unsigned char UCHAR;
typedef signed char SCHAR;
typedef long int SDWORD;
typedef short int SWORD;
typedef unsigned long int UDWORD;
typedef unsigned short int UWORD;
typedef unsigned long ULONG;
typedef unsigned short USHORT;

#endif
typedef signed long SLONG;
typedef signed short SSHORT;
typedef double SDOUBLE;
typedef double LDOUBLE;
typedef float SFLOAT;
typedef void* PTR;
typedef void* HENV;
typedef void* HDBC;
typedef void* HSTMT;
#ifndef __windows_h__
typedef signed short RETCODE;
#endif
#if defined(WIN32) || defined(OS2)
typedef HWND SQLHWND;
#elif defined (UNIX)
typedef Widget SQLHWND;
#else
typedef SQLPOINTER SQLHWND;
#endif
#ifndef	__SQLDATE
#define	__SQLDATE
typedef struct tagDATE_STRUCT
{
SQLSMALLINT year;
SQLUSMALLINT month;
SQLUSMALLINT day;
} DATE_STRUCT;
#if (ODBCVER >= 768)
typedef DATE_STRUCT	SQL_DATE_STRUCT;
#endif
typedef struct tagTIME_STRUCT
{
SQLUSMALLINT hour;
SQLUSMALLINT minute;
SQLUSMALLINT second;
} TIME_STRUCT;
#if (ODBCVER >= 768)
typedef TIME_STRUCT	SQL_TIME_STRUCT;
#endif
typedef struct tagTIMESTAMP_STRUCT
{
SQLSMALLINT year;
SQLUSMALLINT month;
SQLUSMALLINT day;
SQLUSMALLINT hour;
SQLUSMALLINT minute;
SQLUSMALLINT second;
SQLUINTEGER fraction;
} TIMESTAMP_STRUCT;
#if (ODBCVER >= 768)
typedef TIMESTAMP_STRUCT	SQL_TIMESTAMP_STRUCT;
#endif
#if (ODBCVER >= 768)
typedef enum
{
SQL_IS_YEAR=1,
SQL_IS_MONTH=2,
SQL_IS_DAY=3,
SQL_IS_HOUR=4,
SQL_IS_MINUTE=5,
SQL_IS_SECOND=6,
SQL_IS_YEAR_TO_MONTH=7,
SQL_IS_DAY_TO_HOUR=8,
SQL_IS_DAY_TO_MINUTE=9,
SQL_IS_DAY_TO_SECOND=10,
SQL_IS_HOUR_TO_MINUTE=11,
SQL_IS_HOUR_TO_SECOND=12,
SQL_IS_MINUTE_TO_SECOND=13
} SQLINTERVAL;
#endif
#if (ODBCVER >= 768)
typedef struct tagSQL_YEAR_MONTH
{
SQLUINTEGER	year;
SQLUINTEGER	month;
} SQL_YEAR_MONTH_STRUCT;
typedef struct tagSQL_DAY_SECOND
{
SQLUINTEGER	day;
SQLUINTEGER	hour;
SQLUINTEGER	minute;
SQLUINTEGER	second;
SQLUINTEGER	fraction;
} SQL_DAY_SECOND_STRUCT;
typedef struct tagSQL_INTERVAL_STRUCT
{
SQLINTERVAL	interval_type;
SQLSMALLINT	interval_sign;
union {
SQL_YEAR_MONTH_STRUCT	year_month;
SQL_DAY_SECOND_STRUCT	day_second;
} intval;
} SQL_INTERVAL_STRUCT;
#endif
#endif
#if (ODBCVER >= 768)
#if (_MSC_VER >= 900)
#define ODBCINT64	__int64
#endif
#ifdef ODBCINT64
typedef ODBCINT64	SQLBIGINT;
typedef unsigned ODBCINT64	SQLUBIGINT;
#endif
#endif
#if (ODBCVER >= 768)
#define SQL_MAX_NUMERIC_LEN	16
typedef struct tagSQL_NUMERIC_STRUCT
{
SQLCHAR	precision;
SQLSCHAR	scale;
SQLCHAR	sign;
SQLCHAR	val[SQL_MAX_NUMERIC_LEN];
} SQL_NUMERIC_STRUCT;
#endif
#if (ODBCVER >= 848)
#ifdef GUID_DEFINED
typedef GUID	SQLGUID;
#else
typedef struct tagSQLGUID
{
DWORD Data1;
WORD Data2;
WORD Data3;
BYTE Data4[ 8 ];
} SQLGUID;
#endif
#endif
typedef unsigned long int BOOKMARK;
#ifdef _WCHAR_T_DEFINED
typedef wchar_t SQLWCHAR;
#else
typedef unsigned short SQLWCHAR;
#endif
#ifdef UNICODE
typedef SQLWCHAR SQLTCHAR;
#else
typedef SQLCHAR SQLTCHAR;
#endif
#endif
#endif
