#ifndef __stdlib_h__
#define __stdlib_h__
#include <stddef.h>
#include <_syslist.h>
#define MB_CUR_MAX	2
#define _MAX_PATH 260
#define _MAX_FNAME	256
#define _MAX_EXT	256
#define _MAX_DRIVE	3
#define _MAX_DIR	256
#undef RAND_MAX
#define RAND_MAX 0x7FFF
typedef struct {
  int quot; /* quotient */
  int rem; /* remainder */
} div_t;

typedef struct {
  long quot; /* quotient */
  long rem; /* remainder */
} ldiv_t;
typedef struct {
	long long quot;
	long long rem;
} lldiv_t;
#undef NULL
#define NULL ((void *)0)
#ifndef _WCHAR_T_DEFINED
typedef unsigned short wchar_t;
#define _WCHAR_T_DEFINED
#endif
#ifndef EXIT_FAILURE
#define EXIT_FAILURE 1
#define EXIT_SUCCESS 0
#endif

void	abort(void);
int	abs(int);
long long llabs(long long);
int	atexit(void (*_func)(void));
double	atof(const char *);
int	atoi(const char *);
char    *itoa(int,char *,int);
char	*ltoa(long,char *,int);
void *	bsearch(const void * _key,const void * _base, size_t _nmemb, size_t _size,
		       int (*_compar)(const void *,const void *));
void *	calloc(size_t _nmemb, size_t _size);
#if __LCCOPTIMLEVEL > 0
inline div_t __declspec(naked) div(int a,int b)
{
        _asm("\tmovl\t(%esp),%eax");
        _asm("\tmovl\t4(%esp),%ecx");
        _asm("\tcdq");
        _asm("\tidivl\t%ecx");
}
#else
div_t	div(int _numer, int _denom);
#endif
void	exit(int _status);
void	_exit(int status);
#define _Exit _exit
void	free(void *);


double  strtod(const char *restrict nptr,char ** restrict endptr);
long double strtold(const char *restrict nptr,char ** restrict endptr);
float   strtof(const char *restrict nptr,char ** restrict endptr);
char *  getenv(const char *_string);
long	labs(long);
ldiv_t	ldiv(long _numer, long _denom);
lldiv_t lldiv(long long numer,long long denom);
void *	malloc(size_t _size);
void	qsort(void * _base, size_t _nmemb, size_t _size, int(*_compar)(const void *, const void *));
int	rand(void);
void *	realloc(void * _r, size_t _size);
void	srand(unsigned _seed);
double	strtod(const char *_n, char **_endvoid);
long double strtold(const char *,char **);
long long strtoll(const char *,char **,int);
unsigned long long strtoull(const char *,char **,int);
long	strtol(const char *_n, char **_endvoid, int _base);
unsigned long strtoul(const char *_n, char **_end, int _base);
int	system(const char *_string);
int	putenv(const char *_string);
char *	_gcvt(double,int,char *);
char *	_fcvt(double,int,int *,int *);
char *	ecvt(double,int,int *,int *);
int     mbstowcs(wchar_t *,char *,size_t);
size_t wcstombs( char *mbstr, const wchar_t *wcstr, size_t count );
int	mblen(char *,size_t);
int	mbstrlen(char *s);
long    atol(char *_nptr);

#ifndef __ANSIC__ONLY__
#include "safelib.h"

typedef void (*constraint_handler_t)( const char * restrict msg, void * restrict ptr, errno_t error);
double  frand(void);
constraint_handler_t set_constraint_handler_s( constraint_handler_t handler);
constraint_handler_t get_constraint_handler_s( void );
void abort_handler_s( const char * restrict msg, void * restrict ptr, errno_t error);
void ignore_handler_s( const char * restrict msg, void * restrict ptr, errno_t error);
errno_t getenv_s(size_t * restrict len, char * restrict value, rsize_t maxsize, const char * restrict name);
void *bsearch_s(const void *key, const void *base, rsize_t nmemb, rsize_t size, int (*compar)(const void *k, const void *y, void *context), void *context);
errno_t qsort_s(void *base, rsize_t nmemb, rsize_t size, int (*compar)(const void *x, const void *y, void *context), void *context);
errno_t wctomb_s(int * restrict status, char * restrict s, rsize_t smax, wchar_t wc);
errno_t mbstowcs_s(size_t * restrict retval, wchar_t * restrict dst, rsize_t dstmax, const char * restrict src, rsize_t len);
errno_t wcstombs_s(size_t * restrict retval, char * restrict dst, rsize_t dstmax, const wchar_t * restrict src, rsize_t len);


#ifndef max
#define max(a,b)    (((a) > (b)) ? (a) : (b))
#define min(a,b)    (((a) < (b)) ? (a) : (b))
#endif
double  wtof(const wchar_t *);
char	*_fullpath( char *absPath, const char *relPath, size_t maxLength );
void _makepath(char *path, const char *drive, const char *dir, const char *fname, const char *ext );
void _splitpath(const char*, char*, char*, char*, char*);

#define _OUT_TO_DEFAULT	0
#define _OUT_TO_STDERR	1
#define _OUT_TO_MSGBOX	2
#define _REPORT_ERRMODE	3

extern int _sleep(unsigned long);
#define sleep _sleep
#define	_mbstrlen mbstrlen
#define CRTAPI1
#define _fmode *(_imp___fmode_dll)
extern int _fmode;
extern char ***_imp___environ_dll;
#define _environ (*_imp___environ_dll)
extern unsigned int _osver;
extern unsigned int *(_imp___osver);
#define _osver *(_imp___osver)
extern unsigned int _winmajor;
extern unsigned int *(_imp___winmajor);
#define _winmajor *(_imp___winmajor)
extern unsigned int _winminor;
extern unsigned int *(_imp___winminor);
#define _winminor *(_imp___winminor)
extern unsigned int _winver;
extern unsigned int *(_imp___winver);
#define _winver *(_imp___winver)
void _searchenv(char *,char *,char *);
wchar_t *  _itow (int, wchar_t *, int);
wchar_t *  _ltow (long, wchar_t *, int);
unsigned short *  _ultow (unsigned long, unsigned short *, int);
double  wcstod(const wchar_t *, wchar_t **);
long    wcstol(const wchar_t *, wchar_t **, int);
int wctomb(char *s,wchar_t wchar);
unsigned long  wcstoul(const wchar_t *, wchar_t **, int);
wchar_t *  _wgetenv(const wchar_t *);
int     _wsystem(const wchar_t *);
int  _wtoi(const wchar_t *);
long  _wtol(const wchar_t *);
// Contains argv[0]
extern char * __declspec(dllimport) _pgmptr;
int _stdcall _lrotl(unsigned long,unsigned int);
int _stdcall _lrotr(unsigned int,unsigned int);
char    *_i64toa(long long,char *,int);
char    *_ui64toa(unsigned long long,char *,int);
long long _atoi64(const char *);
#define atoi64  _atoi64
char    *_ultoa(unsigned long,char *,int);
unsigned short   *_ultow(unsigned long,unsigned short *,int);
#define ultoa _ultoa
#define ultow _ultow
int    _stdcall  _System(const char *cmd,int nCmdShow);
#endif 
#endif /* _STDLIB_H_ */
