#ifndef	__traffic_h__
#define	__traffic_h__
// This only runs under windows NT 5.0
#define	CURRENT_TCI_VERSION 	0x0002
#define	TC_FLAGS_PERSIST	0x00000001
#define	TC_FLAGS_SHUTDOWN	0x00000002
#define	TC_NOTIFY_IFC_UP	1
#define	TC_NOTIFY_IFC_CLOSE	2
#define	TC_NOTIFY_IFC_CHANGE	3
#define	TC_NOTIFY_PARAM_CHANGED	4
#define	TC_NOTIFY_FLOW_CLOSE	5
#define	TC_INVALID_HANDLE	((HANDLE)0)
#define	MAX_STRING_LENGTH	256
#ifndef	CALLBACK
#define	CALLBACK __stdcall
#endif
#ifndef	APIENTRY
#define	APIENTRY __stdcall
#endif
typedef	VOID (CALLBACK * TCI_NOTIFY_HANDLER)(HANDLE,HANDLE,ULONG,ULONG,ULONG,PVOID);
typedef	VOID (CALLBACK * TCI_ADD_FLOW_COMPLETE_HANDLER)(HANDLE,ULONG);
typedef	VOID (CALLBACK * TCI_MOD_FLOW_COMPLETE_HANDLER)(HANDLE,ULONG);
typedef	VOID (CALLBACK * TCI_DEL_FLOW_COMPLETE_HANDLER)(HANDLE,ULONG);
typedef	struct _TCI_CLIENT_FUNC_LIST {
	TCI_NOTIFY_HANDLER	ClNotifyHandler;
	TCI_ADD_FLOW_COMPLETE_HANDLER	ClAddFlowCompleteHandler;
	TCI_MOD_FLOW_COMPLETE_HANDLER	ClModifyFlowCompleteHandler;
	TCI_DEL_FLOW_COMPLETE_HANDLER	ClDeleteFlowCompleteHandler;
}	TCI_CLIENT_FUNC_LIST, *PTCI_CLIENT_FUNC_LIST;
#ifndef	_NTDDNDIS_
typedef	struct _NETWORK_ADDRESS {
	USHORT	AddressLength;	
	USHORT	AddressType;	
	UCHAR	Address[1];	
}	NETWORK_ADDRESS, *PNETWORK_ADDRESS;
typedef	struct _NETWORK_ADDRESS_LIST {
	LONG	AddressCount;	
	USHORT	AddressType;	
	NETWORK_ADDRESS	Address[1];	
}	NETWORK_ADDRESS_LIST, *PNETWORK_ADDRESS_LIST;
typedef	struct _NETWORK_ADDRESS_IP {
	USHORT	sin_port;
	ULONG	in_addr;
	UCHAR	sin_zero[8];
}	NETWORK_ADDRESS_IP, *PNETWORK_ADDRESS_IP;
#define	NETWORK_ADDRESS_LENGTH_IP sizeof (NETWORK_ADDRESS_IP)
typedef	struct _NETWORK_ADDRESS_IPX {
	ULONG	NetworkAddress;
	UCHAR	NodeAddress[6];
	USHORT	Socket;
}	NETWORK_ADDRESS_IPX, *PNETWORK_ADDRESS_IPX;
#endif
typedef	struct _ADDRESS_LIST_DESCRIPTOR {
	ULONG	MediaType;
	NETWORK_ADDRESS_LIST	AddressList;
}	ADDRESS_LIST_DESCRIPTOR, *PADDRESS_LIST_DESCRIPTOR;
typedef	struct _TC_IFC_DESCRIPTOR {
	ULONG	Length;
	LPWSTR	pInterfaceName;
	ADDRESS_LIST_DESCRIPTOR	AddressListDesc;
}	TC_IFC_DESCRIPTOR, *PTC_IFC_DESCRIPTOR;
typedef	struct _TC_GEN_FILTER {
	USHORT	AddressType;	
	ULONG	PatternSize;	
	PVOID		Pattern;	
	PVOID		Mask;	
}	TC_GEN_FILTER, *PTC_GEN_FILTER;
typedef	struct _TC_GEN_FLOW {
	FLOWSPEC	SendingFlowspec;
	FLOWSPEC	ReceivingFlowspec;
	ULONG	TcObjectsLength;	
	QOS_OBJECT_HDR	TcObjects[1];
}	TC_GEN_FLOW, *PTC_GEN_FLOW;
typedef	struct _IP_PATTERN {
	ULONG	Reserved1;
	ULONG	Reserved2;
	ULONG	SrcAddr;
	ULONG	DstAddr;
	union {
	struct { USHORT s_srcport,s_dstport; } S_un_ports;
	struct { UCHAR s_type,s_code; USHORT filler; } S_un_icmp;
	ULONG	S_Spi;
	} S_un;
	UCHAR	ProtocolId;
	UCHAR	Reserved3[3];
#define	tcSrcPort S_un.S_un_ports.s_srcport
#define	tcDstPort S_un.S_un_ports.s_dstport
#define	tcIcmpType S_un.S_un_icmp.s_type
#define	tcIcmpCode S_un.S_un_icmp.s_code
#define	tcSpi S_un.S_Spi
}	IP_PATTERN, *PIP_PATTERN;
typedef	struct _IPX_PATTERN {
	struct {
	ULONG 	NetworkAddress;
	UCHAR 	NodeAddress[6];
	USHORT 	Socket;
	} Src, Dest;
}	IPX_PATTERN, *PIPX_PATTERN;
typedef	struct _ENUMERATION_BUFFER {
	ULONG	Length;
	ULONG	OwnerProcessId;
	USHORT	FlowNameLength;
	WCHAR	FlowName[MAX_STRING_LENGTH];
	PTC_GEN_FLOW	pFlow;
	ULONG	NumberOfFilters;
	TC_GEN_FILTER	GenericFilter[1];		
}	ENUMERATION_BUFFER, *PENUMERATION_BUFFER;
#define	CLSMAP_ID_BASE 5000
#define	CLSMAP_OBJECT_SERVICETYPE (0x00000000 + CLSMAP_ID_BASE)
#define	CLSMAP_OBJECT_END_OF_LIST (0x00000001 + CLSMAP_ID_BASE)
typedef	struct _CLSMAP_SERVICETYPE {
	QOS_OBJECT_HDR	Header;
	ULONG	ServiceType;
	ULONG	ClassId;
}	CLSMAP_SERVICETYPE, *PCLSMAP_SERVICETYPE;
typedef	struct _TC_CLASS_MAP_FLOW {
	ULONG 	DefaultClass;	
	ULONG 	ObjectsLength;	
	QOS_OBJECT_HDR	Objects;	
}	TC_CLASS_MAP_FLOW, *PTC_CLASS_MAP_FLOW;
typedef	struct _QOS_HIERARCHY_CLASS {
	ULONG	ClassId;	
	ULONG Allocation;	
	ULONG BurstLength;	
	ULONG Flags;	
	ULONG ParentClassId;	
	ULONG ObjectsLength;	
	UCHAR Objects[1];
}	QOS_HIERARCHY_CLASS, *PQOS_HIERARCHY_CLASS;
#define	HCLASS_FLAG_BOUNDED	1
ULONG	APIENTRY TcRegisterClient(ULONG,HANDLE,PTCI_CLIENT_FUNC_LIST,PHANDLE);
ULONG	APIENTRY TcEnumerateInterfaces(HANDLE,PULONG,PTC_IFC_DESCRIPTOR);
ULONG	APIENTRY TcOpenInterfaceA(LPSTR,HANDLE,HANDLE,PHANDLE);
ULONG	APIENTRY TcOpenInterfaceW(LPWSTR,HANDLE,HANDLE,PHANDLE);
ULONG	APIENTRY TcCloseInterface(HANDLE);
ULONG	APIENTRY TcQueryInterface(HANDLE,LPGUID,BOOLEAN,PULONG,PVOID);
ULONG	APIENTRY TcSetInterface(HANDLE,LPGUID,ULONG,PVOID);
ULONG	APIENTRY TcQueryFlowA(LPSTR,LPGUID,PULONG,PVOID);
ULONG	APIENTRY TcQueryFlowW(LPWSTR,LPGUID,PULONG,PVOID);
ULONG	APIENTRY TcSetFlowA(LPSTR,LPGUID,ULONG,PVOID);
ULONG	APIENTRY TcSetFlowW(LPWSTR,LPGUID,ULONG,PVOID);
ULONG	APIENTRY TcAddFlow(HANDLE,HANDLE,ULONG,PTC_GEN_FLOW,PHANDLE);
ULONG	APIENTRY TcGetFlowNameA(HANDLE,ULONG,LPSTR);
ULONG	APIENTRY TcGetFlowNameW(HANDLE,ULONG,LPWSTR);
ULONG	APIENTRY TcModifyFlow(HANDLE,PTC_GEN_FLOW);
ULONG	APIENTRY TcAddFilter(HANDLE,PTC_GEN_FILTER,PHANDLE);
ULONG	APIENTRY TcDeregisterClient(HANDLE);
ULONG	APIENTRY TcDeleteFlow(HANDLE);
ULONG	APIENTRY TcDeleteFilter(HANDLE);
ULONG	APIENTRY TcEnumerateFlows(HANDLE,PHANDLE,PULONG,PULONG,PENUMERATION_BUFFER);
ULONG	APIENTRY TcAddClassMapFlow( HANDLE, HANDLE, ULONG, PTC_CLASS_MAP_FLOW, PHANDLE );
#ifdef	UNICODE
#define	TcOpenInterface	TcOpenInterfaceW
#define	TcQueryFlow	TcQueryFlowW
#define	TcSetFlow	TcSetFlowW
#define	TcGetFlowName	TcGetFlowNameW
#else	
#define	TcOpenInterface	TcOpenInterfaceA
#define	TcQueryFlow	TcQueryFlowA
#define	TcSetFlow	TcSetFlowA
#define	TcGetFlowName	TcGetFlowNameA
#endif	
#endif

