#ifndef __userenv_h__
#define __userenv_h__
#include <wbemcli.h>
#include <profinfo.h>
#if !defined(_USERENV_)
#define USERENVAPI DECLSPEC_IMPORT
#else
#define USERENVAPI
#endif
#define PI_NOUI 1
#define PI_APPLYPOLICY 2
USERENVAPI BOOL WINAPI LoadUserProfileA(HANDLE ,LPPROFILEINFOA );
USERENVAPI BOOL WINAPI LoadUserProfileW(HANDLE ,LPPROFILEINFOW );
#ifdef UNICODE
#define GetProfilesDirectory GetProfilesDirectoryW
#define LoadUserProfile LoadUserProfileW
#define DeleteProfile DeleteProfileW
#else
#define GetProfilesDirectory GetProfilesDirectoryA
#define LoadUserProfile LoadUserProfileA
#define DeleteProfile DeleteProfileA
#endif 
USERENVAPI BOOL WINAPI UnloadUserProfile(HANDLE ,HANDLE );
USERENVAPI BOOL WINAPI GetProfilesDirectoryA(LPSTR ,LPDWORD );
USERENVAPI BOOL WINAPI GetProfilesDirectoryW(LPWSTR ,LPDWORD );
#if(WINVER >= 1280)
#define PT_TEMPORARY 1
#define PT_ROAMING 2
#define PT_MANDATORY 4
USERENVAPI BOOL WINAPI GetProfileType(DWORD *);
#endif 
#if(WINVER >= 1280)
USERENVAPI BOOL WINAPI DeleteProfileA (LPCSTR ,LPCSTR ,LPCSTR );
USERENVAPI BOOL WINAPI DeleteProfileW (LPCWSTR ,LPCWSTR ,LPCWSTR );
#endif 
#if(WINVER >= 1280)
USERENVAPI BOOL WINAPI GetDefaultUserProfileDirectoryA(LPSTR ,LPDWORD );
USERENVAPI BOOL WINAPI GetDefaultUserProfileDirectoryW(LPWSTR ,LPDWORD );
#ifdef UNICODE
#define GetDefaultUserProfileDirectory GetDefaultUserProfileDirectoryW
#else
#define GetDefaultUserProfileDirectory GetDefaultUserProfileDirectoryA
#endif 
#endif 
#if(WINVER >= 1280)
USERENVAPI BOOL WINAPI GetAllUsersProfileDirectoryA(LPSTR ,LPDWORD );
USERENVAPI BOOL WINAPI GetAllUsersProfileDirectoryW(LPWSTR ,LPDWORD );
#ifdef UNICODE
#define GetAllUsersProfileDirectory GetAllUsersProfileDirectoryW
#else
#define GetAllUsersProfileDirectory GetAllUsersProfileDirectoryA
#endif 
#endif 
USERENVAPI BOOL WINAPI GetUserProfileDirectoryA(HANDLE ,LPSTR ,LPDWORD );
USERENVAPI BOOL WINAPI GetUserProfileDirectoryW(HANDLE ,LPWSTR ,LPDWORD );
#ifdef UNICODE
#define GetUserProfileDirectory GetUserProfileDirectoryW
#else
#define GetUserProfileDirectory GetUserProfileDirectoryA
#endif 
USERENVAPI BOOL WINAPI CreateEnvironmentBlock(LPVOID *,HANDLE ,BOOL );
USERENVAPI BOOL WINAPI DestroyEnvironmentBlock(LPVOID );
#if(WINVER >= 1280)
USERENVAPI BOOL WINAPI ExpandEnvironmentStringsForUserA(HANDLE ,LPCSTR ,LPSTR ,DWORD );
USERENVAPI BOOL WINAPI ExpandEnvironmentStringsForUserW(HANDLE ,LPCWSTR ,LPWSTR ,DWORD );
#ifdef UNICODE
#define ExpandEnvironmentStringsForUser ExpandEnvironmentStringsForUserW
#else
#define ExpandEnvironmentStringsForUser ExpandEnvironmentStringsForUserA
#endif 
#endif 
#if(WINVER >= 1280)
USERENVAPI BOOL WINAPI RefreshPolicy(BOOL );
#endif 
#if(WINVER >= 1280)
#define RP_FORCE 1 
USERENVAPI BOOL WINAPI RefreshPolicyEx(BOOL ,IN DWORD dwOptions);
#endif 
#if(WINVER >= 1280)
USERENVAPI HANDLE WINAPI EnterCriticalPolicySection(BOOL );
#endif 
#if(WINVER >= 1280)
USERENVAPI BOOL WINAPI LeaveCriticalPolicySection(HANDLE );
#endif 
#if(WINVER >= 1280)
USERENVAPI BOOL WINAPI RegisterGPNotification(HANDLE ,BOOL );
#endif 
#if(WINVER >= 1280)
USERENVAPI BOOL WINAPI UnregisterGPNotification(HANDLE );
#endif 
#if(WINVER >= 1280)
#define GPC_BLOCK_POLICY 1
#endif 
#if(WINVER >= 1280)
#define GPO_FLAG_DISABLE 1
#define GPO_FLAG_FORCE 2
#endif 
#if(WINVER >= 1280)
typedef enum _GPO_LINK {
GPLinkUnknown=0,
GPLinkMachine,
GPLinkSite,
GPLinkDomain,
GPLinkOrganizationalUnit 
} GPO_LINK,*PGPO_LINK;
typedef struct _GROUP_POLICY_OBJECTA {
DWORD dwOptions; 
DWORD dwVersion; 
LPSTR lpDSPath; 
LPSTR lpFileSysPath; 
LPSTR lpDisplayName; 
CHAR szGPOName[50]; 
GPO_LINK GPOLink; 
LPARAM lParam; 
struct _GROUP_POLICY_OBJECTA * pNext; 
struct _GROUP_POLICY_OBJECTA * pPrev; 
LPSTR lpExtensions; 
LPARAM lParam2; 
LPSTR lpLink; 
} GROUP_POLICY_OBJECTA,*PGROUP_POLICY_OBJECTA;
typedef struct _GROUP_POLICY_OBJECTW {
DWORD dwOptions; 
DWORD dwVersion; 
LPWSTR lpDSPath; 
LPWSTR lpFileSysPath; 
LPWSTR lpDisplayName; 
WCHAR szGPOName[50]; 
GPO_LINK GPOLink; 
LPARAM lParam; 
struct _GROUP_POLICY_OBJECTW * pNext; 
struct _GROUP_POLICY_OBJECTW * pPrev; 
LPWSTR lpExtensions; 
LPARAM lParam2; 
LPWSTR lpLink; 
} GROUP_POLICY_OBJECTW,*PGROUP_POLICY_OBJECTW;
#ifdef UNICODE
typedef GROUP_POLICY_OBJECTW GROUP_POLICY_OBJECT;
typedef PGROUP_POLICY_OBJECTW PGROUP_POLICY_OBJECT;
#else
typedef GROUP_POLICY_OBJECTA GROUP_POLICY_OBJECT;
typedef PGROUP_POLICY_OBJECTA PGROUP_POLICY_OBJECT;
#endif 
#define GPO_LIST_FLAG_MACHINE 1
#define GPO_LIST_FLAG_SITEONLY 2
#define GPO_LIST_FLAG_NO_WMIFILTERS 4
USERENVAPI BOOL WINAPI GetGPOListA (HANDLE ,LPCSTR ,LPCSTR ,LPCSTR ,DWORD ,PGROUP_POLICY_OBJECTA *);
USERENVAPI BOOL WINAPI GetGPOListW (HANDLE ,LPCWSTR ,LPCWSTR ,LPCWSTR ,DWORD ,PGROUP_POLICY_OBJECTW *);
#ifdef UNICODE
#define GetGPOList GetGPOListW
#else
#define GetGPOList GetGPOListA
#endif 
#endif 
#if(WINVER >= 1280)
USERENVAPI BOOL WINAPI FreeGPOListA (PGROUP_POLICY_OBJECTA );
USERENVAPI BOOL WINAPI FreeGPOListW (PGROUP_POLICY_OBJECTW );
#ifdef UNICODE
#define FreeGPOList FreeGPOListW
#else
#define FreeGPOList FreeGPOListA
#endif 
#endif 
#if(WINVER >= 1280)
USERENVAPI DWORD WINAPI GetAppliedGPOListA (DWORD ,LPCSTR ,PSID ,GUID *,PGROUP_POLICY_OBJECTA *);
USERENVAPI DWORD WINAPI GetAppliedGPOListW (DWORD ,LPCWSTR ,PSID ,GUID *,PGROUP_POLICY_OBJECTW *);
#ifdef UNICODE
#define GetAppliedGPOList GetAppliedGPOListW
#else
#define GetAppliedGPOList GetAppliedGPOListA
#endif 
#endif 
#if(WINVER >= 1280)
#define GP_DLLNAME TEXT("DllName")
#define GP_ENABLEASYNCHRONOUSPROCESSING TEXT("EnableAsynchronousProcessing")
#define GP_MAXNOGPOLISTCHANGESINTERVAL TEXT("MaxNoGPOListChangesInterval")
#define GP_NOBACKGROUNDPOLICY TEXT("NoBackgroundPolicy")
#define GP_NOGPOLISTCHANGES TEXT("NoGPOListChanges")
#define GP_NOMACHINEPOLICY TEXT("NoMachinePolicy")
#define GP_NOSLOWLINK TEXT("NoSlowLink")
#define GP_NOTIFYLINKTRANSITION TEXT("NotifyLinkTransition")
#define GP_NOUSERPOLICY TEXT("NoUserPolicy")
#define GP_PERUSERLOCALSETTINGS TEXT("PerUserLocalSettings")
#define GP_PROCESSGROUPPOLICY TEXT("ProcessGroupPolicy")
#define GP_REQUIRESSUCCESSFULREGISTRY TEXT("RequiresSuccessfulRegistry")
#define GPO_INFO_FLAG_MACHINE 1
#define GPO_INFO_FLAG_BACKGROUND 16
#define GPO_INFO_FLAG_SLOWLINK 32
#define GPO_INFO_FLAG_VERBOSE 64
#define GPO_INFO_FLAG_NOCHANGES 128
#define GPO_INFO_FLAG_LINKTRANSITION 256
#define GPO_INFO_FLAG_LOGRSOP_TRANSITION 512
#define GPO_INFO_FLAG_FORCED_REFRESH 1024
#define GPO_INFO_FLAG_SAFEMODE_BOOT 2048
#define GPO_INFO_FLAG_ASYNC_FOREGROUND 4096
#define GPO_INFO_FLAG_REPORT 0x2000
typedef UINT_PTR ASYNCCOMPLETIONHANDLE;
typedef DWORD (*PFNSTATUSMESSAGECALLBACK)(BOOL ,LPWSTR );
typedef DWORD(*PFNPROCESSGROUPPOLICY)(DWORD ,HANDLE ,HKEY ,PGROUP_POLICY_OBJECT ,PGROUP_POLICY_OBJECT ,ASYNCCOMPLETIONHANDLE ,BOOL *,PFNSTATUSMESSAGECALLBACK ); 
typedef DWORD(*PFNPROCESSGROUPPOLICYEX)(DWORD ,HANDLE ,HKEY ,PGROUP_POLICY_OBJECT ,PGROUP_POLICY_OBJECT ,ASYNCCOMPLETIONHANDLE ,BOOL *,PFNSTATUSMESSAGECALLBACK ,IWbemServices *,HRESULT *); 
typedef PVOID PRSOPTOKEN;
typedef struct _RSOP_TARGET {
WCHAR * pwszAccountName; 
WCHAR * pwszNewSOM; 
SAFEARRAY * psaSecurityGroups; 
PRSOPTOKEN pRsopToken; 
PGROUP_POLICY_OBJECT pGPOList; 
IWbemServices * pWbemServices; 
} RSOP_TARGET,*PRSOP_TARGET;
typedef DWORD(*PFNGENERATEGROUPPOLICY)(DWORD ,BOOL *,WCHAR *,PRSOP_TARGET ,PRSOP_TARGET ); 
#define REGISTRY_EXTENSION_GUID { 0x35378eac,0x683f,4562,168,154,0,192,79,187,207,162}
#endif 
#if(WINVER >= 1280)
typedef GUID *REFGPEXTENSIONID;
USERENVAPI DWORD WINAPI ProcessGroupPolicyCompleted(REFGPEXTENSIONID ,ASYNCCOMPLETIONHANDLE ,DWORD );
#endif 
#if(WINVER >= 1280)
USERENVAPI DWORD WINAPI ProcessGroupPolicyCompletedEx(REFGPEXTENSIONID ,ASYNCCOMPLETIONHANDLE ,DWORD ,HRESULT );
#endif 
#if(WINVER >= 1280)
USERENVAPI HRESULT 
WINAPI RsopAccessCheckByType(PSECURITY_DESCRIPTOR ,PSID ,PRSOPTOKEN ,DWORD ,POBJECT_TYPE_LIST ,DWORD ,PGENERIC_MAPPING ,PPRIVILEGE_SET ,LPDWORD ,LPDWORD ,LPBOOL );
#endif 
#if(WINVER >= 1280)
USERENVAPI HRESULT 
WINAPI RsopFileAccessCheck(LPWSTR ,PRSOPTOKEN ,DWORD ,LPDWORD ,LPBOOL );
#endif 
typedef enum _SETTINGSTATUS
{
RSOPUnspecified=0,
RSOPApplied,
RSOPIgnored,
RSOPFailed,
RSOPSubsettingFailed
} SETTINGSTATUS;
typedef struct _POLICYSETTINGSTATUSINFO
{
LPWSTR	szKey;
LPWSTR	szEventSource;
LPWSTR	szEventLogName;
DWORD	dwEventID;
DWORD	dwErrorCode;
SETTINGSTATUS status;
SYSTEMTIME	timeLogged;
} POLICYSETTINGSTATUSINFO,*LPPOLICYSETTINGSTATUSINFO;
USERENVAPI HRESULT WINAPI RsopSetPolicySettingStatus(DWORD ,IWbemServices* pServices,IWbemClassObject* pSettingInstance,DWORD ,POLICYSETTINGSTATUSINFO* pStatus);
USERENVAPI HRESULT WINAPI RsopResetPolicySettingStatus(DWORD ,IWbemServices* pServices,IWbemClassObject* pSettingInstance);
#define FLAG_NO_GPO_FILTER 0x80000000
#define FLAG_NO_CSE_INVOKE 0x40000000
#define FLAG_ASSUME_SLOW_LINK 0x20000000
#define FLAG_LOOPBACK_MERGE 0x10000000
#define FLAG_LOOPBACK_REPLACE 0x8000000
#define FLAG_ASSUME_USER_WQLFILTER_TRUE 0x4000000
#define FLAG_ASSUME_COMP_WQLFILTER_TRUE 0x2000000
#define FLAG_PLANNING_MODE 0x1000000
#define FLAG_NO_USER 1
#define FLAG_NO_COMPUTER 2
#define FLAG_FORCE_CREATENAMESPACE 4
#define RSOP_USER_ACCESS_DENIED 1
#define RSOP_COMPUTER_ACCESS_DENIED 2
#define RSOP_TEMPNAMESPACE_EXISTS 4
#endif 
