#ifndef __uxtheme_h__
#define __uxtheme_h__
#include <commctrl.h>
#ifndef THEMEAPI
#if !defined(_UXTHEME_)
#define THEMEAPI EXTERN_C DECLSPEC_IMPORT HRESULT STDAPICALLTYPE
#define THEMEAPI_(type) EXTERN_C DECLSPEC_IMPORT type STDAPICALLTYPE
#else
#define THEMEAPI STDAPI
#define THEMEAPI_(type) STDAPI_(type)
#endif
#endif 
typedef HANDLE HTHEME; 
THEMEAPI_(HTHEME) OpenThemeData(HWND ,LPCWSTR );
THEMEAPI CloseThemeData(HTHEME );
THEMEAPI DrawThemeBackground(HTHEME ,HDC ,int ,int ,const RECT *pRect,const RECT *pClipRect);
#define DTT_GRAYED 1
THEMEAPI DrawThemeText(HTHEME ,HDC ,int ,int ,LPCWSTR ,int ,DWORD ,DWORD ,const RECT *pRect);
THEMEAPI GetThemeBackgroundContentRect(HTHEME ,HDC hdc,int ,int ,const RECT *pBoundingRect,RECT *);
THEMEAPI GetThemeBackgroundExtent(HTHEME ,HDC hdc,int ,int ,const RECT *pContentRect,RECT *);
typedef enum { TS_MIN, TS_TRUE, TS_DRAW, } THEMESIZE ;
THEMEAPI GetThemePartSize(HTHEME ,HDC ,int ,int ,RECT *,THEMESIZE eSize,SIZE *psz);
THEMEAPI GetThemeTextExtent(HTHEME ,HDC ,int ,int ,LPCWSTR ,int ,DWORD ,const RECT *pBoundingRect,RECT *);
THEMEAPI GetThemeTextMetrics(HTHEME ,HDC hdc,int ,int ,TEXTMETRIC* ptm);
THEMEAPI GetThemeBackgroundRegion(HTHEME ,HDC hdc,int ,int ,const RECT *pRect, HRGN *pRegion);
#define HTTB_BACKGROUNDSEG 0
#define HTTB_FIXEDBORDER 2
#define HTTB_CAPTION 4
#define HTTB_RESIZINGBORDER_LEFT 16
#define HTTB_RESIZINGBORDER_TOP 32
#define HTTB_RESIZINGBORDER_RIGHT 64
#define HTTB_RESIZINGBORDER_BOTTOM 128
#define HTTB_RESIZINGBORDER (HTTB_RESIZINGBORDER_LEFT|HTTB_RESIZINGBORDER_TOP|\ HTTB_RESIZINGBORDER_RIGHT|HTTB_RESIZINGBORDER_BOTTOM)
#define HTTB_SIZINGTEMPLATE 256
#define HTTB_SYSTEMSIZINGMARGINS 512
THEMEAPI HitTestThemeBackground(HTHEME ,HDC hdc,int ,int ,DWORD ,const RECT *pRect,HRGN hrgn,POINT ,WORD *pwHitTestCode);
THEMEAPI DrawThemeEdge(HTHEME ,HDC ,int ,int ,const RECT *pDestRect,UINT ,UINT ,RECT *pContentRect);
THEMEAPI DrawThemeIcon(HTHEME ,HDC ,int ,int ,const RECT *pRect,HIMAGELIST ,int );
THEMEAPI_(BOOL) IsThemePartDefined(HTHEME ,int ,int );
THEMEAPI_(BOOL) IsThemeBackgroundPartiallyTransparent(HTHEME ,int ,int );
THEMEAPI GetThemeColor(HTHEME ,int ,int ,int ,COLORREF *pColor);
THEMEAPI GetThemeMetric(HTHEME ,HDC hdc,int ,int ,int ,int *piVal);
THEMEAPI GetThemeString(HTHEME ,int ,int ,int ,LPWSTR pszBuff,int );
THEMEAPI GetThemeBool(HTHEME ,int ,int ,int ,BOOL *pfVal);
THEMEAPI GetThemeInt(HTHEME ,int ,int ,int ,int *piVal);
THEMEAPI GetThemeEnumValue(HTHEME ,int ,int ,int ,int *piVal);
THEMEAPI GetThemePosition(HTHEME ,int ,int ,int ,POINT *pPoint);
THEMEAPI GetThemeFont(HTHEME ,HDC hdc,int ,int ,int ,LOGFONT *pFont);
THEMEAPI GetThemeRect(HTHEME ,int ,int ,int ,RECT *pRect);
typedef struct _MARGINS
{
int cxLeftWidth; 
int cxRightWidth; 
int cyTopHeight; 
int cyBottomHeight; 
} MARGINS,*PMARGINS;
THEMEAPI GetThemeMargins(HTHEME ,HDC hdc,int ,int ,int ,RECT *prc,MARGINS *pMargins);
#define MAX_INTLIST_COUNT 10
typedef struct _INTLIST { int iValueCount; int iValues[MAX_INTLIST_COUNT];
} INTLIST,*PINTLIST;
THEMEAPI GetThemeIntList(HTHEME ,int ,int ,int ,INTLIST *pIntList);
typedef enum PROPERTYORIGIN { PO_STATE, PO_PART, PO_CLASS, PO_GLOBAL, PO_NOTFOUND };
THEMEAPI GetThemePropertyOrigin(HTHEME ,int ,int ,int ,enum PROPERTYORIGIN *pOrigin);
THEMEAPI SetWindowTheme(HWND ,LPCWSTR ,LPCWSTR );
THEMEAPI GetThemeFilename(HTHEME ,int ,int ,int ,LPWSTR pszThemeFileName,int );
THEMEAPI_(COLORREF) GetThemeSysColor(HTHEME ,int );
THEMEAPI_(HBRUSH) GetThemeSysColorBrush(HTHEME ,int );
THEMEAPI_(BOOL) GetThemeSysBool(HTHEME ,int );
THEMEAPI_(int) GetThemeSysSize(HTHEME ,int );
THEMEAPI GetThemeSysFont(HTHEME ,int ,LOGFONT *plf);
THEMEAPI GetThemeSysString(HTHEME ,int ,LPWSTR ,int );
THEMEAPI GetThemeSysInt(HTHEME ,int ,int *);
THEMEAPI_(BOOL) IsThemeActive();
THEMEAPI_(BOOL) IsAppThemed();
THEMEAPI_(HTHEME) GetWindowTheme(HWND );
#define ETDT_DISABLE 1
#define ETDT_ENABLE 2
#define ETDT_USETABTEXTURE 4
#define ETDT_ENABLETAB (ETDT_ENABLE | ETDT_USETABTEXTURE)
THEMEAPI EnableThemeDialogTexture(HWND ,DWORD );
THEMEAPI_(BOOL) IsThemeDialogTextureEnabled(HWND );
#define STAP_ALLOW_NONCLIENT (1 << 0)
#define STAP_ALLOW_CONTROLS (1 << 1)
#define STAP_ALLOW_WEBCONTENT (1 << 2)
THEMEAPI_(DWORD) GetThemeAppProperties();
THEMEAPI_(void) SetThemeAppProperties(DWORD );
THEMEAPI GetCurrentThemeName(LPWSTR ,int ,LPWSTR ,int ,LPWSTR ,int );
#define SZ_THDOCPROP_DISPLAYNAME L"DisplayName"
#define SZ_THDOCPROP_CANONICALNAME L"ThemeName"
#define SZ_THDOCPROP_TOOLTIP L"ToolTip"
#define SZ_THDOCPROP_AUTHOR L"author"
THEMEAPI GetThemeDocumentationProperty(LPCWSTR ,LPCWSTR ,LPWSTR pszValueBuff,int );
THEMEAPI DrawThemeParentBackground(HWND ,HDC ,RECT* prc);
THEMEAPI EnableTheming(BOOL );
#define DTBG_CLIPRECT 1
#define DTBG_DRAWSOLID 2
#define DTBG_OMITBORDER 4
#define DTBG_OMITCONTENT 8
#define DTBG_COMPUTINGREGION 16
#define DTBG_MIRRORDC 32
typedef struct _DTBGOPTS
{
DWORD dwSize; 
DWORD dwFlags; 
RECT rcClip; 
}
DTBGOPTS,*PDTBGOPTS;
THEMEAPI DrawThemeBackgroundEx(HTHEME ,HDC ,int ,int ,const RECT *pRect,const DTBGOPTS *pOptions);
#endif 
