#ifndef __wincred_h__
#define __wincred_h__
#define WINADVAPI
#define CREDUIAPI
#ifndef __SECHANDLE_DEFINED__
typedef struct _SecHandle {
	ULONG_PTR dwLower ;
	ULONG_PTR dwUpper ;
}
SecHandle,* PSecHandle ;
#define __SECHANDLE_DEFINED__
#endif
typedef PSecHandle PCtxtHandle;
#ifndef _WINBASE_
#ifndef _FILETIME_
#define _FILETIME_
typedef struct _FILETIME
{
	DWORD dwLowDateTime;
	DWORD dwHighDateTime;
}
FILETIME;
typedef struct _FILETIME *PFILETIME;
typedef struct _FILETIME *LPFILETIME;
#endif
#endif
#ifndef _NTDEF_
typedef LONG NTSTATUS,*PNTSTATUS;
#endif
#define STATUS_LOGON_FAILURE ((NTSTATUS)0xc000006d)
#define STATUS_WRONG_PASSWORD ((NTSTATUS)0xc000006a)
#define STATUS_PASSWORD_EXPIRED ((NTSTATUS)0xc0000071)
#define STATUS_PASSWORD_MUST_CHANGE ((NTSTATUS)0xc0000224)
#define STATUS_ACCESS_DENIED ((NTSTATUS)0xc0000022)
#define STATUS_DOWNGRADE_DETECTED ((NTSTATUS)0xc0000388)
#define STATUS_AUTHENTICATION_FIREWALL_FAILED ((NTSTATUS)0xc0000413)
#define STATUS_ACCOUNT_DISABLED ((NTSTATUS)0xc0000072)
#define STATUS_ACCOUNT_RESTRICTION ((NTSTATUS)0xc000006e)
#define STATUS_ACCOUNT_LOCKED_OUT ((NTSTATUS)0xc0000234)
#define STATUS_ACCOUNT_EXPIRED ((NTSTATUS)0xc0000193)
#define STATUS_LOGON_TYPE_NOT_GRANTED ((NTSTATUS)0xc000015b)
#define NERR_BASE 2100
#define NERR_PasswordExpired (NERR_BASE+142)
#define CREDUIP_IS_USER_PASSWORD_ERROR(_Status) ((_Status)== ERROR_LOGON_FAILURE || (_Status)== HRESULT_FROM_WIN32(ERROR_LOGON_FAILURE) || \
	(_Status)== STATUS_LOGON_FAILURE ||(_Status)== HRESULT_FROM_NT(STATUS_LOGON_FAILURE) ||\
	(_Status)== ERROR_ACCESS_DENIED || (_Status)== HRESULT_FROM_WIN32(ERROR_ACCESS_DENIED) ||\
	(_Status)== STATUS_ACCESS_DENIED || (_Status)== HRESULT_FROM_NT(STATUS_ACCESS_DENIED) ||\
	(_Status)== ERROR_INVALID_PASSWORD || (_Status)== HRESULT_FROM_WIN32(ERROR_INVALID_PASSWORD) ||\
	(_Status)== STATUS_WRONG_PASSWORD || (_Status)== HRESULT_FROM_NT(STATUS_WRONG_PASSWORD) || \
	(_Status)== SEC_E_NO_CREDENTIALS || (_Status)== SEC_E_LOGON_DENIED)
#define CREDUIP_IS_DOWNGRADE_ERROR(_Status) ((_Status)== ERROR_DOWNGRADE_DETECTED||(_Status)== HRESULT_FROM_WIN32(ERROR_DOWNGRADE_DETECTED)||\
	(_Status)== STATUS_DOWNGRADE_DETECTED || (_Status)== HRESULT_FROM_NT(STATUS_DOWNGRADE_DETECTED))
#define CREDUIP_IS_EXPIRED_ERROR(_Status) ((_Status)== ERROR_PASSWORD_EXPIRED || (_Status)== HRESULT_FROM_WIN32(ERROR_PASSWORD_EXPIRED) || \
	(_Status)== STATUS_PASSWORD_EXPIRED || (_Status)== HRESULT_FROM_NT(STATUS_PASSWORD_EXPIRED)||\
	(_Status)== ERROR_PASSWORD_MUST_CHANGE || (_Status)== HRESULT_FROM_WIN32(ERROR_PASSWORD_MUST_CHANGE)||\
	(_Status)== STATUS_PASSWORD_MUST_CHANGE ||(_Status)== HRESULT_FROM_NT(STATUS_PASSWORD_MUST_CHANGE)||\
	(_Status)== NERR_PasswordExpired || (_Status)== HRESULT_FROM_WIN32(NERR_PasswordExpired))
#define CREDUI_IS_AUTHENTICATION_ERROR(_Status) (\ CREDUIP_IS_USER_PASSWORD_ERROR(_Status) || CREDUIP_IS_DOWNGRADE_ERROR(_Status) || \
	CREDUIP_IS_EXPIRED_ERROR(_Status) )
#define CREDUI_NO_PROMPT_AUTHENTICATION_ERROR(_Status) ((_Status)== ERROR_AUTHENTICATION_FIREWALL_FAILED || \
	(_Status)== HRESULT_FROM_WIN32(ERROR_AUTHENTICATION_FIREWALL_FAILED) || (_Status)== STATUS_AUTHENTICATION_FIREWALL_FAILED || \
	(_Status)== HRESULT_FROM_NT(STATUS_AUTHENTICATION_FIREWALL_FAILED) || (_Status)== ERROR_ACCOUNT_DISABLED || \
	(_Status)== HRESULT_FROM_WIN32(ERROR_ACCOUNT_DISABLED) || (_Status)== STATUS_ACCOUNT_DISABLED ||  (_Status)== HRESULT_FROM_NT(STATUS_ACCOUNT_DISABLED) || \
	(_Status)== ERROR_ACCOUNT_RESTRICTION || (_Status)== HRESULT_FROM_WIN32(ERROR_ACCOUNT_RESTRICTION) || \
	(_Status)== STATUS_ACCOUNT_RESTRICTION || (_Status)== HRESULT_FROM_NT(STATUS_ACCOUNT_RESTRICTION) || \
	(_Status)== ERROR_ACCOUNT_LOCKED_OUT || (_Status)== HRESULT_FROM_WIN32(ERROR_ACCOUNT_LOCKED_OUT) || (_Status)== STATUS_ACCOUNT_LOCKED_OUT || \
	(_Status)== HRESULT_FROM_NT(STATUS_ACCOUNT_LOCKED_OUT) || (_Status)== ERROR_ACCOUNT_EXPIRED || \
	(_Status)== HRESULT_FROM_WIN32(ERROR_ACCOUNT_EXPIRED) || (_Status)== STATUS_ACCOUNT_EXPIRED || \
	(_Status)== HRESULT_FROM_NT(STATUS_ACCOUNT_EXPIRED) ||  (_Status)== ERROR_LOGON_TYPE_NOT_GRANTED || \
	(_Status)== HRESULT_FROM_WIN32(ERROR_LOGON_TYPE_NOT_GRANTED) || (_Status)== STATUS_LOGON_TYPE_NOT_GRANTED || \
	(_Status)== HRESULT_FROM_NT(STATUS_LOGON_TYPE_NOT_GRANTED) )
#define CRED_MAX_STRING_LENGTH 256
#define CRED_MAX_USERNAME_LENGTH (256+1+256)
#define CRED_MAX_GENERIC_TARGET_NAME_LENGTH 32767
#define CRED_MAX_DOMAIN_TARGET_NAME_LENGTH (256+1+80)
#define CRED_MAX_VALUE_SIZE 256
#define CRED_MAX_ATTRIBUTES 64
typedef struct _CREDENTIAL_ATTRIBUTEA {
	LPSTR Keyword;
	DWORD Flags;
	DWORD ValueSize;
	LPBYTE Value;
}
CREDENTIAL_ATTRIBUTEA,*PCREDENTIAL_ATTRIBUTEA;
typedef struct _CREDENTIAL_ATTRIBUTEW {
	LPWSTR Keyword;
	DWORD Flags;
	DWORD ValueSize;
	LPBYTE Value;
}
CREDENTIAL_ATTRIBUTEW,*PCREDENTIAL_ATTRIBUTEW;
#ifdef UNICODE
typedef CREDENTIAL_ATTRIBUTEW CREDENTIAL_ATTRIBUTE;
typedef PCREDENTIAL_ATTRIBUTEW PCREDENTIAL_ATTRIBUTE;
#else
typedef CREDENTIAL_ATTRIBUTEA CREDENTIAL_ATTRIBUTE;
typedef PCREDENTIAL_ATTRIBUTEA PCREDENTIAL_ATTRIBUTE;
#endif
#define CRED_SESSION_WILDCARD_NAME_W L"*Session"
#define CRED_SESSION_WILDCARD_NAME_A "*Session"
#define CRED_SESSION_WILDCARD_NAME_LENGTH (sizeof(CRED_SESSION_WILDCARD_NAME_A)-1)
#ifdef UNICODE
#define CRED_SESSION_WILDCARD_NAME CRED_SESSION_WILDCARD_NAME_W
#else
#define CRED_SESSION_WILDCARD_NAME CRED_SESSION_WILDCARD_NAME_A
#endif
#define CRED_FLAGS_PASSWORD_FOR_CERT 1
#define CRED_FLAGS_PROMPT_NOW 2
#define CRED_FLAGS_USERNAME_TARGET 4
#define CRED_FLAGS_OWF_CRED_BLOB 8
#define CRED_FLAGS_VALID_FLAGS 15
#define CRED_TYPE_GENERIC 1
#define CRED_TYPE_DOMAIN_PASSWORD 2
#define CRED_TYPE_DOMAIN_CERTIFICATE 3
#define CRED_TYPE_DOMAIN_VISIBLE_PASSWORD 4
#define CRED_TYPE_MAXIMUM 5
#define CRED_TYPE_MAXIMUM_EX (CRED_TYPE_MAXIMUM+1000)
#define CRED_MAX_CREDENTIAL_BLOB_SIZE 512
#define CRED_PERSIST_NONE 0
#define CRED_PERSIST_SESSION 1
#define CRED_PERSIST_LOCAL_MACHINE 2
#define CRED_PERSIST_ENTERPRISE 3
typedef struct _CREDENTIALA {
	DWORD Flags;
	DWORD Type;
	LPSTR TargetName;
	LPSTR Comment;
	FILETIME LastWritten;
	DWORD CredentialBlobSize;
	LPBYTE CredentialBlob;
	DWORD Persist;
	DWORD AttributeCount;
	PCREDENTIAL_ATTRIBUTEA Attributes;
	LPSTR TargetAlias;
	LPSTR UserName;
} CREDENTIALA,*PCREDENTIALA;
typedef struct _CREDENTIALW {
	DWORD Flags;
	DWORD Type;
	LPWSTR TargetName;
	LPWSTR Comment;
	FILETIME LastWritten;
	DWORD CredentialBlobSize;
	LPBYTE CredentialBlob;
	DWORD Persist;
	DWORD AttributeCount;
	PCREDENTIAL_ATTRIBUTEW Attributes;
	LPWSTR TargetAlias;
	LPWSTR UserName;
} CREDENTIALW,*PCREDENTIALW;
#ifdef UNICODE
typedef CREDENTIALW CREDENTIAL;
typedef PCREDENTIALW PCREDENTIAL;
#else
typedef CREDENTIALA CREDENTIAL;
typedef PCREDENTIALA PCREDENTIAL;
#endif
#define CRED_TI_SERVER_FORMAT_UNKNOWN 1
#define CRED_TI_DOMAIN_FORMAT_UNKNOWN 2
#define CRED_TI_ONLY_PASSWORD_REQUIRED 4
#define CRED_TI_USERNAME_TARGET 8
#define CRED_TI_CREATE_EXPLICIT_CRED 16
#define CRED_TI_WORKGROUP_MEMBER 32
#define CRED_TI_VALID_FLAGS 63
typedef struct _CREDENTIAL_TARGET_INFORMATIONA {
	LPSTR TargetName;
	LPSTR NetbiosServerName;
	LPSTR DnsServerName;
	LPSTR NetbiosDomainName;
	LPSTR DnsDomainName;
	LPSTR DnsTreeName;
	LPSTR PackageName;
	ULONG Flags;
	DWORD CredTypeCount;
	LPDWORD CredTypes;
}
CREDENTIAL_TARGET_INFORMATIONA,*PCREDENTIAL_TARGET_INFORMATIONA;
typedef struct _CREDENTIAL_TARGET_INFORMATIONW {
	LPWSTR TargetName;
	LPWSTR NetbiosServerName;
	LPWSTR DnsServerName;
	LPWSTR NetbiosDomainName;
	LPWSTR DnsDomainName;
	LPWSTR DnsTreeName;
	LPWSTR PackageName;
	ULONG Flags;
	DWORD CredTypeCount;
	LPDWORD CredTypes;
} CREDENTIAL_TARGET_INFORMATIONW,*PCREDENTIAL_TARGET_INFORMATIONW;
#ifdef UNICODE
typedef CREDENTIAL_TARGET_INFORMATIONW CREDENTIAL_TARGET_INFORMATION;
typedef PCREDENTIAL_TARGET_INFORMATIONW PCREDENTIAL_TARGET_INFORMATION;
#else
typedef CREDENTIAL_TARGET_INFORMATIONA CREDENTIAL_TARGET_INFORMATION;
typedef PCREDENTIAL_TARGET_INFORMATIONA PCREDENTIAL_TARGET_INFORMATION;
#endif
#define CERT_HASH_LENGTH 20
typedef struct _CERT_CREDENTIAL_INFO {
	ULONG cbSize;
	UCHAR rgbHashOfCert[CERT_HASH_LENGTH];
}
CERT_CREDENTIAL_INFO,*PCERT_CREDENTIAL_INFO;
typedef struct _USERNAME_TARGET_CREDENTIAL_INFO {
	LPWSTR UserName;
}
USERNAME_TARGET_CREDENTIAL_INFO,*PUSERNAME_TARGET_CREDENTIAL_INFO;
typedef enum _CRED_MARSHAL_TYPE {
	CertCredential=1,
	UsernameTargetCredential
}
CRED_MARSHAL_TYPE,*PCRED_MARSHAL_TYPE;
typedef struct _CREDUI_INFOA
{
	DWORD cbSize;
	HWND hwndParent;
	PCSTR pszMessageText;
	PCSTR pszCaptionText;
	HBITMAP hbmBanner;
}
CREDUI_INFOA,*PCREDUI_INFOA;
typedef struct _CREDUI_INFOW
{
	DWORD cbSize;
	HWND hwndParent;
	PCWSTR pszMessageText;
	PCWSTR pszCaptionText;
	HBITMAP hbmBanner;
}
CREDUI_INFOW,*PCREDUI_INFOW;
#ifdef UNICODE
typedef CREDUI_INFOW CREDUI_INFO;
typedef PCREDUI_INFOW PCREDUI_INFO;
#else
typedef CREDUI_INFOA CREDUI_INFO;
typedef PCREDUI_INFOA PCREDUI_INFO;
#endif
#define CREDUI_MAX_MESSAGE_LENGTH 32767
#define CREDUI_MAX_CAPTION_LENGTH 128
#define CREDUI_MAX_GENERIC_TARGET_LENGTH CRED_MAX_GENERIC_TARGET_NAME_LENGTH
#define CREDUI_MAX_DOMAIN_TARGET_LENGTH CRED_MAX_DOMAIN_TARGET_NAME_LENGTH
#define CREDUI_MAX_USERNAME_LENGTH CRED_MAX_USERNAME_LENGTH
#define CREDUI_MAX_PASSWORD_LENGTH (CRED_MAX_CREDENTIAL_BLOB_SIZE / 2)
#define CREDUI_FLAGS_INCORRECT_PASSWORD 1
#define CREDUI_FLAGS_DO_NOT_PERSIST 2
#define CREDUI_FLAGS_REQUEST_ADMINISTRATOR 4
#define CREDUI_FLAGS_EXCLUDE_CERTIFICATES 8
#define CREDUI_FLAGS_REQUIRE_CERTIFICATE 16
#define CREDUI_FLAGS_SHOW_SAVE_CHECK_BOX 64
#define CREDUI_FLAGS_ALWAYS_SHOW_UI 128
#define CREDUI_FLAGS_REQUIRE_SMARTCARD 256
#define CREDUI_FLAGS_PASSWORD_ONLY_OK 512
#define CREDUI_FLAGS_VALIDATE_USERNAME 1024
#define CREDUI_FLAGS_COMPLETE_USERNAME 2048
#define CREDUI_FLAGS_PERSIST 4096
#define CREDUI_FLAGS_SERVER_CREDENTIAL 0x4000
#define CREDUI_FLAGS_EXPECT_CONFIRMATION 0x20000
#define CREDUI_FLAGS_GENERIC_CREDENTIALS 0x40000
#define CREDUI_FLAGS_USERNAME_TARGET_CREDENTIALS 0x80000
#define CREDUI_FLAGS_KEEP_USERNAME 0x100000
#define CREDUI_FLAGS_PROMPT_VALID (CREDUI_FLAGS_INCORRECT_PASSWORD|CREDUI_FLAGS_DO_NOT_PERSIST|CREDUI_FLAGS_REQUEST_ADMINISTRATOR|\
	CREDUI_FLAGS_EXCLUDE_CERTIFICATES|CREDUI_FLAGS_REQUIRE_CERTIFICATE|CREDUI_FLAGS_SHOW_SAVE_CHECK_BOX|CREDUI_FLAGS_ALWAYS_SHOW_UI|\
	CREDUI_FLAGS_REQUIRE_SMARTCARD|CREDUI_FLAGS_PASSWORD_ONLY_OK|CREDUI_FLAGS_VALIDATE_USERNAME|CREDUI_FLAGS_COMPLETE_USERNAME|\
	CREDUI_FLAGS_PERSIST|CREDUI_FLAGS_SERVER_CREDENTIAL|CREDUI_FLAGS_EXPECT_CONFIRMATION|CREDUI_FLAGS_GENERIC_CREDENTIALS|\
	CREDUI_FLAGS_USERNAME_TARGET_CREDENTIALS|CREDUI_FLAGS_KEEP_USERNAME)
#define CRED_PRESERVE_CREDENTIAL_BLOB 1
WINADVAPI BOOL WINAPI CredWriteW (PCREDENTIALW ,DWORD Flags );
WINADVAPI BOOL WINAPI CredWriteA (PCREDENTIALA ,DWORD Flags );
#ifdef UNICODE
#define CredWrite CredWriteW
#else
#define CredWrite CredWriteA
#endif
WINADVAPI BOOL WINAPI CredReadW (LPCWSTR ,DWORD ,DWORD ,PCREDENTIALW *Credential );
WINADVAPI BOOL WINAPI CredReadA (LPCSTR ,DWORD ,DWORD ,PCREDENTIALA *Credential );
#ifdef UNICODE
#define CredRead CredReadW
#else
#define CredRead CredReadA
#endif
WINADVAPI BOOL WINAPI CredEnumerateW (LPCWSTR ,DWORD ,DWORD *,PCREDENTIALW **Credential );
WINADVAPI BOOL WINAPI CredEnumerateA (LPCSTR ,DWORD ,DWORD *,PCREDENTIALA **Credential );
#ifdef UNICODE
#define CredEnumerate CredEnumerateW
#else
#define CredEnumerate CredEnumerateA
#endif
WINADVAPI BOOL WINAPI CredWriteDomainCredentialsW (PCREDENTIAL_TARGET_INFORMATIONW ,PCREDENTIALW ,DWORD Flags );
WINADVAPI BOOL WINAPI CredWriteDomainCredentialsA (PCREDENTIAL_TARGET_INFORMATIONA ,PCREDENTIALA ,DWORD Flags );
#ifdef UNICODE
#define CredWriteDomainCredentials CredWriteDomainCredentialsW
#else
#define CredWriteDomainCredentials CredWriteDomainCredentialsA
#endif
#define CRED_CACHE_TARGET_INFORMATION 1
WINADVAPI BOOL WINAPI CredReadDomainCredentialsW (PCREDENTIAL_TARGET_INFORMATIONW ,DWORD ,DWORD *,PCREDENTIALW **Credential );
WINADVAPI BOOL WINAPI CredReadDomainCredentialsA (PCREDENTIAL_TARGET_INFORMATIONA ,DWORD ,DWORD *,PCREDENTIALA **Credential );
#ifdef UNICODE
#define CredReadDomainCredentials CredReadDomainCredentialsW
#else
#define CredReadDomainCredentials CredReadDomainCredentialsA
#endif
WINADVAPI BOOL WINAPI CredDeleteW (LPCWSTR ,DWORD ,DWORD Flags );
WINADVAPI BOOL WINAPI CredDeleteA (LPCSTR ,DWORD ,DWORD Flags );
#ifdef UNICODE
#define CredDelete CredDeleteW
#else
#define CredDelete CredDeleteA
#endif
WINADVAPI BOOL WINAPI CredRenameW (LPCWSTR ,LPCWSTR ,DWORD ,DWORD Flags );
WINADVAPI BOOL WINAPI CredRenameA (LPCSTR ,LPCSTR ,DWORD ,DWORD Flags );
#ifdef UNICODE
#define CredRename CredRenameW
#else
#define CredRename CredRenameA
#endif
#define CRED_ALLOW_NAME_RESOLUTION 1
WINADVAPI BOOL WINAPI CredGetTargetInfoW (LPCWSTR ,DWORD ,PCREDENTIAL_TARGET_INFORMATIONW *TargetInfo );
WINADVAPI BOOL WINAPI CredGetTargetInfoA (LPCSTR ,DWORD ,PCREDENTIAL_TARGET_INFORMATIONA *TargetInfo );
#ifdef UNICODE
#define CredGetTargetInfo CredGetTargetInfoW
#else
#define CredGetTargetInfo CredGetTargetInfoA
#endif
WINADVAPI BOOL WINAPI CredMarshalCredentialW(CRED_MARSHAL_TYPE ,PVOID ,LPWSTR *MarshaledCredential );
WINADVAPI BOOL WINAPI CredMarshalCredentialA(CRED_MARSHAL_TYPE ,PVOID ,LPSTR *MarshaledCredential );
#ifdef UNICODE
#define CredMarshalCredential CredMarshalCredentialW
#else
#define CredMarshalCredential CredMarshalCredentialA
#endif
WINADVAPI BOOL WINAPI CredUnmarshalCredentialW(LPCWSTR ,PCRED_MARSHAL_TYPE ,PVOID *Credential );
WINADVAPI BOOL WINAPI CredUnmarshalCredentialA(LPCSTR ,PCRED_MARSHAL_TYPE ,PVOID *Credential );
#ifdef UNICODE
#define CredUnmarshalCredential CredUnmarshalCredentialW
#else
#define CredUnmarshalCredential CredUnmarshalCredentialA
#endif
WINADVAPI BOOL WINAPI CredIsMarshaledCredentialW(LPCWSTR MarshaledCredential );
WINADVAPI BOOL WINAPI CredIsMarshaledCredentialA(LPCSTR MarshaledCredential );
#ifdef UNICODE
#define CredIsMarshaledCredential CredIsMarshaledCredentialW
#else
#define CredIsMarshaledCredential CredIsMarshaledCredentialA
#endif
WINADVAPI BOOL WINAPI CredGetSessionTypes (DWORD ,LPDWORD MaximumPersist );
WINADVAPI VOID WINAPI CredFree (PVOID Buffer );
CREDUIAPI DWORD WINAPI CredUIPromptForCredentialsW(PCREDUI_INFOW ,PCWSTR ,PCtxtHandle ,DWORD ,PWSTR ,ULONG ,PWSTR ,ULONG ,BOOL *,DWORD dwFlags );
CREDUIAPI DWORD WINAPI CredUIPromptForCredentialsA(PCREDUI_INFOA ,PCSTR ,PCtxtHandle ,DWORD ,PSTR ,ULONG ,PSTR ,ULONG ,BOOL *,DWORD dwFlags );
#ifdef UNICODE
#define CredUIPromptForCredentials CredUIPromptForCredentialsW
#else
#define CredUIPromptForCredentials CredUIPromptForCredentialsA
#endif
CREDUIAPI DWORD WINAPI CredUIParseUserNameW(PCWSTR ,PWSTR ,ULONG ,PWSTR ,ULONG ulDomainBufferSize );
CREDUIAPI DWORD WINAPI CredUIParseUserNameA(PCSTR ,PSTR ,ULONG ,PSTR ,ULONG ulDomainBufferSize );
#ifdef UNICODE
#define CredUIParseUserName CredUIParseUserNameW
#else
#define CredUIParseUserName CredUIParseUserNameA
#endif
CREDUIAPI DWORD WINAPI CredUICmdLinePromptForCredentialsW(PCWSTR ,PCtxtHandle ,DWORD ,PWSTR ,ULONG ,PWSTR ,ULONG ,PBOOL ,DWORD dwFlags );
CREDUIAPI DWORD WINAPI CredUICmdLinePromptForCredentialsA(PCSTR ,PCtxtHandle ,DWORD ,PSTR ,ULONG ,PSTR ,ULONG ,PBOOL ,DWORD dwFlags );
#ifdef UNICODE
#define CredUICmdLinePromptForCredentials CredUICmdLinePromptForCredentialsW
#else
#define CredUICmdLinePromptForCredentials CredUICmdLinePromptForCredentialsA
#endif
CREDUIAPI DWORD WINAPI CredUIConfirmCredentialsW(PCWSTR ,BOOL bConfirm );
CREDUIAPI DWORD WINAPI CredUIConfirmCredentialsA(PCSTR ,BOOL bConfirm );
#ifdef UNICODE
#define CredUIConfirmCredentials CredUIConfirmCredentialsW
#else
#define CredUIConfirmCredentials CredUIConfirmCredentialsA
#endif
CREDUIAPI DWORD WINAPI CredUIStoreSSOCredW (PCWSTR ,PCWSTR ,PCWSTR ,BOOL bPersist );
CREDUIAPI DWORD WINAPI CredUIReadSSOCredW (PCWSTR ,PWSTR* ppszUsername );
#endif
