#ifndef __winldap_h__
#define __winldap_h__
#ifndef __windows_h__
#include <windows.h>
#endif
#ifndef __schnlsp_h__
#include <schnlsp.h>
#endif
#define WINLDAPAPI
#define LDAPAPI
#ifndef LDAP_UNICODE
#ifdef UNICODE
#define LDAP_UNICODE 1
#else
#define LDAP_UNICODE 0
#endif
#endif
#define LDAP_PORT 389
#define LDAP_SSL_PORT 636
#define LDAP_GC_PORT 3268
#define LDAP_SSL_GC_PORT 3269
#define LDAP_VERSION1 1
#define LDAP_VERSION2 2
#define LDAP_VERSION3 3
#define LDAP_VERSION LDAP_VERSION2
#define LDAP_BIND_CMD 96
#define LDAP_UNBIND_CMD 66
#define LDAP_SEARCH_CMD 99
#define LDAP_MODIFY_CMD 102
#define LDAP_ADD_CMD 104
#define LDAP_DELETE_CMD 74
#define LDAP_MODRDN_CMD 108
#define LDAP_COMPARE_CMD 110
#define LDAP_ABANDON_CMD 80
#define LDAP_SESSION_CMD 113
#define LDAP_EXTENDED_CMD 119
#define LDAP_RES_BIND 97
#define LDAP_RES_SEARCH_ENTRY 100
#define LDAP_RES_SEARCH_RESULT 101
#define LDAP_RES_MODIFY 103
#define LDAP_RES_ADD 105
#define LDAP_RES_DELETE 107
#define LDAP_RES_MODRDN 109
#define LDAP_RES_COMPARE 111
#define LDAP_RES_SESSION 114
#define LDAP_RES_REFERRAL 115
#define LDAP_RES_EXTENDED 120
#define LDAP_RES_ANY (-1L)
#define LDAP_INVALID_CMD 255
#define LDAP_INVALID_RES 255
typedef enum {
	LDAP_SUCCESS=0,
	LDAP_OPERATIONS_ERROR=1,
	LDAP_PROTOCOL_ERROR=2,
	LDAP_TIMELIMIT_EXCEEDED=3,
	LDAP_SIZELIMIT_EXCEEDED=4,
	LDAP_COMPARE_FALSE=5,
	LDAP_COMPARE_TRUE=6,
	LDAP_AUTH_METHOD_NOT_SUPPORTED=7,
	LDAP_STRONG_AUTH_REQUIRED=8,
	LDAP_REFERRAL_V2=9,
	LDAP_PARTIAL_RESULTS=9,
	LDAP_REFERRAL=10,
	LDAP_ADMIN_LIMIT_EXCEEDED=11,
	LDAP_UNAVAILABLE_CRIT_EXTENSION=12,
	LDAP_CONFIDENTIALITY_REQUIRED=13,
	LDAP_SASL_BIND_IN_PROGRESS=14,
	LDAP_NO_SUCH_ATTRIBUTE=16,
	LDAP_UNDEFINED_TYPE=17,
	LDAP_INAPPROPRIATE_MATCHING=18,
	LDAP_CONSTRAINT_VIOLATION=19,
	LDAP_ATTRIBUTE_OR_VALUE_EXISTS=20,
	LDAP_INVALID_SYNTAX=21,
	LDAP_NO_SUCH_OBJECT=32,
	LDAP_ALIAS_PROBLEM=33,
	LDAP_INVALID_DN_SYNTAX=34,
	LDAP_IS_LEAF=35,
	LDAP_ALIAS_DEREF_PROBLEM=36,
	LDAP_INAPPROPRIATE_AUTH=48,
	LDAP_INVALID_CREDENTIALS=49,
	LDAP_INSUFFICIENT_RIGHTS=50,
	LDAP_BUSY=51,
	LDAP_UNAVAILABLE=52,
	LDAP_UNWILLING_TO_PERFORM=53,
	LDAP_LOOP_DETECT=54,
	LDAP_SORT_CONTROL_MISSING=60,
	LDAP_OFFSET_RANGE_ERROR=61,
	LDAP_NAMING_VIOLATION=64,
	LDAP_OBJECT_CLASS_VIOLATION=65,
	LDAP_NOT_ALLOWED_ON_NONLEAF=66,
	LDAP_NOT_ALLOWED_ON_RDN=67,
	LDAP_ALREADY_EXISTS=68,
	LDAP_NO_OBJECT_CLASS_MODS=69,
	LDAP_RESULTS_TOO_LARGE=70,
	LDAP_AFFECTS_MULTIPLE_DSAS=71,
	LDAP_VIRTUAL_LIST_VIEW_ERROR=76,
	LDAP_OTHER=80,
	LDAP_SERVER_DOWN=81,
	LDAP_LOCAL_ERROR=82,
	LDAP_ENCODING_ERROR=83,
	LDAP_DECODING_ERROR=84,
	LDAP_TIMEOUT=85,
	LDAP_AUTH_UNKNOWN=86,
	LDAP_FILTER_ERROR=87,
	LDAP_USER_CANCELLED=88,
	LDAP_PARAM_ERROR=89,
	LDAP_NO_MEMORY=90,
	LDAP_CONNECT_ERROR=91,
	LDAP_NOT_SUPPORTED=92,
	LDAP_NO_RESULTS_RETURNED=94,
	LDAP_CONTROL_NOT_FOUND=93,
	LDAP_MORE_RESULTS_TO_RETURN=95,
	LDAP_CLIENT_LOOP=96,
	LDAP_REFERRAL_LIMIT_EXCEEDED=97
}
LDAP_RETCODE;
#define LDAP_AUTH_SIMPLE 128
#define LDAP_AUTH_SASL 131
#define LDAP_AUTH_OTHERKIND 134
#define LDAP_AUTH_SICILY (LDAP_AUTH_OTHERKIND | 512)
#define LDAP_AUTH_MSN (LDAP_AUTH_OTHERKIND | 2048)
#define LDAP_AUTH_NTLM (LDAP_AUTH_OTHERKIND | 4096)
#define LDAP_AUTH_DPA (LDAP_AUTH_OTHERKIND | 0x2000)
#define LDAP_AUTH_NEGOTIATE (LDAP_AUTH_OTHERKIND | 1024)
#define LDAP_AUTH_SSPI LDAP_AUTH_NEGOTIATE
#define LDAP_AUTH_DIGEST (LDAP_AUTH_OTHERKIND | 0x4000)
#define LDAP_AUTH_EXTERNAL (LDAP_AUTH_OTHERKIND | 32)
#define LDAP_FILTER_AND 160
#define LDAP_FILTER_OR 161
#define LDAP_FILTER_NOT 162
#define LDAP_FILTER_EQUALITY 163
#define LDAP_FILTER_SUBSTRINGS 164
#define LDAP_FILTER_GE 165
#define LDAP_FILTER_LE 166
#define LDAP_FILTER_PRESENT 135
#define LDAP_FILTER_APPROX 168
#define LDAP_FILTER_EXTENSIBLE 169
#define LDAP_SUBSTRING_INITIAL 128
#define LDAP_SUBSTRING_ANY 129
#define LDAP_SUBSTRING_FINAL 130
#define LDAP_DEREF_NEVER 0
#define LDAP_DEREF_SEARCHING 1
#define LDAP_DEREF_FINDING 2
#define LDAP_DEREF_ALWAYS 3
#define LDAP_NO_LIMIT 0
#define LDAP_OPT_DNS 1
#define LDAP_OPT_CHASE_REFERRALS 2
#define LDAP_OPT_RETURN_REFS 4
#if !defined(_WIN64)
#endif
typedef struct ldap {
	struct {
		UINT_PTR sb_sd;
		UCHAR Reserved1[(10*sizeof(ULONG))+1];
		ULONG_PTR sb_naddr;
		UCHAR Reserved2[(6*sizeof(ULONG))];
	}
	ld_sb;
	PCHAR ld_host;
	ULONG ld_version;
	UCHAR ld_lberoptions;
	ULONG ld_deref;
	ULONG ld_timelimit;
	ULONG ld_sizelimit;
	ULONG ld_errno;
	PCHAR ld_matched;
	PCHAR ld_error;
	ULONG ld_msgid;
	UCHAR Reserved3[(6*sizeof(ULONG))+1];
	ULONG ld_cldaptries;
	ULONG ld_cldaptimeout;
	ULONG ld_refhoplimit;
	ULONG ld_options;
}
LDAP,* PLDAP;
typedef struct l_timeval {
	LONG tv_sec;
	LONG tv_usec;
}
LDAP_TIMEVAL,* PLDAP_TIMEVAL;
typedef struct berval {
	ULONG bv_len;
	PCHAR bv_val;
}
LDAP_BERVAL,* PLDAP_BERVAL,BERVAL,* PBERVAL,BerValue;
typedef struct ldapmsg {
	ULONG lm_msgid;
	ULONG lm_msgtype;
	PVOID lm_ber;
	struct ldapmsg *lm_chain;
	struct ldapmsg *lm_next;
	ULONG lm_time;
	PLDAP Connection;
	PVOID Request;
	ULONG lm_returncode;
	USHORT lm_referral;
	BOOLEAN lm_chased;
	BOOLEAN lm_eom;
	BOOLEAN ConnectionReferenced;
}
LDAPMessage,*PLDAPMessage;
typedef struct ldapcontrolA {
	PCHAR ldctl_oid;
	struct berval ldctl_value;
	BOOLEAN ldctl_iscritical;
}
LDAPControlA,*PLDAPControlA;
typedef struct ldapcontrolW {
	PWCHAR ldctl_oid;
	struct berval ldctl_value;
	BOOLEAN ldctl_iscritical;
}
LDAPControlW,*PLDAPControlW;
#if LDAP_UNICODE
#define LDAPControl LDAPControlW
#define PLDAPControl PLDAPControlW
#else
#define LDAPControl LDAPControlA
#define PLDAPControl PLDAPControlA
#endif
#define LDAP_CONTROL_REFERRALS_W L"1.2.840.113556.1.4.616"
#define LDAP_CONTROL_REFERRALS "1.2.840.113556.1.4.616"
#define LDAP_MOD_ADD 0
#define LDAP_MOD_DELETE 1
#define LDAP_MOD_REPLACE 2
#define LDAP_MOD_BVALUES 128
typedef struct ldapmodW {
	ULONG mod_op;
	PWCHAR mod_type;
	union {
		PWCHAR *modv_strvals;
		struct berval **modv_bvals;
	}
	mod_vals;
}
LDAPModW,*PLDAPModW;
typedef struct ldapmodA {
	ULONG mod_op;
	PCHAR mod_type;
	union {
		PCHAR *modv_strvals;
		struct berval **modv_bvals;
	}
	mod_vals;
}
LDAPModA,*PLDAPModA;
#if LDAP_UNICODE
#define LDAPMod LDAPModW
#define PLDAPMod PLDAPModW
#else
#define LDAPMod LDAPModA
#define PLDAPMod PLDAPModA
#endif
#if !defined(_WIN64)
#endif
#define LDAP_IS_CLDAP(ld) ((ld)->ld_sb.sb_naddr > 0)
#define mod_values mod_vals.modv_strvals
#define mod_bvalues mod_vals.modv_bvals
#define NAME_ERROR(n) ((n & 240)== 32)
WINLDAPAPI LDAP * LDAPAPI ldap_openW(const WCHAR * ,ULONG );
WINLDAPAPI LDAP * LDAPAPI ldap_openA(const PCHAR ,ULONG );
WINLDAPAPI LDAP * LDAPAPI ldap_initW(const WCHAR *,ULONG );
WINLDAPAPI LDAP * LDAPAPI ldap_initA(const PCHAR ,ULONG );
WINLDAPAPI LDAP * LDAPAPI ldap_sslinitW(PWCHAR ,ULONG ,int );
WINLDAPAPI LDAP * LDAPAPI ldap_sslinitA(PCHAR ,ULONG ,int );
WINLDAPAPI ULONG LDAPAPI ldap_connect(LDAP *,struct l_timeval *timeout );
#if LDAP_UNICODE
#define ldap_open ldap_openW
#define ldap_init ldap_initW
#define ldap_sslinit ldap_sslinitW
#else
WINLDAPAPI LDAP * LDAPAPI ldap_open(PCHAR ,ULONG );
WINLDAPAPI LDAP * LDAPAPI ldap_init(PCHAR ,ULONG );
WINLDAPAPI LDAP * LDAPAPI ldap_sslinit(PCHAR ,ULONG ,int );
#endif
WINLDAPAPI LDAP * LDAPAPI cldap_openW(PWCHAR ,ULONG );
WINLDAPAPI LDAP * LDAPAPI cldap_openA(PCHAR ,ULONG );
#if LDAP_UNICODE
#define cldap_open cldap_openW
#else
WINLDAPAPI LDAP * LDAPAPI cldap_open(PCHAR ,ULONG );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_unbind(LDAP *);
WINLDAPAPI ULONG LDAPAPI ldap_unbind_s(LDAP *);
WINLDAPAPI ULONG LDAPAPI ldap_get_option(LDAP *,int ,void *);
WINLDAPAPI ULONG LDAPAPI ldap_get_optionW(LDAP *,int ,void *);
WINLDAPAPI ULONG LDAPAPI ldap_set_option(LDAP *,int ,const void *);
WINLDAPAPI ULONG LDAPAPI ldap_set_optionW(LDAP *,int ,const void *);
#if LDAP_UNICODE
#define ldap_get_option ldap_get_optionW
#define ldap_set_option ldap_set_optionW
#endif
#define LDAP_OPT_API_INFO 0
#define LDAP_OPT_DESC 1
#define LDAP_OPT_DEREF 2
#define LDAP_OPT_SIZELIMIT 3
#define LDAP_OPT_TIMELIMIT 4
#define LDAP_OPT_THREAD_FN_PTRS 5
#define LDAP_OPT_REBIND_FN 6
#define LDAP_OPT_REBIND_ARG 7
#define LDAP_OPT_REFERRALS 8
#define LDAP_OPT_RESTART 9
#define LDAP_OPT_SSL 10
#define LDAP_OPT_IO_FN_PTRS 11
#define LDAP_OPT_CACHE_FN_PTRS 13
#define LDAP_OPT_CACHE_STRATEGY 14
#define LDAP_OPT_CACHE_ENABLE 15
#define LDAP_OPT_REFERRAL_HOP_LIMIT 16
#define LDAP_OPT_PROTOCOL_VERSION 17
#define LDAP_OPT_VERSION 17
#define LDAP_OPT_API_FEATURE_INFO 21
#define LDAP_OPT_HOST_NAME 48
#define LDAP_OPT_ERROR_NUMBER 49
#define LDAP_OPT_ERROR_STRING 50
#define LDAP_OPT_SERVER_ERROR 51
#define LDAP_OPT_SERVER_EXT_ERROR 52
#define LDAP_OPT_HOST_REACHABLE 62
#define LDAP_OPT_PING_KEEP_ALIVE 54
#define LDAP_OPT_PING_WAIT_TIME 55
#define LDAP_OPT_PING_LIMIT 56
#define LDAP_OPT_DNSDOMAIN_NAME 59
#define LDAP_OPT_GETDSNAME_FLAGS 61
#define LDAP_OPT_PROMPT_CREDENTIALS 63
#define LDAP_OPT_AUTO_RECONNECT 145
#define LDAP_OPT_SSPI_FLAGS 146
#define LDAP_OPT_SSL_INFO 147
#define LDAP_OPT_TLS LDAP_OPT_SSL
#define LDAP_OPT_TLS_INFO LDAP_OPT_SSL_INFO
#define LDAP_OPT_SIGN 149
#define LDAP_OPT_ENCRYPT 150
#define LDAP_OPT_SASL_METHOD 151
#define LDAP_OPT_AREC_EXCLUSIVE 152
#define LDAP_OPT_SECURITY_CONTEXT 153
#define LDAP_OPT_ROOTDSE_CACHE 154
#define LDAP_OPT_TCP_KEEPALIVE 64
#define LDAP_OPT_FAST_CONCURRENT_BIND 65
#define LDAP_OPT_SEND_TIMEOUT 66
#define LDAP_OPT_ON ((void *) 1)
#define LDAP_OPT_OFF ((void *) 0)
#define LDAP_CHASE_SUBORDINATE_REFERRALS 32
#define LDAP_CHASE_EXTERNAL_REFERRALS 64
WINLDAPAPI ULONG LDAPAPI ldap_simple_bindW(LDAP *,PWCHAR ,PWCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_simple_bindA(LDAP *,PCHAR ,PCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_simple_bind_sW(LDAP *,PWCHAR ,PWCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_simple_bind_sA(LDAP *,PCHAR ,PCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_bindW(LDAP *,PWCHAR ,PWCHAR ,ULONG );
WINLDAPAPI ULONG LDAPAPI ldap_bindA(LDAP *,PCHAR ,PCHAR ,ULONG );
WINLDAPAPI ULONG LDAPAPI ldap_bind_sW(LDAP *,PWCHAR ,PWCHAR ,ULONG );
WINLDAPAPI ULONG LDAPAPI ldap_bind_sA(LDAP *,PCHAR ,PCHAR ,ULONG );
WINLDAPAPI INT LDAPAPI ldap_sasl_bindA(LDAP *, const PCHAR DistName, const PCHAR AuthMechanism, const BERVAL *cred,PLDAPControlA *,PLDAPControlA *,int *MessageNumber );
WINLDAPAPI INT LDAPAPI ldap_sasl_bindW(LDAP *, const PWCHAR DistName, const PWCHAR AuthMechanism, const BERVAL *cred,PLDAPControlW *,PLDAPControlW *,int *MessageNumber );
WINLDAPAPI INT LDAPAPI ldap_sasl_bind_sA(LDAP *, const PCHAR DistName, const PCHAR AuthMechanism, const BERVAL *cred,PLDAPControlA *,PLDAPControlA *,PBERVAL *ServerData );
WINLDAPAPI INT LDAPAPI ldap_sasl_bind_sW(LDAP *, const PWCHAR DistName, const PWCHAR AuthMechanism, const BERVAL *cred,PLDAPControlW *,PLDAPControlW *,PBERVAL *ServerData );
#if LDAP_UNICODE
#define ldap_simple_bind ldap_simple_bindW
#define ldap_simple_bind_s ldap_simple_bind_sW
#define ldap_bind ldap_bindW
#define ldap_bind_s ldap_bind_sW
#define ldap_sasl_bind ldap_sasl_bindW
#define ldap_sasl_bind_s ldap_sasl_bind_sW
#else
WINLDAPAPI ULONG LDAPAPI ldap_simple_bind(LDAP *,const PCHAR ,const PCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_simple_bind_s(LDAP *,const PCHAR ,const PCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_bind(LDAP *,const PCHAR ,const PCHAR ,ULONG );
WINLDAPAPI ULONG LDAPAPI ldap_bind_s(LDAP *,const PCHAR ,const PCHAR ,ULONG );
#define ldap_sasl_bind ldap_sasl_bindA
#define ldap_sasl_bind_s ldap_sasl_bind_sA
#endif
#define LDAP_SCOPE_BASE 0
#define LDAP_SCOPE_ONELEVEL 1
#define LDAP_SCOPE_SUBTREE 2
WINLDAPAPI ULONG LDAPAPI ldap_searchW(LDAP *, const PWCHAR base,ULONG , const PWCHAR filter,PWCHAR attrs[],ULONG attrsonly  );
WINLDAPAPI ULONG LDAPAPI ldap_searchA(LDAP *, const PCHAR base,ULONG , const PCHAR filter,PCHAR attrs[],ULONG attrsonly  );
WINLDAPAPI ULONG LDAPAPI ldap_search_sW(LDAP *, const PWCHAR base,ULONG , const PWCHAR filter,PWCHAR attrs[],ULONG ,LDAPMessage **res );
WINLDAPAPI ULONG LDAPAPI ldap_search_sA(LDAP *, const PCHAR base,ULONG , const PCHAR filter,PCHAR attrs[],ULONG ,LDAPMessage **res );
WINLDAPAPI ULONG LDAPAPI ldap_search_stW(LDAP *, const PWCHAR base,ULONG , const PWCHAR filter,PWCHAR attrs[],ULONG ,struct l_timeval *timeout,LDAPMessage **res );
WINLDAPAPI ULONG LDAPAPI ldap_search_stA(LDAP *, const PCHAR base,ULONG , const PCHAR filter,PCHAR attrs[],ULONG ,struct l_timeval *timeout,LDAPMessage **res );
WINLDAPAPI ULONG LDAPAPI ldap_search_extW(LDAP *, const PWCHAR base,ULONG , const PWCHAR filter,PWCHAR attrs[],ULONG ,PLDAPControlW *,PLDAPControlW *,ULONG ,ULONG ,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_search_extA(LDAP *, const PCHAR base,ULONG , const PCHAR filter,PCHAR attrs[],ULONG ,PLDAPControlA *,PLDAPControlA *,ULONG ,ULONG ,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_search_ext_sW(LDAP *, const PWCHAR base,ULONG , const PWCHAR filter,PWCHAR attrs[],ULONG ,PLDAPControlW *,PLDAPControlW *,struct l_timeval *timeout,ULONG ,LDAPMessage **res );
WINLDAPAPI ULONG LDAPAPI ldap_search_ext_sA(LDAP *, const PCHAR base,ULONG , const PCHAR filter,PCHAR attrs[],ULONG ,PLDAPControlA *,PLDAPControlA *,struct l_timeval *timeout,ULONG ,LDAPMessage **res );
#if LDAP_UNICODE
#define ldap_search ldap_searchW
#define ldap_search_s ldap_search_sW
#define ldap_search_st ldap_search_stW
#define ldap_search_ext ldap_search_extW
#define ldap_search_ext_s ldap_search_ext_sW
#else
WINLDAPAPI ULONG LDAPAPI ldap_search(LDAP *,PCHAR ,ULONG ,PCHAR ,PCHAR attrs[],ULONG attrsonly  );
WINLDAPAPI ULONG LDAPAPI ldap_search_s(LDAP *,PCHAR ,ULONG ,PCHAR ,PCHAR attrs[],ULONG ,LDAPMessage **res );
WINLDAPAPI ULONG LDAPAPI ldap_search_st(LDAP *,PCHAR ,ULONG ,PCHAR ,PCHAR attrs[],ULONG ,struct l_timeval *timeout,LDAPMessage **res );
WINLDAPAPI ULONG LDAPAPI ldap_search_ext(LDAP *,PCHAR ,ULONG ,PCHAR ,PCHAR attrs[],ULONG ,PLDAPControlA *,PLDAPControlA *,ULONG ,ULONG ,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_search_ext_s(LDAP *,PCHAR ,ULONG ,PCHAR ,PCHAR attrs[],ULONG ,PLDAPControlA *,PLDAPControlA *,struct l_timeval *timeout,ULONG ,LDAPMessage **res );
#endif
WINLDAPAPI ULONG LDAPAPI
ldap_check_filterW(LDAP *,PWCHAR SearchFilter );
WINLDAPAPI ULONG LDAPAPI
ldap_check_filterA(LDAP *,PCHAR SearchFilter );
#if LDAP_UNICODE
#define ldap_check_filter ldap_check_filterW
#else
#define ldap_check_filter ldap_check_filterA
#endif
WINLDAPAPI ULONG LDAPAPI ldap_modifyW(LDAP *,PWCHAR ,LDAPModW *mods[]);
WINLDAPAPI ULONG LDAPAPI ldap_modifyA(LDAP *,PCHAR ,LDAPModA *mods[]);
WINLDAPAPI ULONG LDAPAPI ldap_modify_sW(LDAP *,PWCHAR ,LDAPModW *mods[]);
WINLDAPAPI ULONG LDAPAPI ldap_modify_sA(LDAP *,PCHAR ,LDAPModA *mods[]);
WINLDAPAPI ULONG LDAPAPI ldap_modify_extW(LDAP *, const PWCHAR dn,LDAPModW *mods[],PLDAPControlW *,PLDAPControlW *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_modify_extA(LDAP *, const PCHAR dn,LDAPModA *mods[],PLDAPControlA *,PLDAPControlA *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_modify_ext_sW(LDAP *, const PWCHAR dn,LDAPModW *mods[],PLDAPControlW *,PLDAPControlW *ClientControls );
WINLDAPAPI ULONG LDAPAPI ldap_modify_ext_sA(LDAP *, const PCHAR dn,LDAPModA *mods[],PLDAPControlA *,PLDAPControlA *ClientControls );
#if LDAP_UNICODE
#define ldap_modify ldap_modifyW
#define ldap_modify_s ldap_modify_sW
#define ldap_modify_ext ldap_modify_extW
#define ldap_modify_ext_s ldap_modify_ext_sW
#else
WINLDAPAPI ULONG LDAPAPI ldap_modify(LDAP *,PCHAR ,LDAPModA *mods[]);
WINLDAPAPI ULONG LDAPAPI ldap_modify_s(LDAP *,PCHAR ,LDAPModA *mods[]);
WINLDAPAPI ULONG LDAPAPI ldap_modify_ext(LDAP *, const PCHAR dn,LDAPModA *mods[],PLDAPControlA *,PLDAPControlA *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_modify_ext_s(LDAP *, const PCHAR dn,LDAPModA *mods[],PLDAPControlA *,PLDAPControlA *ClientControls );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_modrdn2W (LDAP *, const PWCHAR DistinguishedName, const PWCHAR NewDistinguishedName,INT DeleteOldRdn );
WINLDAPAPI ULONG LDAPAPI ldap_modrdn2A (LDAP *, const PCHAR DistinguishedName, const PCHAR NewDistinguishedName,INT DeleteOldRdn );
WINLDAPAPI ULONG LDAPAPI ldap_modrdnW (LDAP *, const PWCHAR DistinguishedName, const PWCHAR NewDistinguishedName );
WINLDAPAPI ULONG LDAPAPI ldap_modrdnA (LDAP *, const PCHAR DistinguishedName, const PCHAR NewDistinguishedName );
WINLDAPAPI ULONG LDAPAPI ldap_modrdn2_sW (LDAP *, const PWCHAR DistinguishedName, const PWCHAR NewDistinguishedName,INT DeleteOldRdn );
WINLDAPAPI ULONG LDAPAPI ldap_modrdn2_sA (LDAP *, const PCHAR DistinguishedName, const PCHAR NewDistinguishedName,INT DeleteOldRdn );
WINLDAPAPI ULONG LDAPAPI ldap_modrdn_sW (LDAP *, const PWCHAR DistinguishedName, const PWCHAR NewDistinguishedName );
WINLDAPAPI ULONG LDAPAPI ldap_modrdn_sA (LDAP *, const PCHAR DistinguishedName, const PCHAR NewDistinguishedName );
#if LDAP_UNICODE
#define ldap_modrdn2 ldap_modrdn2W
#define ldap_modrdn ldap_modrdnW
#define ldap_modrdn2_s ldap_modrdn2_sW
#define ldap_modrdn_s ldap_modrdn_sW
#else
WINLDAPAPI ULONG LDAPAPI ldap_modrdn2 (LDAP *, const PCHAR DistinguishedName, const PCHAR NewDistinguishedName,INT DeleteOldRdn );
WINLDAPAPI ULONG LDAPAPI ldap_modrdn (LDAP *, const PCHAR DistinguishedName, const PCHAR NewDistinguishedName );
WINLDAPAPI ULONG LDAPAPI ldap_modrdn2_s (LDAP *, const PCHAR DistinguishedName, const PCHAR NewDistinguishedName,INT DeleteOldRdn );
WINLDAPAPI ULONG LDAPAPI ldap_modrdn_s (LDAP *, const PCHAR DistinguishedName, const PCHAR NewDistinguishedName );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_rename_extW(LDAP *, const PWCHAR dn, const PWCHAR NewRDN, const PWCHAR NewParent,INT ,PLDAPControlW *,PLDAPControlW *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_rename_extA(LDAP *, const PCHAR dn, const PCHAR NewRDN, const PCHAR NewParent,INT ,PLDAPControlA *,PLDAPControlA *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_rename_ext_sW(LDAP *, const PWCHAR dn, const PWCHAR NewRDN, const PWCHAR NewParent,INT ,PLDAPControlW *,PLDAPControlW *ClientControls );
WINLDAPAPI ULONG LDAPAPI ldap_rename_ext_sA(LDAP *, const PCHAR dn, const PCHAR NewRDN, const PCHAR NewParent,INT ,PLDAPControlA *,PLDAPControlA *ClientControls );
#if LDAP_UNICODE
#define ldap_rename ldap_rename_extW
#define ldap_rename_s ldap_rename_ext_sW
#else
#define ldap_rename ldap_rename_extA
#define ldap_rename_s ldap_rename_ext_sA
#endif
#if LDAP_UNICODE
#define ldap_rename_ext ldap_rename_extW
#define ldap_rename_ext_s ldap_rename_ext_sW
#else
WINLDAPAPI ULONG LDAPAPI ldap_rename_ext(LDAP *, const PCHAR dn, const PCHAR NewRDN, const PCHAR NewParent,INT ,PLDAPControlA *,PLDAPControlA *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_rename_ext_s(LDAP *, const PCHAR dn, const PCHAR NewRDN, const PCHAR NewParent,INT ,PLDAPControlA *,PLDAPControlA *ClientControls );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_addW(LDAP *,PWCHAR ,LDAPModW *attrs[]);
WINLDAPAPI ULONG LDAPAPI ldap_addA(LDAP *,PCHAR ,LDAPModA *attrs[]);
WINLDAPAPI ULONG LDAPAPI ldap_add_sW(LDAP *,PWCHAR ,LDAPModW *attrs[]);
WINLDAPAPI ULONG LDAPAPI ldap_add_sA(LDAP *,PCHAR ,LDAPModA *attrs[]);
WINLDAPAPI ULONG LDAPAPI ldap_add_extW(LDAP *, const PWCHAR dn,LDAPModW *attrs[],PLDAPControlW *,PLDAPControlW *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_add_extA(LDAP *, const PCHAR dn,LDAPModA *attrs[],PLDAPControlA *,PLDAPControlA *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_add_ext_sW(LDAP *, const PWCHAR dn,LDAPModW *attrs[],PLDAPControlW *,PLDAPControlW *ClientControls );
WINLDAPAPI ULONG LDAPAPI ldap_add_ext_sA(LDAP *, const PCHAR dn,LDAPModA *attrs[],PLDAPControlA *,PLDAPControlA *ClientControls );
#if LDAP_UNICODE
#define ldap_add ldap_addW
#define ldap_add_s ldap_add_sW
#define ldap_add_ext ldap_add_extW
#define ldap_add_ext_s ldap_add_ext_sW
#else
WINLDAPAPI ULONG LDAPAPI ldap_add(LDAP *,PCHAR ,LDAPMod *attrs[]);
WINLDAPAPI ULONG LDAPAPI ldap_add_s(LDAP *,PCHAR ,LDAPMod *attrs[]);
WINLDAPAPI ULONG LDAPAPI ldap_add_ext(LDAP *, const PCHAR dn,LDAPModA *attrs[],PLDAPControlA *,PLDAPControlA *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_add_ext_s(LDAP *, const PCHAR dn,LDAPModA *attrs[],PLDAPControlA *,PLDAPControlA *ClientControls );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_compareW(LDAP *,const PWCHAR ,const PWCHAR ,PWCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_compareA(LDAP *,const PCHAR ,const PCHAR ,PCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_compare_sW(LDAP *,const PWCHAR ,const PWCHAR ,PWCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_compare_sA(LDAP *,const PCHAR ,const PCHAR ,PCHAR );
#if LDAP_UNICODE
#define ldap_compare ldap_compareW
#define ldap_compare_s ldap_compare_sW
#else
WINLDAPAPI ULONG LDAPAPI ldap_compare(LDAP *,const PCHAR ,const PCHAR ,PCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_compare_s(LDAP *,const PCHAR ,const PCHAR ,PCHAR );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_compare_extW(LDAP *, const PWCHAR dn, const PWCHAR Attr, const PWCHAR Value,struct berval *Data,PLDAPControlW *,PLDAPControlW *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_compare_extA(LDAP *, const PCHAR dn, const PCHAR Attr, const PCHAR Value,struct berval *Data,PLDAPControlA *,PLDAPControlA *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_compare_ext_sW(LDAP *, const PWCHAR dn, const PWCHAR Attr, const PWCHAR Value,struct berval *Data,PLDAPControlW *,PLDAPControlW *ClientControls );
WINLDAPAPI ULONG LDAPAPI ldap_compare_ext_sA(LDAP *, const PCHAR dn, const PCHAR Attr, const PCHAR Value,struct berval *Data,PLDAPControlA *,PLDAPControlA *ClientControls );
#if LDAP_UNICODE
#define ldap_compare_ext ldap_compare_extW
#define ldap_compare_ext_s ldap_compare_ext_sW
#else
WINLDAPAPI ULONG LDAPAPI ldap_compare_ext(LDAP *, const PCHAR dn, const PCHAR Attr, const PCHAR Value,struct berval *Data,PLDAPControlA *,PLDAPControlA *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_compare_ext_s(LDAP *, const PCHAR dn, const PCHAR Attr, const PCHAR Value,struct berval *Data,PLDAPControlA *,PLDAPControlA *ClientControls );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_deleteW(LDAP *,const PWCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_deleteA(LDAP *,const PCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_delete_sW(LDAP *,const PWCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_delete_sA(LDAP *,const PCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_delete_extW(LDAP *, const PWCHAR dn,PLDAPControlW *,PLDAPControlW *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_delete_extA(LDAP *, const PCHAR dn,PLDAPControlA *,PLDAPControlA *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_delete_ext_sW(LDAP *, const PWCHAR dn,PLDAPControlW *,PLDAPControlW *ClientControls );
WINLDAPAPI ULONG LDAPAPI ldap_delete_ext_sA(LDAP *, const PCHAR dn,PLDAPControlA *,PLDAPControlA *ClientControls );
#if LDAP_UNICODE
#define ldap_delete ldap_deleteW
#define ldap_delete_ext ldap_delete_extW
#define ldap_delete_s ldap_delete_sW
#define ldap_delete_ext_s ldap_delete_ext_sW
#else
WINLDAPAPI ULONG LDAPAPI ldap_delete(LDAP *,PCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_delete_s(LDAP *,PCHAR );
WINLDAPAPI ULONG LDAPAPI ldap_delete_ext(LDAP *, const PCHAR dn,PLDAPControlA *,PLDAPControlA *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_delete_ext_s(LDAP *, const PCHAR dn,PLDAPControlA *,PLDAPControlA *ClientControls );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_abandon(LDAP *,ULONG );
#define LDAP_MSG_ONE 0
#define LDAP_MSG_ALL 1
#define LDAP_MSG_RECEIVED 2
WINLDAPAPI ULONG LDAPAPI ldap_result(LDAP *,ULONG ,ULONG ,struct l_timeval *timeout,LDAPMessage **res );
WINLDAPAPI ULONG LDAPAPI ldap_msgfree(LDAPMessage *);
WINLDAPAPI ULONG LDAPAPI ldap_result2error(LDAP *,LDAPMessage *,ULONG freeit  );
WINLDAPAPI ULONG LDAPAPI ldap_parse_resultW (LDAP *,LDAPMessage *,ULONG *,PWCHAR *,PWCHAR *,PWCHAR **,PLDAPControlW **,BOOLEAN Freeit );
WINLDAPAPI ULONG LDAPAPI ldap_parse_resultA (LDAP *,LDAPMessage *,ULONG *,PCHAR *,PCHAR *,PCHAR **,PLDAPControlA **,BOOLEAN Freeit );
WINLDAPAPI ULONG LDAPAPI ldap_parse_extended_resultA (LDAP *,LDAPMessage *,PCHAR *,struct berval **ResultData,BOOLEAN Freeit  );
WINLDAPAPI ULONG LDAPAPI ldap_parse_extended_resultW (LDAP *,LDAPMessage *,PWCHAR *,struct berval **ResultData,BOOLEAN Freeit  );
WINLDAPAPI ULONG LDAPAPI ldap_controls_freeA (LDAPControlA **Controls );
WINLDAPAPI ULONG LDAPAPI ldap_control_freeA (LDAPControlA *Controls );
WINLDAPAPI ULONG LDAPAPI ldap_controls_freeW (LDAPControlW **Control );
WINLDAPAPI ULONG LDAPAPI ldap_control_freeW (LDAPControlW *Control );
WINLDAPAPI ULONG LDAPAPI ldap_free_controlsW (LDAPControlW **Controls );
WINLDAPAPI ULONG LDAPAPI ldap_free_controlsA (LDAPControlA **Controls );
#if LDAP_UNICODE
#define ldap_parse_result ldap_parse_resultW
#define ldap_controls_free ldap_controls_freeW
#define ldap_control_free ldap_control_freeW
#define ldap_free_controls ldap_free_controlsW
#define ldap_parse_extended_result ldap_parse_extended_resultW
#else
#define ldap_parse_extended_result ldap_parse_extended_resultA
WINLDAPAPI ULONG LDAPAPI ldap_parse_result (LDAP *,LDAPMessage *,ULONG *,PCHAR *,PCHAR *,PCHAR **,PLDAPControlA **,BOOLEAN Freeit );
WINLDAPAPI ULONG LDAPAPI ldap_controls_free (LDAPControlA **Controls );
WINLDAPAPI ULONG LDAPAPI ldap_control_free (LDAPControlA *Control );
WINLDAPAPI ULONG LDAPAPI ldap_free_controls (LDAPControlA **Controls );
#endif
WINLDAPAPI PWCHAR LDAPAPI ldap_err2stringW(ULONG );
WINLDAPAPI PCHAR LDAPAPI ldap_err2stringA(ULONG );
#if LDAP_UNICODE
#define ldap_err2string ldap_err2stringW
#else
WINLDAPAPI PCHAR LDAPAPI ldap_err2string(ULONG );
#endif
WINLDAPAPI void LDAPAPI ldap_perror(LDAP *,const PCHAR );
WINLDAPAPI LDAPMessage *LDAPAPI ldap_first_entry(LDAP *,LDAPMessage *);
WINLDAPAPI LDAPMessage *LDAPAPI ldap_next_entry(LDAP *,LDAPMessage *);
WINLDAPAPI ULONG LDAPAPI ldap_count_entries(LDAP *,LDAPMessage *);
typedef struct berelement {
	PCHAR opaque;
}
BerElement;
#define NULLBER ((BerElement *) 0)
WINLDAPAPI PWCHAR LDAPAPI ldap_first_attributeW(LDAP *,LDAPMessage *,BerElement **ptr );
WINLDAPAPI PCHAR LDAPAPI ldap_first_attributeA(LDAP *,LDAPMessage *,BerElement **ptr );
#if LDAP_UNICODE
#define ldap_first_attribute ldap_first_attributeW
#else
WINLDAPAPI PCHAR LDAPAPI ldap_first_attribute(LDAP *,LDAPMessage *,BerElement **ptr );
#endif
WINLDAPAPI PWCHAR LDAPAPI ldap_next_attributeW(LDAP *,LDAPMessage *,BerElement *ptr );
WINLDAPAPI PCHAR LDAPAPI ldap_next_attributeA(LDAP *,LDAPMessage *,BerElement *ptr );
#if LDAP_UNICODE
#define ldap_next_attribute ldap_next_attributeW
#else
WINLDAPAPI PCHAR LDAPAPI ldap_next_attribute(LDAP *,LDAPMessage *,BerElement *ptr );
#endif
WINLDAPAPI PWCHAR *LDAPAPI ldap_get_valuesW(LDAP *,LDAPMessage *, const PWCHAR attr );
WINLDAPAPI PCHAR *LDAPAPI ldap_get_valuesA(LDAP *,LDAPMessage *, const PCHAR attr );
#if LDAP_UNICODE
#define ldap_get_values ldap_get_valuesW
#else
WINLDAPAPI PCHAR *LDAPAPI ldap_get_values(LDAP *,LDAPMessage *, const PCHAR attr );
#endif
WINLDAPAPI struct berval **LDAPAPI ldap_get_values_lenW (LDAP *,LDAPMessage *, const PWCHAR attr );
WINLDAPAPI struct berval **LDAPAPI ldap_get_values_lenA (LDAP *,LDAPMessage *, const PCHAR attr );
#if LDAP_UNICODE
#define ldap_get_values_len ldap_get_values_lenW
#else
WINLDAPAPI struct berval **LDAPAPI ldap_get_values_len (LDAP *,LDAPMessage *, const PCHAR attr );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_count_valuesW(PWCHAR *);
WINLDAPAPI ULONG LDAPAPI ldap_count_valuesA(PCHAR *);
#if LDAP_UNICODE
#define ldap_count_values ldap_count_valuesW
#else
WINLDAPAPI ULONG LDAPAPI ldap_count_values(PCHAR *);
#endif
WINLDAPAPI ULONG LDAPAPI ldap_count_values_len(struct berval **vals);
WINLDAPAPI ULONG LDAPAPI ldap_value_freeW(PWCHAR *);
WINLDAPAPI ULONG LDAPAPI ldap_value_freeA(PCHAR *);
#if LDAP_UNICODE
#define ldap_value_free ldap_value_freeW
#else
WINLDAPAPI ULONG LDAPAPI ldap_value_free(PCHAR *);
#endif
WINLDAPAPI ULONG LDAPAPI ldap_value_free_len(struct berval **vals);
WINLDAPAPI PWCHAR LDAPAPI ldap_get_dnW(LDAP *,LDAPMessage *);
WINLDAPAPI PCHAR LDAPAPI ldap_get_dnA(LDAP *,LDAPMessage *);
#if LDAP_UNICODE
#define ldap_get_dn ldap_get_dnW
#else
WINLDAPAPI PCHAR LDAPAPI ldap_get_dn(LDAP *,LDAPMessage *);
#endif
WINLDAPAPI PWCHAR *LDAPAPI ldap_explode_dnW(const PWCHAR ,ULONG );
WINLDAPAPI PCHAR *LDAPAPI ldap_explode_dnA(const PCHAR ,ULONG );
#if LDAP_UNICODE
#define ldap_explode_dn ldap_explode_dnW
#else
WINLDAPAPI PCHAR *LDAPAPI ldap_explode_dn(const PCHAR ,ULONG );
#endif
WINLDAPAPI PWCHAR LDAPAPI ldap_dn2ufnW(const PWCHAR );
WINLDAPAPI PCHAR LDAPAPI ldap_dn2ufnA(const PCHAR );
#if LDAP_UNICODE
#define ldap_dn2ufn ldap_dn2ufnW
#else
WINLDAPAPI PCHAR LDAPAPI ldap_dn2ufn(const PCHAR );
#endif
WINLDAPAPI VOID LDAPAPI ldap_memfreeW(PWCHAR );
WINLDAPAPI VOID LDAPAPI ldap_memfreeA(PCHAR );
WINLDAPAPI VOID LDAPAPI ber_bvfree(struct berval *bv);
#if LDAP_UNICODE
#define ldap_memfree ldap_memfreeW
#else
WINLDAPAPI VOID LDAPAPI ldap_memfree(PCHAR );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_ufn2dnW (const PWCHAR ,PWCHAR *pDn );
WINLDAPAPI ULONG LDAPAPI ldap_ufn2dnA (const PCHAR ,PCHAR *pDn );
#if LDAP_UNICODE
#define ldap_ufn2dn ldap_ufn2dnW
#else
WINLDAPAPI ULONG LDAPAPI ldap_ufn2dn (const PCHAR ,PCHAR *pDn );
#endif
#define LBER_USE_DER 1
#define LBER_USE_INDEFINITE_LEN 2
#define LBER_TRANSLATE_STRINGS 4
#define LAPI_MAJOR_VER1 1
#define LAPI_MINOR_VER1 1
typedef struct ldap_version_info {
	ULONG lv_size;
	ULONG lv_major;
	ULONG lv_minor;
} LDAP_VERSION_INFO,*PLDAP_VERSION_INFO;
WINLDAPAPI ULONG LDAPAPI ldap_startup (PLDAP_VERSION_INFO ,HANDLE *Instance );
#define LDAP_API_INFO_VERSION 1
#define LDAP_API_VERSION 2004
#define LDAP_VERSION_MIN 2
#define LDAP_VERSION_MAX 3
#define LDAP_VENDOR_NAME "Microsoft Corporation."
#define LDAP_VENDOR_NAME_W L"Microsoft Corporation."
#define LDAP_VENDOR_VERSION 510
typedef struct ldapapiinfoA {
	int ldapai_info_version;
	int ldapai_api_version;
	int ldapai_protocol_version;
	char **ldapai_extensions;
	char *ldapai_vendor_name;
	int ldapai_vendor_version;
} LDAPAPIInfoA;
typedef struct ldapapiinfoW {
	int ldapai_info_version;
	int ldapai_api_version;
	int ldapai_protocol_version;
	PWCHAR *ldapai_extensions;
	PWCHAR ldapai_vendor_name;
	int ldapai_vendor_version;
} LDAPAPIInfoW;
#define LDAP_FEATURE_INFO_VERSION 1
typedef struct ldap_apifeature_infoA {
	int ldapaif_info_version;
	char *ldapaif_name;
	int ldapaif_version;
} LDAPAPIFeatureInfoA;
typedef struct ldap_apifeature_infoW {
	int ldapaif_info_version;
	PWCHAR ldapaif_name;
	int ldapaif_version;
} LDAPAPIFeatureInfoW;
#if LDAP_UNICODE
#define LDAPAPIInfo LDAPAPIInfoW
#define LDAPAPIFeatureInfo LDAPAPIFeatureInfoW
#else
#define LDAPAPIInfo LDAPAPIInfoA
#define LDAPAPIFeatureInfo LDAPAPIFeatureInfoA
#endif
WINLDAPAPI ULONG LDAPAPI ldap_cleanup (HANDLE hInstance );
WINLDAPAPI ULONG LDAPAPI ldap_escape_filter_elementW (PCHAR ,ULONG ,PWCHAR ,ULONG destLength );
WINLDAPAPI ULONG LDAPAPI ldap_escape_filter_elementA (PCHAR ,ULONG ,PCHAR ,ULONG destLength );
#if LDAP_UNICODE
#define ldap_escape_filter_element ldap_escape_filter_elementW
#else
WINLDAPAPI ULONG LDAPAPI ldap_escape_filter_element (PCHAR ,ULONG ,PCHAR ,ULONG destLength );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_set_dbg_flags(ULONG );
typedef ULONG (_cdecl *DBGPRINT)(PCH ,...);
WINLDAPAPI VOID LDAPAPI ldap_set_dbg_routine(DBGPRINT );
WINLDAPAPI int LDAPAPI
LdapUTF8ToUnicode(LPCSTR ,int ,LPWSTR ,int cchDest );
WINLDAPAPI int LDAPAPI
LdapUnicodeToUTF8(LPCWSTR ,int ,LPSTR ,int cchDest );
#define LDAP_SERVER_SORT_OID "1.2.840.113556.1.4.473"
#define LDAP_SERVER_SORT_OID_W L"1.2.840.113556.1.4.473"
#define LDAP_SERVER_RESP_SORT_OID "1.2.840.113556.1.4.474"
#define LDAP_SERVER_RESP_SORT_OID_W L"1.2.840.113556.1.4.474"
typedef struct ldapsearch LDAPSearch,*PLDAPSearch;
typedef struct ldapsortkeyW {
	PWCHAR sk_attrtype;
	PWCHAR sk_matchruleoid;
	BOOLEAN sk_reverseorder;
} LDAPSortKeyW,*PLDAPSortKeyW;
typedef struct ldapsortkeyA {
	PCHAR sk_attrtype;
	PCHAR sk_matchruleoid;
	BOOLEAN sk_reverseorder;
} LDAPSortKeyA,*PLDAPSortKeyA;
#if LDAP_UNICODE
#define LDAPSortKey LDAPSortKeyW
#define PLDAPSortKey PLDAPSortKeyW
#else
#define LDAPSortKey LDAPSortKeyA
#define PLDAPSortKey PLDAPSortKeyA
#endif
WINLDAPAPI ULONG LDAPAPI ldap_create_sort_controlA (PLDAP ,PLDAPSortKeyA *,UCHAR ,PLDAPControlA *Control );
WINLDAPAPI ULONG LDAPAPI ldap_create_sort_controlW (PLDAP ,PLDAPSortKeyW *,UCHAR ,PLDAPControlW *Control );
WINLDAPAPI ULONG LDAPAPI ldap_parse_sort_controlA (PLDAP ,PLDAPControlA *,ULONG *,PCHAR *Attribute );
WINLDAPAPI ULONG LDAPAPI ldap_parse_sort_controlW (PLDAP ,PLDAPControlW *,ULONG *,PWCHAR *Attribute );
#if LDAP_UNICODE
#define ldap_create_sort_control ldap_create_sort_controlW
#define ldap_parse_sort_control ldap_parse_sort_controlW
#else
WINLDAPAPI ULONG LDAPAPI ldap_create_sort_control (PLDAP ,PLDAPSortKeyA *,UCHAR ,PLDAPControlA *Control );
WINLDAPAPI ULONG LDAPAPI ldap_parse_sort_control (PLDAP ,PLDAPControlA *,ULONG *,PCHAR *Attribute );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_encode_sort_controlW (PLDAP ,PLDAPSortKeyW *,PLDAPControlW ,BOOLEAN Criticality );
WINLDAPAPI ULONG LDAPAPI ldap_encode_sort_controlA (PLDAP ,PLDAPSortKeyA *,PLDAPControlA ,BOOLEAN Criticality );
#if LDAP_UNICODE
#define ldap_encode_sort_control ldap_encode_sort_controlW
#else
WINLDAPAPI ULONG LDAPAPI ldap_encode_sort_control (PLDAP ,PLDAPSortKeyA *,PLDAPControlA ,BOOLEAN Criticality );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_create_page_controlW(PLDAP ,ULONG ,struct berval *Cookie,UCHAR ,PLDAPControlW *Control );
WINLDAPAPI ULONG LDAPAPI ldap_create_page_controlA(PLDAP ,ULONG ,struct berval *Cookie,UCHAR ,PLDAPControlA *Control );
WINLDAPAPI ULONG LDAPAPI ldap_parse_page_controlW (PLDAP ,PLDAPControlW *,ULONG *,struct berval **Cookie  );
WINLDAPAPI ULONG LDAPAPI ldap_parse_page_controlA (PLDAP ,PLDAPControlA *,ULONG *,struct berval **Cookie  );
#if LDAP_UNICODE
#define ldap_create_page_control ldap_create_page_controlW
#define ldap_parse_page_control ldap_parse_page_controlW
#else
WINLDAPAPI ULONG LDAPAPI ldap_create_page_control(PLDAP ,ULONG ,struct berval *Cookie,UCHAR ,PLDAPControlA *Control );
WINLDAPAPI ULONG LDAPAPI ldap_parse_page_control (PLDAP ,PLDAPControlA *,ULONG *,struct berval **Cookie  );
#endif
#define LDAP_PAGED_RESULT_OID_STRING "1.2.840.113556.1.4.319"
#define LDAP_PAGED_RESULT_OID_STRING_W L"1.2.840.113556.1.4.319"
WINLDAPAPI PLDAPSearch LDAPAPI ldap_search_init_pageW(PLDAP , const PWCHAR DistinguishedName,ULONG , const PWCHAR SearchFilter,PWCHAR AttributeList[],ULONG ,PLDAPControlW *,PLDAPControlW *,ULONG ,ULONG ,PLDAPSortKeyW *SortKeys );
WINLDAPAPI PLDAPSearch LDAPAPI ldap_search_init_pageA(PLDAP , const PCHAR DistinguishedName,ULONG , const PCHAR SearchFilter,PCHAR AttributeList[],ULONG ,PLDAPControlA *,PLDAPControlA *,ULONG ,ULONG ,PLDAPSortKeyA *SortKeys );
#if LDAP_UNICODE
#define ldap_search_init_page ldap_search_init_pageW
#else
WINLDAPAPI PLDAPSearch LDAPAPI ldap_search_init_page(PLDAP , const PCHAR DistinguishedName,ULONG , const PCHAR SearchFilter,PCHAR AttributeList[],ULONG ,PLDAPControl *,PLDAPControl *,ULONG ,ULONG ,PLDAPSortKey *SortKeys );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_get_next_page(PLDAP ,PLDAPSearch ,ULONG ,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_get_next_page_s(PLDAP ,PLDAPSearch ,struct l_timeval *timeout,ULONG ,ULONG *,LDAPMessage **Results );
WINLDAPAPI ULONG LDAPAPI ldap_get_paged_count(PLDAP ,PLDAPSearch ,ULONG *,PLDAPMessage Results );
WINLDAPAPI ULONG LDAPAPI ldap_search_abandon_page(PLDAP ,PLDAPSearch SearchBlock );
#define LDAP_CONTROL_VLVREQUEST "2.16.840.1.113730.3.4.9"
#define LDAP_CONTROL_VLVREQUEST_W L"2.16.840.1.113730.3.4.9"
#define LDAP_CONTROL_VLVRESPONSE "2.16.840.1.113730.3.4.10"
#define LDAP_CONTROL_VLVRESPONSE_W L"2.16.840.1.113730.3.4.10"
#define LDAP_API_FEATURE_VIRTUAL_LIST_VIEW 1001
#define LDAP_VLVINFO_VERSION 1
typedef struct ldapvlvinfo {
	int ldvlv_version;
	ULONG ldvlv_before_count;
	ULONG ldvlv_after_count;
	ULONG ldvlv_offset;
	ULONG ldvlv_count;
	PBERVAL ldvlv_attrvalue;
	PBERVAL ldvlv_context;
	VOID *ldvlv_extradata;
}
LDAPVLVInfo,*PLDAPVLVInfo;
WINLDAPAPI INT LDAPAPI ldap_create_vlv_controlW (PLDAP ,PLDAPVLVInfo ,UCHAR ,PLDAPControlW *Control );
WINLDAPAPI INT LDAPAPI ldap_create_vlv_controlA (PLDAP ,PLDAPVLVInfo ,UCHAR ,PLDAPControlA *Control );
WINLDAPAPI INT LDAPAPI ldap_parse_vlv_controlW (PLDAP ,PLDAPControlW *,PULONG ,PULONG ,PBERVAL *,PINT ErrCode );
WINLDAPAPI INT LDAPAPI ldap_parse_vlv_controlA (PLDAP ,PLDAPControlA *,PULONG ,PULONG ,PBERVAL *,PINT ErrCode );
#if LDAP_UNICODE
#define ldap_create_vlv_control ldap_create_vlv_controlW
#define ldap_parse_vlv_control ldap_parse_vlv_controlW
#else
#define ldap_create_vlv_control ldap_create_vlv_controlA
#define ldap_parse_vlv_control ldap_parse_vlv_controlA
#endif
#define LDAP_START_TLS_OID "1.3.6.1.4.1.1466.20037"
#define LDAP_START_TLS_OID_W L"1.3.6.1.4.1.1466.20037"
WINLDAPAPI ULONG LDAPAPI ldap_start_tls_sW (PLDAP ,PULONG ,LDAPMessage **,PLDAPControlW *,PLDAPControlW *ClientControls );
WINLDAPAPI ULONG LDAPAPI ldap_start_tls_sA (PLDAP ,PULONG ,LDAPMessage **,PLDAPControlA *,PLDAPControlA *ClientControls );
WINLDAPAPI BOOLEAN LDAPAPI ldap_stop_tls_s (PLDAP ExternalHandle );
#if LDAP_UNICODE
#define ldap_start_tls_s ldap_start_tls_sW
#else
#define ldap_start_tls_s ldap_start_tls_sA
#endif
#define LDAP_TTL_EXTENDED_OP_OID "1.3.6.1.4.1.1466.101.119.1"
#define LDAP_TTL_EXTENDED_OP_OID_W L"1.3.6.1.4.1.1466.101.119.1"
WINLDAPAPI LDAPMessage *LDAPAPI ldap_first_reference(LDAP *,LDAPMessage *);
WINLDAPAPI LDAPMessage *LDAPAPI ldap_next_reference(LDAP *,LDAPMessage *);
WINLDAPAPI ULONG LDAPAPI ldap_count_references(LDAP *,LDAPMessage *);
WINLDAPAPI ULONG LDAPAPI ldap_parse_referenceW (LDAP *,LDAPMessage *,PWCHAR **Referrals  );
WINLDAPAPI ULONG LDAPAPI ldap_parse_referenceA (LDAP *,LDAPMessage *,PCHAR **Referrals  );
#if LDAP_UNICODE
#define ldap_parse_reference ldap_parse_referenceW
#else
WINLDAPAPI ULONG LDAPAPI ldap_parse_reference (LDAP *,LDAPMessage *,PCHAR **Referrals  );
#endif
WINLDAPAPI ULONG LDAPAPI ldap_extended_operationW(LDAP *, const PWCHAR Oid,struct berval *Data,PLDAPControlW *,PLDAPControlW *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_extended_operationA(LDAP *, const PCHAR Oid,struct berval *Data,PLDAPControlA *,PLDAPControlA *,ULONG *MessageNumber );
WINLDAPAPI ULONG LDAPAPI ldap_extended_operation_sA (LDAP *,PCHAR ,struct berval *Data,PLDAPControlA *,PLDAPControlA *,PCHAR *,struct berval **ReturnedData );
WINLDAPAPI ULONG LDAPAPI ldap_extended_operation_sW (LDAP *,PWCHAR ,struct berval *Data,PLDAPControlW *,PLDAPControlW *,PWCHAR *,struct berval **ReturnedData );
#if LDAP_UNICODE
#define ldap_extended_operation ldap_extended_operationW
#define ldap_extended_operation_s ldap_extended_operation_sW
#else
WINLDAPAPI ULONG LDAPAPI ldap_extended_operation(LDAP *, const PCHAR Oid,struct berval *Data,PLDAPControlA *,PLDAPControlA *,ULONG *MessageNumber );
#define ldap_extended_operation_s ldap_extended_operation_sA
#endif
WINLDAPAPI ULONG LDAPAPI ldap_close_extended_op(LDAP *,ULONG MessageNumber );
#define LDAP_OPT_REFERRAL_CALLBACK 112
typedef ULONG (_cdecl QUERYFORCONNECTION)(PLDAP ,PLDAP ,PWCHAR ,PCHAR ,ULONG ,PVOID ,PVOID ,PLDAP *ConnectionToUse );
typedef BOOLEAN (_cdecl NOTIFYOFNEWCONNECTION) (PLDAP ,PLDAP ,PWCHAR ,PCHAR ,PLDAP ,ULONG ,PVOID ,PVOID ,ULONG ErrorCodeFromBind );
typedef ULONG (_cdecl DEREFERENCECONNECTION)(PLDAP ,PLDAP ConnectionToDereference );
typedef struct LdapReferralCallback {
	ULONG SizeOfCallbacks;
	QUERYFORCONNECTION *QueryForConnection;
	NOTIFYOFNEWCONNECTION *NotifyRoutine;
	DEREFERENCECONNECTION *DereferenceRoutine;
}
LDAP_REFERRAL_CALLBACK,*PLDAP_REFERRAL_CALLBACK;
WINLDAPAPI ULONG LDAPAPI LdapGetLastError(VOID);
WINLDAPAPI ULONG LDAPAPI LdapMapErrorToWin32(ULONG );
#define LDAP_OPT_CLIENT_CERTIFICATE 128
typedef BOOLEAN (_cdecl QUERYCLIENTCERT) (PLDAP ,PSecPkgContext_IssuerListInfoEx ,PCCERT_CONTEXT *ppCertificate );
#define LDAP_OPT_SERVER_CERTIFICATE 129
typedef BOOLEAN (_cdecl VERIFYSERVERCERT) (PLDAP ,PCCERT_CONTEXT pServerCert );
WINLDAPAPI LDAP * LDAPAPI ldap_conn_from_msg (LDAP *,LDAPMessage *res );
#define LDAP_OPT_REF_DEREF_CONN_PER_MSG 148
#endif
