#ifndef __winscard_h__
#define __winscard_h__
#include <wtypes.h>
#include <winioctl.h>
#include "winsmcrd.h"
#ifndef SCARD_S_SUCCESS
#include "SCardErr.h"
#endif
#ifndef _LPCBYTE_DEFINED
#define _LPCBYTE_DEFINED
typedef const BYTE *LPCBYTE;
#endif
#ifndef _LPCVOID_DEFINED
#define _LPCVOID_DEFINED
typedef const VOID *LPCVOID;
#endif
#ifndef WINSCARDAPI
#define WINSCARDAPI
#endif
#ifndef WINSCARDDATA
#define WINSCARDDATA __declspec(dllimport)
#endif
WINSCARDDATA extern const SCARD_IO_REQUEST
g_rgSCardT0Pci,
g_rgSCardT1Pci,
g_rgSCardRawPci;
#define SCARD_PCI_T0 (&g_rgSCardT0Pci)
#define SCARD_PCI_T1 (&g_rgSCardT1Pci)
#define SCARD_PCI_RAW (&g_rgSCardRawPci)
typedef ULONG * SCARDCONTEXT;
typedef SCARDCONTEXT *PSCARDCONTEXT,*LPSCARDCONTEXT;
typedef ULONG_PTR SCARDHANDLE;
typedef SCARDHANDLE *PSCARDHANDLE,*LPSCARDHANDLE;
#define SCARD_AUTOALLOCATE (DWORD)(-1)
#define SCARD_SCOPE_USER 0 
#define SCARD_SCOPE_TERMINAL 1 
#define SCARD_SCOPE_SYSTEM 2 
extern WINSCARDAPI LONG WINAPI
SCardEstablishContext(DWORD ,LPCVOID ,LPCVOID ,LPSCARDCONTEXT );
extern WINSCARDAPI LONG WINAPI
SCardReleaseContext(SCARDCONTEXT );
extern WINSCARDAPI LONG WINAPI
SCardIsValidContext(SCARDCONTEXT );
#define SCARD_ALL_READERS TEXT("SCard$AllReaders\000")
#define SCARD_DEFAULT_READERS TEXT("SCard$DefaultReaders\000")
#define SCARD_LOCAL_READERS TEXT("SCard$LocalReaders\000")
#define SCARD_SYSTEM_READERS TEXT("SCard$SystemReaders\000")
#define SCARD_PROVIDER_PRIMARY 1 
#define SCARD_PROVIDER_CSP 2 
extern WINSCARDAPI LONG WINAPI
SCardListReaderGroupsA(SCARDCONTEXT ,LPSTR ,LPDWORD );
extern WINSCARDAPI LONG WINAPI
SCardListReaderGroupsW(SCARDCONTEXT ,LPWSTR ,LPDWORD );
#ifdef UNICODE
#define SCardListReaderGroups SCardListReaderGroupsW
#else
#define SCardListReaderGroups SCardListReaderGroupsA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardListReadersA(SCARDCONTEXT ,LPCSTR ,LPSTR ,LPDWORD );
extern WINSCARDAPI LONG WINAPI
SCardListReadersW(SCARDCONTEXT ,LPCWSTR ,LPWSTR ,LPDWORD );
#ifdef UNICODE
#define SCardListReaders SCardListReadersW
#else
#define SCardListReaders SCardListReadersA
#endif 
extern LONG WINAPI SCardListCardsA(SCARDCONTEXT ,LPCBYTE ,LPCGUID ,DWORD ,LPSTR ,LPDWORD );
extern LONG WINAPI SCardListCardsW(SCARDCONTEXT ,LPCBYTE ,LPCGUID ,DWORD ,LPWSTR ,LPDWORD );
#ifdef UNICODE
#define SCardListCards SCardListCardsW
#else
#define SCardListCards SCardListCardsA
#endif 
#define SCardListCardTypes SCardListCards
extern WINSCARDAPI LONG WINAPI
SCardListInterfacesA(SCARDCONTEXT ,LPCSTR ,LPGUID ,LPDWORD );
extern WINSCARDAPI LONG WINAPI
SCardListInterfacesW(SCARDCONTEXT ,LPCWSTR ,LPGUID ,LPDWORD );
#ifdef UNICODE
#define SCardListInterfaces SCardListInterfacesW
#else
#define SCardListInterfaces SCardListInterfacesA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardGetProviderIdA(SCARDCONTEXT ,LPCSTR ,LPGUID );
extern WINSCARDAPI LONG WINAPI
SCardGetProviderIdW(SCARDCONTEXT ,LPCWSTR ,LPGUID );
#ifdef UNICODE
#define SCardGetProviderId SCardGetProviderIdW
#else
#define SCardGetProviderId SCardGetProviderIdA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardGetCardTypeProviderNameA(SCARDCONTEXT ,LPCSTR ,DWORD ,LPSTR ,LPDWORD );
extern WINSCARDAPI LONG WINAPI
SCardGetCardTypeProviderNameW(SCARDCONTEXT ,LPCWSTR ,DWORD ,LPWSTR ,LPDWORD );
#ifdef UNICODE
#define SCardGetCardTypeProviderName SCardGetCardTypeProviderNameW
#else
#define SCardGetCardTypeProviderName SCardGetCardTypeProviderNameA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardIntroduceReaderGroupA(SCARDCONTEXT ,LPCSTR );
extern WINSCARDAPI LONG WINAPI
SCardIntroduceReaderGroupW(SCARDCONTEXT ,LPCWSTR );
#ifdef UNICODE
#define SCardIntroduceReaderGroup SCardIntroduceReaderGroupW
#else
#define SCardIntroduceReaderGroup SCardIntroduceReaderGroupA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardForgetReaderGroupA(SCARDCONTEXT ,LPCSTR );
extern WINSCARDAPI LONG WINAPI
SCardForgetReaderGroupW(SCARDCONTEXT ,LPCWSTR );
#ifdef UNICODE
#define SCardForgetReaderGroup SCardForgetReaderGroupW
#else
#define SCardForgetReaderGroup SCardForgetReaderGroupA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardIntroduceReaderA(SCARDCONTEXT ,LPCSTR ,LPCSTR );
extern WINSCARDAPI LONG WINAPI
SCardIntroduceReaderW(SCARDCONTEXT ,LPCWSTR ,LPCWSTR );
#ifdef UNICODE
#define SCardIntroduceReader SCardIntroduceReaderW
#else
#define SCardIntroduceReader SCardIntroduceReaderA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardForgetReaderA(SCARDCONTEXT ,LPCSTR );
extern WINSCARDAPI LONG WINAPI
SCardForgetReaderW(SCARDCONTEXT ,LPCWSTR );
#ifdef UNICODE
#define SCardForgetReader SCardForgetReaderW
#else
#define SCardForgetReader SCardForgetReaderA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardAddReaderToGroupA(SCARDCONTEXT ,LPCSTR ,LPCSTR );
extern WINSCARDAPI LONG WINAPI
SCardAddReaderToGroupW(SCARDCONTEXT ,LPCWSTR ,LPCWSTR );
#ifdef UNICODE
#define SCardAddReaderToGroup SCardAddReaderToGroupW
#else
#define SCardAddReaderToGroup SCardAddReaderToGroupA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardRemoveReaderFromGroupA(SCARDCONTEXT ,LPCSTR ,LPCSTR );
extern WINSCARDAPI LONG WINAPI
SCardRemoveReaderFromGroupW(SCARDCONTEXT ,LPCWSTR ,LPCWSTR );
#ifdef UNICODE
#define SCardRemoveReaderFromGroup SCardRemoveReaderFromGroupW
#else
#define SCardRemoveReaderFromGroup SCardRemoveReaderFromGroupA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardIntroduceCardTypeA(SCARDCONTEXT ,LPCSTR ,LPCGUID ,LPCGUID ,DWORD ,LPCBYTE ,LPCBYTE ,DWORD );
extern WINSCARDAPI LONG WINAPI
SCardIntroduceCardTypeW(SCARDCONTEXT ,LPCWSTR ,LPCGUID ,LPCGUID ,DWORD ,LPCBYTE ,LPCBYTE ,DWORD );
#ifdef UNICODE
#define SCardIntroduceCardType SCardIntroduceCardTypeW
#else
#define SCardIntroduceCardType SCardIntroduceCardTypeA
#endif 
#define PCSCardIntroduceCardType(hContext,szCardName,pbAtr,pbAtrMask,cbAtrLen,pguidPrimaryProvider,rgguidInterfaces,dwInterfaceCount) \
SCardIntroduceCardType(hContext,szCardName,pguidPrimaryProvider,rgguidInterfaces,dwInterfaceCount,pbAtr,pbAtrMask,cbAtrLen)
extern WINSCARDAPI LONG WINAPI
SCardSetCardTypeProviderNameA(SCARDCONTEXT ,LPCSTR ,DWORD ,LPCSTR );
extern WINSCARDAPI LONG WINAPI
SCardSetCardTypeProviderNameW(SCARDCONTEXT ,LPCWSTR ,DWORD ,LPCWSTR );
#ifdef UNICODE
#define SCardSetCardTypeProviderName SCardSetCardTypeProviderNameW
#else
#define SCardSetCardTypeProviderName SCardSetCardTypeProviderNameA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardForgetCardTypeA(SCARDCONTEXT ,LPCSTR );
extern WINSCARDAPI LONG WINAPI
SCardForgetCardTypeW(SCARDCONTEXT ,LPCWSTR );
#ifdef UNICODE
#define SCardForgetCardType SCardForgetCardTypeW
#else
#define SCardForgetCardType SCardForgetCardTypeA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardFreeMemory(SCARDCONTEXT ,LPVOID );
typedef struct {
LPCSTR szReader; 
LPVOID pvUserData; 
DWORD dwCurrentState; 
DWORD dwEventState; 
DWORD cbAtr; 
BYTE rgbAtr[36]; 
} SCARD_READERSTATEA,*PSCARD_READERSTATEA,*LPSCARD_READERSTATEA;
typedef struct {
LPCWSTR szReader; 
LPVOID pvUserData; 
DWORD dwCurrentState; 
DWORD dwEventState; 
DWORD cbAtr; 
BYTE rgbAtr[36]; 
} SCARD_READERSTATEW,*PSCARD_READERSTATEW,*LPSCARD_READERSTATEW;
#ifdef UNICODE
typedef SCARD_READERSTATEW SCARD_READERSTATE;
typedef PSCARD_READERSTATEW PSCARD_READERSTATE;
typedef LPSCARD_READERSTATEW LPSCARD_READERSTATE;
#else
typedef SCARD_READERSTATEA SCARD_READERSTATE;
typedef PSCARD_READERSTATEA PSCARD_READERSTATE;
typedef LPSCARD_READERSTATEA LPSCARD_READERSTATE;
#endif 
#define SCARD_READERSTATE_A SCARD_READERSTATEA
#define SCARD_READERSTATE_W SCARD_READERSTATEW
#define PSCARD_READERSTATE_A PSCARD_READERSTATEA
#define PSCARD_READERSTATE_W PSCARD_READERSTATEW
#define LPSCARD_READERSTATE_A LPSCARD_READERSTATEA
#define LPSCARD_READERSTATE_W LPSCARD_READERSTATEW
#define SCARD_STATE_UNAWARE 0
#define SCARD_STATE_IGNORE 1
#define SCARD_STATE_CHANGED 2
#define SCARD_STATE_UNKNOWN 4
#define SCARD_STATE_UNAVAILABLE 8
#define SCARD_STATE_EMPTY 16
#define SCARD_STATE_PRESENT 32
#define SCARD_STATE_ATRMATCH 64
#define SCARD_STATE_EXCLUSIVE 128
#define SCARD_STATE_INUSE 256
#define SCARD_STATE_MUTE 512
#define SCARD_STATE_UNPOWERED 1024
extern WINSCARDAPI LONG WINAPI
SCardLocateCardsA(SCARDCONTEXT ,LPCSTR ,LPSCARD_READERSTATEA ,DWORD );
extern WINSCARDAPI LONG WINAPI
SCardLocateCardsW(SCARDCONTEXT ,LPCWSTR ,LPSCARD_READERSTATEW ,DWORD );
#ifdef UNICODE
#define SCardLocateCards SCardLocateCardsW
#else
#define SCardLocateCards SCardLocateCardsA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardGetStatusChangeA(SCARDCONTEXT ,DWORD ,LPSCARD_READERSTATEA ,DWORD );
extern WINSCARDAPI LONG WINAPI
SCardGetStatusChangeW(SCARDCONTEXT ,DWORD ,LPSCARD_READERSTATEW ,DWORD );
#ifdef UNICODE
#define SCardGetStatusChange SCardGetStatusChangeW
#else
#define SCardGetStatusChange SCardGetStatusChangeA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardCancel(SCARDCONTEXT );
#define SCARD_SHARE_EXCLUSIVE 1 
#define SCARD_SHARE_SHARED 2 
#define SCARD_SHARE_DIRECT 3 
#define SCARD_LEAVE_CARD 0 
#define SCARD_RESET_CARD 1 
#define SCARD_UNPOWER_CARD 2 
#define SCARD_EJECT_CARD 3 
extern WINSCARDAPI LONG WINAPI
SCardConnectA(SCARDCONTEXT ,LPCSTR ,DWORD ,DWORD ,LPSCARDHANDLE ,LPDWORD );
extern WINSCARDAPI LONG WINAPI
SCardConnectW(SCARDCONTEXT ,LPCWSTR ,DWORD ,DWORD ,LPSCARDHANDLE ,LPDWORD );
#ifdef UNICODE
#define SCardConnect SCardConnectW
#else
#define SCardConnect SCardConnectA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardReconnect(SCARDHANDLE ,DWORD ,DWORD ,DWORD ,LPDWORD );
extern WINSCARDAPI LONG WINAPI
SCardDisconnect(SCARDHANDLE ,DWORD );
extern WINSCARDAPI LONG WINAPI
SCardBeginTransaction(SCARDHANDLE );
extern WINSCARDAPI LONG WINAPI
SCardEndTransaction(SCARDHANDLE ,DWORD );
extern WINSCARDAPI LONG WINAPI
SCardCancelTransaction(SCARDHANDLE );
extern WINSCARDAPI LONG WINAPI
SCardState(SCARDHANDLE ,LPDWORD ,LPDWORD ,LPBYTE ,LPDWORD );
extern WINSCARDAPI LONG WINAPI
SCardStatusA(SCARDHANDLE ,LPSTR ,LPDWORD ,LPDWORD ,LPDWORD ,LPBYTE ,LPDWORD );
extern WINSCARDAPI LONG WINAPI
SCardStatusW(SCARDHANDLE ,LPWSTR ,LPDWORD ,LPDWORD ,LPDWORD ,LPBYTE ,LPDWORD );
#ifdef UNICODE
#define SCardStatus SCardStatusW
#else
#define SCardStatus SCardStatusA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardTransmit(SCARDHANDLE ,LPCSCARD_IO_REQUEST ,LPCBYTE ,DWORD ,LPSCARD_IO_REQUEST ,LPBYTE ,LPDWORD );
extern WINSCARDAPI LONG WINAPI
SCardControl(SCARDHANDLE ,DWORD ,LPCVOID ,DWORD ,LPVOID ,DWORD ,LPDWORD );
extern WINSCARDAPI LONG WINAPI
SCardGetAttrib(SCARDHANDLE ,DWORD ,LPBYTE ,LPDWORD );
#define SCardGetReaderCapabilities SCardGetAttrib
extern WINSCARDAPI LONG WINAPI
SCardSetAttrib(SCARDHANDLE ,DWORD ,LPCBYTE ,DWORD );
#define SCardSetReaderCapabilities SCardSetAttrib
#define SC_DLG_MINIMAL_UI 1
#define SC_DLG_NO_UI 2
#define SC_DLG_FORCE_UI 4
#define SCERR_NOCARDNAME 0x4000
#define SCERR_NOGUIDS 0x8000
typedef SCARDHANDLE (WINAPI *LPOCNCONNPROCA) (SCARDCONTEXT ,LPSTR ,LPSTR ,PVOID );
typedef SCARDHANDLE (WINAPI *LPOCNCONNPROCW) (SCARDCONTEXT ,LPWSTR ,LPWSTR ,PVOID );
#ifdef UNICODE
#define LPOCNCONNPROC LPOCNCONNPROCW
#else
#define LPOCNCONNPROC LPOCNCONNPROCA
#endif 
typedef BOOL (WINAPI *LPOCNCHKPROC) (SCARDCONTEXT ,SCARDHANDLE ,PVOID );
typedef void (WINAPI *LPOCNDSCPROC) (SCARDCONTEXT ,SCARDHANDLE ,PVOID);
typedef struct {
DWORD dwStructSize;
LPSTR lpstrGroupNames; 
DWORD nMaxGroupNames; 
LPCGUID rgguidInterfaces; 
DWORD cguidInterfaces; 
LPSTR lpstrCardNames; 
DWORD nMaxCardNames; 
LPOCNCHKPROC lpfnCheck; 
LPOCNCONNPROCA lpfnConnect; 
LPOCNDSCPROC lpfnDisconnect; 
LPVOID pvUserData; 
DWORD dwShareMode; 
DWORD dwPreferredProtocols; 
} OPENCARD_SEARCH_CRITERIAA,*POPENCARD_SEARCH_CRITERIAA,*LPOPENCARD_SEARCH_CRITERIAA;
typedef struct {
DWORD dwStructSize;
LPWSTR lpstrGroupNames; 
DWORD nMaxGroupNames; 
LPCGUID rgguidInterfaces; 
DWORD cguidInterfaces; 
LPWSTR lpstrCardNames; 
DWORD nMaxCardNames; 
LPOCNCHKPROC lpfnCheck; 
LPOCNCONNPROCW lpfnConnect; 
LPOCNDSCPROC lpfnDisconnect; 
LPVOID pvUserData; 
DWORD dwShareMode; 
DWORD dwPreferredProtocols; 
} OPENCARD_SEARCH_CRITERIAW,*POPENCARD_SEARCH_CRITERIAW,*LPOPENCARD_SEARCH_CRITERIAW;
#ifdef UNICODE
typedef OPENCARD_SEARCH_CRITERIAW OPENCARD_SEARCH_CRITERIA;
typedef POPENCARD_SEARCH_CRITERIAW POPENCARD_SEARCH_CRITERIA;
typedef LPOPENCARD_SEARCH_CRITERIAW LPOPENCARD_SEARCH_CRITERIA;
#else
typedef OPENCARD_SEARCH_CRITERIAA OPENCARD_SEARCH_CRITERIA;
typedef POPENCARD_SEARCH_CRITERIAA POPENCARD_SEARCH_CRITERIA;
typedef LPOPENCARD_SEARCH_CRITERIAA LPOPENCARD_SEARCH_CRITERIA;
#endif 
typedef struct {
DWORD dwStructSize; 
SCARDCONTEXT hSCardContext; 
HWND hwndOwner; 
DWORD dwFlags; 
LPCSTR lpstrTitle; 
LPCSTR lpstrSearchDesc; 
HICON hIcon; 
POPENCARD_SEARCH_CRITERIAA pOpenCardSearchCriteria; 
LPOCNCONNPROCA lpfnConnect; 
LPVOID pvUserData; 
DWORD dwShareMode; 
DWORD dwPreferredProtocols; 
LPSTR lpstrRdr; 
DWORD nMaxRdr; 
LPSTR lpstrCard; 
DWORD nMaxCard; 
DWORD dwActiveProtocol; 
SCARDHANDLE hCardHandle; 
} OPENCARDNAMEA_EX,*POPENCARDNAMEA_EX,*LPOPENCARDNAMEA_EX;
typedef struct {
DWORD dwStructSize; 
SCARDCONTEXT hSCardContext; 
HWND hwndOwner; 
DWORD dwFlags; 
LPCWSTR lpstrTitle; 
LPCWSTR lpstrSearchDesc; 
HICON hIcon; 
POPENCARD_SEARCH_CRITERIAW pOpenCardSearchCriteria; 
LPOCNCONNPROCW lpfnConnect; 
LPVOID pvUserData; 
DWORD dwShareMode; 
DWORD dwPreferredProtocols; 
LPWSTR lpstrRdr; 
DWORD nMaxRdr; 
LPWSTR lpstrCard; 
DWORD nMaxCard; 
DWORD dwActiveProtocol; 
SCARDHANDLE hCardHandle; 
} OPENCARDNAMEW_EX,*POPENCARDNAMEW_EX,*LPOPENCARDNAMEW_EX;
#ifdef UNICODE
#else
#endif 
extern WINSCARDAPI LONG WINAPI
SCardUIDlgSelectCardA(LPOPENCARDNAMEA_EX);
extern WINSCARDAPI LONG WINAPI
SCardUIDlgSelectCardW(LPOPENCARDNAMEW_EX);
#ifdef UNICODE
#define SCardUIDlgSelectCard SCardUIDlgSelectCardW
#else
#define SCardUIDlgSelectCard SCardUIDlgSelectCardA
#endif 
typedef struct {
DWORD dwStructSize;
HWND hwndOwner;
SCARDCONTEXT hSCardContext;
LPSTR lpstrGroupNames;
DWORD nMaxGroupNames;
LPSTR lpstrCardNames;
DWORD nMaxCardNames;
LPCGUID rgguidInterfaces;
DWORD cguidInterfaces;
LPSTR lpstrRdr;
DWORD nMaxRdr;
LPSTR lpstrCard;
DWORD nMaxCard;
LPCSTR lpstrTitle;
DWORD dwFlags;
LPVOID pvUserData;
DWORD dwShareMode;
DWORD dwPreferredProtocols;
DWORD dwActiveProtocol;
LPOCNCONNPROCA lpfnConnect;
LPOCNCHKPROC lpfnCheck;
LPOCNDSCPROC lpfnDisconnect;
SCARDHANDLE hCardHandle;
} OPENCARDNAMEA,*POPENCARDNAMEA,*LPOPENCARDNAMEA;
typedef struct {
DWORD dwStructSize;
HWND hwndOwner;
SCARDCONTEXT hSCardContext;
LPWSTR lpstrGroupNames;
DWORD nMaxGroupNames;
LPWSTR lpstrCardNames;
DWORD nMaxCardNames;
LPCGUID rgguidInterfaces;
DWORD cguidInterfaces;
LPWSTR lpstrRdr;
DWORD nMaxRdr;
LPWSTR lpstrCard;
DWORD nMaxCard;
LPCWSTR lpstrTitle;
DWORD dwFlags;
LPVOID pvUserData;
DWORD dwShareMode;
DWORD dwPreferredProtocols;
DWORD dwActiveProtocol;
LPOCNCONNPROCW lpfnConnect;
LPOCNCHKPROC lpfnCheck;
LPOCNDSCPROC lpfnDisconnect;
SCARDHANDLE hCardHandle;
} OPENCARDNAMEW,*POPENCARDNAMEW,*LPOPENCARDNAMEW;
#ifdef UNICODE
typedef OPENCARDNAMEW OPENCARDNAME;
typedef POPENCARDNAMEW POPENCARDNAME;
typedef LPOPENCARDNAMEW LPOPENCARDNAME;
#else
typedef OPENCARDNAMEA OPENCARDNAME;
typedef POPENCARDNAMEA POPENCARDNAME;
typedef LPOPENCARDNAMEA LPOPENCARDNAME;
#endif 
#define OPENCARDNAME_A OPENCARDNAMEA
#define OPENCARDNAME_W OPENCARDNAMEW
#define POPENCARDNAME_A POPENCARDNAMEA
#define POPENCARDNAME_W POPENCARDNAMEW
#define LPOPENCARDNAME_A LPOPENCARDNAMEA
#define LPOPENCARDNAME_W LPOPENCARDNAMEW
extern WINSCARDAPI LONG WINAPI
GetOpenCardNameA(LPOPENCARDNAMEA);
extern WINSCARDAPI LONG WINAPI
GetOpenCardNameW(LPOPENCARDNAMEW);
#ifdef UNICODE
#define GetOpenCardName GetOpenCardNameW
#else
#define GetOpenCardName GetOpenCardNameA
#endif 
extern WINSCARDAPI LONG WINAPI
SCardDlgExtendedError (void);
#endif 
