#ifndef __winsnmp_h__ 
#define __winsnmp_h__ 
#ifndef __windows_h__ 
#include <windows.h>
#endif 
#include <limits.h>
typedef HANDLE HSNMP_SESSION,*LPHSNMP_SESSION;
typedef HANDLE HSNMP_ENTITY,*LPHSNMP_ENTITY;
typedef HANDLE HSNMP_CONTEXT,*LPHSNMP_CONTEXT;
typedef HANDLE HSNMP_PDU,*LPHSNMP_PDU;
typedef HANDLE HSNMP_VBL,*LPHSNMP_VBL;
typedef unsigned char smiBYTE,*smiLPBYTE;
#if ULONG_MAX == 4294967295U
typedef signed long smiINT,*smiLPINT;
typedef smiINT smiINT32,*smiLPINT32;
typedef unsigned long smiUINT32,*smiLPUINT32;
#elif UINT_MAX == 4294967295U
typedef int smiINT,*smiLPINT;
typedef smiINT smiINT32,*smiLPINT32;
typedef unsigned int smiUINT32,*smiLPUINT32;
#else
#error can not define smiINT and smiUINT
#endif
typedef struct { smiUINT32 len; smiLPBYTE ptr;} smiOCTETS,*smiLPOCTETS;
typedef const smiOCTETS *smiLPCOCTETS;
typedef smiOCTETS smiBITS,*smiLPBITS;
typedef struct { smiUINT32 len; smiLPUINT32 ptr;} smiOID,*smiLPOID;
typedef const smiOID *smiLPCOID;
typedef smiOCTETS smiIPADDR,*smiLPIPADDR;
typedef smiUINT32 smiCNTR32,*smiLPCNTR32;
typedef smiUINT32 smiGAUGE32,*smiLPGAUGE32;
typedef smiUINT32 smiTIMETICKS,*smiLPTIMETICKS;
typedef smiOCTETS smiOPAQUE,*smiLPOPAQUE;
typedef smiOCTETS smiNSAPADDR,*smiLPNSAPADDR;
typedef struct { smiUINT32 hipart; smiUINT32 lopart;} smiCNTR64,*smiLPCNTR64;
#ifndef ASN__UNIVERSAL
#define ASN_UNIVERSAL 0
#define ASN_APPLICATION 0x40
#define ASN_CONTEXT 0x80
#define ASN_PRIVATE 0xC0
#define ASN_PRIMITIVE 0
#define ASN_CONSTRUCTOR 0x20
#endif
#define SNMP_SYNTAX_SEQUENCE (ASN_UNIVERSAL|ASN_CONSTRUCTOR|0x10)
#define SNMP_SYNTAX_INT (ASN_UNIVERSAL|ASN_PRIMITIVE|2)
#define SNMP_SYNTAX_BITS (ASN_UNIVERSAL|ASN_PRIMITIVE|3)
#define SNMP_SYNTAX_OCTETS (ASN_UNIVERSAL|ASN_PRIMITIVE|4)
#define SNMP_SYNTAX_NULL (ASN_UNIVERSAL|ASN_PRIMITIVE|5)
#define SNMP_SYNTAX_OID (ASN_UNIVERSAL|ASN_PRIMITIVE|6)
#define SNMP_SYNTAX_INT32 SNMP_SYNTAX_INT
#define SNMP_SYNTAX_IPADDR (ASN_APPLICATION|ASN_PRIMITIVE)
#define SNMP_SYNTAX_CNTR32 (ASN_APPLICATION|ASN_PRIMITIVE|1)
#define SNMP_SYNTAX_GAUGE32 (ASN_APPLICATION|ASN_PRIMITIVE|2)
#define SNMP_SYNTAX_TIMETICKS (ASN_APPLICATION|ASN_PRIMITIVE|3)
#define SNMP_SYNTAX_OPAQUE (ASN_APPLICATION|ASN_PRIMITIVE|4)
#define SNMP_SYNTAX_NSAPADDR (ASN_APPLICATION|ASN_PRIMITIVE|5)
#define SNMP_SYNTAX_CNTR64 (ASN_APPLICATION|ASN_PRIMITIVE|6)
#define SNMP_SYNTAX_UINT32 (ASN_APPLICATION|ASN_PRIMITIVE|7)
#define SNMP_SYNTAX_NOSUCHOBJECT (ASN_CONTEXT|ASN_PRIMITIVE)
#define SNMP_SYNTAX_NOSUCHINSTANCE (ASN_CONTEXT|ASN_PRIMITIVE|1)
#define SNMP_SYNTAX_ENDOFMIBVIEW (ASN_CONTEXT|ASN_PRIMITIVE|2)
typedef struct { 
 smiUINT32 syntax; 
 union {
 smiINT sNumber; 
 smiUINT32 uNumber; 
 smiCNTR64 hNumber; 
 smiOCTETS string; 
 smiOID oid; 
 smiBYTE empty; 
 } value; 
 } smiVALUE,*smiLPVALUE;
typedef const smiVALUE *smiLPCVALUE;
#define MAXOBJIDSIZE 128 
#define MAXOBJIDSTRSIZE 1408 
#ifndef SNMP_PDU_GET
#define SNMP_PDU_GET (ASN_CONTEXT|ASN_CONSTRUCTOR)
#define SNMP_PDU_GETNEXT (ASN_CONTEXT|ASN_CONSTRUCTOR|1)
#define SNMP_PDU_RESPONSE (ASN_CONTEXT|ASN_CONSTRUCTOR|2)
#define SNMP_PDU_SET (ASN_CONTEXT|ASN_CONSTRUCTOR|3)
#define SNMP_PDU_V1TRAP (ASN_CONTEXT|ASN_CONSTRUCTOR|4)
#define SNMP_PDU_GETBULK (ASN_CONTEXT|ASN_CONSTRUCTOR|5)
#define SNMP_PDU_INFORM (ASN_CONTEXT|ASN_CONSTRUCTOR|6)
#define SNMP_PDU_TRAP (ASN_CONTEXT|ASN_CONSTRUCTOR|7)
#endif
#define SNMP_TRAP_COLDSTART 0
#define SNMP_TRAP_WARMSTART 1
#define SNMP_TRAP_LINKDOWN 2
#define SNMP_TRAP_LINKUP 3
#define SNMP_TRAP_AUTHFAIL 4
#define SNMP_TRAP_EGPNEIGHBORLOSS 5
#define SNMP_TRAP_ENTERPRISESPECIFIC 6
#define SNMP_ERROR_NOERROR 0
#define SNMP_ERROR_TOOBIG 1
#define SNMP_ERROR_NOSUCHNAME 2
#define SNMP_ERROR_BADVALUE 3
#define SNMP_ERROR_READONLY 4
#define SNMP_ERROR_GENERR 5
#define SNMP_ERROR_NOACCESS 6
#define SNMP_ERROR_WRONGTYPE 7
#define SNMP_ERROR_WRONGLENGTH 8
#define SNMP_ERROR_WRONGENCODING 9
#define SNMP_ERROR_WRONGVALUE 10
#define SNMP_ERROR_NOCREATION 11
#define SNMP_ERROR_INCONSISTENTVALUE 12
#define SNMP_ERROR_RESOURCEUNAVAILABLE 13
#define SNMP_ERROR_COMMITFAILED 14
#define SNMP_ERROR_UNDOFAILED 15
#define SNMP_ERROR_AUTHORIZATIONERROR 16
#define SNMP_ERROR_NOTWRITABLE 17
#define SNMP_ERROR_INCONSISTENTNAME 18
#define SNMPAPI_TRANSLATED 0
#define SNMPAPI_UNTRANSLATED_V1 1
#define SNMPAPI_UNTRANSLATED_V2 2
#define SNMPAPI_NO_SUPPORT 0
#define SNMPAPI_V1_SUPPORT 1
#define SNMPAPI_V2_SUPPORT 2
#define SNMPAPI_M2M_SUPPORT 3
#define SNMPAPI_OFF 0 
#define SNMPAPI_ON 1 
typedef smiUINT32 SNMPAPI_STATUS; 
#define SNMPAPI_FAILURE 0 
#define SNMPAPI_SUCCESS 1 
#define SNMPAPI_ALLOC_ERROR 2 
#define SNMPAPI_CONTEXT_INVALID 3 
#define SNMPAPI_CONTEXT_UNKNOWN 4 
#define SNMPAPI_ENTITY_INVALID 5 
#define SNMPAPI_ENTITY_UNKNOWN 6 
#define SNMPAPI_INDEX_INVALID 7 
#define SNMPAPI_NOOP 8 
#define SNMPAPI_OID_INVALID 9 
#define SNMPAPI_OPERATION_INVALID 10 
#define SNMPAPI_OUTPUT_TRUNCATED 11 
#define SNMPAPI_PDU_INVALID 12 
#define SNMPAPI_SESSION_INVALID 13 
#define SNMPAPI_SYNTAX_INVALID 14 
#define SNMPAPI_VBL_INVALID 15 
#define SNMPAPI_MODE_INVALID 16 
#define SNMPAPI_SIZE_INVALID 17 
#define SNMPAPI_NOT_INITIALIZED 18 
#define SNMPAPI_MESSAGE_INVALID 19 
#define SNMPAPI_HWND_INVALID 20 
#define SNMPAPI_OTHER_ERROR 99 
#define SNMPAPI_TL_NOT_INITIALIZED 100 
#define SNMPAPI_TL_NOT_SUPPORTED 101 
#define SNMPAPI_TL_NOT_AVAILABLE 102 
#define SNMPAPI_TL_RESOURCE_ERROR 103 
#define SNMPAPI_TL_UNDELIVERABLE 104 
#define SNMPAPI_TL_SRC_INVALID 105 
#define SNMPAPI_TL_INVALID_PARAM 106 
#define SNMPAPI_TL_IN_USE 107 
#define SNMPAPI_TL_TIMEOUT 108 
#define SNMPAPI_TL_PDU_TOO_BIG 109 
#define SNMPAPI_TL_OTHER 199 
#define MAXVENDORINFO 32
typedef struct {
	char vendorName[MAXVENDORINFO*2];
	char vendorContact[MAXVENDORINFO*2];
	char vendorVersionId[MAXVENDORINFO];
	char vendorVersionDate[MAXVENDORINFO];
	smiUINT32 vendorEnterprise;
} smiVENDORINFO,*smiLPVENDORINFO;
typedef SNMPAPI_STATUS (CALLBACK *SNMPAPI_CALLBACK)(HSNMP_SESSION,HWND,UINT,WPARAM,LPARAM,LPVOID);
SNMPAPI_STATUS WINAPI SnmpGetTranslateMode(smiLPUINT32);
SNMPAPI_STATUS WINAPI SnmpSetTranslateMode (smiUINT32);
SNMPAPI_STATUS WINAPI SnmpGetRetransmitMode (smiLPUINT32);
SNMPAPI_STATUS WINAPI SnmpSetRetransmitMode (smiUINT32);
SNMPAPI_STATUS WINAPI SnmpGetTimeout(HSNMP_ENTITY,smiLPTIMETICKS,smiLPTIMETICKS);
SNMPAPI_STATUS WINAPI SnmpSetTimeout(HSNMP_ENTITY hEntity,smiTIMETICKS nPolicyTimeout);
SNMPAPI_STATUS WINAPI SnmpGetRetry(HSNMP_ENTITY,smiLPUINT32,smiLPUINT32);
SNMPAPI_STATUS WINAPI SnmpSetRetry(HSNMP_ENTITY,smiUINT32);
SNMPAPI_STATUS WINAPI SnmpGetVendorInfo(smiLPVENDORINFO);
SNMPAPI_STATUS WINAPI SnmpStartup(smiLPUINT32,smiLPUINT32,smiLPUINT32,smiLPUINT32,smiLPUINT32);
SNMPAPI_STATUS WINAPI SnmpCleanup (void);
HSNMP_SESSION WINAPI SnmpOpen (HWND,UINT);
SNMPAPI_STATUS WINAPI SnmpClose(HSNMP_SESSION);
SNMPAPI_STATUS WINAPI SnmpSendMsg(HSNMP_SESSION,HSNMP_ENTITY,HSNMP_ENTITY,HSNMP_CONTEXT,HSNMP_PDU PDU);
SNMPAPI_STATUS WINAPI SnmpRecvMsg(HSNMP_SESSION,LPHSNMP_ENTITY,LPHSNMP_ENTITY,LPHSNMP_CONTEXT,LPHSNMP_PDU);
SNMPAPI_STATUS WINAPI SnmpRegister(HSNMP_SESSION, HSNMP_ENTITY, HSNMP_ENTITY, HSNMP_CONTEXT, smiLPCOID,smiUINT32);
HSNMP_SESSION WINAPI SnmpCreateSession(HWND,UINT,SNMPAPI_CALLBACK,LPVOID);
SNMPAPI_STATUS WINAPI SnmpListen(HSNMP_ENTITY,SNMPAPI_STATUS);
SNMPAPI_STATUS WINAPI SnmpCancelMsg(HSNMP_SESSION,smiINT32);
HSNMP_ENTITY WINAPI SnmpStrToEntity(HSNMP_SESSION,LPCSTR);
SNMPAPI_STATUS WINAPI SnmpEntityToStr(HSNMP_ENTITY,smiUINT32,LPSTR);
SNMPAPI_STATUS WINAPI SnmpFreeEntity(HSNMP_ENTITY);
HSNMP_CONTEXT WINAPI SnmpStrToContext(HSNMP_SESSION,smiLPCOCTETS);
SNMPAPI_STATUS WINAPI SnmpContextToStr(HSNMP_CONTEXT,smiLPOCTETS);
SNMPAPI_STATUS WINAPI SnmpFreeContext(HSNMP_CONTEXT);
SNMPAPI_STATUS WINAPI SnmpSetPort(HSNMP_ENTITY,UINT);
HSNMP_PDU WINAPI SnmpCreatePdu(HSNMP_SESSION,smiINT,smiINT32,smiINT,smiINT,HSNMP_VBL);
SNMPAPI_STATUS WINAPI SnmpGetPduData(HSNMP_PDU,smiLPINT,smiLPINT32,smiLPINT,smiLPINT,LPHSNMP_VBL);
SNMPAPI_STATUS WINAPI SnmpSetPduData(HSNMP_PDU,const smiINT *,const smiINT32 *,const smiINT *,const smiINT *,const HSNMP_VBL *);
HSNMP_PDU WINAPI SnmpDuplicatePdu(HSNMP_SESSION,HSNMP_PDU); 
SNMPAPI_STATUS WINAPI SnmpFreePdu(HSNMP_PDU);
HSNMP_VBL WINAPI SnmpCreateVbl(HSNMP_SESSION,smiLPCOID,smiLPCVALUE);
HSNMP_VBL WINAPI SnmpDuplicateVbl(HSNMP_SESSION,HSNMP_VBL);
SNMPAPI_STATUS WINAPI SnmpFreeVbl(HSNMP_VBL);
SNMPAPI_STATUS WINAPI SnmpCountVbl(HSNMP_VBL);
SNMPAPI_STATUS WINAPI SnmpGetVb(HSNMP_VBL,smiUINT32,smiLPOID,smiLPVALUE);
SNMPAPI_STATUS WINAPI SnmpSetVb(HSNMP_VBL,smiUINT32,smiLPCOID,smiLPCVALUE);
SNMPAPI_STATUS WINAPI SnmpDeleteVb(HSNMP_VBL,smiUINT32);
SNMPAPI_STATUS WINAPI SnmpGetLastError(HSNMP_SESSION);
SNMPAPI_STATUS WINAPI SnmpStrToOid(LPCSTR,smiLPOID);
SNMPAPI_STATUS WINAPI SnmpOidToStr(smiLPCOID,smiUINT32,LPSTR);
SNMPAPI_STATUS WINAPI SnmpOidCopy(smiLPCOID,smiLPOID);
SNMPAPI_STATUS WINAPI SnmpOidCompare(smiLPCOID,smiLPCOID,smiUINT32,smiLPINT);
SNMPAPI_STATUS WINAPI SnmpEncodeMsg(HSNMP_SESSION,HSNMP_ENTITY,HSNMP_ENTITY,HSNMP_CONTEXT,HSNMP_PDU,smiLPOCTETS);
SNMPAPI_STATUS WINAPI SnmpDecodeMsg(HSNMP_SESSION,LPHSNMP_ENTITY,LPHSNMP_ENTITY,LPHSNMP_CONTEXT,LPHSNMP_PDU,smiLPCOCTETS);
SNMPAPI_STATUS WINAPI SnmpFreeDescriptor(smiUINT32,smiLPOPAQUE);
#endif 

