#ifndef __wmistr_h__
#define __wmistr_h__
typedef struct _WNODE_HEADER { ULONG BufferSize; ULONG ProviderId; 
	union { ULONG64 HistoricalContext; 
		struct { ULONG Version; ULONG Linkage; };
	};
	union { HANDLE KernelHandle; LARGE_INTEGER TimeStamp; };
	GUID Guid; 
	ULONG ClientContext;
	ULONG Flags; 
} WNODE_HEADER, *PWNODE_HEADER;
#define WNODE_FLAG_ALL_DATA 1
#define WNODE_FLAG_SINGLE_INSTANCE 2
#define WNODE_FLAG_SINGLE_ITEM 4
#define WNODE_FLAG_EVENT_ITEM 8
#define WNODE_FLAG_FIXED_INSTANCE_SIZE 16
#define WNODE_FLAG_TOO_SMALL 32
#define WNODE_FLAG_INSTANCES_SAME 64
#define WNODE_FLAG_STATIC_INSTANCE_NAMES 128
#define WNODE_FLAG_INTERNAL 256
#define WNODE_FLAG_USE_TIMESTAMP 512
#define WNODE_FLAG_EVENT_REFERENCE 0x2000
#define WNODE_FLAG_ANSI_INSTANCENAMES 0x4000
#define WNODE_FLAG_METHOD_ITEM 0x8000
#define WNODE_FLAG_PDO_INSTANCE_NAMES 0x10000
#define WNODE_FLAG_TRACED_GUID 0x20000
#define WNODE_FLAG_LOG_WNODE 0x40000
#define WNODE_FLAG_USE_GUID_PTR 0x80000
#define WNODE_FLAG_USE_MOF_PTR 0x100000
#define WNODE_FLAG_INTERNAL2 0x200000
#define WNODE_FLAG_SEVERITY_MASK 0xff000000
typedef struct { ULONG OffsetInstanceData; ULONG LengthInstanceData; 
} OFFSETINSTANCEDATAANDLENGTH, *POFFSETINSTANCEDATAANDLENGTH;
typedef struct tagWNODE_ALL_DATA {
struct _WNODE_HEADER WnodeHeader;
ULONG DataBlockOffset;
ULONG InstanceCount; 
ULONG OffsetInstanceNameOffsets;
union
{
ULONG FixedInstanceSize;
OFFSETINSTANCEDATAANDLENGTH OffsetInstanceDataAndLength[1];
};
} WNODE_ALL_DATA, *PWNODE_ALL_DATA;
typedef struct tagWNODE_SINGLE_INSTANCE
{
struct _WNODE_HEADER WnodeHeader;
ULONG OffsetInstanceName;
ULONG InstanceIndex; 
ULONG DataBlockOffset; 
ULONG SizeDataBlock; 
UCHAR VariableData[1];
} WNODE_SINGLE_INSTANCE, *PWNODE_SINGLE_INSTANCE;
typedef struct tagWNODE_SINGLE_ITEM
{
struct _WNODE_HEADER WnodeHeader;
ULONG OffsetInstanceName;
ULONG InstanceIndex; 
ULONG ItemId; 
ULONG DataBlockOffset; 
ULONG SizeDataItem; 
UCHAR VariableData[1];
} WNODE_SINGLE_ITEM, *PWNODE_SINGLE_ITEM;
typedef struct tagWNODE_METHOD_ITEM
{
struct _WNODE_HEADER WnodeHeader;
ULONG OffsetInstanceName;
ULONG InstanceIndex; 
ULONG MethodId; 
ULONG DataBlockOffset; 
ULONG SizeDataBlock; 
UCHAR VariableData[1];
} WNODE_METHOD_ITEM, *PWNODE_METHOD_ITEM;
typedef struct tagWNODE_EVENT_ITEM
{
struct _WNODE_HEADER WnodeHeader;
} WNODE_EVENT_ITEM, *PWNODE_EVENT_ITEM;
typedef struct tagWNODE_EVENT_REFERENCE
{
struct _WNODE_HEADER WnodeHeader;
GUID TargetGuid;
ULONG TargetDataBlockSize;
union
{
ULONG TargetInstanceIndex;
WCHAR TargetInstanceName[1];
};
} WNODE_EVENT_REFERENCE, *PWNODE_EVENT_REFERENCE;
typedef struct tagWNODE_TOO_SMALL
{
struct _WNODE_HEADER WnodeHeader;
ULONG SizeNeeded; 
} WNODE_TOO_SMALL, *PWNODE_TOO_SMALL;
typedef struct
{
GUID Guid; 
ULONG Flags; 
ULONG InstanceCount; 
union
{
ULONG InstanceNameList;
ULONG BaseNameOffset;
ULONG_PTR Pdo;
ULONG_PTR InstanceInfo;
};
} WMIREGGUIDW, *PWMIREGGUIDW;
typedef WMIREGGUIDW WMIREGGUID;
typedef PWMIREGGUIDW PWMIREGGUID;
#define WMIREG_FLAG_EXPENSIVE 1
#define WMIREG_FLAG_INSTANCE_LIST 4
#define WMIREG_FLAG_INSTANCE_BASENAME 8
#define WMIREG_FLAG_INSTANCE_PDO 32
#define WMIREG_FLAG_REMOVE_GUID 0x10000
#define WMIREG_FLAG_RESERVED1 0x20000
#define WMIREG_FLAG_RESERVED2 0x40000
#define WMIREG_FLAG_TRACED_GUID 0x80000
#define WMIREG_FLAG_TRACE_CONTROL_GUID 4096
#define WMIREG_FLAG_EVENT_ONLY_GUID 64
typedef struct
{
ULONG BufferSize;
ULONG NextWmiRegInfo; 
ULONG RegistryPath; 
ULONG MofResourceName;
ULONG GuidCount;
WMIREGGUIDW WmiRegGuid[1]; 
} WMIREGINFOW, *PWMIREGINFOW;
typedef WMIREGINFOW WMIREGINFO;
typedef PWMIREGINFOW PWMIREGINFO;
typedef enum
{
#ifndef _WMIKM_
WMI_GET_ALL_DATA=0,
WMI_GET_SINGLE_INSTANCE=1,
WMI_SET_SINGLE_INSTANCE=2,
WMI_SET_SINGLE_ITEM=3,
WMI_ENABLE_EVENTS=4,
WMI_DISABLE_EVENTS=5,
WMI_ENABLE_COLLECTION=6,
WMI_DISABLE_COLLECTION=7,
WMI_REGINFO=8,
WMI_EXECUTE_METHOD=9
#endif
} WMIDPREQUESTCODE;
#if defined(_WINNT_) || defined(WINNT)
#ifndef _WMIKM_
#define WMI_GUIDTYPE_TRACECONTROL 0
#define WMI_GUIDTYPE_TRACE 1
#define WMI_GUIDTYPE_DATA 2
#define WMI_GUIDTYPE_EVENT 3
#endif
#define WMIGUID_QUERY 1
#define WMIGUID_SET 2
#define WMIGUID_NOTIFICATION 4
#define WMIGUID_READ_DESCRIPTION 8
#define WMIGUID_EXECUTE 16
#define TRACELOG_CREATE_REALTIME 32
#define TRACELOG_CREATE_ONDISK 64
#define TRACELOG_GUID_ENABLE 128
#define TRACELOG_ACCESS_KERNEL_LOGGER 256
#define TRACELOG_CREATE_INPROC 512
#define TRACELOG_ACCESS_REALTIME 1024
#define WMIGUID_ALL_ACCESS (STANDARD_RIGHTS_READ|WMIGUID_QUERY|WMIGUID_SET|WMIGUID_NOTIFICATION|WMIGUID_READ_DESCRIPTION|WMIGUID_EXECUTE|TRACELOG_CREATE_REALTIME|TRACELOG_CREATE_ONDISK|TRACELOG_GUID_ENABLE|TRACELOG_ACCESS_KERNEL_LOGGER|TRACELOG_CREATE_INPROC|TRACELOG_ACCESS_REALTIME)
#define WMI_GLOBAL_LOGGER_ID 1
#endif
#endif
