#ifndef _WS2TCPIP_H_
#define _WS2TCPIP_H_
struct ip_mreq {
struct in_addr imr_multiaddr; 
struct in_addr imr_interface; 
};
struct ip_mreq_source {
struct in_addr imr_multiaddr; 
struct in_addr imr_sourceaddr; 
struct in_addr imr_interface; 
};
struct ip_msfilter {
struct in_addr imsf_multiaddr; 
struct in_addr imsf_interface; 
u_long imsf_fmode; 
u_long imsf_numsrc; 
struct in_addr imsf_slist[1];
};
#define IP_MSFILTER_SIZE(numsrc) \
(sizeof(struct )-sizeof(struct ) + (numsrc)*sizeof(struct ))
#define MCAST_INCLUDE 0
#define MCAST_EXCLUDE 1
#define SIO_GET_INTERFACE_LIST _IOR('t',127,u_long)
#define SIO_GET_INTERFACE_LIST_EX _IOR('t',126,u_long)
#define SIO_SET_MULTICAST_FILTER _IOW('t',125,u_long)
#define SIO_GET_MULTICAST_FILTER _IOW('t',124 | IOC_IN,u_long)
#define IP_OPTIONS 1 
#define IP_HDRINCL 2 
#define IP_TOS 3 
#define IP_TTL 4 
#define IP_MULTICAST_IF 9 
#define IP_MULTICAST_TTL 10 
#define IP_MULTICAST_LOOP 11 
#define IP_ADD_MEMBERSHIP 12 
#define IP_DROP_MEMBERSHIP 13
#define IP_DONTFRAGMENT 14 
#define IP_ADD_SOURCE_MEMBERSHIP 15 
#define IP_DROP_SOURCE_MEMBERSHIP 16 
#define IP_BLOCK_SOURCE 17 
#define IP_UNBLOCK_SOURCE 18 
#define IP_PKTINFO 19 
#define IPV6_HDRINCL 2 
#define IPV6_UNICAST_HOPS 4 
#define IPV6_MULTICAST_IF 9 
#define IPV6_MULTICAST_HOPS 10 
#define IPV6_MULTICAST_LOOP 11 
#define IPV6_ADD_MEMBERSHIP 12 
#define IPV6_DROP_MEMBERSHIP 13 
#define IPV6_JOIN_GROUP IPV6_ADD_MEMBERSHIP
#define IPV6_LEAVE_GROUP IPV6_DROP_MEMBERSHIP
#define IPV6_PKTINFO 19 
#define UDP_NOCHECKSUM 1
#define UDP_CHECKSUM_COVERAGE 20 
#define TCP_EXPEDITED_1122 2
#ifndef s6_addr
struct in6_addr {
union {
u_char Byte[16];
u_short Word[8];
} u;
};
#define in_addr6 in6_addr
#define _S6_un u
#define _S6_u8 Byte
#define s6_addr _S6_un._S6_u8
#define s6_bytes u.Byte
#define s6_words u.Word
#endif
typedef struct ipv6_mreq {
struct in6_addr ipv6mr_multiaddr; 
unsigned int ipv6mr_interface; 
} IPV6_MREQ;
struct sockaddr_in6_old {
short sin6_family; 
u_short sin6_port; 
u_long sin6_flowinfo; 
struct in6_addr sin6_addr; 
};
struct sockaddr_in6 {
short sin6_family; 
u_short sin6_port; 
u_long sin6_flowinfo; 
struct in6_addr sin6_addr; 
u_long sin6_scope_id; 
};
typedef struct in6_addr IN6_ADDR;
typedef struct in6_addr *PIN6_ADDR;
typedef struct in6_addr *LPIN6_ADDR;
typedef struct sockaddr_in6 SOCKADDR_IN6;
typedef struct sockaddr_in6 *PSOCKADDR_IN6;
typedef struct sockaddr_in6 *LPSOCKADDR_IN6;
#define SS_PORT(ssp) (((struct sockaddr_in*)(ssp))->sin_port)
#define IN6ADDR_ANY_INIT { 0 }
#define IN6ADDR_LOOPBACK_INIT { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 }
#ifdef __cplusplus
extern "C" {
#endif
extern const struct in6_addr in6addr_any;
extern const struct in6_addr in6addr_loopback;
#ifdef __cplusplus
}
#endif
#define WS2TCPIP_INLINE inline
#define IN6ADDR_SETANY(x) {\
(x)->sin6_family=AF_INET6; \
(x)->sin6_port=0; \
(x)->sin6_flowinfo=0; \
*((u_long *)((x)->sin6_addr.s6_addr))=0; \
*((u_long *)((x)->sin6_addr.s6_addr) + 1)=0; \
*((u_long *)((x)->sin6_addr.s6_addr) + 2)=0; \
*((u_long *)((x)->sin6_addr.s6_addr) + 3)=0; \
}
#define IN6ADDR_SETLOOPBACK(x) {\
(x)->sin6_family=AF_INET6; \
(x)->sin6_port=0; \
(x)->sin6_flowinfo=0; \
*((u_long *)((x)->sin6_addr.s6_addr))=0; \
*((u_long *)((x)->sin6_addr.s6_addr) + 1)=0; \
*((u_long *)((x)->sin6_addr.s6_addr) + 2)=0; \
*((u_long *)((x)->sin6_addr.s6_addr) + 3)=1; \
}
#define IN6ADDR_ISANY(x) (\ (x)->sin6_family== AF_INET6 && \ *((u_long *)((x)->sin6_addr.s6_addr))== 0 && \ *((u_long *)((x)->sin6_addr.s6_addr) + 1)== 0 && \ *((u_long *)((x)->sin6_addr.s6_addr) + 2)== 0 && \ *((u_long *)((x)->sin6_addr.s6_addr) + 3)== 0 \ )
#define IN6ADDR_ISLOOPBACK(x) (\ (x)->sin6_family== AF_INET6 && \ *((u_long *)((x)->sin6_addr.s6_addr))== 0 && \ *((u_long *)((x)->sin6_addr.s6_addr) + 1)== 0 && \ *((u_long *)((x)->sin6_addr.s6_addr) + 2)== 0 && \ *((u_long *)((x)->sin6_addr.s6_addr) + 3)== 1 \ )
WS2TCPIP_INLINE int
IN6_ADDR_EQUAL(const struct in6_addr *a,const struct in6_addr *b)
{
return (memcmp(a,b,sizeof(struct in6_addr))== 0);
}
#define IN6_IS_ADDR_UNSPECIFIED(a) IN6_ADDR_EQUAL((a),&in6addr_any)
#define IN6_IS_ADDR_LOOPBACK(a) IN6_ADDR_EQUAL((a),&in6addr_loopback)
WS2TCPIP_INLINE int
IN6_IS_ADDR_MULTICAST(const struct in6_addr *a)
{
return (a->s6_bytes[0]== 255);
}
WS2TCPIP_INLINE int
IN6_IS_ADDR_LINKLOCAL(const struct in6_addr *a)
{
return ((a->s6_bytes[0]== 254) && ((a->s6_bytes[1] & 192)== 128));
}
WS2TCPIP_INLINE int
IN6_IS_ADDR_SITELOCAL(const struct in6_addr *a)
{
return ((a->s6_bytes[0]== 254) && ((a->s6_bytes[1] & 192)== 192));
}
WS2TCPIP_INLINE int
IN6_IS_ADDR_V4MAPPED(const struct in6_addr *a)
{
return ((a->s6_words[0]== 0) && (a->s6_words[1]== 0) && (a->s6_words[2]== 0) && (a->s6_words[3]== 0) && (a->s6_words[4]== 0) && (a->s6_words[5]== 0xffff));
}
WS2TCPIP_INLINE int
IN6_IS_ADDR_V4COMPAT(const struct in6_addr *a)
{
return ((a->s6_words[0]== 0) && (a->s6_words[1]== 0) && (a->s6_words[2]== 0) && (a->s6_words[3]== 0) && (a->s6_words[4]== 0) && (a->s6_words[5]== 0) && !((a->s6_words[6]== 0) && (a->s6_addr[14]== 0) && ((a->s6_addr[15]== 0) || (a->s6_addr[15]== 1))));
}
WS2TCPIP_INLINE int
IN6_IS_ADDR_MC_NODELOCAL(const struct in6_addr *a)
{
return IN6_IS_ADDR_MULTICAST(a) && ((a->s6_bytes[1] & 15)== 1);
}
WS2TCPIP_INLINE int
IN6_IS_ADDR_MC_LINKLOCAL(const struct in6_addr *a)
{
return IN6_IS_ADDR_MULTICAST(a) && ((a->s6_bytes[1] & 15)== 2);
}
WS2TCPIP_INLINE int
IN6_IS_ADDR_MC_SITELOCAL(const struct in6_addr *a)
{
return IN6_IS_ADDR_MULTICAST(a) && ((a->s6_bytes[1] & 15)== 5);
}
WS2TCPIP_INLINE int
IN6_IS_ADDR_MC_ORGLOCAL(const struct in6_addr *a)
{
return IN6_IS_ADDR_MULTICAST(a) && ((a->s6_bytes[1] & 15)== 8);
}
WS2TCPIP_INLINE int
IN6_IS_ADDR_MC_GLOBAL(const struct in6_addr *a)
{
return IN6_IS_ADDR_MULTICAST(a) && ((a->s6_bytes[1] & 15)== 14);
}
typedef union sockaddr_gen{
struct sockaddr Address;
struct sockaddr_in AddressIn;
struct sockaddr_in6_old AddressIn6;
} sockaddr_gen;
typedef struct _INTERFACE_INFO
{
u_long iiFlags; 
sockaddr_gen iiAddress; 
sockaddr_gen iiBroadcastAddress; 
sockaddr_gen iiNetmask; 
} INTERFACE_INFO,FAR *LPINTERFACE_INFO;
typedef struct _INTERFACE_INFO_EX
{
u_long iiFlags; 
SOCKET_ADDRESS iiAddress; 
SOCKET_ADDRESS iiBroadcastAddress; 
SOCKET_ADDRESS iiNetmask; 
} INTERFACE_INFO_EX,FAR *LPINTERFACE_INFO_EX;
#define IFF_UP 1
#define IFF_BROADCAST 2
#define IFF_LOOPBACK 4
#define IFF_POINTTOPOINT 8
#define IFF_MULTICAST 16
typedef struct in_pktinfo {
IN_ADDR ipi_addr; 
UINT ipi_ifindex; 
} IN_PKTINFO;
//C_ASSERT(sizeof(IN_PKTINFO)== 8);
typedef struct in6_pktinfo {
IN6_ADDR ipi6_addr; 
UINT ipi6_ifindex; 
} IN6_PKTINFO;
//C_ASSERT(sizeof(IN6_PKTINFO)== 20);
#define EAI_AGAIN WSATRY_AGAIN
#define EAI_BADFLAGS WSAEINVAL
#define EAI_FAIL WSANO_RECOVERY
#define EAI_FAMILY WSAEAFNOSUPPORT
#define EAI_MEMORY WSA_NOT_ENOUGH_MEMORY
#define EAI_NONAME WSAHOST_NOT_FOUND
#define EAI_SERVICE WSATYPE_NOT_FOUND
#define EAI_SOCKTYPE WSAESOCKTNOSUPPORT
#define EAI_NODATA EAI_NONAME
typedef struct addrinfo {
int ai_flags; 
int ai_family; 
int ai_socktype; 
int ai_protocol; 
size_t ai_addrlen; 
char *ai_canonname; 
struct sockaddr *ai_addr; 
struct addrinfo *ai_next; 
} ADDRINFO, *LPADDRINFO;
#define AI_PASSIVE 1
#define AI_CANONNAME 2
#define AI_NUMERICHOST 4
WINSOCK_API_LINKAGE
int WSAAPI getaddrinfo(const char * nodename,const char * servname,const struct addrinfo * hints,struct addrinfo * * res );
#if INCL_WINSOCK_API_TYPEDEFS
typedef int (WSAAPI *LPFN_GETADDRINFO)(const char * nodename,const char * servname,const struct addrinfo * hints,struct addrinfo * * res );
#endif
WINSOCK_API_LINKAGE
void WSAAPI freeaddrinfo(struct addrinfo * ai );
#if INCL_WINSOCK_API_TYPEDEFS
typedef void (WSAAPI *LPFN_FREEADDRINFO)(struct addrinfo * ai );
#endif
#if INCL_WINSOCK_API_PROTOTYPES
#ifdef UNICODE
#define gai_strerror gai_strerrorW
#else
#define gai_strerror gai_strerrorA
#endif 
#define GAI_STRERROR_BUFFER_SIZE 1024
WS2TCPIP_INLINE
char *
gai_strerrorA(int )
{
DWORD dwMsgLen;
static char buff[GAI_STRERROR_BUFFER_SIZE + 1];
dwMsgLen=FormatMessageA(FORMAT_MESSAGE_FROM_SYSTEM |FORMAT_MESSAGE_IGNORE_INSERTS |FORMAT_MESSAGE_MAX_WIDTH_MASK,NULL,ecode,MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),(LPSTR)buff,GAI_STRERROR_BUFFER_SIZE,NULL);
return buff;
}
WS2TCPIP_INLINE
WCHAR *
gai_strerrorW(int ecode )
{
DWORD dwMsgLen;
static WCHAR buff[GAI_STRERROR_BUFFER_SIZE + 1];
dwMsgLen=FormatMessageW(FORMAT_MESSAGE_FROM_SYSTEM |FORMAT_MESSAGE_IGNORE_INSERTS |FORMAT_MESSAGE_MAX_WIDTH_MASK,NULL,ecode,MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),(LPWSTR)buff,GAI_STRERROR_BUFFER_SIZE,NULL);
return buff;
}
#endif 
typedef int socklen_t;
WINSOCK_API_LINKAGE
int WSAAPI getnameinfo(const struct sockaddr * sa,socklen_t ,char *,DWORD ,char *,DWORD ,int flags );
#if INCL_WINSOCK_API_TYPEDEFS
typedef int (WSAAPI *LPFN_GETNAMEINFO)(const struct sockaddr * sa,socklen_t ,char *,DWORD ,char *,DWORD ,int flags );
#endif
#define NI_MAXHOST 1025 
#define NI_MAXSERV 32 
#define INET_ADDRSTRLEN 16 
#define INET6_ADDRSTRLEN 46 
#define NI_NOFQDN 1
#define NI_NUMERICHOST 2
#define NI_NAMEREQD 4
#define NI_NUMERICSERV 8
#define NI_DGRAM 16
#if !defined(_WIN32_WINNT) || (_WIN32_WINNT <= 1280)
#include <wspiapi.h>
#endif
#endif 
