#include <complex.h>
double _Complex c_polar(double r, double t);
long double _Complex c_polarl(long double r, long double t);
float _Complex c_polarf(float r,float t);
long double _Complex clogl(long double _Complex z)
{
        long double _Complex w;
        long double p, rr;

        /*rr = sqrt( z->r * z->r  +  z->i * z->i );*/
        rr = cabsl(z);
        p = logl(rr);
        rr = atan2l( z.im, z.re );
        w.im = rr;
        w.re = p;
        return w;
}
#undef cexp
double _Complex cexp(const double _Complex z)
{
	double complex w;
	double r, x, y;

	x = creal (z);
	y = cimag (z);
	r = exp (x);
	w.re = r * cos (y);
	w.im = r * sin (y);
	return (w);
}

float _Complex cexpf(const float _Complex z)
{
	float complex w;
	float r, x, y;

	x = crealf (z);
	y = cimagf(z);
	r = exp (x);
	w.re = r * cos (y);
	w.im = r * sin (y);
	return (w);

}

long double _Complex cexpl(const long double _Complex z)
{
	long double complex w;
	long double r, x, y;
	
	x = creall(z);
	y = cimagl(z);
	r = expl(x);
	w.re = r * cosl(y);
	w.im = r * sinl(y);
	return w;
}

#undef clog
double _Complex clog(double _Complex z)
{
        double _Complex w;
        double p, rr;

        /*rr = sqrt( z->r * z->r  +  z->i * z->i );*/
        rr = cabsl((long double _Complex)z);
        p = logl(rr);
        rr = atan2l( z.im, z.re );
        w.im = rr;
        w.re = p;
        return w;
}

#undef cpow
double _Complex cpow(const double _Complex x, const double _Complex y)
{
        double logr = log (cabsl((long double _Complex)x));
        double t = carg (x);

        return c_polar (exp (logr * y.re - y.im * t),
                y.im * logr + y.re * t);
}

long double _Complex cpowl(const long double _Complex x, const long double _Complex y)
{
        long double logr = log (cabsl(x));
        long double t = cargl(x);

        return c_polarl(expl(logr * y.re - y.im * t),
                y.im * logr + y.re * t);
}

long double _Complex cpowld(const long double _Complex x,double y)
{
	long double logr = log(cabsl(x));
	long double t = cargl(x);

	return c_polarl(expl(logr * y),
		y * t);
}

long double _Complex cpowll(const long double _Complex x,long double y)
{
	long double logr = log(cabsl(x));
	long double t = cargl(x);

	return c_polarl(expl(logr * y),
		y * t);
}
