#include <complex.h>

long double _Complex EXPORT csqrtl(long double _Complex z)
{
	long double r,s;
	long double x,y;
	long double _Complex result;
	x = fabs(z.re);
	y = fabs(z.im);
	if(x>=y) {
		if(x==0) {
			return 0;
		}
		r = x;
		s = y/x;
	}
	else {
		r = y;
		s = x/y;
	}
	r *= sqrt(1+ s*s);
	if(z.re>0) {
		result.re = sqrt((r+z.re)/2);
		result.im = z.im/(2* result.re);
	}
	else {
		result.im = sqrt((r-z.re)/2);
		if(z.im<0)
			result.im = -result.im;
		result.re = z.im/(2* result.im);
	}
	return result;
}

#undef csqrt
double _Complex EXPORT csqrt(double _Complex x)
{
	long double _Complex s = (long double _Complex)x;
	double _Complex result;

	s = csqrtl(s);
	result = (double _Complex)s;
	return result;
}
