#ifndef __bitstring_h__
#define __bitstring_h__
#include <malloc.h>
#include <stdio.h>
#include <list.h>
#include <stdbool.h>
typedef struct _bitstring {
	size_t count;	// count in bits;
	char *Data;
} Bitstring;
Bitstring *new_bitstring(size_t bitlen);
Bitstring *get_subrange_bitstring(Bitstring *bs,size_t start,size_t end);
int equal_bitstring(Bitstring bsl,Bitstring bsr);
int less_equal_bitstring(Bitstring bsl,Bitstring bsr);
Bitstring * shiftleft_bitstring(Bitstring *bs,int shift);
Bitstring * shiftright_bitstring(Bitstring *bs,int shift);
int sprint_bitstring(Bitstring *b,size_t bufsiz,char *buf);
int fprint_bitstring(Bitstring *b,FILE *out);
int countbits(int);
#ifndef __ANSIC_ONLY__
bool operator[](Bitstring *bs,size_t position);
bool operator []=(Bitstring *bs,size_t position,bool b);
int operator <=(Bitstring bsl,Bitstring bsr);
int operator ==(Bitstring bsl,Bitstring bsr);
Bitstring * operator>>(Bitstring *bs,int shift);
Bitstring * operator<<(Bitstring *bs,int shift);
Bitstring * operator^(Bitstring &bs1,Bitstring &bs2);
Bitstring * operator & (Bitstring *bsl,Bitstring *bsr);
Bitstring * operator | (Bitstring *bsl,Bitstring *bsr);
#endif
bool set_element_bitstring(Bitstring *bs,size_t position,bool b);
size_t get_size_bitstring(Bitstring *b);
Bitstring *copy_bitstring(Bitstring *b);
void delete_bitstring(Bitstring *b);
int Sizeof_bitstring(Bitstring *);
#ifndef __ANSIC_ONLY__
#define makeToBitstring(T) Bitstring  * overloaded ToBitstring(T a)
makeToBitstring(int);
makeToBitstring(double);
makeToBitstring(long double);
makeToBitstring(char *);
#undef makeToBitstring
#endif
#endif
