#include <stdio.h>
#include <windows.h>
#include <wincrypt.h>
#define MY_ENCODING_TYPE  (PKCS_7_ASN_ENCODING | X509_ASN_ENCODING)
#include "str.h"
#include "str_private.h"
int Strdecrypt(String &src)
{

	HCRYPTMSG hMsg;
	unsigned int cbDecoded;
	char *pbDecoded;
	unsigned cbEncodedBlob = Strlen(src);
	char *pbEncodedBlob = src.content;
	StringA result;
	// Open a message for decoding.

	hMsg = CryptMsgOpenToDecode(
		MY_ENCODING_TYPE,      // Encoding type.
		0,                     // Flags.
		CMSG_DATA,             // Look for a data message.
		0LL,                  // Cryptographic provider.
		NULL,                  // Recipient information.
		NULL);
	if (!hMsg)                 // Stream information.
    {
		return 0;
	}
	//--------------------------------------------------------------------
	// Update the message with an encoded BLOB.
	// Both pbEncodedBlob, the encoded data,
	// and cbEncodedBlob, the length of the encoded data,
	// must be available.


	if(!CryptMsgUpdate(
		hMsg,                 // Handle to the message
		pbEncodedBlob,        // Pointer to the encoded BLOB
		cbEncodedBlob,        // Size of the encoded BLOB
		TRUE))                // Last call


    {
		return 0;
	}
	//--------------------------------------------------------------------
	// Get the size of the content.

	if(!CryptMsgGetParam(
		hMsg,                  // Handle to the message
		CMSG_CONTENT_PARAM,    // Parameter type
		0,                     // Index
		NULL,                  // Address for returned
		// information
		&cbDecoded))           // Size of the returned
    {
		return (0);
	}
	//--------------------------------------------------------------------
	// Allocate memory.

	pbDecoded = allocate_proper_space(cbDecoded+1,1);
	//--------------------------------------------------------------------
	// Get a pointer to the content.

	if(!CryptMsgGetParam(
		hMsg,                  // Handle to the message
		CMSG_CONTENT_PARAM,    // Parameter type
		0,                     // Index
		pbDecoded,             // Address for returned
		// information
		&cbDecoded))           // Size of the returned
    {
		return 0;
	}
	//--------------------------------------------------------------------
	// Clean up.

	if(hMsg)
		CryptMsgClose(hMsg);
	src.capacity = cbDecoded+1;
	src.count = cbDecoded;
	src.content = pbDecoded;
	return 1;
}

int Strencrypt(String &src)
{
	HCRYPTMSG hMsg;
	BYTE* pbContent;     // A byte pointer to the message
	DWORD cbContent;     // The size of message
	DWORD cbEncodedBlob;
	BYTE *pbEncodedBlob;

	pbContent = (BYTE*) src.content;
	cbContent = src.count;
	// Get the size of the encoded message BLOB.
	cbEncodedBlob = CryptMsgCalculateEncodedLength(
		MY_ENCODING_TYPE,       // Message encoding type
		0,                      // Flags
		CMSG_DATA,              // Message type
		NULL,                   // Pointer to structure
		NULL,                   // Inner content object ID
		cbContent);
	if (!cbEncodedBlob)             // Size of content
		return 0;
	// Allocate memory for the encoded BLOB.
	pbEncodedBlob = (BYTE *) allocate_proper_space(cbEncodedBlob+1,1);
	// Open a message to encode.
	hMsg = CryptMsgOpenToEncode( MY_ENCODING_TYPE,        // Encoding type
		0,                       // Flags
		CMSG_DATA,               // Message type
		NULL,                    // Pointer to structure
		NULL,                    // Inner content object ID
		NULL);
	if (!hMsg)                   // Stream information (not used)
		return 0;
	// Update the message with the data.
	if(!CryptMsgUpdate(
		hMsg,         // Handle to the message
		pbContent,    // Pointer to the content
		cbContent,    // Size of the content
		TRUE))        // Last call
		return 0;
	// Get the resulting message.
	if(!CryptMsgGetParam(
		hMsg,                      // Handle to the message
		CMSG_BARE_CONTENT_PARAM,   // Parameter type
		0,                         // Index
		pbEncodedBlob,             // Pointer to the BLOB
		&cbEncodedBlob))           // Size of the BLOB
		return 0;
	// pbEncodedBlob now points to the encoded, signed content.
	// Close the message.
	if(hMsg)
		CryptMsgClose(hMsg);
	src.capacity = cbEncodedBlob+1;
	src.count = cbEncodedBlob;
	src.content = pbEncodedBlob;
	return 1;
}
