/* -----------------------------------------------------------------------
   Q runtime library
   -----------------

   List routines
   ---------------
   Private definitions containing the implementation of the list functions
--------------------------------------------------------------------------
*/
#include "list.h"
/*
 Definition of the opaque structure list.
*/

typedef struct _link {
	struct _link *Next;
	void *Data;
} link;

/*
This starts the list of list links, that is augmented when a list is freed.
*/
static link *free_list;

/*
Definition of the list implementation
*/
struct _list {
        size_t size;                    /* in elements units */
		link *Last;                     /* The last item */
        Malloc_Function_Type pmalloc;   /* routine to allocate memory */
        Free_Function_Type pfree;       /* routine to free memory */
        link *First;                    /* The contents of the list start here */
};

link *new_link(Malloc_Function_Type pmalloc);

