#include <gc.h>
#include "stack.h"
#include <string.h>
#include <stdlib.h>
#include <stdbool.h>
struct _stack {
	int count;
	struct element {
		struct element *Next;
		void *Data;
	} *head;
};

stack *new_stack(void)
{
	stack *result = GC_malloc(sizeof(stack));
	memset(result,0,sizeof(stack));
	return result;
}

void push_stack(stack *s,void *data)
{
	struct element *t;
	if (s == NULL)
		return;
	t = GC_malloc(sizeof(struct element));
	if (t == NULL)
		return;
	t->Data = data;
	t->Next = s->head;
	s->head = t;
	s->count++;
}

void *pop_stack(stack *s)
{
	void *x;
	struct element *t;
	if (s == NULL)
		return NULL;
	if (s->count <= 0)
		return NULL;
	t = s->head;
	x = t->Data;
	s->head = t->Next;
	s->count--;
	return x;
}

size_t get_size_stack(stack *s)
{
	return s->count;
}

void dispose_stack(stack &s)
{
	memset(&s,0,sizeof(stack));
}

stack *copy_stack(stack *s)
{
	stack *result = GC_malloc(sizeof(stack));
	struct element *t = s->head,*u,*v;

	if (result == NULL)
		return NULL;
	memcpy(result,s,sizeof(stack));
	if (t == NULL)
		return result;
	u = GC_malloc(sizeof(struct element));
	result->head = u;
	u->Data = t->Data;
	u->Next = NULL;
	t = t->Next;
	result->count = 1;
	while (t) {
		v = GC_malloc(sizeof(struct element));
		if (v == NULL) {
			dispose_stack(*result);
			return NULL;
		}
		u->Next = v;
		v->Data = t->Data;
		u = v;
		t = t->Next;
		result->count++;
	}
	return result;
}


