#include "str.h"
#include "exceptions.h"
#include "str_private.h"

/* filtering */
StringW EXPORT overloaded Strfilter(StringW & from, bool (*pred_fun) (int))
{
	StringW result;

	require(StrvalidW(from) && (pred_fun != NULL));
	result.content = allocate_proper_space((1+from.count),
		                                   sizeof(*(result.content)));
	if (result.content == NULL) {
		memset(&result,0,sizeof(result));
		return result;
	}
	result.capacity = 1+from.count;
	int j = 0;
	for(int i = 0; i < from.count; ++i){
		if (pred_fun (from[i])){
			result.content[ j] =  from.content[i];
			++j;
		}
	}
	result.count = j;
	return result;
}

StringA EXPORT overloaded Strfilter(StringA & from, bool (*pred_fun) (int))
{
	StringA result;

	require(StrvalidA(from) && (pred_fun != NULL));
	result.content = allocate_proper_space(1+from.count,sizeof(*(result.content)));
	if (result.content == NULL) {
		memset(&result,0,sizeof(result));
		return result;
	}
	result.capacity = 1+from.count;
	int j = 0;
	for (int i = 0; i < from.count; ++i){
		if (pred_fun (from[i])){
			result.content[j++] =  from.content[i];
		}
	}
	result.count = j;
	return result;
}

StringA EXPORT overloaded Strfilter(StringA & from, char *set)
{
	StringA result;
	int setlength;

	require(StrvalidA(from) && set != NULL);
	setlength = strlen(set);
	result.content = allocate_proper_space(1+from.count,sizeof(*(result.content)));
	if (result.content == NULL) {
		memset(&result,0,sizeof(result));
		return result;
	}
	if (result.content == NULL)
	result.capacity = 1+from.count;
	int j = 0;
	for(int i = 0; i < from.count; ++i) {
		for (int k=0; k<setlength;k++) {
			if (from.content[i] == set[k]) {
				result.content[j++] =  set[k];
				break;
			}
		}
	}
	result.count = j;
	return result;
}
StringA EXPORT overloaded Strfilter(StringA & from, StringA &set)
{
	return Strfilter(from,set.content);
}

StringW EXPORT overloaded Strfilter(StringW & from, wchar_t *set)
{
	StringW result;
	int setlength;

	require(StrvalidW(from) && set != NULL);
	setlength = wcslen(set);
	result.content = allocate_proper_space(1+from.count,sizeof(*(result.content)));
	if (result.content == NULL) {
		memset(&result,0,sizeof(result));
		return result;
	}
	result.capacity = 1+from.count;
	int j = 0;
	for(int i = 0; i < from.count; ++i) {
		for (int k=0; k<setlength;k++) {
			if (from.content[i] == set[k]) {
				result.content[j++] =  set[k];
				break;
			}
		}
	}
	result.count = j;
	return result;
}

StringW EXPORT overloaded Strfilter(StringW & from, StringW &set)
{
	return Strfilter(from,set.content);
}


