#include "str.h"
#include "exceptions.h"
#include "str_private.h"
#ifdef __DLL__
#define EXPORT __declspec(dllexport)
#else
#define EXPORT
#endif

size_t EXPORT overloaded Strcspn(StringA & s1, const StringA &s2)
{
	/* error checking */
	size_t result = 0;
	int code = 0;

	require(StrvalidA(s1) && StrvalidA(s2));
	result = (size_t)Strfind_first_of(s1, s2);
	if (result == (size_t)-1){
		result = s1.count;
	}
	return result;
}

size_t EXPORT overloaded Strcspn(StringW & s1, const StringW &s2)
{
	/* error checking */
	size_t result = 0;
	int code = 0;

	require(StrvalidW(s1) && StrvalidW(s2));
	result = (size_t)Strfind_first_of(s1, s2);
	if (result == (size_t)-1){
		result = s1.count;
	}
	return result;
}


int overloaded Strfind_first_of(StringA &s,StringA &set)
{
	require(StrvalidA(s) && StrvalidA(set));
	char *strcontents = s.content,*p;
	int i,j,count = s.count,setcount = set.count;
	int c;

	if (set.count == 0 || s.count == 0)
		return -1;
	for (i=0; i<count;i++) {
		p = set.content;
		c = strcontents[i];
		for (j=0; j<setcount;j++) {
			if (c == p[j])
				return i;
		}
	}
	return -1;
}

int overloaded Strfind_first_of(StringW &s,StringW &set)
{
	require(StrvalidW(s) && StrvalidW(set));
	wchar_t *strcontents = s.content,*p;
	int i,j,count = s.count,setcount = set.count;
	int c;

	if (set.count == 0 || s.count == 0)
		return -1;
	for (i=0; i<count;i++) {
		p = set.content;
		c = strcontents[i];
		for (j=0; j<setcount;j++) {
			if (c == p[j])
				return i;
		}
	}
	return -1;
}

int overloaded Strfind_first_of(StringA &s,char *set)
{
	StringA d;
	require(set != NULL);

	d.count = strlen(set);
	d.capacity = d.count+1;
	d.content = set;
	return Strfind_first_of(s,d);
}

int overloaded Strfind_first_of(StringW &s,wchar_t *set)
{
	StringW d;

	require(set != NULL);
	d.count = wcslen(set);
	d.capacity = d.count+1;
	d.content = set;
	return Strfind_first_of(s,d);
}


int overloaded Strfind_last_of(StringA &s,StringA &set)
{
	require(StrvalidA(s) && StrvalidA(set));
	char *strcontents = s.content,*p;
	int i,j,count = s.count,setcount = set.count;

	if (set.count == 0 || s.count == 0)
		return -1;
	for (i=count-1; i>= 0;i--) {
		p = set.content;
		for (j=setcount-1; j>=0;j--) {
			if (strcontents[i] == p[j])
				return i;
		}
	}
	return -1;
}

int overloaded Strfind_last_of(StringW &s,StringW &set)
{
	require(StrvalidW(s) && StrvalidW(set));
	wchar_t *strcontents = s.content,*p;
	int i,j,count = s.count,setcount = set.count;

	if (set.count == 0 || s.count == 0)
		return -1;
	for (i=count-1; i>= 0;i--) {
		p = set.content;
		for (j=setcount-1; j>=0;j--) {
			if (strcontents[i] == p[j])
				return i;
		}
	}
	return -1;
}


int overloaded Strfind_last_of(StringA &s,char *set)
{
	StringA d;
	require(set != NULL);

	d.count = strlen(set);
	d.capacity = d.count+1;
	d.content = set;
	return Strfind_last_of(s,d);
}

int overloaded Strfind_last_of(StringW &s,wchar_t *set)
{
	StringW d;
	require(set != NULL);

	d.count = wcslen(set);
	d.capacity = d.count+1;
	d.content = set;
	return Strfind_last_of(s,d);
}

int overloaded Strfind_first_not_of(StringA &s,StringA &set)
{
	require(StrvalidA(s) && StrvalidA(set));
	char *strcontents = s.content,*p;
	int i,j,count = s.count,setcount = set.count;
	int c;

	if (set.count == 0 || s.count == 0)
		return -1;
	for (i=0; i<count;i++) {
		p = set.content;
		c = strcontents[i];
		for (j=0; j<setcount;j++) {
			if (c == p[j])
				break;
		}
		if (j == setcount)
			return i;
	}
	return -1;
}

int overloaded Strfind_first_not_of(StringW &s,StringW &set)
{
	require(StrvalidW(s) && StrvalidW(set));
	wchar_t *strcontents = s.content,*p;
	int i,j,count = s.count,setcount = set.count;
	int c;

	if (set.count == 0 || s.count == 0)
		return -1;
	for (i=0; i<count;i++) {
		p = set.content;
		c = strcontents[i];
		for (j=0; j<setcount;j++) {
			if (c == p[j])
				break;
		}
		if (j == setcount)
			return i;
	}
	return -1;
}

int overloaded Strfind_first_not_of(StringA &s,char *set)
{
	StringA d;
	require(set != NULL);

	d.count = strlen(set);
	d.capacity = d.count+1;
	d.content = set;
	return Strfind_first_not_of(s,d);
}

int overloaded Strfind_first_not_of(StringW &s,wchar_t *set)
{
	StringW d;

	require(set != NULL);
	d.count = wcslen(set);
	d.capacity = d.count+1;
	d.content = set;
	return Strfind_first_not_of(s,d);
}

int overloaded Strfind_last_not_of(StringA &s,StringA &set)
{
	require(StrvalidA(s) && StrvalidA(set));
	char *strcontents = s.content,*p;
	int i,j,c,count = s.count,setcount = set.count;

	if (set.count == 0 || s.count == 0)
		return -1;
	for (i=count-1; i>= 0;i--) {
		p = set.content;
		c = strcontents[i];
		for (j=setcount-1; j>=0;j--) {
			if (c == p[j])
				break;
		}
		if (j < 0)
			return i;
	}
	return -1;
}

int overloaded Strfind_last_not_of(StringW &s,StringW &set)
{
	require(StrvalidW(s) && StrvalidW(set));
	wchar_t *strcontents = s.content,*p;
	int i,j,c,count = s.count,setcount = set.count;

	if (set.count == 0 || s.count == 0)
		return -1;
	for (i=count-1; i>= 0;i--) {
		p = set.content;
		c = strcontents[i];
		for (j=setcount-1; j>=0;j--) {
			if (c == p[j])
				break;
		}
		if (j < 0)
			return i;
	}
	return -1;
}


int overloaded Strfind_last_not_of(StringA &s,char *set)
{
	StringA d;
	require(set != NULL);
	d.count = strlen(set);
	d.capacity = d.count+1;
	d.content = set;
	return Strfind_last_not_of(s,d);
}

int overloaded Strfind_last_not_of(StringW &s,wchar_t *set)
{
	StringW d;
	require(set != NULL);

	d.count = wcslen(set);
	d.capacity = d.count+1;
	d.content = set;
	return Strfind_last_not_of(s,d);
}

/** Finds the first occurence of @a find_this in @a string.
@returns If found a valid String covering the String @a find_this
at it's first position otherwise and invalid stringp
*/
StringpA EXPORT overloaded Strstr(StringA & string, StringA & find_this)
{
	char *strp,*end;
	int first_char;

	require(StrvalidA(string) && StrvalidA(find_this));
	first_char = find_this.content[0];
	strp = memchr(string.content,first_char,string.count);
	if (strp) {
		end = string.content + string.count;
		while (strp < end) {
			if (!memcmp(strp,find_this.content,find_this.count))
				return new_stringpA(string,strp);
			else
				strp++;
		}
	}
	return invalid_stringpA;
}

StringpA EXPORT overloaded Strstr(StringpA s, char *set)
{
	StringA s1;
	StringpA result;

	require(set != NULL);
	s1.count = s.count;
	s1.capacity = s1.count+1;
	s1.content = s.content;
	result = Strstr(s1,set);
	if (result.count)
		result.parent = s.parent;
	return result;
}
StringpW EXPORT overloaded Strstr(StringpW s,wchar_t *set)
{
	StringW s1;
	StringpW result;

	require(set != NULL);
	s1.count = s.count;
	s1.capacity = s.count+1;
	s1.content = s.content;
	result = Strstr(s1,set);
	if (result.count)
		result.parent = s.parent;
	return result;
}

StringpA EXPORT overloaded Strstr(StringA & string, char *find_this)
{
	StringA d;

	require(find_this != NULL);
	d.count = strlen(find_this);
	d.capacity = d.count+1;
	d.content = find_this;
	return Strstr(string,d);
}

StringpW EXPORT overloaded Strstr(StringW & string, StringW & find_this)
{
	wchar_t *strp,*end;
	int first_char;

	require(StrvalidW(string) && StrvalidW(find_this));
	first_char = find_this.content[0];
	strp = memchr(string.content,first_char,string.count*sizeof(wchar_t));
	if (strp) {
		end = string.content + string.count;
		while (strp < end) {
			if (!memcmp(strp,find_this.content,find_this.count*sizeof(wchar_t)))
				return new_stringpW(string,strp);
			else
				strp++;
		}
	}
	return invalid_stringpW;
}

StringpW EXPORT overloaded Strstr(StringW & string, wchar_t *find_this)
{
	StringW d;

	require(find_this != NULL);
	d.count = wcslen(find_this);
	d.capacity = d.count+1;
	d.content = find_this;
	return Strstr(string,d);
}


