#include <windows.h>
#include "str.h"
#include "exceptions.h"
#include "str_private.h"
static int IsWindowsNT(void)
{
	OSVERSIONINFO osv;

	osv.dwOSVersionInfoSize = sizeof(osv);
	GetVersionEx(&osv);
	return(osv.dwPlatformId == VER_PLATFORM_WIN32_NT);
}

StringA overloaded Strfrompipe(String &Cmdline)
{
	STARTUPINFO startInfo;
	char *p;
	int processStarted,m;
	String result = invalid_stringA;
	HANDLE hWritePipe;
	LPSECURITY_ATTRIBUTES lpsa=NULL;
	SECURITY_ATTRIBUTES sa;
	SECURITY_DESCRIPTOR sd;
	DWORD Status;
	PROCESS_INFORMATION pi;
	char *tmpfile = tmpnam(NULL);
	char cmdline[1024];
	char arguments[8192];
	FILE *outputfile;

	memset(cmdline,0,sizeof(cmdline));
	memset(arguments,0,sizeof(arguments));
	if (Cmdline.content[0] == '"') {
		p = strchr(Cmdline.content+1,'"');
		if (p) {
			p++;
			strncpy(cmdline,Cmdline.content,p-Cmdline.content);
			cmdline[p-Cmdline.content] = 0;
			strncpy(arguments,p,sizeof(arguments)-1);
			arguments[sizeof(arguments)-1] = 0;
		}
		else return invalid_stringA;
	}
	else {
		strncpy(cmdline,Cmdline.content,sizeof(cmdline));
		p = strchr(cmdline,' ');
		if (p) {
			*p++ = 0;
			strcpy(arguments,Cmdline.content);
		}
		else arguments[0] = 0;
	}
	if (IsWindowsNT()) {
		InitializeSecurityDescriptor(&sd,SECURITY_DESCRIPTOR_REVISION);
		SetSecurityDescriptorDacl(&sd,TRUE,NULL,FALSE);
		sa.nLength = sizeof(SECURITY_ATTRIBUTES);
		sa.bInheritHandle = TRUE;
		sa.lpSecurityDescriptor = &sd;
		lpsa = &sa;
	}
	memset(&startInfo,0,sizeof(STARTUPINFO));
	startInfo.cb = sizeof(STARTUPINFO);
	outputfile = fopen(tmpfile,"wb");
	if (outputfile == NULL) {
		return invalid_stringA;
	}
	hWritePipe = (HANDLE)_get_osfhandle(_fileno(outputfile));
	startInfo.dwFlags = STARTF_USESTDHANDLES|STARTF_USESHOWWINDOW;
	startInfo.wShowWindow = SW_HIDE;
	startInfo.hStdOutput = hWritePipe;
	startInfo.hStdError = hWritePipe;
	result = invalid_stringA;
	processStarted = CreateProcess(cmdline,arguments,lpsa,lpsa,1,
		CREATE_NEW_PROCESS_GROUP|NORMAL_PRIORITY_CLASS,
		NULL,NULL,&startInfo,&pi);
	if (processStarted) {
		WaitForSingleObject(pi.hProcess,INFINITE);
		GetExitCodeProcess(pi.hProcess,(unsigned long *)&Status);
		CloseHandle(pi.hProcess);
		CloseHandle(pi.hThread);
		result = Strfromfile(tmpfile,1);
	}
	if (outputfile)
		fclose(outputfile);
	remove(tmpfile);
	return(result);
}

StringA overloaded Strfrompipe(char *cmdline)
{
	String s;
	int len = strlen(cmdline);
	s.count = len;
	s.capacity = len+1;
	s.content = cmdline;
	return Strfrompipe(s);
}
