#include "str.h"
#include "exceptions.h"
#include "str_private.h"
int overloaded Strrepl(StringA &inputS, StringA &StrToFind, StringA &StrToReplace)
{
	int result,needed_length;
	char *output,*pReplacement;
	require(StrvalidA(inputS));

	if (isNullStringA(StrToReplace)) {
		needed_length = strrepl(inputS.content,StrToFind.content,NULL,NULL);
		pReplacement = NULL;
	}
	else {
		pReplacement = StrToReplace.content;
		needed_length = strrepl(inputS.content,StrToFind.content,pReplacement,NULL);
	}
	if (needed_length == 0)
		return 0; // no match

	if (needed_length < inputS.capacity) {
		output = inputS.content;
		needed_length = inputS.capacity;
	}
	else {
		needed_length = calculate_new_capacity(inputS.capacity,needed_length);
		output = allocate_proper_space(needed_length+1, sizeof(*output));
	}
	result = strrepl(inputS.content,StrToFind.content,pReplacement,output);
	inputS.count = strlen(output);
	inputS.content = output;
	inputS.capacity = needed_length;
	inputS.content[inputS.count] = 0;
	return result;
}

int overloaded Strrepl(StringA & inputS,char *strtofind,char *strtorepl)
{
	StringA s1,s2;

	if (strtorepl == NULL)
		s2 = invalid_stringA;
	else {
		s2.count = strlen(strtorepl);
		s2.capacity = 1+s2.count;
		s2.content = strtorepl;
	}
	s1.count = strlen(strtofind);
	s1.capacity = 1+s1.count;
	s1.content = strtofind;
	return Strrepl(inputS,s1,s2);
}

int overloaded Strrepl(StringW & inputS,wchar_t *strtofind,wchar_t *strtorepl)
{
	StringW s1,s2;

	if (strtorepl == NULL)
		s2 = invalid_stringW;
	else {
		s2.count = wcslen(strtorepl);
		s2.capacity = 1+s2.count;
		s2.content = strtorepl;
	}
	s1.count = wcslen(strtofind);
	s1.capacity = 1+s1.count;
	s1.content = strtofind;
	return Strrepl(inputS,s1,s2);
}

int overloaded Strrepl(StringW &inputS, StringW &StrToFind, StringW &StrToReplace)
{
	int result,needed_length;
	wchar_t *output,*pReplacement;
	require(StrvalidW(inputS));

	if (isNullStringW(StrToReplace)) {
		needed_length = wcsrepl(inputS.content,StrToFind.content,NULL,NULL);
		pReplacement = NULL;
	}
	else {
		pReplacement = StrToReplace.content;
		needed_length = wcsrepl(inputS.content,StrToFind.content,pReplacement,NULL);
	}

	if (needed_length == 0)
		return 0; // no match

	if (needed_length < inputS.capacity) {
		output = inputS.content;
		needed_length = inputS.capacity;
	}
	else {
		needed_length = calculate_new_capacity(inputS.capacity,needed_length);
		output = allocate_proper_space(needed_length+1,sizeof(*output));
	}
	result = wcsrepl(inputS.content,StrToFind.content,pReplacement,output);
	inputS.count = wcslen(output);
	inputS.content = output;
	inputS.capacity = needed_length;
	return result;
}

int overloaded Strrepl(StringA &str,int existingChar,int replaceChar)
{
	require(StrvalidA(str));
	int result=0;

	for (int i = 0; i<str.count;i++) {
		if (str.content[i] == existingChar) {
			str.content[i] = replaceChar;
			result++;
		}
	}
	return result;
}

int overloaded Strrepl(StringW &str,int existingChar,int replaceChar)
{
	require(StrvalidW(str));
	int result=0;

	for (int i = 0; i<str.count;i++) {
		if (str.content[i] == existingChar) {
			str.content[i] = replaceChar;
			result++;
		}
	}
	return result;
}

