#include "str.h"
#include "exceptions.h"
#include "str_private.h"

//----------------------------------------------------resizing
int overloaded Strresize(StringA & string,size_t requested_size)
{
	char *content = NULL;
	size_t new_capacity;
	int strvalid = 0;

	if (StrvalidA(string)) {
		size_t req_size = requested_size + 1;
		if (requested_size < string.count) {
			string.count = requested_size;
			string.content[string.count] = 0;
			return 1;
		}
		/* it should hold anytime str[count] == '\0' */
		new_capacity = calculate_new_capacity(string.capacity,req_size);

		if (new_capacity == string.capacity){
			/* do nothing */
			return 1;
		}
		strvalid = 1;
	}
	else new_capacity = requested_size+1;

	content = allocate_proper_space(new_capacity, sizeof(*content));
	if (content == NULL)
		return 0;
	if (strvalid)
		memcpy(content,string.content,string.count);
	string.content = content;
	string.capacity = new_capacity;
	return 1;
}

int overloaded Strresize(StringW & string,size_t requested_size)
{
	wchar_t *content = NULL;
	size_t new_capacity;
	int strvalid = 0;

	if (StrvalidW(string)) {
		size_t req_size = requested_size + 1;
		if (requested_size < string.count) {
			string.count = requested_size;
			string.content[string.count] = 0;
			return 1;
		}
		/* it should hold anytime str[count] == '\0' */
		new_capacity = calculate_new_capacity(string.capacity,req_size);

		if (new_capacity == string.capacity){
			/* do nothing */
			return 1;
		}
		strvalid = 1;
	}
	else new_capacity = requested_size+1;

	content = allocate_proper_space(new_capacity, sizeof(*content));
	if (content == NULL)
		return 0;
	if (strvalid)
		memcpy(content,string.content,string.count*sizeof(wchar_t));
	string.content = content;
	string.capacity = new_capacity;
	return 1;
}

