#include "str.h"
#include "exceptions.h"
#include "str_private.h"


size_t EXPORT overloaded Strspn(const StringA &s1, const StringA & s2)
{
	StringpA result;

	require(StrvalidA(s1) && StrvalidA(s2));

	return strspn(s1.content,s2.content);
}

size_t EXPORT overloaded Strspn(const StringW &s1, const StringW & s2)
{
	StringpW result;

	require(StrvalidW(s1) && StrvalidW(s2));

	return wcsspn(s1.content,s2.content);
}

size_t EXPORT overloaded Strspn(StringW &s1, const wchar_t *s2)
{
	StringW d;
	require(s2 != NULL);

	d.count = wcslen(s2);
	d.capacity = d.count+1;
	d.content = s2;
	return Strspn(s1,d);
}
size_t EXPORT overloaded Strspn(StringA &s1, const char *s2)
{
	StringA d;

	require(s2 != NULL);
	d.count = strlen(s2);
	d.capacity = d.count+1;
	d.content = s2;
	return Strspn(s1,d);
}



