@echo off
rem cmd-Skript bl.cmd
rem --------------------------------------------------------------------
rem Cmd-Skript bl.cmd zum Compilieren und Binden aller C-Quelldateien
rem im aktuellen Arbeitsverzeichnis.
rem Compiler und Binder: Little-C-Compiler-und-Binder lcc/lcclnk.
rem
rem Aufrufe und was sie bewirken (> ist das Promptzeichen):
rem
rem > bl hallo01   rem Alle C-Quelldateien im aktuellen Arbeitsverzeichnis
rem                rem werden compiliert und zu einer Datei namens
rem                rem hallo01.exe gebunden. Der Name hallo01 wird in die
rem                rem Datei namens ..\AktuelleDatei.nam geschrieben.
rem
rem > bl           rem Alle C-Quelldateien im aktuellen Arbeitsverzeichnis
rem                rem werden compiliert und zu einer Datei gebunden, die
rem                rem den Namen hat, der in ..\AktuelleDatei.nam steht und
rem                rem die Erweiterung .exe hat.
rem
rem Auch unter Unix (z.B. Linux) kann man ausfuehrbare Dateien durch
rem die Erweiterung .exe kenntlich machen. Solche Dateien sind leichter
rem loeschbar (mit rm *.exe) als Dateien ohne eine spezielle Erweiterung.
rem --------------------------------------------------------------------

if [%2] NEQ [] (
   echo -------------------------------------------------------------
   echo Skript a.cmd : Geben Sie bitte null oder einen Parameter an,
   echo den Namen der zu erzeugenden .exe-Datei, ohne die
   echo Erweiterung .exe, z.B. so:
   echo.
   echo ^> bl              rem Null Parameter
   echo ^> bl hallo01      rem Ein  Parameter
   echo -------------------------------------------------------------
   goto :EOF
)

SetLocal EnableDelayedExpansion

rem Den Namen der zu erzeugenden .exe-Datei entweder aus dem Parameter %1
rem oder aus der Datei ..\AktuelleDatei.nam holen und in die Variable
rem EXEDATEI bringen:

if [%1] NEQ [] (
   set   EXEDATEI=%1
   echo !EXEDATEI!> ..\AktuelleDatei.nam
) else (
   if EXIST ..\AktuelleDatei.nam (
      set /P EXEDATEI=< ..\AktuelleDatei.nam
   ) else (
      echo -------------------------------------------------------------
      echo a.cmd: Beim ersten Aufruf dieses Skripts muessen Sie
      echo        den Namen einer zu erzeugenden .exe-Datei angeben,
      echo        ohne die Erweiterung .exe, z.B. so:
      echo.
      echo ^> a.cmd hallo01
      echo -------------------------------------------------------------
      goto :EOF
   )
)

echo ------------------------------------------------------------------- 0
echo Eine ausfuehrbare Datei !EXEDATEI!.exe wird erzeugt.
echo Compiler und Binder: Little-C-Compiler-und-Binder lcc/lcclnk.

rem Jetzt kommen endlich die Kommandos zum Compilieren, Binden und Ausfuehren:

rem Alle .c-Dateien compilieren:
echo ------------------------------------------------------------------- 1
rem Der Compiler lcc.exe akzeptiert nur eine einzige Quelldatei als Parameter,
rem deshalb muss er hier fr jede Quelldatei einmal aufgerufen werden
for /F %%F in ('dir /B *.c') do (
   echo Compiliert  wird %%F
   lcc.exe %%F
   if %ERRORLEVEL% GTR 0 goto :ERROR
)
echo ------------------------------------------------------------------- 2

rem Alle .obj-Dateien binden:
set OBJECTS=
for /F %%F in ('dir /B *.obj') do set OBJECTS=%%F !OBJECTS!
echo Gebunden    werden !OBJECTS!
echo ------------------------------------------------------------------- 3
lcclnk.exe -o %EXEDATEI%.exe !OBJECTS!
if %ERRORLEVEL% GTR 0 goto :ERROR

goto :EOF

:ERROR
echo ------------------------------------------------------------------- 4
echo Es sind noch Fehler aufgetreten.
echo ------------------------------------------------------------------- 5
