@echo off
rem cmd-Skript c.cmd
rem --------------------------------------------------------------------
rem Cmd-Skript c.cmd  zum Compilieren einer C-Quelldatei.
rem Compiler: Gnu-C-Compiler gcc.
rem
rem Aufrufe und was sie bewirken (> ist das Promptzeichen):
rem
rem > c  hallo01   rem Die Datei hallo01.c wird compiliert
rem                rem (zu einer Datei namens hallo01.o)   und der Name
rem                rem hallo01 wird in die Datei namens
rem                rem ..\AktuelleDatei.nam geschrieben.
rem
rem > c            rem Compiliert wird die Datei, deren Name in der Datei
rem                rem mit dem Namen ..\AktuelleDatei.nam steht.
rem --------------------------------------------------------------------

if [%2] NEQ [] (
   echo ---------------------------------------------------------------
   echo c.cmd:  Geben Sie bitte null oder einen Parameter an, den Namen
   echo         einer zu compilierenden C-Quelldatei, ohne die
   echo         Erweiterung .c, z.B. so:
   echo.
   echo ^> c            rem Null Parameter
   echo ^> c   hallo01  rem Ein  Parameter
   echo ---------------------------------------------------------------
   goto :EOF
)

SetLocal EnableDelayedExpansion

rem Den Namen der zu compilierenden Datei entweder aus dem Parameter %1
rem oder aus der Datei ..\AktuelleDatei.nam holen und in die Variable
rem EXEDATEI bringen:

if [%1] NEQ [] (
   set   CEHDATEI=%1
) else (
   if EXIST ..\AktuelleDatei.nam (
      set /P CEHDATEI=< ..\AktuelleDatei.nam
   ) else (
      echo -------------------------------------------------------------
      echo c.cmd: Beim ersten Aufruf dieses Skripts muessen Sie
      echo        den Namen einer zu compilierenden .c-Datei angeben,
      echo        ohne die Erweiterung .exe, z.B. so:
      echo.
      echo ^> c.cmd hallo01
      echo -------------------------------------------------------------
      goto :EOF
   )
)

rem Existiert die zu compilierende Datei ueberhaupt?
if NOT EXIST %CEHDATEI%.c (
   echo -------------------------------------------------------------
   echo c.cmd: Kann die Datei !CEHDATEI!.c nicht finden!
   goto :ERROR
)

rem Wenn die zu compilierende Datei existiert, ihren
rem Namen in die Datei namens ..\AktuelleDatei.nam schreiben (fuer
rem den naechsten Aufruf dieses oder eines aehnlichen Skripts):
echo !CEHDATEI!> ..\AktuelleDatei.nam

echo -------------------------------------------------------------
echo Compiliert wird die Datei !CEHDATEI!.c:
echo Compiler: Gnu-C-Compiler gcc.

rem Jetzt kommt endlich der Befehl zum Compilieren:

rem gcc -std=gnu99 -c $CEHDATEI.c
gcc -c !CEHDATEI!.c
if %ERRORLEVEL% GTR 0 goto :ERROR
goto :EOF

:ERROR
echo -------------------------------------------------------------------
echo Es sind noch Fehler aufgetreten.
echo -------------------------------------------------------------------
