@echo off
rem cmd-Skript setEnv.cmd
echo ---------------------------------------------------------------------
echo Ausgefuehrt wird: %~f0
echo ---------------------------------------------------------------------

rem echo Home Directory HD in setEnv.cmd: %HD%

rem Ordner (directories), in denen Programme (Werkzeuge) stehen (sollten):
set D01=%HD%MinGW\msys\1.0\bin
set D02=%HD%MinGW\bin
set D03=%HD%Lcc\bin
set D04=%HD%BCC55\Bin
set D05=%HD%Tcc
set D06=%HD%Skripte

rem Programme (Werkzeuge), die in den Verzeichnissen stehen (sollten):
set P01=%D02%\gcc.exe
set P02=%D03%\lcc.exe
set P03=%D04%\bcc32.exe
set P04=%D05%\tcc.exe

rem Fehlermeldungen, wenn die Programme %P01% bis %P04% nicht in den
rem Ordnern stehen, in denen sie stehen sollten:
for %%F in (%P01% %P02% %P03% %P04%) do (
   if not exist %%F echo Missing tool: %%F
)

rem Die Pfade %D01% bis %D06% in die PATH-Variable eintragen, aber nur
rem wenn sie dort noch nicht drinstehen (damit der PATH-Inhalt nicht immer
rem laenger wird, falls dieses Skript mehrmals aufgerufen wird).

rem (Fuehle mich von der cmd.exe-Shell gezwungen, die schrecklichste
rem Befehlsfolge meines Lebens zu hacken, um dieses simple Problem
rem zu loesen! Oder habe ich eine einfachere Loesung uebersehen?

SetLocal EnableDelayedExpansion

rem 'SetLocal' bewirkt: Alle Veraenderungen von Umgebungsvariablen sind
rem nur bis zum naechsten 'EndLocal' wirksam und verschwinden dort wieder.
rem 'EnableDelayedExpansion' bewirkt: Das Kommando 'set PATH=%%F;!PATH!'
rem im Rumpf der folgenden for-Schleife darf !PATH! anstelle von %PATH%
rem enthalten und wird deshalb mehrmals (6 Mal) ausgefuehrt (mit %PATH%
rem anstelle von !PATH! wuerde das Kommando nur 1 Mal ausgefuehrt, obwohl
rem es im Rumpf der Schleife steht!!).

rem Die Verzeichnisse D01 und D02 sollen im PATH ganz vorn stehen, damit
rem Programme (z.B. grep.exe) zuerst dort gesucht werden.

for %%F in (%D06% %D05% %D04% %D03% %D02% %D01%) do (
   rem Wenn %%F in %PATH% vorkommt, wird es entfernt:
   call set PATH=%%PATH:%%F;=%%
   rem %%F und ein Semikolon ; werden vorne in die PATH-Variable
   rem eingefuegt:
   set PATH=%%F;!PATH!
)

rem Die Datei bcc32.cfg des Borland-Compilers aktualisieren:
cmd.exe "/C %HD%\Skripte\setBcc32Cfg.cmd"

rem Der Compiler lcc und der Binder lcclnk erwarten bestimmte Schluessel in
rem der Registry. Die schreibt das Skript setLccRegistry.cmd dort hin:

rem Die Registry-Eintraege fuer den Compiler/Binder lcc/lcclnk aktualisieren
cmd.exe "/C call setLccRegistry.cmd"

rem Die folgende Zeile beendet den Gueltigkeitsbereich mit EndLocal,
rem rettet aber die Veraenderungen der PATH-Variable "nach draussen":
EndLocal & set PATH=%PATH%

rem Zur Erleichterung der Suche nach Fehlern wichtige Daten
rem ausgeben (YES) oder nicht (NO)
set PRINT_NOW_1=NO
set PRINT_NOW_2=NO

if %PRINT_NOW_1%==YES (
   echo HD  : %HD%
)

if %PRINT_NOW_2%==YES (
   rem Den Inhalt der Umgebungsvariablen PATH in lesbarer Form ausgeben:
   echu PATH
)
