@echo off
rem setLccRegistry.cmd
rem Erwartet keine Parameter:
rem ----------------------------------------------------------------------
rem In die Registry werden drei Schluessel und ihre Werte geschrieben.
rem Mit deren Hilfe findet 
rem der Compiler lcc sein include-Verzeichnis 
rem (mit lauter Kopfdateien, d.h. .h-Dateien darin) und 
rem der Binder lcclnk sein lib-Verzeichnis 
rem (mit lauter Bibliotheken, d.h. .lb-Dateien darin)
rem Es folgt der Inhalt einer .reg-Datei, der die betreffenden Schluessel
rem und Werte beschreibt. Dabei ist S:\TB1-IN1-SDW\ceh das Heimatverzeich-
rem nis der gesamten Softwaredistribution:

rem Windows Registry Editor Version 5.00
rem 
rem [HKEY_CURRENT_USER\Software\lcc]
rem "lccroot"="S:\\TB1-IN1-SWD\\ceh"
rem 
rem [HKEY_CURRENT_USER\Software\lcc\Compiler]
rem "includepath"="S:\\TB1-IN1-SWD\\ceh\\Lcc\\include"
rem 
rem [HKEY_CURRENT_USER\Software\lcc\lcclnk]
rem "libpath"="S:\\TB1-IN1-SWD\\ceh\\Lcc\\lib"

rem ----------------------------------------------------------------------
rem Alle Umgebungsvariablen zu lokalen Variablen dieses Skripts machen:
SetLocal

rem Den Pfadnamen des Verzeichnisses, in dem dieses Skript steht,
rem nach HD (wie "home directory") bringen.
rem "d" wie "device" (Laufwerk) und "p" wie "path" (Pfad)
rem %0 ist der nullte Parameter dieses Skripts
set  HD=%~dp0

rem Die Zeichenkette '\Skripte\' am Ende von %HD% entfernen:
set HD=%HD:\Skripte\=%

rem Sicher stellen, dass in der Registry der Schluessel HKCU\Software\Lcc\
rem existiert (damit die Prozedur :PRINT keinen Fehler meldet)
reg add HKCU\Software\lcc\ >nul 2>&1

rem call :PRINT "Alte Werte:"

set ROOT=%HD%
set INCP=%HD%\Lcc\include
set LIBP=%HD%\Lcc\lib

reg add HKCU\Software\lcc\         /v lccroot     /d %ROOT% /f >nul 2>&1
reg add HKCU\Software\lcc\compiler /v includepath /d %INCP% /f >nul 2>&1
reg add HKCU\Software\lcc\lcclnk   /v libpath     /d %LIBP% /f >nul 2>&1

rem call :PRINT "Neue Werte:"

goto :EOF

rem ----------------------------------------------------------------------
rem Eine Prozedur, die einen kleinen Teil der Registry ausgibt (den
rem Schluessel HKEY_CURRENT_USER\Software\lcc und alle Unterscluessel)
:PRINT
echo ---------------------------------------------------------------------
echo %1
echo ---------------------------------------------------------------------
reg query HKCU\Software\lcc /s
echo ---------------------------------------------------------------------
goto :EOF

EndLocal